#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 2100
#define SYMBOL_COUNT 221
#define ALIAS_COUNT 8
#define TOKEN_COUNT 117
#define EXTERNAL_TOKEN_COUNT 2
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym__automatic_semicolon = 1,
  sym__template_chars = 2,
  sym_hash_bang_line = 3,
  anon_sym_export = 4,
  anon_sym_STAR = 5,
  anon_sym_default = 6,
  anon_sym_LBRACE = 7,
  anon_sym_COMMA = 8,
  anon_sym_RBRACE = 9,
  anon_sym_as = 10,
  anon_sym_import = 11,
  anon_sym_from = 12,
  anon_sym_var = 13,
  anon_sym_let = 14,
  anon_sym_const = 15,
  anon_sym_if = 16,
  anon_sym_else = 17,
  anon_sym_switch = 18,
  anon_sym_for = 19,
  anon_sym_LPAREN = 20,
  anon_sym_RPAREN = 21,
  anon_sym_in = 22,
  anon_sym_await = 23,
  anon_sym_of = 24,
  anon_sym_while = 25,
  anon_sym_do = 26,
  anon_sym_try = 27,
  anon_sym_with = 28,
  anon_sym_break = 29,
  anon_sym_continue = 30,
  anon_sym_debugger = 31,
  anon_sym_return = 32,
  anon_sym_throw = 33,
  anon_sym_SEMI = 34,
  anon_sym_COLON = 35,
  anon_sym_case = 36,
  anon_sym_catch = 37,
  anon_sym_finally = 38,
  anon_sym_yield = 39,
  anon_sym_LBRACK = 40,
  anon_sym_RBRACK = 41,
  anon_sym_LT = 42,
  anon_sym_GT = 43,
  anon_sym_SLASH = 44,
  sym_jsx_text = 45,
  sym_jsx_identifier = 46,
  anon_sym_DOT = 47,
  anon_sym_EQ = 48,
  anon_sym_class = 49,
  anon_sym_extends = 50,
  anon_sym_async = 51,
  anon_sym_function = 52,
  anon_sym_EQ_GT = 53,
  anon_sym_new = 54,
  anon_sym_PLUS_EQ = 55,
  anon_sym_DASH_EQ = 56,
  anon_sym_STAR_EQ = 57,
  anon_sym_SLASH_EQ = 58,
  anon_sym_PERCENT_EQ = 59,
  anon_sym_CARET_EQ = 60,
  anon_sym_AMP_EQ = 61,
  anon_sym_PIPE_EQ = 62,
  anon_sym_GT_GT_EQ = 63,
  anon_sym_GT_GT_GT_EQ = 64,
  anon_sym_LT_LT_EQ = 65,
  anon_sym_DOT_DOT_DOT = 66,
  anon_sym_QMARK = 67,
  anon_sym_AMP_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_GT_GT = 70,
  anon_sym_GT_GT_GT = 71,
  anon_sym_LT_LT = 72,
  anon_sym_AMP = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_PLUS = 76,
  anon_sym_DASH = 77,
  anon_sym_PERCENT = 78,
  anon_sym_LT_EQ = 79,
  anon_sym_EQ_EQ = 80,
  anon_sym_EQ_EQ_EQ = 81,
  anon_sym_BANG_EQ = 82,
  anon_sym_BANG_EQ_EQ = 83,
  anon_sym_GT_EQ = 84,
  anon_sym_instanceof = 85,
  anon_sym_BANG = 86,
  anon_sym_TILDE = 87,
  anon_sym_typeof = 88,
  anon_sym_void = 89,
  anon_sym_delete = 90,
  anon_sym_PLUS_PLUS = 91,
  anon_sym_DASH_DASH = 92,
  anon_sym_DQUOTE = 93,
  aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH = 94,
  anon_sym_SQUOTE = 95,
  aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH = 96,
  sym_escape_sequence = 97,
  sym_comment = 98,
  anon_sym_BQUOTE = 99,
  anon_sym_DOLLAR_LBRACE = 100,
  anon_sym_SLASH2 = 101,
  sym_regex_pattern = 102,
  sym_regex_flags = 103,
  sym_number = 104,
  sym_identifier = 105,
  anon_sym_target = 106,
  sym_this = 107,
  sym_super = 108,
  sym_true = 109,
  sym_false = 110,
  sym_null = 111,
  sym_undefined = 112,
  anon_sym_AT = 113,
  anon_sym_static = 114,
  anon_sym_get = 115,
  anon_sym_set = 116,
  sym_program = 117,
  sym_export_statement = 118,
  sym_export_clause = 119,
  sym__import_export_specifier = 120,
  sym__declaration = 121,
  sym_import_statement = 122,
  sym_import_clause = 123,
  sym__from_clause = 124,
  sym_namespace_import = 125,
  sym_named_imports = 126,
  sym_expression_statement = 127,
  sym_variable_declaration = 128,
  sym_lexical_declaration = 129,
  sym_variable_declarator = 130,
  sym_statement_block = 131,
  sym_if_statement = 132,
  sym_switch_statement = 133,
  sym_for_statement = 134,
  sym_for_in_statement = 135,
  sym_for_of_statement = 136,
  sym_while_statement = 137,
  sym_do_statement = 138,
  sym_try_statement = 139,
  sym_with_statement = 140,
  sym_break_statement = 141,
  sym_continue_statement = 142,
  sym_debugger_statement = 143,
  sym_return_statement = 144,
  sym_throw_statement = 145,
  sym_empty_statement = 146,
  sym_labeled_statement = 147,
  sym_switch_body = 148,
  sym_switch_case = 149,
  sym_switch_default = 150,
  sym_catch_clause = 151,
  sym_finally_clause = 152,
  sym_parenthesized_expression = 153,
  sym__expression = 154,
  sym_yield_expression = 155,
  sym_object = 156,
  sym_assignment_pattern = 157,
  sym_array = 158,
  sym_jsx_element = 159,
  sym_jsx_fragment = 160,
  sym_jsx_expression = 161,
  sym_jsx_opening_element = 162,
  sym_nested_identifier = 163,
  sym_jsx_namespace_name = 164,
  sym_jsx_closing_element = 165,
  sym_jsx_self_closing_element = 166,
  sym_jsx_attribute = 167,
  sym_anonymous_class = 168,
  sym_class = 169,
  sym_class_heritage = 170,
  sym_function = 171,
  sym_arrow_function = 172,
  sym_generator_function = 173,
  sym_call_expression = 174,
  sym_new_expression = 175,
  sym_await_expression = 176,
  sym_member_expression = 177,
  sym_subscript_expression = 178,
  sym_assignment_expression = 179,
  sym_augmented_assignment_expression = 180,
  sym__initializer = 181,
  sym_spread_element = 182,
  sym_ternary_expression = 183,
  sym_binary_expression = 184,
  sym_unary_expression = 185,
  sym_update_expression = 186,
  sym_sequence_expression = 187,
  sym_string = 188,
  sym_template_string = 189,
  sym_template_substitution = 190,
  sym_regex = 191,
  sym_meta_property = 192,
  sym_arguments = 193,
  sym_decorator = 194,
  sym__identifier_reference = 195,
  sym_decorator_member_expression = 196,
  sym_decorator_call_expression = 197,
  sym_class_body = 198,
  sym_public_field_definition = 199,
  sym_formal_parameters = 200,
  sym_rest_parameter = 201,
  sym_method_definition = 202,
  sym_pair = 203,
  sym__property_name = 204,
  sym_computed_property_name = 205,
  aux_sym_program_repeat1 = 206,
  aux_sym_export_statement_repeat1 = 207,
  aux_sym_export_clause_repeat1 = 208,
  aux_sym_named_imports_repeat1 = 209,
  aux_sym_variable_declaration_repeat1 = 210,
  aux_sym_switch_body_repeat1 = 211,
  aux_sym_object_repeat1 = 212,
  aux_sym_array_repeat1 = 213,
  aux_sym_jsx_element_repeat1 = 214,
  aux_sym_jsx_opening_element_repeat1 = 215,
  aux_sym_string_repeat1 = 216,
  aux_sym_string_repeat2 = 217,
  aux_sym_template_string_repeat1 = 218,
  aux_sym_class_body_repeat1 = 219,
  aux_sym_formal_parameters_repeat1 = 220,
  alias_sym_array_pattern = 221,
  alias_sym_export_specifier = 222,
  alias_sym_identifier = 223,
  alias_sym_import_specifier = 224,
  alias_sym_object_pattern = 225,
  alias_sym_property_identifier = 226,
  alias_sym_shorthand_property_identifier = 227,
  alias_sym_statement_identifier = 228,
};

static const char *ts_symbol_names[] = {
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [ts_builtin_sym_end] = "END",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_as] = "as",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_in] = "in",
  [anon_sym_await] = "await",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_extends] = "extends",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_typeof] = "typeof",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = "/[^\"\\\\\\n]+/",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = "/[^'\\\\\\n]+/",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_identifier] = "identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym_for_of_statement] = "for_of_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_anonymous_class] = "anonymous_class",
  [sym_class] = "class",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_arrow_function] = "arrow_function",
  [sym_generator_function] = "generator_function",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym__identifier_reference] = "_identifier_reference",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_jsx_opening_element_repeat1] = "jsx_opening_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_identifier] = "identifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_of_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_reference] = {
    .visible = false,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[22][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_identifier,
  },
  [2] = {
    [0] = alias_sym_property_identifier,
  },
  [3] = {
    [0] = alias_sym_object_pattern,
  },
  [4] = {
    [0] = alias_sym_array_pattern,
  },
  [5] = {
    [1] = alias_sym_identifier,
  },
  [6] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [7] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [8] = {
    [1] = alias_sym_object_pattern,
  },
  [9] = {
    [1] = alias_sym_array_pattern,
  },
  [10] = {
    [1] = alias_sym_statement_identifier,
  },
  [11] = {
    [0] = alias_sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [12] = {
    [0] = alias_sym_statement_identifier,
  },
  [13] = {
    [2] = alias_sym_property_identifier,
  },
  [14] = {
    [1] = alias_sym_export_specifier,
  },
  [15] = {
    [1] = alias_sym_import_specifier,
  },
  [16] = {
    [2] = alias_sym_object_pattern,
  },
  [17] = {
    [2] = alias_sym_array_pattern,
  },
  [18] = {
    [3] = alias_sym_object_pattern,
  },
  [19] = {
    [3] = alias_sym_array_pattern,
  },
  [20] = {
    [4] = alias_sym_object_pattern,
  },
  [21] = {
    [4] = alias_sym_array_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(25);
      if (lookahead == '/')
        ADVANCE(32);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '\\')
        ADVANCE(64);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(84);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      ADVANCE(86);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=')
        ADVANCE(4);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 6:
      if (lookahead == '!')
        ADVANCE(7);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(7);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(11);
      if (lookahead == '=')
        ADVANCE(12);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(19);
      if (lookahead == '=')
        ADVANCE(20);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(24);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 26:
      if (lookahead == '.')
        ADVANCE(27);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E')
        ADVANCE(29);
      if (lookahead == 'e')
        ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 29:
      if (lookahead == '+')
        ADVANCE(30);
      if (lookahead == '-')
        ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(31);
      END_STATE();
    case 30:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(31);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(31);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      END_STATE();
    case 33:
      if (lookahead == '*')
        ADVANCE(34);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 34:
      if (lookahead == '*')
        ADVANCE(34);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(36);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.')
        ADVANCE(28);
      if (lookahead == 'B')
        ADVANCE(38);
      if (lookahead == 'E')
        ADVANCE(29);
      if (lookahead == 'O')
        ADVANCE(40);
      if (lookahead == 'X')
        ADVANCE(42);
      if (lookahead == 'b')
        ADVANCE(38);
      if (lookahead == 'e')
        ADVANCE(29);
      if (lookahead == 'o')
        ADVANCE(40);
      if (lookahead == 'x')
        ADVANCE(42);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 38:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(39);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(41);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(41);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(43);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.')
        ADVANCE(28);
      if (lookahead == 'E')
        ADVANCE(29);
      if (lookahead == 'e')
        ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(48);
      if (lookahead == '=')
        ADVANCE(50);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(49);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(52);
      if (lookahead == '>')
        ADVANCE(54);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(57);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(58);
      if (lookahead == '>')
        ADVANCE(59);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 64:
      if (lookahead == 'u')
        ADVANCE(65);
      if (lookahead == 'x')
        ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(72);
      if (lookahead != 0)
        ADVANCE(68);
      END_STATE();
    case 65:
      if (lookahead == '{')
        ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(69);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == '}')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(70);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(71);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(68);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(68);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(80);
      if (lookahead == '|')
        ADVANCE(81);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 84:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(6);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(25);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(84);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if ((lookahead < '[' || lookahead > '^'))
        ADVANCE(86);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~') &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(86);
      END_STATE();
    case 87:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(88);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '#')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(91);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '=')
        ADVANCE(93);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(87);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if ((lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(19);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(23);
      END_STATE();
    case 91:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 93:
      if (lookahead == '>')
        ADVANCE(54);
      END_STATE();
    case 94:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(88);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(91);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '=')
        ADVANCE(93);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(94);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if ((lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 95:
      if (lookahead == '!')
        ADVANCE(88);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(97);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '=')
        ADVANCE(93);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(95);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 97:
      if (lookahead == '.')
        ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 98:
      if (lookahead == '!')
        ADVANCE(88);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(97);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '=')
        ADVANCE(93);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(98);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 99:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(88);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(91);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '=')
        ADVANCE(93);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(99);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if ((lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 100:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(106);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(100);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(11);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(105);
      if (lookahead == '=')
        ADVANCE(50);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 106:
      if (lookahead == '=')
        ADVANCE(52);
      if (lookahead == '>')
        ADVANCE(54);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>')
        ADVANCE(109);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(81);
      END_STATE();
    case 112:
      if (lookahead == '!')
        ADVANCE(88);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(97);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '=')
        ADVANCE(93);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(112);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 113:
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == '=')
        ADVANCE(115);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(113);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-')
        ADVANCE(118);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(117);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '~') &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(86);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(118);
      END_STATE();
    case 119:
      if (lookahead == '\n')
        SKIP(120);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '[')
        ADVANCE(122);
      if (lookahead == '\\')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(126);
      if (lookahead != 0)
        ADVANCE(124);
      END_STATE();
    case 120:
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(120);
      END_STATE();
    case 121:
      if (lookahead == '*')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      END_STATE();
    case 122:
      if (lookahead == '\\')
        ADVANCE(123);
      if (lookahead == ']')
        ADVANCE(124);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(122);
      END_STATE();
    case 123:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(122);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[')
        ADVANCE(122);
      if (lookahead == '\\')
        ADVANCE(125);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/')
        ADVANCE(124);
      END_STATE();
    case 125:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(124);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[')
        ADVANCE(122);
      if (lookahead == '\\')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(126);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '/')
        ADVANCE(124);
      END_STATE();
    case 127:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(127);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 128:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(33);
      if (lookahead == '/')
        ADVANCE(36);
      if (lookahead == '=')
        ADVANCE(130);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 131:
      if (lookahead == '!')
        ADVANCE(88);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '=')
        ADVANCE(132);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(131);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>')
        ADVANCE(54);
      END_STATE();
    case 133:
      if (lookahead == '\n')
        SKIP(134);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '/')
        ADVANCE(135);
      if (lookahead == '\\')
        ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(140);
      if (lookahead != 0)
        ADVANCE(138);
      END_STATE();
    case 134:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead == '*')
        ADVANCE(136);
      if (lookahead == '/')
        ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(138);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead == '*')
        ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead == '*')
        ADVANCE(137);
      if (lookahead == '/')
        ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(136);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(139);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead == '/')
        ADVANCE(135);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(140);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\"' &&
          lookahead != '\\')
        ADVANCE(138);
      END_STATE();
    case 141:
      if (lookahead == '\n')
        SKIP(142);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(143);
      if (lookahead == '\\')
        ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(148);
      if (lookahead != 0)
        ADVANCE(146);
      END_STATE();
    case 142:
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead == '*')
        ADVANCE(144);
      if (lookahead == '/')
        ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(146);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead == '*')
        ADVANCE(145);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead == '*')
        ADVANCE(145);
      if (lookahead == '/')
        ADVANCE(146);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(144);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH);
      if (lookahead == '/')
        ADVANCE(143);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(148);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(146);
      END_STATE();
    case 149:
      if (lookahead == '$')
        ADVANCE(150);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '\\')
        ADVANCE(64);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(152);
      END_STATE();
    case 150:
      if (lookahead == '{')
        ADVANCE(151);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 152:
      if (lookahead == '$')
        ADVANCE(150);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(152);
      END_STATE();
    case 153:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(153);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 154:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(154);
      END_STATE();
    case 155:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(156);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(155);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(52);
      END_STATE();
    case 157:
      if (lookahead == '/')
        ADVANCE(158);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}')
        ADVANCE(162);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*')
        ADVANCE(159);
      if (lookahead == '/')
        ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(162);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*')
        ADVANCE(160);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(33);
      if (lookahead != 0)
        ADVANCE(159);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*')
        ADVANCE(160);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(33);
      if (lookahead != 0)
        ADVANCE(159);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(36);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(161);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/')
        ADVANCE(158);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(162);
      END_STATE();
    case 164:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(106);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(164);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if ((lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^'))
        ADVANCE(86);
      END_STATE();
    case 165:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(88);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(91);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '=')
        ADVANCE(93);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(165);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if ((lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 166:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(166);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if ((lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^'))
        ADVANCE(86);
      END_STATE();
    case 167:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(167);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 168:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(106);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(168);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 169:
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '=')
        ADVANCE(115);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(169);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 170:
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(170);
      END_STATE();
    case 171:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(171);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 172:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(172);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 173:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(173);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 174:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(106);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(174);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if ((lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^'))
        ADVANCE(86);
      END_STATE();
    case 175:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(175);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 176:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(156);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(176);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 177:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(177);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 178:
      if (lookahead == '/')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(120);
      END_STATE();
    case 179:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(156);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(179);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 180:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(180);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 181:
      if (lookahead == '=')
        ADVANCE(52);
      END_STATE();
    case 182:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(106);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(182);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 183:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(183);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 184:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(156);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(184);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 185:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(88);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(91);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(92);
      if (lookahead == '=')
        ADVANCE(93);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(185);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if ((lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 186:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(156);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(186);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 187:
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(187);
      END_STATE();
    case 188:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(189);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(190);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '`' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 189:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(189);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_regex_flags);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '`' || lookahead > '~') &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(86);
      END_STATE();
    case 191:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '.')
        ADVANCE(91);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '=')
        ADVANCE(115);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(191);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 192:
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(91);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '=')
        ADVANCE(115);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(192);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 193:
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '/')
        ADVANCE(121);
      if (lookahead == '=')
        ADVANCE(115);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(193);
      END_STATE();
    case 194:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(156);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(194);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 195:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == '*')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(22);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(129);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(51);
      if (lookahead == '>')
        ADVANCE(55);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(75);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '|')
        ADVANCE(79);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(195);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 196:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(197);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(190);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '`' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 197:
      if (lookahead == '!')
        ADVANCE(128);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(114);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == ':')
        ADVANCE(45);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(181);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == ']')
        ADVANCE(74);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(197);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    case 198:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(101);
      if (lookahead == '&')
        ADVANCE(102);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(14);
      if (lookahead == ')')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(96);
      if (lookahead == '+')
        ADVANCE(89);
      if (lookahead == ',')
        ADVANCE(21);
      if (lookahead == '-')
        ADVANCE(90);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(85);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ';')
        ADVANCE(46);
      if (lookahead == '<')
        ADVANCE(104);
      if (lookahead == '=')
        ADVANCE(106);
      if (lookahead == '>')
        ADVANCE(107);
      if (lookahead == '?')
        ADVANCE(61);
      if (lookahead == '@')
        ADVANCE(62);
      if (lookahead == '[')
        ADVANCE(63);
      if (lookahead == '^')
        ADVANCE(110);
      if (lookahead == '`')
        ADVANCE(77);
      if (lookahead == '{')
        ADVANCE(78);
      if (lookahead == '|')
        ADVANCE(111);
      if (lookahead == '~')
        ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(198);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '#') &&
          (lookahead < '%' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(86);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a')
        ADVANCE(1);
      if (lookahead == 'b')
        ADVANCE(10);
      if (lookahead == 'c')
        ADVANCE(15);
      if (lookahead == 'd')
        ADVANCE(35);
      if (lookahead == 'e')
        ADVANCE(53);
      if (lookahead == 'f')
        ADVANCE(67);
      if (lookahead == 'g')
        ADVANCE(90);
      if (lookahead == 'i')
        ADVANCE(93);
      if (lookahead == 'l')
        ADVANCE(109);
      if (lookahead == 'n')
        ADVANCE(112);
      if (lookahead == 'o')
        ADVANCE(118);
      if (lookahead == 'r')
        ADVANCE(120);
      if (lookahead == 's')
        ADVANCE(126);
      if (lookahead == 't')
        ADVANCE(143);
      if (lookahead == 'u')
        ADVANCE(164);
      if (lookahead == 'v')
        ADVANCE(173);
      if (lookahead == 'w')
        ADVANCE(179);
      if (lookahead == 'y')
        ADVANCE(187);
      END_STATE();
    case 1:
      if (lookahead == 's')
        ADVANCE(2);
      if (lookahead == 'w')
        ADVANCE(6);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'n')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'c')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 6:
      if (lookahead == 'a')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'i')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 't')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 10:
      if (lookahead == 'r')
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == 'e')
        ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == 'a')
        ADVANCE(13);
      END_STATE();
    case 13:
      if (lookahead == 'k')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 15:
      if (lookahead == 'a')
        ADVANCE(16);
      if (lookahead == 'l')
        ADVANCE(22);
      if (lookahead == 'o')
        ADVANCE(26);
      END_STATE();
    case 16:
      if (lookahead == 's')
        ADVANCE(17);
      if (lookahead == 't')
        ADVANCE(19);
      END_STATE();
    case 17:
      if (lookahead == 'e')
        ADVANCE(18);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 19:
      if (lookahead == 'c')
        ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == 'h')
        ADVANCE(21);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 22:
      if (lookahead == 'a')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 's')
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == 's')
        ADVANCE(25);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 26:
      if (lookahead == 'n')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 's')
        ADVANCE(28);
      if (lookahead == 't')
        ADVANCE(30);
      END_STATE();
    case 28:
      if (lookahead == 't')
        ADVANCE(29);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 30:
      if (lookahead == 'i')
        ADVANCE(31);
      END_STATE();
    case 31:
      if (lookahead == 'n')
        ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == 'u')
        ADVANCE(33);
      END_STATE();
    case 33:
      if (lookahead == 'e')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 35:
      if (lookahead == 'e')
        ADVANCE(36);
      if (lookahead == 'o')
        ADVANCE(52);
      END_STATE();
    case 36:
      if (lookahead == 'b')
        ADVANCE(37);
      if (lookahead == 'f')
        ADVANCE(43);
      if (lookahead == 'l')
        ADVANCE(48);
      END_STATE();
    case 37:
      if (lookahead == 'u')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'g')
        ADVANCE(39);
      END_STATE();
    case 39:
      if (lookahead == 'g')
        ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == 'e')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'r')
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 43:
      if (lookahead == 'a')
        ADVANCE(44);
      END_STATE();
    case 44:
      if (lookahead == 'u')
        ADVANCE(45);
      END_STATE();
    case 45:
      if (lookahead == 'l')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 't')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 48:
      if (lookahead == 'e')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 't')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 'e')
        ADVANCE(51);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 53:
      if (lookahead == 'l')
        ADVANCE(54);
      if (lookahead == 'x')
        ADVANCE(57);
      END_STATE();
    case 54:
      if (lookahead == 's')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 'e')
        ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 57:
      if (lookahead == 'p')
        ADVANCE(58);
      if (lookahead == 't')
        ADVANCE(62);
      END_STATE();
    case 58:
      if (lookahead == 'o')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'r')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 't')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 62:
      if (lookahead == 'e')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 'n')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'd')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 's')
        ADVANCE(66);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 67:
      if (lookahead == 'a')
        ADVANCE(68);
      if (lookahead == 'i')
        ADVANCE(72);
      if (lookahead == 'o')
        ADVANCE(78);
      if (lookahead == 'r')
        ADVANCE(80);
      if (lookahead == 'u')
        ADVANCE(83);
      END_STATE();
    case 68:
      if (lookahead == 'l')
        ADVANCE(69);
      END_STATE();
    case 69:
      if (lookahead == 's')
        ADVANCE(70);
      END_STATE();
    case 70:
      if (lookahead == 'e')
        ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 72:
      if (lookahead == 'n')
        ADVANCE(73);
      END_STATE();
    case 73:
      if (lookahead == 'a')
        ADVANCE(74);
      END_STATE();
    case 74:
      if (lookahead == 'l')
        ADVANCE(75);
      END_STATE();
    case 75:
      if (lookahead == 'l')
        ADVANCE(76);
      END_STATE();
    case 76:
      if (lookahead == 'y')
        ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 78:
      if (lookahead == 'r')
        ADVANCE(79);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 80:
      if (lookahead == 'o')
        ADVANCE(81);
      END_STATE();
    case 81:
      if (lookahead == 'm')
        ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 83:
      if (lookahead == 'n')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'c')
        ADVANCE(85);
      END_STATE();
    case 85:
      if (lookahead == 't')
        ADVANCE(86);
      END_STATE();
    case 86:
      if (lookahead == 'i')
        ADVANCE(87);
      END_STATE();
    case 87:
      if (lookahead == 'o')
        ADVANCE(88);
      END_STATE();
    case 88:
      if (lookahead == 'n')
        ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 90:
      if (lookahead == 'e')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 't')
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 93:
      if (lookahead == 'f')
        ADVANCE(94);
      if (lookahead == 'm')
        ADVANCE(95);
      if (lookahead == 'n')
        ADVANCE(100);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 95:
      if (lookahead == 'p')
        ADVANCE(96);
      END_STATE();
    case 96:
      if (lookahead == 'o')
        ADVANCE(97);
      END_STATE();
    case 97:
      if (lookahead == 'r')
        ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == 't')
        ADVANCE(99);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's')
        ADVANCE(101);
      END_STATE();
    case 101:
      if (lookahead == 't')
        ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == 'a')
        ADVANCE(103);
      END_STATE();
    case 103:
      if (lookahead == 'n')
        ADVANCE(104);
      END_STATE();
    case 104:
      if (lookahead == 'c')
        ADVANCE(105);
      END_STATE();
    case 105:
      if (lookahead == 'e')
        ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == 'o')
        ADVANCE(107);
      END_STATE();
    case 107:
      if (lookahead == 'f')
        ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 109:
      if (lookahead == 'e')
        ADVANCE(110);
      END_STATE();
    case 110:
      if (lookahead == 't')
        ADVANCE(111);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 112:
      if (lookahead == 'e')
        ADVANCE(113);
      if (lookahead == 'u')
        ADVANCE(115);
      END_STATE();
    case 113:
      if (lookahead == 'w')
        ADVANCE(114);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 115:
      if (lookahead == 'l')
        ADVANCE(116);
      END_STATE();
    case 116:
      if (lookahead == 'l')
        ADVANCE(117);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 118:
      if (lookahead == 'f')
        ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 120:
      if (lookahead == 'e')
        ADVANCE(121);
      END_STATE();
    case 121:
      if (lookahead == 't')
        ADVANCE(122);
      END_STATE();
    case 122:
      if (lookahead == 'u')
        ADVANCE(123);
      END_STATE();
    case 123:
      if (lookahead == 'r')
        ADVANCE(124);
      END_STATE();
    case 124:
      if (lookahead == 'n')
        ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 126:
      if (lookahead == 'e')
        ADVANCE(127);
      if (lookahead == 't')
        ADVANCE(129);
      if (lookahead == 'u')
        ADVANCE(134);
      if (lookahead == 'w')
        ADVANCE(138);
      END_STATE();
    case 127:
      if (lookahead == 't')
        ADVANCE(128);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 129:
      if (lookahead == 'a')
        ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == 't')
        ADVANCE(131);
      END_STATE();
    case 131:
      if (lookahead == 'i')
        ADVANCE(132);
      END_STATE();
    case 132:
      if (lookahead == 'c')
        ADVANCE(133);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 134:
      if (lookahead == 'p')
        ADVANCE(135);
      END_STATE();
    case 135:
      if (lookahead == 'e')
        ADVANCE(136);
      END_STATE();
    case 136:
      if (lookahead == 'r')
        ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 138:
      if (lookahead == 'i')
        ADVANCE(139);
      END_STATE();
    case 139:
      if (lookahead == 't')
        ADVANCE(140);
      END_STATE();
    case 140:
      if (lookahead == 'c')
        ADVANCE(141);
      END_STATE();
    case 141:
      if (lookahead == 'h')
        ADVANCE(142);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 143:
      if (lookahead == 'a')
        ADVANCE(144);
      if (lookahead == 'h')
        ADVANCE(149);
      if (lookahead == 'r')
        ADVANCE(155);
      if (lookahead == 'y')
        ADVANCE(159);
      END_STATE();
    case 144:
      if (lookahead == 'r')
        ADVANCE(145);
      END_STATE();
    case 145:
      if (lookahead == 'g')
        ADVANCE(146);
      END_STATE();
    case 146:
      if (lookahead == 'e')
        ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == 't')
        ADVANCE(148);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 149:
      if (lookahead == 'i')
        ADVANCE(150);
      if (lookahead == 'r')
        ADVANCE(152);
      END_STATE();
    case 150:
      if (lookahead == 's')
        ADVANCE(151);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 152:
      if (lookahead == 'o')
        ADVANCE(153);
      END_STATE();
    case 153:
      if (lookahead == 'w')
        ADVANCE(154);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 155:
      if (lookahead == 'u')
        ADVANCE(156);
      if (lookahead == 'y')
        ADVANCE(158);
      END_STATE();
    case 156:
      if (lookahead == 'e')
        ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 159:
      if (lookahead == 'p')
        ADVANCE(160);
      END_STATE();
    case 160:
      if (lookahead == 'e')
        ADVANCE(161);
      END_STATE();
    case 161:
      if (lookahead == 'o')
        ADVANCE(162);
      END_STATE();
    case 162:
      if (lookahead == 'f')
        ADVANCE(163);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 164:
      if (lookahead == 'n')
        ADVANCE(165);
      END_STATE();
    case 165:
      if (lookahead == 'd')
        ADVANCE(166);
      END_STATE();
    case 166:
      if (lookahead == 'e')
        ADVANCE(167);
      END_STATE();
    case 167:
      if (lookahead == 'f')
        ADVANCE(168);
      END_STATE();
    case 168:
      if (lookahead == 'i')
        ADVANCE(169);
      END_STATE();
    case 169:
      if (lookahead == 'n')
        ADVANCE(170);
      END_STATE();
    case 170:
      if (lookahead == 'e')
        ADVANCE(171);
      END_STATE();
    case 171:
      if (lookahead == 'd')
        ADVANCE(172);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 173:
      if (lookahead == 'a')
        ADVANCE(174);
      if (lookahead == 'o')
        ADVANCE(176);
      END_STATE();
    case 174:
      if (lookahead == 'r')
        ADVANCE(175);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 176:
      if (lookahead == 'i')
        ADVANCE(177);
      END_STATE();
    case 177:
      if (lookahead == 'd')
        ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 179:
      if (lookahead == 'h')
        ADVANCE(180);
      if (lookahead == 'i')
        ADVANCE(184);
      END_STATE();
    case 180:
      if (lookahead == 'i')
        ADVANCE(181);
      END_STATE();
    case 181:
      if (lookahead == 'l')
        ADVANCE(182);
      END_STATE();
    case 182:
      if (lookahead == 'e')
        ADVANCE(183);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 184:
      if (lookahead == 't')
        ADVANCE(185);
      END_STATE();
    case 185:
      if (lookahead == 'h')
        ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 187:
      if (lookahead == 'i')
        ADVANCE(188);
      END_STATE();
    case 188:
      if (lookahead == 'e')
        ADVANCE(189);
      END_STATE();
    case 189:
      if (lookahead == 'l')
        ADVANCE(190);
      END_STATE();
    case 190:
      if (lookahead == 'd')
        ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 87},
  [2] = {.lex_state = 94},
  [3] = {.lex_state = 95},
  [4] = {.lex_state = 95},
  [5] = {.lex_state = 95},
  [6] = {.lex_state = 87},
  [7] = {.lex_state = 87},
  [8] = {.lex_state = 87},
  [9] = {.lex_state = 87},
  [10] = {.lex_state = 87},
  [11] = {.lex_state = 98},
  [12] = {.lex_state = 87},
  [13] = {.lex_state = 87},
  [14] = {.lex_state = 87},
  [15] = {.lex_state = 87},
  [16] = {.lex_state = 87},
  [17] = {.lex_state = 94, .external_lex_state = 2},
  [18] = {.lex_state = 94, .external_lex_state = 2},
  [19] = {.lex_state = 94, .external_lex_state = 2},
  [20] = {.lex_state = 94, .external_lex_state = 2},
  [21] = {.lex_state = 87},
  [22] = {.lex_state = 99},
  [23] = {.lex_state = 100, .external_lex_state = 2},
  [24] = {.lex_state = 112},
  [25] = {.lex_state = 113},
  [26] = {.lex_state = 119},
  [27] = {.lex_state = 87},
  [28] = {.lex_state = 127, .external_lex_state = 2},
  [29] = {.lex_state = 95},
  [30] = {.lex_state = 87},
  [31] = {.lex_state = 131},
  [32] = {.lex_state = 87},
  [33] = {.lex_state = 87},
  [34] = {.lex_state = 133},
  [35] = {.lex_state = 141},
  [36] = {.lex_state = 149, .external_lex_state = 3},
  [37] = {.lex_state = 153, .external_lex_state = 2},
  [38] = {.lex_state = 100},
  [39] = {.lex_state = 87},
  [40] = {.lex_state = 127, .external_lex_state = 2},
  [41] = {.lex_state = 154},
  [42] = {.lex_state = 100, .external_lex_state = 2},
  [43] = {.lex_state = 155, .external_lex_state = 2},
  [44] = {.lex_state = 155, .external_lex_state = 2},
  [45] = {.lex_state = 157},
  [46] = {.lex_state = 164, .external_lex_state = 2},
  [47] = {.lex_state = 164, .external_lex_state = 2},
  [48] = {.lex_state = 127, .external_lex_state = 2},
  [49] = {.lex_state = 94, .external_lex_state = 2},
  [50] = {.lex_state = 87},
  [51] = {.lex_state = 94},
  [52] = {.lex_state = 87},
  [53] = {.lex_state = 94},
  [54] = {.lex_state = 87},
  [55] = {.lex_state = 87},
  [56] = {.lex_state = 95},
  [57] = {.lex_state = 87},
  [58] = {.lex_state = 87},
  [59] = {.lex_state = 95},
  [60] = {.lex_state = 94, .external_lex_state = 2},
  [61] = {.lex_state = 165},
  [62] = {.lex_state = 165, .external_lex_state = 2},
  [63] = {.lex_state = 87},
  [64] = {.lex_state = 87},
  [65] = {.lex_state = 95},
  [66] = {.lex_state = 166, .external_lex_state = 2},
  [67] = {.lex_state = 87},
  [68] = {.lex_state = 87},
  [69] = {.lex_state = 87},
  [70] = {.lex_state = 87},
  [71] = {.lex_state = 112},
  [72] = {.lex_state = 167, .external_lex_state = 2},
  [73] = {.lex_state = 87},
  [74] = {.lex_state = 168, .external_lex_state = 2},
  [75] = {.lex_state = 167, .external_lex_state = 2},
  [76] = {.lex_state = 167, .external_lex_state = 2},
  [77] = {.lex_state = 155, .external_lex_state = 2},
  [78] = {.lex_state = 95},
  [79] = {.lex_state = 155, .external_lex_state = 2},
  [80] = {.lex_state = 131},
  [81] = {.lex_state = 95},
  [82] = {.lex_state = 95},
  [83] = {.lex_state = 95},
  [84] = {.lex_state = 87},
  [85] = {.lex_state = 95},
  [86] = {.lex_state = 95},
  [87] = {.lex_state = 87},
  [88] = {.lex_state = 87},
  [89] = {.lex_state = 94, .external_lex_state = 2},
  [90] = {.lex_state = 95},
  [91] = {.lex_state = 112},
  [92] = {.lex_state = 169, .external_lex_state = 2},
  [93] = {.lex_state = 170, .external_lex_state = 2},
  [94] = {.lex_state = 169, .external_lex_state = 2},
  [95] = {.lex_state = 169, .external_lex_state = 2},
  [96] = {.lex_state = 170, .external_lex_state = 2},
  [97] = {.lex_state = 87},
  [98] = {.lex_state = 87},
  [99] = {.lex_state = 87},
  [100] = {.lex_state = 87},
  [101] = {.lex_state = 87},
  [102] = {.lex_state = 95},
  [103] = {.lex_state = 98},
  [104] = {.lex_state = 87},
  [105] = {.lex_state = 87},
  [106] = {.lex_state = 171},
  [107] = {.lex_state = 112},
  [108] = {.lex_state = 113},
  [109] = {.lex_state = 119},
  [110] = {.lex_state = 87},
  [111] = {.lex_state = 172},
  [112] = {.lex_state = 95},
  [113] = {.lex_state = 87},
  [114] = {.lex_state = 131},
  [115] = {.lex_state = 87},
  [116] = {.lex_state = 87},
  [117] = {.lex_state = 87},
  [118] = {.lex_state = 133},
  [119] = {.lex_state = 141},
  [120] = {.lex_state = 149, .external_lex_state = 3},
  [121] = {.lex_state = 172},
  [122] = {.lex_state = 100},
  [123] = {.lex_state = 172},
  [124] = {.lex_state = 171},
  [125] = {.lex_state = 171},
  [126] = {.lex_state = 98},
  [127] = {.lex_state = 171},
  [128] = {.lex_state = 157},
  [129] = {.lex_state = 173},
  [130] = {.lex_state = 172},
  [131] = {.lex_state = 98},
  [132] = {.lex_state = 87},
  [133] = {.lex_state = 87},
  [134] = {.lex_state = 95},
  [135] = {.lex_state = 127, .external_lex_state = 2},
  [136] = {.lex_state = 100, .external_lex_state = 2},
  [137] = {.lex_state = 174, .external_lex_state = 2},
  [138] = {.lex_state = 87},
  [139] = {.lex_state = 87},
  [140] = {.lex_state = 95},
  [141] = {.lex_state = 87},
  [142] = {.lex_state = 87},
  [143] = {.lex_state = 87},
  [144] = {.lex_state = 87},
  [145] = {.lex_state = 153, .external_lex_state = 2},
  [146] = {.lex_state = 87},
  [147] = {.lex_state = 100, .external_lex_state = 2},
  [148] = {.lex_state = 100, .external_lex_state = 2},
  [149] = {.lex_state = 87},
  [150] = {.lex_state = 95},
  [151] = {.lex_state = 165},
  [152] = {.lex_state = 87},
  [153] = {.lex_state = 165},
  [154] = {.lex_state = 94, .external_lex_state = 2},
  [155] = {.lex_state = 165},
  [156] = {.lex_state = 94, .external_lex_state = 2},
  [157] = {.lex_state = 165},
  [158] = {.lex_state = 165},
  [159] = {.lex_state = 100, .external_lex_state = 2},
  [160] = {.lex_state = 94, .external_lex_state = 2},
  [161] = {.lex_state = 100, .external_lex_state = 2},
  [162] = {.lex_state = 94, .external_lex_state = 2},
  [163] = {.lex_state = 100, .external_lex_state = 2},
  [164] = {.lex_state = 112},
  [165] = {.lex_state = 87},
  [166] = {.lex_state = 175},
  [167] = {.lex_state = 176, .external_lex_state = 2},
  [168] = {.lex_state = 177},
  [169] = {.lex_state = 87},
  [170] = {.lex_state = 131},
  [171] = {.lex_state = 87},
  [172] = {.lex_state = 87},
  [173] = {.lex_state = 87},
  [174] = {.lex_state = 177},
  [175] = {.lex_state = 177},
  [176] = {.lex_state = 175},
  [177] = {.lex_state = 175},
  [178] = {.lex_state = 175},
  [179] = {.lex_state = 177},
  [180] = {.lex_state = 112},
  [181] = {.lex_state = 87},
  [182] = {.lex_state = 112},
  [183] = {.lex_state = 157},
  [184] = {.lex_state = 113},
  [185] = {.lex_state = 113},
  [186] = {.lex_state = 113},
  [187] = {.lex_state = 113},
  [188] = {.lex_state = 178},
  [189] = {.lex_state = 95},
  [190] = {.lex_state = 87},
  [191] = {.lex_state = 87},
  [192] = {.lex_state = 87},
  [193] = {.lex_state = 174, .external_lex_state = 2},
  [194] = {.lex_state = 98},
  [195] = {.lex_state = 87},
  [196] = {.lex_state = 87},
  [197] = {.lex_state = 87},
  [198] = {.lex_state = 87},
  [199] = {.lex_state = 87},
  [200] = {.lex_state = 87},
  [201] = {.lex_state = 174, .external_lex_state = 2},
  [202] = {.lex_state = 87},
  [203] = {.lex_state = 87},
  [204] = {.lex_state = 87},
  [205] = {.lex_state = 95},
  [206] = {.lex_state = 174, .external_lex_state = 2},
  [207] = {.lex_state = 100, .external_lex_state = 2},
  [208] = {.lex_state = 87},
  [209] = {.lex_state = 100},
  [210] = {.lex_state = 87},
  [211] = {.lex_state = 127, .external_lex_state = 2},
  [212] = {.lex_state = 87},
  [213] = {.lex_state = 87},
  [214] = {.lex_state = 174, .external_lex_state = 2},
  [215] = {.lex_state = 127, .external_lex_state = 2},
  [216] = {.lex_state = 100},
  [217] = {.lex_state = 179, .external_lex_state = 2},
  [218] = {.lex_state = 100},
  [219] = {.lex_state = 176, .external_lex_state = 2},
  [220] = {.lex_state = 176, .external_lex_state = 2},
  [221] = {.lex_state = 174, .external_lex_state = 2},
  [222] = {.lex_state = 179, .external_lex_state = 2},
  [223] = {.lex_state = 174, .external_lex_state = 2},
  [224] = {.lex_state = 174, .external_lex_state = 2},
  [225] = {.lex_state = 180, .external_lex_state = 2},
  [226] = {.lex_state = 133},
  [227] = {.lex_state = 141},
  [228] = {.lex_state = 174, .external_lex_state = 2},
  [229] = {.lex_state = 87},
  [230] = {.lex_state = 149, .external_lex_state = 3},
  [231] = {.lex_state = 87},
  [232] = {.lex_state = 87},
  [233] = {.lex_state = 87},
  [234] = {.lex_state = 87},
  [235] = {.lex_state = 174, .external_lex_state = 2},
  [236] = {.lex_state = 98},
  [237] = {.lex_state = 87},
  [238] = {.lex_state = 174, .external_lex_state = 2},
  [239] = {.lex_state = 100},
  [240] = {.lex_state = 100},
  [241] = {.lex_state = 95},
  [242] = {.lex_state = 99},
  [243] = {.lex_state = 87},
  [244] = {.lex_state = 87},
  [245] = {.lex_state = 87},
  [246] = {.lex_state = 87},
  [247] = {.lex_state = 87},
  [248] = {.lex_state = 87},
  [249] = {.lex_state = 174, .external_lex_state = 2},
  [250] = {.lex_state = 174, .external_lex_state = 2},
  [251] = {.lex_state = 174, .external_lex_state = 2},
  [252] = {.lex_state = 95},
  [253] = {.lex_state = 113},
  [254] = {.lex_state = 157},
  [255] = {.lex_state = 174, .external_lex_state = 2},
  [256] = {.lex_state = 157},
  [257] = {.lex_state = 165},
  [258] = {.lex_state = 94},
  [259] = {.lex_state = 87},
  [260] = {.lex_state = 87},
  [261] = {.lex_state = 87},
  [262] = {.lex_state = 87},
  [263] = {.lex_state = 94, .external_lex_state = 2},
  [264] = {.lex_state = 87},
  [265] = {.lex_state = 182, .external_lex_state = 2},
  [266] = {.lex_state = 183, .external_lex_state = 2},
  [267] = {.lex_state = 87},
  [268] = {.lex_state = 131},
  [269] = {.lex_state = 87},
  [270] = {.lex_state = 87},
  [271] = {.lex_state = 183, .external_lex_state = 2},
  [272] = {.lex_state = 183, .external_lex_state = 2},
  [273] = {.lex_state = 182, .external_lex_state = 2},
  [274] = {.lex_state = 184, .external_lex_state = 2},
  [275] = {.lex_state = 184, .external_lex_state = 2},
  [276] = {.lex_state = 183, .external_lex_state = 2},
  [277] = {.lex_state = 87},
  [278] = {.lex_state = 95},
  [279] = {.lex_state = 94, .external_lex_state = 2},
  [280] = {.lex_state = 95},
  [281] = {.lex_state = 95},
  [282] = {.lex_state = 87},
  [283] = {.lex_state = 87},
  [284] = {.lex_state = 87},
  [285] = {.lex_state = 87},
  [286] = {.lex_state = 87},
  [287] = {.lex_state = 165},
  [288] = {.lex_state = 87},
  [289] = {.lex_state = 87},
  [290] = {.lex_state = 87},
  [291] = {.lex_state = 87},
  [292] = {.lex_state = 87},
  [293] = {.lex_state = 95},
  [294] = {.lex_state = 112},
  [295] = {.lex_state = 131},
  [296] = {.lex_state = 131},
  [297] = {.lex_state = 131},
  [298] = {.lex_state = 113},
  [299] = {.lex_state = 95},
  [300] = {.lex_state = 113},
  [301] = {.lex_state = 95},
  [302] = {.lex_state = 87},
  [303] = {.lex_state = 87},
  [304] = {.lex_state = 87},
  [305] = {.lex_state = 87},
  [306] = {.lex_state = 87},
  [307] = {.lex_state = 175},
  [308] = {.lex_state = 87},
  [309] = {.lex_state = 176, .external_lex_state = 2},
  [310] = {.lex_state = 87},
  [311] = {.lex_state = 87},
  [312] = {.lex_state = 95},
  [313] = {.lex_state = 87},
  [314] = {.lex_state = 164},
  [315] = {.lex_state = 167},
  [316] = {.lex_state = 87},
  [317] = {.lex_state = 131},
  [318] = {.lex_state = 87},
  [319] = {.lex_state = 87},
  [320] = {.lex_state = 167},
  [321] = {.lex_state = 167},
  [322] = {.lex_state = 164},
  [323] = {.lex_state = 166},
  [324] = {.lex_state = 166},
  [325] = {.lex_state = 167},
  [326] = {.lex_state = 87},
  [327] = {.lex_state = 87},
  [328] = {.lex_state = 87},
  [329] = {.lex_state = 164, .external_lex_state = 2},
  [330] = {.lex_state = 164, .external_lex_state = 2},
  [331] = {.lex_state = 176, .external_lex_state = 2},
  [332] = {.lex_state = 95},
  [333] = {.lex_state = 164, .external_lex_state = 2},
  [334] = {.lex_state = 87},
  [335] = {.lex_state = 87},
  [336] = {.lex_state = 185},
  [337] = {.lex_state = 153, .external_lex_state = 2},
  [338] = {.lex_state = 95},
  [339] = {.lex_state = 95},
  [340] = {.lex_state = 87},
  [341] = {.lex_state = 95},
  [342] = {.lex_state = 87},
  [343] = {.lex_state = 95},
  [344] = {.lex_state = 95},
  [345] = {.lex_state = 87},
  [346] = {.lex_state = 95},
  [347] = {.lex_state = 87},
  [348] = {.lex_state = 95},
  [349] = {.lex_state = 95},
  [350] = {.lex_state = 94, .external_lex_state = 2},
  [351] = {.lex_state = 165},
  [352] = {.lex_state = 169, .external_lex_state = 2},
  [353] = {.lex_state = 131},
  [354] = {.lex_state = 131},
  [355] = {.lex_state = 131},
  [356] = {.lex_state = 95},
  [357] = {.lex_state = 95},
  [358] = {.lex_state = 95},
  [359] = {.lex_state = 169, .external_lex_state = 2},
  [360] = {.lex_state = 175},
  [361] = {.lex_state = 112},
  [362] = {.lex_state = 112},
  [363] = {.lex_state = 170, .external_lex_state = 2},
  [364] = {.lex_state = 165},
  [365] = {.lex_state = 87},
  [366] = {.lex_state = 170, .external_lex_state = 2},
  [367] = {.lex_state = 170, .external_lex_state = 2},
  [368] = {.lex_state = 170, .external_lex_state = 2},
  [369] = {.lex_state = 165},
  [370] = {.lex_state = 170, .external_lex_state = 2},
  [371] = {.lex_state = 172},
  [372] = {.lex_state = 172},
  [373] = {.lex_state = 172},
  [374] = {.lex_state = 171},
  [375] = {.lex_state = 171},
  [376] = {.lex_state = 171},
  [377] = {.lex_state = 98},
  [378] = {.lex_state = 87},
  [379] = {.lex_state = 87},
  [380] = {.lex_state = 87},
  [381] = {.lex_state = 87},
  [382] = {.lex_state = 153, .external_lex_state = 2},
  [383] = {.lex_state = 94},
  [384] = {.lex_state = 95},
  [385] = {.lex_state = 165},
  [386] = {.lex_state = 87},
  [387] = {.lex_state = 87},
  [388] = {.lex_state = 127, .external_lex_state = 2},
  [389] = {.lex_state = 87},
  [390] = {.lex_state = 155, .external_lex_state = 2},
  [391] = {.lex_state = 155, .external_lex_state = 2},
  [392] = {.lex_state = 87},
  [393] = {.lex_state = 173},
  [394] = {.lex_state = 131},
  [395] = {.lex_state = 131},
  [396] = {.lex_state = 131},
  [397] = {.lex_state = 95},
  [398] = {.lex_state = 95},
  [399] = {.lex_state = 95},
  [400] = {.lex_state = 171},
  [401] = {.lex_state = 98},
  [402] = {.lex_state = 171},
  [403] = {.lex_state = 171},
  [404] = {.lex_state = 173},
  [405] = {.lex_state = 175},
  [406] = {.lex_state = 112},
  [407] = {.lex_state = 112},
  [408] = {.lex_state = 157},
  [409] = {.lex_state = 113},
  [410] = {.lex_state = 113},
  [411] = {.lex_state = 113},
  [412] = {.lex_state = 113},
  [413] = {.lex_state = 178},
  [414] = {.lex_state = 95},
  [415] = {.lex_state = 87},
  [416] = {.lex_state = 87},
  [417] = {.lex_state = 173},
  [418] = {.lex_state = 95},
  [419] = {.lex_state = 87},
  [420] = {.lex_state = 87},
  [421] = {.lex_state = 87},
  [422] = {.lex_state = 87},
  [423] = {.lex_state = 87},
  [424] = {.lex_state = 87},
  [425] = {.lex_state = 87},
  [426] = {.lex_state = 173},
  [427] = {.lex_state = 98},
  [428] = {.lex_state = 87},
  [429] = {.lex_state = 87},
  [430] = {.lex_state = 87},
  [431] = {.lex_state = 95},
  [432] = {.lex_state = 173},
  [433] = {.lex_state = 171},
  [434] = {.lex_state = 87},
  [435] = {.lex_state = 172},
  [436] = {.lex_state = 173},
  [437] = {.lex_state = 172},
  [438] = {.lex_state = 186},
  [439] = {.lex_state = 100},
  [440] = {.lex_state = 173},
  [441] = {.lex_state = 173},
  [442] = {.lex_state = 173},
  [443] = {.lex_state = 186},
  [444] = {.lex_state = 98},
  [445] = {.lex_state = 173},
  [446] = {.lex_state = 173},
  [447] = {.lex_state = 173},
  [448] = {.lex_state = 133},
  [449] = {.lex_state = 141},
  [450] = {.lex_state = 173},
  [451] = {.lex_state = 149, .external_lex_state = 3},
  [452] = {.lex_state = 87},
  [453] = {.lex_state = 87},
  [454] = {.lex_state = 87},
  [455] = {.lex_state = 87},
  [456] = {.lex_state = 171},
  [457] = {.lex_state = 98},
  [458] = {.lex_state = 98},
  [459] = {.lex_state = 87},
  [460] = {.lex_state = 173},
  [461] = {.lex_state = 87},
  [462] = {.lex_state = 87},
  [463] = {.lex_state = 174, .external_lex_state = 2},
  [464] = {.lex_state = 87},
  [465] = {.lex_state = 87},
  [466] = {.lex_state = 87},
  [467] = {.lex_state = 87},
  [468] = {.lex_state = 173},
  [469] = {.lex_state = 87},
  [470] = {.lex_state = 171},
  [471] = {.lex_state = 98},
  [472] = {.lex_state = 87},
  [473] = {.lex_state = 171},
  [474] = {.lex_state = 98},
  [475] = {.lex_state = 113},
  [476] = {.lex_state = 173},
  [477] = {.lex_state = 157},
  [478] = {.lex_state = 173},
  [479] = {.lex_state = 87},
  [480] = {.lex_state = 176, .external_lex_state = 2},
  [481] = {.lex_state = 131},
  [482] = {.lex_state = 131},
  [483] = {.lex_state = 131},
  [484] = {.lex_state = 95},
  [485] = {.lex_state = 165},
  [486] = {.lex_state = 87},
  [487] = {.lex_state = 87},
  [488] = {.lex_state = 87},
  [489] = {.lex_state = 87},
  [490] = {.lex_state = 87},
  [491] = {.lex_state = 87},
  [492] = {.lex_state = 87},
  [493] = {.lex_state = 87},
  [494] = {.lex_state = 87},
  [495] = {.lex_state = 87},
  [496] = {.lex_state = 87},
  [497] = {.lex_state = 185},
  [498] = {.lex_state = 87},
  [499] = {.lex_state = 87},
  [500] = {.lex_state = 165},
  [501] = {.lex_state = 165},
  [502] = {.lex_state = 165},
  [503] = {.lex_state = 165},
  [504] = {.lex_state = 165},
  [505] = {.lex_state = 165},
  [506] = {.lex_state = 165},
  [507] = {.lex_state = 175},
  [508] = {.lex_state = 187},
  [509] = {.lex_state = 175},
  [510] = {.lex_state = 175},
  [511] = {.lex_state = 87},
  [512] = {.lex_state = 87},
  [513] = {.lex_state = 87},
  [514] = {.lex_state = 87},
  [515] = {.lex_state = 175},
  [516] = {.lex_state = 177},
  [517] = {.lex_state = 177},
  [518] = {.lex_state = 175},
  [519] = {.lex_state = 87},
  [520] = {.lex_state = 87},
  [521] = {.lex_state = 87},
  [522] = {.lex_state = 176, .external_lex_state = 2},
  [523] = {.lex_state = 87},
  [524] = {.lex_state = 87},
  [525] = {.lex_state = 87},
  [526] = {.lex_state = 87},
  [527] = {.lex_state = 112},
  [528] = {.lex_state = 173},
  [529] = {.lex_state = 173},
  [530] = {.lex_state = 112},
  [531] = {.lex_state = 113},
  [532] = {.lex_state = 157},
  [533] = {.lex_state = 95},
  [534] = {.lex_state = 113},
  [535] = {.lex_state = 157},
  [536] = {.lex_state = 113},
  [537] = {.lex_state = 113},
  [538] = {.lex_state = 113},
  [539] = {.lex_state = 113},
  [540] = {.lex_state = 87},
  [541] = {.lex_state = 188, .external_lex_state = 2},
  [542] = {.lex_state = 174, .external_lex_state = 2},
  [543] = {.lex_state = 87},
  [544] = {.lex_state = 191, .external_lex_state = 2},
  [545] = {.lex_state = 133},
  [546] = {.lex_state = 141},
  [547] = {.lex_state = 192, .external_lex_state = 2},
  [548] = {.lex_state = 95},
  [549] = {.lex_state = 192, .external_lex_state = 2},
  [550] = {.lex_state = 94, .external_lex_state = 2},
  [551] = {.lex_state = 95},
  [552] = {.lex_state = 192, .external_lex_state = 2},
  [553] = {.lex_state = 95},
  [554] = {.lex_state = 95},
  [555] = {.lex_state = 87},
  [556] = {.lex_state = 100},
  [557] = {.lex_state = 127},
  [558] = {.lex_state = 87},
  [559] = {.lex_state = 131},
  [560] = {.lex_state = 87},
  [561] = {.lex_state = 87},
  [562] = {.lex_state = 127},
  [563] = {.lex_state = 127},
  [564] = {.lex_state = 100},
  [565] = {.lex_state = 155},
  [566] = {.lex_state = 155},
  [567] = {.lex_state = 127},
  [568] = {.lex_state = 87},
  [569] = {.lex_state = 87},
  [570] = {.lex_state = 174, .external_lex_state = 2},
  [571] = {.lex_state = 174, .external_lex_state = 2},
  [572] = {.lex_state = 112},
  [573] = {.lex_state = 98},
  [574] = {.lex_state = 193},
  [575] = {.lex_state = 193},
  [576] = {.lex_state = 193},
  [577] = {.lex_state = 179, .external_lex_state = 2},
  [578] = {.lex_state = 100, .external_lex_state = 2},
  [579] = {.lex_state = 87},
  [580] = {.lex_state = 87},
  [581] = {.lex_state = 174, .external_lex_state = 2},
  [582] = {.lex_state = 100, .external_lex_state = 2},
  [583] = {.lex_state = 100, .external_lex_state = 2},
  [584] = {.lex_state = 87},
  [585] = {.lex_state = 87},
  [586] = {.lex_state = 87},
  [587] = {.lex_state = 95},
  [588] = {.lex_state = 174, .external_lex_state = 2},
  [589] = {.lex_state = 95},
  [590] = {.lex_state = 127},
  [591] = {.lex_state = 87},
  [592] = {.lex_state = 131},
  [593] = {.lex_state = 127},
  [594] = {.lex_state = 127},
  [595] = {.lex_state = 155},
  [596] = {.lex_state = 155},
  [597] = {.lex_state = 127},
  [598] = {.lex_state = 87},
  [599] = {.lex_state = 174, .external_lex_state = 2},
  [600] = {.lex_state = 98},
  [601] = {.lex_state = 87},
  [602] = {.lex_state = 87},
  [603] = {.lex_state = 174, .external_lex_state = 2},
  [604] = {.lex_state = 174, .external_lex_state = 2},
  [605] = {.lex_state = 87},
  [606] = {.lex_state = 87},
  [607] = {.lex_state = 87},
  [608] = {.lex_state = 87},
  [609] = {.lex_state = 87},
  [610] = {.lex_state = 87},
  [611] = {.lex_state = 180, .external_lex_state = 2},
  [612] = {.lex_state = 133},
  [613] = {.lex_state = 141},
  [614] = {.lex_state = 164},
  [615] = {.lex_state = 95},
  [616] = {.lex_state = 174, .external_lex_state = 2},
  [617] = {.lex_state = 149, .external_lex_state = 3},
  [618] = {.lex_state = 100, .external_lex_state = 2},
  [619] = {.lex_state = 165},
  [620] = {.lex_state = 179, .external_lex_state = 2},
  [621] = {.lex_state = 100, .external_lex_state = 2},
  [622] = {.lex_state = 98},
  [623] = {.lex_state = 174, .external_lex_state = 2},
  [624] = {.lex_state = 87},
  [625] = {.lex_state = 171},
  [626] = {.lex_state = 98},
  [627] = {.lex_state = 98},
  [628] = {.lex_state = 175},
  [629] = {.lex_state = 112},
  [630] = {.lex_state = 87},
  [631] = {.lex_state = 95},
  [632] = {.lex_state = 174, .external_lex_state = 2},
  [633] = {.lex_state = 100, .external_lex_state = 2},
  [634] = {.lex_state = 94, .external_lex_state = 2},
  [635] = {.lex_state = 87},
  [636] = {.lex_state = 168},
  [637] = {.lex_state = 153},
  [638] = {.lex_state = 87},
  [639] = {.lex_state = 131},
  [640] = {.lex_state = 87},
  [641] = {.lex_state = 87},
  [642] = {.lex_state = 153},
  [643] = {.lex_state = 153},
  [644] = {.lex_state = 168},
  [645] = {.lex_state = 194},
  [646] = {.lex_state = 194},
  [647] = {.lex_state = 153},
  [648] = {.lex_state = 87},
  [649] = {.lex_state = 100, .external_lex_state = 2},
  [650] = {.lex_state = 100, .external_lex_state = 2},
  [651] = {.lex_state = 100, .external_lex_state = 2},
  [652] = {.lex_state = 157},
  [653] = {.lex_state = 87},
  [654] = {.lex_state = 164},
  [655] = {.lex_state = 95},
  [656] = {.lex_state = 113},
  [657] = {.lex_state = 113},
  [658] = {.lex_state = 113},
  [659] = {.lex_state = 113},
  [660] = {.lex_state = 113},
  [661] = {.lex_state = 113},
  [662] = {.lex_state = 157},
  [663] = {.lex_state = 157},
  [664] = {.lex_state = 174, .external_lex_state = 2},
  [665] = {.lex_state = 157},
  [666] = {.lex_state = 87},
  [667] = {.lex_state = 87},
  [668] = {.lex_state = 87},
  [669] = {.lex_state = 94, .external_lex_state = 2},
  [670] = {.lex_state = 165},
  [671] = {.lex_state = 182, .external_lex_state = 2},
  [672] = {.lex_state = 182, .external_lex_state = 2},
  [673] = {.lex_state = 87},
  [674] = {.lex_state = 87},
  [675] = {.lex_state = 87},
  [676] = {.lex_state = 87},
  [677] = {.lex_state = 182, .external_lex_state = 2},
  [678] = {.lex_state = 183, .external_lex_state = 2},
  [679] = {.lex_state = 183, .external_lex_state = 2},
  [680] = {.lex_state = 87},
  [681] = {.lex_state = 87},
  [682] = {.lex_state = 87},
  [683] = {.lex_state = 87},
  [684] = {.lex_state = 87},
  [685] = {.lex_state = 87},
  [686] = {.lex_state = 87},
  [687] = {.lex_state = 94, .external_lex_state = 2},
  [688] = {.lex_state = 87},
  [689] = {.lex_state = 95},
  [690] = {.lex_state = 94, .external_lex_state = 2},
  [691] = {.lex_state = 95},
  [692] = {.lex_state = 95},
  [693] = {.lex_state = 87},
  [694] = {.lex_state = 165, .external_lex_state = 2},
  [695] = {.lex_state = 87},
  [696] = {.lex_state = 87},
  [697] = {.lex_state = 87},
  [698] = {.lex_state = 87},
  [699] = {.lex_state = 95},
  [700] = {.lex_state = 165, .external_lex_state = 2},
  [701] = {.lex_state = 87},
  [702] = {.lex_state = 87},
  [703] = {.lex_state = 175},
  [704] = {.lex_state = 177},
  [705] = {.lex_state = 87},
  [706] = {.lex_state = 131},
  [707] = {.lex_state = 87},
  [708] = {.lex_state = 87},
  [709] = {.lex_state = 177},
  [710] = {.lex_state = 177},
  [711] = {.lex_state = 175},
  [712] = {.lex_state = 175},
  [713] = {.lex_state = 175},
  [714] = {.lex_state = 177},
  [715] = {.lex_state = 87},
  [716] = {.lex_state = 87},
  [717] = {.lex_state = 193},
  [718] = {.lex_state = 131},
  [719] = {.lex_state = 131},
  [720] = {.lex_state = 131},
  [721] = {.lex_state = 95},
  [722] = {.lex_state = 95},
  [723] = {.lex_state = 95},
  [724] = {.lex_state = 193},
  [725] = {.lex_state = 175},
  [726] = {.lex_state = 112},
  [727] = {.lex_state = 112},
  [728] = {.lex_state = 87},
  [729] = {.lex_state = 174},
  [730] = {.lex_state = 174},
  [731] = {.lex_state = 174},
  [732] = {.lex_state = 95},
  [733] = {.lex_state = 95},
  [734] = {.lex_state = 87},
  [735] = {.lex_state = 87},
  [736] = {.lex_state = 87},
  [737] = {.lex_state = 87},
  [738] = {.lex_state = 153, .external_lex_state = 2},
  [739] = {.lex_state = 95},
  [740] = {.lex_state = 87},
  [741] = {.lex_state = 87},
  [742] = {.lex_state = 127, .external_lex_state = 2},
  [743] = {.lex_state = 87},
  [744] = {.lex_state = 155, .external_lex_state = 2},
  [745] = {.lex_state = 155, .external_lex_state = 2},
  [746] = {.lex_state = 87},
  [747] = {.lex_state = 194, .external_lex_state = 2},
  [748] = {.lex_state = 87},
  [749] = {.lex_state = 176, .external_lex_state = 2},
  [750] = {.lex_state = 164},
  [751] = {.lex_state = 164},
  [752] = {.lex_state = 87},
  [753] = {.lex_state = 87},
  [754] = {.lex_state = 87},
  [755] = {.lex_state = 164},
  [756] = {.lex_state = 167},
  [757] = {.lex_state = 167},
  [758] = {.lex_state = 87},
  [759] = {.lex_state = 87},
  [760] = {.lex_state = 87},
  [761] = {.lex_state = 87},
  [762] = {.lex_state = 87},
  [763] = {.lex_state = 87},
  [764] = {.lex_state = 87},
  [765] = {.lex_state = 87},
  [766] = {.lex_state = 164, .external_lex_state = 2},
  [767] = {.lex_state = 195, .external_lex_state = 2},
  [768] = {.lex_state = 87},
  [769] = {.lex_state = 131},
  [770] = {.lex_state = 87},
  [771] = {.lex_state = 87},
  [772] = {.lex_state = 195, .external_lex_state = 2},
  [773] = {.lex_state = 195, .external_lex_state = 2},
  [774] = {.lex_state = 164, .external_lex_state = 2},
  [775] = {.lex_state = 166, .external_lex_state = 2},
  [776] = {.lex_state = 166, .external_lex_state = 2},
  [777] = {.lex_state = 195, .external_lex_state = 2},
  [778] = {.lex_state = 87},
  [779] = {.lex_state = 176, .external_lex_state = 2},
  [780] = {.lex_state = 164},
  [781] = {.lex_state = 95},
  [782] = {.lex_state = 95},
  [783] = {.lex_state = 87},
  [784] = {.lex_state = 87},
  [785] = {.lex_state = 95},
  [786] = {.lex_state = 87},
  [787] = {.lex_state = 95},
  [788] = {.lex_state = 87},
  [789] = {.lex_state = 165},
  [790] = {.lex_state = 169, .external_lex_state = 2},
  [791] = {.lex_state = 95},
  [792] = {.lex_state = 169, .external_lex_state = 2},
  [793] = {.lex_state = 95},
  [794] = {.lex_state = 95},
  [795] = {.lex_state = 169, .external_lex_state = 2},
  [796] = {.lex_state = 112},
  [797] = {.lex_state = 170, .external_lex_state = 2},
  [798] = {.lex_state = 165},
  [799] = {.lex_state = 170, .external_lex_state = 2},
  [800] = {.lex_state = 165},
  [801] = {.lex_state = 87},
  [802] = {.lex_state = 87},
  [803] = {.lex_state = 87},
  [804] = {.lex_state = 87},
  [805] = {.lex_state = 87},
  [806] = {.lex_state = 87},
  [807] = {.lex_state = 87},
  [808] = {.lex_state = 87},
  [809] = {.lex_state = 113},
  [810] = {.lex_state = 165},
  [811] = {.lex_state = 87},
  [812] = {.lex_state = 95},
  [813] = {.lex_state = 169, .external_lex_state = 2},
  [814] = {.lex_state = 169, .external_lex_state = 2},
  [815] = {.lex_state = 169, .external_lex_state = 2},
  [816] = {.lex_state = 87},
  [817] = {.lex_state = 87},
  [818] = {.lex_state = 98},
  [819] = {.lex_state = 87},
  [820] = {.lex_state = 87},
  [821] = {.lex_state = 87},
  [822] = {.lex_state = 87},
  [823] = {.lex_state = 87},
  [824] = {.lex_state = 87},
  [825] = {.lex_state = 87},
  [826] = {.lex_state = 87},
  [827] = {.lex_state = 173},
  [828] = {.lex_state = 95},
  [829] = {.lex_state = 173},
  [830] = {.lex_state = 95},
  [831] = {.lex_state = 95},
  [832] = {.lex_state = 173},
  [833] = {.lex_state = 173},
  [834] = {.lex_state = 112},
  [835] = {.lex_state = 113},
  [836] = {.lex_state = 157},
  [837] = {.lex_state = 113},
  [838] = {.lex_state = 113},
  [839] = {.lex_state = 196},
  [840] = {.lex_state = 173},
  [841] = {.lex_state = 95},
  [842] = {.lex_state = 87},
  [843] = {.lex_state = 173},
  [844] = {.lex_state = 173},
  [845] = {.lex_state = 98},
  [846] = {.lex_state = 193},
  [847] = {.lex_state = 193},
  [848] = {.lex_state = 98},
  [849] = {.lex_state = 193},
  [850] = {.lex_state = 186},
  [851] = {.lex_state = 171},
  [852] = {.lex_state = 87},
  [853] = {.lex_state = 87},
  [854] = {.lex_state = 173},
  [855] = {.lex_state = 171},
  [856] = {.lex_state = 171},
  [857] = {.lex_state = 87},
  [858] = {.lex_state = 87},
  [859] = {.lex_state = 98},
  [860] = {.lex_state = 87},
  [861] = {.lex_state = 87},
  [862] = {.lex_state = 95},
  [863] = {.lex_state = 173},
  [864] = {.lex_state = 167, .external_lex_state = 2},
  [865] = {.lex_state = 167, .external_lex_state = 2},
  [866] = {.lex_state = 167, .external_lex_state = 2},
  [867] = {.lex_state = 95},
  [868] = {.lex_state = 95},
  [869] = {.lex_state = 173},
  [870] = {.lex_state = 98},
  [871] = {.lex_state = 173},
  [872] = {.lex_state = 173},
  [873] = {.lex_state = 173},
  [874] = {.lex_state = 173},
  [875] = {.lex_state = 171},
  [876] = {.lex_state = 186},
  [877] = {.lex_state = 171},
  [878] = {.lex_state = 87},
  [879] = {.lex_state = 173},
  [880] = {.lex_state = 171},
  [881] = {.lex_state = 98},
  [882] = {.lex_state = 98},
  [883] = {.lex_state = 175},
  [884] = {.lex_state = 112},
  [885] = {.lex_state = 173},
  [886] = {.lex_state = 171},
  [887] = {.lex_state = 173},
  [888] = {.lex_state = 168},
  [889] = {.lex_state = 171},
  [890] = {.lex_state = 171},
  [891] = {.lex_state = 171},
  [892] = {.lex_state = 87},
  [893] = {.lex_state = 87},
  [894] = {.lex_state = 113},
  [895] = {.lex_state = 173},
  [896] = {.lex_state = 87},
  [897] = {.lex_state = 87},
  [898] = {.lex_state = 87},
  [899] = {.lex_state = 87},
  [900] = {.lex_state = 87},
  [901] = {.lex_state = 87},
  [902] = {.lex_state = 87},
  [903] = {.lex_state = 153, .external_lex_state = 2},
  [904] = {.lex_state = 87},
  [905] = {.lex_state = 87},
  [906] = {.lex_state = 87},
  [907] = {.lex_state = 127, .external_lex_state = 2},
  [908] = {.lex_state = 87},
  [909] = {.lex_state = 155, .external_lex_state = 2},
  [910] = {.lex_state = 155, .external_lex_state = 2},
  [911] = {.lex_state = 87},
  [912] = {.lex_state = 87},
  [913] = {.lex_state = 94, .external_lex_state = 2},
  [914] = {.lex_state = 87},
  [915] = {.lex_state = 165},
  [916] = {.lex_state = 165},
  [917] = {.lex_state = 165},
  [918] = {.lex_state = 175},
  [919] = {.lex_state = 175},
  [920] = {.lex_state = 175},
  [921] = {.lex_state = 87},
  [922] = {.lex_state = 175},
  [923] = {.lex_state = 175},
  [924] = {.lex_state = 168},
  [925] = {.lex_state = 175},
  [926] = {.lex_state = 175},
  [927] = {.lex_state = 175},
  [928] = {.lex_state = 176, .external_lex_state = 2},
  [929] = {.lex_state = 113},
  [930] = {.lex_state = 113},
  [931] = {.lex_state = 113},
  [932] = {.lex_state = 164},
  [933] = {.lex_state = 95},
  [934] = {.lex_state = 113},
  [935] = {.lex_state = 174, .external_lex_state = 2},
  [936] = {.lex_state = 87},
  [937] = {.lex_state = 87},
  [938] = {.lex_state = 157},
  [939] = {.lex_state = 113},
  [940] = {.lex_state = 113},
  [941] = {.lex_state = 113},
  [942] = {.lex_state = 174, .external_lex_state = 2},
  [943] = {.lex_state = 175},
  [944] = {.lex_state = 192, .external_lex_state = 2},
  [945] = {.lex_state = 133},
  [946] = {.lex_state = 141},
  [947] = {.lex_state = 94, .external_lex_state = 2},
  [948] = {.lex_state = 95},
  [949] = {.lex_state = 95},
  [950] = {.lex_state = 94, .external_lex_state = 2},
  [951] = {.lex_state = 95},
  [952] = {.lex_state = 95},
  [953] = {.lex_state = 174, .external_lex_state = 2},
  [954] = {.lex_state = 95},
  [955] = {.lex_state = 100},
  [956] = {.lex_state = 100},
  [957] = {.lex_state = 87},
  [958] = {.lex_state = 87},
  [959] = {.lex_state = 87},
  [960] = {.lex_state = 87},
  [961] = {.lex_state = 100},
  [962] = {.lex_state = 127},
  [963] = {.lex_state = 127},
  [964] = {.lex_state = 87},
  [965] = {.lex_state = 87},
  [966] = {.lex_state = 87},
  [967] = {.lex_state = 87},
  [968] = {.lex_state = 87},
  [969] = {.lex_state = 87},
  [970] = {.lex_state = 87},
  [971] = {.lex_state = 174, .external_lex_state = 2},
  [972] = {.lex_state = 175},
  [973] = {.lex_state = 87},
  [974] = {.lex_state = 174, .external_lex_state = 2},
  [975] = {.lex_state = 174, .external_lex_state = 2},
  [976] = {.lex_state = 100, .external_lex_state = 2},
  [977] = {.lex_state = 87},
  [978] = {.lex_state = 174, .external_lex_state = 2},
  [979] = {.lex_state = 174, .external_lex_state = 2},
  [980] = {.lex_state = 174, .external_lex_state = 2},
  [981] = {.lex_state = 87},
  [982] = {.lex_state = 87},
  [983] = {.lex_state = 127},
  [984] = {.lex_state = 127},
  [985] = {.lex_state = 174, .external_lex_state = 2},
  [986] = {.lex_state = 87},
  [987] = {.lex_state = 100},
  [988] = {.lex_state = 168},
  [989] = {.lex_state = 100},
  [990] = {.lex_state = 100},
  [991] = {.lex_state = 100},
  [992] = {.lex_state = 87},
  [993] = {.lex_state = 149, .external_lex_state = 3},
  [994] = {.lex_state = 171},
  [995] = {.lex_state = 171},
  [996] = {.lex_state = 174, .external_lex_state = 2},
  [997] = {.lex_state = 98},
  [998] = {.lex_state = 98},
  [999] = {.lex_state = 87},
  [1000] = {.lex_state = 179, .external_lex_state = 2},
  [1001] = {.lex_state = 100},
  [1002] = {.lex_state = 168},
  [1003] = {.lex_state = 168},
  [1004] = {.lex_state = 87},
  [1005] = {.lex_state = 87},
  [1006] = {.lex_state = 87},
  [1007] = {.lex_state = 87},
  [1008] = {.lex_state = 168},
  [1009] = {.lex_state = 153},
  [1010] = {.lex_state = 153},
  [1011] = {.lex_state = 87},
  [1012] = {.lex_state = 87},
  [1013] = {.lex_state = 87},
  [1014] = {.lex_state = 87},
  [1015] = {.lex_state = 87},
  [1016] = {.lex_state = 87},
  [1017] = {.lex_state = 87},
  [1018] = {.lex_state = 87},
  [1019] = {.lex_state = 87},
  [1020] = {.lex_state = 164},
  [1021] = {.lex_state = 167},
  [1022] = {.lex_state = 87},
  [1023] = {.lex_state = 131},
  [1024] = {.lex_state = 87},
  [1025] = {.lex_state = 87},
  [1026] = {.lex_state = 167},
  [1027] = {.lex_state = 167},
  [1028] = {.lex_state = 164},
  [1029] = {.lex_state = 166},
  [1030] = {.lex_state = 166},
  [1031] = {.lex_state = 167},
  [1032] = {.lex_state = 87},
  [1033] = {.lex_state = 157},
  [1034] = {.lex_state = 113},
  [1035] = {.lex_state = 113},
  [1036] = {.lex_state = 113},
  [1037] = {.lex_state = 113},
  [1038] = {.lex_state = 113},
  [1039] = {.lex_state = 113},
  [1040] = {.lex_state = 113},
  [1041] = {.lex_state = 157},
  [1042] = {.lex_state = 113},
  [1043] = {.lex_state = 182, .external_lex_state = 2},
  [1044] = {.lex_state = 87},
  [1045] = {.lex_state = 174, .external_lex_state = 2},
  [1046] = {.lex_state = 182, .external_lex_state = 2},
  [1047] = {.lex_state = 182, .external_lex_state = 2},
  [1048] = {.lex_state = 182, .external_lex_state = 2},
  [1049] = {.lex_state = 87},
  [1050] = {.lex_state = 182, .external_lex_state = 2},
  [1051] = {.lex_state = 182, .external_lex_state = 2},
  [1052] = {.lex_state = 168},
  [1053] = {.lex_state = 182, .external_lex_state = 2},
  [1054] = {.lex_state = 182, .external_lex_state = 2},
  [1055] = {.lex_state = 182, .external_lex_state = 2},
  [1056] = {.lex_state = 95},
  [1057] = {.lex_state = 94, .external_lex_state = 2},
  [1058] = {.lex_state = 95},
  [1059] = {.lex_state = 95},
  [1060] = {.lex_state = 95},
  [1061] = {.lex_state = 165, .external_lex_state = 2},
  [1062] = {.lex_state = 95},
  [1063] = {.lex_state = 165, .external_lex_state = 2},
  [1064] = {.lex_state = 87},
  [1065] = {.lex_state = 165, .external_lex_state = 2},
  [1066] = {.lex_state = 87},
  [1067] = {.lex_state = 165, .external_lex_state = 2},
  [1068] = {.lex_state = 165, .external_lex_state = 2},
  [1069] = {.lex_state = 95},
  [1070] = {.lex_state = 87},
  [1071] = {.lex_state = 175},
  [1072] = {.lex_state = 175},
  [1073] = {.lex_state = 87},
  [1074] = {.lex_state = 87},
  [1075] = {.lex_state = 87},
  [1076] = {.lex_state = 87},
  [1077] = {.lex_state = 175},
  [1078] = {.lex_state = 177},
  [1079] = {.lex_state = 177},
  [1080] = {.lex_state = 87},
  [1081] = {.lex_state = 87},
  [1082] = {.lex_state = 87},
  [1083] = {.lex_state = 87},
  [1084] = {.lex_state = 87},
  [1085] = {.lex_state = 87},
  [1086] = {.lex_state = 87},
  [1087] = {.lex_state = 87},
  [1088] = {.lex_state = 95},
  [1089] = {.lex_state = 193},
  [1090] = {.lex_state = 95},
  [1091] = {.lex_state = 193},
  [1092] = {.lex_state = 95},
  [1093] = {.lex_state = 95},
  [1094] = {.lex_state = 131},
  [1095] = {.lex_state = 112},
  [1096] = {.lex_state = 193},
  [1097] = {.lex_state = 164},
  [1098] = {.lex_state = 87},
  [1099] = {.lex_state = 87},
  [1100] = {.lex_state = 87},
  [1101] = {.lex_state = 87},
  [1102] = {.lex_state = 87},
  [1103] = {.lex_state = 87},
  [1104] = {.lex_state = 87},
  [1105] = {.lex_state = 169, .external_lex_state = 2},
  [1106] = {.lex_state = 169, .external_lex_state = 2},
  [1107] = {.lex_state = 169, .external_lex_state = 2},
  [1108] = {.lex_state = 87},
  [1109] = {.lex_state = 87},
  [1110] = {.lex_state = 98},
  [1111] = {.lex_state = 87},
  [1112] = {.lex_state = 87},
  [1113] = {.lex_state = 87},
  [1114] = {.lex_state = 87},
  [1115] = {.lex_state = 87},
  [1116] = {.lex_state = 87},
  [1117] = {.lex_state = 87},
  [1118] = {.lex_state = 87},
  [1119] = {.lex_state = 87},
  [1120] = {.lex_state = 164},
  [1121] = {.lex_state = 164},
  [1122] = {.lex_state = 87},
  [1123] = {.lex_state = 164},
  [1124] = {.lex_state = 164},
  [1125] = {.lex_state = 168},
  [1126] = {.lex_state = 164},
  [1127] = {.lex_state = 164},
  [1128] = {.lex_state = 164},
  [1129] = {.lex_state = 164, .external_lex_state = 2},
  [1130] = {.lex_state = 164, .external_lex_state = 2},
  [1131] = {.lex_state = 87},
  [1132] = {.lex_state = 87},
  [1133] = {.lex_state = 87},
  [1134] = {.lex_state = 164, .external_lex_state = 2},
  [1135] = {.lex_state = 195, .external_lex_state = 2},
  [1136] = {.lex_state = 195, .external_lex_state = 2},
  [1137] = {.lex_state = 87},
  [1138] = {.lex_state = 87},
  [1139] = {.lex_state = 87},
  [1140] = {.lex_state = 87},
  [1141] = {.lex_state = 87},
  [1142] = {.lex_state = 87},
  [1143] = {.lex_state = 87},
  [1144] = {.lex_state = 176, .external_lex_state = 2},
  [1145] = {.lex_state = 87},
  [1146] = {.lex_state = 95},
  [1147] = {.lex_state = 95},
  [1148] = {.lex_state = 95},
  [1149] = {.lex_state = 169, .external_lex_state = 2},
  [1150] = {.lex_state = 169, .external_lex_state = 2},
  [1151] = {.lex_state = 95},
  [1152] = {.lex_state = 169, .external_lex_state = 2},
  [1153] = {.lex_state = 94},
  [1154] = {.lex_state = 87},
  [1155] = {.lex_state = 87},
  [1156] = {.lex_state = 127, .external_lex_state = 2},
  [1157] = {.lex_state = 87},
  [1158] = {.lex_state = 155, .external_lex_state = 2},
  [1159] = {.lex_state = 155, .external_lex_state = 2},
  [1160] = {.lex_state = 87},
  [1161] = {.lex_state = 165},
  [1162] = {.lex_state = 95},
  [1163] = {.lex_state = 87},
  [1164] = {.lex_state = 168},
  [1165] = {.lex_state = 153},
  [1166] = {.lex_state = 87},
  [1167] = {.lex_state = 131},
  [1168] = {.lex_state = 87},
  [1169] = {.lex_state = 87},
  [1170] = {.lex_state = 153},
  [1171] = {.lex_state = 153},
  [1172] = {.lex_state = 168},
  [1173] = {.lex_state = 194},
  [1174] = {.lex_state = 194},
  [1175] = {.lex_state = 153},
  [1176] = {.lex_state = 113},
  [1177] = {.lex_state = 87},
  [1178] = {.lex_state = 165},
  [1179] = {.lex_state = 95},
  [1180] = {.lex_state = 87},
  [1181] = {.lex_state = 87},
  [1182] = {.lex_state = 87},
  [1183] = {.lex_state = 87},
  [1184] = {.lex_state = 87},
  [1185] = {.lex_state = 87},
  [1186] = {.lex_state = 87},
  [1187] = {.lex_state = 198, .external_lex_state = 2},
  [1188] = {.lex_state = 172, .external_lex_state = 2},
  [1189] = {.lex_state = 87},
  [1190] = {.lex_state = 131},
  [1191] = {.lex_state = 87},
  [1192] = {.lex_state = 87},
  [1193] = {.lex_state = 172, .external_lex_state = 2},
  [1194] = {.lex_state = 172, .external_lex_state = 2},
  [1195] = {.lex_state = 198, .external_lex_state = 2},
  [1196] = {.lex_state = 171, .external_lex_state = 2},
  [1197] = {.lex_state = 171, .external_lex_state = 2},
  [1198] = {.lex_state = 172, .external_lex_state = 2},
  [1199] = {.lex_state = 98},
  [1200] = {.lex_state = 87},
  [1201] = {.lex_state = 87},
  [1202] = {.lex_state = 171},
  [1203] = {.lex_state = 172},
  [1204] = {.lex_state = 87},
  [1205] = {.lex_state = 131},
  [1206] = {.lex_state = 87},
  [1207] = {.lex_state = 87},
  [1208] = {.lex_state = 172},
  [1209] = {.lex_state = 172},
  [1210] = {.lex_state = 171},
  [1211] = {.lex_state = 171},
  [1212] = {.lex_state = 171},
  [1213] = {.lex_state = 172},
  [1214] = {.lex_state = 87},
  [1215] = {.lex_state = 87},
  [1216] = {.lex_state = 171},
  [1217] = {.lex_state = 98},
  [1218] = {.lex_state = 198, .external_lex_state = 2},
  [1219] = {.lex_state = 98},
  [1220] = {.lex_state = 171},
  [1221] = {.lex_state = 198, .external_lex_state = 2},
  [1222] = {.lex_state = 98},
  [1223] = {.lex_state = 171},
  [1224] = {.lex_state = 87},
  [1225] = {.lex_state = 87},
  [1226] = {.lex_state = 87},
  [1227] = {.lex_state = 173},
  [1228] = {.lex_state = 173},
  [1229] = {.lex_state = 95},
  [1230] = {.lex_state = 173},
  [1231] = {.lex_state = 113},
  [1232] = {.lex_state = 113},
  [1233] = {.lex_state = 173},
  [1234] = {.lex_state = 113},
  [1235] = {.lex_state = 173},
  [1236] = {.lex_state = 173},
  [1237] = {.lex_state = 173},
  [1238] = {.lex_state = 87},
  [1239] = {.lex_state = 173},
  [1240] = {.lex_state = 173},
  [1241] = {.lex_state = 171},
  [1242] = {.lex_state = 87},
  [1243] = {.lex_state = 173},
  [1244] = {.lex_state = 173},
  [1245] = {.lex_state = 173},
  [1246] = {.lex_state = 173},
  [1247] = {.lex_state = 173},
  [1248] = {.lex_state = 98},
  [1249] = {.lex_state = 186},
  [1250] = {.lex_state = 87},
  [1251] = {.lex_state = 113},
  [1252] = {.lex_state = 113},
  [1253] = {.lex_state = 113},
  [1254] = {.lex_state = 113},
  [1255] = {.lex_state = 87},
  [1256] = {.lex_state = 173},
  [1257] = {.lex_state = 87},
  [1258] = {.lex_state = 87},
  [1259] = {.lex_state = 87},
  [1260] = {.lex_state = 87},
  [1261] = {.lex_state = 87},
  [1262] = {.lex_state = 87},
  [1263] = {.lex_state = 87},
  [1264] = {.lex_state = 169, .external_lex_state = 2},
  [1265] = {.lex_state = 169, .external_lex_state = 2},
  [1266] = {.lex_state = 169, .external_lex_state = 2},
  [1267] = {.lex_state = 87},
  [1268] = {.lex_state = 87},
  [1269] = {.lex_state = 98},
  [1270] = {.lex_state = 87},
  [1271] = {.lex_state = 87},
  [1272] = {.lex_state = 87},
  [1273] = {.lex_state = 87},
  [1274] = {.lex_state = 87},
  [1275] = {.lex_state = 87},
  [1276] = {.lex_state = 87},
  [1277] = {.lex_state = 87},
  [1278] = {.lex_state = 165},
  [1279] = {.lex_state = 98},
  [1280] = {.lex_state = 175},
  [1281] = {.lex_state = 87},
  [1282] = {.lex_state = 174, .external_lex_state = 2},
  [1283] = {.lex_state = 113},
  [1284] = {.lex_state = 113},
  [1285] = {.lex_state = 113},
  [1286] = {.lex_state = 133},
  [1287] = {.lex_state = 141},
  [1288] = {.lex_state = 113},
  [1289] = {.lex_state = 157},
  [1290] = {.lex_state = 113},
  [1291] = {.lex_state = 174, .external_lex_state = 2},
  [1292] = {.lex_state = 192, .external_lex_state = 2},
  [1293] = {.lex_state = 192, .external_lex_state = 2},
  [1294] = {.lex_state = 95},
  [1295] = {.lex_state = 94, .external_lex_state = 2},
  [1296] = {.lex_state = 95},
  [1297] = {.lex_state = 100},
  [1298] = {.lex_state = 100},
  [1299] = {.lex_state = 100},
  [1300] = {.lex_state = 87},
  [1301] = {.lex_state = 100},
  [1302] = {.lex_state = 100},
  [1303] = {.lex_state = 168},
  [1304] = {.lex_state = 100},
  [1305] = {.lex_state = 100},
  [1306] = {.lex_state = 100},
  [1307] = {.lex_state = 174, .external_lex_state = 2},
  [1308] = {.lex_state = 174, .external_lex_state = 2},
  [1309] = {.lex_state = 87},
  [1310] = {.lex_state = 172},
  [1311] = {.lex_state = 87},
  [1312] = {.lex_state = 164},
  [1313] = {.lex_state = 174, .external_lex_state = 2},
  [1314] = {.lex_state = 175},
  [1315] = {.lex_state = 168},
  [1316] = {.lex_state = 168},
  [1317] = {.lex_state = 168},
  [1318] = {.lex_state = 87},
  [1319] = {.lex_state = 168},
  [1320] = {.lex_state = 168},
  [1321] = {.lex_state = 100, .external_lex_state = 2},
  [1322] = {.lex_state = 168},
  [1323] = {.lex_state = 168},
  [1324] = {.lex_state = 168},
  [1325] = {.lex_state = 168},
  [1326] = {.lex_state = 164},
  [1327] = {.lex_state = 164},
  [1328] = {.lex_state = 87},
  [1329] = {.lex_state = 87},
  [1330] = {.lex_state = 87},
  [1331] = {.lex_state = 87},
  [1332] = {.lex_state = 164},
  [1333] = {.lex_state = 167},
  [1334] = {.lex_state = 167},
  [1335] = {.lex_state = 87},
  [1336] = {.lex_state = 87},
  [1337] = {.lex_state = 87},
  [1338] = {.lex_state = 87},
  [1339] = {.lex_state = 87},
  [1340] = {.lex_state = 87},
  [1341] = {.lex_state = 87},
  [1342] = {.lex_state = 174, .external_lex_state = 2},
  [1343] = {.lex_state = 157},
  [1344] = {.lex_state = 113},
  [1345] = {.lex_state = 113},
  [1346] = {.lex_state = 113},
  [1347] = {.lex_state = 113},
  [1348] = {.lex_state = 113},
  [1349] = {.lex_state = 165},
  [1350] = {.lex_state = 174, .external_lex_state = 2},
  [1351] = {.lex_state = 182, .external_lex_state = 2},
  [1352] = {.lex_state = 87},
  [1353] = {.lex_state = 94, .external_lex_state = 2},
  [1354] = {.lex_state = 87},
  [1355] = {.lex_state = 165, .external_lex_state = 2},
  [1356] = {.lex_state = 165, .external_lex_state = 2},
  [1357] = {.lex_state = 165, .external_lex_state = 2},
  [1358] = {.lex_state = 165, .external_lex_state = 2},
  [1359] = {.lex_state = 165, .external_lex_state = 2},
  [1360] = {.lex_state = 175},
  [1361] = {.lex_state = 175},
  [1362] = {.lex_state = 175},
  [1363] = {.lex_state = 87},
  [1364] = {.lex_state = 175},
  [1365] = {.lex_state = 175},
  [1366] = {.lex_state = 168},
  [1367] = {.lex_state = 175},
  [1368] = {.lex_state = 175},
  [1369] = {.lex_state = 175},
  [1370] = {.lex_state = 193},
  [1371] = {.lex_state = 193},
  [1372] = {.lex_state = 95},
  [1373] = {.lex_state = 193},
  [1374] = {.lex_state = 95},
  [1375] = {.lex_state = 87},
  [1376] = {.lex_state = 87},
  [1377] = {.lex_state = 127, .external_lex_state = 2},
  [1378] = {.lex_state = 87},
  [1379] = {.lex_state = 155, .external_lex_state = 2},
  [1380] = {.lex_state = 155, .external_lex_state = 2},
  [1381] = {.lex_state = 87},
  [1382] = {.lex_state = 87},
  [1383] = {.lex_state = 87},
  [1384] = {.lex_state = 87},
  [1385] = {.lex_state = 87},
  [1386] = {.lex_state = 87},
  [1387] = {.lex_state = 87},
  [1388] = {.lex_state = 198, .external_lex_state = 2},
  [1389] = {.lex_state = 98},
  [1390] = {.lex_state = 171},
  [1391] = {.lex_state = 87},
  [1392] = {.lex_state = 171},
  [1393] = {.lex_state = 98},
  [1394] = {.lex_state = 198, .external_lex_state = 2},
  [1395] = {.lex_state = 98},
  [1396] = {.lex_state = 171},
  [1397] = {.lex_state = 198, .external_lex_state = 2},
  [1398] = {.lex_state = 98},
  [1399] = {.lex_state = 171},
  [1400] = {.lex_state = 87},
  [1401] = {.lex_state = 87},
  [1402] = {.lex_state = 87},
  [1403] = {.lex_state = 95},
  [1404] = {.lex_state = 164},
  [1405] = {.lex_state = 87},
  [1406] = {.lex_state = 164, .external_lex_state = 2},
  [1407] = {.lex_state = 164, .external_lex_state = 2},
  [1408] = {.lex_state = 87},
  [1409] = {.lex_state = 164, .external_lex_state = 2},
  [1410] = {.lex_state = 164, .external_lex_state = 2},
  [1411] = {.lex_state = 168},
  [1412] = {.lex_state = 164, .external_lex_state = 2},
  [1413] = {.lex_state = 164, .external_lex_state = 2},
  [1414] = {.lex_state = 164, .external_lex_state = 2},
  [1415] = {.lex_state = 87},
  [1416] = {.lex_state = 87},
  [1417] = {.lex_state = 169, .external_lex_state = 2},
  [1418] = {.lex_state = 87},
  [1419] = {.lex_state = 169, .external_lex_state = 2},
  [1420] = {.lex_state = 169, .external_lex_state = 2},
  [1421] = {.lex_state = 169, .external_lex_state = 2},
  [1422] = {.lex_state = 87},
  [1423] = {.lex_state = 87},
  [1424] = {.lex_state = 98},
  [1425] = {.lex_state = 87},
  [1426] = {.lex_state = 87},
  [1427] = {.lex_state = 87},
  [1428] = {.lex_state = 87},
  [1429] = {.lex_state = 87},
  [1430] = {.lex_state = 87},
  [1431] = {.lex_state = 87},
  [1432] = {.lex_state = 87},
  [1433] = {.lex_state = 87},
  [1434] = {.lex_state = 87},
  [1435] = {.lex_state = 87},
  [1436] = {.lex_state = 87},
  [1437] = {.lex_state = 153, .external_lex_state = 2},
  [1438] = {.lex_state = 95},
  [1439] = {.lex_state = 168},
  [1440] = {.lex_state = 168},
  [1441] = {.lex_state = 87},
  [1442] = {.lex_state = 87},
  [1443] = {.lex_state = 87},
  [1444] = {.lex_state = 87},
  [1445] = {.lex_state = 168},
  [1446] = {.lex_state = 153},
  [1447] = {.lex_state = 153},
  [1448] = {.lex_state = 87},
  [1449] = {.lex_state = 87},
  [1450] = {.lex_state = 87},
  [1451] = {.lex_state = 87},
  [1452] = {.lex_state = 95},
  [1453] = {.lex_state = 87},
  [1454] = {.lex_state = 87},
  [1455] = {.lex_state = 87},
  [1456] = {.lex_state = 87},
  [1457] = {.lex_state = 171},
  [1458] = {.lex_state = 98},
  [1459] = {.lex_state = 171},
  [1460] = {.lex_state = 171},
  [1461] = {.lex_state = 98},
  [1462] = {.lex_state = 171},
  [1463] = {.lex_state = 171},
  [1464] = {.lex_state = 98},
  [1465] = {.lex_state = 171},
  [1466] = {.lex_state = 198, .external_lex_state = 2},
  [1467] = {.lex_state = 198, .external_lex_state = 2},
  [1468] = {.lex_state = 87},
  [1469] = {.lex_state = 87},
  [1470] = {.lex_state = 87},
  [1471] = {.lex_state = 87},
  [1472] = {.lex_state = 198, .external_lex_state = 2},
  [1473] = {.lex_state = 172, .external_lex_state = 2},
  [1474] = {.lex_state = 172, .external_lex_state = 2},
  [1475] = {.lex_state = 87},
  [1476] = {.lex_state = 87},
  [1477] = {.lex_state = 87},
  [1478] = {.lex_state = 87},
  [1479] = {.lex_state = 87},
  [1480] = {.lex_state = 87},
  [1481] = {.lex_state = 87},
  [1482] = {.lex_state = 87},
  [1483] = {.lex_state = 171},
  [1484] = {.lex_state = 171},
  [1485] = {.lex_state = 87},
  [1486] = {.lex_state = 87},
  [1487] = {.lex_state = 87},
  [1488] = {.lex_state = 87},
  [1489] = {.lex_state = 171},
  [1490] = {.lex_state = 172},
  [1491] = {.lex_state = 172},
  [1492] = {.lex_state = 87},
  [1493] = {.lex_state = 87},
  [1494] = {.lex_state = 87},
  [1495] = {.lex_state = 87},
  [1496] = {.lex_state = 87},
  [1497] = {.lex_state = 87},
  [1498] = {.lex_state = 87},
  [1499] = {.lex_state = 87},
  [1500] = {.lex_state = 165},
  [1501] = {.lex_state = 87},
  [1502] = {.lex_state = 87},
  [1503] = {.lex_state = 87},
  [1504] = {.lex_state = 87},
  [1505] = {.lex_state = 87},
  [1506] = {.lex_state = 87},
  [1507] = {.lex_state = 87},
  [1508] = {.lex_state = 87},
  [1509] = {.lex_state = 173},
  [1510] = {.lex_state = 173},
  [1511] = {.lex_state = 113},
  [1512] = {.lex_state = 173},
  [1513] = {.lex_state = 173},
  [1514] = {.lex_state = 173},
  [1515] = {.lex_state = 173},
  [1516] = {.lex_state = 171},
  [1517] = {.lex_state = 173},
  [1518] = {.lex_state = 173},
  [1519] = {.lex_state = 87},
  [1520] = {.lex_state = 87},
  [1521] = {.lex_state = 87},
  [1522] = {.lex_state = 127, .external_lex_state = 2},
  [1523] = {.lex_state = 87},
  [1524] = {.lex_state = 155, .external_lex_state = 2},
  [1525] = {.lex_state = 155, .external_lex_state = 2},
  [1526] = {.lex_state = 87},
  [1527] = {.lex_state = 87},
  [1528] = {.lex_state = 87},
  [1529] = {.lex_state = 87},
  [1530] = {.lex_state = 87},
  [1531] = {.lex_state = 87},
  [1532] = {.lex_state = 87},
  [1533] = {.lex_state = 198, .external_lex_state = 2},
  [1534] = {.lex_state = 98},
  [1535] = {.lex_state = 171},
  [1536] = {.lex_state = 87},
  [1537] = {.lex_state = 171},
  [1538] = {.lex_state = 98},
  [1539] = {.lex_state = 198, .external_lex_state = 2},
  [1540] = {.lex_state = 98},
  [1541] = {.lex_state = 171},
  [1542] = {.lex_state = 198, .external_lex_state = 2},
  [1543] = {.lex_state = 98},
  [1544] = {.lex_state = 171},
  [1545] = {.lex_state = 87},
  [1546] = {.lex_state = 87},
  [1547] = {.lex_state = 87},
  [1548] = {.lex_state = 87},
  [1549] = {.lex_state = 175},
  [1550] = {.lex_state = 174, .external_lex_state = 2},
  [1551] = {.lex_state = 157},
  [1552] = {.lex_state = 113},
  [1553] = {.lex_state = 113},
  [1554] = {.lex_state = 113},
  [1555] = {.lex_state = 113},
  [1556] = {.lex_state = 113},
  [1557] = {.lex_state = 133},
  [1558] = {.lex_state = 141},
  [1559] = {.lex_state = 113},
  [1560] = {.lex_state = 113},
  [1561] = {.lex_state = 157},
  [1562] = {.lex_state = 95},
  [1563] = {.lex_state = 100},
  [1564] = {.lex_state = 87},
  [1565] = {.lex_state = 168},
  [1566] = {.lex_state = 87},
  [1567] = {.lex_state = 164},
  [1568] = {.lex_state = 164},
  [1569] = {.lex_state = 164},
  [1570] = {.lex_state = 87},
  [1571] = {.lex_state = 164},
  [1572] = {.lex_state = 164},
  [1573] = {.lex_state = 168},
  [1574] = {.lex_state = 164},
  [1575] = {.lex_state = 164},
  [1576] = {.lex_state = 164},
  [1577] = {.lex_state = 157},
  [1578] = {.lex_state = 157},
  [1579] = {.lex_state = 182, .external_lex_state = 2},
  [1580] = {.lex_state = 175},
  [1581] = {.lex_state = 87},
  [1582] = {.lex_state = 193},
  [1583] = {.lex_state = 87},
  [1584] = {.lex_state = 169, .external_lex_state = 2},
  [1585] = {.lex_state = 169, .external_lex_state = 2},
  [1586] = {.lex_state = 169, .external_lex_state = 2},
  [1587] = {.lex_state = 87},
  [1588] = {.lex_state = 87},
  [1589] = {.lex_state = 98},
  [1590] = {.lex_state = 87},
  [1591] = {.lex_state = 87},
  [1592] = {.lex_state = 87},
  [1593] = {.lex_state = 87},
  [1594] = {.lex_state = 87},
  [1595] = {.lex_state = 87},
  [1596] = {.lex_state = 87},
  [1597] = {.lex_state = 87},
  [1598] = {.lex_state = 171},
  [1599] = {.lex_state = 98},
  [1600] = {.lex_state = 171},
  [1601] = {.lex_state = 171},
  [1602] = {.lex_state = 98},
  [1603] = {.lex_state = 171},
  [1604] = {.lex_state = 171},
  [1605] = {.lex_state = 98},
  [1606] = {.lex_state = 171},
  [1607] = {.lex_state = 87},
  [1608] = {.lex_state = 87},
  [1609] = {.lex_state = 87},
  [1610] = {.lex_state = 87},
  [1611] = {.lex_state = 87},
  [1612] = {.lex_state = 87},
  [1613] = {.lex_state = 87},
  [1614] = {.lex_state = 87},
  [1615] = {.lex_state = 87},
  [1616] = {.lex_state = 87},
  [1617] = {.lex_state = 164},
  [1618] = {.lex_state = 164, .external_lex_state = 2},
  [1619] = {.lex_state = 87},
  [1620] = {.lex_state = 87},
  [1621] = {.lex_state = 87},
  [1622] = {.lex_state = 87},
  [1623] = {.lex_state = 87},
  [1624] = {.lex_state = 87},
  [1625] = {.lex_state = 87},
  [1626] = {.lex_state = 198, .external_lex_state = 2},
  [1627] = {.lex_state = 98},
  [1628] = {.lex_state = 171},
  [1629] = {.lex_state = 87},
  [1630] = {.lex_state = 171},
  [1631] = {.lex_state = 98},
  [1632] = {.lex_state = 198, .external_lex_state = 2},
  [1633] = {.lex_state = 98},
  [1634] = {.lex_state = 171},
  [1635] = {.lex_state = 198, .external_lex_state = 2},
  [1636] = {.lex_state = 98},
  [1637] = {.lex_state = 171},
  [1638] = {.lex_state = 87},
  [1639] = {.lex_state = 87},
  [1640] = {.lex_state = 87},
  [1641] = {.lex_state = 87},
  [1642] = {.lex_state = 87},
  [1643] = {.lex_state = 87},
  [1644] = {.lex_state = 87},
  [1645] = {.lex_state = 87},
  [1646] = {.lex_state = 87},
  [1647] = {.lex_state = 95},
  [1648] = {.lex_state = 168},
  [1649] = {.lex_state = 168},
  [1650] = {.lex_state = 168},
  [1651] = {.lex_state = 87},
  [1652] = {.lex_state = 168},
  [1653] = {.lex_state = 168},
  [1654] = {.lex_state = 168},
  [1655] = {.lex_state = 95},
  [1656] = {.lex_state = 168},
  [1657] = {.lex_state = 168},
  [1658] = {.lex_state = 168},
  [1659] = {.lex_state = 168},
  [1660] = {.lex_state = 87},
  [1661] = {.lex_state = 87},
  [1662] = {.lex_state = 87},
  [1663] = {.lex_state = 87},
  [1664] = {.lex_state = 87},
  [1665] = {.lex_state = 87},
  [1666] = {.lex_state = 198, .external_lex_state = 2},
  [1667] = {.lex_state = 198, .external_lex_state = 2},
  [1668] = {.lex_state = 198, .external_lex_state = 2},
  [1669] = {.lex_state = 87},
  [1670] = {.lex_state = 198, .external_lex_state = 2},
  [1671] = {.lex_state = 198, .external_lex_state = 2},
  [1672] = {.lex_state = 165},
  [1673] = {.lex_state = 168},
  [1674] = {.lex_state = 198, .external_lex_state = 2},
  [1675] = {.lex_state = 198, .external_lex_state = 2},
  [1676] = {.lex_state = 198, .external_lex_state = 2},
  [1677] = {.lex_state = 171},
  [1678] = {.lex_state = 171},
  [1679] = {.lex_state = 171},
  [1680] = {.lex_state = 87},
  [1681] = {.lex_state = 171},
  [1682] = {.lex_state = 171},
  [1683] = {.lex_state = 165},
  [1684] = {.lex_state = 168},
  [1685] = {.lex_state = 171},
  [1686] = {.lex_state = 171},
  [1687] = {.lex_state = 171},
  [1688] = {.lex_state = 165},
  [1689] = {.lex_state = 165},
  [1690] = {.lex_state = 165},
  [1691] = {.lex_state = 165},
  [1692] = {.lex_state = 165},
  [1693] = {.lex_state = 171},
  [1694] = {.lex_state = 171},
  [1695] = {.lex_state = 171},
  [1696] = {.lex_state = 173},
  [1697] = {.lex_state = 87},
  [1698] = {.lex_state = 169, .external_lex_state = 2},
  [1699] = {.lex_state = 169, .external_lex_state = 2},
  [1700] = {.lex_state = 169, .external_lex_state = 2},
  [1701] = {.lex_state = 87},
  [1702] = {.lex_state = 87},
  [1703] = {.lex_state = 98},
  [1704] = {.lex_state = 87},
  [1705] = {.lex_state = 87},
  [1706] = {.lex_state = 87},
  [1707] = {.lex_state = 87},
  [1708] = {.lex_state = 87},
  [1709] = {.lex_state = 87},
  [1710] = {.lex_state = 87},
  [1711] = {.lex_state = 87},
  [1712] = {.lex_state = 171},
  [1713] = {.lex_state = 98},
  [1714] = {.lex_state = 171},
  [1715] = {.lex_state = 171},
  [1716] = {.lex_state = 98},
  [1717] = {.lex_state = 171},
  [1718] = {.lex_state = 171},
  [1719] = {.lex_state = 98},
  [1720] = {.lex_state = 171},
  [1721] = {.lex_state = 87},
  [1722] = {.lex_state = 87},
  [1723] = {.lex_state = 87},
  [1724] = {.lex_state = 87},
  [1725] = {.lex_state = 87},
  [1726] = {.lex_state = 87},
  [1727] = {.lex_state = 87},
  [1728] = {.lex_state = 87},
  [1729] = {.lex_state = 87},
  [1730] = {.lex_state = 87},
  [1731] = {.lex_state = 165},
  [1732] = {.lex_state = 113},
  [1733] = {.lex_state = 157},
  [1734] = {.lex_state = 113},
  [1735] = {.lex_state = 113},
  [1736] = {.lex_state = 113},
  [1737] = {.lex_state = 113},
  [1738] = {.lex_state = 113},
  [1739] = {.lex_state = 100},
  [1740] = {.lex_state = 168},
  [1741] = {.lex_state = 164},
  [1742] = {.lex_state = 87},
  [1743] = {.lex_state = 175},
  [1744] = {.lex_state = 87},
  [1745] = {.lex_state = 87},
  [1746] = {.lex_state = 87},
  [1747] = {.lex_state = 87},
  [1748] = {.lex_state = 87},
  [1749] = {.lex_state = 87},
  [1750] = {.lex_state = 198, .external_lex_state = 2},
  [1751] = {.lex_state = 98},
  [1752] = {.lex_state = 171},
  [1753] = {.lex_state = 87},
  [1754] = {.lex_state = 171},
  [1755] = {.lex_state = 98},
  [1756] = {.lex_state = 198, .external_lex_state = 2},
  [1757] = {.lex_state = 98},
  [1758] = {.lex_state = 171},
  [1759] = {.lex_state = 198, .external_lex_state = 2},
  [1760] = {.lex_state = 98},
  [1761] = {.lex_state = 171},
  [1762] = {.lex_state = 87},
  [1763] = {.lex_state = 87},
  [1764] = {.lex_state = 87},
  [1765] = {.lex_state = 87},
  [1766] = {.lex_state = 87},
  [1767] = {.lex_state = 87},
  [1768] = {.lex_state = 87},
  [1769] = {.lex_state = 87},
  [1770] = {.lex_state = 87},
  [1771] = {.lex_state = 171},
  [1772] = {.lex_state = 171},
  [1773] = {.lex_state = 171},
  [1774] = {.lex_state = 164, .external_lex_state = 2},
  [1775] = {.lex_state = 171},
  [1776] = {.lex_state = 98},
  [1777] = {.lex_state = 171},
  [1778] = {.lex_state = 171},
  [1779] = {.lex_state = 98},
  [1780] = {.lex_state = 171},
  [1781] = {.lex_state = 171},
  [1782] = {.lex_state = 98},
  [1783] = {.lex_state = 171},
  [1784] = {.lex_state = 87},
  [1785] = {.lex_state = 87},
  [1786] = {.lex_state = 87},
  [1787] = {.lex_state = 87},
  [1788] = {.lex_state = 87},
  [1789] = {.lex_state = 87},
  [1790] = {.lex_state = 87},
  [1791] = {.lex_state = 87},
  [1792] = {.lex_state = 87},
  [1793] = {.lex_state = 87},
  [1794] = {.lex_state = 87},
  [1795] = {.lex_state = 87},
  [1796] = {.lex_state = 87},
  [1797] = {.lex_state = 87},
  [1798] = {.lex_state = 153, .external_lex_state = 2},
  [1799] = {.lex_state = 95},
  [1800] = {.lex_state = 87},
  [1801] = {.lex_state = 87},
  [1802] = {.lex_state = 127, .external_lex_state = 2},
  [1803] = {.lex_state = 87},
  [1804] = {.lex_state = 155, .external_lex_state = 2},
  [1805] = {.lex_state = 155, .external_lex_state = 2},
  [1806] = {.lex_state = 87},
  [1807] = {.lex_state = 168},
  [1808] = {.lex_state = 87},
  [1809] = {.lex_state = 165},
  [1810] = {.lex_state = 165},
  [1811] = {.lex_state = 165},
  [1812] = {.lex_state = 165},
  [1813] = {.lex_state = 165},
  [1814] = {.lex_state = 165},
  [1815] = {.lex_state = 198, .external_lex_state = 2},
  [1816] = {.lex_state = 87},
  [1817] = {.lex_state = 171},
  [1818] = {.lex_state = 87},
  [1819] = {.lex_state = 87},
  [1820] = {.lex_state = 87},
  [1821] = {.lex_state = 87},
  [1822] = {.lex_state = 87},
  [1823] = {.lex_state = 87},
  [1824] = {.lex_state = 87},
  [1825] = {.lex_state = 87},
  [1826] = {.lex_state = 87},
  [1827] = {.lex_state = 87},
  [1828] = {.lex_state = 198, .external_lex_state = 2},
  [1829] = {.lex_state = 98},
  [1830] = {.lex_state = 171},
  [1831] = {.lex_state = 87},
  [1832] = {.lex_state = 171},
  [1833] = {.lex_state = 98},
  [1834] = {.lex_state = 198, .external_lex_state = 2},
  [1835] = {.lex_state = 98},
  [1836] = {.lex_state = 171},
  [1837] = {.lex_state = 198, .external_lex_state = 2},
  [1838] = {.lex_state = 98},
  [1839] = {.lex_state = 171},
  [1840] = {.lex_state = 87},
  [1841] = {.lex_state = 87},
  [1842] = {.lex_state = 87},
  [1843] = {.lex_state = 87},
  [1844] = {.lex_state = 87},
  [1845] = {.lex_state = 87},
  [1846] = {.lex_state = 87},
  [1847] = {.lex_state = 87},
  [1848] = {.lex_state = 87},
  [1849] = {.lex_state = 171},
  [1850] = {.lex_state = 171},
  [1851] = {.lex_state = 171},
  [1852] = {.lex_state = 113},
  [1853] = {.lex_state = 113},
  [1854] = {.lex_state = 113},
  [1855] = {.lex_state = 113},
  [1856] = {.lex_state = 113},
  [1857] = {.lex_state = 113},
  [1858] = {.lex_state = 113},
  [1859] = {.lex_state = 113},
  [1860] = {.lex_state = 164},
  [1861] = {.lex_state = 171},
  [1862] = {.lex_state = 98},
  [1863] = {.lex_state = 171},
  [1864] = {.lex_state = 171},
  [1865] = {.lex_state = 98},
  [1866] = {.lex_state = 171},
  [1867] = {.lex_state = 171},
  [1868] = {.lex_state = 98},
  [1869] = {.lex_state = 171},
  [1870] = {.lex_state = 87},
  [1871] = {.lex_state = 87},
  [1872] = {.lex_state = 87},
  [1873] = {.lex_state = 87},
  [1874] = {.lex_state = 87},
  [1875] = {.lex_state = 87},
  [1876] = {.lex_state = 87},
  [1877] = {.lex_state = 87},
  [1878] = {.lex_state = 87},
  [1879] = {.lex_state = 87},
  [1880] = {.lex_state = 87},
  [1881] = {.lex_state = 87},
  [1882] = {.lex_state = 87},
  [1883] = {.lex_state = 87},
  [1884] = {.lex_state = 87},
  [1885] = {.lex_state = 87},
  [1886] = {.lex_state = 87},
  [1887] = {.lex_state = 87},
  [1888] = {.lex_state = 87},
  [1889] = {.lex_state = 171},
  [1890] = {.lex_state = 171},
  [1891] = {.lex_state = 171},
  [1892] = {.lex_state = 87},
  [1893] = {.lex_state = 87},
  [1894] = {.lex_state = 87},
  [1895] = {.lex_state = 87},
  [1896] = {.lex_state = 87},
  [1897] = {.lex_state = 87},
  [1898] = {.lex_state = 87},
  [1899] = {.lex_state = 169, .external_lex_state = 2},
  [1900] = {.lex_state = 169, .external_lex_state = 2},
  [1901] = {.lex_state = 169, .external_lex_state = 2},
  [1902] = {.lex_state = 87},
  [1903] = {.lex_state = 87},
  [1904] = {.lex_state = 98},
  [1905] = {.lex_state = 87},
  [1906] = {.lex_state = 87},
  [1907] = {.lex_state = 87},
  [1908] = {.lex_state = 87},
  [1909] = {.lex_state = 87},
  [1910] = {.lex_state = 87},
  [1911] = {.lex_state = 87},
  [1912] = {.lex_state = 87},
  [1913] = {.lex_state = 168},
  [1914] = {.lex_state = 198, .external_lex_state = 2},
  [1915] = {.lex_state = 171},
  [1916] = {.lex_state = 165},
  [1917] = {.lex_state = 165},
  [1918] = {.lex_state = 165},
  [1919] = {.lex_state = 171},
  [1920] = {.lex_state = 98},
  [1921] = {.lex_state = 171},
  [1922] = {.lex_state = 171},
  [1923] = {.lex_state = 98},
  [1924] = {.lex_state = 171},
  [1925] = {.lex_state = 171},
  [1926] = {.lex_state = 98},
  [1927] = {.lex_state = 171},
  [1928] = {.lex_state = 87},
  [1929] = {.lex_state = 87},
  [1930] = {.lex_state = 87},
  [1931] = {.lex_state = 87},
  [1932] = {.lex_state = 87},
  [1933] = {.lex_state = 87},
  [1934] = {.lex_state = 87},
  [1935] = {.lex_state = 87},
  [1936] = {.lex_state = 87},
  [1937] = {.lex_state = 87},
  [1938] = {.lex_state = 87},
  [1939] = {.lex_state = 87},
  [1940] = {.lex_state = 87},
  [1941] = {.lex_state = 113},
  [1942] = {.lex_state = 113},
  [1943] = {.lex_state = 113},
  [1944] = {.lex_state = 113},
  [1945] = {.lex_state = 87},
  [1946] = {.lex_state = 87},
  [1947] = {.lex_state = 87},
  [1948] = {.lex_state = 87},
  [1949] = {.lex_state = 87},
  [1950] = {.lex_state = 87},
  [1951] = {.lex_state = 171},
  [1952] = {.lex_state = 171},
  [1953] = {.lex_state = 171},
  [1954] = {.lex_state = 87},
  [1955] = {.lex_state = 87},
  [1956] = {.lex_state = 87},
  [1957] = {.lex_state = 95},
  [1958] = {.lex_state = 87},
  [1959] = {.lex_state = 87},
  [1960] = {.lex_state = 127, .external_lex_state = 2},
  [1961] = {.lex_state = 87},
  [1962] = {.lex_state = 155, .external_lex_state = 2},
  [1963] = {.lex_state = 155, .external_lex_state = 2},
  [1964] = {.lex_state = 87},
  [1965] = {.lex_state = 87},
  [1966] = {.lex_state = 87},
  [1967] = {.lex_state = 87},
  [1968] = {.lex_state = 87},
  [1969] = {.lex_state = 87},
  [1970] = {.lex_state = 87},
  [1971] = {.lex_state = 198, .external_lex_state = 2},
  [1972] = {.lex_state = 98},
  [1973] = {.lex_state = 171},
  [1974] = {.lex_state = 87},
  [1975] = {.lex_state = 171},
  [1976] = {.lex_state = 98},
  [1977] = {.lex_state = 198, .external_lex_state = 2},
  [1978] = {.lex_state = 98},
  [1979] = {.lex_state = 171},
  [1980] = {.lex_state = 198, .external_lex_state = 2},
  [1981] = {.lex_state = 98},
  [1982] = {.lex_state = 171},
  [1983] = {.lex_state = 87},
  [1984] = {.lex_state = 87},
  [1985] = {.lex_state = 87},
  [1986] = {.lex_state = 87},
  [1987] = {.lex_state = 87},
  [1988] = {.lex_state = 87},
  [1989] = {.lex_state = 87},
  [1990] = {.lex_state = 87},
  [1991] = {.lex_state = 87},
  [1992] = {.lex_state = 171},
  [1993] = {.lex_state = 171},
  [1994] = {.lex_state = 171},
  [1995] = {.lex_state = 113},
  [1996] = {.lex_state = 87},
  [1997] = {.lex_state = 87},
  [1998] = {.lex_state = 87},
  [1999] = {.lex_state = 87},
  [2000] = {.lex_state = 169, .external_lex_state = 2},
  [2001] = {.lex_state = 169, .external_lex_state = 2},
  [2002] = {.lex_state = 169, .external_lex_state = 2},
  [2003] = {.lex_state = 87},
  [2004] = {.lex_state = 87},
  [2005] = {.lex_state = 98},
  [2006] = {.lex_state = 87},
  [2007] = {.lex_state = 87},
  [2008] = {.lex_state = 87},
  [2009] = {.lex_state = 87},
  [2010] = {.lex_state = 87},
  [2011] = {.lex_state = 87},
  [2012] = {.lex_state = 87},
  [2013] = {.lex_state = 87},
  [2014] = {.lex_state = 171},
  [2015] = {.lex_state = 98},
  [2016] = {.lex_state = 171},
  [2017] = {.lex_state = 171},
  [2018] = {.lex_state = 98},
  [2019] = {.lex_state = 171},
  [2020] = {.lex_state = 171},
  [2021] = {.lex_state = 98},
  [2022] = {.lex_state = 171},
  [2023] = {.lex_state = 87},
  [2024] = {.lex_state = 87},
  [2025] = {.lex_state = 87},
  [2026] = {.lex_state = 87},
  [2027] = {.lex_state = 87},
  [2028] = {.lex_state = 87},
  [2029] = {.lex_state = 87},
  [2030] = {.lex_state = 87},
  [2031] = {.lex_state = 87},
  [2032] = {.lex_state = 87},
  [2033] = {.lex_state = 87},
  [2034] = {.lex_state = 87},
  [2035] = {.lex_state = 87},
  [2036] = {.lex_state = 87},
  [2037] = {.lex_state = 87},
  [2038] = {.lex_state = 87},
  [2039] = {.lex_state = 87},
  [2040] = {.lex_state = 87},
  [2041] = {.lex_state = 87},
  [2042] = {.lex_state = 198, .external_lex_state = 2},
  [2043] = {.lex_state = 98},
  [2044] = {.lex_state = 171},
  [2045] = {.lex_state = 87},
  [2046] = {.lex_state = 171},
  [2047] = {.lex_state = 98},
  [2048] = {.lex_state = 198, .external_lex_state = 2},
  [2049] = {.lex_state = 98},
  [2050] = {.lex_state = 171},
  [2051] = {.lex_state = 198, .external_lex_state = 2},
  [2052] = {.lex_state = 98},
  [2053] = {.lex_state = 171},
  [2054] = {.lex_state = 87},
  [2055] = {.lex_state = 87},
  [2056] = {.lex_state = 87},
  [2057] = {.lex_state = 87},
  [2058] = {.lex_state = 87},
  [2059] = {.lex_state = 87},
  [2060] = {.lex_state = 87},
  [2061] = {.lex_state = 87},
  [2062] = {.lex_state = 87},
  [2063] = {.lex_state = 171},
  [2064] = {.lex_state = 171},
  [2065] = {.lex_state = 171},
  [2066] = {.lex_state = 171},
  [2067] = {.lex_state = 98},
  [2068] = {.lex_state = 171},
  [2069] = {.lex_state = 171},
  [2070] = {.lex_state = 98},
  [2071] = {.lex_state = 171},
  [2072] = {.lex_state = 171},
  [2073] = {.lex_state = 98},
  [2074] = {.lex_state = 171},
  [2075] = {.lex_state = 87},
  [2076] = {.lex_state = 87},
  [2077] = {.lex_state = 87},
  [2078] = {.lex_state = 87},
  [2079] = {.lex_state = 87},
  [2080] = {.lex_state = 87},
  [2081] = {.lex_state = 87},
  [2082] = {.lex_state = 87},
  [2083] = {.lex_state = 87},
  [2084] = {.lex_state = 87},
  [2085] = {.lex_state = 87},
  [2086] = {.lex_state = 87},
  [2087] = {.lex_state = 87},
  [2088] = {.lex_state = 87},
  [2089] = {.lex_state = 87},
  [2090] = {.lex_state = 87},
  [2091] = {.lex_state = 87},
  [2092] = {.lex_state = 87},
  [2093] = {.lex_state = 87},
  [2094] = {.lex_state = 171},
  [2095] = {.lex_state = 171},
  [2096] = {.lex_state = 171},
  [2097] = {.lex_state = 87},
  [2098] = {.lex_state = 87},
  [2099] = {.lex_state = 87},
};

enum {
  ts_external_token__automatic_semicolon,
  ts_external_token__template_chars,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__automatic_semicolon] = ACTIONS(2),
    [sym__template_chars] = ACTIONS(2),
    [ts_builtin_sym_end] = ACTIONS(2),
    [sym_hash_bang_line] = ACTIONS(2),
    [anon_sym_export] = ACTIONS(4),
    [anon_sym_STAR] = ACTIONS(4),
    [anon_sym_default] = ACTIONS(4),
    [anon_sym_LBRACE] = ACTIONS(2),
    [anon_sym_COMMA] = ACTIONS(2),
    [anon_sym_RBRACE] = ACTIONS(2),
    [anon_sym_as] = ACTIONS(4),
    [anon_sym_import] = ACTIONS(4),
    [anon_sym_from] = ACTIONS(4),
    [anon_sym_var] = ACTIONS(4),
    [anon_sym_let] = ACTIONS(4),
    [anon_sym_const] = ACTIONS(4),
    [anon_sym_if] = ACTIONS(4),
    [anon_sym_else] = ACTIONS(4),
    [anon_sym_switch] = ACTIONS(4),
    [anon_sym_for] = ACTIONS(4),
    [anon_sym_LPAREN] = ACTIONS(2),
    [anon_sym_RPAREN] = ACTIONS(2),
    [anon_sym_in] = ACTIONS(4),
    [anon_sym_await] = ACTIONS(4),
    [anon_sym_of] = ACTIONS(4),
    [anon_sym_while] = ACTIONS(4),
    [anon_sym_do] = ACTIONS(4),
    [anon_sym_try] = ACTIONS(4),
    [anon_sym_with] = ACTIONS(4),
    [anon_sym_break] = ACTIONS(4),
    [anon_sym_continue] = ACTIONS(4),
    [anon_sym_debugger] = ACTIONS(4),
    [anon_sym_return] = ACTIONS(4),
    [anon_sym_throw] = ACTIONS(4),
    [anon_sym_SEMI] = ACTIONS(2),
    [anon_sym_COLON] = ACTIONS(2),
    [anon_sym_case] = ACTIONS(4),
    [anon_sym_catch] = ACTIONS(4),
    [anon_sym_finally] = ACTIONS(4),
    [anon_sym_yield] = ACTIONS(4),
    [anon_sym_LBRACK] = ACTIONS(2),
    [anon_sym_RBRACK] = ACTIONS(2),
    [anon_sym_LT] = ACTIONS(4),
    [anon_sym_GT] = ACTIONS(4),
    [anon_sym_SLASH] = ACTIONS(4),
    [anon_sym_DOT] = ACTIONS(4),
    [anon_sym_EQ] = ACTIONS(4),
    [anon_sym_class] = ACTIONS(4),
    [anon_sym_extends] = ACTIONS(4),
    [anon_sym_async] = ACTIONS(4),
    [anon_sym_function] = ACTIONS(4),
    [anon_sym_EQ_GT] = ACTIONS(2),
    [anon_sym_new] = ACTIONS(4),
    [anon_sym_PLUS_EQ] = ACTIONS(2),
    [anon_sym_DASH_EQ] = ACTIONS(2),
    [anon_sym_STAR_EQ] = ACTIONS(2),
    [anon_sym_PERCENT_EQ] = ACTIONS(2),
    [anon_sym_CARET_EQ] = ACTIONS(2),
    [anon_sym_AMP_EQ] = ACTIONS(2),
    [anon_sym_PIPE_EQ] = ACTIONS(2),
    [anon_sym_GT_GT_EQ] = ACTIONS(2),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2),
    [anon_sym_LT_LT_EQ] = ACTIONS(2),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2),
    [anon_sym_QMARK] = ACTIONS(2),
    [anon_sym_AMP_AMP] = ACTIONS(2),
    [anon_sym_PIPE_PIPE] = ACTIONS(2),
    [anon_sym_GT_GT] = ACTIONS(4),
    [anon_sym_GT_GT_GT] = ACTIONS(4),
    [anon_sym_LT_LT] = ACTIONS(4),
    [anon_sym_AMP] = ACTIONS(4),
    [anon_sym_CARET] = ACTIONS(4),
    [anon_sym_PIPE] = ACTIONS(4),
    [anon_sym_PLUS] = ACTIONS(4),
    [anon_sym_DASH] = ACTIONS(4),
    [anon_sym_PERCENT] = ACTIONS(4),
    [anon_sym_LT_EQ] = ACTIONS(2),
    [anon_sym_EQ_EQ] = ACTIONS(4),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2),
    [anon_sym_BANG_EQ] = ACTIONS(4),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2),
    [anon_sym_GT_EQ] = ACTIONS(2),
    [anon_sym_instanceof] = ACTIONS(4),
    [anon_sym_BANG] = ACTIONS(4),
    [anon_sym_TILDE] = ACTIONS(2),
    [anon_sym_typeof] = ACTIONS(4),
    [anon_sym_void] = ACTIONS(4),
    [anon_sym_delete] = ACTIONS(4),
    [anon_sym_PLUS_PLUS] = ACTIONS(2),
    [anon_sym_DASH_DASH] = ACTIONS(2),
    [anon_sym_DQUOTE] = ACTIONS(2),
    [anon_sym_SQUOTE] = ACTIONS(2),
    [sym_escape_sequence] = ACTIONS(2),
    [sym_comment] = ACTIONS(2),
    [anon_sym_BQUOTE] = ACTIONS(2),
    [anon_sym_SLASH2] = ACTIONS(4),
    [sym_number] = ACTIONS(2),
    [sym_identifier] = ACTIONS(4),
    [anon_sym_target] = ACTIONS(4),
    [sym_this] = ACTIONS(4),
    [sym_super] = ACTIONS(4),
    [sym_true] = ACTIONS(4),
    [sym_false] = ACTIONS(4),
    [sym_null] = ACTIONS(4),
    [sym_undefined] = ACTIONS(4),
    [anon_sym_AT] = ACTIONS(2),
    [anon_sym_static] = ACTIONS(4),
    [anon_sym_get] = ACTIONS(4),
    [anon_sym_set] = ACTIONS(4),
  },
  [1] = {
    [sym_program] = STATE(41),
    [sym_export_statement] = STATE(51),
    [sym__declaration] = STATE(51),
    [sym_import_statement] = STATE(51),
    [sym_expression_statement] = STATE(51),
    [sym_variable_declaration] = STATE(51),
    [sym_lexical_declaration] = STATE(51),
    [sym_statement_block] = STATE(51),
    [sym_if_statement] = STATE(51),
    [sym_switch_statement] = STATE(51),
    [sym_for_statement] = STATE(51),
    [sym_for_in_statement] = STATE(51),
    [sym_for_of_statement] = STATE(51),
    [sym_while_statement] = STATE(51),
    [sym_do_statement] = STATE(51),
    [sym_try_statement] = STATE(51),
    [sym_with_statement] = STATE(51),
    [sym_break_statement] = STATE(51),
    [sym_continue_statement] = STATE(51),
    [sym_debugger_statement] = STATE(51),
    [sym_return_statement] = STATE(51),
    [sym_throw_statement] = STATE(51),
    [sym_empty_statement] = STATE(51),
    [sym_labeled_statement] = STATE(51),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(51),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [ts_builtin_sym_end] = ACTIONS(6),
    [sym_hash_bang_line] = ACTIONS(8),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2] = {
    [sym_export_statement] = STATE(53),
    [sym__declaration] = STATE(53),
    [sym_import_statement] = STATE(53),
    [sym_expression_statement] = STATE(53),
    [sym_variable_declaration] = STATE(53),
    [sym_lexical_declaration] = STATE(53),
    [sym_statement_block] = STATE(53),
    [sym_if_statement] = STATE(53),
    [sym_switch_statement] = STATE(53),
    [sym_for_statement] = STATE(53),
    [sym_for_in_statement] = STATE(53),
    [sym_for_of_statement] = STATE(53),
    [sym_while_statement] = STATE(53),
    [sym_do_statement] = STATE(53),
    [sym_try_statement] = STATE(53),
    [sym_with_statement] = STATE(53),
    [sym_break_statement] = STATE(53),
    [sym_continue_statement] = STATE(53),
    [sym_debugger_statement] = STATE(53),
    [sym_return_statement] = STATE(53),
    [sym_throw_statement] = STATE(53),
    [sym_empty_statement] = STATE(53),
    [sym_labeled_statement] = STATE(53),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(53),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [ts_builtin_sym_end] = ACTIONS(94),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [3] = {
    [sym_export_clause] = STATE(60),
    [sym__declaration] = STATE(61),
    [sym_variable_declaration] = STATE(61),
    [sym_lexical_declaration] = STATE(61),
    [sym_class] = STATE(62),
    [sym_function] = STATE(62),
    [sym_generator_function] = STATE(62),
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [anon_sym_STAR] = ACTIONS(96),
    [anon_sym_default] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_var] = ACTIONS(102),
    [anon_sym_let] = ACTIONS(104),
    [anon_sym_const] = ACTIONS(104),
    [anon_sym_class] = ACTIONS(106),
    [anon_sym_async] = ACTIONS(108),
    [anon_sym_function] = ACTIONS(110),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [4] = {
    [sym_export_statement] = STATE(81),
    [sym__declaration] = STATE(81),
    [sym_import_statement] = STATE(81),
    [sym_expression_statement] = STATE(81),
    [sym_variable_declaration] = STATE(81),
    [sym_lexical_declaration] = STATE(81),
    [sym_statement_block] = STATE(81),
    [sym_if_statement] = STATE(81),
    [sym_switch_statement] = STATE(81),
    [sym_for_statement] = STATE(81),
    [sym_for_in_statement] = STATE(81),
    [sym_for_of_statement] = STATE(81),
    [sym_while_statement] = STATE(81),
    [sym_do_statement] = STATE(81),
    [sym_try_statement] = STATE(81),
    [sym_with_statement] = STATE(81),
    [sym_break_statement] = STATE(81),
    [sym_continue_statement] = STATE(81),
    [sym_debugger_statement] = STATE(81),
    [sym_return_statement] = STATE(81),
    [sym_throw_statement] = STATE(81),
    [sym_empty_statement] = STATE(81),
    [sym_labeled_statement] = STATE(81),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(77),
    [sym_assignment_pattern] = STATE(78),
    [sym_array] = STATE(79),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_spread_element] = STATE(78),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(74),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(82),
    [sym_formal_parameters] = STATE(50),
    [sym_method_definition] = STATE(78),
    [sym_pair] = STATE(78),
    [sym__property_name] = STATE(80),
    [sym_computed_property_name] = STATE(80),
    [aux_sym_program_repeat1] = STATE(81),
    [aux_sym_export_statement_repeat1] = STATE(82),
    [aux_sym_object_repeat1] = STATE(83),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(116),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(126),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(128),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(130),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(132),
    [sym_identifier] = ACTIONS(134),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(136),
    [anon_sym_set] = ACTIONS(136),
  },
  [5] = {
    [sym_import_clause] = STATE(87),
    [sym_namespace_import] = STATE(88),
    [sym_named_imports] = STATE(88),
    [sym_string] = STATE(89),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_LBRACE] = ACTIONS(140),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(142),
  },
  [6] = {
    [sym_variable_declarator] = STATE(93),
    [sym_object] = STATE(94),
    [sym_array] = STATE(95),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(148),
  },
  [7] = {
    [sym_variable_declarator] = STATE(96),
    [sym_object] = STATE(94),
    [sym_array] = STATE(95),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(148),
  },
  [8] = {
    [sym_parenthesized_expression] = STATE(98),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [9] = {
    [sym_parenthesized_expression] = STATE(99),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [10] = {
    [anon_sym_LPAREN] = ACTIONS(152),
    [anon_sym_await] = ACTIONS(154),
    [sym_comment] = ACTIONS(78),
  },
  [11] = {
    [sym_parenthesized_expression] = STATE(124),
    [sym__expression] = STATE(124),
    [sym_yield_expression] = STATE(124),
    [sym_object] = STATE(125),
    [sym_assignment_pattern] = STATE(126),
    [sym_array] = STATE(127),
    [sym_jsx_element] = STATE(124),
    [sym_jsx_fragment] = STATE(124),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(124),
    [sym_anonymous_class] = STATE(124),
    [sym_class] = STATE(124),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(124),
    [sym_generator_function] = STATE(124),
    [sym_call_expression] = STATE(124),
    [sym_new_expression] = STATE(124),
    [sym_await_expression] = STATE(124),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(124),
    [sym_augmented_assignment_expression] = STATE(124),
    [sym_ternary_expression] = STATE(124),
    [sym_binary_expression] = STATE(124),
    [sym_unary_expression] = STATE(124),
    [sym_update_expression] = STATE(124),
    [sym_sequence_expression] = STATE(131),
    [sym_string] = STATE(124),
    [sym_template_string] = STATE(124),
    [sym_regex] = STATE(124),
    [sym_meta_property] = STATE(124),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [sym_rest_parameter] = STATE(126),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(160),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(174),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(182),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(196),
    [sym_identifier] = ACTIONS(198),
    [sym_this] = ACTIONS(200),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_null] = ACTIONS(200),
    [sym_undefined] = ACTIONS(200),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(204),
    [anon_sym_set] = ACTIONS(204),
  },
  [12] = {
    [sym_parenthesized_expression] = STATE(136),
    [sym__expression] = STATE(136),
    [sym_yield_expression] = STATE(136),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(136),
    [sym_jsx_fragment] = STATE(136),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(136),
    [sym_anonymous_class] = STATE(136),
    [sym_class] = STATE(136),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(136),
    [sym_generator_function] = STATE(136),
    [sym_call_expression] = STATE(136),
    [sym_new_expression] = STATE(136),
    [sym_await_expression] = STATE(136),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(136),
    [sym_augmented_assignment_expression] = STATE(136),
    [sym_ternary_expression] = STATE(136),
    [sym_binary_expression] = STATE(136),
    [sym_unary_expression] = STATE(136),
    [sym_update_expression] = STATE(136),
    [sym_string] = STATE(136),
    [sym_template_string] = STATE(136),
    [sym_regex] = STATE(136),
    [sym_meta_property] = STATE(136),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(208),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(212),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(212),
    [sym_false] = ACTIONS(212),
    [sym_null] = ACTIONS(212),
    [sym_undefined] = ACTIONS(212),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [13] = {
    [sym_parenthesized_expression] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [14] = {
    [sym_export_statement] = STATE(146),
    [sym__declaration] = STATE(146),
    [sym_import_statement] = STATE(146),
    [sym_expression_statement] = STATE(146),
    [sym_variable_declaration] = STATE(146),
    [sym_lexical_declaration] = STATE(146),
    [sym_statement_block] = STATE(146),
    [sym_if_statement] = STATE(146),
    [sym_switch_statement] = STATE(146),
    [sym_for_statement] = STATE(146),
    [sym_for_in_statement] = STATE(146),
    [sym_for_of_statement] = STATE(146),
    [sym_while_statement] = STATE(146),
    [sym_do_statement] = STATE(146),
    [sym_try_statement] = STATE(146),
    [sym_with_statement] = STATE(146),
    [sym_break_statement] = STATE(146),
    [sym_continue_statement] = STATE(146),
    [sym_debugger_statement] = STATE(146),
    [sym_return_statement] = STATE(146),
    [sym_throw_statement] = STATE(146),
    [sym_empty_statement] = STATE(146),
    [sym_labeled_statement] = STATE(146),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [15] = {
    [sym_statement_block] = STATE(151),
    [anon_sym_LBRACE] = ACTIONS(226),
    [sym_comment] = ACTIONS(78),
  },
  [16] = {
    [sym_parenthesized_expression] = STATE(152),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [17] = {
    [sym__automatic_semicolon] = ACTIONS(228),
    [anon_sym_SEMI] = ACTIONS(228),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(230),
  },
  [18] = {
    [sym__automatic_semicolon] = ACTIONS(232),
    [anon_sym_SEMI] = ACTIONS(232),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(234),
  },
  [19] = {
    [sym__automatic_semicolon] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(236),
    [sym_comment] = ACTIONS(78),
  },
  [20] = {
    [sym_parenthesized_expression] = STATE(159),
    [sym__expression] = STATE(159),
    [sym_yield_expression] = STATE(159),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(159),
    [sym_jsx_fragment] = STATE(159),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(159),
    [sym_anonymous_class] = STATE(159),
    [sym_class] = STATE(159),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(159),
    [sym_generator_function] = STATE(159),
    [sym_call_expression] = STATE(159),
    [sym_new_expression] = STATE(159),
    [sym_await_expression] = STATE(159),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(159),
    [sym_augmented_assignment_expression] = STATE(159),
    [sym_ternary_expression] = STATE(159),
    [sym_binary_expression] = STATE(159),
    [sym_unary_expression] = STATE(159),
    [sym_update_expression] = STATE(159),
    [sym_sequence_expression] = STATE(160),
    [sym_string] = STATE(159),
    [sym_template_string] = STATE(159),
    [sym_regex] = STATE(159),
    [sym_meta_property] = STATE(159),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [sym__automatic_semicolon] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(240),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(242),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(242),
    [sym_false] = ACTIONS(242),
    [sym_null] = ACTIONS(242),
    [sym_undefined] = ACTIONS(242),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [21] = {
    [sym_parenthesized_expression] = STATE(161),
    [sym__expression] = STATE(161),
    [sym_yield_expression] = STATE(161),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(161),
    [sym_jsx_fragment] = STATE(161),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(161),
    [sym_anonymous_class] = STATE(161),
    [sym_class] = STATE(161),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(161),
    [sym_generator_function] = STATE(161),
    [sym_call_expression] = STATE(161),
    [sym_new_expression] = STATE(161),
    [sym_await_expression] = STATE(161),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(161),
    [sym_augmented_assignment_expression] = STATE(161),
    [sym_ternary_expression] = STATE(161),
    [sym_binary_expression] = STATE(161),
    [sym_unary_expression] = STATE(161),
    [sym_update_expression] = STATE(161),
    [sym_sequence_expression] = STATE(162),
    [sym_string] = STATE(161),
    [sym_template_string] = STATE(161),
    [sym_regex] = STATE(161),
    [sym_meta_property] = STATE(161),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(244),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(246),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(246),
    [sym_false] = ACTIONS(246),
    [sym_null] = ACTIONS(246),
    [sym_undefined] = ACTIONS(246),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [22] = {
    [ts_builtin_sym_end] = ACTIONS(248),
    [anon_sym_export] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(248),
    [anon_sym_RBRACE] = ACTIONS(248),
    [anon_sym_import] = ACTIONS(250),
    [anon_sym_var] = ACTIONS(250),
    [anon_sym_let] = ACTIONS(250),
    [anon_sym_const] = ACTIONS(250),
    [anon_sym_if] = ACTIONS(250),
    [anon_sym_else] = ACTIONS(250),
    [anon_sym_switch] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(250),
    [anon_sym_LPAREN] = ACTIONS(248),
    [anon_sym_RPAREN] = ACTIONS(248),
    [anon_sym_await] = ACTIONS(250),
    [anon_sym_while] = ACTIONS(250),
    [anon_sym_do] = ACTIONS(250),
    [anon_sym_try] = ACTIONS(250),
    [anon_sym_with] = ACTIONS(250),
    [anon_sym_break] = ACTIONS(250),
    [anon_sym_continue] = ACTIONS(250),
    [anon_sym_debugger] = ACTIONS(250),
    [anon_sym_return] = ACTIONS(250),
    [anon_sym_throw] = ACTIONS(250),
    [anon_sym_SEMI] = ACTIONS(248),
    [anon_sym_case] = ACTIONS(250),
    [anon_sym_yield] = ACTIONS(250),
    [anon_sym_LBRACK] = ACTIONS(248),
    [anon_sym_LT] = ACTIONS(248),
    [anon_sym_SLASH] = ACTIONS(250),
    [anon_sym_class] = ACTIONS(250),
    [anon_sym_async] = ACTIONS(250),
    [anon_sym_function] = ACTIONS(250),
    [anon_sym_EQ_GT] = ACTIONS(248),
    [anon_sym_new] = ACTIONS(250),
    [anon_sym_PLUS] = ACTIONS(250),
    [anon_sym_DASH] = ACTIONS(250),
    [anon_sym_BANG] = ACTIONS(248),
    [anon_sym_TILDE] = ACTIONS(248),
    [anon_sym_typeof] = ACTIONS(250),
    [anon_sym_void] = ACTIONS(250),
    [anon_sym_delete] = ACTIONS(250),
    [anon_sym_PLUS_PLUS] = ACTIONS(248),
    [anon_sym_DASH_DASH] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(248),
    [anon_sym_SQUOTE] = ACTIONS(248),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(248),
    [sym_number] = ACTIONS(248),
    [sym_identifier] = ACTIONS(250),
    [sym_this] = ACTIONS(250),
    [sym_super] = ACTIONS(250),
    [sym_true] = ACTIONS(250),
    [sym_false] = ACTIONS(250),
    [sym_null] = ACTIONS(250),
    [sym_undefined] = ACTIONS(250),
    [anon_sym_AT] = ACTIONS(248),
    [anon_sym_get] = ACTIONS(250),
    [anon_sym_set] = ACTIONS(250),
  },
  [23] = {
    [sym_parenthesized_expression] = STATE(163),
    [sym__expression] = STATE(163),
    [sym_yield_expression] = STATE(163),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(163),
    [sym_jsx_fragment] = STATE(163),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(163),
    [sym_anonymous_class] = STATE(163),
    [sym_class] = STATE(163),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(163),
    [sym_generator_function] = STATE(163),
    [sym_call_expression] = STATE(163),
    [sym_new_expression] = STATE(163),
    [sym_await_expression] = STATE(163),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(163),
    [sym_augmented_assignment_expression] = STATE(163),
    [sym_ternary_expression] = STATE(163),
    [sym_binary_expression] = STATE(163),
    [sym_unary_expression] = STATE(163),
    [sym_update_expression] = STATE(163),
    [sym_string] = STATE(163),
    [sym_template_string] = STATE(163),
    [sym_regex] = STATE(163),
    [sym_meta_property] = STATE(163),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [sym__automatic_semicolon] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(252),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(68),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(258),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(260),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(260),
    [sym_false] = ACTIONS(260),
    [sym_null] = ACTIONS(260),
    [sym_undefined] = ACTIONS(260),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [24] = {
    [sym_parenthesized_expression] = STATE(176),
    [sym__expression] = STATE(176),
    [sym_yield_expression] = STATE(176),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(176),
    [sym_jsx_fragment] = STATE(176),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(176),
    [sym_anonymous_class] = STATE(176),
    [sym_class] = STATE(176),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(176),
    [sym_generator_function] = STATE(176),
    [sym_call_expression] = STATE(176),
    [sym_new_expression] = STATE(176),
    [sym_await_expression] = STATE(176),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(176),
    [sym_augmented_assignment_expression] = STATE(176),
    [sym_spread_element] = STATE(180),
    [sym_ternary_expression] = STATE(176),
    [sym_binary_expression] = STATE(176),
    [sym_unary_expression] = STATE(176),
    [sym_update_expression] = STATE(176),
    [sym_string] = STATE(176),
    [sym_template_string] = STATE(176),
    [sym_regex] = STATE(176),
    [sym_meta_property] = STATE(176),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(182),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_RBRACK] = ACTIONS(268),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(284),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(288),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(288),
    [sym_false] = ACTIONS(288),
    [sym_null] = ACTIONS(288),
    [sym_undefined] = ACTIONS(288),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [25] = {
    [sym_nested_identifier] = STATE(186),
    [sym_jsx_namespace_name] = STATE(187),
    [anon_sym_GT] = ACTIONS(292),
    [sym_jsx_identifier] = ACTIONS(294),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(296),
  },
  [26] = {
    [sym_comment] = ACTIONS(298),
    [sym_regex_pattern] = ACTIONS(300),
  },
  [27] = {
    [sym_class_heritage] = STATE(192),
    [sym_class_body] = STATE(193),
    [anon_sym_LBRACE] = ACTIONS(302),
    [anon_sym_extends] = ACTIONS(304),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(306),
  },
  [28] = {
    [sym__initializer] = STATE(201),
    [sym_formal_parameters] = STATE(200),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(323),
    [anon_sym_DASH_EQ] = ACTIONS(323),
    [anon_sym_STAR_EQ] = ACTIONS(323),
    [anon_sym_SLASH_EQ] = ACTIONS(323),
    [anon_sym_PERCENT_EQ] = ACTIONS(323),
    [anon_sym_CARET_EQ] = ACTIONS(323),
    [anon_sym_AMP_EQ] = ACTIONS(323),
    [anon_sym_PIPE_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_LT_LT_EQ] = ACTIONS(323),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(325),
  },
  [29] = {
    [sym_formal_parameters] = STATE(204),
    [anon_sym_STAR] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(331),
  },
  [30] = {
    [sym_statement_block] = STATE(206),
    [sym_parenthesized_expression] = STATE(207),
    [sym__expression] = STATE(207),
    [sym_yield_expression] = STATE(207),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(207),
    [sym_jsx_fragment] = STATE(207),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(207),
    [sym_anonymous_class] = STATE(207),
    [sym_class] = STATE(207),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(207),
    [sym_generator_function] = STATE(207),
    [sym_call_expression] = STATE(207),
    [sym_new_expression] = STATE(207),
    [sym_await_expression] = STATE(207),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(207),
    [sym_augmented_assignment_expression] = STATE(207),
    [sym_ternary_expression] = STATE(207),
    [sym_binary_expression] = STATE(207),
    [sym_unary_expression] = STATE(207),
    [sym_update_expression] = STATE(207),
    [sym_string] = STATE(207),
    [sym_template_string] = STATE(207),
    [sym_regex] = STATE(207),
    [sym_meta_property] = STATE(207),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(335),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(337),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(337),
    [sym_false] = ACTIONS(337),
    [sym_null] = ACTIONS(337),
    [sym_undefined] = ACTIONS(337),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [31] = {
    [sym_parenthesized_expression] = STATE(214),
    [sym__expression] = STATE(218),
    [sym_yield_expression] = STATE(218),
    [sym_object] = STATE(219),
    [sym_array] = STATE(220),
    [sym_jsx_element] = STATE(218),
    [sym_jsx_fragment] = STATE(218),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(218),
    [sym_anonymous_class] = STATE(214),
    [sym_class] = STATE(214),
    [sym_function] = STATE(221),
    [sym_arrow_function] = STATE(214),
    [sym_generator_function] = STATE(214),
    [sym_call_expression] = STATE(218),
    [sym_new_expression] = STATE(214),
    [sym_await_expression] = STATE(218),
    [sym_member_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_assignment_expression] = STATE(218),
    [sym_augmented_assignment_expression] = STATE(218),
    [sym_ternary_expression] = STATE(218),
    [sym_binary_expression] = STATE(218),
    [sym_unary_expression] = STATE(218),
    [sym_update_expression] = STATE(218),
    [sym_string] = STATE(214),
    [sym_template_string] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_meta_property] = STATE(214),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_DOT] = ACTIONS(343),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(345),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(353),
    [sym_identifier] = ACTIONS(355),
    [sym_this] = ACTIONS(357),
    [sym_super] = ACTIONS(359),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_undefined] = ACTIONS(357),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(361),
    [anon_sym_set] = ACTIONS(361),
  },
  [32] = {
    [sym_parenthesized_expression] = STATE(223),
    [sym__expression] = STATE(223),
    [sym_yield_expression] = STATE(223),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(223),
    [sym_jsx_fragment] = STATE(223),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(223),
    [sym_anonymous_class] = STATE(223),
    [sym_class] = STATE(223),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(223),
    [sym_generator_function] = STATE(223),
    [sym_call_expression] = STATE(223),
    [sym_new_expression] = STATE(223),
    [sym_await_expression] = STATE(223),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(223),
    [sym_augmented_assignment_expression] = STATE(223),
    [sym_ternary_expression] = STATE(223),
    [sym_binary_expression] = STATE(223),
    [sym_unary_expression] = STATE(223),
    [sym_update_expression] = STATE(223),
    [sym_string] = STATE(223),
    [sym_template_string] = STATE(223),
    [sym_regex] = STATE(223),
    [sym_meta_property] = STATE(223),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(363),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(365),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(365),
    [sym_false] = ACTIONS(365),
    [sym_null] = ACTIONS(365),
    [sym_undefined] = ACTIONS(365),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [33] = {
    [sym_parenthesized_expression] = STATE(224),
    [sym__expression] = STATE(224),
    [sym_yield_expression] = STATE(224),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(224),
    [sym_jsx_fragment] = STATE(224),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(224),
    [sym_anonymous_class] = STATE(224),
    [sym_class] = STATE(224),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(224),
    [sym_generator_function] = STATE(224),
    [sym_call_expression] = STATE(224),
    [sym_new_expression] = STATE(224),
    [sym_await_expression] = STATE(224),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(224),
    [sym_augmented_assignment_expression] = STATE(224),
    [sym_ternary_expression] = STATE(224),
    [sym_binary_expression] = STATE(224),
    [sym_unary_expression] = STATE(224),
    [sym_update_expression] = STATE(224),
    [sym_string] = STATE(224),
    [sym_template_string] = STATE(224),
    [sym_regex] = STATE(224),
    [sym_meta_property] = STATE(224),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(367),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(369),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(369),
    [sym_false] = ACTIONS(369),
    [sym_null] = ACTIONS(369),
    [sym_undefined] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [34] = {
    [aux_sym_string_repeat1] = STATE(226),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(373),
    [sym_escape_sequence] = ACTIONS(373),
    [sym_comment] = ACTIONS(298),
  },
  [35] = {
    [aux_sym_string_repeat2] = STATE(227),
    [anon_sym_SQUOTE] = ACTIONS(371),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(375),
    [sym_escape_sequence] = ACTIONS(375),
    [sym_comment] = ACTIONS(298),
  },
  [36] = {
    [sym_template_substitution] = STATE(230),
    [aux_sym_template_string_repeat1] = STATE(230),
    [sym__template_chars] = ACTIONS(377),
    [sym_escape_sequence] = ACTIONS(377),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(381),
  },
  [37] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(389),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [38] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_DOT] = ACTIONS(391),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [39] = {
    [sym__identifier_reference] = STATE(240),
    [sym_decorator_member_expression] = STATE(240),
    [sym_decorator_call_expression] = STATE(241),
    [anon_sym_async] = ACTIONS(399),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_get] = ACTIONS(399),
    [anon_sym_set] = ACTIONS(399),
  },
  [40] = {
    [sym__initializer] = STATE(201),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_PLUS_EQ] = ACTIONS(323),
    [anon_sym_DASH_EQ] = ACTIONS(323),
    [anon_sym_STAR_EQ] = ACTIONS(323),
    [anon_sym_SLASH_EQ] = ACTIONS(323),
    [anon_sym_PERCENT_EQ] = ACTIONS(323),
    [anon_sym_CARET_EQ] = ACTIONS(323),
    [anon_sym_AMP_EQ] = ACTIONS(323),
    [anon_sym_PIPE_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_LT_LT_EQ] = ACTIONS(323),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [41] = {
    [ts_builtin_sym_end] = ACTIONS(403),
    [sym_comment] = ACTIONS(78),
  },
  [42] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(405),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [43] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [44] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [45] = {
    [sym_jsx_element] = STATE(256),
    [sym_jsx_expression] = STATE(256),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_closing_element] = STATE(255),
    [sym_jsx_self_closing_element] = STATE(256),
    [aux_sym_jsx_element_repeat1] = STATE(256),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(431),
    [sym_jsx_text] = ACTIONS(433),
    [sym_comment] = ACTIONS(78),
  },
  [46] = {
    [sym__automatic_semicolon] = ACTIONS(435),
    [ts_builtin_sym_end] = ACTIONS(437),
    [anon_sym_export] = ACTIONS(439),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_default] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_import] = ACTIONS(439),
    [anon_sym_var] = ACTIONS(439),
    [anon_sym_let] = ACTIONS(439),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_switch] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_await] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_do] = ACTIONS(439),
    [anon_sym_try] = ACTIONS(439),
    [anon_sym_with] = ACTIONS(439),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_continue] = ACTIONS(439),
    [anon_sym_debugger] = ACTIONS(439),
    [anon_sym_return] = ACTIONS(439),
    [anon_sym_throw] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_case] = ACTIONS(439),
    [anon_sym_yield] = ACTIONS(439),
    [anon_sym_LBRACK] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(439),
    [anon_sym_DOT] = ACTIONS(385),
    [anon_sym_class] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ_GT] = ACTIONS(437),
    [anon_sym_new] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_DASH] = ACTIONS(439),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(385),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_typeof] = ACTIONS(439),
    [anon_sym_void] = ACTIONS(439),
    [anon_sym_delete] = ACTIONS(439),
    [anon_sym_PLUS_PLUS] = ACTIONS(437),
    [anon_sym_DASH_DASH] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [sym_number] = ACTIONS(437),
    [sym_identifier] = ACTIONS(439),
    [sym_this] = ACTIONS(439),
    [sym_super] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_undefined] = ACTIONS(439),
    [anon_sym_AT] = ACTIONS(437),
    [anon_sym_get] = ACTIONS(439),
    [anon_sym_set] = ACTIONS(439),
  },
  [47] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(435),
    [ts_builtin_sym_end] = ACTIONS(437),
    [anon_sym_export] = ACTIONS(439),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_default] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_import] = ACTIONS(439),
    [anon_sym_var] = ACTIONS(439),
    [anon_sym_let] = ACTIONS(439),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_switch] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_await] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_do] = ACTIONS(439),
    [anon_sym_try] = ACTIONS(439),
    [anon_sym_with] = ACTIONS(439),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_continue] = ACTIONS(439),
    [anon_sym_debugger] = ACTIONS(439),
    [anon_sym_return] = ACTIONS(439),
    [anon_sym_throw] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_case] = ACTIONS(439),
    [anon_sym_yield] = ACTIONS(439),
    [anon_sym_LBRACK] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(439),
    [anon_sym_DOT] = ACTIONS(385),
    [anon_sym_class] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ_GT] = ACTIONS(437),
    [anon_sym_new] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_DASH] = ACTIONS(439),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(385),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_typeof] = ACTIONS(439),
    [anon_sym_void] = ACTIONS(439),
    [anon_sym_delete] = ACTIONS(439),
    [anon_sym_PLUS_PLUS] = ACTIONS(437),
    [anon_sym_DASH_DASH] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(437),
    [sym_identifier] = ACTIONS(439),
    [sym_this] = ACTIONS(439),
    [sym_super] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_undefined] = ACTIONS(439),
    [anon_sym_AT] = ACTIONS(437),
    [anon_sym_get] = ACTIONS(439),
    [anon_sym_set] = ACTIONS(439),
  },
  [48] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [49] = {
    [sym__automatic_semicolon] = ACTIONS(405),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_comment] = ACTIONS(78),
  },
  [50] = {
    [anon_sym_EQ_GT] = ACTIONS(321),
    [sym_comment] = ACTIONS(78),
  },
  [51] = {
    [sym_export_statement] = STATE(258),
    [sym__declaration] = STATE(258),
    [sym_import_statement] = STATE(258),
    [sym_expression_statement] = STATE(258),
    [sym_variable_declaration] = STATE(258),
    [sym_lexical_declaration] = STATE(258),
    [sym_statement_block] = STATE(258),
    [sym_if_statement] = STATE(258),
    [sym_switch_statement] = STATE(258),
    [sym_for_statement] = STATE(258),
    [sym_for_in_statement] = STATE(258),
    [sym_for_of_statement] = STATE(258),
    [sym_while_statement] = STATE(258),
    [sym_do_statement] = STATE(258),
    [sym_try_statement] = STATE(258),
    [sym_with_statement] = STATE(258),
    [sym_break_statement] = STATE(258),
    [sym_continue_statement] = STATE(258),
    [sym_debugger_statement] = STATE(258),
    [sym_return_statement] = STATE(258),
    [sym_throw_statement] = STATE(258),
    [sym_empty_statement] = STATE(258),
    [sym_labeled_statement] = STATE(258),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(258),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [ts_builtin_sym_end] = ACTIONS(94),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [52] = {
    [sym_decorator] = STATE(261),
    [aux_sym_export_statement_repeat1] = STATE(261),
    [anon_sym_export] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(443),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [53] = {
    [sym_export_statement] = STATE(258),
    [sym__declaration] = STATE(258),
    [sym_import_statement] = STATE(258),
    [sym_expression_statement] = STATE(258),
    [sym_variable_declaration] = STATE(258),
    [sym_lexical_declaration] = STATE(258),
    [sym_statement_block] = STATE(258),
    [sym_if_statement] = STATE(258),
    [sym_switch_statement] = STATE(258),
    [sym_for_statement] = STATE(258),
    [sym_for_in_statement] = STATE(258),
    [sym_for_of_statement] = STATE(258),
    [sym_while_statement] = STATE(258),
    [sym_do_statement] = STATE(258),
    [sym_try_statement] = STATE(258),
    [sym_with_statement] = STATE(258),
    [sym_break_statement] = STATE(258),
    [sym_continue_statement] = STATE(258),
    [sym_debugger_statement] = STATE(258),
    [sym_return_statement] = STATE(258),
    [sym_throw_statement] = STATE(258),
    [sym_empty_statement] = STATE(258),
    [sym_labeled_statement] = STATE(258),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(258),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [ts_builtin_sym_end] = ACTIONS(445),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [54] = {
    [sym__from_clause] = STATE(263),
    [anon_sym_from] = ACTIONS(447),
    [sym_comment] = ACTIONS(78),
  },
  [55] = {
    [sym_parenthesized_expression] = STATE(273),
    [sym__expression] = STATE(273),
    [sym_yield_expression] = STATE(273),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(273),
    [sym_jsx_fragment] = STATE(273),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(273),
    [sym_anonymous_class] = STATE(273),
    [sym_class] = STATE(273),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(273),
    [sym_generator_function] = STATE(273),
    [sym_call_expression] = STATE(273),
    [sym_new_expression] = STATE(273),
    [sym_await_expression] = STATE(273),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(273),
    [sym_augmented_assignment_expression] = STATE(273),
    [sym_ternary_expression] = STATE(273),
    [sym_binary_expression] = STATE(273),
    [sym_unary_expression] = STATE(273),
    [sym_update_expression] = STATE(273),
    [sym_string] = STATE(273),
    [sym_template_string] = STATE(273),
    [sym_regex] = STATE(273),
    [sym_meta_property] = STATE(273),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(465),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(469),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(469),
    [sym_false] = ACTIONS(469),
    [sym_null] = ACTIONS(469),
    [sym_undefined] = ACTIONS(469),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [56] = {
    [sym__import_export_specifier] = STATE(281),
    [anon_sym_COMMA] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(475),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(477),
  },
  [57] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(479),
  },
  [58] = {
    [anon_sym_function] = ACTIONS(481),
    [sym_comment] = ACTIONS(78),
  },
  [59] = {
    [sym_formal_parameters] = STATE(286),
    [anon_sym_STAR] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(485),
  },
  [60] = {
    [sym__from_clause] = STATE(263),
    [sym__automatic_semicolon] = ACTIONS(487),
    [anon_sym_from] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(487),
    [sym_comment] = ACTIONS(78),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(491),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_LBRACE] = ACTIONS(489),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_import] = ACTIONS(491),
    [anon_sym_var] = ACTIONS(491),
    [anon_sym_let] = ACTIONS(491),
    [anon_sym_const] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_else] = ACTIONS(491),
    [anon_sym_switch] = ACTIONS(491),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_LPAREN] = ACTIONS(489),
    [anon_sym_await] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_do] = ACTIONS(491),
    [anon_sym_try] = ACTIONS(491),
    [anon_sym_with] = ACTIONS(491),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_continue] = ACTIONS(491),
    [anon_sym_debugger] = ACTIONS(491),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_throw] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(489),
    [anon_sym_case] = ACTIONS(491),
    [anon_sym_yield] = ACTIONS(491),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_LT] = ACTIONS(489),
    [anon_sym_SLASH] = ACTIONS(491),
    [anon_sym_class] = ACTIONS(491),
    [anon_sym_async] = ACTIONS(491),
    [anon_sym_function] = ACTIONS(491),
    [anon_sym_EQ_GT] = ACTIONS(489),
    [anon_sym_new] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(491),
    [anon_sym_DASH] = ACTIONS(491),
    [anon_sym_BANG] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(489),
    [anon_sym_typeof] = ACTIONS(491),
    [anon_sym_void] = ACTIONS(491),
    [anon_sym_delete] = ACTIONS(491),
    [anon_sym_PLUS_PLUS] = ACTIONS(489),
    [anon_sym_DASH_DASH] = ACTIONS(489),
    [anon_sym_DQUOTE] = ACTIONS(489),
    [anon_sym_SQUOTE] = ACTIONS(489),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [sym_number] = ACTIONS(489),
    [sym_identifier] = ACTIONS(491),
    [sym_this] = ACTIONS(491),
    [sym_super] = ACTIONS(491),
    [sym_true] = ACTIONS(491),
    [sym_false] = ACTIONS(491),
    [sym_null] = ACTIONS(491),
    [sym_undefined] = ACTIONS(491),
    [anon_sym_AT] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(491),
    [anon_sym_set] = ACTIONS(491),
  },
  [62] = {
    [sym__automatic_semicolon] = ACTIONS(435),
    [ts_builtin_sym_end] = ACTIONS(437),
    [anon_sym_export] = ACTIONS(439),
    [anon_sym_default] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_import] = ACTIONS(439),
    [anon_sym_var] = ACTIONS(439),
    [anon_sym_let] = ACTIONS(439),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_switch] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_await] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_do] = ACTIONS(439),
    [anon_sym_try] = ACTIONS(439),
    [anon_sym_with] = ACTIONS(439),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_continue] = ACTIONS(439),
    [anon_sym_debugger] = ACTIONS(439),
    [anon_sym_return] = ACTIONS(439),
    [anon_sym_throw] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_case] = ACTIONS(439),
    [anon_sym_yield] = ACTIONS(439),
    [anon_sym_LBRACK] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(439),
    [anon_sym_class] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_EQ_GT] = ACTIONS(437),
    [anon_sym_new] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_DASH] = ACTIONS(439),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_typeof] = ACTIONS(439),
    [anon_sym_void] = ACTIONS(439),
    [anon_sym_delete] = ACTIONS(439),
    [anon_sym_PLUS_PLUS] = ACTIONS(437),
    [anon_sym_DASH_DASH] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [sym_number] = ACTIONS(437),
    [sym_identifier] = ACTIONS(439),
    [sym_this] = ACTIONS(439),
    [sym_super] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_undefined] = ACTIONS(439),
    [anon_sym_AT] = ACTIONS(437),
    [anon_sym_get] = ACTIONS(439),
    [anon_sym_set] = ACTIONS(439),
  },
  [63] = {
    [sym_decorator] = STATE(289),
    [aux_sym_export_statement_repeat1] = STATE(289),
    [anon_sym_class] = ACTIONS(493),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [64] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [65] = {
    [sym_object] = STATE(298),
    [sym_assignment_pattern] = STATE(299),
    [sym_array] = STATE(300),
    [sym_spread_element] = STATE(299),
    [sym_string] = STATE(80),
    [sym_decorator] = STATE(301),
    [sym_method_definition] = STATE(299),
    [sym_pair] = STATE(299),
    [sym__property_name] = STATE(80),
    [sym_computed_property_name] = STATE(80),
    [aux_sym_export_statement_repeat1] = STATE(301),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_async] = ACTIONS(507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(130),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(509),
    [sym_identifier] = ACTIONS(511),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(513),
    [anon_sym_set] = ACTIONS(513),
  },
  [66] = {
    [sym__automatic_semicolon] = ACTIONS(515),
    [ts_builtin_sym_end] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(515),
    [anon_sym_default] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_import] = ACTIONS(519),
    [anon_sym_var] = ACTIONS(519),
    [anon_sym_let] = ACTIONS(519),
    [anon_sym_const] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(519),
    [anon_sym_else] = ACTIONS(519),
    [anon_sym_switch] = ACTIONS(519),
    [anon_sym_for] = ACTIONS(519),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_await] = ACTIONS(519),
    [anon_sym_while] = ACTIONS(519),
    [anon_sym_do] = ACTIONS(519),
    [anon_sym_try] = ACTIONS(519),
    [anon_sym_with] = ACTIONS(519),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(519),
    [anon_sym_debugger] = ACTIONS(519),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_throw] = ACTIONS(519),
    [anon_sym_SEMI] = ACTIONS(515),
    [anon_sym_case] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(515),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(521),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(515),
    [anon_sym_LT_LT] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(515),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(515),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [anon_sym_instanceof] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_TILDE] = ACTIONS(517),
    [anon_sym_typeof] = ACTIONS(519),
    [anon_sym_void] = ACTIONS(519),
    [anon_sym_delete] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(515),
    [anon_sym_DASH_DASH] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(517),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(515),
    [sym_number] = ACTIONS(517),
    [sym_identifier] = ACTIONS(519),
    [sym_this] = ACTIONS(519),
    [sym_super] = ACTIONS(519),
    [sym_true] = ACTIONS(519),
    [sym_false] = ACTIONS(519),
    [sym_null] = ACTIONS(519),
    [sym_undefined] = ACTIONS(519),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
  },
  [67] = {
    [sym_parenthesized_expression] = STATE(302),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [68] = {
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_await] = ACTIONS(525),
    [sym_comment] = ACTIONS(78),
  },
  [69] = {
    [sym_parenthesized_expression] = STATE(305),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [70] = {
    [sym_parenthesized_expression] = STATE(306),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [71] = {
    [sym_parenthesized_expression] = STATE(307),
    [sym__expression] = STATE(307),
    [sym_yield_expression] = STATE(307),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(307),
    [sym_jsx_fragment] = STATE(307),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(307),
    [sym_anonymous_class] = STATE(307),
    [sym_class] = STATE(307),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(307),
    [sym_generator_function] = STATE(307),
    [sym_call_expression] = STATE(307),
    [sym_new_expression] = STATE(307),
    [sym_await_expression] = STATE(307),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(307),
    [sym_augmented_assignment_expression] = STATE(307),
    [sym_spread_element] = STATE(180),
    [sym_ternary_expression] = STATE(307),
    [sym_binary_expression] = STATE(307),
    [sym_unary_expression] = STATE(307),
    [sym_update_expression] = STATE(307),
    [sym_string] = STATE(307),
    [sym_template_string] = STATE(307),
    [sym_regex] = STATE(307),
    [sym_meta_property] = STATE(307),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(182),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_RBRACK] = ACTIONS(268),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(527),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(529),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(529),
    [sym_false] = ACTIONS(529),
    [sym_null] = ACTIONS(529),
    [sym_undefined] = ACTIONS(529),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [72] = {
    [sym__initializer] = STATE(201),
    [sym_string] = STATE(292),
    [sym_formal_parameters] = STATE(200),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(312),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(545),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(323),
    [anon_sym_DASH_EQ] = ACTIONS(323),
    [anon_sym_STAR_EQ] = ACTIONS(323),
    [anon_sym_SLASH_EQ] = ACTIONS(323),
    [anon_sym_PERCENT_EQ] = ACTIONS(323),
    [anon_sym_CARET_EQ] = ACTIONS(323),
    [anon_sym_AMP_EQ] = ACTIONS(323),
    [anon_sym_PIPE_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_LT_LT_EQ] = ACTIONS(323),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(547),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [73] = {
    [sym_parenthesized_expression] = STATE(322),
    [sym__expression] = STATE(322),
    [sym_yield_expression] = STATE(322),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(322),
    [sym_jsx_fragment] = STATE(322),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(322),
    [sym_anonymous_class] = STATE(322),
    [sym_class] = STATE(322),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(322),
    [sym_generator_function] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_new_expression] = STATE(322),
    [sym_await_expression] = STATE(322),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(322),
    [sym_augmented_assignment_expression] = STATE(322),
    [sym_ternary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_update_expression] = STATE(322),
    [sym_string] = STATE(322),
    [sym_template_string] = STATE(322),
    [sym_regex] = STATE(322),
    [sym_meta_property] = STATE(322),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(567),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(571),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_undefined] = ACTIONS(571),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [74] = {
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [75] = {
    [sym__initializer] = STATE(329),
    [aux_sym_object_repeat1] = STATE(312),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [76] = {
    [sym__initializer] = STATE(201),
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(312),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(588),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(545),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_PLUS_EQ] = ACTIONS(323),
    [anon_sym_DASH_EQ] = ACTIONS(323),
    [anon_sym_STAR_EQ] = ACTIONS(323),
    [anon_sym_SLASH_EQ] = ACTIONS(323),
    [anon_sym_PERCENT_EQ] = ACTIONS(323),
    [anon_sym_CARET_EQ] = ACTIONS(323),
    [anon_sym_AMP_EQ] = ACTIONS(323),
    [anon_sym_PIPE_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_LT_LT_EQ] = ACTIONS(323),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [77] = {
    [sym__initializer] = STATE(330),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [78] = {
    [aux_sym_object_repeat1] = STATE(332),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(591),
    [sym_comment] = ACTIONS(78),
  },
  [79] = {
    [sym__initializer] = STATE(333),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [80] = {
    [sym_formal_parameters] = STATE(335),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_COLON] = ACTIONS(593),
    [sym_comment] = ACTIONS(78),
  },
  [81] = {
    [sym_export_statement] = STATE(338),
    [sym__declaration] = STATE(338),
    [sym_import_statement] = STATE(338),
    [sym_expression_statement] = STATE(338),
    [sym_variable_declaration] = STATE(338),
    [sym_lexical_declaration] = STATE(338),
    [sym_statement_block] = STATE(338),
    [sym_if_statement] = STATE(338),
    [sym_switch_statement] = STATE(338),
    [sym_for_statement] = STATE(338),
    [sym_for_in_statement] = STATE(338),
    [sym_for_of_statement] = STATE(338),
    [sym_while_statement] = STATE(338),
    [sym_do_statement] = STATE(338),
    [sym_try_statement] = STATE(338),
    [sym_with_statement] = STATE(338),
    [sym_break_statement] = STATE(338),
    [sym_continue_statement] = STATE(338),
    [sym_debugger_statement] = STATE(338),
    [sym_return_statement] = STATE(338),
    [sym_throw_statement] = STATE(338),
    [sym_empty_statement] = STATE(338),
    [sym_labeled_statement] = STATE(338),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(338),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [82] = {
    [sym_string] = STATE(342),
    [sym_decorator] = STATE(343),
    [sym_method_definition] = STATE(341),
    [sym__property_name] = STATE(342),
    [sym_computed_property_name] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(343),
    [anon_sym_export] = ACTIONS(599),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_class] = ACTIONS(601),
    [anon_sym_async] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(605),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(607),
    [anon_sym_set] = ACTIONS(607),
  },
  [83] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(591),
    [sym_comment] = ACTIONS(78),
  },
  [84] = {
    [anon_sym_as] = ACTIONS(609),
    [sym_comment] = ACTIONS(78),
  },
  [85] = {
    [sym__import_export_specifier] = STATE(348),
    [anon_sym_COMMA] = ACTIONS(611),
    [anon_sym_RBRACE] = ACTIONS(613),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(477),
  },
  [86] = {
    [anon_sym_COMMA] = ACTIONS(615),
    [anon_sym_from] = ACTIONS(617),
    [sym_comment] = ACTIONS(78),
  },
  [87] = {
    [sym__from_clause] = STATE(350),
    [anon_sym_from] = ACTIONS(447),
    [sym_comment] = ACTIONS(78),
  },
  [88] = {
    [anon_sym_from] = ACTIONS(617),
    [sym_comment] = ACTIONS(78),
  },
  [89] = {
    [sym__automatic_semicolon] = ACTIONS(619),
    [anon_sym_SEMI] = ACTIONS(619),
    [sym_comment] = ACTIONS(78),
  },
  [90] = {
    [sym_object] = STATE(298),
    [sym_assignment_pattern] = STATE(356),
    [sym_array] = STATE(300),
    [sym_spread_element] = STATE(356),
    [sym_string] = STATE(80),
    [sym_decorator] = STATE(357),
    [sym_method_definition] = STATE(356),
    [sym_pair] = STATE(356),
    [sym__property_name] = STATE(80),
    [sym_computed_property_name] = STATE(80),
    [aux_sym_export_statement_repeat1] = STATE(357),
    [aux_sym_object_repeat1] = STATE(358),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_async] = ACTIONS(623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(130),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(509),
    [sym_identifier] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(627),
    [anon_sym_set] = ACTIONS(627),
  },
  [91] = {
    [sym_parenthesized_expression] = STATE(360),
    [sym__expression] = STATE(360),
    [sym_yield_expression] = STATE(360),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(360),
    [sym_jsx_fragment] = STATE(360),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(360),
    [sym_anonymous_class] = STATE(360),
    [sym_class] = STATE(360),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(360),
    [sym_generator_function] = STATE(360),
    [sym_call_expression] = STATE(360),
    [sym_new_expression] = STATE(360),
    [sym_await_expression] = STATE(360),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(360),
    [sym_augmented_assignment_expression] = STATE(360),
    [sym_spread_element] = STATE(361),
    [sym_ternary_expression] = STATE(360),
    [sym_binary_expression] = STATE(360),
    [sym_unary_expression] = STATE(360),
    [sym_update_expression] = STATE(360),
    [sym_string] = STATE(360),
    [sym_template_string] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_meta_property] = STATE(360),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(362),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_RBRACK] = ACTIONS(629),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(631),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(633),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(633),
    [sym_false] = ACTIONS(633),
    [sym_null] = ACTIONS(633),
    [sym_undefined] = ACTIONS(633),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [92] = {
    [sym__initializer] = STATE(363),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [93] = {
    [aux_sym_variable_declaration_repeat1] = STATE(366),
    [sym__automatic_semicolon] = ACTIONS(639),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_SEMI] = ACTIONS(639),
    [sym_comment] = ACTIONS(78),
  },
  [94] = {
    [sym__initializer] = STATE(367),
    [sym__automatic_semicolon] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [95] = {
    [sym__initializer] = STATE(368),
    [sym__automatic_semicolon] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [96] = {
    [aux_sym_variable_declaration_repeat1] = STATE(370),
    [sym__automatic_semicolon] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_SEMI] = ACTIONS(647),
    [sym_comment] = ACTIONS(78),
  },
  [97] = {
    [sym_parenthesized_expression] = STATE(374),
    [sym__expression] = STATE(374),
    [sym_yield_expression] = STATE(374),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(374),
    [sym_jsx_fragment] = STATE(374),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(374),
    [sym_anonymous_class] = STATE(374),
    [sym_class] = STATE(374),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(374),
    [sym_generator_function] = STATE(374),
    [sym_call_expression] = STATE(374),
    [sym_new_expression] = STATE(374),
    [sym_await_expression] = STATE(374),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(374),
    [sym_augmented_assignment_expression] = STATE(374),
    [sym_ternary_expression] = STATE(374),
    [sym_binary_expression] = STATE(374),
    [sym_unary_expression] = STATE(374),
    [sym_update_expression] = STATE(374),
    [sym_sequence_expression] = STATE(377),
    [sym_string] = STATE(374),
    [sym_template_string] = STATE(374),
    [sym_regex] = STATE(374),
    [sym_meta_property] = STATE(374),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(651),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(655),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_null] = ACTIONS(655),
    [sym_undefined] = ACTIONS(655),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [98] = {
    [sym_export_statement] = STATE(383),
    [sym__declaration] = STATE(383),
    [sym_import_statement] = STATE(383),
    [sym_expression_statement] = STATE(383),
    [sym_variable_declaration] = STATE(383),
    [sym_lexical_declaration] = STATE(383),
    [sym_statement_block] = STATE(383),
    [sym_if_statement] = STATE(383),
    [sym_switch_statement] = STATE(383),
    [sym_for_statement] = STATE(383),
    [sym_for_in_statement] = STATE(383),
    [sym_for_of_statement] = STATE(383),
    [sym_while_statement] = STATE(383),
    [sym_do_statement] = STATE(383),
    [sym_try_statement] = STATE(383),
    [sym_with_statement] = STATE(383),
    [sym_break_statement] = STATE(383),
    [sym_continue_statement] = STATE(383),
    [sym_debugger_statement] = STATE(383),
    [sym_return_statement] = STATE(383),
    [sym_throw_statement] = STATE(383),
    [sym_empty_statement] = STATE(383),
    [sym_labeled_statement] = STATE(383),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [99] = {
    [sym_switch_body] = STATE(385),
    [anon_sym_LBRACE] = ACTIONS(669),
    [sym_comment] = ACTIONS(78),
  },
  [100] = {
    [sym_expression_statement] = STATE(389),
    [sym_variable_declaration] = STATE(389),
    [sym_lexical_declaration] = STATE(389),
    [sym_empty_statement] = STATE(389),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(390),
    [sym_array] = STATE(391),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_var] = ACTIONS(671),
    [anon_sym_let] = ACTIONS(673),
    [anon_sym_const] = ACTIONS(673),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(675),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [101] = {
    [anon_sym_LPAREN] = ACTIONS(677),
    [sym_comment] = ACTIONS(78),
  },
  [102] = {
    [sym_object] = STATE(298),
    [sym_assignment_pattern] = STATE(397),
    [sym_array] = STATE(300),
    [sym_spread_element] = STATE(397),
    [sym_string] = STATE(80),
    [sym_decorator] = STATE(398),
    [sym_method_definition] = STATE(397),
    [sym_pair] = STATE(397),
    [sym__property_name] = STATE(80),
    [sym_computed_property_name] = STATE(80),
    [aux_sym_export_statement_repeat1] = STATE(398),
    [aux_sym_object_repeat1] = STATE(399),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_async] = ACTIONS(681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(130),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(509),
    [sym_identifier] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(685),
    [anon_sym_set] = ACTIONS(685),
  },
  [103] = {
    [sym_parenthesized_expression] = STATE(400),
    [sym__expression] = STATE(400),
    [sym_yield_expression] = STATE(400),
    [sym_object] = STATE(125),
    [sym_assignment_pattern] = STATE(126),
    [sym_array] = STATE(127),
    [sym_jsx_element] = STATE(400),
    [sym_jsx_fragment] = STATE(400),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(400),
    [sym_anonymous_class] = STATE(400),
    [sym_class] = STATE(400),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(400),
    [sym_generator_function] = STATE(400),
    [sym_call_expression] = STATE(400),
    [sym_new_expression] = STATE(400),
    [sym_await_expression] = STATE(400),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(400),
    [sym_augmented_assignment_expression] = STATE(400),
    [sym_ternary_expression] = STATE(400),
    [sym_binary_expression] = STATE(400),
    [sym_unary_expression] = STATE(400),
    [sym_update_expression] = STATE(400),
    [sym_sequence_expression] = STATE(401),
    [sym_string] = STATE(400),
    [sym_template_string] = STATE(400),
    [sym_regex] = STATE(400),
    [sym_meta_property] = STATE(400),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [sym_rest_parameter] = STATE(126),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(160),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(174),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(182),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(687),
    [sym_identifier] = ACTIONS(198),
    [sym_this] = ACTIONS(689),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(689),
    [sym_false] = ACTIONS(689),
    [sym_null] = ACTIONS(689),
    [sym_undefined] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(204),
    [anon_sym_set] = ACTIONS(204),
  },
  [104] = {
    [anon_sym_LBRACE] = ACTIONS(691),
    [anon_sym_EQ_GT] = ACTIONS(691),
    [sym_comment] = ACTIONS(78),
  },
  [105] = {
    [sym_parenthesized_expression] = STATE(402),
    [sym__expression] = STATE(402),
    [sym_yield_expression] = STATE(402),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(402),
    [sym_jsx_fragment] = STATE(402),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(402),
    [sym_anonymous_class] = STATE(402),
    [sym_class] = STATE(402),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(402),
    [sym_generator_function] = STATE(402),
    [sym_call_expression] = STATE(402),
    [sym_new_expression] = STATE(402),
    [sym_await_expression] = STATE(402),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(402),
    [sym_augmented_assignment_expression] = STATE(402),
    [sym_ternary_expression] = STATE(402),
    [sym_binary_expression] = STATE(402),
    [sym_unary_expression] = STATE(402),
    [sym_update_expression] = STATE(402),
    [sym_string] = STATE(402),
    [sym_template_string] = STATE(402),
    [sym_regex] = STATE(402),
    [sym_meta_property] = STATE(402),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(693),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(695),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(695),
    [sym_false] = ACTIONS(695),
    [sym_null] = ACTIONS(695),
    [sym_undefined] = ACTIONS(695),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [106] = {
    [sym_parenthesized_expression] = STATE(403),
    [sym__expression] = STATE(403),
    [sym_yield_expression] = STATE(403),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(403),
    [sym_jsx_fragment] = STATE(403),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(403),
    [sym_anonymous_class] = STATE(403),
    [sym_class] = STATE(403),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(403),
    [sym_generator_function] = STATE(403),
    [sym_call_expression] = STATE(403),
    [sym_new_expression] = STATE(403),
    [sym_await_expression] = STATE(403),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(403),
    [sym_augmented_assignment_expression] = STATE(403),
    [sym_ternary_expression] = STATE(403),
    [sym_binary_expression] = STATE(403),
    [sym_unary_expression] = STATE(403),
    [sym_update_expression] = STATE(403),
    [sym_string] = STATE(403),
    [sym_template_string] = STATE(403),
    [sym_regex] = STATE(403),
    [sym_meta_property] = STATE(403),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(184),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(699),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(701),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(701),
    [sym_false] = ACTIONS(701),
    [sym_null] = ACTIONS(701),
    [sym_undefined] = ACTIONS(701),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [107] = {
    [sym_parenthesized_expression] = STATE(405),
    [sym__expression] = STATE(405),
    [sym_yield_expression] = STATE(405),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(405),
    [sym_jsx_fragment] = STATE(405),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(405),
    [sym_anonymous_class] = STATE(405),
    [sym_class] = STATE(405),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(405),
    [sym_generator_function] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_new_expression] = STATE(405),
    [sym_await_expression] = STATE(405),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(405),
    [sym_augmented_assignment_expression] = STATE(405),
    [sym_spread_element] = STATE(406),
    [sym_ternary_expression] = STATE(405),
    [sym_binary_expression] = STATE(405),
    [sym_unary_expression] = STATE(405),
    [sym_update_expression] = STATE(405),
    [sym_string] = STATE(405),
    [sym_template_string] = STATE(405),
    [sym_regex] = STATE(405),
    [sym_meta_property] = STATE(405),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(407),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_RBRACK] = ACTIONS(703),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(705),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(707),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(707),
    [sym_false] = ACTIONS(707),
    [sym_null] = ACTIONS(707),
    [sym_undefined] = ACTIONS(707),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [108] = {
    [sym_nested_identifier] = STATE(411),
    [sym_jsx_namespace_name] = STATE(412),
    [anon_sym_GT] = ACTIONS(709),
    [sym_jsx_identifier] = ACTIONS(711),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(713),
  },
  [109] = {
    [sym_comment] = ACTIONS(298),
    [sym_regex_pattern] = ACTIONS(715),
  },
  [110] = {
    [sym_class_heritage] = STATE(416),
    [sym_class_body] = STATE(417),
    [anon_sym_LBRACE] = ACTIONS(717),
    [anon_sym_extends] = ACTIONS(304),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(719),
  },
  [111] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(425),
    [aux_sym_formal_parameters_repeat1] = STATE(427),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(724),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(735),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(737),
  },
  [112] = {
    [sym_formal_parameters] = STATE(430),
    [anon_sym_STAR] = ACTIONS(739),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(741),
  },
  [113] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(433),
    [sym__expression] = STATE(433),
    [sym_yield_expression] = STATE(433),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(433),
    [sym_jsx_fragment] = STATE(433),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(433),
    [sym_anonymous_class] = STATE(433),
    [sym_class] = STATE(433),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(433),
    [sym_generator_function] = STATE(433),
    [sym_call_expression] = STATE(433),
    [sym_new_expression] = STATE(433),
    [sym_await_expression] = STATE(433),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(433),
    [sym_augmented_assignment_expression] = STATE(433),
    [sym_ternary_expression] = STATE(433),
    [sym_binary_expression] = STATE(433),
    [sym_unary_expression] = STATE(433),
    [sym_update_expression] = STATE(433),
    [sym_string] = STATE(433),
    [sym_template_string] = STATE(433),
    [sym_regex] = STATE(433),
    [sym_meta_property] = STATE(433),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(745),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(747),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(747),
    [sym_false] = ACTIONS(747),
    [sym_null] = ACTIONS(747),
    [sym_undefined] = ACTIONS(747),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [114] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(751),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(755),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [115] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(761),
  },
  [116] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [117] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [118] = {
    [aux_sym_string_repeat1] = STATE(448),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(773),
    [sym_escape_sequence] = ACTIONS(773),
    [sym_comment] = ACTIONS(298),
  },
  [119] = {
    [aux_sym_string_repeat2] = STATE(449),
    [anon_sym_SQUOTE] = ACTIONS(771),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(775),
    [sym_escape_sequence] = ACTIONS(775),
    [sym_comment] = ACTIONS(298),
  },
  [120] = {
    [sym_template_substitution] = STATE(451),
    [aux_sym_template_string_repeat1] = STATE(451),
    [sym__template_chars] = ACTIONS(777),
    [sym_escape_sequence] = ACTIONS(777),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(779),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(381),
  },
  [121] = {
    [sym__initializer] = STATE(456),
    [aux_sym_formal_parameters_repeat1] = STATE(457),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(781),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(784),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_PLUS_EQ] = ACTIONS(791),
    [anon_sym_DASH_EQ] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(791),
    [anon_sym_SLASH_EQ] = ACTIONS(791),
    [anon_sym_PERCENT_EQ] = ACTIONS(791),
    [anon_sym_CARET_EQ] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [122] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_DOT] = ACTIONS(789),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [123] = {
    [sym__initializer] = STATE(426),
    [aux_sym_formal_parameters_repeat1] = STATE(427),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(724),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(735),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [124] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(801),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [125] = {
    [sym__initializer] = STATE(470),
    [aux_sym_formal_parameters_repeat1] = STATE(471),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(781),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(821),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [126] = {
    [aux_sym_formal_parameters_repeat1] = STATE(457),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(826),
    [sym_comment] = ACTIONS(78),
  },
  [127] = {
    [sym__initializer] = STATE(473),
    [aux_sym_formal_parameters_repeat1] = STATE(474),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(781),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(828),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [128] = {
    [sym_jsx_element] = STATE(477),
    [sym_jsx_expression] = STATE(477),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_closing_element] = STATE(476),
    [sym_jsx_self_closing_element] = STATE(477),
    [aux_sym_jsx_element_repeat1] = STATE(477),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(831),
    [sym_jsx_text] = ACTIONS(833),
    [sym_comment] = ACTIONS(78),
  },
  [129] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [130] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_PLUS_EQ] = ACTIONS(791),
    [anon_sym_DASH_EQ] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(791),
    [anon_sym_SLASH_EQ] = ACTIONS(791),
    [anon_sym_PERCENT_EQ] = ACTIONS(791),
    [anon_sym_CARET_EQ] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [131] = {
    [anon_sym_RPAREN] = ACTIONS(801),
    [sym_comment] = ACTIONS(78),
  },
  [132] = {
    [anon_sym_EQ_GT] = ACTIONS(733),
    [sym_comment] = ACTIONS(78),
  },
  [133] = {
    [sym_decorator] = STATE(289),
    [aux_sym_export_statement_repeat1] = STATE(289),
    [anon_sym_class] = ACTIONS(835),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [134] = {
    [sym_object] = STATE(298),
    [sym_assignment_pattern] = STATE(78),
    [sym_array] = STATE(300),
    [sym_spread_element] = STATE(78),
    [sym_string] = STATE(80),
    [sym_decorator] = STATE(484),
    [sym_method_definition] = STATE(78),
    [sym_pair] = STATE(78),
    [sym__property_name] = STATE(80),
    [sym_computed_property_name] = STATE(80),
    [aux_sym_export_statement_repeat1] = STATE(484),
    [aux_sym_object_repeat1] = STATE(83),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_async] = ACTIONS(839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(130),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(509),
    [sym_identifier] = ACTIONS(841),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(843),
    [anon_sym_set] = ACTIONS(843),
  },
  [135] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [136] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [137] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [138] = {
    [sym_decorator] = STATE(289),
    [aux_sym_export_statement_repeat1] = STATE(289),
    [anon_sym_class] = ACTIONS(443),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [139] = {
    [sym_export_statement] = STATE(485),
    [sym__declaration] = STATE(485),
    [sym_import_statement] = STATE(485),
    [sym_expression_statement] = STATE(485),
    [sym_variable_declaration] = STATE(485),
    [sym_lexical_declaration] = STATE(485),
    [sym_statement_block] = STATE(485),
    [sym_if_statement] = STATE(485),
    [sym_switch_statement] = STATE(485),
    [sym_for_statement] = STATE(485),
    [sym_for_in_statement] = STATE(485),
    [sym_for_of_statement] = STATE(485),
    [sym_while_statement] = STATE(485),
    [sym_do_statement] = STATE(485),
    [sym_try_statement] = STATE(485),
    [sym_with_statement] = STATE(485),
    [sym_break_statement] = STATE(485),
    [sym_continue_statement] = STATE(485),
    [sym_debugger_statement] = STATE(485),
    [sym_return_statement] = STATE(485),
    [sym_throw_statement] = STATE(485),
    [sym_empty_statement] = STATE(485),
    [sym_labeled_statement] = STATE(485),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [140] = {
    [sym_export_clause] = STATE(60),
    [sym__declaration] = STATE(61),
    [sym_variable_declaration] = STATE(61),
    [sym_lexical_declaration] = STATE(61),
    [sym_class] = STATE(62),
    [sym_function] = STATE(62),
    [sym_generator_function] = STATE(62),
    [sym_decorator] = STATE(488),
    [aux_sym_export_statement_repeat1] = STATE(488),
    [anon_sym_STAR] = ACTIONS(96),
    [anon_sym_default] = ACTIONS(98),
    [anon_sym_LBRACE] = ACTIONS(100),
    [anon_sym_var] = ACTIONS(102),
    [anon_sym_let] = ACTIONS(104),
    [anon_sym_const] = ACTIONS(104),
    [anon_sym_class] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(849),
    [anon_sym_function] = ACTIONS(851),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [141] = {
    [sym_parenthesized_expression] = STATE(489),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [142] = {
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_await] = ACTIONS(855),
    [sym_comment] = ACTIONS(78),
  },
  [143] = {
    [sym_parenthesized_expression] = STATE(492),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [144] = {
    [sym_parenthesized_expression] = STATE(493),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [145] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [146] = {
    [anon_sym_while] = ACTIONS(859),
    [sym_comment] = ACTIONS(78),
  },
  [147] = {
    [sym__automatic_semicolon] = ACTIONS(435),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_else] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [148] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(435),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_else] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [149] = {
    [sym_decorator] = STATE(261),
    [aux_sym_export_statement_repeat1] = STATE(261),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_class] = ACTIONS(443),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [150] = {
    [sym_export_statement] = STATE(81),
    [sym__declaration] = STATE(81),
    [sym_import_statement] = STATE(81),
    [sym_expression_statement] = STATE(81),
    [sym_variable_declaration] = STATE(81),
    [sym_lexical_declaration] = STATE(81),
    [sym_statement_block] = STATE(81),
    [sym_if_statement] = STATE(81),
    [sym_switch_statement] = STATE(81),
    [sym_for_statement] = STATE(81),
    [sym_for_in_statement] = STATE(81),
    [sym_for_of_statement] = STATE(81),
    [sym_while_statement] = STATE(81),
    [sym_do_statement] = STATE(81),
    [sym_try_statement] = STATE(81),
    [sym_with_statement] = STATE(81),
    [sym_break_statement] = STATE(81),
    [sym_continue_statement] = STATE(81),
    [sym_debugger_statement] = STATE(81),
    [sym_return_statement] = STATE(81),
    [sym_throw_statement] = STATE(81),
    [sym_empty_statement] = STATE(81),
    [sym_labeled_statement] = STATE(81),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(81),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [151] = {
    [sym_catch_clause] = STATE(500),
    [sym_finally_clause] = STATE(501),
    [ts_builtin_sym_end] = ACTIONS(865),
    [anon_sym_export] = ACTIONS(867),
    [anon_sym_default] = ACTIONS(867),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_import] = ACTIONS(867),
    [anon_sym_var] = ACTIONS(867),
    [anon_sym_let] = ACTIONS(867),
    [anon_sym_const] = ACTIONS(867),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_else] = ACTIONS(867),
    [anon_sym_switch] = ACTIONS(867),
    [anon_sym_for] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_await] = ACTIONS(867),
    [anon_sym_while] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(867),
    [anon_sym_try] = ACTIONS(867),
    [anon_sym_with] = ACTIONS(867),
    [anon_sym_break] = ACTIONS(867),
    [anon_sym_continue] = ACTIONS(867),
    [anon_sym_debugger] = ACTIONS(867),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_throw] = ACTIONS(867),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_case] = ACTIONS(867),
    [anon_sym_catch] = ACTIONS(869),
    [anon_sym_finally] = ACTIONS(871),
    [anon_sym_yield] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(865),
    [anon_sym_LT] = ACTIONS(865),
    [anon_sym_SLASH] = ACTIONS(867),
    [anon_sym_class] = ACTIONS(867),
    [anon_sym_async] = ACTIONS(867),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_EQ_GT] = ACTIONS(865),
    [anon_sym_new] = ACTIONS(867),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_typeof] = ACTIONS(867),
    [anon_sym_void] = ACTIONS(867),
    [anon_sym_delete] = ACTIONS(867),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(865),
    [anon_sym_SQUOTE] = ACTIONS(865),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(865),
    [sym_number] = ACTIONS(865),
    [sym_identifier] = ACTIONS(867),
    [sym_this] = ACTIONS(867),
    [sym_super] = ACTIONS(867),
    [sym_true] = ACTIONS(867),
    [sym_false] = ACTIONS(867),
    [sym_null] = ACTIONS(867),
    [sym_undefined] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_get] = ACTIONS(867),
    [anon_sym_set] = ACTIONS(867),
  },
  [152] = {
    [sym_export_statement] = STATE(502),
    [sym__declaration] = STATE(502),
    [sym_import_statement] = STATE(502),
    [sym_expression_statement] = STATE(502),
    [sym_variable_declaration] = STATE(502),
    [sym_lexical_declaration] = STATE(502),
    [sym_statement_block] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_switch_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_for_in_statement] = STATE(502),
    [sym_for_of_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_do_statement] = STATE(502),
    [sym_try_statement] = STATE(502),
    [sym_with_statement] = STATE(502),
    [sym_break_statement] = STATE(502),
    [sym_continue_statement] = STATE(502),
    [sym_debugger_statement] = STATE(502),
    [sym_return_statement] = STATE(502),
    [sym_throw_statement] = STATE(502),
    [sym_empty_statement] = STATE(502),
    [sym_labeled_statement] = STATE(502),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(873),
    [anon_sym_export] = ACTIONS(875),
    [anon_sym_default] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_import] = ACTIONS(875),
    [anon_sym_var] = ACTIONS(875),
    [anon_sym_let] = ACTIONS(875),
    [anon_sym_const] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(875),
    [anon_sym_switch] = ACTIONS(875),
    [anon_sym_for] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_await] = ACTIONS(875),
    [anon_sym_while] = ACTIONS(875),
    [anon_sym_do] = ACTIONS(875),
    [anon_sym_try] = ACTIONS(875),
    [anon_sym_with] = ACTIONS(875),
    [anon_sym_break] = ACTIONS(875),
    [anon_sym_continue] = ACTIONS(875),
    [anon_sym_debugger] = ACTIONS(875),
    [anon_sym_return] = ACTIONS(875),
    [anon_sym_throw] = ACTIONS(875),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_case] = ACTIONS(875),
    [anon_sym_yield] = ACTIONS(875),
    [anon_sym_LBRACK] = ACTIONS(873),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_SLASH] = ACTIONS(875),
    [anon_sym_class] = ACTIONS(875),
    [anon_sym_async] = ACTIONS(875),
    [anon_sym_function] = ACTIONS(875),
    [anon_sym_EQ_GT] = ACTIONS(873),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_BANG] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_typeof] = ACTIONS(875),
    [anon_sym_void] = ACTIONS(875),
    [anon_sym_delete] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(873),
    [anon_sym_DASH_DASH] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(873),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(873),
    [sym_number] = ACTIONS(873),
    [sym_identifier] = ACTIONS(875),
    [sym_this] = ACTIONS(875),
    [sym_super] = ACTIONS(875),
    [sym_true] = ACTIONS(875),
    [sym_false] = ACTIONS(875),
    [sym_null] = ACTIONS(875),
    [sym_undefined] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(873),
    [anon_sym_get] = ACTIONS(875),
    [anon_sym_set] = ACTIONS(875),
  },
  [154] = {
    [sym__automatic_semicolon] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(877),
    [sym_comment] = ACTIONS(78),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(879),
    [anon_sym_export] = ACTIONS(881),
    [anon_sym_default] = ACTIONS(881),
    [anon_sym_LBRACE] = ACTIONS(879),
    [anon_sym_RBRACE] = ACTIONS(879),
    [anon_sym_import] = ACTIONS(881),
    [anon_sym_var] = ACTIONS(881),
    [anon_sym_let] = ACTIONS(881),
    [anon_sym_const] = ACTIONS(881),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_else] = ACTIONS(881),
    [anon_sym_switch] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(881),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_await] = ACTIONS(881),
    [anon_sym_while] = ACTIONS(881),
    [anon_sym_do] = ACTIONS(881),
    [anon_sym_try] = ACTIONS(881),
    [anon_sym_with] = ACTIONS(881),
    [anon_sym_break] = ACTIONS(881),
    [anon_sym_continue] = ACTIONS(881),
    [anon_sym_debugger] = ACTIONS(881),
    [anon_sym_return] = ACTIONS(881),
    [anon_sym_throw] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_case] = ACTIONS(881),
    [anon_sym_yield] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_SLASH] = ACTIONS(881),
    [anon_sym_class] = ACTIONS(881),
    [anon_sym_async] = ACTIONS(881),
    [anon_sym_function] = ACTIONS(881),
    [anon_sym_EQ_GT] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(881),
    [anon_sym_BANG] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(879),
    [anon_sym_typeof] = ACTIONS(881),
    [anon_sym_void] = ACTIONS(881),
    [anon_sym_delete] = ACTIONS(881),
    [anon_sym_PLUS_PLUS] = ACTIONS(879),
    [anon_sym_DASH_DASH] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_SQUOTE] = ACTIONS(879),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [sym_number] = ACTIONS(879),
    [sym_identifier] = ACTIONS(881),
    [sym_this] = ACTIONS(881),
    [sym_super] = ACTIONS(881),
    [sym_true] = ACTIONS(881),
    [sym_false] = ACTIONS(881),
    [sym_null] = ACTIONS(881),
    [sym_undefined] = ACTIONS(881),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
  },
  [156] = {
    [sym__automatic_semicolon] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(883),
    [sym_comment] = ACTIONS(78),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(885),
    [anon_sym_export] = ACTIONS(887),
    [anon_sym_default] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(885),
    [anon_sym_RBRACE] = ACTIONS(885),
    [anon_sym_import] = ACTIONS(887),
    [anon_sym_var] = ACTIONS(887),
    [anon_sym_let] = ACTIONS(887),
    [anon_sym_const] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_switch] = ACTIONS(887),
    [anon_sym_for] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_await] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_try] = ACTIONS(887),
    [anon_sym_with] = ACTIONS(887),
    [anon_sym_break] = ACTIONS(887),
    [anon_sym_continue] = ACTIONS(887),
    [anon_sym_debugger] = ACTIONS(887),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_throw] = ACTIONS(887),
    [anon_sym_SEMI] = ACTIONS(885),
    [anon_sym_case] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(885),
    [anon_sym_LT] = ACTIONS(885),
    [anon_sym_SLASH] = ACTIONS(887),
    [anon_sym_class] = ACTIONS(887),
    [anon_sym_async] = ACTIONS(887),
    [anon_sym_function] = ACTIONS(887),
    [anon_sym_EQ_GT] = ACTIONS(885),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_typeof] = ACTIONS(887),
    [anon_sym_void] = ACTIONS(887),
    [anon_sym_delete] = ACTIONS(887),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_DQUOTE] = ACTIONS(885),
    [anon_sym_SQUOTE] = ACTIONS(885),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(885),
    [sym_number] = ACTIONS(885),
    [sym_identifier] = ACTIONS(887),
    [sym_this] = ACTIONS(887),
    [sym_super] = ACTIONS(887),
    [sym_true] = ACTIONS(887),
    [sym_false] = ACTIONS(887),
    [sym_null] = ACTIONS(887),
    [sym_undefined] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(885),
    [anon_sym_get] = ACTIONS(887),
    [anon_sym_set] = ACTIONS(887),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(891),
    [anon_sym_default] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(889),
    [anon_sym_import] = ACTIONS(891),
    [anon_sym_var] = ACTIONS(891),
    [anon_sym_let] = ACTIONS(891),
    [anon_sym_const] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_switch] = ACTIONS(891),
    [anon_sym_for] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(889),
    [anon_sym_await] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(891),
    [anon_sym_with] = ACTIONS(891),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_continue] = ACTIONS(891),
    [anon_sym_debugger] = ACTIONS(891),
    [anon_sym_return] = ACTIONS(891),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_case] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(889),
    [anon_sym_LT] = ACTIONS(889),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(891),
    [anon_sym_async] = ACTIONS(891),
    [anon_sym_function] = ACTIONS(891),
    [anon_sym_EQ_GT] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_void] = ACTIONS(891),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(889),
    [anon_sym_DASH_DASH] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(889),
    [anon_sym_SQUOTE] = ACTIONS(889),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(889),
    [sym_number] = ACTIONS(889),
    [sym_identifier] = ACTIONS(891),
    [sym_this] = ACTIONS(891),
    [sym_super] = ACTIONS(891),
    [sym_true] = ACTIONS(891),
    [sym_false] = ACTIONS(891),
    [sym_null] = ACTIONS(891),
    [sym_undefined] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(891),
    [anon_sym_set] = ACTIONS(891),
  },
  [159] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [160] = {
    [sym__automatic_semicolon] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(893),
    [sym_comment] = ACTIONS(78),
  },
  [161] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(895),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [162] = {
    [sym__automatic_semicolon] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(895),
    [sym_comment] = ACTIONS(78),
  },
  [163] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(897),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [164] = {
    [sym_parenthesized_expression] = STATE(507),
    [sym__expression] = STATE(507),
    [sym_yield_expression] = STATE(507),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(507),
    [sym_jsx_fragment] = STATE(507),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(507),
    [sym_anonymous_class] = STATE(507),
    [sym_class] = STATE(507),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(507),
    [sym_generator_function] = STATE(507),
    [sym_call_expression] = STATE(507),
    [sym_new_expression] = STATE(507),
    [sym_await_expression] = STATE(507),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(507),
    [sym_augmented_assignment_expression] = STATE(507),
    [sym_spread_element] = STATE(508),
    [sym_ternary_expression] = STATE(507),
    [sym_binary_expression] = STATE(507),
    [sym_unary_expression] = STATE(507),
    [sym_update_expression] = STATE(507),
    [sym_string] = STATE(507),
    [sym_template_string] = STATE(507),
    [sym_regex] = STATE(507),
    [sym_meta_property] = STATE(507),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_RBRACK] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(901),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(903),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(903),
    [sym_false] = ACTIONS(903),
    [sym_null] = ACTIONS(903),
    [sym_undefined] = ACTIONS(903),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [165] = {
    [sym_parenthesized_expression] = STATE(509),
    [sym__expression] = STATE(509),
    [sym_yield_expression] = STATE(509),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(509),
    [sym_jsx_fragment] = STATE(509),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(509),
    [sym_anonymous_class] = STATE(509),
    [sym_class] = STATE(509),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(509),
    [sym_generator_function] = STATE(509),
    [sym_call_expression] = STATE(509),
    [sym_new_expression] = STATE(509),
    [sym_await_expression] = STATE(509),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(509),
    [sym_augmented_assignment_expression] = STATE(509),
    [sym_ternary_expression] = STATE(509),
    [sym_binary_expression] = STATE(509),
    [sym_unary_expression] = STATE(509),
    [sym_update_expression] = STATE(509),
    [sym_string] = STATE(509),
    [sym_template_string] = STATE(509),
    [sym_regex] = STATE(509),
    [sym_meta_property] = STATE(509),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(905),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(907),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(907),
    [sym_false] = ACTIONS(907),
    [sym_null] = ACTIONS(907),
    [sym_undefined] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [166] = {
    [sym_parenthesized_expression] = STATE(510),
    [sym__expression] = STATE(510),
    [sym_yield_expression] = STATE(510),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(510),
    [sym_jsx_fragment] = STATE(510),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(510),
    [sym_anonymous_class] = STATE(510),
    [sym_class] = STATE(510),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(510),
    [sym_generator_function] = STATE(510),
    [sym_call_expression] = STATE(510),
    [sym_new_expression] = STATE(510),
    [sym_await_expression] = STATE(510),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(510),
    [sym_augmented_assignment_expression] = STATE(510),
    [sym_ternary_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_string] = STATE(510),
    [sym_template_string] = STATE(510),
    [sym_regex] = STATE(510),
    [sym_meta_property] = STATE(510),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_RBRACK] = ACTIONS(252),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(278),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(909),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(911),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(911),
    [sym_false] = ACTIONS(911),
    [sym_null] = ACTIONS(911),
    [sym_undefined] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [167] = {
    [sym__automatic_semicolon] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_of] = ACTIONS(913),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_GT_GT_GT] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(913),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_EQ_EQ] = ACTIONS(915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(915),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(913),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_instanceof] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(913),
    [anon_sym_DASH_DASH] = ACTIONS(913),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(913),
  },
  [168] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(514),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_RBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_PLUS_EQ] = ACTIONS(921),
    [anon_sym_DASH_EQ] = ACTIONS(921),
    [anon_sym_STAR_EQ] = ACTIONS(921),
    [anon_sym_SLASH_EQ] = ACTIONS(921),
    [anon_sym_PERCENT_EQ] = ACTIONS(921),
    [anon_sym_CARET_EQ] = ACTIONS(921),
    [anon_sym_AMP_EQ] = ACTIONS(921),
    [anon_sym_PIPE_EQ] = ACTIONS(921),
    [anon_sym_GT_GT_EQ] = ACTIONS(921),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT_EQ] = ACTIONS(921),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(923),
  },
  [169] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(515),
    [sym__expression] = STATE(515),
    [sym_yield_expression] = STATE(515),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(515),
    [sym_jsx_fragment] = STATE(515),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(515),
    [sym_anonymous_class] = STATE(515),
    [sym_class] = STATE(515),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(515),
    [sym_generator_function] = STATE(515),
    [sym_call_expression] = STATE(515),
    [sym_new_expression] = STATE(515),
    [sym_await_expression] = STATE(515),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(515),
    [sym_augmented_assignment_expression] = STATE(515),
    [sym_ternary_expression] = STATE(515),
    [sym_binary_expression] = STATE(515),
    [sym_unary_expression] = STATE(515),
    [sym_update_expression] = STATE(515),
    [sym_string] = STATE(515),
    [sym_template_string] = STATE(515),
    [sym_regex] = STATE(515),
    [sym_meta_property] = STATE(515),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(925),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(927),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_null] = ACTIONS(927),
    [sym_undefined] = ACTIONS(927),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [170] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(931),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [171] = {
    [sym_parenthesized_expression] = STATE(518),
    [sym__expression] = STATE(518),
    [sym_yield_expression] = STATE(518),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(518),
    [sym_jsx_fragment] = STATE(518),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(518),
    [sym_anonymous_class] = STATE(518),
    [sym_class] = STATE(518),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(518),
    [sym_generator_function] = STATE(518),
    [sym_call_expression] = STATE(518),
    [sym_new_expression] = STATE(518),
    [sym_await_expression] = STATE(518),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(518),
    [sym_augmented_assignment_expression] = STATE(518),
    [sym_ternary_expression] = STATE(518),
    [sym_binary_expression] = STATE(518),
    [sym_unary_expression] = STATE(518),
    [sym_update_expression] = STATE(518),
    [sym_string] = STATE(518),
    [sym_template_string] = STATE(518),
    [sym_regex] = STATE(518),
    [sym_meta_property] = STATE(518),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(933),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(935),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(935),
    [sym_false] = ACTIONS(935),
    [sym_null] = ACTIONS(935),
    [sym_undefined] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [172] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [173] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [174] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [175] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_RBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_PLUS_EQ] = ACTIONS(921),
    [anon_sym_DASH_EQ] = ACTIONS(921),
    [anon_sym_STAR_EQ] = ACTIONS(921),
    [anon_sym_SLASH_EQ] = ACTIONS(921),
    [anon_sym_PERCENT_EQ] = ACTIONS(921),
    [anon_sym_CARET_EQ] = ACTIONS(921),
    [anon_sym_AMP_EQ] = ACTIONS(921),
    [anon_sym_PIPE_EQ] = ACTIONS(921),
    [anon_sym_GT_GT_EQ] = ACTIONS(921),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(921),
    [anon_sym_LT_LT_EQ] = ACTIONS(921),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [176] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [aux_sym_array_repeat1] = STATE(527),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(943),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [177] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [178] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [179] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(917),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [180] = {
    [aux_sym_array_repeat1] = STATE(527),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(943),
    [sym_comment] = ACTIONS(78),
  },
  [181] = {
    [anon_sym_EQ_GT] = ACTIONS(919),
    [sym_comment] = ACTIONS(78),
  },
  [182] = {
    [aux_sym_array_repeat1] = STATE(530),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(943),
    [sym_comment] = ACTIONS(78),
  },
  [183] = {
    [sym_jsx_element] = STATE(532),
    [sym_jsx_expression] = STATE(532),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_self_closing_element] = STATE(532),
    [aux_sym_jsx_element_repeat1] = STATE(532),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(961),
    [sym_jsx_text] = ACTIONS(963),
    [sym_comment] = ACTIONS(78),
  },
  [184] = {
    [sym_jsx_expression] = STATE(539),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(539),
    [aux_sym_jsx_opening_element_repeat1] = STATE(539),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(971),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [185] = {
    [sym_jsx_expression] = STATE(539),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(539),
    [aux_sym_jsx_opening_element_repeat1] = STATE(539),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(971),
    [sym_jsx_identifier] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [186] = {
    [sym_jsx_expression] = STATE(539),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(539),
    [aux_sym_jsx_opening_element_repeat1] = STATE(539),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(971),
    [sym_jsx_identifier] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [187] = {
    [sym_jsx_expression] = STATE(539),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(539),
    [aux_sym_jsx_opening_element_repeat1] = STATE(539),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(971),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [188] = {
    [sym_comment] = ACTIONS(78),
    [anon_sym_SLASH2] = ACTIONS(979),
  },
  [189] = {
    [sym_string] = STATE(552),
    [sym_decorator] = STATE(553),
    [sym_public_field_definition] = STATE(550),
    [sym_method_definition] = STATE(551),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [aux_sym_export_statement_repeat1] = STATE(553),
    [aux_sym_class_body_repeat1] = STATE(554),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
  },
  [190] = {
    [sym_parenthesized_expression] = STATE(564),
    [sym__expression] = STATE(564),
    [sym_yield_expression] = STATE(564),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(564),
    [sym_jsx_fragment] = STATE(564),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(564),
    [sym_anonymous_class] = STATE(564),
    [sym_class] = STATE(564),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(564),
    [sym_generator_function] = STATE(564),
    [sym_call_expression] = STATE(564),
    [sym_new_expression] = STATE(564),
    [sym_await_expression] = STATE(564),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(564),
    [sym_augmented_assignment_expression] = STATE(564),
    [sym_ternary_expression] = STATE(564),
    [sym_binary_expression] = STATE(564),
    [sym_unary_expression] = STATE(564),
    [sym_update_expression] = STATE(564),
    [sym_string] = STATE(564),
    [sym_template_string] = STATE(564),
    [sym_regex] = STATE(564),
    [sym_meta_property] = STATE(564),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1015),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(1019),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1019),
    [sym_false] = ACTIONS(1019),
    [sym_null] = ACTIONS(1019),
    [sym_undefined] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [191] = {
    [sym_class_heritage] = STATE(569),
    [sym_class_body] = STATE(570),
    [anon_sym_LBRACE] = ACTIONS(302),
    [anon_sym_extends] = ACTIONS(1023),
    [sym_comment] = ACTIONS(78),
  },
  [192] = {
    [sym_class_body] = STATE(571),
    [anon_sym_LBRACE] = ACTIONS(302),
    [sym_comment] = ACTIONS(78),
  },
  [193] = {
    [sym__automatic_semicolon] = ACTIONS(1025),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(1025),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_in] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1025),
  },
  [194] = {
    [sym_object] = STATE(575),
    [sym_assignment_pattern] = STATE(126),
    [sym_array] = STATE(576),
    [sym_rest_parameter] = STATE(126),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_RPAREN] = ACTIONS(160),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(182),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_get] = ACTIONS(1031),
    [anon_sym_set] = ACTIONS(1031),
  },
  [195] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1035),
  },
  [196] = {
    [sym_parenthesized_expression] = STATE(578),
    [sym__expression] = STATE(578),
    [sym_yield_expression] = STATE(578),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(578),
    [sym_jsx_fragment] = STATE(578),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(578),
    [sym_anonymous_class] = STATE(578),
    [sym_class] = STATE(578),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(578),
    [sym_generator_function] = STATE(578),
    [sym_call_expression] = STATE(578),
    [sym_new_expression] = STATE(578),
    [sym_await_expression] = STATE(578),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(578),
    [sym_augmented_assignment_expression] = STATE(578),
    [sym_ternary_expression] = STATE(578),
    [sym_binary_expression] = STATE(578),
    [sym_unary_expression] = STATE(578),
    [sym_update_expression] = STATE(578),
    [sym_string] = STATE(578),
    [sym_template_string] = STATE(578),
    [sym_regex] = STATE(578),
    [sym_meta_property] = STATE(578),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1039),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1039),
    [sym_false] = ACTIONS(1039),
    [sym_null] = ACTIONS(1039),
    [sym_undefined] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [197] = {
    [sym_formal_parameters] = STATE(580),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1041),
  },
  [198] = {
    [sym_statement_block] = STATE(581),
    [sym_parenthesized_expression] = STATE(582),
    [sym__expression] = STATE(582),
    [sym_yield_expression] = STATE(582),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(582),
    [sym_jsx_fragment] = STATE(582),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(582),
    [sym_anonymous_class] = STATE(582),
    [sym_class] = STATE(582),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(582),
    [sym_generator_function] = STATE(582),
    [sym_call_expression] = STATE(582),
    [sym_new_expression] = STATE(582),
    [sym_await_expression] = STATE(582),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(582),
    [sym_augmented_assignment_expression] = STATE(582),
    [sym_ternary_expression] = STATE(582),
    [sym_binary_expression] = STATE(582),
    [sym_unary_expression] = STATE(582),
    [sym_update_expression] = STATE(582),
    [sym_string] = STATE(582),
    [sym_template_string] = STATE(582),
    [sym_regex] = STATE(582),
    [sym_meta_property] = STATE(582),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1043),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1045),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1045),
    [sym_false] = ACTIONS(1045),
    [sym_null] = ACTIONS(1045),
    [sym_undefined] = ACTIONS(1045),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [199] = {
    [sym_parenthesized_expression] = STATE(583),
    [sym__expression] = STATE(583),
    [sym_yield_expression] = STATE(583),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(583),
    [sym_jsx_fragment] = STATE(583),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(583),
    [sym_anonymous_class] = STATE(583),
    [sym_class] = STATE(583),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(583),
    [sym_generator_function] = STATE(583),
    [sym_call_expression] = STATE(583),
    [sym_new_expression] = STATE(583),
    [sym_await_expression] = STATE(583),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(583),
    [sym_augmented_assignment_expression] = STATE(583),
    [sym_ternary_expression] = STATE(583),
    [sym_binary_expression] = STATE(583),
    [sym_unary_expression] = STATE(583),
    [sym_update_expression] = STATE(583),
    [sym_string] = STATE(583),
    [sym_template_string] = STATE(583),
    [sym_regex] = STATE(583),
    [sym_meta_property] = STATE(583),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1049),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1049),
    [sym_false] = ACTIONS(1049),
    [sym_null] = ACTIONS(1049),
    [sym_undefined] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [200] = {
    [anon_sym_EQ_GT] = ACTIONS(1051),
    [sym_comment] = ACTIONS(78),
  },
  [201] = {
    [sym__automatic_semicolon] = ACTIONS(1053),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(1055),
    [anon_sym_DOT] = ACTIONS(1053),
    [anon_sym_QMARK] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_PERCENT] = ACTIONS(1053),
    [anon_sym_LT_EQ] = ACTIONS(1053),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1053),
    [anon_sym_GT_EQ] = ACTIONS(1053),
    [anon_sym_instanceof] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1053),
  },
  [202] = {
    [sym_formal_parameters] = STATE(586),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1057),
  },
  [203] = {
    [sym_formal_parameters] = STATE(580),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [204] = {
    [sym_statement_block] = STATE(588),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(78),
  },
  [205] = {
    [sym_export_statement] = STATE(589),
    [sym__declaration] = STATE(589),
    [sym_import_statement] = STATE(589),
    [sym_expression_statement] = STATE(589),
    [sym_variable_declaration] = STATE(589),
    [sym_lexical_declaration] = STATE(589),
    [sym_statement_block] = STATE(589),
    [sym_if_statement] = STATE(589),
    [sym_switch_statement] = STATE(589),
    [sym_for_statement] = STATE(589),
    [sym_for_in_statement] = STATE(589),
    [sym_for_of_statement] = STATE(589),
    [sym_while_statement] = STATE(589),
    [sym_do_statement] = STATE(589),
    [sym_try_statement] = STATE(589),
    [sym_with_statement] = STATE(589),
    [sym_break_statement] = STATE(589),
    [sym_continue_statement] = STATE(589),
    [sym_debugger_statement] = STATE(589),
    [sym_return_statement] = STATE(589),
    [sym_throw_statement] = STATE(589),
    [sym_empty_statement] = STATE(589),
    [sym_labeled_statement] = STATE(589),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(77),
    [sym_assignment_pattern] = STATE(78),
    [sym_array] = STATE(79),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_spread_element] = STATE(78),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(74),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(82),
    [sym_formal_parameters] = STATE(50),
    [sym_method_definition] = STATE(78),
    [sym_pair] = STATE(78),
    [sym__property_name] = STATE(80),
    [sym_computed_property_name] = STATE(80),
    [aux_sym_program_repeat1] = STATE(589),
    [aux_sym_export_statement_repeat1] = STATE(82),
    [aux_sym_object_repeat1] = STATE(83),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(126),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(128),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(130),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(132),
    [sym_identifier] = ACTIONS(134),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(136),
    [anon_sym_set] = ACTIONS(136),
  },
  [206] = {
    [sym__automatic_semicolon] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_GT_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1061),
  },
  [207] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [208] = {
    [sym_parenthesized_expression] = STATE(439),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(439),
    [sym_class] = STATE(439),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(439),
    [sym_generator_function] = STATE(439),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(439),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(439),
    [sym_template_string] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_meta_property] = STATE(439),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [209] = {
    [sym_parenthesized_expression] = STATE(439),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(439),
    [sym_class] = STATE(439),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(439),
    [sym_generator_function] = STATE(439),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(439),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(439),
    [sym_template_string] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_meta_property] = STATE(439),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(347),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [210] = {
    [sym_comment] = ACTIONS(78),
    [anon_sym_target] = ACTIONS(1079),
  },
  [211] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(603),
    [sym_formal_parameters] = STATE(200),
    [sym__automatic_semicolon] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(325),
  },
  [212] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [213] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [214] = {
    [sym_arguments] = STATE(604),
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [215] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(604),
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [216] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_DOT] = ACTIONS(391),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [217] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(603),
    [sym__automatic_semicolon] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
  },
  [218] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [219] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(604),
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [220] = {
    [sym__initializer] = STATE(529),
    [sym_arguments] = STATE(604),
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [221] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(604),
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [222] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(604),
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [223] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(1113),
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1113),
    [anon_sym_in] = ACTIONS(1115),
    [anon_sym_SEMI] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_GT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_AMP_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1115),
    [anon_sym_GT_GT_GT] = ACTIONS(1113),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1113),
    [anon_sym_GT_EQ] = ACTIONS(1113),
    [anon_sym_instanceof] = ACTIONS(1113),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [224] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1117),
    [anon_sym_in] = ACTIONS(1119),
    [anon_sym_SEMI] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1117),
    [anon_sym_AMP_AMP] = ACTIONS(1117),
    [anon_sym_PIPE_PIPE] = ACTIONS(1117),
    [anon_sym_GT_GT] = ACTIONS(1119),
    [anon_sym_GT_GT_GT] = ACTIONS(1117),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1117),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_PERCENT] = ACTIONS(1117),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1117),
    [anon_sym_instanceof] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1117),
    [anon_sym_DASH_DASH] = ACTIONS(1117),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [225] = {
    [sym__automatic_semicolon] = ACTIONS(1121),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_RPAREN] = ACTIONS(1121),
    [anon_sym_in] = ACTIONS(1123),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_COLON] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_SLASH] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1121),
    [anon_sym_GT_EQ] = ACTIONS(1121),
    [anon_sym_instanceof] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1121),
  },
  [226] = {
    [aux_sym_string_repeat1] = STATE(612),
    [anon_sym_DQUOTE] = ACTIONS(1125),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(1127),
    [sym_escape_sequence] = ACTIONS(1127),
    [sym_comment] = ACTIONS(298),
  },
  [227] = {
    [aux_sym_string_repeat2] = STATE(613),
    [anon_sym_SQUOTE] = ACTIONS(1125),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(1129),
    [sym_escape_sequence] = ACTIONS(1129),
    [sym_comment] = ACTIONS(298),
  },
  [228] = {
    [sym__automatic_semicolon] = ACTIONS(1131),
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_in] = ACTIONS(1133),
    [anon_sym_SEMI] = ACTIONS(1131),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1131),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1131),
  },
  [229] = {
    [sym_parenthesized_expression] = STATE(614),
    [sym__expression] = STATE(614),
    [sym_yield_expression] = STATE(614),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(614),
    [sym_jsx_fragment] = STATE(614),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(614),
    [sym_anonymous_class] = STATE(614),
    [sym_class] = STATE(614),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(614),
    [sym_generator_function] = STATE(614),
    [sym_call_expression] = STATE(614),
    [sym_new_expression] = STATE(614),
    [sym_await_expression] = STATE(614),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(614),
    [sym_augmented_assignment_expression] = STATE(614),
    [sym_ternary_expression] = STATE(614),
    [sym_binary_expression] = STATE(614),
    [sym_unary_expression] = STATE(614),
    [sym_update_expression] = STATE(614),
    [sym_sequence_expression] = STATE(615),
    [sym_string] = STATE(614),
    [sym_template_string] = STATE(614),
    [sym_regex] = STATE(614),
    [sym_meta_property] = STATE(614),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1135),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(1137),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1137),
    [sym_false] = ACTIONS(1137),
    [sym_null] = ACTIONS(1137),
    [sym_undefined] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [230] = {
    [sym_template_substitution] = STATE(617),
    [aux_sym_template_string_repeat1] = STATE(617),
    [sym__template_chars] = ACTIONS(1139),
    [sym_escape_sequence] = ACTIONS(1139),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(381),
  },
  [231] = {
    [sym_parenthesized_expression] = STATE(618),
    [sym__expression] = STATE(618),
    [sym_yield_expression] = STATE(618),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(618),
    [sym_jsx_fragment] = STATE(618),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(618),
    [sym_anonymous_class] = STATE(618),
    [sym_class] = STATE(618),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(618),
    [sym_generator_function] = STATE(618),
    [sym_call_expression] = STATE(618),
    [sym_new_expression] = STATE(618),
    [sym_await_expression] = STATE(618),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(618),
    [sym_augmented_assignment_expression] = STATE(618),
    [sym_ternary_expression] = STATE(618),
    [sym_binary_expression] = STATE(618),
    [sym_unary_expression] = STATE(618),
    [sym_update_expression] = STATE(618),
    [sym_string] = STATE(618),
    [sym_template_string] = STATE(618),
    [sym_regex] = STATE(618),
    [sym_meta_property] = STATE(618),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1143),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1145),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1145),
    [sym_false] = ACTIONS(1145),
    [sym_null] = ACTIONS(1145),
    [sym_undefined] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [232] = {
    [sym_export_statement] = STATE(619),
    [sym__declaration] = STATE(619),
    [sym_import_statement] = STATE(619),
    [sym_expression_statement] = STATE(619),
    [sym_variable_declaration] = STATE(619),
    [sym_lexical_declaration] = STATE(619),
    [sym_statement_block] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(619),
    [sym_for_in_statement] = STATE(619),
    [sym_for_of_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_do_statement] = STATE(619),
    [sym_try_statement] = STATE(619),
    [sym_with_statement] = STATE(619),
    [sym_break_statement] = STATE(619),
    [sym_continue_statement] = STATE(619),
    [sym_debugger_statement] = STATE(619),
    [sym_return_statement] = STATE(619),
    [sym_throw_statement] = STATE(619),
    [sym_empty_statement] = STATE(619),
    [sym_labeled_statement] = STATE(619),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [233] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1147),
  },
  [234] = {
    [sym_parenthesized_expression] = STATE(621),
    [sym__expression] = STATE(621),
    [sym_yield_expression] = STATE(621),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(621),
    [sym_jsx_fragment] = STATE(621),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(621),
    [sym_anonymous_class] = STATE(621),
    [sym_class] = STATE(621),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(621),
    [sym_generator_function] = STATE(621),
    [sym_call_expression] = STATE(621),
    [sym_new_expression] = STATE(621),
    [sym_await_expression] = STATE(621),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(621),
    [sym_augmented_assignment_expression] = STATE(621),
    [sym_ternary_expression] = STATE(621),
    [sym_binary_expression] = STATE(621),
    [sym_unary_expression] = STATE(621),
    [sym_update_expression] = STATE(621),
    [sym_string] = STATE(621),
    [sym_template_string] = STATE(621),
    [sym_regex] = STATE(621),
    [sym_meta_property] = STATE(621),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1149),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1151),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1151),
    [sym_false] = ACTIONS(1151),
    [sym_null] = ACTIONS(1151),
    [sym_undefined] = ACTIONS(1151),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [235] = {
    [sym__automatic_semicolon] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1153),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1153),
    [anon_sym_QMARK] = ACTIONS(1153),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1153),
    [anon_sym_LT_LT] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1153),
    [anon_sym_LT_EQ] = ACTIONS(1153),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(1153),
    [anon_sym_instanceof] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1153),
  },
  [236] = {
    [sym_parenthesized_expression] = STATE(625),
    [sym__expression] = STATE(625),
    [sym_yield_expression] = STATE(625),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(625),
    [sym_jsx_fragment] = STATE(625),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(625),
    [sym_anonymous_class] = STATE(625),
    [sym_class] = STATE(625),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(625),
    [sym_generator_function] = STATE(625),
    [sym_call_expression] = STATE(625),
    [sym_new_expression] = STATE(625),
    [sym_await_expression] = STATE(625),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(625),
    [sym_augmented_assignment_expression] = STATE(625),
    [sym_spread_element] = STATE(626),
    [sym_ternary_expression] = STATE(625),
    [sym_binary_expression] = STATE(625),
    [sym_unary_expression] = STATE(625),
    [sym_update_expression] = STATE(625),
    [sym_string] = STATE(625),
    [sym_template_string] = STATE(625),
    [sym_regex] = STATE(625),
    [sym_meta_property] = STATE(625),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(627),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1165),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_null] = ACTIONS(1165),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [237] = {
    [sym_parenthesized_expression] = STATE(628),
    [sym__expression] = STATE(628),
    [sym_yield_expression] = STATE(628),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(628),
    [sym_jsx_fragment] = STATE(628),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(628),
    [sym_anonymous_class] = STATE(628),
    [sym_class] = STATE(628),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(628),
    [sym_generator_function] = STATE(628),
    [sym_call_expression] = STATE(628),
    [sym_new_expression] = STATE(628),
    [sym_await_expression] = STATE(628),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(628),
    [sym_augmented_assignment_expression] = STATE(628),
    [sym_ternary_expression] = STATE(628),
    [sym_binary_expression] = STATE(628),
    [sym_unary_expression] = STATE(628),
    [sym_update_expression] = STATE(628),
    [sym_sequence_expression] = STATE(629),
    [sym_string] = STATE(628),
    [sym_template_string] = STATE(628),
    [sym_regex] = STATE(628),
    [sym_meta_property] = STATE(628),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1167),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1169),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1169),
    [sym_false] = ACTIONS(1169),
    [sym_null] = ACTIONS(1169),
    [sym_undefined] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [238] = {
    [sym__automatic_semicolon] = ACTIONS(1171),
    [anon_sym_STAR] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_RPAREN] = ACTIONS(1171),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_SEMI] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1171),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_PIPE_PIPE] = ACTIONS(1171),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1171),
    [anon_sym_LT_EQ] = ACTIONS(1171),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1171),
    [anon_sym_GT_EQ] = ACTIONS(1171),
    [anon_sym_instanceof] = ACTIONS(1171),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1171),
  },
  [239] = {
    [anon_sym_export] = ACTIONS(1175),
    [anon_sym_STAR] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(1175),
    [anon_sym_class] = ACTIONS(1175),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(1177),
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_AT] = ACTIONS(1177),
    [anon_sym_static] = ACTIONS(1175),
    [anon_sym_get] = ACTIONS(1175),
    [anon_sym_set] = ACTIONS(1175),
  },
  [240] = {
    [sym_arguments] = STATE(631),
    [anon_sym_export] = ACTIONS(1179),
    [anon_sym_STAR] = ACTIONS(1181),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_async] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(1181),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_AT] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(1179),
    [anon_sym_set] = ACTIONS(1179),
  },
  [241] = {
    [anon_sym_export] = ACTIONS(1179),
    [anon_sym_STAR] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_async] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(1181),
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_AT] = ACTIONS(1181),
    [anon_sym_static] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(1179),
    [anon_sym_set] = ACTIONS(1179),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [anon_sym_export] = ACTIONS(1187),
    [anon_sym_default] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_import] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(1187),
    [anon_sym_let] = ACTIONS(1187),
    [anon_sym_const] = ACTIONS(1187),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_for] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_RPAREN] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1187),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_do] = ACTIONS(1187),
    [anon_sym_try] = ACTIONS(1187),
    [anon_sym_with] = ACTIONS(1187),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_continue] = ACTIONS(1187),
    [anon_sym_debugger] = ACTIONS(1187),
    [anon_sym_return] = ACTIONS(1187),
    [anon_sym_throw] = ACTIONS(1187),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_case] = ACTIONS(1187),
    [anon_sym_yield] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1185),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_class] = ACTIONS(1187),
    [anon_sym_async] = ACTIONS(1187),
    [anon_sym_function] = ACTIONS(1187),
    [anon_sym_EQ_GT] = ACTIONS(1185),
    [anon_sym_new] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1185),
    [anon_sym_TILDE] = ACTIONS(1185),
    [anon_sym_typeof] = ACTIONS(1187),
    [anon_sym_void] = ACTIONS(1187),
    [anon_sym_delete] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_DASH_DASH] = ACTIONS(1185),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1185),
    [sym_number] = ACTIONS(1185),
    [sym_identifier] = ACTIONS(1187),
    [sym_this] = ACTIONS(1187),
    [sym_super] = ACTIONS(1187),
    [sym_true] = ACTIONS(1187),
    [sym_false] = ACTIONS(1187),
    [sym_null] = ACTIONS(1187),
    [sym_undefined] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
    [anon_sym_get] = ACTIONS(1187),
    [anon_sym_set] = ACTIONS(1187),
  },
  [243] = {
    [sym_parenthesized_expression] = STATE(632),
    [sym__expression] = STATE(632),
    [sym_yield_expression] = STATE(632),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(632),
    [sym_jsx_fragment] = STATE(632),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(632),
    [sym_anonymous_class] = STATE(632),
    [sym_class] = STATE(632),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(632),
    [sym_generator_function] = STATE(632),
    [sym_call_expression] = STATE(632),
    [sym_new_expression] = STATE(632),
    [sym_await_expression] = STATE(632),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(632),
    [sym_augmented_assignment_expression] = STATE(632),
    [sym_ternary_expression] = STATE(632),
    [sym_binary_expression] = STATE(632),
    [sym_unary_expression] = STATE(632),
    [sym_update_expression] = STATE(632),
    [sym_string] = STATE(632),
    [sym_template_string] = STATE(632),
    [sym_regex] = STATE(632),
    [sym_meta_property] = STATE(632),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1191),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1191),
    [sym_false] = ACTIONS(1191),
    [sym_null] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [244] = {
    [sym_parenthesized_expression] = STATE(633),
    [sym__expression] = STATE(633),
    [sym_yield_expression] = STATE(633),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(633),
    [sym_jsx_fragment] = STATE(633),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(633),
    [sym_anonymous_class] = STATE(633),
    [sym_class] = STATE(633),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(633),
    [sym_generator_function] = STATE(633),
    [sym_call_expression] = STATE(633),
    [sym_new_expression] = STATE(633),
    [sym_await_expression] = STATE(633),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(633),
    [sym_augmented_assignment_expression] = STATE(633),
    [sym_ternary_expression] = STATE(633),
    [sym_binary_expression] = STATE(633),
    [sym_unary_expression] = STATE(633),
    [sym_update_expression] = STATE(633),
    [sym_sequence_expression] = STATE(634),
    [sym_string] = STATE(633),
    [sym_template_string] = STATE(633),
    [sym_regex] = STATE(633),
    [sym_meta_property] = STATE(633),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1193),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1195),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1195),
    [sym_false] = ACTIONS(1195),
    [sym_null] = ACTIONS(1195),
    [sym_undefined] = ACTIONS(1195),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [245] = {
    [sym_parenthesized_expression] = STATE(644),
    [sym__expression] = STATE(644),
    [sym_yield_expression] = STATE(644),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(644),
    [sym_jsx_fragment] = STATE(644),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(644),
    [sym_anonymous_class] = STATE(644),
    [sym_class] = STATE(644),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(644),
    [sym_generator_function] = STATE(644),
    [sym_call_expression] = STATE(644),
    [sym_new_expression] = STATE(644),
    [sym_await_expression] = STATE(644),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(644),
    [sym_augmented_assignment_expression] = STATE(644),
    [sym_ternary_expression] = STATE(644),
    [sym_binary_expression] = STATE(644),
    [sym_unary_expression] = STATE(644),
    [sym_update_expression] = STATE(644),
    [sym_string] = STATE(644),
    [sym_template_string] = STATE(644),
    [sym_regex] = STATE(644),
    [sym_meta_property] = STATE(644),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(1217),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1217),
    [sym_false] = ACTIONS(1217),
    [sym_null] = ACTIONS(1217),
    [sym_undefined] = ACTIONS(1217),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [246] = {
    [sym_parenthesized_expression] = STATE(649),
    [sym__expression] = STATE(649),
    [sym_yield_expression] = STATE(649),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(649),
    [sym_jsx_fragment] = STATE(649),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(649),
    [sym_anonymous_class] = STATE(649),
    [sym_class] = STATE(649),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(649),
    [sym_generator_function] = STATE(649),
    [sym_call_expression] = STATE(649),
    [sym_new_expression] = STATE(649),
    [sym_await_expression] = STATE(649),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(649),
    [sym_augmented_assignment_expression] = STATE(649),
    [sym_ternary_expression] = STATE(649),
    [sym_binary_expression] = STATE(649),
    [sym_unary_expression] = STATE(649),
    [sym_update_expression] = STATE(649),
    [sym_string] = STATE(649),
    [sym_template_string] = STATE(649),
    [sym_regex] = STATE(649),
    [sym_meta_property] = STATE(649),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1221),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1223),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1223),
    [sym_false] = ACTIONS(1223),
    [sym_null] = ACTIONS(1223),
    [sym_undefined] = ACTIONS(1223),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [247] = {
    [sym_parenthesized_expression] = STATE(650),
    [sym__expression] = STATE(650),
    [sym_yield_expression] = STATE(650),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(650),
    [sym_jsx_fragment] = STATE(650),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(650),
    [sym_anonymous_class] = STATE(650),
    [sym_class] = STATE(650),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(650),
    [sym_generator_function] = STATE(650),
    [sym_call_expression] = STATE(650),
    [sym_new_expression] = STATE(650),
    [sym_await_expression] = STATE(650),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(650),
    [sym_augmented_assignment_expression] = STATE(650),
    [sym_ternary_expression] = STATE(650),
    [sym_binary_expression] = STATE(650),
    [sym_unary_expression] = STATE(650),
    [sym_update_expression] = STATE(650),
    [sym_string] = STATE(650),
    [sym_template_string] = STATE(650),
    [sym_regex] = STATE(650),
    [sym_meta_property] = STATE(650),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1227),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1227),
    [sym_false] = ACTIONS(1227),
    [sym_null] = ACTIONS(1227),
    [sym_undefined] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [248] = {
    [sym_parenthesized_expression] = STATE(651),
    [sym__expression] = STATE(651),
    [sym_yield_expression] = STATE(651),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(651),
    [sym_jsx_fragment] = STATE(651),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(651),
    [sym_anonymous_class] = STATE(651),
    [sym_class] = STATE(651),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(651),
    [sym_generator_function] = STATE(651),
    [sym_call_expression] = STATE(651),
    [sym_new_expression] = STATE(651),
    [sym_await_expression] = STATE(651),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(651),
    [sym_augmented_assignment_expression] = STATE(651),
    [sym_ternary_expression] = STATE(651),
    [sym_binary_expression] = STATE(651),
    [sym_unary_expression] = STATE(651),
    [sym_update_expression] = STATE(651),
    [sym_string] = STATE(651),
    [sym_template_string] = STATE(651),
    [sym_regex] = STATE(651),
    [sym_meta_property] = STATE(651),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1229),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(1231),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1231),
    [sym_false] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [249] = {
    [sym__automatic_semicolon] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1117),
    [anon_sym_RPAREN] = ACTIONS(1117),
    [anon_sym_in] = ACTIONS(1119),
    [anon_sym_SEMI] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(1117),
    [anon_sym_QMARK] = ACTIONS(1117),
    [anon_sym_AMP_AMP] = ACTIONS(1117),
    [anon_sym_PIPE_PIPE] = ACTIONS(1117),
    [anon_sym_GT_GT] = ACTIONS(1119),
    [anon_sym_GT_GT_GT] = ACTIONS(1117),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1117),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_PERCENT] = ACTIONS(1117),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1117),
    [anon_sym_instanceof] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1117),
    [anon_sym_DASH_DASH] = ACTIONS(1117),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1117),
  },
  [250] = {
    [sym__automatic_semicolon] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1233),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1233),
  },
  [251] = {
    [sym__automatic_semicolon] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_in] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1239),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1237),
  },
  [252] = {
    [sym_parenthesized_expression] = STATE(654),
    [sym__expression] = STATE(654),
    [sym_yield_expression] = STATE(654),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(654),
    [sym_jsx_fragment] = STATE(654),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(654),
    [sym_anonymous_class] = STATE(654),
    [sym_class] = STATE(654),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(654),
    [sym_generator_function] = STATE(654),
    [sym_call_expression] = STATE(654),
    [sym_new_expression] = STATE(654),
    [sym_await_expression] = STATE(654),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(654),
    [sym_augmented_assignment_expression] = STATE(654),
    [sym_spread_element] = STATE(655),
    [sym_ternary_expression] = STATE(654),
    [sym_binary_expression] = STATE(654),
    [sym_unary_expression] = STATE(654),
    [sym_update_expression] = STATE(654),
    [sym_sequence_expression] = STATE(655),
    [sym_string] = STATE(654),
    [sym_template_string] = STATE(654),
    [sym_regex] = STATE(654),
    [sym_meta_property] = STATE(654),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1245),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(1247),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1247),
    [sym_false] = ACTIONS(1247),
    [sym_null] = ACTIONS(1247),
    [sym_undefined] = ACTIONS(1247),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [253] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(1249),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [254] = {
    [sym_jsx_element] = STATE(663),
    [sym_jsx_expression] = STATE(663),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_closing_element] = STATE(662),
    [sym_jsx_self_closing_element] = STATE(663),
    [aux_sym_jsx_element_repeat1] = STATE(663),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(1255),
    [sym_jsx_text] = ACTIONS(1257),
    [sym_comment] = ACTIONS(78),
  },
  [255] = {
    [sym__automatic_semicolon] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_COMMA] = ACTIONS(1259),
    [anon_sym_RBRACE] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1259),
    [anon_sym_LBRACK] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_SLASH] = ACTIONS(1261),
    [anon_sym_DOT] = ACTIONS(1259),
    [anon_sym_QMARK] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_GT_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_CARET] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PERCENT] = ACTIONS(1259),
    [anon_sym_LT_EQ] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1259),
    [anon_sym_BANG_EQ] = ACTIONS(1261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1259),
    [anon_sym_GT_EQ] = ACTIONS(1259),
    [anon_sym_instanceof] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1259),
  },
  [256] = {
    [sym_jsx_element] = STATE(665),
    [sym_jsx_expression] = STATE(665),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_closing_element] = STATE(664),
    [sym_jsx_self_closing_element] = STATE(665),
    [aux_sym_jsx_element_repeat1] = STATE(665),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(431),
    [sym_jsx_text] = ACTIONS(1263),
    [sym_comment] = ACTIONS(78),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(1265),
    [anon_sym_export] = ACTIONS(1267),
    [anon_sym_default] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_import] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1267),
    [anon_sym_let] = ACTIONS(1267),
    [anon_sym_const] = ACTIONS(1267),
    [anon_sym_if] = ACTIONS(1267),
    [anon_sym_else] = ACTIONS(1267),
    [anon_sym_switch] = ACTIONS(1267),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_await] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1267),
    [anon_sym_do] = ACTIONS(1267),
    [anon_sym_try] = ACTIONS(1267),
    [anon_sym_with] = ACTIONS(1267),
    [anon_sym_break] = ACTIONS(1267),
    [anon_sym_continue] = ACTIONS(1267),
    [anon_sym_debugger] = ACTIONS(1267),
    [anon_sym_return] = ACTIONS(1267),
    [anon_sym_throw] = ACTIONS(1267),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_case] = ACTIONS(1267),
    [anon_sym_yield] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1267),
    [anon_sym_class] = ACTIONS(1267),
    [anon_sym_async] = ACTIONS(1267),
    [anon_sym_function] = ACTIONS(1267),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_new] = ACTIONS(1267),
    [anon_sym_PLUS] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1265),
    [anon_sym_TILDE] = ACTIONS(1265),
    [anon_sym_typeof] = ACTIONS(1267),
    [anon_sym_void] = ACTIONS(1267),
    [anon_sym_delete] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1265),
    [anon_sym_DQUOTE] = ACTIONS(1265),
    [anon_sym_SQUOTE] = ACTIONS(1265),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1265),
    [sym_number] = ACTIONS(1265),
    [sym_identifier] = ACTIONS(1267),
    [sym_this] = ACTIONS(1267),
    [sym_super] = ACTIONS(1267),
    [sym_true] = ACTIONS(1267),
    [sym_false] = ACTIONS(1267),
    [sym_null] = ACTIONS(1267),
    [sym_undefined] = ACTIONS(1267),
    [anon_sym_AT] = ACTIONS(1265),
    [anon_sym_get] = ACTIONS(1267),
    [anon_sym_set] = ACTIONS(1267),
  },
  [258] = {
    [sym_export_statement] = STATE(258),
    [sym__declaration] = STATE(258),
    [sym_import_statement] = STATE(258),
    [sym_expression_statement] = STATE(258),
    [sym_variable_declaration] = STATE(258),
    [sym_lexical_declaration] = STATE(258),
    [sym_statement_block] = STATE(258),
    [sym_if_statement] = STATE(258),
    [sym_switch_statement] = STATE(258),
    [sym_for_statement] = STATE(258),
    [sym_for_in_statement] = STATE(258),
    [sym_for_of_statement] = STATE(258),
    [sym_while_statement] = STATE(258),
    [sym_do_statement] = STATE(258),
    [sym_try_statement] = STATE(258),
    [sym_with_statement] = STATE(258),
    [sym_break_statement] = STATE(258),
    [sym_continue_statement] = STATE(258),
    [sym_debugger_statement] = STATE(258),
    [sym_return_statement] = STATE(258),
    [sym_throw_statement] = STATE(258),
    [sym_empty_statement] = STATE(258),
    [sym_labeled_statement] = STATE(258),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(258),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [ts_builtin_sym_end] = ACTIONS(1269),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_import] = ACTIONS(1277),
    [anon_sym_var] = ACTIONS(1280),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1283),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_await] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1304),
    [anon_sym_try] = ACTIONS(1307),
    [anon_sym_with] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_debugger] = ACTIONS(1319),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym_yield] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1340),
    [anon_sym_class] = ACTIONS(1343),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1352),
    [anon_sym_new] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(1361),
    [anon_sym_typeof] = ACTIONS(1358),
    [anon_sym_void] = ACTIONS(1358),
    [anon_sym_delete] = ACTIONS(1358),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [sym_number] = ACTIONS(1376),
    [sym_identifier] = ACTIONS(1379),
    [sym_this] = ACTIONS(1382),
    [sym_super] = ACTIONS(1385),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [sym_null] = ACTIONS(1382),
    [sym_undefined] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1388),
    [anon_sym_get] = ACTIONS(1391),
    [anon_sym_set] = ACTIONS(1391),
  },
  [259] = {
    [sym__declaration] = STATE(287),
    [sym_variable_declaration] = STATE(287),
    [sym_lexical_declaration] = STATE(287),
    [sym_class] = STATE(62),
    [sym_function] = STATE(62),
    [sym_generator_function] = STATE(62),
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [anon_sym_default] = ACTIONS(1394),
    [anon_sym_var] = ACTIONS(102),
    [anon_sym_let] = ACTIONS(104),
    [anon_sym_const] = ACTIONS(104),
    [anon_sym_class] = ACTIONS(106),
    [anon_sym_async] = ACTIONS(108),
    [anon_sym_function] = ACTIONS(110),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [260] = {
    [sym_class_heritage] = STATE(668),
    [sym_class_body] = STATE(571),
    [anon_sym_LBRACE] = ACTIONS(302),
    [anon_sym_extends] = ACTIONS(304),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1396),
  },
  [261] = {
    [sym_decorator] = STATE(261),
    [aux_sym_export_statement_repeat1] = STATE(261),
    [anon_sym_export] = ACTIONS(1398),
    [anon_sym_class] = ACTIONS(1398),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(1400),
  },
  [262] = {
    [sym_string] = STATE(669),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
  },
  [263] = {
    [sym__automatic_semicolon] = ACTIONS(1403),
    [anon_sym_SEMI] = ACTIONS(1403),
    [sym_comment] = ACTIONS(78),
  },
  [264] = {
    [sym_parenthesized_expression] = STATE(671),
    [sym__expression] = STATE(671),
    [sym_yield_expression] = STATE(671),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(671),
    [sym_jsx_fragment] = STATE(671),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(671),
    [sym_anonymous_class] = STATE(671),
    [sym_class] = STATE(671),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(671),
    [sym_generator_function] = STATE(671),
    [sym_call_expression] = STATE(671),
    [sym_new_expression] = STATE(671),
    [sym_await_expression] = STATE(671),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(671),
    [sym_augmented_assignment_expression] = STATE(671),
    [sym_ternary_expression] = STATE(671),
    [sym_binary_expression] = STATE(671),
    [sym_unary_expression] = STATE(671),
    [sym_update_expression] = STATE(671),
    [sym_string] = STATE(671),
    [sym_template_string] = STATE(671),
    [sym_regex] = STATE(671),
    [sym_meta_property] = STATE(671),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1405),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(1407),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1407),
    [sym_false] = ACTIONS(1407),
    [sym_null] = ACTIONS(1407),
    [sym_undefined] = ACTIONS(1407),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [265] = {
    [sym_parenthesized_expression] = STATE(672),
    [sym__expression] = STATE(672),
    [sym_yield_expression] = STATE(672),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(672),
    [sym_jsx_fragment] = STATE(672),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(672),
    [sym_anonymous_class] = STATE(672),
    [sym_class] = STATE(672),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(672),
    [sym_generator_function] = STATE(672),
    [sym_call_expression] = STATE(672),
    [sym_new_expression] = STATE(672),
    [sym_await_expression] = STATE(672),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(672),
    [sym_augmented_assignment_expression] = STATE(672),
    [sym_ternary_expression] = STATE(672),
    [sym_binary_expression] = STATE(672),
    [sym_unary_expression] = STATE(672),
    [sym_update_expression] = STATE(672),
    [sym_string] = STATE(672),
    [sym_template_string] = STATE(672),
    [sym_regex] = STATE(672),
    [sym_meta_property] = STATE(672),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [sym__automatic_semicolon] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_SEMI] = ACTIONS(252),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1409),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(1411),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1411),
    [sym_false] = ACTIONS(1411),
    [sym_null] = ACTIONS(1411),
    [sym_undefined] = ACTIONS(1411),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [266] = {
    [sym__initializer] = STATE(201),
    [sym_formal_parameters] = STATE(676),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(1415),
    [anon_sym_PLUS_EQ] = ACTIONS(1417),
    [anon_sym_DASH_EQ] = ACTIONS(1417),
    [anon_sym_STAR_EQ] = ACTIONS(1417),
    [anon_sym_SLASH_EQ] = ACTIONS(1417),
    [anon_sym_PERCENT_EQ] = ACTIONS(1417),
    [anon_sym_CARET_EQ] = ACTIONS(1417),
    [anon_sym_AMP_EQ] = ACTIONS(1417),
    [anon_sym_PIPE_EQ] = ACTIONS(1417),
    [anon_sym_GT_GT_EQ] = ACTIONS(1417),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1417),
    [anon_sym_LT_LT_EQ] = ACTIONS(1417),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(1419),
  },
  [267] = {
    [sym_statement_block] = STATE(206),
    [sym_parenthesized_expression] = STATE(677),
    [sym__expression] = STATE(677),
    [sym_yield_expression] = STATE(677),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(677),
    [sym_jsx_fragment] = STATE(677),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(677),
    [sym_anonymous_class] = STATE(677),
    [sym_class] = STATE(677),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(677),
    [sym_generator_function] = STATE(677),
    [sym_call_expression] = STATE(677),
    [sym_new_expression] = STATE(677),
    [sym_await_expression] = STATE(677),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(677),
    [sym_augmented_assignment_expression] = STATE(677),
    [sym_ternary_expression] = STATE(677),
    [sym_binary_expression] = STATE(677),
    [sym_unary_expression] = STATE(677),
    [sym_update_expression] = STATE(677),
    [sym_string] = STATE(677),
    [sym_template_string] = STATE(677),
    [sym_regex] = STATE(677),
    [sym_meta_property] = STATE(677),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1421),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(1423),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1423),
    [sym_false] = ACTIONS(1423),
    [sym_null] = ACTIONS(1423),
    [sym_undefined] = ACTIONS(1423),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [268] = {
    [sym_parenthesized_expression] = STATE(214),
    [sym__expression] = STATE(218),
    [sym_yield_expression] = STATE(218),
    [sym_object] = STATE(219),
    [sym_array] = STATE(220),
    [sym_jsx_element] = STATE(218),
    [sym_jsx_fragment] = STATE(218),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(218),
    [sym_anonymous_class] = STATE(214),
    [sym_class] = STATE(214),
    [sym_function] = STATE(221),
    [sym_arrow_function] = STATE(214),
    [sym_generator_function] = STATE(214),
    [sym_call_expression] = STATE(218),
    [sym_new_expression] = STATE(214),
    [sym_await_expression] = STATE(218),
    [sym_member_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_assignment_expression] = STATE(218),
    [sym_augmented_assignment_expression] = STATE(218),
    [sym_ternary_expression] = STATE(218),
    [sym_binary_expression] = STATE(218),
    [sym_unary_expression] = STATE(218),
    [sym_update_expression] = STATE(218),
    [sym_string] = STATE(214),
    [sym_template_string] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_meta_property] = STATE(214),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_DOT] = ACTIONS(343),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1425),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(353),
    [sym_identifier] = ACTIONS(1427),
    [sym_this] = ACTIONS(357),
    [sym_super] = ACTIONS(359),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_undefined] = ACTIONS(357),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(361),
    [anon_sym_set] = ACTIONS(361),
  },
  [269] = {
    [sym_parenthesized_expression] = STATE(223),
    [sym__expression] = STATE(223),
    [sym_yield_expression] = STATE(223),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(223),
    [sym_jsx_fragment] = STATE(223),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(223),
    [sym_anonymous_class] = STATE(223),
    [sym_class] = STATE(223),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(223),
    [sym_generator_function] = STATE(223),
    [sym_call_expression] = STATE(223),
    [sym_new_expression] = STATE(223),
    [sym_await_expression] = STATE(223),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(223),
    [sym_augmented_assignment_expression] = STATE(223),
    [sym_ternary_expression] = STATE(223),
    [sym_binary_expression] = STATE(223),
    [sym_unary_expression] = STATE(223),
    [sym_update_expression] = STATE(223),
    [sym_string] = STATE(223),
    [sym_template_string] = STATE(223),
    [sym_regex] = STATE(223),
    [sym_meta_property] = STATE(223),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(363),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(365),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(365),
    [sym_false] = ACTIONS(365),
    [sym_null] = ACTIONS(365),
    [sym_undefined] = ACTIONS(365),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [270] = {
    [sym_parenthesized_expression] = STATE(224),
    [sym__expression] = STATE(224),
    [sym_yield_expression] = STATE(224),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(224),
    [sym_jsx_fragment] = STATE(224),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(224),
    [sym_anonymous_class] = STATE(224),
    [sym_class] = STATE(224),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(224),
    [sym_generator_function] = STATE(224),
    [sym_call_expression] = STATE(224),
    [sym_new_expression] = STATE(224),
    [sym_await_expression] = STATE(224),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(224),
    [sym_augmented_assignment_expression] = STATE(224),
    [sym_ternary_expression] = STATE(224),
    [sym_binary_expression] = STATE(224),
    [sym_unary_expression] = STATE(224),
    [sym_update_expression] = STATE(224),
    [sym_string] = STATE(224),
    [sym_template_string] = STATE(224),
    [sym_regex] = STATE(224),
    [sym_meta_property] = STATE(224),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(367),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(369),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(369),
    [sym_false] = ACTIONS(369),
    [sym_null] = ACTIONS(369),
    [sym_undefined] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [271] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_EQ_GT] = ACTIONS(1415),
    [anon_sym_PLUS_EQ] = ACTIONS(1431),
    [anon_sym_DASH_EQ] = ACTIONS(1431),
    [anon_sym_STAR_EQ] = ACTIONS(1431),
    [anon_sym_SLASH_EQ] = ACTIONS(1431),
    [anon_sym_PERCENT_EQ] = ACTIONS(1431),
    [anon_sym_CARET_EQ] = ACTIONS(1431),
    [anon_sym_AMP_EQ] = ACTIONS(1431),
    [anon_sym_PIPE_EQ] = ACTIONS(1431),
    [anon_sym_GT_GT_EQ] = ACTIONS(1431),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1431),
    [anon_sym_LT_LT_EQ] = ACTIONS(1431),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [272] = {
    [sym__initializer] = STATE(201),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_PLUS_EQ] = ACTIONS(1417),
    [anon_sym_DASH_EQ] = ACTIONS(1417),
    [anon_sym_STAR_EQ] = ACTIONS(1417),
    [anon_sym_SLASH_EQ] = ACTIONS(1417),
    [anon_sym_PERCENT_EQ] = ACTIONS(1417),
    [anon_sym_CARET_EQ] = ACTIONS(1417),
    [anon_sym_AMP_EQ] = ACTIONS(1417),
    [anon_sym_PIPE_EQ] = ACTIONS(1417),
    [anon_sym_GT_GT_EQ] = ACTIONS(1417),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1417),
    [anon_sym_LT_LT_EQ] = ACTIONS(1417),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [273] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(1403),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [274] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [275] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [276] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(1413),
    [anon_sym_PLUS_EQ] = ACTIONS(1431),
    [anon_sym_DASH_EQ] = ACTIONS(1431),
    [anon_sym_STAR_EQ] = ACTIONS(1431),
    [anon_sym_SLASH_EQ] = ACTIONS(1431),
    [anon_sym_PERCENT_EQ] = ACTIONS(1431),
    [anon_sym_CARET_EQ] = ACTIONS(1431),
    [anon_sym_AMP_EQ] = ACTIONS(1431),
    [anon_sym_PIPE_EQ] = ACTIONS(1431),
    [anon_sym_GT_GT_EQ] = ACTIONS(1431),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1431),
    [anon_sym_LT_LT_EQ] = ACTIONS(1431),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [277] = {
    [anon_sym_EQ_GT] = ACTIONS(1415),
    [sym_comment] = ACTIONS(78),
  },
  [278] = {
    [anon_sym_RBRACE] = ACTIONS(1451),
    [sym_comment] = ACTIONS(78),
  },
  [279] = {
    [sym__automatic_semicolon] = ACTIONS(1453),
    [anon_sym_from] = ACTIONS(1453),
    [anon_sym_SEMI] = ACTIONS(1453),
    [sym_comment] = ACTIONS(78),
  },
  [280] = {
    [anon_sym_COMMA] = ACTIONS(1455),
    [anon_sym_RBRACE] = ACTIONS(1455),
    [anon_sym_as] = ACTIONS(1457),
    [sym_comment] = ACTIONS(78),
  },
  [281] = {
    [aux_sym_export_clause_repeat1] = STATE(691),
    [anon_sym_COMMA] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(78),
  },
  [282] = {
    [sym_class_heritage] = STATE(693),
    [sym_class_body] = STATE(694),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_extends] = ACTIONS(1023),
    [sym_comment] = ACTIONS(78),
  },
  [283] = {
    [sym_formal_parameters] = STATE(696),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1465),
  },
  [284] = {
    [sym_formal_parameters] = STATE(698),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1467),
  },
  [285] = {
    [sym_formal_parameters] = STATE(696),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [286] = {
    [sym_statement_block] = STATE(700),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(78),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(1471),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_import] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_let] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1471),
    [anon_sym_await] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_try] = ACTIONS(1473),
    [anon_sym_with] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_debugger] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_throw] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_yield] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1471),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_SLASH] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_EQ_GT] = ACTIONS(1471),
    [anon_sym_new] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1471),
    [anon_sym_TILDE] = ACTIONS(1471),
    [anon_sym_typeof] = ACTIONS(1473),
    [anon_sym_void] = ACTIONS(1473),
    [anon_sym_delete] = ACTIONS(1473),
    [anon_sym_PLUS_PLUS] = ACTIONS(1471),
    [anon_sym_DASH_DASH] = ACTIONS(1471),
    [anon_sym_DQUOTE] = ACTIONS(1471),
    [anon_sym_SQUOTE] = ACTIONS(1471),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [sym_number] = ACTIONS(1471),
    [sym_identifier] = ACTIONS(1473),
    [sym_this] = ACTIONS(1473),
    [sym_super] = ACTIONS(1473),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [sym_null] = ACTIONS(1473),
    [sym_undefined] = ACTIONS(1473),
    [anon_sym_AT] = ACTIONS(1471),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
  },
  [288] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1475),
  },
  [289] = {
    [sym_decorator] = STATE(289),
    [aux_sym_export_statement_repeat1] = STATE(289),
    [anon_sym_class] = ACTIONS(1398),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(1400),
  },
  [290] = {
    [sym_parenthesized_expression] = STATE(711),
    [sym__expression] = STATE(711),
    [sym_yield_expression] = STATE(711),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(711),
    [sym_jsx_fragment] = STATE(711),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(711),
    [sym_anonymous_class] = STATE(711),
    [sym_class] = STATE(711),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(711),
    [sym_generator_function] = STATE(711),
    [sym_call_expression] = STATE(711),
    [sym_new_expression] = STATE(711),
    [sym_await_expression] = STATE(711),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(711),
    [sym_augmented_assignment_expression] = STATE(711),
    [sym_ternary_expression] = STATE(711),
    [sym_binary_expression] = STATE(711),
    [sym_unary_expression] = STATE(711),
    [sym_update_expression] = STATE(711),
    [sym_string] = STATE(711),
    [sym_template_string] = STATE(711),
    [sym_regex] = STATE(711),
    [sym_meta_property] = STATE(711),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1493),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(1497),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1497),
    [sym_false] = ACTIONS(1497),
    [sym_null] = ACTIONS(1497),
    [sym_undefined] = ACTIONS(1497),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [291] = {
    [anon_sym_LPAREN] = ACTIONS(540),
    [sym_comment] = ACTIONS(78),
  },
  [292] = {
    [sym_formal_parameters] = STATE(716),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [293] = {
    [sym_object] = STATE(298),
    [sym_assignment_pattern] = STATE(721),
    [sym_array] = STATE(300),
    [sym_spread_element] = STATE(721),
    [sym_string] = STATE(80),
    [sym_decorator] = STATE(722),
    [sym_method_definition] = STATE(721),
    [sym_pair] = STATE(721),
    [sym__property_name] = STATE(80),
    [sym_computed_property_name] = STATE(80),
    [aux_sym_export_statement_repeat1] = STATE(722),
    [aux_sym_object_repeat1] = STATE(723),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1501),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_async] = ACTIONS(1503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(130),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(509),
    [sym_identifier] = ACTIONS(1505),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1507),
    [anon_sym_set] = ACTIONS(1507),
  },
  [294] = {
    [sym_parenthesized_expression] = STATE(725),
    [sym__expression] = STATE(725),
    [sym_yield_expression] = STATE(725),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(725),
    [sym_jsx_fragment] = STATE(725),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(725),
    [sym_anonymous_class] = STATE(725),
    [sym_class] = STATE(725),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(725),
    [sym_generator_function] = STATE(725),
    [sym_call_expression] = STATE(725),
    [sym_new_expression] = STATE(725),
    [sym_await_expression] = STATE(725),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(725),
    [sym_augmented_assignment_expression] = STATE(725),
    [sym_spread_element] = STATE(726),
    [sym_ternary_expression] = STATE(725),
    [sym_binary_expression] = STATE(725),
    [sym_unary_expression] = STATE(725),
    [sym_update_expression] = STATE(725),
    [sym_string] = STATE(725),
    [sym_template_string] = STATE(725),
    [sym_regex] = STATE(725),
    [sym_meta_property] = STATE(725),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(727),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_RBRACK] = ACTIONS(1509),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1511),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1513),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1513),
    [sym_false] = ACTIONS(1513),
    [sym_null] = ACTIONS(1513),
    [sym_undefined] = ACTIONS(1513),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [295] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_COMMA] = ACTIONS(1517),
    [anon_sym_RBRACE] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [296] = {
    [sym__initializer] = STATE(729),
    [anon_sym_COMMA] = ACTIONS(1517),
    [anon_sym_RBRACE] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(1519),
    [sym_comment] = ACTIONS(78),
  },
  [297] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [anon_sym_COMMA] = ACTIONS(1517),
    [anon_sym_RBRACE] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [298] = {
    [sym__initializer] = STATE(730),
    [anon_sym_EQ] = ACTIONS(1519),
    [sym_comment] = ACTIONS(78),
  },
  [299] = {
    [anon_sym_COMMA] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [sym_comment] = ACTIONS(78),
  },
  [300] = {
    [sym__initializer] = STATE(731),
    [anon_sym_EQ] = ACTIONS(1519),
    [sym_comment] = ACTIONS(78),
  },
  [301] = {
    [sym_string] = STATE(342),
    [sym_decorator] = STATE(733),
    [sym_method_definition] = STATE(732),
    [sym__property_name] = STATE(342),
    [sym_computed_property_name] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(733),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(605),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(607),
    [anon_sym_set] = ACTIONS(607),
  },
  [302] = {
    [sym_export_statement] = STATE(739),
    [sym__declaration] = STATE(739),
    [sym_import_statement] = STATE(739),
    [sym_expression_statement] = STATE(739),
    [sym_variable_declaration] = STATE(739),
    [sym_lexical_declaration] = STATE(739),
    [sym_statement_block] = STATE(739),
    [sym_if_statement] = STATE(739),
    [sym_switch_statement] = STATE(739),
    [sym_for_statement] = STATE(739),
    [sym_for_in_statement] = STATE(739),
    [sym_for_of_statement] = STATE(739),
    [sym_while_statement] = STATE(739),
    [sym_do_statement] = STATE(739),
    [sym_try_statement] = STATE(739),
    [sym_with_statement] = STATE(739),
    [sym_break_statement] = STATE(739),
    [sym_continue_statement] = STATE(739),
    [sym_debugger_statement] = STATE(739),
    [sym_return_statement] = STATE(739),
    [sym_throw_statement] = STATE(739),
    [sym_empty_statement] = STATE(739),
    [sym_labeled_statement] = STATE(739),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [303] = {
    [sym_expression_statement] = STATE(743),
    [sym_variable_declaration] = STATE(743),
    [sym_lexical_declaration] = STATE(743),
    [sym_empty_statement] = STATE(743),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(744),
    [sym_array] = STATE(745),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_let] = ACTIONS(1535),
    [anon_sym_const] = ACTIONS(1535),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1537),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [304] = {
    [anon_sym_LPAREN] = ACTIONS(1539),
    [sym_comment] = ACTIONS(78),
  },
  [305] = {
    [sym_export_statement] = STATE(485),
    [sym__declaration] = STATE(485),
    [sym_import_statement] = STATE(485),
    [sym_expression_statement] = STATE(485),
    [sym_variable_declaration] = STATE(485),
    [sym_lexical_declaration] = STATE(485),
    [sym_statement_block] = STATE(485),
    [sym_if_statement] = STATE(485),
    [sym_switch_statement] = STATE(485),
    [sym_for_statement] = STATE(485),
    [sym_for_in_statement] = STATE(485),
    [sym_for_of_statement] = STATE(485),
    [sym_while_statement] = STATE(485),
    [sym_do_statement] = STATE(485),
    [sym_try_statement] = STATE(485),
    [sym_with_statement] = STATE(485),
    [sym_break_statement] = STATE(485),
    [sym_continue_statement] = STATE(485),
    [sym_debugger_statement] = STATE(485),
    [sym_return_statement] = STATE(485),
    [sym_throw_statement] = STATE(485),
    [sym_empty_statement] = STATE(485),
    [sym_labeled_statement] = STATE(485),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [306] = {
    [sym_export_statement] = STATE(502),
    [sym__declaration] = STATE(502),
    [sym_import_statement] = STATE(502),
    [sym_expression_statement] = STATE(502),
    [sym_variable_declaration] = STATE(502),
    [sym_lexical_declaration] = STATE(502),
    [sym_statement_block] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_switch_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_for_in_statement] = STATE(502),
    [sym_for_of_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_do_statement] = STATE(502),
    [sym_try_statement] = STATE(502),
    [sym_with_statement] = STATE(502),
    [sym_break_statement] = STATE(502),
    [sym_continue_statement] = STATE(502),
    [sym_debugger_statement] = STATE(502),
    [sym_return_statement] = STATE(502),
    [sym_throw_statement] = STATE(502),
    [sym_empty_statement] = STATE(502),
    [sym_labeled_statement] = STATE(502),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [307] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [aux_sym_array_repeat1] = STATE(527),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [308] = {
    [sym_string] = STATE(748),
    [sym__property_name] = STATE(748),
    [sym_computed_property_name] = STATE(748),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(1543),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [309] = {
    [sym__automatic_semicolon] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1545),
    [anon_sym_COMMA] = ACTIONS(1545),
    [anon_sym_RBRACE] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_RPAREN] = ACTIONS(1545),
    [anon_sym_in] = ACTIONS(1547),
    [anon_sym_of] = ACTIONS(1545),
    [anon_sym_SEMI] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1547),
    [anon_sym_DOT] = ACTIONS(1545),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_GT_GT] = ACTIONS(1547),
    [anon_sym_GT_GT_GT] = ACTIONS(1545),
    [anon_sym_LT_LT] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1545),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1547),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_instanceof] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1545),
  },
  [310] = {
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_EQ_GT] = ACTIONS(1051),
    [sym_comment] = ACTIONS(78),
  },
  [311] = {
    [sym_string] = STATE(748),
    [sym__property_name] = STATE(748),
    [sym_computed_property_name] = STATE(748),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(1543),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [312] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1549),
    [sym_comment] = ACTIONS(78),
  },
  [313] = {
    [sym_parenthesized_expression] = STATE(750),
    [sym__expression] = STATE(750),
    [sym_yield_expression] = STATE(750),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(750),
    [sym_jsx_fragment] = STATE(750),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(750),
    [sym_anonymous_class] = STATE(750),
    [sym_class] = STATE(750),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(750),
    [sym_generator_function] = STATE(750),
    [sym_call_expression] = STATE(750),
    [sym_new_expression] = STATE(750),
    [sym_await_expression] = STATE(750),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(750),
    [sym_augmented_assignment_expression] = STATE(750),
    [sym_ternary_expression] = STATE(750),
    [sym_binary_expression] = STATE(750),
    [sym_unary_expression] = STATE(750),
    [sym_update_expression] = STATE(750),
    [sym_string] = STATE(750),
    [sym_template_string] = STATE(750),
    [sym_regex] = STATE(750),
    [sym_meta_property] = STATE(750),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1551),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(1553),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1553),
    [sym_false] = ACTIONS(1553),
    [sym_null] = ACTIONS(1553),
    [sym_undefined] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [314] = {
    [sym_parenthesized_expression] = STATE(751),
    [sym__expression] = STATE(751),
    [sym_yield_expression] = STATE(751),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(751),
    [sym_jsx_fragment] = STATE(751),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(751),
    [sym_anonymous_class] = STATE(751),
    [sym_class] = STATE(751),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(751),
    [sym_generator_function] = STATE(751),
    [sym_call_expression] = STATE(751),
    [sym_new_expression] = STATE(751),
    [sym_await_expression] = STATE(751),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(751),
    [sym_augmented_assignment_expression] = STATE(751),
    [sym_ternary_expression] = STATE(751),
    [sym_binary_expression] = STATE(751),
    [sym_unary_expression] = STATE(751),
    [sym_update_expression] = STATE(751),
    [sym_string] = STATE(751),
    [sym_template_string] = STATE(751),
    [sym_regex] = STATE(751),
    [sym_meta_property] = STATE(751),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_RBRACE] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1555),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(1557),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1557),
    [sym_undefined] = ACTIONS(1557),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [315] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(754),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1559),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(1561),
    [anon_sym_PLUS_EQ] = ACTIONS(1563),
    [anon_sym_DASH_EQ] = ACTIONS(1563),
    [anon_sym_STAR_EQ] = ACTIONS(1563),
    [anon_sym_SLASH_EQ] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(1563),
    [anon_sym_CARET_EQ] = ACTIONS(1563),
    [anon_sym_AMP_EQ] = ACTIONS(1563),
    [anon_sym_PIPE_EQ] = ACTIONS(1563),
    [anon_sym_GT_GT_EQ] = ACTIONS(1563),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(1563),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(1565),
  },
  [316] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(755),
    [sym__expression] = STATE(755),
    [sym_yield_expression] = STATE(755),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(755),
    [sym_jsx_fragment] = STATE(755),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(755),
    [sym_anonymous_class] = STATE(755),
    [sym_class] = STATE(755),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(755),
    [sym_generator_function] = STATE(755),
    [sym_call_expression] = STATE(755),
    [sym_new_expression] = STATE(755),
    [sym_await_expression] = STATE(755),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(755),
    [sym_augmented_assignment_expression] = STATE(755),
    [sym_ternary_expression] = STATE(755),
    [sym_binary_expression] = STATE(755),
    [sym_unary_expression] = STATE(755),
    [sym_update_expression] = STATE(755),
    [sym_string] = STATE(755),
    [sym_template_string] = STATE(755),
    [sym_regex] = STATE(755),
    [sym_meta_property] = STATE(755),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1567),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(1569),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1569),
    [sym_false] = ACTIONS(1569),
    [sym_null] = ACTIONS(1569),
    [sym_undefined] = ACTIONS(1569),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [317] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1571),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(1573),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [318] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [319] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [320] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1559),
    [anon_sym_EQ_GT] = ACTIONS(1561),
    [anon_sym_PLUS_EQ] = ACTIONS(1577),
    [anon_sym_DASH_EQ] = ACTIONS(1577),
    [anon_sym_STAR_EQ] = ACTIONS(1577),
    [anon_sym_SLASH_EQ] = ACTIONS(1577),
    [anon_sym_PERCENT_EQ] = ACTIONS(1577),
    [anon_sym_CARET_EQ] = ACTIONS(1577),
    [anon_sym_AMP_EQ] = ACTIONS(1577),
    [anon_sym_PIPE_EQ] = ACTIONS(1577),
    [anon_sym_GT_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1577),
    [anon_sym_LT_LT_EQ] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [321] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1559),
    [anon_sym_PLUS_EQ] = ACTIONS(1563),
    [anon_sym_DASH_EQ] = ACTIONS(1563),
    [anon_sym_STAR_EQ] = ACTIONS(1563),
    [anon_sym_SLASH_EQ] = ACTIONS(1563),
    [anon_sym_PERCENT_EQ] = ACTIONS(1563),
    [anon_sym_CARET_EQ] = ACTIONS(1563),
    [anon_sym_AMP_EQ] = ACTIONS(1563),
    [anon_sym_PIPE_EQ] = ACTIONS(1563),
    [anon_sym_GT_GT_EQ] = ACTIONS(1563),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1563),
    [anon_sym_LT_LT_EQ] = ACTIONS(1563),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [322] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(1581),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [323] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(1559),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [324] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(1559),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [325] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(1559),
    [anon_sym_PLUS_EQ] = ACTIONS(1577),
    [anon_sym_DASH_EQ] = ACTIONS(1577),
    [anon_sym_STAR_EQ] = ACTIONS(1577),
    [anon_sym_SLASH_EQ] = ACTIONS(1577),
    [anon_sym_PERCENT_EQ] = ACTIONS(1577),
    [anon_sym_CARET_EQ] = ACTIONS(1577),
    [anon_sym_AMP_EQ] = ACTIONS(1577),
    [anon_sym_PIPE_EQ] = ACTIONS(1577),
    [anon_sym_GT_GT_EQ] = ACTIONS(1577),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1577),
    [anon_sym_LT_LT_EQ] = ACTIONS(1577),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [326] = {
    [anon_sym_EQ_GT] = ACTIONS(1561),
    [sym_comment] = ACTIONS(78),
  },
  [327] = {
    [sym_export_statement] = STATE(619),
    [sym__declaration] = STATE(619),
    [sym_import_statement] = STATE(619),
    [sym_expression_statement] = STATE(619),
    [sym_variable_declaration] = STATE(619),
    [sym_lexical_declaration] = STATE(619),
    [sym_statement_block] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(619),
    [sym_for_in_statement] = STATE(619),
    [sym_for_of_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_do_statement] = STATE(619),
    [sym_try_statement] = STATE(619),
    [sym_with_statement] = STATE(619),
    [sym_break_statement] = STATE(619),
    [sym_continue_statement] = STATE(619),
    [sym_debugger_statement] = STATE(619),
    [sym_return_statement] = STATE(619),
    [sym_throw_statement] = STATE(619),
    [sym_empty_statement] = STATE(619),
    [sym_labeled_statement] = STATE(619),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [328] = {
    [sym_parenthesized_expression] = STATE(774),
    [sym__expression] = STATE(774),
    [sym_yield_expression] = STATE(774),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(774),
    [sym_jsx_fragment] = STATE(774),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(774),
    [sym_anonymous_class] = STATE(774),
    [sym_class] = STATE(774),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(774),
    [sym_generator_function] = STATE(774),
    [sym_call_expression] = STATE(774),
    [sym_new_expression] = STATE(774),
    [sym_await_expression] = STATE(774),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(774),
    [sym_augmented_assignment_expression] = STATE(774),
    [sym_ternary_expression] = STATE(774),
    [sym_binary_expression] = STATE(774),
    [sym_unary_expression] = STATE(774),
    [sym_update_expression] = STATE(774),
    [sym_string] = STATE(774),
    [sym_template_string] = STATE(774),
    [sym_regex] = STATE(774),
    [sym_meta_property] = STATE(774),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1615),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(1619),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1619),
    [sym_false] = ACTIONS(1619),
    [sym_null] = ACTIONS(1619),
    [sym_undefined] = ACTIONS(1619),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [329] = {
    [sym__automatic_semicolon] = ACTIONS(1153),
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_RBRACE] = ACTIONS(1626),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1153),
    [anon_sym_QMARK] = ACTIONS(1153),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1153),
    [anon_sym_LT_LT] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1153),
    [anon_sym_LT_EQ] = ACTIONS(1153),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(1153),
    [anon_sym_instanceof] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1153),
  },
  [330] = {
    [sym__automatic_semicolon] = ACTIONS(1233),
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1628),
    [anon_sym_RBRACE] = ACTIONS(1631),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1233),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1233),
  },
  [331] = {
    [sym__automatic_semicolon] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1633),
    [anon_sym_RBRACE] = ACTIONS(1633),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [anon_sym_RPAREN] = ACTIONS(1633),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_of] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1633),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1633),
    [anon_sym_GT_EQ] = ACTIONS(1633),
    [anon_sym_instanceof] = ACTIONS(1633),
    [anon_sym_PLUS_PLUS] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1633),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1633),
  },
  [332] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [sym_comment] = ACTIONS(78),
  },
  [333] = {
    [sym__automatic_semicolon] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1639),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_in] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1239),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1237),
  },
  [334] = {
    [sym_parenthesized_expression] = STATE(780),
    [sym__expression] = STATE(780),
    [sym_yield_expression] = STATE(780),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(780),
    [sym_jsx_fragment] = STATE(780),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(780),
    [sym_anonymous_class] = STATE(780),
    [sym_class] = STATE(780),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(780),
    [sym_generator_function] = STATE(780),
    [sym_call_expression] = STATE(780),
    [sym_new_expression] = STATE(780),
    [sym_await_expression] = STATE(780),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(780),
    [sym_augmented_assignment_expression] = STATE(780),
    [sym_ternary_expression] = STATE(780),
    [sym_binary_expression] = STATE(780),
    [sym_unary_expression] = STATE(780),
    [sym_update_expression] = STATE(780),
    [sym_string] = STATE(780),
    [sym_template_string] = STATE(780),
    [sym_regex] = STATE(780),
    [sym_meta_property] = STATE(780),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1644),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(1646),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1646),
    [sym_false] = ACTIONS(1646),
    [sym_null] = ACTIONS(1646),
    [sym_undefined] = ACTIONS(1646),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [335] = {
    [sym_statement_block] = STATE(781),
    [anon_sym_LBRACE] = ACTIONS(226),
    [sym_comment] = ACTIONS(78),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(1648),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_STAR] = ACTIONS(1648),
    [anon_sym_default] = ACTIONS(1650),
    [anon_sym_LBRACE] = ACTIONS(1648),
    [anon_sym_COMMA] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_import] = ACTIONS(1650),
    [anon_sym_var] = ACTIONS(1650),
    [anon_sym_let] = ACTIONS(1650),
    [anon_sym_const] = ACTIONS(1650),
    [anon_sym_if] = ACTIONS(1650),
    [anon_sym_else] = ACTIONS(1650),
    [anon_sym_switch] = ACTIONS(1650),
    [anon_sym_for] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1648),
    [anon_sym_await] = ACTIONS(1650),
    [anon_sym_while] = ACTIONS(1650),
    [anon_sym_do] = ACTIONS(1650),
    [anon_sym_try] = ACTIONS(1650),
    [anon_sym_with] = ACTIONS(1650),
    [anon_sym_break] = ACTIONS(1650),
    [anon_sym_continue] = ACTIONS(1650),
    [anon_sym_debugger] = ACTIONS(1650),
    [anon_sym_return] = ACTIONS(1650),
    [anon_sym_throw] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1650),
    [anon_sym_catch] = ACTIONS(1650),
    [anon_sym_finally] = ACTIONS(1650),
    [anon_sym_yield] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(1648),
    [anon_sym_SLASH] = ACTIONS(1650),
    [anon_sym_class] = ACTIONS(1650),
    [anon_sym_async] = ACTIONS(1650),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1648),
    [anon_sym_new] = ACTIONS(1650),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_typeof] = ACTIONS(1650),
    [anon_sym_void] = ACTIONS(1650),
    [anon_sym_delete] = ACTIONS(1650),
    [anon_sym_PLUS_PLUS] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [anon_sym_SQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_number] = ACTIONS(1648),
    [sym_identifier] = ACTIONS(1650),
    [sym_this] = ACTIONS(1650),
    [sym_super] = ACTIONS(1650),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_null] = ACTIONS(1650),
    [sym_undefined] = ACTIONS(1650),
    [anon_sym_AT] = ACTIONS(1648),
    [anon_sym_static] = ACTIONS(1650),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
  },
  [337] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(1652),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [338] = {
    [sym_export_statement] = STATE(338),
    [sym__declaration] = STATE(338),
    [sym_import_statement] = STATE(338),
    [sym_expression_statement] = STATE(338),
    [sym_variable_declaration] = STATE(338),
    [sym_lexical_declaration] = STATE(338),
    [sym_statement_block] = STATE(338),
    [sym_if_statement] = STATE(338),
    [sym_switch_statement] = STATE(338),
    [sym_for_statement] = STATE(338),
    [sym_for_in_statement] = STATE(338),
    [sym_for_of_statement] = STATE(338),
    [sym_while_statement] = STATE(338),
    [sym_do_statement] = STATE(338),
    [sym_try_statement] = STATE(338),
    [sym_with_statement] = STATE(338),
    [sym_break_statement] = STATE(338),
    [sym_continue_statement] = STATE(338),
    [sym_debugger_statement] = STATE(338),
    [sym_return_statement] = STATE(338),
    [sym_throw_statement] = STATE(338),
    [sym_empty_statement] = STATE(338),
    [sym_labeled_statement] = STATE(338),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(338),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_import] = ACTIONS(1277),
    [anon_sym_var] = ACTIONS(1280),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1283),
    [anon_sym_if] = ACTIONS(1654),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(1657),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_await] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1660),
    [anon_sym_do] = ACTIONS(1304),
    [anon_sym_try] = ACTIONS(1307),
    [anon_sym_with] = ACTIONS(1663),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_debugger] = ACTIONS(1319),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym_yield] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1340),
    [anon_sym_class] = ACTIONS(1343),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1352),
    [anon_sym_new] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(1361),
    [anon_sym_typeof] = ACTIONS(1358),
    [anon_sym_void] = ACTIONS(1358),
    [anon_sym_delete] = ACTIONS(1358),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [sym_number] = ACTIONS(1376),
    [sym_identifier] = ACTIONS(1666),
    [sym_this] = ACTIONS(1382),
    [sym_super] = ACTIONS(1385),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [sym_null] = ACTIONS(1382),
    [sym_undefined] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1388),
    [anon_sym_get] = ACTIONS(1391),
    [anon_sym_set] = ACTIONS(1391),
  },
  [339] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [340] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [341] = {
    [aux_sym_object_repeat1] = STATE(782),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [sym_comment] = ACTIONS(78),
  },
  [342] = {
    [sym_formal_parameters] = STATE(335),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [343] = {
    [sym_decorator] = STATE(343),
    [aux_sym_export_statement_repeat1] = STATE(343),
    [anon_sym_export] = ACTIONS(1669),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_class] = ACTIONS(1669),
    [anon_sym_async] = ACTIONS(1669),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1669),
    [anon_sym_AT] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1669),
    [anon_sym_set] = ACTIONS(1669),
  },
  [344] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [sym_comment] = ACTIONS(78),
  },
  [345] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1674),
  },
  [346] = {
    [anon_sym_RBRACE] = ACTIONS(1676),
    [sym_comment] = ACTIONS(78),
  },
  [347] = {
    [anon_sym_from] = ACTIONS(1678),
    [sym_comment] = ACTIONS(78),
  },
  [348] = {
    [aux_sym_named_imports_repeat1] = STATE(787),
    [anon_sym_COMMA] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(78),
  },
  [349] = {
    [sym_namespace_import] = STATE(788),
    [sym_named_imports] = STATE(788),
    [anon_sym_STAR] = ACTIONS(138),
    [anon_sym_LBRACE] = ACTIONS(140),
    [sym_comment] = ACTIONS(78),
  },
  [350] = {
    [sym__automatic_semicolon] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [sym_comment] = ACTIONS(78),
  },
  [351] = {
    [ts_builtin_sym_end] = ACTIONS(1686),
    [anon_sym_export] = ACTIONS(1688),
    [anon_sym_default] = ACTIONS(1688),
    [anon_sym_LBRACE] = ACTIONS(1686),
    [anon_sym_RBRACE] = ACTIONS(1686),
    [anon_sym_import] = ACTIONS(1688),
    [anon_sym_var] = ACTIONS(1688),
    [anon_sym_let] = ACTIONS(1688),
    [anon_sym_const] = ACTIONS(1688),
    [anon_sym_if] = ACTIONS(1688),
    [anon_sym_else] = ACTIONS(1688),
    [anon_sym_switch] = ACTIONS(1688),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_LPAREN] = ACTIONS(1686),
    [anon_sym_await] = ACTIONS(1688),
    [anon_sym_while] = ACTIONS(1688),
    [anon_sym_do] = ACTIONS(1688),
    [anon_sym_try] = ACTIONS(1688),
    [anon_sym_with] = ACTIONS(1688),
    [anon_sym_break] = ACTIONS(1688),
    [anon_sym_continue] = ACTIONS(1688),
    [anon_sym_debugger] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1688),
    [anon_sym_throw] = ACTIONS(1688),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_case] = ACTIONS(1688),
    [anon_sym_yield] = ACTIONS(1688),
    [anon_sym_LBRACK] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(1686),
    [anon_sym_SLASH] = ACTIONS(1688),
    [anon_sym_class] = ACTIONS(1688),
    [anon_sym_async] = ACTIONS(1688),
    [anon_sym_function] = ACTIONS(1688),
    [anon_sym_EQ_GT] = ACTIONS(1686),
    [anon_sym_new] = ACTIONS(1688),
    [anon_sym_PLUS] = ACTIONS(1688),
    [anon_sym_DASH] = ACTIONS(1688),
    [anon_sym_BANG] = ACTIONS(1686),
    [anon_sym_TILDE] = ACTIONS(1686),
    [anon_sym_typeof] = ACTIONS(1688),
    [anon_sym_void] = ACTIONS(1688),
    [anon_sym_delete] = ACTIONS(1688),
    [anon_sym_PLUS_PLUS] = ACTIONS(1686),
    [anon_sym_DASH_DASH] = ACTIONS(1686),
    [anon_sym_DQUOTE] = ACTIONS(1686),
    [anon_sym_SQUOTE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1686),
    [sym_number] = ACTIONS(1686),
    [sym_identifier] = ACTIONS(1688),
    [sym_this] = ACTIONS(1688),
    [sym_super] = ACTIONS(1688),
    [sym_true] = ACTIONS(1688),
    [sym_false] = ACTIONS(1688),
    [sym_null] = ACTIONS(1688),
    [sym_undefined] = ACTIONS(1688),
    [anon_sym_AT] = ACTIONS(1686),
    [anon_sym_get] = ACTIONS(1688),
    [anon_sym_set] = ACTIONS(1688),
  },
  [352] = {
    [sym__automatic_semicolon] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(515),
    [anon_sym_in] = ACTIONS(515),
    [anon_sym_of] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(515),
    [sym_comment] = ACTIONS(78),
  },
  [353] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(791),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [354] = {
    [sym__initializer] = STATE(729),
    [aux_sym_object_repeat1] = STATE(791),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(1519),
    [sym_comment] = ACTIONS(78),
  },
  [355] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(791),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [356] = {
    [aux_sym_object_repeat1] = STATE(793),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1692),
    [sym_comment] = ACTIONS(78),
  },
  [357] = {
    [sym_string] = STATE(342),
    [sym_decorator] = STATE(733),
    [sym_method_definition] = STATE(794),
    [sym__property_name] = STATE(342),
    [sym_computed_property_name] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(733),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(605),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(607),
    [anon_sym_set] = ACTIONS(607),
  },
  [358] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1692),
    [sym_comment] = ACTIONS(78),
  },
  [359] = {
    [sym__automatic_semicolon] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_in] = ACTIONS(913),
    [anon_sym_of] = ACTIONS(913),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(913),
    [sym_comment] = ACTIONS(78),
  },
  [360] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [aux_sym_array_repeat1] = STATE(796),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [361] = {
    [aux_sym_array_repeat1] = STATE(796),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(1694),
    [sym_comment] = ACTIONS(78),
  },
  [362] = {
    [aux_sym_array_repeat1] = STATE(530),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(1694),
    [sym_comment] = ACTIONS(78),
  },
  [363] = {
    [sym__automatic_semicolon] = ACTIONS(1696),
    [anon_sym_COMMA] = ACTIONS(1696),
    [anon_sym_SEMI] = ACTIONS(1696),
    [sym_comment] = ACTIONS(78),
  },
  [364] = {
    [ts_builtin_sym_end] = ACTIONS(1698),
    [anon_sym_export] = ACTIONS(1700),
    [anon_sym_default] = ACTIONS(1700),
    [anon_sym_LBRACE] = ACTIONS(1698),
    [anon_sym_RBRACE] = ACTIONS(1698),
    [anon_sym_import] = ACTIONS(1700),
    [anon_sym_var] = ACTIONS(1700),
    [anon_sym_let] = ACTIONS(1700),
    [anon_sym_const] = ACTIONS(1700),
    [anon_sym_if] = ACTIONS(1700),
    [anon_sym_else] = ACTIONS(1700),
    [anon_sym_switch] = ACTIONS(1700),
    [anon_sym_for] = ACTIONS(1700),
    [anon_sym_LPAREN] = ACTIONS(1698),
    [anon_sym_await] = ACTIONS(1700),
    [anon_sym_while] = ACTIONS(1700),
    [anon_sym_do] = ACTIONS(1700),
    [anon_sym_try] = ACTIONS(1700),
    [anon_sym_with] = ACTIONS(1700),
    [anon_sym_break] = ACTIONS(1700),
    [anon_sym_continue] = ACTIONS(1700),
    [anon_sym_debugger] = ACTIONS(1700),
    [anon_sym_return] = ACTIONS(1700),
    [anon_sym_throw] = ACTIONS(1700),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_case] = ACTIONS(1700),
    [anon_sym_yield] = ACTIONS(1700),
    [anon_sym_LBRACK] = ACTIONS(1698),
    [anon_sym_LT] = ACTIONS(1698),
    [anon_sym_SLASH] = ACTIONS(1700),
    [anon_sym_class] = ACTIONS(1700),
    [anon_sym_async] = ACTIONS(1700),
    [anon_sym_function] = ACTIONS(1700),
    [anon_sym_EQ_GT] = ACTIONS(1698),
    [anon_sym_new] = ACTIONS(1700),
    [anon_sym_PLUS] = ACTIONS(1700),
    [anon_sym_DASH] = ACTIONS(1700),
    [anon_sym_BANG] = ACTIONS(1698),
    [anon_sym_TILDE] = ACTIONS(1698),
    [anon_sym_typeof] = ACTIONS(1700),
    [anon_sym_void] = ACTIONS(1700),
    [anon_sym_delete] = ACTIONS(1700),
    [anon_sym_PLUS_PLUS] = ACTIONS(1698),
    [anon_sym_DASH_DASH] = ACTIONS(1698),
    [anon_sym_DQUOTE] = ACTIONS(1698),
    [anon_sym_SQUOTE] = ACTIONS(1698),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1698),
    [sym_number] = ACTIONS(1698),
    [sym_identifier] = ACTIONS(1700),
    [sym_this] = ACTIONS(1700),
    [sym_super] = ACTIONS(1700),
    [sym_true] = ACTIONS(1700),
    [sym_false] = ACTIONS(1700),
    [sym_null] = ACTIONS(1700),
    [sym_undefined] = ACTIONS(1700),
    [anon_sym_AT] = ACTIONS(1698),
    [anon_sym_get] = ACTIONS(1700),
    [anon_sym_set] = ACTIONS(1700),
  },
  [365] = {
    [sym_variable_declarator] = STATE(797),
    [sym_object] = STATE(94),
    [sym_array] = STATE(95),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(148),
  },
  [366] = {
    [aux_sym_variable_declaration_repeat1] = STATE(799),
    [sym__automatic_semicolon] = ACTIONS(1702),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_SEMI] = ACTIONS(1702),
    [sym_comment] = ACTIONS(78),
  },
  [367] = {
    [sym__automatic_semicolon] = ACTIONS(1704),
    [anon_sym_COMMA] = ACTIONS(1704),
    [anon_sym_SEMI] = ACTIONS(1704),
    [sym_comment] = ACTIONS(78),
  },
  [368] = {
    [sym__automatic_semicolon] = ACTIONS(1706),
    [anon_sym_COMMA] = ACTIONS(1706),
    [anon_sym_SEMI] = ACTIONS(1706),
    [sym_comment] = ACTIONS(78),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(1708),
    [anon_sym_export] = ACTIONS(1710),
    [anon_sym_default] = ACTIONS(1710),
    [anon_sym_LBRACE] = ACTIONS(1708),
    [anon_sym_RBRACE] = ACTIONS(1708),
    [anon_sym_import] = ACTIONS(1710),
    [anon_sym_var] = ACTIONS(1710),
    [anon_sym_let] = ACTIONS(1710),
    [anon_sym_const] = ACTIONS(1710),
    [anon_sym_if] = ACTIONS(1710),
    [anon_sym_else] = ACTIONS(1710),
    [anon_sym_switch] = ACTIONS(1710),
    [anon_sym_for] = ACTIONS(1710),
    [anon_sym_LPAREN] = ACTIONS(1708),
    [anon_sym_await] = ACTIONS(1710),
    [anon_sym_while] = ACTIONS(1710),
    [anon_sym_do] = ACTIONS(1710),
    [anon_sym_try] = ACTIONS(1710),
    [anon_sym_with] = ACTIONS(1710),
    [anon_sym_break] = ACTIONS(1710),
    [anon_sym_continue] = ACTIONS(1710),
    [anon_sym_debugger] = ACTIONS(1710),
    [anon_sym_return] = ACTIONS(1710),
    [anon_sym_throw] = ACTIONS(1710),
    [anon_sym_SEMI] = ACTIONS(1708),
    [anon_sym_case] = ACTIONS(1710),
    [anon_sym_yield] = ACTIONS(1710),
    [anon_sym_LBRACK] = ACTIONS(1708),
    [anon_sym_LT] = ACTIONS(1708),
    [anon_sym_SLASH] = ACTIONS(1710),
    [anon_sym_class] = ACTIONS(1710),
    [anon_sym_async] = ACTIONS(1710),
    [anon_sym_function] = ACTIONS(1710),
    [anon_sym_EQ_GT] = ACTIONS(1708),
    [anon_sym_new] = ACTIONS(1710),
    [anon_sym_PLUS] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(1710),
    [anon_sym_BANG] = ACTIONS(1708),
    [anon_sym_TILDE] = ACTIONS(1708),
    [anon_sym_typeof] = ACTIONS(1710),
    [anon_sym_void] = ACTIONS(1710),
    [anon_sym_delete] = ACTIONS(1710),
    [anon_sym_PLUS_PLUS] = ACTIONS(1708),
    [anon_sym_DASH_DASH] = ACTIONS(1708),
    [anon_sym_DQUOTE] = ACTIONS(1708),
    [anon_sym_SQUOTE] = ACTIONS(1708),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1708),
    [sym_number] = ACTIONS(1708),
    [sym_identifier] = ACTIONS(1710),
    [sym_this] = ACTIONS(1710),
    [sym_super] = ACTIONS(1710),
    [sym_true] = ACTIONS(1710),
    [sym_false] = ACTIONS(1710),
    [sym_null] = ACTIONS(1710),
    [sym_undefined] = ACTIONS(1710),
    [anon_sym_AT] = ACTIONS(1708),
    [anon_sym_get] = ACTIONS(1710),
    [anon_sym_set] = ACTIONS(1710),
  },
  [370] = {
    [aux_sym_variable_declaration_repeat1] = STATE(799),
    [sym__automatic_semicolon] = ACTIONS(1712),
    [anon_sym_COMMA] = ACTIONS(641),
    [anon_sym_SEMI] = ACTIONS(1712),
    [sym_comment] = ACTIONS(78),
  },
  [371] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(425),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(735),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(737),
  },
  [372] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_PLUS_EQ] = ACTIONS(791),
    [anon_sym_DASH_EQ] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(791),
    [anon_sym_SLASH_EQ] = ACTIONS(791),
    [anon_sym_PERCENT_EQ] = ACTIONS(791),
    [anon_sym_CARET_EQ] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [373] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_PLUS_EQ] = ACTIONS(735),
    [anon_sym_DASH_EQ] = ACTIONS(735),
    [anon_sym_STAR_EQ] = ACTIONS(735),
    [anon_sym_SLASH_EQ] = ACTIONS(735),
    [anon_sym_PERCENT_EQ] = ACTIONS(735),
    [anon_sym_CARET_EQ] = ACTIONS(735),
    [anon_sym_AMP_EQ] = ACTIONS(735),
    [anon_sym_PIPE_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_EQ] = ACTIONS(735),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(735),
    [anon_sym_LT_LT_EQ] = ACTIONS(735),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [374] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1714),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [375] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [376] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [377] = {
    [anon_sym_RPAREN] = ACTIONS(1714),
    [sym_comment] = ACTIONS(78),
  },
  [378] = {
    [sym_parenthesized_expression] = STATE(802),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [379] = {
    [anon_sym_LPAREN] = ACTIONS(1716),
    [anon_sym_await] = ACTIONS(1718),
    [sym_comment] = ACTIONS(78),
  },
  [380] = {
    [sym_parenthesized_expression] = STATE(805),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [381] = {
    [sym_parenthesized_expression] = STATE(806),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [382] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(1720),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [383] = {
    [ts_builtin_sym_end] = ACTIONS(1722),
    [anon_sym_export] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_import] = ACTIONS(1724),
    [anon_sym_var] = ACTIONS(1724),
    [anon_sym_let] = ACTIONS(1724),
    [anon_sym_const] = ACTIONS(1724),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_else] = ACTIONS(1726),
    [anon_sym_switch] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1724),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_await] = ACTIONS(1724),
    [anon_sym_while] = ACTIONS(1724),
    [anon_sym_do] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(1724),
    [anon_sym_with] = ACTIONS(1724),
    [anon_sym_break] = ACTIONS(1724),
    [anon_sym_continue] = ACTIONS(1724),
    [anon_sym_debugger] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1724),
    [anon_sym_throw] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_yield] = ACTIONS(1724),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1724),
    [anon_sym_class] = ACTIONS(1724),
    [anon_sym_async] = ACTIONS(1724),
    [anon_sym_function] = ACTIONS(1724),
    [anon_sym_EQ_GT] = ACTIONS(1722),
    [anon_sym_new] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_typeof] = ACTIONS(1724),
    [anon_sym_void] = ACTIONS(1724),
    [anon_sym_delete] = ACTIONS(1724),
    [anon_sym_PLUS_PLUS] = ACTIONS(1722),
    [anon_sym_DASH_DASH] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [sym_number] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1724),
    [sym_this] = ACTIONS(1724),
    [sym_super] = ACTIONS(1724),
    [sym_true] = ACTIONS(1724),
    [sym_false] = ACTIONS(1724),
    [sym_null] = ACTIONS(1724),
    [sym_undefined] = ACTIONS(1724),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_get] = ACTIONS(1724),
    [anon_sym_set] = ACTIONS(1724),
  },
  [384] = {
    [sym_switch_case] = STATE(812),
    [sym_switch_default] = STATE(812),
    [aux_sym_switch_body_repeat1] = STATE(812),
    [anon_sym_default] = ACTIONS(1728),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_case] = ACTIONS(1732),
    [sym_comment] = ACTIONS(78),
  },
  [385] = {
    [ts_builtin_sym_end] = ACTIONS(1734),
    [anon_sym_export] = ACTIONS(1736),
    [anon_sym_default] = ACTIONS(1736),
    [anon_sym_LBRACE] = ACTIONS(1734),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_import] = ACTIONS(1736),
    [anon_sym_var] = ACTIONS(1736),
    [anon_sym_let] = ACTIONS(1736),
    [anon_sym_const] = ACTIONS(1736),
    [anon_sym_if] = ACTIONS(1736),
    [anon_sym_else] = ACTIONS(1736),
    [anon_sym_switch] = ACTIONS(1736),
    [anon_sym_for] = ACTIONS(1736),
    [anon_sym_LPAREN] = ACTIONS(1734),
    [anon_sym_await] = ACTIONS(1736),
    [anon_sym_while] = ACTIONS(1736),
    [anon_sym_do] = ACTIONS(1736),
    [anon_sym_try] = ACTIONS(1736),
    [anon_sym_with] = ACTIONS(1736),
    [anon_sym_break] = ACTIONS(1736),
    [anon_sym_continue] = ACTIONS(1736),
    [anon_sym_debugger] = ACTIONS(1736),
    [anon_sym_return] = ACTIONS(1736),
    [anon_sym_throw] = ACTIONS(1736),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_case] = ACTIONS(1736),
    [anon_sym_yield] = ACTIONS(1736),
    [anon_sym_LBRACK] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_SLASH] = ACTIONS(1736),
    [anon_sym_class] = ACTIONS(1736),
    [anon_sym_async] = ACTIONS(1736),
    [anon_sym_function] = ACTIONS(1736),
    [anon_sym_EQ_GT] = ACTIONS(1734),
    [anon_sym_new] = ACTIONS(1736),
    [anon_sym_PLUS] = ACTIONS(1736),
    [anon_sym_DASH] = ACTIONS(1736),
    [anon_sym_BANG] = ACTIONS(1734),
    [anon_sym_TILDE] = ACTIONS(1734),
    [anon_sym_typeof] = ACTIONS(1736),
    [anon_sym_void] = ACTIONS(1736),
    [anon_sym_delete] = ACTIONS(1736),
    [anon_sym_PLUS_PLUS] = ACTIONS(1734),
    [anon_sym_DASH_DASH] = ACTIONS(1734),
    [anon_sym_DQUOTE] = ACTIONS(1734),
    [anon_sym_SQUOTE] = ACTIONS(1734),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1734),
    [sym_number] = ACTIONS(1734),
    [sym_identifier] = ACTIONS(1736),
    [sym_this] = ACTIONS(1736),
    [sym_super] = ACTIONS(1736),
    [sym_true] = ACTIONS(1736),
    [sym_false] = ACTIONS(1736),
    [sym_null] = ACTIONS(1736),
    [sym_undefined] = ACTIONS(1736),
    [anon_sym_AT] = ACTIONS(1734),
    [anon_sym_get] = ACTIONS(1736),
    [anon_sym_set] = ACTIONS(1736),
  },
  [386] = {
    [sym_variable_declarator] = STATE(93),
    [sym_object] = STATE(814),
    [sym_array] = STATE(815),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1738),
  },
  [387] = {
    [sym_variable_declarator] = STATE(96),
    [sym_object] = STATE(814),
    [sym_array] = STATE(815),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1738),
  },
  [388] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1740),
    [anon_sym_of] = ACTIONS(1742),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [389] = {
    [sym_expression_statement] = STATE(818),
    [sym_empty_statement] = STATE(818),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [390] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1744),
    [anon_sym_of] = ACTIONS(1746),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [391] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1748),
    [anon_sym_of] = ACTIONS(1750),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [392] = {
    [sym_object] = STATE(825),
    [sym_array] = STATE(826),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_var] = ACTIONS(1752),
    [anon_sym_let] = ACTIONS(1752),
    [anon_sym_const] = ACTIONS(1752),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1754),
  },
  [393] = {
    [anon_sym_STAR] = ACTIONS(515),
    [anon_sym_LBRACE] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_RPAREN] = ACTIONS(515),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_of] = ACTIONS(515),
    [anon_sym_COLON] = ACTIONS(515),
    [anon_sym_LBRACK] = ACTIONS(515),
    [anon_sym_RBRACK] = ACTIONS(515),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(515),
    [anon_sym_LT_LT] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(515),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(515),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [anon_sym_instanceof] = ACTIONS(515),
    [anon_sym_PLUS_PLUS] = ACTIONS(515),
    [anon_sym_DASH_DASH] = ACTIONS(515),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(515),
  },
  [394] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(828),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [395] = {
    [sym__initializer] = STATE(729),
    [aux_sym_object_repeat1] = STATE(828),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(1519),
    [sym_comment] = ACTIONS(78),
  },
  [396] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(828),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [397] = {
    [aux_sym_object_repeat1] = STATE(830),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(78),
  },
  [398] = {
    [sym_string] = STATE(342),
    [sym_decorator] = STATE(733),
    [sym_method_definition] = STATE(831),
    [sym__property_name] = STATE(342),
    [sym_computed_property_name] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(733),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(605),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(607),
    [anon_sym_set] = ACTIONS(607),
  },
  [399] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1758),
    [sym_comment] = ACTIONS(78),
  },
  [400] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1760),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [401] = {
    [anon_sym_RPAREN] = ACTIONS(1760),
    [sym_comment] = ACTIONS(78),
  },
  [402] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [403] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [404] = {
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_of] = ACTIONS(913),
    [anon_sym_COLON] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_RBRACK] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_DOT] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_GT_GT_GT] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(913),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_EQ_EQ] = ACTIONS(915),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(915),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(913),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_instanceof] = ACTIONS(913),
    [anon_sym_PLUS_PLUS] = ACTIONS(913),
    [anon_sym_DASH_DASH] = ACTIONS(913),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(913),
  },
  [405] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [aux_sym_array_repeat1] = STATE(834),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [406] = {
    [aux_sym_array_repeat1] = STATE(834),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(1762),
    [sym_comment] = ACTIONS(78),
  },
  [407] = {
    [aux_sym_array_repeat1] = STATE(530),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(1762),
    [sym_comment] = ACTIONS(78),
  },
  [408] = {
    [sym_jsx_element] = STATE(836),
    [sym_jsx_expression] = STATE(836),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_self_closing_element] = STATE(836),
    [aux_sym_jsx_element_repeat1] = STATE(836),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(1764),
    [sym_jsx_text] = ACTIONS(1766),
    [sym_comment] = ACTIONS(78),
  },
  [409] = {
    [sym_jsx_expression] = STATE(838),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(838),
    [aux_sym_jsx_opening_element_repeat1] = STATE(838),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(1768),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [410] = {
    [sym_jsx_expression] = STATE(838),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(838),
    [aux_sym_jsx_opening_element_repeat1] = STATE(838),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(1768),
    [sym_jsx_identifier] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [411] = {
    [sym_jsx_expression] = STATE(838),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(838),
    [aux_sym_jsx_opening_element_repeat1] = STATE(838),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(1768),
    [sym_jsx_identifier] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [412] = {
    [sym_jsx_expression] = STATE(838),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(838),
    [aux_sym_jsx_opening_element_repeat1] = STATE(838),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(1768),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [413] = {
    [sym_comment] = ACTIONS(78),
    [anon_sym_SLASH2] = ACTIONS(1770),
  },
  [414] = {
    [sym_string] = STATE(552),
    [sym_decorator] = STATE(553),
    [sym_public_field_definition] = STATE(550),
    [sym_method_definition] = STATE(551),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [aux_sym_export_statement_repeat1] = STATE(553),
    [aux_sym_class_body_repeat1] = STATE(841),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_RBRACE] = ACTIONS(1772),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
  },
  [415] = {
    [sym_class_heritage] = STATE(842),
    [sym_class_body] = STATE(843),
    [anon_sym_LBRACE] = ACTIONS(717),
    [anon_sym_extends] = ACTIONS(1023),
    [sym_comment] = ACTIONS(78),
  },
  [416] = {
    [sym_class_body] = STATE(844),
    [anon_sym_LBRACE] = ACTIONS(717),
    [sym_comment] = ACTIONS(78),
  },
  [417] = {
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_LBRACE] = ACTIONS(1025),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(1025),
    [anon_sym_RPAREN] = ACTIONS(1025),
    [anon_sym_in] = ACTIONS(1027),
    [anon_sym_COLON] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1025),
    [anon_sym_RBRACK] = ACTIONS(1025),
    [anon_sym_LT] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1025),
    [anon_sym_QMARK] = ACTIONS(1025),
    [anon_sym_AMP_AMP] = ACTIONS(1025),
    [anon_sym_PIPE_PIPE] = ACTIONS(1025),
    [anon_sym_GT_GT] = ACTIONS(1027),
    [anon_sym_GT_GT_GT] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1025),
    [anon_sym_LT_EQ] = ACTIONS(1025),
    [anon_sym_EQ_EQ] = ACTIONS(1027),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1025),
    [anon_sym_BANG_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1025),
    [anon_sym_instanceof] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1025),
  },
  [418] = {
    [sym_object] = STATE(847),
    [sym_assignment_pattern] = STATE(848),
    [sym_array] = STATE(849),
    [sym_rest_parameter] = STATE(848),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1774),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(182),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1776),
    [anon_sym_get] = ACTIONS(1774),
    [anon_sym_set] = ACTIONS(1774),
  },
  [419] = {
    [anon_sym_LBRACE] = ACTIONS(1778),
    [anon_sym_EQ_GT] = ACTIONS(1778),
    [sym_comment] = ACTIONS(78),
  },
  [420] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1780),
  },
  [421] = {
    [sym_parenthesized_expression] = STATE(851),
    [sym__expression] = STATE(851),
    [sym_yield_expression] = STATE(851),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(851),
    [sym_jsx_fragment] = STATE(851),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(851),
    [sym_anonymous_class] = STATE(851),
    [sym_class] = STATE(851),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(851),
    [sym_generator_function] = STATE(851),
    [sym_call_expression] = STATE(851),
    [sym_new_expression] = STATE(851),
    [sym_await_expression] = STATE(851),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(851),
    [sym_augmented_assignment_expression] = STATE(851),
    [sym_ternary_expression] = STATE(851),
    [sym_binary_expression] = STATE(851),
    [sym_unary_expression] = STATE(851),
    [sym_update_expression] = STATE(851),
    [sym_string] = STATE(851),
    [sym_template_string] = STATE(851),
    [sym_regex] = STATE(851),
    [sym_meta_property] = STATE(851),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1782),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1784),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1784),
    [sym_false] = ACTIONS(1784),
    [sym_null] = ACTIONS(1784),
    [sym_undefined] = ACTIONS(1784),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [422] = {
    [sym_formal_parameters] = STATE(853),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1786),
  },
  [423] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(855),
    [sym__expression] = STATE(855),
    [sym_yield_expression] = STATE(855),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(855),
    [sym_jsx_fragment] = STATE(855),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(855),
    [sym_anonymous_class] = STATE(855),
    [sym_class] = STATE(855),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(855),
    [sym_generator_function] = STATE(855),
    [sym_call_expression] = STATE(855),
    [sym_new_expression] = STATE(855),
    [sym_await_expression] = STATE(855),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(855),
    [sym_augmented_assignment_expression] = STATE(855),
    [sym_ternary_expression] = STATE(855),
    [sym_binary_expression] = STATE(855),
    [sym_unary_expression] = STATE(855),
    [sym_update_expression] = STATE(855),
    [sym_string] = STATE(855),
    [sym_template_string] = STATE(855),
    [sym_regex] = STATE(855),
    [sym_meta_property] = STATE(855),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1788),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1790),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1790),
    [sym_false] = ACTIONS(1790),
    [sym_null] = ACTIONS(1790),
    [sym_undefined] = ACTIONS(1790),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [424] = {
    [sym_parenthesized_expression] = STATE(856),
    [sym__expression] = STATE(856),
    [sym_yield_expression] = STATE(856),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(856),
    [sym_jsx_fragment] = STATE(856),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(856),
    [sym_anonymous_class] = STATE(856),
    [sym_class] = STATE(856),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(856),
    [sym_generator_function] = STATE(856),
    [sym_call_expression] = STATE(856),
    [sym_new_expression] = STATE(856),
    [sym_await_expression] = STATE(856),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(856),
    [sym_augmented_assignment_expression] = STATE(856),
    [sym_ternary_expression] = STATE(856),
    [sym_binary_expression] = STATE(856),
    [sym_unary_expression] = STATE(856),
    [sym_update_expression] = STATE(856),
    [sym_string] = STATE(856),
    [sym_template_string] = STATE(856),
    [sym_regex] = STATE(856),
    [sym_meta_property] = STATE(856),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1792),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1794),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1794),
    [sym_false] = ACTIONS(1794),
    [sym_null] = ACTIONS(1794),
    [sym_undefined] = ACTIONS(1794),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [425] = {
    [anon_sym_EQ_GT] = ACTIONS(1796),
    [sym_comment] = ACTIONS(78),
  },
  [426] = {
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(1055),
    [anon_sym_COLON] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1053),
    [anon_sym_RBRACK] = ACTIONS(1053),
    [anon_sym_LT] = ACTIONS(1055),
    [anon_sym_GT] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(1055),
    [anon_sym_DOT] = ACTIONS(1053),
    [anon_sym_QMARK] = ACTIONS(1053),
    [anon_sym_AMP_AMP] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_GT_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_PERCENT] = ACTIONS(1053),
    [anon_sym_LT_EQ] = ACTIONS(1053),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1053),
    [anon_sym_GT_EQ] = ACTIONS(1053),
    [anon_sym_instanceof] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1053),
    [anon_sym_DASH_DASH] = ACTIONS(1053),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1053),
  },
  [427] = {
    [aux_sym_formal_parameters_repeat1] = STATE(859),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(1798),
    [sym_comment] = ACTIONS(78),
  },
  [428] = {
    [sym_formal_parameters] = STATE(861),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1800),
  },
  [429] = {
    [sym_formal_parameters] = STATE(853),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [430] = {
    [sym_statement_block] = STATE(863),
    [anon_sym_LBRACE] = ACTIONS(1802),
    [sym_comment] = ACTIONS(78),
  },
  [431] = {
    [sym_export_statement] = STATE(867),
    [sym__declaration] = STATE(867),
    [sym_import_statement] = STATE(867),
    [sym_expression_statement] = STATE(867),
    [sym_variable_declaration] = STATE(867),
    [sym_lexical_declaration] = STATE(867),
    [sym_statement_block] = STATE(867),
    [sym_if_statement] = STATE(867),
    [sym_switch_statement] = STATE(867),
    [sym_for_statement] = STATE(867),
    [sym_for_in_statement] = STATE(867),
    [sym_for_of_statement] = STATE(867),
    [sym_while_statement] = STATE(867),
    [sym_do_statement] = STATE(867),
    [sym_try_statement] = STATE(867),
    [sym_with_statement] = STATE(867),
    [sym_break_statement] = STATE(867),
    [sym_continue_statement] = STATE(867),
    [sym_debugger_statement] = STATE(867),
    [sym_return_statement] = STATE(867),
    [sym_throw_statement] = STATE(867),
    [sym_empty_statement] = STATE(867),
    [sym_labeled_statement] = STATE(867),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(77),
    [sym_assignment_pattern] = STATE(397),
    [sym_array] = STATE(79),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_spread_element] = STATE(397),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(74),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(868),
    [sym_formal_parameters] = STATE(50),
    [sym_method_definition] = STATE(397),
    [sym_pair] = STATE(397),
    [sym__property_name] = STATE(80),
    [sym_computed_property_name] = STATE(80),
    [aux_sym_program_repeat1] = STATE(867),
    [aux_sym_export_statement_repeat1] = STATE(868),
    [aux_sym_object_repeat1] = STATE(399),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(126),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1804),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(130),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(132),
    [sym_identifier] = ACTIONS(1806),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1808),
    [anon_sym_set] = ACTIONS(1808),
  },
  [432] = {
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_COLON] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1061),
    [anon_sym_RBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_QMARK] = ACTIONS(1061),
    [anon_sym_AMP_AMP] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_GT_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1061),
    [anon_sym_GT_EQ] = ACTIONS(1061),
    [anon_sym_instanceof] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1061),
    [anon_sym_DASH_DASH] = ACTIONS(1061),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1061),
  },
  [433] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [434] = {
    [sym_comment] = ACTIONS(78),
    [anon_sym_target] = ACTIONS(1810),
  },
  [435] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(425),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(737),
  },
  [436] = {
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [437] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [438] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
  },
  [439] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1099),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [440] = {
    [sym__initializer] = STATE(528),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [441] = {
    [sym__initializer] = STATE(529),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [442] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [443] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [444] = {
    [anon_sym_COMMA] = ACTIONS(1812),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [sym_comment] = ACTIONS(78),
  },
  [445] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(1113),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1113),
    [anon_sym_in] = ACTIONS(1115),
    [anon_sym_COLON] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(1115),
    [anon_sym_GT] = ACTIONS(1115),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1113),
    [anon_sym_AMP_AMP] = ACTIONS(1113),
    [anon_sym_PIPE_PIPE] = ACTIONS(1113),
    [anon_sym_GT_GT] = ACTIONS(1115),
    [anon_sym_GT_GT_GT] = ACTIONS(1113),
    [anon_sym_LT_LT] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_CARET] = ACTIONS(1113),
    [anon_sym_PIPE] = ACTIONS(1115),
    [anon_sym_PLUS] = ACTIONS(1115),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [anon_sym_LT_EQ] = ACTIONS(1113),
    [anon_sym_EQ_EQ] = ACTIONS(1115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1113),
    [anon_sym_BANG_EQ] = ACTIONS(1115),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1113),
    [anon_sym_GT_EQ] = ACTIONS(1113),
    [anon_sym_instanceof] = ACTIONS(1113),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [446] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1117),
    [anon_sym_in] = ACTIONS(1119),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1117),
    [anon_sym_AMP_AMP] = ACTIONS(1117),
    [anon_sym_PIPE_PIPE] = ACTIONS(1117),
    [anon_sym_GT_GT] = ACTIONS(1119),
    [anon_sym_GT_GT_GT] = ACTIONS(1117),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1117),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_PERCENT] = ACTIONS(1117),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1117),
    [anon_sym_instanceof] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1117),
    [anon_sym_DASH_DASH] = ACTIONS(1117),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [447] = {
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_RPAREN] = ACTIONS(1121),
    [anon_sym_in] = ACTIONS(1123),
    [anon_sym_COLON] = ACTIONS(1121),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_RBRACK] = ACTIONS(1121),
    [anon_sym_LT] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(1123),
    [anon_sym_SLASH] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1121),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_AMP_AMP] = ACTIONS(1121),
    [anon_sym_PIPE_PIPE] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_GT_GT_GT] = ACTIONS(1121),
    [anon_sym_LT_LT] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_PIPE] = ACTIONS(1123),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_PERCENT] = ACTIONS(1121),
    [anon_sym_LT_EQ] = ACTIONS(1121),
    [anon_sym_EQ_EQ] = ACTIONS(1123),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1121),
    [anon_sym_BANG_EQ] = ACTIONS(1123),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1121),
    [anon_sym_GT_EQ] = ACTIONS(1121),
    [anon_sym_instanceof] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1121),
  },
  [448] = {
    [aux_sym_string_repeat1] = STATE(612),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(1127),
    [sym_escape_sequence] = ACTIONS(1127),
    [sym_comment] = ACTIONS(298),
  },
  [449] = {
    [aux_sym_string_repeat2] = STATE(613),
    [anon_sym_SQUOTE] = ACTIONS(1814),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(1129),
    [sym_escape_sequence] = ACTIONS(1129),
    [sym_comment] = ACTIONS(298),
  },
  [450] = {
    [anon_sym_STAR] = ACTIONS(1131),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_RPAREN] = ACTIONS(1131),
    [anon_sym_in] = ACTIONS(1133),
    [anon_sym_COLON] = ACTIONS(1131),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_RBRACK] = ACTIONS(1131),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_SLASH] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_AMP_AMP] = ACTIONS(1131),
    [anon_sym_PIPE_PIPE] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_GT_GT_GT] = ACTIONS(1131),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_CARET] = ACTIONS(1131),
    [anon_sym_PIPE] = ACTIONS(1133),
    [anon_sym_PLUS] = ACTIONS(1133),
    [anon_sym_DASH] = ACTIONS(1133),
    [anon_sym_PERCENT] = ACTIONS(1131),
    [anon_sym_LT_EQ] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1131),
    [anon_sym_BANG_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1131),
    [anon_sym_GT_EQ] = ACTIONS(1131),
    [anon_sym_instanceof] = ACTIONS(1131),
    [anon_sym_PLUS_PLUS] = ACTIONS(1131),
    [anon_sym_DASH_DASH] = ACTIONS(1131),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1131),
  },
  [451] = {
    [sym_template_substitution] = STATE(617),
    [aux_sym_template_string_repeat1] = STATE(617),
    [sym__template_chars] = ACTIONS(1139),
    [sym_escape_sequence] = ACTIONS(1139),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(381),
  },
  [452] = {
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_EQ_GT] = ACTIONS(1818),
    [sym_comment] = ACTIONS(78),
  },
  [453] = {
    [sym_parenthesized_expression] = STATE(875),
    [sym__expression] = STATE(875),
    [sym_yield_expression] = STATE(875),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(875),
    [sym_jsx_fragment] = STATE(875),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(875),
    [sym_anonymous_class] = STATE(875),
    [sym_class] = STATE(875),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(875),
    [sym_generator_function] = STATE(875),
    [sym_call_expression] = STATE(875),
    [sym_new_expression] = STATE(875),
    [sym_await_expression] = STATE(875),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(875),
    [sym_augmented_assignment_expression] = STATE(875),
    [sym_ternary_expression] = STATE(875),
    [sym_binary_expression] = STATE(875),
    [sym_unary_expression] = STATE(875),
    [sym_update_expression] = STATE(875),
    [sym_string] = STATE(875),
    [sym_template_string] = STATE(875),
    [sym_regex] = STATE(875),
    [sym_meta_property] = STATE(875),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1820),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1822),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_null] = ACTIONS(1822),
    [sym_undefined] = ACTIONS(1822),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [454] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1824),
  },
  [455] = {
    [sym_parenthesized_expression] = STATE(877),
    [sym__expression] = STATE(877),
    [sym_yield_expression] = STATE(877),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(877),
    [sym_jsx_fragment] = STATE(877),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(877),
    [sym_anonymous_class] = STATE(877),
    [sym_class] = STATE(877),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(877),
    [sym_generator_function] = STATE(877),
    [sym_call_expression] = STATE(877),
    [sym_new_expression] = STATE(877),
    [sym_await_expression] = STATE(877),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(877),
    [sym_augmented_assignment_expression] = STATE(877),
    [sym_ternary_expression] = STATE(877),
    [sym_binary_expression] = STATE(877),
    [sym_unary_expression] = STATE(877),
    [sym_update_expression] = STATE(877),
    [sym_string] = STATE(877),
    [sym_template_string] = STATE(877),
    [sym_regex] = STATE(877),
    [sym_meta_property] = STATE(877),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1826),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1828),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1828),
    [sym_false] = ACTIONS(1828),
    [sym_null] = ACTIONS(1828),
    [sym_undefined] = ACTIONS(1828),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [456] = {
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1623),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_RPAREN] = ACTIONS(1623),
    [anon_sym_in] = ACTIONS(1155),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1153),
    [anon_sym_QMARK] = ACTIONS(1153),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1153),
    [anon_sym_LT_LT] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1153),
    [anon_sym_LT_EQ] = ACTIONS(1153),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(1153),
    [anon_sym_instanceof] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1153),
  },
  [457] = {
    [aux_sym_formal_parameters_repeat1] = STATE(859),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(1830),
    [sym_comment] = ACTIONS(78),
  },
  [458] = {
    [sym_parenthesized_expression] = STATE(880),
    [sym__expression] = STATE(880),
    [sym_yield_expression] = STATE(880),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(880),
    [sym_jsx_fragment] = STATE(880),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(880),
    [sym_anonymous_class] = STATE(880),
    [sym_class] = STATE(880),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(880),
    [sym_generator_function] = STATE(880),
    [sym_call_expression] = STATE(880),
    [sym_new_expression] = STATE(880),
    [sym_await_expression] = STATE(880),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(880),
    [sym_augmented_assignment_expression] = STATE(880),
    [sym_spread_element] = STATE(881),
    [sym_ternary_expression] = STATE(880),
    [sym_binary_expression] = STATE(880),
    [sym_unary_expression] = STATE(880),
    [sym_update_expression] = STATE(880),
    [sym_string] = STATE(880),
    [sym_template_string] = STATE(880),
    [sym_regex] = STATE(880),
    [sym_meta_property] = STATE(880),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(882),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(1832),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1834),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1836),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1836),
    [sym_false] = ACTIONS(1836),
    [sym_null] = ACTIONS(1836),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [459] = {
    [sym_parenthesized_expression] = STATE(883),
    [sym__expression] = STATE(883),
    [sym_yield_expression] = STATE(883),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(883),
    [sym_jsx_fragment] = STATE(883),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(883),
    [sym_anonymous_class] = STATE(883),
    [sym_class] = STATE(883),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(883),
    [sym_generator_function] = STATE(883),
    [sym_call_expression] = STATE(883),
    [sym_new_expression] = STATE(883),
    [sym_await_expression] = STATE(883),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(883),
    [sym_augmented_assignment_expression] = STATE(883),
    [sym_ternary_expression] = STATE(883),
    [sym_binary_expression] = STATE(883),
    [sym_unary_expression] = STATE(883),
    [sym_update_expression] = STATE(883),
    [sym_sequence_expression] = STATE(884),
    [sym_string] = STATE(883),
    [sym_template_string] = STATE(883),
    [sym_regex] = STATE(883),
    [sym_meta_property] = STATE(883),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1838),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1840),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1840),
    [sym_false] = ACTIONS(1840),
    [sym_null] = ACTIONS(1840),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [460] = {
    [anon_sym_STAR] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_RPAREN] = ACTIONS(1171),
    [anon_sym_in] = ACTIONS(1173),
    [anon_sym_COLON] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_RBRACK] = ACTIONS(1171),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_SLASH] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1171),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_AMP_AMP] = ACTIONS(1171),
    [anon_sym_PIPE_PIPE] = ACTIONS(1171),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_GT_GT_GT] = ACTIONS(1171),
    [anon_sym_LT_LT] = ACTIONS(1171),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_CARET] = ACTIONS(1171),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_PLUS] = ACTIONS(1173),
    [anon_sym_DASH] = ACTIONS(1173),
    [anon_sym_PERCENT] = ACTIONS(1171),
    [anon_sym_LT_EQ] = ACTIONS(1171),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1171),
    [anon_sym_BANG_EQ] = ACTIONS(1173),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1171),
    [anon_sym_GT_EQ] = ACTIONS(1171),
    [anon_sym_instanceof] = ACTIONS(1171),
    [anon_sym_PLUS_PLUS] = ACTIONS(1171),
    [anon_sym_DASH_DASH] = ACTIONS(1171),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1171),
  },
  [461] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [462] = {
    [sym_parenthesized_expression] = STATE(886),
    [sym__expression] = STATE(886),
    [sym_yield_expression] = STATE(886),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(886),
    [sym_jsx_fragment] = STATE(886),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(886),
    [sym_anonymous_class] = STATE(886),
    [sym_class] = STATE(886),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(886),
    [sym_generator_function] = STATE(886),
    [sym_call_expression] = STATE(886),
    [sym_new_expression] = STATE(886),
    [sym_await_expression] = STATE(886),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(886),
    [sym_augmented_assignment_expression] = STATE(886),
    [sym_ternary_expression] = STATE(886),
    [sym_binary_expression] = STATE(886),
    [sym_unary_expression] = STATE(886),
    [sym_update_expression] = STATE(886),
    [sym_sequence_expression] = STATE(887),
    [sym_string] = STATE(886),
    [sym_template_string] = STATE(886),
    [sym_regex] = STATE(886),
    [sym_meta_property] = STATE(886),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1846),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1848),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_null] = ACTIONS(1848),
    [sym_undefined] = ACTIONS(1848),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [463] = {
    [sym__automatic_semicolon] = ACTIONS(1850),
    [anon_sym_STAR] = ACTIONS(1850),
    [anon_sym_COMMA] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(1850),
    [anon_sym_LPAREN] = ACTIONS(1850),
    [anon_sym_RPAREN] = ACTIONS(1850),
    [anon_sym_in] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1850),
    [anon_sym_LBRACK] = ACTIONS(1850),
    [anon_sym_LT] = ACTIONS(1852),
    [anon_sym_GT] = ACTIONS(1852),
    [anon_sym_SLASH] = ACTIONS(1852),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_QMARK] = ACTIONS(1850),
    [anon_sym_AMP_AMP] = ACTIONS(1850),
    [anon_sym_PIPE_PIPE] = ACTIONS(1850),
    [anon_sym_GT_GT] = ACTIONS(1852),
    [anon_sym_GT_GT_GT] = ACTIONS(1850),
    [anon_sym_LT_LT] = ACTIONS(1850),
    [anon_sym_AMP] = ACTIONS(1852),
    [anon_sym_CARET] = ACTIONS(1850),
    [anon_sym_PIPE] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1852),
    [anon_sym_PERCENT] = ACTIONS(1850),
    [anon_sym_LT_EQ] = ACTIONS(1850),
    [anon_sym_EQ_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1850),
    [anon_sym_BANG_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1850),
    [anon_sym_GT_EQ] = ACTIONS(1850),
    [anon_sym_instanceof] = ACTIONS(1850),
    [anon_sym_PLUS_PLUS] = ACTIONS(1850),
    [anon_sym_DASH_DASH] = ACTIONS(1850),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1850),
  },
  [464] = {
    [sym_parenthesized_expression] = STATE(888),
    [sym__expression] = STATE(888),
    [sym_yield_expression] = STATE(888),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(888),
    [sym_jsx_fragment] = STATE(888),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(888),
    [sym_anonymous_class] = STATE(888),
    [sym_class] = STATE(888),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(888),
    [sym_generator_function] = STATE(888),
    [sym_call_expression] = STATE(888),
    [sym_new_expression] = STATE(888),
    [sym_await_expression] = STATE(888),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(888),
    [sym_augmented_assignment_expression] = STATE(888),
    [sym_ternary_expression] = STATE(888),
    [sym_binary_expression] = STATE(888),
    [sym_unary_expression] = STATE(888),
    [sym_update_expression] = STATE(888),
    [sym_string] = STATE(888),
    [sym_template_string] = STATE(888),
    [sym_regex] = STATE(888),
    [sym_meta_property] = STATE(888),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1854),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(1856),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1856),
    [sym_false] = ACTIONS(1856),
    [sym_null] = ACTIONS(1856),
    [sym_undefined] = ACTIONS(1856),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [465] = {
    [sym_parenthesized_expression] = STATE(889),
    [sym__expression] = STATE(889),
    [sym_yield_expression] = STATE(889),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(889),
    [sym_jsx_fragment] = STATE(889),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(889),
    [sym_anonymous_class] = STATE(889),
    [sym_class] = STATE(889),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(889),
    [sym_generator_function] = STATE(889),
    [sym_call_expression] = STATE(889),
    [sym_new_expression] = STATE(889),
    [sym_await_expression] = STATE(889),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(889),
    [sym_augmented_assignment_expression] = STATE(889),
    [sym_ternary_expression] = STATE(889),
    [sym_binary_expression] = STATE(889),
    [sym_unary_expression] = STATE(889),
    [sym_update_expression] = STATE(889),
    [sym_string] = STATE(889),
    [sym_template_string] = STATE(889),
    [sym_regex] = STATE(889),
    [sym_meta_property] = STATE(889),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1858),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1860),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1860),
    [sym_false] = ACTIONS(1860),
    [sym_null] = ACTIONS(1860),
    [sym_undefined] = ACTIONS(1860),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [466] = {
    [sym_parenthesized_expression] = STATE(890),
    [sym__expression] = STATE(890),
    [sym_yield_expression] = STATE(890),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(890),
    [sym_jsx_fragment] = STATE(890),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(890),
    [sym_anonymous_class] = STATE(890),
    [sym_class] = STATE(890),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(890),
    [sym_generator_function] = STATE(890),
    [sym_call_expression] = STATE(890),
    [sym_new_expression] = STATE(890),
    [sym_await_expression] = STATE(890),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(890),
    [sym_augmented_assignment_expression] = STATE(890),
    [sym_ternary_expression] = STATE(890),
    [sym_binary_expression] = STATE(890),
    [sym_unary_expression] = STATE(890),
    [sym_update_expression] = STATE(890),
    [sym_string] = STATE(890),
    [sym_template_string] = STATE(890),
    [sym_regex] = STATE(890),
    [sym_meta_property] = STATE(890),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1862),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1864),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1864),
    [sym_false] = ACTIONS(1864),
    [sym_null] = ACTIONS(1864),
    [sym_undefined] = ACTIONS(1864),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [467] = {
    [sym_parenthesized_expression] = STATE(891),
    [sym__expression] = STATE(891),
    [sym_yield_expression] = STATE(891),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(891),
    [sym_jsx_fragment] = STATE(891),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(891),
    [sym_anonymous_class] = STATE(891),
    [sym_class] = STATE(891),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(891),
    [sym_generator_function] = STATE(891),
    [sym_call_expression] = STATE(891),
    [sym_new_expression] = STATE(891),
    [sym_await_expression] = STATE(891),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(891),
    [sym_ternary_expression] = STATE(891),
    [sym_binary_expression] = STATE(891),
    [sym_unary_expression] = STATE(891),
    [sym_update_expression] = STATE(891),
    [sym_string] = STATE(891),
    [sym_template_string] = STATE(891),
    [sym_regex] = STATE(891),
    [sym_meta_property] = STATE(891),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1866),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(1868),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1868),
    [sym_false] = ACTIONS(1868),
    [sym_null] = ACTIONS(1868),
    [sym_undefined] = ACTIONS(1868),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [468] = {
    [anon_sym_STAR] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_LPAREN] = ACTIONS(1117),
    [anon_sym_RPAREN] = ACTIONS(1117),
    [anon_sym_in] = ACTIONS(1119),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1117),
    [anon_sym_RBRACK] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1119),
    [anon_sym_SLASH] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(1117),
    [anon_sym_QMARK] = ACTIONS(1117),
    [anon_sym_AMP_AMP] = ACTIONS(1117),
    [anon_sym_PIPE_PIPE] = ACTIONS(1117),
    [anon_sym_GT_GT] = ACTIONS(1119),
    [anon_sym_GT_GT_GT] = ACTIONS(1117),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_AMP] = ACTIONS(1119),
    [anon_sym_CARET] = ACTIONS(1117),
    [anon_sym_PIPE] = ACTIONS(1119),
    [anon_sym_PLUS] = ACTIONS(1119),
    [anon_sym_DASH] = ACTIONS(1119),
    [anon_sym_PERCENT] = ACTIONS(1117),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_EQ_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1117),
    [anon_sym_BANG_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1117),
    [anon_sym_instanceof] = ACTIONS(1117),
    [anon_sym_PLUS_PLUS] = ACTIONS(1117),
    [anon_sym_DASH_DASH] = ACTIONS(1117),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1117),
  },
  [469] = {
    [anon_sym_LBRACE] = ACTIONS(1870),
    [anon_sym_EQ_GT] = ACTIONS(1870),
    [sym_comment] = ACTIONS(78),
  },
  [470] = {
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1628),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_RPAREN] = ACTIONS(1628),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1233),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1233),
  },
  [471] = {
    [aux_sym_formal_parameters_repeat1] = STATE(859),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(1872),
    [sym_comment] = ACTIONS(78),
  },
  [472] = {
    [anon_sym_LBRACE] = ACTIONS(1874),
    [anon_sym_EQ_GT] = ACTIONS(1874),
    [sym_comment] = ACTIONS(78),
  },
  [473] = {
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1639),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_in] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1239),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1237),
  },
  [474] = {
    [aux_sym_formal_parameters_repeat1] = STATE(859),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(1876),
    [sym_comment] = ACTIONS(78),
  },
  [475] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(1878),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [476] = {
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_COMMA] = ACTIONS(1259),
    [anon_sym_RBRACE] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(1259),
    [anon_sym_RPAREN] = ACTIONS(1259),
    [anon_sym_in] = ACTIONS(1261),
    [anon_sym_COLON] = ACTIONS(1259),
    [anon_sym_LBRACK] = ACTIONS(1259),
    [anon_sym_RBRACK] = ACTIONS(1259),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_SLASH] = ACTIONS(1261),
    [anon_sym_DOT] = ACTIONS(1259),
    [anon_sym_QMARK] = ACTIONS(1259),
    [anon_sym_AMP_AMP] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_GT_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_CARET] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_PERCENT] = ACTIONS(1259),
    [anon_sym_LT_EQ] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1259),
    [anon_sym_BANG_EQ] = ACTIONS(1261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1259),
    [anon_sym_GT_EQ] = ACTIONS(1259),
    [anon_sym_instanceof] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1259),
    [anon_sym_DASH_DASH] = ACTIONS(1259),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1259),
  },
  [477] = {
    [sym_jsx_element] = STATE(665),
    [sym_jsx_expression] = STATE(665),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_closing_element] = STATE(895),
    [sym_jsx_self_closing_element] = STATE(665),
    [aux_sym_jsx_element_repeat1] = STATE(665),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(831),
    [sym_jsx_text] = ACTIONS(1263),
    [sym_comment] = ACTIONS(78),
  },
  [478] = {
    [anon_sym_STAR] = ACTIONS(1153),
    [anon_sym_LBRACE] = ACTIONS(1153),
    [anon_sym_COMMA] = ACTIONS(1153),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1153),
    [anon_sym_RPAREN] = ACTIONS(1153),
    [anon_sym_in] = ACTIONS(1155),
    [anon_sym_COLON] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_RBRACK] = ACTIONS(1153),
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_SLASH] = ACTIONS(1155),
    [anon_sym_DOT] = ACTIONS(1153),
    [anon_sym_QMARK] = ACTIONS(1153),
    [anon_sym_AMP_AMP] = ACTIONS(1153),
    [anon_sym_PIPE_PIPE] = ACTIONS(1153),
    [anon_sym_GT_GT] = ACTIONS(1155),
    [anon_sym_GT_GT_GT] = ACTIONS(1153),
    [anon_sym_LT_LT] = ACTIONS(1153),
    [anon_sym_AMP] = ACTIONS(1155),
    [anon_sym_CARET] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1155),
    [anon_sym_PLUS] = ACTIONS(1155),
    [anon_sym_DASH] = ACTIONS(1155),
    [anon_sym_PERCENT] = ACTIONS(1153),
    [anon_sym_LT_EQ] = ACTIONS(1153),
    [anon_sym_EQ_EQ] = ACTIONS(1155),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1153),
    [anon_sym_BANG_EQ] = ACTIONS(1155),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1153),
    [anon_sym_GT_EQ] = ACTIONS(1153),
    [anon_sym_instanceof] = ACTIONS(1153),
    [anon_sym_PLUS_PLUS] = ACTIONS(1153),
    [anon_sym_DASH_DASH] = ACTIONS(1153),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1153),
  },
  [479] = {
    [sym_class_heritage] = STATE(897),
    [sym_class_body] = STATE(844),
    [anon_sym_LBRACE] = ACTIONS(717),
    [anon_sym_extends] = ACTIONS(304),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1880),
  },
  [480] = {
    [sym__automatic_semicolon] = ACTIONS(515),
    [anon_sym_STAR] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_RPAREN] = ACTIONS(515),
    [anon_sym_in] = ACTIONS(521),
    [anon_sym_of] = ACTIONS(515),
    [anon_sym_SEMI] = ACTIONS(515),
    [anon_sym_LBRACK] = ACTIONS(515),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(515),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_GT_GT_GT] = ACTIONS(515),
    [anon_sym_LT_LT] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(515),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(515),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [anon_sym_instanceof] = ACTIONS(515),
    [anon_sym_PLUS_PLUS] = ACTIONS(515),
    [anon_sym_DASH_DASH] = ACTIONS(515),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(515),
  },
  [481] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(312),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [482] = {
    [sym__initializer] = STATE(729),
    [aux_sym_object_repeat1] = STATE(312),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(1519),
    [sym_comment] = ACTIONS(78),
  },
  [483] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(312),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [484] = {
    [sym_string] = STATE(342),
    [sym_decorator] = STATE(733),
    [sym_method_definition] = STATE(341),
    [sym__property_name] = STATE(342),
    [sym_computed_property_name] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(733),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(605),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(607),
    [anon_sym_set] = ACTIONS(607),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(1882),
    [anon_sym_export] = ACTIONS(1884),
    [anon_sym_default] = ACTIONS(1884),
    [anon_sym_LBRACE] = ACTIONS(1882),
    [anon_sym_RBRACE] = ACTIONS(1882),
    [anon_sym_import] = ACTIONS(1884),
    [anon_sym_var] = ACTIONS(1884),
    [anon_sym_let] = ACTIONS(1884),
    [anon_sym_const] = ACTIONS(1884),
    [anon_sym_if] = ACTIONS(1884),
    [anon_sym_else] = ACTIONS(1884),
    [anon_sym_switch] = ACTIONS(1884),
    [anon_sym_for] = ACTIONS(1884),
    [anon_sym_LPAREN] = ACTIONS(1882),
    [anon_sym_await] = ACTIONS(1884),
    [anon_sym_while] = ACTIONS(1884),
    [anon_sym_do] = ACTIONS(1884),
    [anon_sym_try] = ACTIONS(1884),
    [anon_sym_with] = ACTIONS(1884),
    [anon_sym_break] = ACTIONS(1884),
    [anon_sym_continue] = ACTIONS(1884),
    [anon_sym_debugger] = ACTIONS(1884),
    [anon_sym_return] = ACTIONS(1884),
    [anon_sym_throw] = ACTIONS(1884),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_case] = ACTIONS(1884),
    [anon_sym_yield] = ACTIONS(1884),
    [anon_sym_LBRACK] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_SLASH] = ACTIONS(1884),
    [anon_sym_class] = ACTIONS(1884),
    [anon_sym_async] = ACTIONS(1884),
    [anon_sym_function] = ACTIONS(1884),
    [anon_sym_EQ_GT] = ACTIONS(1882),
    [anon_sym_new] = ACTIONS(1884),
    [anon_sym_PLUS] = ACTIONS(1884),
    [anon_sym_DASH] = ACTIONS(1884),
    [anon_sym_BANG] = ACTIONS(1882),
    [anon_sym_TILDE] = ACTIONS(1882),
    [anon_sym_typeof] = ACTIONS(1884),
    [anon_sym_void] = ACTIONS(1884),
    [anon_sym_delete] = ACTIONS(1884),
    [anon_sym_PLUS_PLUS] = ACTIONS(1882),
    [anon_sym_DASH_DASH] = ACTIONS(1882),
    [anon_sym_DQUOTE] = ACTIONS(1882),
    [anon_sym_SQUOTE] = ACTIONS(1882),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1882),
    [sym_number] = ACTIONS(1882),
    [sym_identifier] = ACTIONS(1884),
    [sym_this] = ACTIONS(1884),
    [sym_super] = ACTIONS(1884),
    [sym_true] = ACTIONS(1884),
    [sym_false] = ACTIONS(1884),
    [sym_null] = ACTIONS(1884),
    [sym_undefined] = ACTIONS(1884),
    [anon_sym_AT] = ACTIONS(1882),
    [anon_sym_get] = ACTIONS(1884),
    [anon_sym_set] = ACTIONS(1884),
  },
  [486] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1886),
  },
  [487] = {
    [anon_sym_function] = ACTIONS(1888),
    [sym_comment] = ACTIONS(78),
  },
  [488] = {
    [sym_decorator] = STATE(289),
    [aux_sym_export_statement_repeat1] = STATE(289),
    [anon_sym_class] = ACTIONS(1890),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [489] = {
    [sym_export_statement] = STATE(904),
    [sym__declaration] = STATE(904),
    [sym_import_statement] = STATE(904),
    [sym_expression_statement] = STATE(904),
    [sym_variable_declaration] = STATE(904),
    [sym_lexical_declaration] = STATE(904),
    [sym_statement_block] = STATE(904),
    [sym_if_statement] = STATE(904),
    [sym_switch_statement] = STATE(904),
    [sym_for_statement] = STATE(904),
    [sym_for_in_statement] = STATE(904),
    [sym_for_of_statement] = STATE(904),
    [sym_while_statement] = STATE(904),
    [sym_do_statement] = STATE(904),
    [sym_try_statement] = STATE(904),
    [sym_with_statement] = STATE(904),
    [sym_break_statement] = STATE(904),
    [sym_continue_statement] = STATE(904),
    [sym_debugger_statement] = STATE(904),
    [sym_return_statement] = STATE(904),
    [sym_throw_statement] = STATE(904),
    [sym_empty_statement] = STATE(904),
    [sym_labeled_statement] = STATE(904),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [490] = {
    [sym_expression_statement] = STATE(908),
    [sym_variable_declaration] = STATE(908),
    [sym_lexical_declaration] = STATE(908),
    [sym_empty_statement] = STATE(908),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(909),
    [sym_array] = STATE(910),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_var] = ACTIONS(1902),
    [anon_sym_let] = ACTIONS(1904),
    [anon_sym_const] = ACTIONS(1904),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1906),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [491] = {
    [anon_sym_LPAREN] = ACTIONS(1908),
    [sym_comment] = ACTIONS(78),
  },
  [492] = {
    [sym_export_statement] = STATE(485),
    [sym__declaration] = STATE(485),
    [sym_import_statement] = STATE(485),
    [sym_expression_statement] = STATE(485),
    [sym_variable_declaration] = STATE(485),
    [sym_lexical_declaration] = STATE(485),
    [sym_statement_block] = STATE(485),
    [sym_if_statement] = STATE(485),
    [sym_switch_statement] = STATE(485),
    [sym_for_statement] = STATE(485),
    [sym_for_in_statement] = STATE(485),
    [sym_for_of_statement] = STATE(485),
    [sym_while_statement] = STATE(485),
    [sym_do_statement] = STATE(485),
    [sym_try_statement] = STATE(485),
    [sym_with_statement] = STATE(485),
    [sym_break_statement] = STATE(485),
    [sym_continue_statement] = STATE(485),
    [sym_debugger_statement] = STATE(485),
    [sym_return_statement] = STATE(485),
    [sym_throw_statement] = STATE(485),
    [sym_empty_statement] = STATE(485),
    [sym_labeled_statement] = STATE(485),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [493] = {
    [sym_export_statement] = STATE(502),
    [sym__declaration] = STATE(502),
    [sym_import_statement] = STATE(502),
    [sym_expression_statement] = STATE(502),
    [sym_variable_declaration] = STATE(502),
    [sym_lexical_declaration] = STATE(502),
    [sym_statement_block] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_switch_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_for_in_statement] = STATE(502),
    [sym_for_of_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_do_statement] = STATE(502),
    [sym_try_statement] = STATE(502),
    [sym_with_statement] = STATE(502),
    [sym_break_statement] = STATE(502),
    [sym_continue_statement] = STATE(502),
    [sym_debugger_statement] = STATE(502),
    [sym_return_statement] = STATE(502),
    [sym_throw_statement] = STATE(502),
    [sym_empty_statement] = STATE(502),
    [sym_labeled_statement] = STATE(502),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [494] = {
    [sym_export_statement] = STATE(619),
    [sym__declaration] = STATE(619),
    [sym_import_statement] = STATE(619),
    [sym_expression_statement] = STATE(619),
    [sym_variable_declaration] = STATE(619),
    [sym_lexical_declaration] = STATE(619),
    [sym_statement_block] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(619),
    [sym_for_in_statement] = STATE(619),
    [sym_for_of_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_do_statement] = STATE(619),
    [sym_try_statement] = STATE(619),
    [sym_with_statement] = STATE(619),
    [sym_break_statement] = STATE(619),
    [sym_continue_statement] = STATE(619),
    [sym_debugger_statement] = STATE(619),
    [sym_return_statement] = STATE(619),
    [sym_throw_statement] = STATE(619),
    [sym_empty_statement] = STATE(619),
    [sym_labeled_statement] = STATE(619),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [495] = {
    [sym_parenthesized_expression] = STATE(913),
    [anon_sym_LPAREN] = ACTIONS(1910),
    [sym_comment] = ACTIONS(78),
  },
  [496] = {
    [sym__declaration] = STATE(287),
    [sym_variable_declaration] = STATE(287),
    [sym_lexical_declaration] = STATE(287),
    [sym_class] = STATE(62),
    [sym_function] = STATE(62),
    [sym_generator_function] = STATE(62),
    [sym_decorator] = STATE(488),
    [aux_sym_export_statement_repeat1] = STATE(488),
    [anon_sym_default] = ACTIONS(1394),
    [anon_sym_var] = ACTIONS(102),
    [anon_sym_let] = ACTIONS(104),
    [anon_sym_const] = ACTIONS(104),
    [anon_sym_class] = ACTIONS(847),
    [anon_sym_async] = ACTIONS(849),
    [anon_sym_function] = ACTIONS(851),
    [sym_comment] = ACTIONS(78),
    [anon_sym_AT] = ACTIONS(90),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_default] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_import] = ACTIONS(519),
    [anon_sym_var] = ACTIONS(519),
    [anon_sym_let] = ACTIONS(519),
    [anon_sym_const] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(519),
    [anon_sym_else] = ACTIONS(519),
    [anon_sym_switch] = ACTIONS(519),
    [anon_sym_for] = ACTIONS(519),
    [anon_sym_LPAREN] = ACTIONS(517),
    [anon_sym_await] = ACTIONS(519),
    [anon_sym_while] = ACTIONS(519),
    [anon_sym_do] = ACTIONS(519),
    [anon_sym_try] = ACTIONS(519),
    [anon_sym_with] = ACTIONS(519),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(519),
    [anon_sym_debugger] = ACTIONS(519),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_throw] = ACTIONS(519),
    [anon_sym_SEMI] = ACTIONS(517),
    [anon_sym_case] = ACTIONS(519),
    [anon_sym_catch] = ACTIONS(519),
    [anon_sym_finally] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(519),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(519),
    [anon_sym_DASH] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(517),
    [anon_sym_typeof] = ACTIONS(519),
    [anon_sym_void] = ACTIONS(519),
    [anon_sym_delete] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(517),
    [anon_sym_DASH_DASH] = ACTIONS(517),
    [anon_sym_DQUOTE] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(517),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [sym_number] = ACTIONS(517),
    [sym_identifier] = ACTIONS(519),
    [sym_this] = ACTIONS(519),
    [sym_super] = ACTIONS(519),
    [sym_true] = ACTIONS(519),
    [sym_false] = ACTIONS(519),
    [sym_null] = ACTIONS(519),
    [sym_undefined] = ACTIONS(519),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_static] = ACTIONS(519),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
  },
  [498] = {
    [sym_statement_block] = STATE(915),
    [anon_sym_LBRACE] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(1912),
    [sym_comment] = ACTIONS(78),
  },
  [499] = {
    [sym_statement_block] = STATE(916),
    [anon_sym_LBRACE] = ACTIONS(226),
    [sym_comment] = ACTIONS(78),
  },
  [500] = {
    [sym_finally_clause] = STATE(917),
    [ts_builtin_sym_end] = ACTIONS(1914),
    [anon_sym_export] = ACTIONS(1916),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1914),
    [anon_sym_RBRACE] = ACTIONS(1914),
    [anon_sym_import] = ACTIONS(1916),
    [anon_sym_var] = ACTIONS(1916),
    [anon_sym_let] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_if] = ACTIONS(1916),
    [anon_sym_else] = ACTIONS(1916),
    [anon_sym_switch] = ACTIONS(1916),
    [anon_sym_for] = ACTIONS(1916),
    [anon_sym_LPAREN] = ACTIONS(1914),
    [anon_sym_await] = ACTIONS(1916),
    [anon_sym_while] = ACTIONS(1916),
    [anon_sym_do] = ACTIONS(1916),
    [anon_sym_try] = ACTIONS(1916),
    [anon_sym_with] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1916),
    [anon_sym_continue] = ACTIONS(1916),
    [anon_sym_debugger] = ACTIONS(1916),
    [anon_sym_return] = ACTIONS(1916),
    [anon_sym_throw] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [anon_sym_case] = ACTIONS(1916),
    [anon_sym_finally] = ACTIONS(871),
    [anon_sym_yield] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_SLASH] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_async] = ACTIONS(1916),
    [anon_sym_function] = ACTIONS(1916),
    [anon_sym_EQ_GT] = ACTIONS(1914),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_BANG] = ACTIONS(1914),
    [anon_sym_TILDE] = ACTIONS(1914),
    [anon_sym_typeof] = ACTIONS(1916),
    [anon_sym_void] = ACTIONS(1916),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_PLUS_PLUS] = ACTIONS(1914),
    [anon_sym_DASH_DASH] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(1914),
    [anon_sym_SQUOTE] = ACTIONS(1914),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [sym_number] = ACTIONS(1914),
    [sym_identifier] = ACTIONS(1916),
    [sym_this] = ACTIONS(1916),
    [sym_super] = ACTIONS(1916),
    [sym_true] = ACTIONS(1916),
    [sym_false] = ACTIONS(1916),
    [sym_null] = ACTIONS(1916),
    [sym_undefined] = ACTIONS(1916),
    [anon_sym_AT] = ACTIONS(1914),
    [anon_sym_get] = ACTIONS(1916),
    [anon_sym_set] = ACTIONS(1916),
  },
  [501] = {
    [ts_builtin_sym_end] = ACTIONS(1914),
    [anon_sym_export] = ACTIONS(1916),
    [anon_sym_default] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1914),
    [anon_sym_RBRACE] = ACTIONS(1914),
    [anon_sym_import] = ACTIONS(1916),
    [anon_sym_var] = ACTIONS(1916),
    [anon_sym_let] = ACTIONS(1916),
    [anon_sym_const] = ACTIONS(1916),
    [anon_sym_if] = ACTIONS(1916),
    [anon_sym_else] = ACTIONS(1916),
    [anon_sym_switch] = ACTIONS(1916),
    [anon_sym_for] = ACTIONS(1916),
    [anon_sym_LPAREN] = ACTIONS(1914),
    [anon_sym_await] = ACTIONS(1916),
    [anon_sym_while] = ACTIONS(1916),
    [anon_sym_do] = ACTIONS(1916),
    [anon_sym_try] = ACTIONS(1916),
    [anon_sym_with] = ACTIONS(1916),
    [anon_sym_break] = ACTIONS(1916),
    [anon_sym_continue] = ACTIONS(1916),
    [anon_sym_debugger] = ACTIONS(1916),
    [anon_sym_return] = ACTIONS(1916),
    [anon_sym_throw] = ACTIONS(1916),
    [anon_sym_SEMI] = ACTIONS(1914),
    [anon_sym_case] = ACTIONS(1916),
    [anon_sym_yield] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1914),
    [anon_sym_LT] = ACTIONS(1914),
    [anon_sym_SLASH] = ACTIONS(1916),
    [anon_sym_class] = ACTIONS(1916),
    [anon_sym_async] = ACTIONS(1916),
    [anon_sym_function] = ACTIONS(1916),
    [anon_sym_EQ_GT] = ACTIONS(1914),
    [anon_sym_new] = ACTIONS(1916),
    [anon_sym_PLUS] = ACTIONS(1916),
    [anon_sym_DASH] = ACTIONS(1916),
    [anon_sym_BANG] = ACTIONS(1914),
    [anon_sym_TILDE] = ACTIONS(1914),
    [anon_sym_typeof] = ACTIONS(1916),
    [anon_sym_void] = ACTIONS(1916),
    [anon_sym_delete] = ACTIONS(1916),
    [anon_sym_PLUS_PLUS] = ACTIONS(1914),
    [anon_sym_DASH_DASH] = ACTIONS(1914),
    [anon_sym_DQUOTE] = ACTIONS(1914),
    [anon_sym_SQUOTE] = ACTIONS(1914),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1914),
    [sym_number] = ACTIONS(1914),
    [sym_identifier] = ACTIONS(1916),
    [sym_this] = ACTIONS(1916),
    [sym_super] = ACTIONS(1916),
    [sym_true] = ACTIONS(1916),
    [sym_false] = ACTIONS(1916),
    [sym_null] = ACTIONS(1916),
    [sym_undefined] = ACTIONS(1916),
    [anon_sym_AT] = ACTIONS(1914),
    [anon_sym_get] = ACTIONS(1916),
    [anon_sym_set] = ACTIONS(1916),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1918),
    [anon_sym_export] = ACTIONS(1920),
    [anon_sym_default] = ACTIONS(1920),
    [anon_sym_LBRACE] = ACTIONS(1918),
    [anon_sym_RBRACE] = ACTIONS(1918),
    [anon_sym_import] = ACTIONS(1920),
    [anon_sym_var] = ACTIONS(1920),
    [anon_sym_let] = ACTIONS(1920),
    [anon_sym_const] = ACTIONS(1920),
    [anon_sym_if] = ACTIONS(1920),
    [anon_sym_else] = ACTIONS(1920),
    [anon_sym_switch] = ACTIONS(1920),
    [anon_sym_for] = ACTIONS(1920),
    [anon_sym_LPAREN] = ACTIONS(1918),
    [anon_sym_await] = ACTIONS(1920),
    [anon_sym_while] = ACTIONS(1920),
    [anon_sym_do] = ACTIONS(1920),
    [anon_sym_try] = ACTIONS(1920),
    [anon_sym_with] = ACTIONS(1920),
    [anon_sym_break] = ACTIONS(1920),
    [anon_sym_continue] = ACTIONS(1920),
    [anon_sym_debugger] = ACTIONS(1920),
    [anon_sym_return] = ACTIONS(1920),
    [anon_sym_throw] = ACTIONS(1920),
    [anon_sym_SEMI] = ACTIONS(1918),
    [anon_sym_case] = ACTIONS(1920),
    [anon_sym_yield] = ACTIONS(1920),
    [anon_sym_LBRACK] = ACTIONS(1918),
    [anon_sym_LT] = ACTIONS(1918),
    [anon_sym_SLASH] = ACTIONS(1920),
    [anon_sym_class] = ACTIONS(1920),
    [anon_sym_async] = ACTIONS(1920),
    [anon_sym_function] = ACTIONS(1920),
    [anon_sym_EQ_GT] = ACTIONS(1918),
    [anon_sym_new] = ACTIONS(1920),
    [anon_sym_PLUS] = ACTIONS(1920),
    [anon_sym_DASH] = ACTIONS(1920),
    [anon_sym_BANG] = ACTIONS(1918),
    [anon_sym_TILDE] = ACTIONS(1918),
    [anon_sym_typeof] = ACTIONS(1920),
    [anon_sym_void] = ACTIONS(1920),
    [anon_sym_delete] = ACTIONS(1920),
    [anon_sym_PLUS_PLUS] = ACTIONS(1918),
    [anon_sym_DASH_DASH] = ACTIONS(1918),
    [anon_sym_DQUOTE] = ACTIONS(1918),
    [anon_sym_SQUOTE] = ACTIONS(1918),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1918),
    [sym_number] = ACTIONS(1918),
    [sym_identifier] = ACTIONS(1920),
    [sym_this] = ACTIONS(1920),
    [sym_super] = ACTIONS(1920),
    [sym_true] = ACTIONS(1920),
    [sym_false] = ACTIONS(1920),
    [sym_null] = ACTIONS(1920),
    [sym_undefined] = ACTIONS(1920),
    [anon_sym_AT] = ACTIONS(1918),
    [anon_sym_get] = ACTIONS(1920),
    [anon_sym_set] = ACTIONS(1920),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1922),
    [anon_sym_export] = ACTIONS(1924),
    [anon_sym_default] = ACTIONS(1924),
    [anon_sym_LBRACE] = ACTIONS(1922),
    [anon_sym_RBRACE] = ACTIONS(1922),
    [anon_sym_import] = ACTIONS(1924),
    [anon_sym_var] = ACTIONS(1924),
    [anon_sym_let] = ACTIONS(1924),
    [anon_sym_const] = ACTIONS(1924),
    [anon_sym_if] = ACTIONS(1924),
    [anon_sym_else] = ACTIONS(1924),
    [anon_sym_switch] = ACTIONS(1924),
    [anon_sym_for] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(1922),
    [anon_sym_await] = ACTIONS(1924),
    [anon_sym_while] = ACTIONS(1924),
    [anon_sym_do] = ACTIONS(1924),
    [anon_sym_try] = ACTIONS(1924),
    [anon_sym_with] = ACTIONS(1924),
    [anon_sym_break] = ACTIONS(1924),
    [anon_sym_continue] = ACTIONS(1924),
    [anon_sym_debugger] = ACTIONS(1924),
    [anon_sym_return] = ACTIONS(1924),
    [anon_sym_throw] = ACTIONS(1924),
    [anon_sym_SEMI] = ACTIONS(1922),
    [anon_sym_case] = ACTIONS(1924),
    [anon_sym_yield] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(1922),
    [anon_sym_LT] = ACTIONS(1922),
    [anon_sym_SLASH] = ACTIONS(1924),
    [anon_sym_class] = ACTIONS(1924),
    [anon_sym_async] = ACTIONS(1924),
    [anon_sym_function] = ACTIONS(1924),
    [anon_sym_EQ_GT] = ACTIONS(1922),
    [anon_sym_new] = ACTIONS(1924),
    [anon_sym_PLUS] = ACTIONS(1924),
    [anon_sym_DASH] = ACTIONS(1924),
    [anon_sym_BANG] = ACTIONS(1922),
    [anon_sym_TILDE] = ACTIONS(1922),
    [anon_sym_typeof] = ACTIONS(1924),
    [anon_sym_void] = ACTIONS(1924),
    [anon_sym_delete] = ACTIONS(1924),
    [anon_sym_PLUS_PLUS] = ACTIONS(1922),
    [anon_sym_DASH_DASH] = ACTIONS(1922),
    [anon_sym_DQUOTE] = ACTIONS(1922),
    [anon_sym_SQUOTE] = ACTIONS(1922),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1922),
    [sym_number] = ACTIONS(1922),
    [sym_identifier] = ACTIONS(1924),
    [sym_this] = ACTIONS(1924),
    [sym_super] = ACTIONS(1924),
    [sym_true] = ACTIONS(1924),
    [sym_false] = ACTIONS(1924),
    [sym_null] = ACTIONS(1924),
    [sym_undefined] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(1922),
    [anon_sym_get] = ACTIONS(1924),
    [anon_sym_set] = ACTIONS(1924),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1926),
    [anon_sym_export] = ACTIONS(1928),
    [anon_sym_default] = ACTIONS(1928),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_RBRACE] = ACTIONS(1926),
    [anon_sym_import] = ACTIONS(1928),
    [anon_sym_var] = ACTIONS(1928),
    [anon_sym_let] = ACTIONS(1928),
    [anon_sym_const] = ACTIONS(1928),
    [anon_sym_if] = ACTIONS(1928),
    [anon_sym_else] = ACTIONS(1928),
    [anon_sym_switch] = ACTIONS(1928),
    [anon_sym_for] = ACTIONS(1928),
    [anon_sym_LPAREN] = ACTIONS(1926),
    [anon_sym_await] = ACTIONS(1928),
    [anon_sym_while] = ACTIONS(1928),
    [anon_sym_do] = ACTIONS(1928),
    [anon_sym_try] = ACTIONS(1928),
    [anon_sym_with] = ACTIONS(1928),
    [anon_sym_break] = ACTIONS(1928),
    [anon_sym_continue] = ACTIONS(1928),
    [anon_sym_debugger] = ACTIONS(1928),
    [anon_sym_return] = ACTIONS(1928),
    [anon_sym_throw] = ACTIONS(1928),
    [anon_sym_SEMI] = ACTIONS(1926),
    [anon_sym_case] = ACTIONS(1928),
    [anon_sym_yield] = ACTIONS(1928),
    [anon_sym_LBRACK] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(1926),
    [anon_sym_SLASH] = ACTIONS(1928),
    [anon_sym_class] = ACTIONS(1928),
    [anon_sym_async] = ACTIONS(1928),
    [anon_sym_function] = ACTIONS(1928),
    [anon_sym_EQ_GT] = ACTIONS(1926),
    [anon_sym_new] = ACTIONS(1928),
    [anon_sym_PLUS] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1928),
    [anon_sym_BANG] = ACTIONS(1926),
    [anon_sym_TILDE] = ACTIONS(1926),
    [anon_sym_typeof] = ACTIONS(1928),
    [anon_sym_void] = ACTIONS(1928),
    [anon_sym_delete] = ACTIONS(1928),
    [anon_sym_PLUS_PLUS] = ACTIONS(1926),
    [anon_sym_DASH_DASH] = ACTIONS(1926),
    [anon_sym_DQUOTE] = ACTIONS(1926),
    [anon_sym_SQUOTE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1926),
    [sym_number] = ACTIONS(1926),
    [sym_identifier] = ACTIONS(1928),
    [sym_this] = ACTIONS(1928),
    [sym_super] = ACTIONS(1928),
    [sym_true] = ACTIONS(1928),
    [sym_false] = ACTIONS(1928),
    [sym_null] = ACTIONS(1928),
    [sym_undefined] = ACTIONS(1928),
    [anon_sym_AT] = ACTIONS(1926),
    [anon_sym_get] = ACTIONS(1928),
    [anon_sym_set] = ACTIONS(1928),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(1930),
    [anon_sym_export] = ACTIONS(1932),
    [anon_sym_default] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1930),
    [anon_sym_RBRACE] = ACTIONS(1930),
    [anon_sym_import] = ACTIONS(1932),
    [anon_sym_var] = ACTIONS(1932),
    [anon_sym_let] = ACTIONS(1932),
    [anon_sym_const] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(1932),
    [anon_sym_else] = ACTIONS(1932),
    [anon_sym_switch] = ACTIONS(1932),
    [anon_sym_for] = ACTIONS(1932),
    [anon_sym_LPAREN] = ACTIONS(1930),
    [anon_sym_await] = ACTIONS(1932),
    [anon_sym_while] = ACTIONS(1932),
    [anon_sym_do] = ACTIONS(1932),
    [anon_sym_try] = ACTIONS(1932),
    [anon_sym_with] = ACTIONS(1932),
    [anon_sym_break] = ACTIONS(1932),
    [anon_sym_continue] = ACTIONS(1932),
    [anon_sym_debugger] = ACTIONS(1932),
    [anon_sym_return] = ACTIONS(1932),
    [anon_sym_throw] = ACTIONS(1932),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_case] = ACTIONS(1932),
    [anon_sym_yield] = ACTIONS(1932),
    [anon_sym_LBRACK] = ACTIONS(1930),
    [anon_sym_LT] = ACTIONS(1930),
    [anon_sym_SLASH] = ACTIONS(1932),
    [anon_sym_class] = ACTIONS(1932),
    [anon_sym_async] = ACTIONS(1932),
    [anon_sym_function] = ACTIONS(1932),
    [anon_sym_EQ_GT] = ACTIONS(1930),
    [anon_sym_new] = ACTIONS(1932),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG] = ACTIONS(1930),
    [anon_sym_TILDE] = ACTIONS(1930),
    [anon_sym_typeof] = ACTIONS(1932),
    [anon_sym_void] = ACTIONS(1932),
    [anon_sym_delete] = ACTIONS(1932),
    [anon_sym_PLUS_PLUS] = ACTIONS(1930),
    [anon_sym_DASH_DASH] = ACTIONS(1930),
    [anon_sym_DQUOTE] = ACTIONS(1930),
    [anon_sym_SQUOTE] = ACTIONS(1930),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1930),
    [sym_number] = ACTIONS(1930),
    [sym_identifier] = ACTIONS(1932),
    [sym_this] = ACTIONS(1932),
    [sym_super] = ACTIONS(1932),
    [sym_true] = ACTIONS(1932),
    [sym_false] = ACTIONS(1932),
    [sym_null] = ACTIONS(1932),
    [sym_undefined] = ACTIONS(1932),
    [anon_sym_AT] = ACTIONS(1930),
    [anon_sym_get] = ACTIONS(1932),
    [anon_sym_set] = ACTIONS(1932),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(1934),
    [anon_sym_export] = ACTIONS(1936),
    [anon_sym_default] = ACTIONS(1936),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_RBRACE] = ACTIONS(1934),
    [anon_sym_import] = ACTIONS(1936),
    [anon_sym_var] = ACTIONS(1936),
    [anon_sym_let] = ACTIONS(1936),
    [anon_sym_const] = ACTIONS(1936),
    [anon_sym_if] = ACTIONS(1936),
    [anon_sym_else] = ACTIONS(1936),
    [anon_sym_switch] = ACTIONS(1936),
    [anon_sym_for] = ACTIONS(1936),
    [anon_sym_LPAREN] = ACTIONS(1934),
    [anon_sym_await] = ACTIONS(1936),
    [anon_sym_while] = ACTIONS(1936),
    [anon_sym_do] = ACTIONS(1936),
    [anon_sym_try] = ACTIONS(1936),
    [anon_sym_with] = ACTIONS(1936),
    [anon_sym_break] = ACTIONS(1936),
    [anon_sym_continue] = ACTIONS(1936),
    [anon_sym_debugger] = ACTIONS(1936),
    [anon_sym_return] = ACTIONS(1936),
    [anon_sym_throw] = ACTIONS(1936),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_case] = ACTIONS(1936),
    [anon_sym_yield] = ACTIONS(1936),
    [anon_sym_LBRACK] = ACTIONS(1934),
    [anon_sym_LT] = ACTIONS(1934),
    [anon_sym_SLASH] = ACTIONS(1936),
    [anon_sym_class] = ACTIONS(1936),
    [anon_sym_async] = ACTIONS(1936),
    [anon_sym_function] = ACTIONS(1936),
    [anon_sym_EQ_GT] = ACTIONS(1934),
    [anon_sym_new] = ACTIONS(1936),
    [anon_sym_PLUS] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1936),
    [anon_sym_BANG] = ACTIONS(1934),
    [anon_sym_TILDE] = ACTIONS(1934),
    [anon_sym_typeof] = ACTIONS(1936),
    [anon_sym_void] = ACTIONS(1936),
    [anon_sym_delete] = ACTIONS(1936),
    [anon_sym_PLUS_PLUS] = ACTIONS(1934),
    [anon_sym_DASH_DASH] = ACTIONS(1934),
    [anon_sym_DQUOTE] = ACTIONS(1934),
    [anon_sym_SQUOTE] = ACTIONS(1934),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1934),
    [sym_number] = ACTIONS(1934),
    [sym_identifier] = ACTIONS(1936),
    [sym_this] = ACTIONS(1936),
    [sym_super] = ACTIONS(1936),
    [sym_true] = ACTIONS(1936),
    [sym_false] = ACTIONS(1936),
    [sym_null] = ACTIONS(1936),
    [sym_undefined] = ACTIONS(1936),
    [anon_sym_AT] = ACTIONS(1934),
    [anon_sym_get] = ACTIONS(1936),
    [anon_sym_set] = ACTIONS(1936),
  },
  [507] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(1938),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [508] = {
    [anon_sym_COMMA] = ACTIONS(1938),
    [anon_sym_RPAREN] = ACTIONS(1938),
    [anon_sym_RBRACK] = ACTIONS(1938),
    [sym_comment] = ACTIONS(78),
  },
  [509] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [510] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(897),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [511] = {
    [sym_parenthesized_expression] = STATE(918),
    [sym__expression] = STATE(918),
    [sym_yield_expression] = STATE(918),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(918),
    [sym_jsx_fragment] = STATE(918),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(918),
    [sym_anonymous_class] = STATE(918),
    [sym_class] = STATE(918),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(918),
    [sym_generator_function] = STATE(918),
    [sym_call_expression] = STATE(918),
    [sym_new_expression] = STATE(918),
    [sym_await_expression] = STATE(918),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(918),
    [sym_augmented_assignment_expression] = STATE(918),
    [sym_ternary_expression] = STATE(918),
    [sym_binary_expression] = STATE(918),
    [sym_unary_expression] = STATE(918),
    [sym_update_expression] = STATE(918),
    [sym_string] = STATE(918),
    [sym_template_string] = STATE(918),
    [sym_regex] = STATE(918),
    [sym_meta_property] = STATE(918),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1940),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1942),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1942),
    [sym_false] = ACTIONS(1942),
    [sym_null] = ACTIONS(1942),
    [sym_undefined] = ACTIONS(1942),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [512] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(919),
    [sym__expression] = STATE(919),
    [sym_yield_expression] = STATE(919),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(919),
    [sym_jsx_fragment] = STATE(919),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(919),
    [sym_anonymous_class] = STATE(919),
    [sym_class] = STATE(919),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(919),
    [sym_generator_function] = STATE(919),
    [sym_call_expression] = STATE(919),
    [sym_new_expression] = STATE(919),
    [sym_await_expression] = STATE(919),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(919),
    [sym_augmented_assignment_expression] = STATE(919),
    [sym_ternary_expression] = STATE(919),
    [sym_binary_expression] = STATE(919),
    [sym_unary_expression] = STATE(919),
    [sym_update_expression] = STATE(919),
    [sym_string] = STATE(919),
    [sym_template_string] = STATE(919),
    [sym_regex] = STATE(919),
    [sym_meta_property] = STATE(919),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1944),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1946),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1946),
    [sym_false] = ACTIONS(1946),
    [sym_null] = ACTIONS(1946),
    [sym_undefined] = ACTIONS(1946),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [513] = {
    [sym_parenthesized_expression] = STATE(920),
    [sym__expression] = STATE(920),
    [sym_yield_expression] = STATE(920),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(920),
    [sym_jsx_fragment] = STATE(920),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(920),
    [sym_anonymous_class] = STATE(920),
    [sym_class] = STATE(920),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(920),
    [sym_generator_function] = STATE(920),
    [sym_call_expression] = STATE(920),
    [sym_new_expression] = STATE(920),
    [sym_await_expression] = STATE(920),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(920),
    [sym_augmented_assignment_expression] = STATE(920),
    [sym_ternary_expression] = STATE(920),
    [sym_binary_expression] = STATE(920),
    [sym_unary_expression] = STATE(920),
    [sym_update_expression] = STATE(920),
    [sym_string] = STATE(920),
    [sym_template_string] = STATE(920),
    [sym_regex] = STATE(920),
    [sym_meta_property] = STATE(920),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1948),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1950),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1950),
    [sym_false] = ACTIONS(1950),
    [sym_null] = ACTIONS(1950),
    [sym_undefined] = ACTIONS(1950),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [514] = {
    [anon_sym_EQ_GT] = ACTIONS(1952),
    [sym_comment] = ACTIONS(78),
  },
  [515] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [516] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(514),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(923),
  },
  [517] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(919),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [518] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(1581),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [519] = {
    [sym_parenthesized_expression] = STATE(922),
    [sym__expression] = STATE(922),
    [sym_yield_expression] = STATE(922),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(922),
    [sym_jsx_fragment] = STATE(922),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(922),
    [sym_anonymous_class] = STATE(922),
    [sym_class] = STATE(922),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(922),
    [sym_generator_function] = STATE(922),
    [sym_call_expression] = STATE(922),
    [sym_new_expression] = STATE(922),
    [sym_await_expression] = STATE(922),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(922),
    [sym_augmented_assignment_expression] = STATE(922),
    [sym_ternary_expression] = STATE(922),
    [sym_binary_expression] = STATE(922),
    [sym_unary_expression] = STATE(922),
    [sym_update_expression] = STATE(922),
    [sym_string] = STATE(922),
    [sym_template_string] = STATE(922),
    [sym_regex] = STATE(922),
    [sym_meta_property] = STATE(922),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1954),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1956),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1956),
    [sym_false] = ACTIONS(1956),
    [sym_null] = ACTIONS(1956),
    [sym_undefined] = ACTIONS(1956),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [520] = {
    [sym_parenthesized_expression] = STATE(923),
    [sym__expression] = STATE(923),
    [sym_yield_expression] = STATE(923),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(923),
    [sym_jsx_fragment] = STATE(923),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(923),
    [sym_anonymous_class] = STATE(923),
    [sym_class] = STATE(923),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(923),
    [sym_generator_function] = STATE(923),
    [sym_call_expression] = STATE(923),
    [sym_new_expression] = STATE(923),
    [sym_await_expression] = STATE(923),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(923),
    [sym_augmented_assignment_expression] = STATE(923),
    [sym_ternary_expression] = STATE(923),
    [sym_binary_expression] = STATE(923),
    [sym_unary_expression] = STATE(923),
    [sym_update_expression] = STATE(923),
    [sym_string] = STATE(923),
    [sym_template_string] = STATE(923),
    [sym_regex] = STATE(923),
    [sym_meta_property] = STATE(923),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1958),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1960),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1960),
    [sym_false] = ACTIONS(1960),
    [sym_null] = ACTIONS(1960),
    [sym_undefined] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [521] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [522] = {
    [sym__automatic_semicolon] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_in] = ACTIONS(1964),
    [anon_sym_of] = ACTIONS(1962),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_LBRACK] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_DOT] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1964),
    [anon_sym_QMARK] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_GT_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1962),
    [anon_sym_LT_EQ] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1962),
    [anon_sym_BANG_EQ] = ACTIONS(1964),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1962),
    [anon_sym_GT_EQ] = ACTIONS(1962),
    [anon_sym_instanceof] = ACTIONS(1962),
    [anon_sym_PLUS_PLUS] = ACTIONS(1962),
    [anon_sym_DASH_DASH] = ACTIONS(1962),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1962),
  },
  [523] = {
    [sym_parenthesized_expression] = STATE(924),
    [sym__expression] = STATE(924),
    [sym_yield_expression] = STATE(924),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(924),
    [sym_jsx_fragment] = STATE(924),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(924),
    [sym_anonymous_class] = STATE(924),
    [sym_class] = STATE(924),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(924),
    [sym_generator_function] = STATE(924),
    [sym_call_expression] = STATE(924),
    [sym_new_expression] = STATE(924),
    [sym_await_expression] = STATE(924),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(924),
    [sym_augmented_assignment_expression] = STATE(924),
    [sym_ternary_expression] = STATE(924),
    [sym_binary_expression] = STATE(924),
    [sym_unary_expression] = STATE(924),
    [sym_update_expression] = STATE(924),
    [sym_string] = STATE(924),
    [sym_template_string] = STATE(924),
    [sym_regex] = STATE(924),
    [sym_meta_property] = STATE(924),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1966),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(1968),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1968),
    [sym_false] = ACTIONS(1968),
    [sym_null] = ACTIONS(1968),
    [sym_undefined] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [524] = {
    [sym_parenthesized_expression] = STATE(925),
    [sym__expression] = STATE(925),
    [sym_yield_expression] = STATE(925),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(925),
    [sym_jsx_fragment] = STATE(925),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(925),
    [sym_anonymous_class] = STATE(925),
    [sym_class] = STATE(925),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(925),
    [sym_generator_function] = STATE(925),
    [sym_call_expression] = STATE(925),
    [sym_new_expression] = STATE(925),
    [sym_await_expression] = STATE(925),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(925),
    [sym_augmented_assignment_expression] = STATE(925),
    [sym_ternary_expression] = STATE(925),
    [sym_binary_expression] = STATE(925),
    [sym_unary_expression] = STATE(925),
    [sym_update_expression] = STATE(925),
    [sym_string] = STATE(925),
    [sym_template_string] = STATE(925),
    [sym_regex] = STATE(925),
    [sym_meta_property] = STATE(925),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1970),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1972),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1972),
    [sym_false] = ACTIONS(1972),
    [sym_null] = ACTIONS(1972),
    [sym_undefined] = ACTIONS(1972),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [525] = {
    [sym_parenthesized_expression] = STATE(926),
    [sym__expression] = STATE(926),
    [sym_yield_expression] = STATE(926),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(926),
    [sym_jsx_fragment] = STATE(926),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(926),
    [sym_anonymous_class] = STATE(926),
    [sym_class] = STATE(926),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(926),
    [sym_generator_function] = STATE(926),
    [sym_call_expression] = STATE(926),
    [sym_new_expression] = STATE(926),
    [sym_await_expression] = STATE(926),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(926),
    [sym_augmented_assignment_expression] = STATE(926),
    [sym_ternary_expression] = STATE(926),
    [sym_binary_expression] = STATE(926),
    [sym_unary_expression] = STATE(926),
    [sym_update_expression] = STATE(926),
    [sym_string] = STATE(926),
    [sym_template_string] = STATE(926),
    [sym_regex] = STATE(926),
    [sym_meta_property] = STATE(926),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1974),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1976),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1976),
    [sym_false] = ACTIONS(1976),
    [sym_null] = ACTIONS(1976),
    [sym_undefined] = ACTIONS(1976),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [526] = {
    [sym_parenthesized_expression] = STATE(927),
    [sym__expression] = STATE(927),
    [sym_yield_expression] = STATE(927),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(927),
    [sym_jsx_fragment] = STATE(927),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(927),
    [sym_anonymous_class] = STATE(927),
    [sym_class] = STATE(927),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(927),
    [sym_generator_function] = STATE(927),
    [sym_call_expression] = STATE(927),
    [sym_new_expression] = STATE(927),
    [sym_await_expression] = STATE(927),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(927),
    [sym_augmented_assignment_expression] = STATE(927),
    [sym_ternary_expression] = STATE(927),
    [sym_binary_expression] = STATE(927),
    [sym_unary_expression] = STATE(927),
    [sym_update_expression] = STATE(927),
    [sym_string] = STATE(927),
    [sym_template_string] = STATE(927),
    [sym_regex] = STATE(927),
    [sym_meta_property] = STATE(927),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1978),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(1980),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1980),
    [sym_false] = ACTIONS(1980),
    [sym_null] = ACTIONS(1980),
    [sym_undefined] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [527] = {
    [aux_sym_array_repeat1] = STATE(530),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(1982),
    [sym_comment] = ACTIONS(78),
  },
  [528] = {
    [anon_sym_STAR] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_in] = ACTIONS(1235),
    [anon_sym_COLON] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_AMP_AMP] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_GT_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1235),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_instanceof] = ACTIONS(1233),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_DASH_DASH] = ACTIONS(1233),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1233),
  },
  [529] = {
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_in] = ACTIONS(1239),
    [anon_sym_COLON] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_RBRACK] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_GT_GT] = ACTIONS(1239),
    [anon_sym_GT_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1239),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1239),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_instanceof] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_DASH_DASH] = ACTIONS(1237),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1237),
  },
  [530] = {
    [aux_sym_array_repeat1] = STATE(530),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1938),
    [sym_comment] = ACTIONS(78),
  },
  [531] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(1987),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [532] = {
    [sym_jsx_element] = STATE(665),
    [sym_jsx_expression] = STATE(665),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_self_closing_element] = STATE(665),
    [aux_sym_jsx_element_repeat1] = STATE(665),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(1989),
    [sym_jsx_text] = ACTIONS(1263),
    [sym_comment] = ACTIONS(78),
  },
  [533] = {
    [sym_parenthesized_expression] = STATE(932),
    [sym__expression] = STATE(932),
    [sym_yield_expression] = STATE(932),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(932),
    [sym_jsx_fragment] = STATE(932),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(932),
    [sym_anonymous_class] = STATE(932),
    [sym_class] = STATE(932),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(932),
    [sym_generator_function] = STATE(932),
    [sym_call_expression] = STATE(932),
    [sym_new_expression] = STATE(932),
    [sym_await_expression] = STATE(932),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(932),
    [sym_augmented_assignment_expression] = STATE(932),
    [sym_spread_element] = STATE(933),
    [sym_ternary_expression] = STATE(932),
    [sym_binary_expression] = STATE(932),
    [sym_unary_expression] = STATE(932),
    [sym_update_expression] = STATE(932),
    [sym_sequence_expression] = STATE(933),
    [sym_string] = STATE(932),
    [sym_template_string] = STATE(932),
    [sym_regex] = STATE(932),
    [sym_meta_property] = STATE(932),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_RBRACE] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(1995),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1995),
    [sym_false] = ACTIONS(1995),
    [sym_null] = ACTIONS(1995),
    [sym_undefined] = ACTIONS(1995),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [534] = {
    [sym_jsx_identifier] = ACTIONS(1997),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1999),
  },
  [535] = {
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_LT] = ACTIONS(2001),
    [sym_jsx_text] = ACTIONS(2001),
    [sym_comment] = ACTIONS(78),
  },
  [536] = {
    [anon_sym_GT] = ACTIONS(2003),
    [sym_comment] = ACTIONS(78),
  },
  [537] = {
    [anon_sym_LBRACE] = ACTIONS(2005),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2007),
    [sym_jsx_identifier] = ACTIONS(2005),
    [anon_sym_EQ] = ACTIONS(2009),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2007),
  },
  [538] = {
    [anon_sym_LBRACE] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_jsx_identifier] = ACTIONS(2011),
    [anon_sym_EQ] = ACTIONS(2015),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2013),
  },
  [539] = {
    [sym_jsx_expression] = STATE(940),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(940),
    [aux_sym_jsx_opening_element_repeat1] = STATE(940),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(2019),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [540] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2021),
  },
  [541] = {
    [sym__automatic_semicolon] = ACTIONS(2023),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_COMMA] = ACTIONS(2023),
    [anon_sym_RBRACE] = ACTIONS(2023),
    [anon_sym_LPAREN] = ACTIONS(2023),
    [anon_sym_RPAREN] = ACTIONS(2023),
    [anon_sym_in] = ACTIONS(2025),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym_LBRACK] = ACTIONS(2023),
    [anon_sym_LT] = ACTIONS(2025),
    [anon_sym_GT] = ACTIONS(2025),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_DOT] = ACTIONS(2023),
    [anon_sym_QMARK] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_GT_GT_GT] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(2025),
    [anon_sym_PLUS] = ACTIONS(2025),
    [anon_sym_DASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ] = ACTIONS(2025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2025),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2023),
    [anon_sym_GT_EQ] = ACTIONS(2023),
    [anon_sym_instanceof] = ACTIONS(2025),
    [anon_sym_PLUS_PLUS] = ACTIONS(2023),
    [anon_sym_DASH_DASH] = ACTIONS(2023),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2023),
    [sym_regex_flags] = ACTIONS(2027),
  },
  [542] = {
    [sym__automatic_semicolon] = ACTIONS(2029),
    [ts_builtin_sym_end] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_COMMA] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_LT] = ACTIONS(2031),
    [anon_sym_GT] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_DOT] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_EQ_GT] = ACTIONS(2029),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_QMARK] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [anon_sym_GT_GT] = ACTIONS(2031),
    [anon_sym_GT_GT_GT] = ACTIONS(2029),
    [anon_sym_LT_LT] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2031),
    [anon_sym_CARET] = ACTIONS(2029),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_PERCENT] = ACTIONS(2029),
    [anon_sym_LT_EQ] = ACTIONS(2029),
    [anon_sym_EQ_EQ] = ACTIONS(2031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2029),
    [anon_sym_BANG_EQ] = ACTIONS(2031),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2029),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_instanceof] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2031),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_number] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
  },
  [543] = {
    [sym_parenthesized_expression] = STATE(943),
    [sym__expression] = STATE(943),
    [sym_yield_expression] = STATE(943),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(943),
    [sym_jsx_fragment] = STATE(943),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(943),
    [sym_anonymous_class] = STATE(943),
    [sym_class] = STATE(943),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(943),
    [sym_generator_function] = STATE(943),
    [sym_call_expression] = STATE(943),
    [sym_new_expression] = STATE(943),
    [sym_await_expression] = STATE(943),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(943),
    [sym_augmented_assignment_expression] = STATE(943),
    [sym_ternary_expression] = STATE(943),
    [sym_binary_expression] = STATE(943),
    [sym_unary_expression] = STATE(943),
    [sym_update_expression] = STATE(943),
    [sym_string] = STATE(943),
    [sym_template_string] = STATE(943),
    [sym_regex] = STATE(943),
    [sym_meta_property] = STATE(943),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2033),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(2035),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2035),
    [sym_false] = ACTIONS(2035),
    [sym_null] = ACTIONS(2035),
    [sym_undefined] = ACTIONS(2035),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [544] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [sym__automatic_semicolon] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(540),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [545] = {
    [aux_sym_string_repeat1] = STATE(945),
    [anon_sym_DQUOTE] = ACTIONS(2037),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(2039),
    [sym_escape_sequence] = ACTIONS(2039),
    [sym_comment] = ACTIONS(298),
  },
  [546] = {
    [aux_sym_string_repeat2] = STATE(946),
    [anon_sym_SQUOTE] = ACTIONS(2037),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(2041),
    [sym_escape_sequence] = ACTIONS(2041),
    [sym_comment] = ACTIONS(298),
  },
  [547] = {
    [sym__automatic_semicolon] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(540),
    [sym_comment] = ACTIONS(78),
  },
  [548] = {
    [sym_string] = STATE(552),
    [sym_public_field_definition] = STATE(947),
    [sym_method_definition] = STATE(948),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
  },
  [549] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [sym__automatic_semicolon] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(540),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [550] = {
    [sym__automatic_semicolon] = ACTIONS(2043),
    [anon_sym_SEMI] = ACTIONS(2043),
    [sym_comment] = ACTIONS(78),
  },
  [551] = {
    [anon_sym_STAR] = ACTIONS(2045),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_SEMI] = ACTIONS(2043),
    [anon_sym_LBRACK] = ACTIONS(2045),
    [anon_sym_async] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2045),
    [anon_sym_SQUOTE] = ACTIONS(2045),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(2045),
    [sym_identifier] = ACTIONS(2047),
    [anon_sym_AT] = ACTIONS(2045),
    [anon_sym_static] = ACTIONS(2047),
    [anon_sym_get] = ACTIONS(2047),
    [anon_sym_set] = ACTIONS(2047),
  },
  [552] = {
    [sym__initializer] = STATE(950),
    [sym_formal_parameters] = STATE(335),
    [sym__automatic_semicolon] = ACTIONS(2049),
    [anon_sym_LPAREN] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(2049),
    [anon_sym_EQ] = ACTIONS(2051),
    [sym_comment] = ACTIONS(78),
  },
  [553] = {
    [sym_string] = STATE(552),
    [sym_decorator] = STATE(952),
    [sym_public_field_definition] = STATE(947),
    [sym_method_definition] = STATE(948),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [aux_sym_export_statement_repeat1] = STATE(952),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_static] = ACTIONS(2053),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
  },
  [554] = {
    [sym_string] = STATE(552),
    [sym_decorator] = STATE(553),
    [sym_public_field_definition] = STATE(550),
    [sym_method_definition] = STATE(551),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [aux_sym_export_statement_repeat1] = STATE(553),
    [aux_sym_class_body_repeat1] = STATE(954),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
  },
  [555] = {
    [sym_parenthesized_expression] = STATE(955),
    [sym__expression] = STATE(955),
    [sym_yield_expression] = STATE(955),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(955),
    [sym_jsx_fragment] = STATE(955),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(955),
    [sym_anonymous_class] = STATE(955),
    [sym_class] = STATE(955),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(955),
    [sym_generator_function] = STATE(955),
    [sym_call_expression] = STATE(955),
    [sym_new_expression] = STATE(955),
    [sym_await_expression] = STATE(955),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(955),
    [sym_augmented_assignment_expression] = STATE(955),
    [sym_ternary_expression] = STATE(955),
    [sym_binary_expression] = STATE(955),
    [sym_unary_expression] = STATE(955),
    [sym_update_expression] = STATE(955),
    [sym_string] = STATE(955),
    [sym_template_string] = STATE(955),
    [sym_regex] = STATE(955),
    [sym_meta_property] = STATE(955),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2057),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(2059),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2059),
    [sym_false] = ACTIONS(2059),
    [sym_null] = ACTIONS(2059),
    [sym_undefined] = ACTIONS(2059),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [556] = {
    [sym_parenthesized_expression] = STATE(956),
    [sym__expression] = STATE(956),
    [sym_yield_expression] = STATE(956),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(956),
    [sym_jsx_fragment] = STATE(956),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(956),
    [sym_anonymous_class] = STATE(956),
    [sym_class] = STATE(956),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(956),
    [sym_generator_function] = STATE(956),
    [sym_call_expression] = STATE(956),
    [sym_new_expression] = STATE(956),
    [sym_await_expression] = STATE(956),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(956),
    [sym_augmented_assignment_expression] = STATE(956),
    [sym_ternary_expression] = STATE(956),
    [sym_binary_expression] = STATE(956),
    [sym_unary_expression] = STATE(956),
    [sym_update_expression] = STATE(956),
    [sym_string] = STATE(956),
    [sym_template_string] = STATE(956),
    [sym_regex] = STATE(956),
    [sym_meta_property] = STATE(956),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2061),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(2063),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2063),
    [sym_false] = ACTIONS(2063),
    [sym_null] = ACTIONS(2063),
    [sym_undefined] = ACTIONS(2063),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [557] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(960),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LBRACE] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(2067),
    [anon_sym_PLUS_EQ] = ACTIONS(2069),
    [anon_sym_DASH_EQ] = ACTIONS(2069),
    [anon_sym_STAR_EQ] = ACTIONS(2069),
    [anon_sym_SLASH_EQ] = ACTIONS(2069),
    [anon_sym_PERCENT_EQ] = ACTIONS(2069),
    [anon_sym_CARET_EQ] = ACTIONS(2069),
    [anon_sym_AMP_EQ] = ACTIONS(2069),
    [anon_sym_PIPE_EQ] = ACTIONS(2069),
    [anon_sym_GT_GT_EQ] = ACTIONS(2069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2069),
    [anon_sym_LT_LT_EQ] = ACTIONS(2069),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(2071),
  },
  [558] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(961),
    [sym__expression] = STATE(961),
    [sym_yield_expression] = STATE(961),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(961),
    [sym_jsx_fragment] = STATE(961),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(961),
    [sym_anonymous_class] = STATE(961),
    [sym_class] = STATE(961),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(961),
    [sym_generator_function] = STATE(961),
    [sym_call_expression] = STATE(961),
    [sym_new_expression] = STATE(961),
    [sym_await_expression] = STATE(961),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(961),
    [sym_augmented_assignment_expression] = STATE(961),
    [sym_ternary_expression] = STATE(961),
    [sym_binary_expression] = STATE(961),
    [sym_unary_expression] = STATE(961),
    [sym_update_expression] = STATE(961),
    [sym_string] = STATE(961),
    [sym_template_string] = STATE(961),
    [sym_regex] = STATE(961),
    [sym_meta_property] = STATE(961),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2073),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(2075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_null] = ACTIONS(2075),
    [sym_undefined] = ACTIONS(2075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [559] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2077),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(2079),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [560] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [561] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [562] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_EQ_GT] = ACTIONS(2067),
    [anon_sym_PLUS_EQ] = ACTIONS(2083),
    [anon_sym_DASH_EQ] = ACTIONS(2083),
    [anon_sym_STAR_EQ] = ACTIONS(2083),
    [anon_sym_SLASH_EQ] = ACTIONS(2083),
    [anon_sym_PERCENT_EQ] = ACTIONS(2083),
    [anon_sym_CARET_EQ] = ACTIONS(2083),
    [anon_sym_AMP_EQ] = ACTIONS(2083),
    [anon_sym_PIPE_EQ] = ACTIONS(2083),
    [anon_sym_GT_GT_EQ] = ACTIONS(2083),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2083),
    [anon_sym_LT_LT_EQ] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [563] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LBRACE] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2069),
    [anon_sym_DASH_EQ] = ACTIONS(2069),
    [anon_sym_STAR_EQ] = ACTIONS(2069),
    [anon_sym_SLASH_EQ] = ACTIONS(2069),
    [anon_sym_PERCENT_EQ] = ACTIONS(2069),
    [anon_sym_CARET_EQ] = ACTIONS(2069),
    [anon_sym_AMP_EQ] = ACTIONS(2069),
    [anon_sym_PIPE_EQ] = ACTIONS(2069),
    [anon_sym_GT_GT_EQ] = ACTIONS(2069),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2069),
    [anon_sym_LT_LT_EQ] = ACTIONS(2069),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [564] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2087),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [565] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [566] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [567] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(2065),
    [anon_sym_PLUS_EQ] = ACTIONS(2083),
    [anon_sym_DASH_EQ] = ACTIONS(2083),
    [anon_sym_STAR_EQ] = ACTIONS(2083),
    [anon_sym_SLASH_EQ] = ACTIONS(2083),
    [anon_sym_PERCENT_EQ] = ACTIONS(2083),
    [anon_sym_CARET_EQ] = ACTIONS(2083),
    [anon_sym_AMP_EQ] = ACTIONS(2083),
    [anon_sym_PIPE_EQ] = ACTIONS(2083),
    [anon_sym_GT_GT_EQ] = ACTIONS(2083),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2083),
    [anon_sym_LT_LT_EQ] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [568] = {
    [anon_sym_EQ_GT] = ACTIONS(2067),
    [sym_comment] = ACTIONS(78),
  },
  [569] = {
    [sym_class_body] = STATE(971),
    [anon_sym_LBRACE] = ACTIONS(302),
    [sym_comment] = ACTIONS(78),
  },
  [570] = {
    [sym__automatic_semicolon] = ACTIONS(2105),
    [ts_builtin_sym_end] = ACTIONS(2105),
    [anon_sym_export] = ACTIONS(2107),
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_default] = ACTIONS(2107),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_import] = ACTIONS(2107),
    [anon_sym_var] = ACTIONS(2107),
    [anon_sym_let] = ACTIONS(2107),
    [anon_sym_const] = ACTIONS(2107),
    [anon_sym_if] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2107),
    [anon_sym_switch] = ACTIONS(2107),
    [anon_sym_for] = ACTIONS(2107),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_RPAREN] = ACTIONS(2105),
    [anon_sym_in] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2107),
    [anon_sym_while] = ACTIONS(2107),
    [anon_sym_do] = ACTIONS(2107),
    [anon_sym_try] = ACTIONS(2107),
    [anon_sym_with] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2107),
    [anon_sym_continue] = ACTIONS(2107),
    [anon_sym_debugger] = ACTIONS(2107),
    [anon_sym_return] = ACTIONS(2107),
    [anon_sym_throw] = ACTIONS(2107),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_case] = ACTIONS(2107),
    [anon_sym_yield] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2107),
    [anon_sym_GT] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(2107),
    [anon_sym_DOT] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2107),
    [anon_sym_async] = ACTIONS(2107),
    [anon_sym_function] = ACTIONS(2107),
    [anon_sym_EQ_GT] = ACTIONS(2105),
    [anon_sym_new] = ACTIONS(2107),
    [anon_sym_QMARK] = ACTIONS(2105),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2107),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2107),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_instanceof] = ACTIONS(2107),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_typeof] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2107),
    [anon_sym_delete] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2105),
    [sym_number] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2107),
    [sym_this] = ACTIONS(2107),
    [sym_super] = ACTIONS(2107),
    [sym_true] = ACTIONS(2107),
    [sym_false] = ACTIONS(2107),
    [sym_null] = ACTIONS(2107),
    [sym_undefined] = ACTIONS(2107),
    [anon_sym_AT] = ACTIONS(2105),
    [anon_sym_get] = ACTIONS(2107),
    [anon_sym_set] = ACTIONS(2107),
  },
  [571] = {
    [sym__automatic_semicolon] = ACTIONS(2109),
    [anon_sym_STAR] = ACTIONS(2109),
    [anon_sym_COMMA] = ACTIONS(2109),
    [anon_sym_RBRACE] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_SEMI] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2109),
    [anon_sym_QMARK] = ACTIONS(2109),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2109),
    [anon_sym_LT_EQ] = ACTIONS(2109),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2109),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2109),
    [anon_sym_GT_EQ] = ACTIONS(2109),
    [anon_sym_instanceof] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2109),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2109),
  },
  [572] = {
    [sym_parenthesized_expression] = STATE(972),
    [sym__expression] = STATE(972),
    [sym_yield_expression] = STATE(972),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(972),
    [sym_jsx_fragment] = STATE(972),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(972),
    [sym_anonymous_class] = STATE(972),
    [sym_class] = STATE(972),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(972),
    [sym_generator_function] = STATE(972),
    [sym_call_expression] = STATE(972),
    [sym_new_expression] = STATE(972),
    [sym_await_expression] = STATE(972),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(972),
    [sym_augmented_assignment_expression] = STATE(972),
    [sym_spread_element] = STATE(726),
    [sym_ternary_expression] = STATE(972),
    [sym_binary_expression] = STATE(972),
    [sym_unary_expression] = STATE(972),
    [sym_update_expression] = STATE(972),
    [sym_string] = STATE(972),
    [sym_template_string] = STATE(972),
    [sym_regex] = STATE(972),
    [sym_meta_property] = STATE(972),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(727),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_RBRACK] = ACTIONS(1509),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2113),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(2115),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2115),
    [sym_false] = ACTIONS(2115),
    [sym_null] = ACTIONS(2115),
    [sym_undefined] = ACTIONS(2115),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [573] = {
    [aux_sym_formal_parameters_repeat1] = STATE(427),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [sym_comment] = ACTIONS(78),
  },
  [574] = {
    [sym__initializer] = STATE(729),
    [aux_sym_formal_parameters_repeat1] = STATE(457),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(826),
    [anon_sym_EQ] = ACTIONS(2119),
    [sym_comment] = ACTIONS(78),
  },
  [575] = {
    [sym__initializer] = STATE(730),
    [aux_sym_formal_parameters_repeat1] = STATE(471),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(2121),
    [anon_sym_EQ] = ACTIONS(2119),
    [sym_comment] = ACTIONS(78),
  },
  [576] = {
    [sym__initializer] = STATE(731),
    [aux_sym_formal_parameters_repeat1] = STATE(474),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_RPAREN] = ACTIONS(2123),
    [anon_sym_EQ] = ACTIONS(2119),
    [sym_comment] = ACTIONS(78),
  },
  [577] = {
    [sym__automatic_semicolon] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2127),
    [anon_sym_COMMA] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_RPAREN] = ACTIONS(2125),
    [anon_sym_in] = ACTIONS(2127),
    [anon_sym_SEMI] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2127),
    [anon_sym_GT] = ACTIONS(2127),
    [anon_sym_SLASH] = ACTIONS(2127),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2127),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [anon_sym_DASH_EQ] = ACTIONS(2125),
    [anon_sym_STAR_EQ] = ACTIONS(2125),
    [anon_sym_SLASH_EQ] = ACTIONS(2125),
    [anon_sym_PERCENT_EQ] = ACTIONS(2125),
    [anon_sym_CARET_EQ] = ACTIONS(2125),
    [anon_sym_AMP_EQ] = ACTIONS(2125),
    [anon_sym_PIPE_EQ] = ACTIONS(2125),
    [anon_sym_GT_GT_EQ] = ACTIONS(2125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2125),
    [anon_sym_LT_LT_EQ] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_GT] = ACTIONS(2127),
    [anon_sym_GT_GT_GT] = ACTIONS(2127),
    [anon_sym_LT_LT] = ACTIONS(2127),
    [anon_sym_AMP] = ACTIONS(2127),
    [anon_sym_CARET] = ACTIONS(2127),
    [anon_sym_PIPE] = ACTIONS(2127),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2127),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ] = ACTIONS(2127),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_instanceof] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2125),
  },
  [578] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [579] = {
    [sym_formal_parameters] = STATE(973),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [580] = {
    [sym_statement_block] = STATE(974),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(78),
  },
  [581] = {
    [sym__automatic_semicolon] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2131),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_in] = ACTIONS(2133),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2133),
    [anon_sym_GT] = ACTIONS(2133),
    [anon_sym_SLASH] = ACTIONS(2133),
    [anon_sym_DOT] = ACTIONS(2131),
    [anon_sym_QMARK] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_GT_GT] = ACTIONS(2133),
    [anon_sym_GT_GT_GT] = ACTIONS(2131),
    [anon_sym_LT_LT] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2133),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_PERCENT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2133),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_instanceof] = ACTIONS(2131),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2131),
  },
  [582] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [583] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2135),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [584] = {
    [sym_statement_block] = STATE(975),
    [sym_parenthesized_expression] = STATE(976),
    [sym__expression] = STATE(976),
    [sym_yield_expression] = STATE(976),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(976),
    [sym_jsx_fragment] = STATE(976),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(976),
    [sym_anonymous_class] = STATE(976),
    [sym_class] = STATE(976),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(976),
    [sym_generator_function] = STATE(976),
    [sym_call_expression] = STATE(976),
    [sym_new_expression] = STATE(976),
    [sym_await_expression] = STATE(976),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(976),
    [sym_augmented_assignment_expression] = STATE(976),
    [sym_ternary_expression] = STATE(976),
    [sym_binary_expression] = STATE(976),
    [sym_unary_expression] = STATE(976),
    [sym_update_expression] = STATE(976),
    [sym_string] = STATE(976),
    [sym_template_string] = STATE(976),
    [sym_regex] = STATE(976),
    [sym_meta_property] = STATE(976),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(2139),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [sym_null] = ACTIONS(2139),
    [sym_undefined] = ACTIONS(2139),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [585] = {
    [sym_formal_parameters] = STATE(977),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [586] = {
    [sym_statement_block] = STATE(978),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(78),
  },
  [587] = {
    [sym_export_statement] = STATE(589),
    [sym__declaration] = STATE(589),
    [sym_import_statement] = STATE(589),
    [sym_expression_statement] = STATE(589),
    [sym_variable_declaration] = STATE(589),
    [sym_lexical_declaration] = STATE(589),
    [sym_statement_block] = STATE(589),
    [sym_if_statement] = STATE(589),
    [sym_switch_statement] = STATE(589),
    [sym_for_statement] = STATE(589),
    [sym_for_in_statement] = STATE(589),
    [sym_for_of_statement] = STATE(589),
    [sym_while_statement] = STATE(589),
    [sym_do_statement] = STATE(589),
    [sym_try_statement] = STATE(589),
    [sym_with_statement] = STATE(589),
    [sym_break_statement] = STATE(589),
    [sym_continue_statement] = STATE(589),
    [sym_debugger_statement] = STATE(589),
    [sym_return_statement] = STATE(589),
    [sym_throw_statement] = STATE(589),
    [sym_empty_statement] = STATE(589),
    [sym_labeled_statement] = STATE(589),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(589),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [588] = {
    [sym__automatic_semicolon] = ACTIONS(2143),
    [ts_builtin_sym_end] = ACTIONS(2143),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2143),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_COMMA] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [anon_sym_RPAREN] = ACTIONS(2143),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2143),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_DOT] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_EQ_GT] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_QMARK] = ACTIONS(2143),
    [anon_sym_AMP_AMP] = ACTIONS(2143),
    [anon_sym_PIPE_PIPE] = ACTIONS(2143),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_GT_GT_GT] = ACTIONS(2143),
    [anon_sym_LT_LT] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2143),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_PERCENT] = ACTIONS(2143),
    [anon_sym_LT_EQ] = ACTIONS(2143),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2143),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2143),
    [anon_sym_GT_EQ] = ACTIONS(2143),
    [anon_sym_instanceof] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(2143),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_DASH_DASH] = ACTIONS(2143),
    [anon_sym_DQUOTE] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(2143),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [sym_number] = ACTIONS(2143),
    [sym_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2143),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
  },
  [589] = {
    [sym_export_statement] = STATE(338),
    [sym__declaration] = STATE(338),
    [sym_import_statement] = STATE(338),
    [sym_expression_statement] = STATE(338),
    [sym_variable_declaration] = STATE(338),
    [sym_lexical_declaration] = STATE(338),
    [sym_statement_block] = STATE(338),
    [sym_if_statement] = STATE(338),
    [sym_switch_statement] = STATE(338),
    [sym_for_statement] = STATE(338),
    [sym_for_in_statement] = STATE(338),
    [sym_for_of_statement] = STATE(338),
    [sym_while_statement] = STATE(338),
    [sym_do_statement] = STATE(338),
    [sym_try_statement] = STATE(338),
    [sym_with_statement] = STATE(338),
    [sym_break_statement] = STATE(338),
    [sym_continue_statement] = STATE(338),
    [sym_debugger_statement] = STATE(338),
    [sym_return_statement] = STATE(338),
    [sym_throw_statement] = STATE(338),
    [sym_empty_statement] = STATE(338),
    [sym_labeled_statement] = STATE(338),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(338),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [590] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(982),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(2149),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(2151),
  },
  [591] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(439),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(439),
    [sym_class] = STATE(439),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(439),
    [sym_generator_function] = STATE(439),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(439),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(439),
    [sym_template_string] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_meta_property] = STATE(439),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [592] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2153),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(2155),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [593] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(2149),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [594] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [595] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [596] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [597] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [598] = {
    [anon_sym_EQ_GT] = ACTIONS(2149),
    [sym_comment] = ACTIONS(78),
  },
  [599] = {
    [sym__automatic_semicolon] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2157),
    [anon_sym_COMMA] = ACTIONS(2157),
    [anon_sym_RBRACE] = ACTIONS(2157),
    [anon_sym_LPAREN] = ACTIONS(2157),
    [anon_sym_RPAREN] = ACTIONS(2157),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2157),
    [anon_sym_LT] = ACTIONS(2159),
    [anon_sym_GT] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2159),
    [anon_sym_DOT] = ACTIONS(2157),
    [anon_sym_QMARK] = ACTIONS(2157),
    [anon_sym_AMP_AMP] = ACTIONS(2157),
    [anon_sym_PIPE_PIPE] = ACTIONS(2157),
    [anon_sym_GT_GT] = ACTIONS(2159),
    [anon_sym_GT_GT_GT] = ACTIONS(2157),
    [anon_sym_LT_LT] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_PIPE] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PERCENT] = ACTIONS(2157),
    [anon_sym_LT_EQ] = ACTIONS(2157),
    [anon_sym_EQ_EQ] = ACTIONS(2159),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2157),
    [anon_sym_BANG_EQ] = ACTIONS(2159),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2157),
    [anon_sym_GT_EQ] = ACTIONS(2157),
    [anon_sym_instanceof] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2157),
  },
  [600] = {
    [sym_parenthesized_expression] = STATE(625),
    [sym__expression] = STATE(625),
    [sym_yield_expression] = STATE(625),
    [sym_object] = STATE(125),
    [sym_assignment_pattern] = STATE(126),
    [sym_array] = STATE(127),
    [sym_jsx_element] = STATE(625),
    [sym_jsx_fragment] = STATE(625),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(625),
    [sym_anonymous_class] = STATE(625),
    [sym_class] = STATE(625),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(625),
    [sym_generator_function] = STATE(625),
    [sym_call_expression] = STATE(625),
    [sym_new_expression] = STATE(625),
    [sym_await_expression] = STATE(625),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(625),
    [sym_augmented_assignment_expression] = STATE(625),
    [sym_spread_element] = STATE(626),
    [sym_ternary_expression] = STATE(625),
    [sym_binary_expression] = STATE(625),
    [sym_unary_expression] = STATE(625),
    [sym_update_expression] = STATE(625),
    [sym_string] = STATE(625),
    [sym_template_string] = STATE(625),
    [sym_regex] = STATE(625),
    [sym_meta_property] = STATE(625),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [sym_rest_parameter] = STATE(126),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(627),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(2161),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(174),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1163),
    [sym_identifier] = ACTIONS(198),
    [sym_this] = ACTIONS(1165),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1165),
    [sym_false] = ACTIONS(1165),
    [sym_null] = ACTIONS(1165),
    [sym_undefined] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(204),
    [anon_sym_set] = ACTIONS(204),
  },
  [601] = {
    [sym_parenthesized_expression] = STATE(439),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(439),
    [sym_class] = STATE(439),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(439),
    [sym_generator_function] = STATE(439),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(439),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(439),
    [sym_template_string] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_meta_property] = STATE(439),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [602] = {
    [sym_parenthesized_expression] = STATE(439),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(439),
    [sym_class] = STATE(439),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(439),
    [sym_generator_function] = STATE(439),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(439),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(439),
    [sym_template_string] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_meta_property] = STATE(439),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [603] = {
    [sym__automatic_semicolon] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_COMMA] = ACTIONS(2165),
    [anon_sym_RBRACE] = ACTIONS(2165),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_RPAREN] = ACTIONS(2165),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym_LBRACK] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_GT] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_DOT] = ACTIONS(2165),
    [anon_sym_QMARK] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(2165),
    [anon_sym_PIPE_PIPE] = ACTIONS(2165),
    [anon_sym_GT_GT] = ACTIONS(2167),
    [anon_sym_GT_GT_GT] = ACTIONS(2165),
    [anon_sym_LT_LT] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_CARET] = ACTIONS(2165),
    [anon_sym_PIPE] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_PERCENT] = ACTIONS(2165),
    [anon_sym_LT_EQ] = ACTIONS(2165),
    [anon_sym_EQ_EQ] = ACTIONS(2167),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2165),
    [anon_sym_BANG_EQ] = ACTIONS(2167),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2165),
    [anon_sym_GT_EQ] = ACTIONS(2165),
    [anon_sym_instanceof] = ACTIONS(2165),
    [anon_sym_PLUS_PLUS] = ACTIONS(2165),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2165),
  },
  [604] = {
    [sym__automatic_semicolon] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_RPAREN] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2171),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2171),
    [anon_sym_SLASH] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2171),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2171),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_instanceof] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2169),
  },
  [605] = {
    [sym_parenthesized_expression] = STATE(987),
    [sym__expression] = STATE(987),
    [sym_yield_expression] = STATE(987),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(987),
    [sym_jsx_fragment] = STATE(987),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(987),
    [sym_anonymous_class] = STATE(987),
    [sym_class] = STATE(987),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(987),
    [sym_generator_function] = STATE(987),
    [sym_call_expression] = STATE(987),
    [sym_new_expression] = STATE(987),
    [sym_await_expression] = STATE(987),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(987),
    [sym_augmented_assignment_expression] = STATE(987),
    [sym_ternary_expression] = STATE(987),
    [sym_binary_expression] = STATE(987),
    [sym_unary_expression] = STATE(987),
    [sym_update_expression] = STATE(987),
    [sym_string] = STATE(987),
    [sym_template_string] = STATE(987),
    [sym_regex] = STATE(987),
    [sym_meta_property] = STATE(987),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2173),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(2175),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2175),
    [sym_false] = ACTIONS(2175),
    [sym_null] = ACTIONS(2175),
    [sym_undefined] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [606] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [607] = {
    [sym_parenthesized_expression] = STATE(988),
    [sym__expression] = STATE(988),
    [sym_yield_expression] = STATE(988),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(988),
    [sym_jsx_fragment] = STATE(988),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(988),
    [sym_anonymous_class] = STATE(988),
    [sym_class] = STATE(988),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(988),
    [sym_generator_function] = STATE(988),
    [sym_call_expression] = STATE(988),
    [sym_new_expression] = STATE(988),
    [sym_await_expression] = STATE(988),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(988),
    [sym_augmented_assignment_expression] = STATE(988),
    [sym_ternary_expression] = STATE(988),
    [sym_binary_expression] = STATE(988),
    [sym_unary_expression] = STATE(988),
    [sym_update_expression] = STATE(988),
    [sym_string] = STATE(988),
    [sym_template_string] = STATE(988),
    [sym_regex] = STATE(988),
    [sym_meta_property] = STATE(988),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2177),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(2179),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2179),
    [sym_false] = ACTIONS(2179),
    [sym_null] = ACTIONS(2179),
    [sym_undefined] = ACTIONS(2179),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [608] = {
    [sym_parenthesized_expression] = STATE(989),
    [sym__expression] = STATE(989),
    [sym_yield_expression] = STATE(989),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(989),
    [sym_jsx_fragment] = STATE(989),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(989),
    [sym_anonymous_class] = STATE(989),
    [sym_class] = STATE(989),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(989),
    [sym_generator_function] = STATE(989),
    [sym_call_expression] = STATE(989),
    [sym_new_expression] = STATE(989),
    [sym_await_expression] = STATE(989),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(989),
    [sym_augmented_assignment_expression] = STATE(989),
    [sym_ternary_expression] = STATE(989),
    [sym_binary_expression] = STATE(989),
    [sym_unary_expression] = STATE(989),
    [sym_update_expression] = STATE(989),
    [sym_string] = STATE(989),
    [sym_template_string] = STATE(989),
    [sym_regex] = STATE(989),
    [sym_meta_property] = STATE(989),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2181),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(2183),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2183),
    [sym_false] = ACTIONS(2183),
    [sym_null] = ACTIONS(2183),
    [sym_undefined] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [609] = {
    [sym_parenthesized_expression] = STATE(990),
    [sym__expression] = STATE(990),
    [sym_yield_expression] = STATE(990),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(990),
    [sym_jsx_fragment] = STATE(990),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(990),
    [sym_anonymous_class] = STATE(990),
    [sym_class] = STATE(990),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(990),
    [sym_generator_function] = STATE(990),
    [sym_call_expression] = STATE(990),
    [sym_new_expression] = STATE(990),
    [sym_await_expression] = STATE(990),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(990),
    [sym_augmented_assignment_expression] = STATE(990),
    [sym_ternary_expression] = STATE(990),
    [sym_binary_expression] = STATE(990),
    [sym_unary_expression] = STATE(990),
    [sym_update_expression] = STATE(990),
    [sym_string] = STATE(990),
    [sym_template_string] = STATE(990),
    [sym_regex] = STATE(990),
    [sym_meta_property] = STATE(990),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2185),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(2187),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2187),
    [sym_false] = ACTIONS(2187),
    [sym_null] = ACTIONS(2187),
    [sym_undefined] = ACTIONS(2187),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [610] = {
    [sym_parenthesized_expression] = STATE(991),
    [sym__expression] = STATE(991),
    [sym_yield_expression] = STATE(991),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(991),
    [sym_jsx_fragment] = STATE(991),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(991),
    [sym_anonymous_class] = STATE(991),
    [sym_class] = STATE(991),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(991),
    [sym_generator_function] = STATE(991),
    [sym_call_expression] = STATE(991),
    [sym_new_expression] = STATE(991),
    [sym_await_expression] = STATE(991),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(991),
    [sym_augmented_assignment_expression] = STATE(991),
    [sym_ternary_expression] = STATE(991),
    [sym_binary_expression] = STATE(991),
    [sym_unary_expression] = STATE(991),
    [sym_update_expression] = STATE(991),
    [sym_string] = STATE(991),
    [sym_template_string] = STATE(991),
    [sym_regex] = STATE(991),
    [sym_meta_property] = STATE(991),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2189),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(2191),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2191),
    [sym_false] = ACTIONS(2191),
    [sym_null] = ACTIONS(2191),
    [sym_undefined] = ACTIONS(2191),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [611] = {
    [sym__automatic_semicolon] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(2193),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_RPAREN] = ACTIONS(2193),
    [anon_sym_in] = ACTIONS(2195),
    [anon_sym_SEMI] = ACTIONS(2193),
    [anon_sym_COLON] = ACTIONS(2193),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_LT] = ACTIONS(2195),
    [anon_sym_GT] = ACTIONS(2195),
    [anon_sym_SLASH] = ACTIONS(2195),
    [anon_sym_DOT] = ACTIONS(2193),
    [anon_sym_QMARK] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2193),
    [anon_sym_PIPE_PIPE] = ACTIONS(2193),
    [anon_sym_GT_GT] = ACTIONS(2195),
    [anon_sym_GT_GT_GT] = ACTIONS(2193),
    [anon_sym_LT_LT] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_CARET] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_PLUS] = ACTIONS(2195),
    [anon_sym_DASH] = ACTIONS(2195),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_EQ_EQ] = ACTIONS(2195),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2193),
    [anon_sym_BANG_EQ] = ACTIONS(2195),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2193),
    [anon_sym_instanceof] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2193),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2193),
  },
  [612] = {
    [aux_sym_string_repeat1] = STATE(612),
    [anon_sym_DQUOTE] = ACTIONS(2197),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(2199),
    [sym_escape_sequence] = ACTIONS(2199),
    [sym_comment] = ACTIONS(298),
  },
  [613] = {
    [aux_sym_string_repeat2] = STATE(613),
    [anon_sym_SQUOTE] = ACTIONS(2202),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(2204),
    [sym_escape_sequence] = ACTIONS(2204),
    [sym_comment] = ACTIONS(298),
  },
  [614] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2209),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [615] = {
    [anon_sym_RBRACE] = ACTIONS(2209),
    [sym_comment] = ACTIONS(78),
  },
  [616] = {
    [sym__automatic_semicolon] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(2211),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(2211),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_in] = ACTIONS(2213),
    [anon_sym_SEMI] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_GT] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_DOT] = ACTIONS(2211),
    [anon_sym_QMARK] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2213),
    [anon_sym_GT_GT_GT] = ACTIONS(2211),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2211),
    [anon_sym_LT_EQ] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2211),
    [anon_sym_BANG_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2211),
    [anon_sym_GT_EQ] = ACTIONS(2211),
    [anon_sym_instanceof] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2211),
  },
  [617] = {
    [sym_template_substitution] = STATE(617),
    [aux_sym_template_string_repeat1] = STATE(617),
    [sym__template_chars] = ACTIONS(2215),
    [sym_escape_sequence] = ACTIONS(2215),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2218),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2220),
  },
  [618] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(2227),
    [anon_sym_export] = ACTIONS(2229),
    [anon_sym_default] = ACTIONS(2229),
    [anon_sym_LBRACE] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2227),
    [anon_sym_import] = ACTIONS(2229),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2229),
    [anon_sym_if] = ACTIONS(2229),
    [anon_sym_else] = ACTIONS(2229),
    [anon_sym_switch] = ACTIONS(2229),
    [anon_sym_for] = ACTIONS(2229),
    [anon_sym_LPAREN] = ACTIONS(2227),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_while] = ACTIONS(2229),
    [anon_sym_do] = ACTIONS(2229),
    [anon_sym_try] = ACTIONS(2229),
    [anon_sym_with] = ACTIONS(2229),
    [anon_sym_break] = ACTIONS(2229),
    [anon_sym_continue] = ACTIONS(2229),
    [anon_sym_debugger] = ACTIONS(2229),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_throw] = ACTIONS(2229),
    [anon_sym_SEMI] = ACTIONS(2227),
    [anon_sym_case] = ACTIONS(2229),
    [anon_sym_yield] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2227),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_class] = ACTIONS(2229),
    [anon_sym_async] = ACTIONS(2229),
    [anon_sym_function] = ACTIONS(2229),
    [anon_sym_EQ_GT] = ACTIONS(2227),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2229),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_TILDE] = ACTIONS(2227),
    [anon_sym_typeof] = ACTIONS(2229),
    [anon_sym_void] = ACTIONS(2229),
    [anon_sym_delete] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2227),
    [anon_sym_DQUOTE] = ACTIONS(2227),
    [anon_sym_SQUOTE] = ACTIONS(2227),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2227),
    [sym_number] = ACTIONS(2227),
    [sym_identifier] = ACTIONS(2229),
    [sym_this] = ACTIONS(2229),
    [sym_super] = ACTIONS(2229),
    [sym_true] = ACTIONS(2229),
    [sym_false] = ACTIONS(2229),
    [sym_null] = ACTIONS(2229),
    [sym_undefined] = ACTIONS(2229),
    [anon_sym_AT] = ACTIONS(2227),
    [anon_sym_get] = ACTIONS(2229),
    [anon_sym_set] = ACTIONS(2229),
  },
  [620] = {
    [sym__automatic_semicolon] = ACTIONS(2231),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_COMMA] = ACTIONS(2231),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_RPAREN] = ACTIONS(2231),
    [anon_sym_in] = ACTIONS(2233),
    [anon_sym_SEMI] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_PLUS_EQ] = ACTIONS(2231),
    [anon_sym_DASH_EQ] = ACTIONS(2231),
    [anon_sym_STAR_EQ] = ACTIONS(2231),
    [anon_sym_SLASH_EQ] = ACTIONS(2231),
    [anon_sym_PERCENT_EQ] = ACTIONS(2231),
    [anon_sym_CARET_EQ] = ACTIONS(2231),
    [anon_sym_AMP_EQ] = ACTIONS(2231),
    [anon_sym_PIPE_EQ] = ACTIONS(2231),
    [anon_sym_GT_GT_EQ] = ACTIONS(2231),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2231),
    [anon_sym_LT_LT_EQ] = ACTIONS(2231),
    [anon_sym_QMARK] = ACTIONS(2231),
    [anon_sym_AMP_AMP] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2231),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_GT_GT_GT] = ACTIONS(2233),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_LT_EQ] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2231),
    [anon_sym_BANG_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2231),
    [anon_sym_GT_EQ] = ACTIONS(2231),
    [anon_sym_instanceof] = ACTIONS(2231),
    [anon_sym_PLUS_PLUS] = ACTIONS(2231),
    [anon_sym_DASH_DASH] = ACTIONS(2231),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2231),
  },
  [621] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [622] = {
    [sym_parenthesized_expression] = STATE(994),
    [sym__expression] = STATE(994),
    [sym_yield_expression] = STATE(994),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(994),
    [sym_jsx_fragment] = STATE(994),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(994),
    [sym_anonymous_class] = STATE(994),
    [sym_class] = STATE(994),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(994),
    [sym_generator_function] = STATE(994),
    [sym_call_expression] = STATE(994),
    [sym_new_expression] = STATE(994),
    [sym_await_expression] = STATE(994),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(994),
    [sym_augmented_assignment_expression] = STATE(994),
    [sym_spread_element] = STATE(508),
    [sym_ternary_expression] = STATE(994),
    [sym_binary_expression] = STATE(994),
    [sym_unary_expression] = STATE(994),
    [sym_update_expression] = STATE(994),
    [sym_string] = STATE(994),
    [sym_template_string] = STATE(994),
    [sym_regex] = STATE(994),
    [sym_meta_property] = STATE(994),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1161),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2237),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(2239),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2239),
    [sym_false] = ACTIONS(2239),
    [sym_null] = ACTIONS(2239),
    [sym_undefined] = ACTIONS(2239),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [623] = {
    [sym__automatic_semicolon] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2243),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_SLASH] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2241),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_GT_GT_GT] = ACTIONS(2241),
    [anon_sym_LT_LT] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_instanceof] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2241),
  },
  [624] = {
    [sym_parenthesized_expression] = STATE(995),
    [sym__expression] = STATE(995),
    [sym_yield_expression] = STATE(995),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(995),
    [sym_jsx_fragment] = STATE(995),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(995),
    [sym_anonymous_class] = STATE(995),
    [sym_class] = STATE(995),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(995),
    [sym_generator_function] = STATE(995),
    [sym_call_expression] = STATE(995),
    [sym_new_expression] = STATE(995),
    [sym_await_expression] = STATE(995),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(995),
    [sym_augmented_assignment_expression] = STATE(995),
    [sym_ternary_expression] = STATE(995),
    [sym_binary_expression] = STATE(995),
    [sym_unary_expression] = STATE(995),
    [sym_update_expression] = STATE(995),
    [sym_string] = STATE(995),
    [sym_template_string] = STATE(995),
    [sym_regex] = STATE(995),
    [sym_meta_property] = STATE(995),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2245),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(2247),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2247),
    [sym_false] = ACTIONS(2247),
    [sym_null] = ACTIONS(2247),
    [sym_undefined] = ACTIONS(2247),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [625] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [aux_sym_array_repeat1] = STATE(997),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [626] = {
    [aux_sym_array_repeat1] = STATE(997),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [sym_comment] = ACTIONS(78),
  },
  [627] = {
    [aux_sym_array_repeat1] = STATE(998),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2249),
    [sym_comment] = ACTIONS(78),
  },
  [628] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2253),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [629] = {
    [anon_sym_RBRACK] = ACTIONS(2253),
    [sym_comment] = ACTIONS(78),
  },
  [630] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2255),
  },
  [631] = {
    [anon_sym_export] = ACTIONS(2257),
    [anon_sym_STAR] = ACTIONS(2259),
    [anon_sym_LBRACK] = ACTIONS(2259),
    [anon_sym_class] = ACTIONS(2257),
    [anon_sym_async] = ACTIONS(2257),
    [anon_sym_DQUOTE] = ACTIONS(2259),
    [anon_sym_SQUOTE] = ACTIONS(2259),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(2259),
    [sym_identifier] = ACTIONS(2257),
    [anon_sym_AT] = ACTIONS(2259),
    [anon_sym_static] = ACTIONS(2257),
    [anon_sym_get] = ACTIONS(2257),
    [anon_sym_set] = ACTIONS(2257),
  },
  [632] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2225),
    [anon_sym_GT_GT_GT] = ACTIONS(2223),
    [anon_sym_LT_LT] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2223),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [633] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2261),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [634] = {
    [sym__automatic_semicolon] = ACTIONS(2261),
    [anon_sym_SEMI] = ACTIONS(2261),
    [sym_comment] = ACTIONS(78),
  },
  [635] = {
    [sym_parenthesized_expression] = STATE(1002),
    [sym__expression] = STATE(1002),
    [sym_yield_expression] = STATE(1002),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1002),
    [sym_jsx_fragment] = STATE(1002),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1002),
    [sym_anonymous_class] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1002),
    [sym_generator_function] = STATE(1002),
    [sym_call_expression] = STATE(1002),
    [sym_new_expression] = STATE(1002),
    [sym_await_expression] = STATE(1002),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1002),
    [sym_augmented_assignment_expression] = STATE(1002),
    [sym_ternary_expression] = STATE(1002),
    [sym_binary_expression] = STATE(1002),
    [sym_unary_expression] = STATE(1002),
    [sym_update_expression] = STATE(1002),
    [sym_string] = STATE(1002),
    [sym_template_string] = STATE(1002),
    [sym_regex] = STATE(1002),
    [sym_meta_property] = STATE(1002),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2263),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(2265),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2265),
    [sym_false] = ACTIONS(2265),
    [sym_null] = ACTIONS(2265),
    [sym_undefined] = ACTIONS(2265),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [636] = {
    [sym_parenthesized_expression] = STATE(1003),
    [sym__expression] = STATE(1003),
    [sym_yield_expression] = STATE(1003),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1003),
    [sym_jsx_fragment] = STATE(1003),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1003),
    [sym_anonymous_class] = STATE(1003),
    [sym_class] = STATE(1003),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1003),
    [sym_generator_function] = STATE(1003),
    [sym_call_expression] = STATE(1003),
    [sym_new_expression] = STATE(1003),
    [sym_await_expression] = STATE(1003),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1003),
    [sym_augmented_assignment_expression] = STATE(1003),
    [sym_ternary_expression] = STATE(1003),
    [sym_binary_expression] = STATE(1003),
    [sym_unary_expression] = STATE(1003),
    [sym_update_expression] = STATE(1003),
    [sym_string] = STATE(1003),
    [sym_template_string] = STATE(1003),
    [sym_regex] = STATE(1003),
    [sym_meta_property] = STATE(1003),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_COLON] = ACTIONS(252),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2267),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(2269),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2269),
    [sym_false] = ACTIONS(2269),
    [sym_null] = ACTIONS(2269),
    [sym_undefined] = ACTIONS(2269),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [637] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(1007),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_COLON] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(2273),
    [anon_sym_PLUS_EQ] = ACTIONS(2275),
    [anon_sym_DASH_EQ] = ACTIONS(2275),
    [anon_sym_STAR_EQ] = ACTIONS(2275),
    [anon_sym_SLASH_EQ] = ACTIONS(2275),
    [anon_sym_PERCENT_EQ] = ACTIONS(2275),
    [anon_sym_CARET_EQ] = ACTIONS(2275),
    [anon_sym_AMP_EQ] = ACTIONS(2275),
    [anon_sym_PIPE_EQ] = ACTIONS(2275),
    [anon_sym_GT_GT_EQ] = ACTIONS(2275),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2275),
    [anon_sym_LT_LT_EQ] = ACTIONS(2275),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(2277),
  },
  [638] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__expression] = STATE(1008),
    [sym_yield_expression] = STATE(1008),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1008),
    [sym_jsx_fragment] = STATE(1008),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1008),
    [sym_anonymous_class] = STATE(1008),
    [sym_class] = STATE(1008),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1008),
    [sym_generator_function] = STATE(1008),
    [sym_call_expression] = STATE(1008),
    [sym_new_expression] = STATE(1008),
    [sym_await_expression] = STATE(1008),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1008),
    [sym_augmented_assignment_expression] = STATE(1008),
    [sym_ternary_expression] = STATE(1008),
    [sym_binary_expression] = STATE(1008),
    [sym_unary_expression] = STATE(1008),
    [sym_update_expression] = STATE(1008),
    [sym_string] = STATE(1008),
    [sym_template_string] = STATE(1008),
    [sym_regex] = STATE(1008),
    [sym_meta_property] = STATE(1008),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(2281),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2281),
    [sym_false] = ACTIONS(2281),
    [sym_null] = ACTIONS(2281),
    [sym_undefined] = ACTIONS(2281),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [639] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2283),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(2285),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [640] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [641] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [642] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_EQ_GT] = ACTIONS(2273),
    [anon_sym_PLUS_EQ] = ACTIONS(2289),
    [anon_sym_DASH_EQ] = ACTIONS(2289),
    [anon_sym_STAR_EQ] = ACTIONS(2289),
    [anon_sym_SLASH_EQ] = ACTIONS(2289),
    [anon_sym_PERCENT_EQ] = ACTIONS(2289),
    [anon_sym_CARET_EQ] = ACTIONS(2289),
    [anon_sym_AMP_EQ] = ACTIONS(2289),
    [anon_sym_PIPE_EQ] = ACTIONS(2289),
    [anon_sym_GT_GT_EQ] = ACTIONS(2289),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2289),
    [anon_sym_LT_LT_EQ] = ACTIONS(2289),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [643] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_COLON] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_PLUS_EQ] = ACTIONS(2275),
    [anon_sym_DASH_EQ] = ACTIONS(2275),
    [anon_sym_STAR_EQ] = ACTIONS(2275),
    [anon_sym_SLASH_EQ] = ACTIONS(2275),
    [anon_sym_PERCENT_EQ] = ACTIONS(2275),
    [anon_sym_CARET_EQ] = ACTIONS(2275),
    [anon_sym_AMP_EQ] = ACTIONS(2275),
    [anon_sym_PIPE_EQ] = ACTIONS(2275),
    [anon_sym_GT_GT_EQ] = ACTIONS(2275),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2275),
    [anon_sym_LT_LT_EQ] = ACTIONS(2275),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [644] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [645] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [646] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [647] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(2271),
    [anon_sym_PLUS_EQ] = ACTIONS(2289),
    [anon_sym_DASH_EQ] = ACTIONS(2289),
    [anon_sym_STAR_EQ] = ACTIONS(2289),
    [anon_sym_SLASH_EQ] = ACTIONS(2289),
    [anon_sym_PERCENT_EQ] = ACTIONS(2289),
    [anon_sym_CARET_EQ] = ACTIONS(2289),
    [anon_sym_AMP_EQ] = ACTIONS(2289),
    [anon_sym_PIPE_EQ] = ACTIONS(2289),
    [anon_sym_GT_GT_EQ] = ACTIONS(2289),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2289),
    [anon_sym_LT_LT_EQ] = ACTIONS(2289),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [648] = {
    [anon_sym_EQ_GT] = ACTIONS(2273),
    [sym_comment] = ACTIONS(78),
  },
  [649] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [650] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [651] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [652] = {
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2311),
    [sym_jsx_text] = ACTIONS(2311),
    [sym_comment] = ACTIONS(78),
  },
  [653] = {
    [sym_parenthesized_expression] = STATE(1028),
    [sym__expression] = STATE(1028),
    [sym_yield_expression] = STATE(1028),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1028),
    [sym_jsx_fragment] = STATE(1028),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1028),
    [sym_anonymous_class] = STATE(1028),
    [sym_class] = STATE(1028),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1028),
    [sym_generator_function] = STATE(1028),
    [sym_call_expression] = STATE(1028),
    [sym_new_expression] = STATE(1028),
    [sym_await_expression] = STATE(1028),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1028),
    [sym_augmented_assignment_expression] = STATE(1028),
    [sym_ternary_expression] = STATE(1028),
    [sym_binary_expression] = STATE(1028),
    [sym_unary_expression] = STATE(1028),
    [sym_update_expression] = STATE(1028),
    [sym_string] = STATE(1028),
    [sym_template_string] = STATE(1028),
    [sym_regex] = STATE(1028),
    [sym_meta_property] = STATE(1028),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2329),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(2333),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2333),
    [sym_false] = ACTIONS(2333),
    [sym_null] = ACTIONS(2333),
    [sym_undefined] = ACTIONS(2333),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [654] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2337),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [655] = {
    [anon_sym_RBRACE] = ACTIONS(2337),
    [sym_comment] = ACTIONS(78),
  },
  [656] = {
    [sym_nested_identifier] = STATE(1036),
    [sym_jsx_namespace_name] = STATE(1037),
    [sym_jsx_identifier] = ACTIONS(2339),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2341),
  },
  [657] = {
    [sym_jsx_expression] = STATE(1039),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(1039),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1039),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(2343),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [658] = {
    [sym_jsx_expression] = STATE(1039),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(1039),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1039),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(2343),
    [sym_jsx_identifier] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [659] = {
    [sym_jsx_expression] = STATE(1039),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(1039),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1039),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(2343),
    [sym_jsx_identifier] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [660] = {
    [sym_jsx_expression] = STATE(1039),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(1039),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1039),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(2343),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [661] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(2345),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [662] = {
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [sym_jsx_text] = ACTIONS(1261),
    [sym_comment] = ACTIONS(78),
  },
  [663] = {
    [sym_jsx_element] = STATE(665),
    [sym_jsx_expression] = STATE(665),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_closing_element] = STATE(1041),
    [sym_jsx_self_closing_element] = STATE(665),
    [aux_sym_jsx_element_repeat1] = STATE(665),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(1255),
    [sym_jsx_text] = ACTIONS(1263),
    [sym_comment] = ACTIONS(78),
  },
  [664] = {
    [sym__automatic_semicolon] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2349),
    [anon_sym_GT] = ACTIONS(2349),
    [anon_sym_SLASH] = ACTIONS(2349),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2349),
    [anon_sym_GT_GT_GT] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_instanceof] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2347),
  },
  [665] = {
    [sym_jsx_element] = STATE(665),
    [sym_jsx_expression] = STATE(665),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_self_closing_element] = STATE(665),
    [aux_sym_jsx_element_repeat1] = STATE(665),
    [anon_sym_LBRACE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2354),
    [sym_jsx_text] = ACTIONS(2357),
    [sym_comment] = ACTIONS(78),
  },
  [666] = {
    [sym_parenthesized_expression] = STATE(1043),
    [sym__expression] = STATE(1043),
    [sym_yield_expression] = STATE(1043),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1043),
    [sym_jsx_fragment] = STATE(1043),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1043),
    [sym_anonymous_class] = STATE(1043),
    [sym_class] = STATE(1043),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1043),
    [sym_generator_function] = STATE(1043),
    [sym_call_expression] = STATE(1043),
    [sym_new_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1043),
    [sym_augmented_assignment_expression] = STATE(1043),
    [sym_ternary_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_update_expression] = STATE(1043),
    [sym_string] = STATE(1043),
    [sym_template_string] = STATE(1043),
    [sym_regex] = STATE(1043),
    [sym_meta_property] = STATE(1043),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2360),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(2362),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [sym_null] = ACTIONS(2362),
    [sym_undefined] = ACTIONS(2362),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [667] = {
    [sym_class_heritage] = STATE(1044),
    [sym_class_body] = STATE(971),
    [anon_sym_LBRACE] = ACTIONS(302),
    [anon_sym_extends] = ACTIONS(1023),
    [sym_comment] = ACTIONS(78),
  },
  [668] = {
    [sym_class_body] = STATE(1045),
    [anon_sym_LBRACE] = ACTIONS(302),
    [sym_comment] = ACTIONS(78),
  },
  [669] = {
    [sym__automatic_semicolon] = ACTIONS(2364),
    [anon_sym_SEMI] = ACTIONS(2364),
    [sym_comment] = ACTIONS(78),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(2366),
    [anon_sym_export] = ACTIONS(2368),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_LBRACE] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2366),
    [anon_sym_import] = ACTIONS(2368),
    [anon_sym_var] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_switch] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_LPAREN] = ACTIONS(2366),
    [anon_sym_await] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_do] = ACTIONS(2368),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_with] = ACTIONS(2368),
    [anon_sym_break] = ACTIONS(2368),
    [anon_sym_continue] = ACTIONS(2368),
    [anon_sym_debugger] = ACTIONS(2368),
    [anon_sym_return] = ACTIONS(2368),
    [anon_sym_throw] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2368),
    [anon_sym_yield] = ACTIONS(2368),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_SLASH] = ACTIONS(2368),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_async] = ACTIONS(2368),
    [anon_sym_function] = ACTIONS(2368),
    [anon_sym_EQ_GT] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2368),
    [anon_sym_PLUS] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [anon_sym_typeof] = ACTIONS(2368),
    [anon_sym_void] = ACTIONS(2368),
    [anon_sym_delete] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2366),
    [anon_sym_DQUOTE] = ACTIONS(2366),
    [anon_sym_SQUOTE] = ACTIONS(2366),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2366),
    [sym_number] = ACTIONS(2366),
    [sym_identifier] = ACTIONS(2368),
    [sym_this] = ACTIONS(2368),
    [sym_super] = ACTIONS(2368),
    [sym_true] = ACTIONS(2368),
    [sym_false] = ACTIONS(2368),
    [sym_null] = ACTIONS(2368),
    [sym_undefined] = ACTIONS(2368),
    [anon_sym_AT] = ACTIONS(2366),
    [anon_sym_get] = ACTIONS(2368),
    [anon_sym_set] = ACTIONS(2368),
  },
  [671] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [672] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(897),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [673] = {
    [sym_parenthesized_expression] = STATE(1046),
    [sym__expression] = STATE(1046),
    [sym_yield_expression] = STATE(1046),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1046),
    [sym_jsx_fragment] = STATE(1046),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1046),
    [sym_anonymous_class] = STATE(1046),
    [sym_class] = STATE(1046),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1046),
    [sym_generator_function] = STATE(1046),
    [sym_call_expression] = STATE(1046),
    [sym_new_expression] = STATE(1046),
    [sym_await_expression] = STATE(1046),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1046),
    [sym_augmented_assignment_expression] = STATE(1046),
    [sym_ternary_expression] = STATE(1046),
    [sym_binary_expression] = STATE(1046),
    [sym_unary_expression] = STATE(1046),
    [sym_update_expression] = STATE(1046),
    [sym_string] = STATE(1046),
    [sym_template_string] = STATE(1046),
    [sym_regex] = STATE(1046),
    [sym_meta_property] = STATE(1046),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2370),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(2372),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2372),
    [sym_false] = ACTIONS(2372),
    [sym_null] = ACTIONS(2372),
    [sym_undefined] = ACTIONS(2372),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [674] = {
    [sym_statement_block] = STATE(581),
    [sym_parenthesized_expression] = STATE(1047),
    [sym__expression] = STATE(1047),
    [sym_yield_expression] = STATE(1047),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1047),
    [sym_jsx_fragment] = STATE(1047),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1047),
    [sym_anonymous_class] = STATE(1047),
    [sym_class] = STATE(1047),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1047),
    [sym_generator_function] = STATE(1047),
    [sym_call_expression] = STATE(1047),
    [sym_new_expression] = STATE(1047),
    [sym_await_expression] = STATE(1047),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1047),
    [sym_augmented_assignment_expression] = STATE(1047),
    [sym_ternary_expression] = STATE(1047),
    [sym_binary_expression] = STATE(1047),
    [sym_unary_expression] = STATE(1047),
    [sym_update_expression] = STATE(1047),
    [sym_string] = STATE(1047),
    [sym_template_string] = STATE(1047),
    [sym_regex] = STATE(1047),
    [sym_meta_property] = STATE(1047),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2374),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(2376),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2376),
    [sym_false] = ACTIONS(2376),
    [sym_null] = ACTIONS(2376),
    [sym_undefined] = ACTIONS(2376),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [675] = {
    [sym_parenthesized_expression] = STATE(1048),
    [sym__expression] = STATE(1048),
    [sym_yield_expression] = STATE(1048),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1048),
    [sym_jsx_fragment] = STATE(1048),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1048),
    [sym_anonymous_class] = STATE(1048),
    [sym_class] = STATE(1048),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1048),
    [sym_generator_function] = STATE(1048),
    [sym_call_expression] = STATE(1048),
    [sym_new_expression] = STATE(1048),
    [sym_await_expression] = STATE(1048),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1048),
    [sym_augmented_assignment_expression] = STATE(1048),
    [sym_ternary_expression] = STATE(1048),
    [sym_binary_expression] = STATE(1048),
    [sym_unary_expression] = STATE(1048),
    [sym_update_expression] = STATE(1048),
    [sym_string] = STATE(1048),
    [sym_template_string] = STATE(1048),
    [sym_regex] = STATE(1048),
    [sym_meta_property] = STATE(1048),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2378),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(2380),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2380),
    [sym_false] = ACTIONS(2380),
    [sym_null] = ACTIONS(2380),
    [sym_undefined] = ACTIONS(2380),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [676] = {
    [anon_sym_EQ_GT] = ACTIONS(2382),
    [sym_comment] = ACTIONS(78),
  },
  [677] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [678] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(603),
    [sym_formal_parameters] = STATE(676),
    [sym__automatic_semicolon] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(1415),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1419),
  },
  [679] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(604),
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(1415),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [680] = {
    [sym_parenthesized_expression] = STATE(1050),
    [sym__expression] = STATE(1050),
    [sym_yield_expression] = STATE(1050),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1050),
    [sym_jsx_fragment] = STATE(1050),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1050),
    [sym_anonymous_class] = STATE(1050),
    [sym_class] = STATE(1050),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1050),
    [sym_generator_function] = STATE(1050),
    [sym_call_expression] = STATE(1050),
    [sym_new_expression] = STATE(1050),
    [sym_await_expression] = STATE(1050),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1050),
    [sym_augmented_assignment_expression] = STATE(1050),
    [sym_ternary_expression] = STATE(1050),
    [sym_binary_expression] = STATE(1050),
    [sym_unary_expression] = STATE(1050),
    [sym_update_expression] = STATE(1050),
    [sym_string] = STATE(1050),
    [sym_template_string] = STATE(1050),
    [sym_regex] = STATE(1050),
    [sym_meta_property] = STATE(1050),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2384),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(2386),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [sym_null] = ACTIONS(2386),
    [sym_undefined] = ACTIONS(2386),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [681] = {
    [sym_parenthesized_expression] = STATE(1051),
    [sym__expression] = STATE(1051),
    [sym_yield_expression] = STATE(1051),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1051),
    [sym_jsx_fragment] = STATE(1051),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1051),
    [sym_anonymous_class] = STATE(1051),
    [sym_class] = STATE(1051),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1051),
    [sym_generator_function] = STATE(1051),
    [sym_call_expression] = STATE(1051),
    [sym_new_expression] = STATE(1051),
    [sym_await_expression] = STATE(1051),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1051),
    [sym_augmented_assignment_expression] = STATE(1051),
    [sym_ternary_expression] = STATE(1051),
    [sym_binary_expression] = STATE(1051),
    [sym_unary_expression] = STATE(1051),
    [sym_update_expression] = STATE(1051),
    [sym_string] = STATE(1051),
    [sym_template_string] = STATE(1051),
    [sym_regex] = STATE(1051),
    [sym_meta_property] = STATE(1051),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(2390),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_null] = ACTIONS(2390),
    [sym_undefined] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [682] = {
    [sym_parenthesized_expression] = STATE(632),
    [sym__expression] = STATE(632),
    [sym_yield_expression] = STATE(632),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(632),
    [sym_jsx_fragment] = STATE(632),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(632),
    [sym_anonymous_class] = STATE(632),
    [sym_class] = STATE(632),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(632),
    [sym_generator_function] = STATE(632),
    [sym_call_expression] = STATE(632),
    [sym_new_expression] = STATE(632),
    [sym_await_expression] = STATE(632),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(632),
    [sym_augmented_assignment_expression] = STATE(632),
    [sym_ternary_expression] = STATE(632),
    [sym_binary_expression] = STATE(632),
    [sym_unary_expression] = STATE(632),
    [sym_update_expression] = STATE(632),
    [sym_string] = STATE(632),
    [sym_template_string] = STATE(632),
    [sym_regex] = STATE(632),
    [sym_meta_property] = STATE(632),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(1191),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1191),
    [sym_false] = ACTIONS(1191),
    [sym_null] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [683] = {
    [sym_parenthesized_expression] = STATE(1052),
    [sym__expression] = STATE(1052),
    [sym_yield_expression] = STATE(1052),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1052),
    [sym_jsx_fragment] = STATE(1052),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1052),
    [sym_anonymous_class] = STATE(1052),
    [sym_class] = STATE(1052),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1052),
    [sym_generator_function] = STATE(1052),
    [sym_call_expression] = STATE(1052),
    [sym_new_expression] = STATE(1052),
    [sym_await_expression] = STATE(1052),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1052),
    [sym_augmented_assignment_expression] = STATE(1052),
    [sym_ternary_expression] = STATE(1052),
    [sym_binary_expression] = STATE(1052),
    [sym_unary_expression] = STATE(1052),
    [sym_update_expression] = STATE(1052),
    [sym_string] = STATE(1052),
    [sym_template_string] = STATE(1052),
    [sym_regex] = STATE(1052),
    [sym_meta_property] = STATE(1052),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2392),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(2394),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [sym_null] = ACTIONS(2394),
    [sym_undefined] = ACTIONS(2394),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [684] = {
    [sym_parenthesized_expression] = STATE(1053),
    [sym__expression] = STATE(1053),
    [sym_yield_expression] = STATE(1053),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1053),
    [sym_jsx_fragment] = STATE(1053),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1053),
    [sym_anonymous_class] = STATE(1053),
    [sym_class] = STATE(1053),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1053),
    [sym_generator_function] = STATE(1053),
    [sym_call_expression] = STATE(1053),
    [sym_new_expression] = STATE(1053),
    [sym_await_expression] = STATE(1053),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1053),
    [sym_augmented_assignment_expression] = STATE(1053),
    [sym_ternary_expression] = STATE(1053),
    [sym_binary_expression] = STATE(1053),
    [sym_unary_expression] = STATE(1053),
    [sym_update_expression] = STATE(1053),
    [sym_string] = STATE(1053),
    [sym_template_string] = STATE(1053),
    [sym_regex] = STATE(1053),
    [sym_meta_property] = STATE(1053),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2396),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(2398),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2398),
    [sym_false] = ACTIONS(2398),
    [sym_null] = ACTIONS(2398),
    [sym_undefined] = ACTIONS(2398),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [685] = {
    [sym_parenthesized_expression] = STATE(1054),
    [sym__expression] = STATE(1054),
    [sym_yield_expression] = STATE(1054),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1054),
    [sym_jsx_fragment] = STATE(1054),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1054),
    [sym_anonymous_class] = STATE(1054),
    [sym_class] = STATE(1054),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1054),
    [sym_generator_function] = STATE(1054),
    [sym_call_expression] = STATE(1054),
    [sym_new_expression] = STATE(1054),
    [sym_await_expression] = STATE(1054),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1054),
    [sym_augmented_assignment_expression] = STATE(1054),
    [sym_ternary_expression] = STATE(1054),
    [sym_binary_expression] = STATE(1054),
    [sym_unary_expression] = STATE(1054),
    [sym_update_expression] = STATE(1054),
    [sym_string] = STATE(1054),
    [sym_template_string] = STATE(1054),
    [sym_regex] = STATE(1054),
    [sym_meta_property] = STATE(1054),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2400),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(2402),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2402),
    [sym_false] = ACTIONS(2402),
    [sym_null] = ACTIONS(2402),
    [sym_undefined] = ACTIONS(2402),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [686] = {
    [sym_parenthesized_expression] = STATE(1055),
    [sym__expression] = STATE(1055),
    [sym_yield_expression] = STATE(1055),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1055),
    [sym_jsx_fragment] = STATE(1055),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1055),
    [sym_anonymous_class] = STATE(1055),
    [sym_class] = STATE(1055),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1055),
    [sym_generator_function] = STATE(1055),
    [sym_call_expression] = STATE(1055),
    [sym_new_expression] = STATE(1055),
    [sym_await_expression] = STATE(1055),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1055),
    [sym_augmented_assignment_expression] = STATE(1055),
    [sym_ternary_expression] = STATE(1055),
    [sym_binary_expression] = STATE(1055),
    [sym_unary_expression] = STATE(1055),
    [sym_update_expression] = STATE(1055),
    [sym_string] = STATE(1055),
    [sym_template_string] = STATE(1055),
    [sym_regex] = STATE(1055),
    [sym_meta_property] = STATE(1055),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2404),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(2406),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2406),
    [sym_false] = ACTIONS(2406),
    [sym_null] = ACTIONS(2406),
    [sym_undefined] = ACTIONS(2406),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [687] = {
    [sym__automatic_semicolon] = ACTIONS(2408),
    [anon_sym_from] = ACTIONS(2408),
    [anon_sym_SEMI] = ACTIONS(2408),
    [sym_comment] = ACTIONS(78),
  },
  [688] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2410),
  },
  [689] = {
    [sym__import_export_specifier] = STATE(1058),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(477),
  },
  [690] = {
    [sym__automatic_semicolon] = ACTIONS(2414),
    [anon_sym_from] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2414),
    [sym_comment] = ACTIONS(78),
  },
  [691] = {
    [aux_sym_export_clause_repeat1] = STATE(1060),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [sym_comment] = ACTIONS(78),
  },
  [692] = {
    [sym_string] = STATE(552),
    [sym_decorator] = STATE(553),
    [sym_public_field_definition] = STATE(550),
    [sym_method_definition] = STATE(551),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [aux_sym_export_statement_repeat1] = STATE(553),
    [aux_sym_class_body_repeat1] = STATE(1062),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
  },
  [693] = {
    [sym_class_body] = STATE(1063),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(78),
  },
  [694] = {
    [sym__automatic_semicolon] = ACTIONS(2105),
    [ts_builtin_sym_end] = ACTIONS(2105),
    [anon_sym_export] = ACTIONS(2107),
    [anon_sym_default] = ACTIONS(2107),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_import] = ACTIONS(2107),
    [anon_sym_var] = ACTIONS(2107),
    [anon_sym_let] = ACTIONS(2107),
    [anon_sym_const] = ACTIONS(2107),
    [anon_sym_if] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2107),
    [anon_sym_switch] = ACTIONS(2107),
    [anon_sym_for] = ACTIONS(2107),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_await] = ACTIONS(2107),
    [anon_sym_while] = ACTIONS(2107),
    [anon_sym_do] = ACTIONS(2107),
    [anon_sym_try] = ACTIONS(2107),
    [anon_sym_with] = ACTIONS(2107),
    [anon_sym_break] = ACTIONS(2107),
    [anon_sym_continue] = ACTIONS(2107),
    [anon_sym_debugger] = ACTIONS(2107),
    [anon_sym_return] = ACTIONS(2107),
    [anon_sym_throw] = ACTIONS(2107),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_case] = ACTIONS(2107),
    [anon_sym_yield] = ACTIONS(2107),
    [anon_sym_LBRACK] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_SLASH] = ACTIONS(2107),
    [anon_sym_class] = ACTIONS(2107),
    [anon_sym_async] = ACTIONS(2107),
    [anon_sym_function] = ACTIONS(2107),
    [anon_sym_EQ_GT] = ACTIONS(2105),
    [anon_sym_new] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2107),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [anon_sym_typeof] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2107),
    [anon_sym_delete] = ACTIONS(2107),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [anon_sym_SQUOTE] = ACTIONS(2105),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2105),
    [sym_number] = ACTIONS(2105),
    [sym_identifier] = ACTIONS(2107),
    [sym_this] = ACTIONS(2107),
    [sym_super] = ACTIONS(2107),
    [sym_true] = ACTIONS(2107),
    [sym_false] = ACTIONS(2107),
    [sym_null] = ACTIONS(2107),
    [sym_undefined] = ACTIONS(2107),
    [anon_sym_AT] = ACTIONS(2105),
    [anon_sym_get] = ACTIONS(2107),
    [anon_sym_set] = ACTIONS(2107),
  },
  [695] = {
    [sym_formal_parameters] = STATE(1064),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [696] = {
    [sym_statement_block] = STATE(1065),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(78),
  },
  [697] = {
    [sym_formal_parameters] = STATE(1066),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [698] = {
    [sym_statement_block] = STATE(1067),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(78),
  },
  [699] = {
    [sym_export_statement] = STATE(1069),
    [sym__declaration] = STATE(1069),
    [sym_import_statement] = STATE(1069),
    [sym_expression_statement] = STATE(1069),
    [sym_variable_declaration] = STATE(1069),
    [sym_lexical_declaration] = STATE(1069),
    [sym_statement_block] = STATE(1069),
    [sym_if_statement] = STATE(1069),
    [sym_switch_statement] = STATE(1069),
    [sym_for_statement] = STATE(1069),
    [sym_for_in_statement] = STATE(1069),
    [sym_for_of_statement] = STATE(1069),
    [sym_while_statement] = STATE(1069),
    [sym_do_statement] = STATE(1069),
    [sym_try_statement] = STATE(1069),
    [sym_with_statement] = STATE(1069),
    [sym_break_statement] = STATE(1069),
    [sym_continue_statement] = STATE(1069),
    [sym_debugger_statement] = STATE(1069),
    [sym_return_statement] = STATE(1069),
    [sym_throw_statement] = STATE(1069),
    [sym_empty_statement] = STATE(1069),
    [sym_labeled_statement] = STATE(1069),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(1069),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [700] = {
    [sym__automatic_semicolon] = ACTIONS(2143),
    [ts_builtin_sym_end] = ACTIONS(2143),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_var] = ACTIONS(2145),
    [anon_sym_let] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [anon_sym_await] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_with] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_debugger] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2143),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_yield] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_LT] = ACTIONS(2143),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_async] = ACTIONS(2145),
    [anon_sym_function] = ACTIONS(2145),
    [anon_sym_EQ_GT] = ACTIONS(2143),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2143),
    [anon_sym_TILDE] = ACTIONS(2143),
    [anon_sym_typeof] = ACTIONS(2145),
    [anon_sym_void] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_DASH_DASH] = ACTIONS(2143),
    [anon_sym_DQUOTE] = ACTIONS(2143),
    [anon_sym_SQUOTE] = ACTIONS(2143),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2143),
    [sym_number] = ACTIONS(2143),
    [sym_identifier] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [sym_super] = ACTIONS(2145),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [sym_null] = ACTIONS(2145),
    [sym_undefined] = ACTIONS(2145),
    [anon_sym_AT] = ACTIONS(2143),
    [anon_sym_get] = ACTIONS(2145),
    [anon_sym_set] = ACTIONS(2145),
  },
  [701] = {
    [sym_class_heritage] = STATE(1070),
    [sym_class_body] = STATE(1063),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_extends] = ACTIONS(1023),
    [sym_comment] = ACTIONS(78),
  },
  [702] = {
    [sym_parenthesized_expression] = STATE(1071),
    [sym__expression] = STATE(1071),
    [sym_yield_expression] = STATE(1071),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1071),
    [sym_jsx_fragment] = STATE(1071),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1071),
    [sym_anonymous_class] = STATE(1071),
    [sym_class] = STATE(1071),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1071),
    [sym_generator_function] = STATE(1071),
    [sym_call_expression] = STATE(1071),
    [sym_new_expression] = STATE(1071),
    [sym_await_expression] = STATE(1071),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1071),
    [sym_augmented_assignment_expression] = STATE(1071),
    [sym_ternary_expression] = STATE(1071),
    [sym_binary_expression] = STATE(1071),
    [sym_unary_expression] = STATE(1071),
    [sym_update_expression] = STATE(1071),
    [sym_string] = STATE(1071),
    [sym_template_string] = STATE(1071),
    [sym_regex] = STATE(1071),
    [sym_meta_property] = STATE(1071),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2422),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(2424),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2424),
    [sym_false] = ACTIONS(2424),
    [sym_null] = ACTIONS(2424),
    [sym_undefined] = ACTIONS(2424),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [703] = {
    [sym_parenthesized_expression] = STATE(1072),
    [sym__expression] = STATE(1072),
    [sym_yield_expression] = STATE(1072),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1072),
    [sym_jsx_fragment] = STATE(1072),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1072),
    [sym_anonymous_class] = STATE(1072),
    [sym_class] = STATE(1072),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1072),
    [sym_generator_function] = STATE(1072),
    [sym_call_expression] = STATE(1072),
    [sym_new_expression] = STATE(1072),
    [sym_await_expression] = STATE(1072),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1072),
    [sym_augmented_assignment_expression] = STATE(1072),
    [sym_ternary_expression] = STATE(1072),
    [sym_binary_expression] = STATE(1072),
    [sym_unary_expression] = STATE(1072),
    [sym_update_expression] = STATE(1072),
    [sym_string] = STATE(1072),
    [sym_template_string] = STATE(1072),
    [sym_regex] = STATE(1072),
    [sym_meta_property] = STATE(1072),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_RBRACK] = ACTIONS(252),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2426),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(2428),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2428),
    [sym_false] = ACTIONS(2428),
    [sym_null] = ACTIONS(2428),
    [sym_undefined] = ACTIONS(2428),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [704] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(1076),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_RBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(2432),
    [anon_sym_PLUS_EQ] = ACTIONS(2434),
    [anon_sym_DASH_EQ] = ACTIONS(2434),
    [anon_sym_STAR_EQ] = ACTIONS(2434),
    [anon_sym_SLASH_EQ] = ACTIONS(2434),
    [anon_sym_PERCENT_EQ] = ACTIONS(2434),
    [anon_sym_CARET_EQ] = ACTIONS(2434),
    [anon_sym_AMP_EQ] = ACTIONS(2434),
    [anon_sym_PIPE_EQ] = ACTIONS(2434),
    [anon_sym_GT_GT_EQ] = ACTIONS(2434),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2434),
    [anon_sym_LT_LT_EQ] = ACTIONS(2434),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(2436),
  },
  [705] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(1077),
    [sym__expression] = STATE(1077),
    [sym_yield_expression] = STATE(1077),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1077),
    [sym_jsx_fragment] = STATE(1077),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1077),
    [sym_anonymous_class] = STATE(1077),
    [sym_class] = STATE(1077),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1077),
    [sym_generator_function] = STATE(1077),
    [sym_call_expression] = STATE(1077),
    [sym_new_expression] = STATE(1077),
    [sym_await_expression] = STATE(1077),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1077),
    [sym_augmented_assignment_expression] = STATE(1077),
    [sym_ternary_expression] = STATE(1077),
    [sym_binary_expression] = STATE(1077),
    [sym_unary_expression] = STATE(1077),
    [sym_update_expression] = STATE(1077),
    [sym_string] = STATE(1077),
    [sym_template_string] = STATE(1077),
    [sym_regex] = STATE(1077),
    [sym_meta_property] = STATE(1077),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2438),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(2440),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2440),
    [sym_false] = ACTIONS(2440),
    [sym_null] = ACTIONS(2440),
    [sym_undefined] = ACTIONS(2440),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [706] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2442),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(2444),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [707] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [708] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [709] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_EQ_GT] = ACTIONS(2432),
    [anon_sym_PLUS_EQ] = ACTIONS(2448),
    [anon_sym_DASH_EQ] = ACTIONS(2448),
    [anon_sym_STAR_EQ] = ACTIONS(2448),
    [anon_sym_SLASH_EQ] = ACTIONS(2448),
    [anon_sym_PERCENT_EQ] = ACTIONS(2448),
    [anon_sym_CARET_EQ] = ACTIONS(2448),
    [anon_sym_AMP_EQ] = ACTIONS(2448),
    [anon_sym_PIPE_EQ] = ACTIONS(2448),
    [anon_sym_GT_GT_EQ] = ACTIONS(2448),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2448),
    [anon_sym_LT_LT_EQ] = ACTIONS(2448),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [710] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_RBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(2434),
    [anon_sym_DASH_EQ] = ACTIONS(2434),
    [anon_sym_STAR_EQ] = ACTIONS(2434),
    [anon_sym_SLASH_EQ] = ACTIONS(2434),
    [anon_sym_PERCENT_EQ] = ACTIONS(2434),
    [anon_sym_CARET_EQ] = ACTIONS(2434),
    [anon_sym_AMP_EQ] = ACTIONS(2434),
    [anon_sym_PIPE_EQ] = ACTIONS(2434),
    [anon_sym_GT_GT_EQ] = ACTIONS(2434),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2434),
    [anon_sym_LT_LT_EQ] = ACTIONS(2434),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [711] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [712] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [713] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [714] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_RBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_PLUS_EQ] = ACTIONS(2448),
    [anon_sym_DASH_EQ] = ACTIONS(2448),
    [anon_sym_STAR_EQ] = ACTIONS(2448),
    [anon_sym_SLASH_EQ] = ACTIONS(2448),
    [anon_sym_PERCENT_EQ] = ACTIONS(2448),
    [anon_sym_CARET_EQ] = ACTIONS(2448),
    [anon_sym_AMP_EQ] = ACTIONS(2448),
    [anon_sym_PIPE_EQ] = ACTIONS(2448),
    [anon_sym_GT_GT_EQ] = ACTIONS(2448),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2448),
    [anon_sym_LT_LT_EQ] = ACTIONS(2448),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [715] = {
    [anon_sym_EQ_GT] = ACTIONS(2432),
    [sym_comment] = ACTIONS(78),
  },
  [716] = {
    [sym_statement_block] = STATE(1088),
    [anon_sym_LBRACE] = ACTIONS(226),
    [sym_comment] = ACTIONS(78),
  },
  [717] = {
    [anon_sym_COMMA] = ACTIONS(515),
    [anon_sym_RPAREN] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(515),
    [sym_comment] = ACTIONS(78),
  },
  [718] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(1090),
    [anon_sym_STAR] = ACTIONS(1515),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [719] = {
    [sym__initializer] = STATE(729),
    [aux_sym_object_repeat1] = STATE(1090),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(1519),
    [sym_comment] = ACTIONS(78),
  },
  [720] = {
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(1090),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [721] = {
    [aux_sym_object_repeat1] = STATE(1092),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(78),
  },
  [722] = {
    [sym_string] = STATE(342),
    [sym_decorator] = STATE(733),
    [sym_method_definition] = STATE(1093),
    [sym__property_name] = STATE(342),
    [sym_computed_property_name] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(733),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(605),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(607),
    [anon_sym_set] = ACTIONS(607),
  },
  [723] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(78),
  },
  [724] = {
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(913),
    [sym_comment] = ACTIONS(78),
  },
  [725] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [aux_sym_array_repeat1] = STATE(1095),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2474),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [726] = {
    [aux_sym_array_repeat1] = STATE(1095),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [sym_comment] = ACTIONS(78),
  },
  [727] = {
    [aux_sym_array_repeat1] = STATE(530),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [sym_comment] = ACTIONS(78),
  },
  [728] = {
    [sym_parenthesized_expression] = STATE(1097),
    [sym__expression] = STATE(1097),
    [sym_yield_expression] = STATE(1097),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1097),
    [sym_jsx_fragment] = STATE(1097),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1097),
    [sym_anonymous_class] = STATE(1097),
    [sym_class] = STATE(1097),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1097),
    [sym_generator_function] = STATE(1097),
    [sym_call_expression] = STATE(1097),
    [sym_new_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1097),
    [sym_augmented_assignment_expression] = STATE(1097),
    [sym_ternary_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_update_expression] = STATE(1097),
    [sym_string] = STATE(1097),
    [sym_template_string] = STATE(1097),
    [sym_regex] = STATE(1097),
    [sym_meta_property] = STATE(1097),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2478),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(2480),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [sym_null] = ACTIONS(2480),
    [sym_undefined] = ACTIONS(2480),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [729] = {
    [anon_sym_COMMA] = ACTIONS(1626),
    [anon_sym_RBRACE] = ACTIONS(1626),
    [anon_sym_RPAREN] = ACTIONS(1626),
    [sym_comment] = ACTIONS(78),
  },
  [730] = {
    [anon_sym_COMMA] = ACTIONS(1631),
    [anon_sym_RBRACE] = ACTIONS(1631),
    [anon_sym_RPAREN] = ACTIONS(1631),
    [sym_comment] = ACTIONS(78),
  },
  [731] = {
    [anon_sym_COMMA] = ACTIONS(1642),
    [anon_sym_RBRACE] = ACTIONS(1642),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [sym_comment] = ACTIONS(78),
  },
  [732] = {
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [sym_comment] = ACTIONS(78),
  },
  [733] = {
    [sym_decorator] = STATE(733),
    [aux_sym_export_statement_repeat1] = STATE(733),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_async] = ACTIONS(1669),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1669),
    [anon_sym_AT] = ACTIONS(1400),
    [anon_sym_get] = ACTIONS(1669),
    [anon_sym_set] = ACTIONS(1669),
  },
  [734] = {
    [sym_parenthesized_expression] = STATE(1098),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [735] = {
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2486),
    [sym_comment] = ACTIONS(78),
  },
  [736] = {
    [sym_parenthesized_expression] = STATE(1101),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [737] = {
    [sym_parenthesized_expression] = STATE(1102),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [738] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [739] = {
    [anon_sym_export] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_import] = ACTIONS(1724),
    [anon_sym_var] = ACTIONS(1724),
    [anon_sym_let] = ACTIONS(1724),
    [anon_sym_const] = ACTIONS(1724),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1724),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_await] = ACTIONS(1724),
    [anon_sym_while] = ACTIONS(1724),
    [anon_sym_do] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(1724),
    [anon_sym_with] = ACTIONS(1724),
    [anon_sym_break] = ACTIONS(1724),
    [anon_sym_continue] = ACTIONS(1724),
    [anon_sym_debugger] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1724),
    [anon_sym_throw] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_yield] = ACTIONS(1724),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1724),
    [anon_sym_class] = ACTIONS(1724),
    [anon_sym_async] = ACTIONS(1724),
    [anon_sym_function] = ACTIONS(1724),
    [anon_sym_EQ_GT] = ACTIONS(1722),
    [anon_sym_new] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_typeof] = ACTIONS(1724),
    [anon_sym_void] = ACTIONS(1724),
    [anon_sym_delete] = ACTIONS(1724),
    [anon_sym_PLUS_PLUS] = ACTIONS(1722),
    [anon_sym_DASH_DASH] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [sym_number] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1724),
    [sym_this] = ACTIONS(1724),
    [sym_super] = ACTIONS(1724),
    [sym_true] = ACTIONS(1724),
    [sym_false] = ACTIONS(1724),
    [sym_null] = ACTIONS(1724),
    [sym_undefined] = ACTIONS(1724),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_get] = ACTIONS(1724),
    [anon_sym_set] = ACTIONS(1724),
  },
  [740] = {
    [sym_variable_declarator] = STATE(93),
    [sym_object] = STATE(1106),
    [sym_array] = STATE(1107),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2492),
  },
  [741] = {
    [sym_variable_declarator] = STATE(96),
    [sym_object] = STATE(1106),
    [sym_array] = STATE(1107),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2492),
  },
  [742] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_of] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [743] = {
    [sym_expression_statement] = STATE(1110),
    [sym_empty_statement] = STATE(1110),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [744] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_of] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [745] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2502),
    [anon_sym_of] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [746] = {
    [sym_object] = STATE(1117),
    [sym_array] = STATE(1118),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_var] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2508),
  },
  [747] = {
    [sym__automatic_semicolon] = ACTIONS(1962),
    [anon_sym_STAR] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_in] = ACTIONS(1964),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_COLON] = ACTIONS(2513),
    [anon_sym_LBRACK] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_DOT] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1964),
    [anon_sym_QMARK] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_GT_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1962),
    [anon_sym_LT_EQ] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1962),
    [anon_sym_BANG_EQ] = ACTIONS(1964),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1962),
    [anon_sym_GT_EQ] = ACTIONS(1962),
    [anon_sym_instanceof] = ACTIONS(1962),
    [anon_sym_PLUS_PLUS] = ACTIONS(1962),
    [anon_sym_DASH_DASH] = ACTIONS(1962),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1962),
  },
  [748] = {
    [sym_formal_parameters] = STATE(1119),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [749] = {
    [sym__automatic_semicolon] = ACTIONS(2515),
    [anon_sym_STAR] = ACTIONS(2515),
    [anon_sym_COMMA] = ACTIONS(2515),
    [anon_sym_RBRACE] = ACTIONS(2515),
    [anon_sym_LPAREN] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_in] = ACTIONS(2517),
    [anon_sym_of] = ACTIONS(2515),
    [anon_sym_SEMI] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(2515),
    [anon_sym_LT] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2517),
    [anon_sym_SLASH] = ACTIONS(2517),
    [anon_sym_DOT] = ACTIONS(2515),
    [anon_sym_EQ] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_GT_GT] = ACTIONS(2517),
    [anon_sym_GT_GT_GT] = ACTIONS(2515),
    [anon_sym_LT_LT] = ACTIONS(2515),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_CARET] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_PLUS] = ACTIONS(2517),
    [anon_sym_DASH] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_EQ_EQ] = ACTIONS(2517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2515),
    [anon_sym_BANG_EQ] = ACTIONS(2517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2515),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_instanceof] = ACTIONS(2515),
    [anon_sym_PLUS_PLUS] = ACTIONS(2515),
    [anon_sym_DASH_DASH] = ACTIONS(2515),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2515),
  },
  [750] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [751] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [752] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(1120),
    [sym__expression] = STATE(1120),
    [sym_yield_expression] = STATE(1120),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1120),
    [sym_jsx_fragment] = STATE(1120),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1120),
    [sym_anonymous_class] = STATE(1120),
    [sym_class] = STATE(1120),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1120),
    [sym_generator_function] = STATE(1120),
    [sym_call_expression] = STATE(1120),
    [sym_new_expression] = STATE(1120),
    [sym_await_expression] = STATE(1120),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1120),
    [sym_augmented_assignment_expression] = STATE(1120),
    [sym_ternary_expression] = STATE(1120),
    [sym_binary_expression] = STATE(1120),
    [sym_unary_expression] = STATE(1120),
    [sym_update_expression] = STATE(1120),
    [sym_string] = STATE(1120),
    [sym_template_string] = STATE(1120),
    [sym_regex] = STATE(1120),
    [sym_meta_property] = STATE(1120),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2519),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(2521),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2521),
    [sym_false] = ACTIONS(2521),
    [sym_null] = ACTIONS(2521),
    [sym_undefined] = ACTIONS(2521),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [753] = {
    [sym_parenthesized_expression] = STATE(1121),
    [sym__expression] = STATE(1121),
    [sym_yield_expression] = STATE(1121),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1121),
    [sym_jsx_fragment] = STATE(1121),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1121),
    [sym_anonymous_class] = STATE(1121),
    [sym_class] = STATE(1121),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1121),
    [sym_generator_function] = STATE(1121),
    [sym_call_expression] = STATE(1121),
    [sym_new_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1121),
    [sym_augmented_assignment_expression] = STATE(1121),
    [sym_ternary_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_update_expression] = STATE(1121),
    [sym_string] = STATE(1121),
    [sym_template_string] = STATE(1121),
    [sym_regex] = STATE(1121),
    [sym_meta_property] = STATE(1121),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(2525),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_undefined] = ACTIONS(2525),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [754] = {
    [anon_sym_EQ_GT] = ACTIONS(2527),
    [sym_comment] = ACTIONS(78),
  },
  [755] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [756] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(754),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(1561),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(1565),
  },
  [757] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(1561),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [758] = {
    [sym_parenthesized_expression] = STATE(1123),
    [sym__expression] = STATE(1123),
    [sym_yield_expression] = STATE(1123),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1123),
    [sym_jsx_fragment] = STATE(1123),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1123),
    [sym_anonymous_class] = STATE(1123),
    [sym_class] = STATE(1123),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1123),
    [sym_generator_function] = STATE(1123),
    [sym_call_expression] = STATE(1123),
    [sym_new_expression] = STATE(1123),
    [sym_await_expression] = STATE(1123),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1123),
    [sym_augmented_assignment_expression] = STATE(1123),
    [sym_ternary_expression] = STATE(1123),
    [sym_binary_expression] = STATE(1123),
    [sym_unary_expression] = STATE(1123),
    [sym_update_expression] = STATE(1123),
    [sym_string] = STATE(1123),
    [sym_template_string] = STATE(1123),
    [sym_regex] = STATE(1123),
    [sym_meta_property] = STATE(1123),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2529),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(2531),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2531),
    [sym_false] = ACTIONS(2531),
    [sym_null] = ACTIONS(2531),
    [sym_undefined] = ACTIONS(2531),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [759] = {
    [sym_parenthesized_expression] = STATE(1124),
    [sym__expression] = STATE(1124),
    [sym_yield_expression] = STATE(1124),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1124),
    [sym_jsx_fragment] = STATE(1124),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1124),
    [sym_anonymous_class] = STATE(1124),
    [sym_class] = STATE(1124),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1124),
    [sym_generator_function] = STATE(1124),
    [sym_call_expression] = STATE(1124),
    [sym_new_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1124),
    [sym_augmented_assignment_expression] = STATE(1124),
    [sym_ternary_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_update_expression] = STATE(1124),
    [sym_string] = STATE(1124),
    [sym_template_string] = STATE(1124),
    [sym_regex] = STATE(1124),
    [sym_meta_property] = STATE(1124),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2533),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(2535),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2535),
    [sym_false] = ACTIONS(2535),
    [sym_null] = ACTIONS(2535),
    [sym_undefined] = ACTIONS(2535),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [760] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [761] = {
    [sym_parenthesized_expression] = STATE(1125),
    [sym__expression] = STATE(1125),
    [sym_yield_expression] = STATE(1125),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1125),
    [sym_jsx_fragment] = STATE(1125),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1125),
    [sym_anonymous_class] = STATE(1125),
    [sym_class] = STATE(1125),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1125),
    [sym_generator_function] = STATE(1125),
    [sym_call_expression] = STATE(1125),
    [sym_new_expression] = STATE(1125),
    [sym_await_expression] = STATE(1125),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1125),
    [sym_augmented_assignment_expression] = STATE(1125),
    [sym_ternary_expression] = STATE(1125),
    [sym_binary_expression] = STATE(1125),
    [sym_unary_expression] = STATE(1125),
    [sym_update_expression] = STATE(1125),
    [sym_string] = STATE(1125),
    [sym_template_string] = STATE(1125),
    [sym_regex] = STATE(1125),
    [sym_meta_property] = STATE(1125),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2537),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(2539),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2539),
    [sym_false] = ACTIONS(2539),
    [sym_null] = ACTIONS(2539),
    [sym_undefined] = ACTIONS(2539),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [762] = {
    [sym_parenthesized_expression] = STATE(1126),
    [sym__expression] = STATE(1126),
    [sym_yield_expression] = STATE(1126),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1126),
    [sym_jsx_fragment] = STATE(1126),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1126),
    [sym_anonymous_class] = STATE(1126),
    [sym_class] = STATE(1126),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1126),
    [sym_generator_function] = STATE(1126),
    [sym_call_expression] = STATE(1126),
    [sym_new_expression] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1126),
    [sym_augmented_assignment_expression] = STATE(1126),
    [sym_ternary_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_unary_expression] = STATE(1126),
    [sym_update_expression] = STATE(1126),
    [sym_string] = STATE(1126),
    [sym_template_string] = STATE(1126),
    [sym_regex] = STATE(1126),
    [sym_meta_property] = STATE(1126),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2541),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(2543),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2543),
    [sym_false] = ACTIONS(2543),
    [sym_null] = ACTIONS(2543),
    [sym_undefined] = ACTIONS(2543),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [763] = {
    [sym_parenthesized_expression] = STATE(1127),
    [sym__expression] = STATE(1127),
    [sym_yield_expression] = STATE(1127),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1127),
    [sym_jsx_fragment] = STATE(1127),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1127),
    [sym_anonymous_class] = STATE(1127),
    [sym_class] = STATE(1127),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1127),
    [sym_generator_function] = STATE(1127),
    [sym_call_expression] = STATE(1127),
    [sym_new_expression] = STATE(1127),
    [sym_await_expression] = STATE(1127),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1127),
    [sym_augmented_assignment_expression] = STATE(1127),
    [sym_ternary_expression] = STATE(1127),
    [sym_binary_expression] = STATE(1127),
    [sym_unary_expression] = STATE(1127),
    [sym_update_expression] = STATE(1127),
    [sym_string] = STATE(1127),
    [sym_template_string] = STATE(1127),
    [sym_regex] = STATE(1127),
    [sym_meta_property] = STATE(1127),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2545),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(2547),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2547),
    [sym_false] = ACTIONS(2547),
    [sym_null] = ACTIONS(2547),
    [sym_undefined] = ACTIONS(2547),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [764] = {
    [sym_parenthesized_expression] = STATE(1128),
    [sym__expression] = STATE(1128),
    [sym_yield_expression] = STATE(1128),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1128),
    [sym_jsx_fragment] = STATE(1128),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1128),
    [sym_anonymous_class] = STATE(1128),
    [sym_class] = STATE(1128),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1128),
    [sym_generator_function] = STATE(1128),
    [sym_call_expression] = STATE(1128),
    [sym_new_expression] = STATE(1128),
    [sym_await_expression] = STATE(1128),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1128),
    [sym_augmented_assignment_expression] = STATE(1128),
    [sym_ternary_expression] = STATE(1128),
    [sym_binary_expression] = STATE(1128),
    [sym_unary_expression] = STATE(1128),
    [sym_update_expression] = STATE(1128),
    [sym_string] = STATE(1128),
    [sym_template_string] = STATE(1128),
    [sym_regex] = STATE(1128),
    [sym_meta_property] = STATE(1128),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2549),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(2551),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2551),
    [sym_false] = ACTIONS(2551),
    [sym_null] = ACTIONS(2551),
    [sym_undefined] = ACTIONS(2551),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [765] = {
    [sym_parenthesized_expression] = STATE(1129),
    [sym__expression] = STATE(1129),
    [sym_yield_expression] = STATE(1129),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1129),
    [sym_jsx_fragment] = STATE(1129),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1129),
    [sym_anonymous_class] = STATE(1129),
    [sym_class] = STATE(1129),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1129),
    [sym_generator_function] = STATE(1129),
    [sym_call_expression] = STATE(1129),
    [sym_new_expression] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1129),
    [sym_augmented_assignment_expression] = STATE(1129),
    [sym_ternary_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_update_expression] = STATE(1129),
    [sym_string] = STATE(1129),
    [sym_template_string] = STATE(1129),
    [sym_regex] = STATE(1129),
    [sym_meta_property] = STATE(1129),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2553),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(2555),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2555),
    [sym_false] = ACTIONS(2555),
    [sym_null] = ACTIONS(2555),
    [sym_undefined] = ACTIONS(2555),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [766] = {
    [sym_parenthesized_expression] = STATE(1130),
    [sym__expression] = STATE(1130),
    [sym_yield_expression] = STATE(1130),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1130),
    [sym_jsx_fragment] = STATE(1130),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1130),
    [sym_anonymous_class] = STATE(1130),
    [sym_class] = STATE(1130),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1130),
    [sym_generator_function] = STATE(1130),
    [sym_call_expression] = STATE(1130),
    [sym_new_expression] = STATE(1130),
    [sym_await_expression] = STATE(1130),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1130),
    [sym_augmented_assignment_expression] = STATE(1130),
    [sym_ternary_expression] = STATE(1130),
    [sym_binary_expression] = STATE(1130),
    [sym_unary_expression] = STATE(1130),
    [sym_update_expression] = STATE(1130),
    [sym_string] = STATE(1130),
    [sym_template_string] = STATE(1130),
    [sym_regex] = STATE(1130),
    [sym_meta_property] = STATE(1130),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [sym__automatic_semicolon] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_RBRACE] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(252),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(1609),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2557),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(2559),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2559),
    [sym_false] = ACTIONS(2559),
    [sym_null] = ACTIONS(2559),
    [sym_undefined] = ACTIONS(2559),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [767] = {
    [sym__initializer] = STATE(201),
    [sym_formal_parameters] = STATE(1133),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(2561),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(2565),
  },
  [768] = {
    [sym_statement_block] = STATE(206),
    [sym_parenthesized_expression] = STATE(1134),
    [sym__expression] = STATE(1134),
    [sym_yield_expression] = STATE(1134),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1134),
    [sym_jsx_fragment] = STATE(1134),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1134),
    [sym_anonymous_class] = STATE(1134),
    [sym_class] = STATE(1134),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1134),
    [sym_generator_function] = STATE(1134),
    [sym_call_expression] = STATE(1134),
    [sym_new_expression] = STATE(1134),
    [sym_await_expression] = STATE(1134),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1134),
    [sym_augmented_assignment_expression] = STATE(1134),
    [sym_ternary_expression] = STATE(1134),
    [sym_binary_expression] = STATE(1134),
    [sym_unary_expression] = STATE(1134),
    [sym_update_expression] = STATE(1134),
    [sym_string] = STATE(1134),
    [sym_template_string] = STATE(1134),
    [sym_regex] = STATE(1134),
    [sym_meta_property] = STATE(1134),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2567),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(2569),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2569),
    [sym_false] = ACTIONS(2569),
    [sym_null] = ACTIONS(2569),
    [sym_undefined] = ACTIONS(2569),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [769] = {
    [sym_parenthesized_expression] = STATE(214),
    [sym__expression] = STATE(218),
    [sym_yield_expression] = STATE(218),
    [sym_object] = STATE(219),
    [sym_array] = STATE(220),
    [sym_jsx_element] = STATE(218),
    [sym_jsx_fragment] = STATE(218),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(218),
    [sym_anonymous_class] = STATE(214),
    [sym_class] = STATE(214),
    [sym_function] = STATE(221),
    [sym_arrow_function] = STATE(214),
    [sym_generator_function] = STATE(214),
    [sym_call_expression] = STATE(218),
    [sym_new_expression] = STATE(214),
    [sym_await_expression] = STATE(218),
    [sym_member_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_assignment_expression] = STATE(218),
    [sym_augmented_assignment_expression] = STATE(218),
    [sym_ternary_expression] = STATE(218),
    [sym_binary_expression] = STATE(218),
    [sym_unary_expression] = STATE(218),
    [sym_update_expression] = STATE(218),
    [sym_string] = STATE(214),
    [sym_template_string] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_meta_property] = STATE(214),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_DOT] = ACTIONS(343),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2571),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(353),
    [sym_identifier] = ACTIONS(2573),
    [sym_this] = ACTIONS(357),
    [sym_super] = ACTIONS(359),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_undefined] = ACTIONS(357),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(361),
    [anon_sym_set] = ACTIONS(361),
  },
  [770] = {
    [sym_parenthesized_expression] = STATE(223),
    [sym__expression] = STATE(223),
    [sym_yield_expression] = STATE(223),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(223),
    [sym_jsx_fragment] = STATE(223),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(223),
    [sym_anonymous_class] = STATE(223),
    [sym_class] = STATE(223),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(223),
    [sym_generator_function] = STATE(223),
    [sym_call_expression] = STATE(223),
    [sym_new_expression] = STATE(223),
    [sym_await_expression] = STATE(223),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(223),
    [sym_augmented_assignment_expression] = STATE(223),
    [sym_ternary_expression] = STATE(223),
    [sym_binary_expression] = STATE(223),
    [sym_unary_expression] = STATE(223),
    [sym_update_expression] = STATE(223),
    [sym_string] = STATE(223),
    [sym_template_string] = STATE(223),
    [sym_regex] = STATE(223),
    [sym_meta_property] = STATE(223),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(363),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(365),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(365),
    [sym_false] = ACTIONS(365),
    [sym_null] = ACTIONS(365),
    [sym_undefined] = ACTIONS(365),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [771] = {
    [sym_parenthesized_expression] = STATE(224),
    [sym__expression] = STATE(224),
    [sym_yield_expression] = STATE(224),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(224),
    [sym_jsx_fragment] = STATE(224),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(224),
    [sym_anonymous_class] = STATE(224),
    [sym_class] = STATE(224),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(224),
    [sym_generator_function] = STATE(224),
    [sym_call_expression] = STATE(224),
    [sym_new_expression] = STATE(224),
    [sym_await_expression] = STATE(224),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(224),
    [sym_augmented_assignment_expression] = STATE(224),
    [sym_ternary_expression] = STATE(224),
    [sym_binary_expression] = STATE(224),
    [sym_unary_expression] = STATE(224),
    [sym_update_expression] = STATE(224),
    [sym_string] = STATE(224),
    [sym_template_string] = STATE(224),
    [sym_regex] = STATE(224),
    [sym_meta_property] = STATE(224),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(367),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(369),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(369),
    [sym_false] = ACTIONS(369),
    [sym_null] = ACTIONS(369),
    [sym_undefined] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [772] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_EQ_GT] = ACTIONS(2561),
    [anon_sym_PLUS_EQ] = ACTIONS(2577),
    [anon_sym_DASH_EQ] = ACTIONS(2577),
    [anon_sym_STAR_EQ] = ACTIONS(2577),
    [anon_sym_SLASH_EQ] = ACTIONS(2577),
    [anon_sym_PERCENT_EQ] = ACTIONS(2577),
    [anon_sym_CARET_EQ] = ACTIONS(2577),
    [anon_sym_AMP_EQ] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2577),
    [anon_sym_LT_LT_EQ] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [773] = {
    [sym__initializer] = STATE(201),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_PLUS_EQ] = ACTIONS(2563),
    [anon_sym_DASH_EQ] = ACTIONS(2563),
    [anon_sym_STAR_EQ] = ACTIONS(2563),
    [anon_sym_SLASH_EQ] = ACTIONS(2563),
    [anon_sym_PERCENT_EQ] = ACTIONS(2563),
    [anon_sym_CARET_EQ] = ACTIONS(2563),
    [anon_sym_AMP_EQ] = ACTIONS(2563),
    [anon_sym_PIPE_EQ] = ACTIONS(2563),
    [anon_sym_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2563),
    [anon_sym_LT_LT_EQ] = ACTIONS(2563),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [774] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [775] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [776] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [777] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_PLUS_EQ] = ACTIONS(2577),
    [anon_sym_DASH_EQ] = ACTIONS(2577),
    [anon_sym_STAR_EQ] = ACTIONS(2577),
    [anon_sym_SLASH_EQ] = ACTIONS(2577),
    [anon_sym_PERCENT_EQ] = ACTIONS(2577),
    [anon_sym_CARET_EQ] = ACTIONS(2577),
    [anon_sym_AMP_EQ] = ACTIONS(2577),
    [anon_sym_PIPE_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT_EQ] = ACTIONS(2577),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2577),
    [anon_sym_LT_LT_EQ] = ACTIONS(2577),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [778] = {
    [anon_sym_EQ_GT] = ACTIONS(2561),
    [sym_comment] = ACTIONS(78),
  },
  [779] = {
    [sym__automatic_semicolon] = ACTIONS(2597),
    [anon_sym_STAR] = ACTIONS(2597),
    [anon_sym_COMMA] = ACTIONS(2597),
    [anon_sym_RBRACE] = ACTIONS(2597),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_RPAREN] = ACTIONS(2597),
    [anon_sym_in] = ACTIONS(2599),
    [anon_sym_of] = ACTIONS(2597),
    [anon_sym_SEMI] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_SLASH] = ACTIONS(2599),
    [anon_sym_DOT] = ACTIONS(2597),
    [anon_sym_EQ] = ACTIONS(2599),
    [anon_sym_QMARK] = ACTIONS(2597),
    [anon_sym_AMP_AMP] = ACTIONS(2597),
    [anon_sym_PIPE_PIPE] = ACTIONS(2597),
    [anon_sym_GT_GT] = ACTIONS(2599),
    [anon_sym_GT_GT_GT] = ACTIONS(2597),
    [anon_sym_LT_LT] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_CARET] = ACTIONS(2597),
    [anon_sym_PIPE] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2599),
    [anon_sym_PERCENT] = ACTIONS(2597),
    [anon_sym_LT_EQ] = ACTIONS(2597),
    [anon_sym_EQ_EQ] = ACTIONS(2599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2599),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2597),
    [anon_sym_GT_EQ] = ACTIONS(2597),
    [anon_sym_instanceof] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2597),
  },
  [780] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2601),
    [anon_sym_RBRACE] = ACTIONS(2601),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [781] = {
    [anon_sym_STAR] = ACTIONS(2603),
    [anon_sym_COMMA] = ACTIONS(2603),
    [anon_sym_RBRACE] = ACTIONS(2603),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym_LBRACK] = ACTIONS(2603),
    [anon_sym_async] = ACTIONS(2605),
    [anon_sym_DQUOTE] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(2603),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(2603),
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_AT] = ACTIONS(2603),
    [anon_sym_static] = ACTIONS(2605),
    [anon_sym_get] = ACTIONS(2605),
    [anon_sym_set] = ACTIONS(2605),
  },
  [782] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2607),
    [sym_comment] = ACTIONS(78),
  },
  [783] = {
    [anon_sym_from] = ACTIONS(2609),
    [sym_comment] = ACTIONS(78),
  },
  [784] = {
    [anon_sym_from] = ACTIONS(2611),
    [sym_comment] = ACTIONS(78),
  },
  [785] = {
    [sym__import_export_specifier] = STATE(1146),
    [anon_sym_RBRACE] = ACTIONS(2613),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(477),
  },
  [786] = {
    [anon_sym_from] = ACTIONS(2615),
    [sym_comment] = ACTIONS(78),
  },
  [787] = {
    [aux_sym_named_imports_repeat1] = STATE(1148),
    [anon_sym_COMMA] = ACTIONS(2617),
    [anon_sym_RBRACE] = ACTIONS(2613),
    [sym_comment] = ACTIONS(78),
  },
  [788] = {
    [anon_sym_from] = ACTIONS(2619),
    [sym_comment] = ACTIONS(78),
  },
  [789] = {
    [ts_builtin_sym_end] = ACTIONS(2621),
    [anon_sym_export] = ACTIONS(2623),
    [anon_sym_default] = ACTIONS(2623),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_RBRACE] = ACTIONS(2621),
    [anon_sym_import] = ACTIONS(2623),
    [anon_sym_var] = ACTIONS(2623),
    [anon_sym_let] = ACTIONS(2623),
    [anon_sym_const] = ACTIONS(2623),
    [anon_sym_if] = ACTIONS(2623),
    [anon_sym_else] = ACTIONS(2623),
    [anon_sym_switch] = ACTIONS(2623),
    [anon_sym_for] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2621),
    [anon_sym_await] = ACTIONS(2623),
    [anon_sym_while] = ACTIONS(2623),
    [anon_sym_do] = ACTIONS(2623),
    [anon_sym_try] = ACTIONS(2623),
    [anon_sym_with] = ACTIONS(2623),
    [anon_sym_break] = ACTIONS(2623),
    [anon_sym_continue] = ACTIONS(2623),
    [anon_sym_debugger] = ACTIONS(2623),
    [anon_sym_return] = ACTIONS(2623),
    [anon_sym_throw] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2623),
    [anon_sym_yield] = ACTIONS(2623),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_LT] = ACTIONS(2621),
    [anon_sym_SLASH] = ACTIONS(2623),
    [anon_sym_class] = ACTIONS(2623),
    [anon_sym_async] = ACTIONS(2623),
    [anon_sym_function] = ACTIONS(2623),
    [anon_sym_EQ_GT] = ACTIONS(2621),
    [anon_sym_new] = ACTIONS(2623),
    [anon_sym_PLUS] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2621),
    [anon_sym_TILDE] = ACTIONS(2621),
    [anon_sym_typeof] = ACTIONS(2623),
    [anon_sym_void] = ACTIONS(2623),
    [anon_sym_delete] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2621),
    [anon_sym_DASH_DASH] = ACTIONS(2621),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [anon_sym_SQUOTE] = ACTIONS(2621),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2621),
    [sym_number] = ACTIONS(2621),
    [sym_identifier] = ACTIONS(2623),
    [sym_this] = ACTIONS(2623),
    [sym_super] = ACTIONS(2623),
    [sym_true] = ACTIONS(2623),
    [sym_false] = ACTIONS(2623),
    [sym_null] = ACTIONS(2623),
    [sym_undefined] = ACTIONS(2623),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_get] = ACTIONS(2623),
    [anon_sym_set] = ACTIONS(2623),
  },
  [790] = {
    [sym__automatic_semicolon] = ACTIONS(1545),
    [anon_sym_COMMA] = ACTIONS(1545),
    [anon_sym_in] = ACTIONS(1545),
    [anon_sym_of] = ACTIONS(1545),
    [anon_sym_SEMI] = ACTIONS(1545),
    [anon_sym_EQ] = ACTIONS(1545),
    [sym_comment] = ACTIONS(78),
  },
  [791] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2625),
    [sym_comment] = ACTIONS(78),
  },
  [792] = {
    [sym__automatic_semicolon] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1633),
    [anon_sym_in] = ACTIONS(1633),
    [anon_sym_of] = ACTIONS(1633),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1633),
    [sym_comment] = ACTIONS(78),
  },
  [793] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [sym_comment] = ACTIONS(78),
  },
  [794] = {
    [aux_sym_object_repeat1] = STATE(1151),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [sym_comment] = ACTIONS(78),
  },
  [795] = {
    [sym__automatic_semicolon] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_of] = ACTIONS(1962),
    [anon_sym_SEMI] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1962),
    [sym_comment] = ACTIONS(78),
  },
  [796] = {
    [aux_sym_array_repeat1] = STATE(530),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(2629),
    [sym_comment] = ACTIONS(78),
  },
  [797] = {
    [sym__automatic_semicolon] = ACTIONS(2631),
    [anon_sym_COMMA] = ACTIONS(2631),
    [anon_sym_SEMI] = ACTIONS(2631),
    [sym_comment] = ACTIONS(78),
  },
  [798] = {
    [ts_builtin_sym_end] = ACTIONS(2633),
    [anon_sym_export] = ACTIONS(2635),
    [anon_sym_default] = ACTIONS(2635),
    [anon_sym_LBRACE] = ACTIONS(2633),
    [anon_sym_RBRACE] = ACTIONS(2633),
    [anon_sym_import] = ACTIONS(2635),
    [anon_sym_var] = ACTIONS(2635),
    [anon_sym_let] = ACTIONS(2635),
    [anon_sym_const] = ACTIONS(2635),
    [anon_sym_if] = ACTIONS(2635),
    [anon_sym_else] = ACTIONS(2635),
    [anon_sym_switch] = ACTIONS(2635),
    [anon_sym_for] = ACTIONS(2635),
    [anon_sym_LPAREN] = ACTIONS(2633),
    [anon_sym_await] = ACTIONS(2635),
    [anon_sym_while] = ACTIONS(2635),
    [anon_sym_do] = ACTIONS(2635),
    [anon_sym_try] = ACTIONS(2635),
    [anon_sym_with] = ACTIONS(2635),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_continue] = ACTIONS(2635),
    [anon_sym_debugger] = ACTIONS(2635),
    [anon_sym_return] = ACTIONS(2635),
    [anon_sym_throw] = ACTIONS(2635),
    [anon_sym_SEMI] = ACTIONS(2633),
    [anon_sym_case] = ACTIONS(2635),
    [anon_sym_yield] = ACTIONS(2635),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_LT] = ACTIONS(2633),
    [anon_sym_SLASH] = ACTIONS(2635),
    [anon_sym_class] = ACTIONS(2635),
    [anon_sym_async] = ACTIONS(2635),
    [anon_sym_function] = ACTIONS(2635),
    [anon_sym_EQ_GT] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2635),
    [anon_sym_PLUS] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2633),
    [anon_sym_TILDE] = ACTIONS(2633),
    [anon_sym_typeof] = ACTIONS(2635),
    [anon_sym_void] = ACTIONS(2635),
    [anon_sym_delete] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2633),
    [anon_sym_DQUOTE] = ACTIONS(2633),
    [anon_sym_SQUOTE] = ACTIONS(2633),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2633),
    [sym_number] = ACTIONS(2633),
    [sym_identifier] = ACTIONS(2635),
    [sym_this] = ACTIONS(2635),
    [sym_super] = ACTIONS(2635),
    [sym_true] = ACTIONS(2635),
    [sym_false] = ACTIONS(2635),
    [sym_null] = ACTIONS(2635),
    [sym_undefined] = ACTIONS(2635),
    [anon_sym_AT] = ACTIONS(2633),
    [anon_sym_get] = ACTIONS(2635),
    [anon_sym_set] = ACTIONS(2635),
  },
  [799] = {
    [aux_sym_variable_declaration_repeat1] = STATE(799),
    [sym__automatic_semicolon] = ACTIONS(2631),
    [anon_sym_COMMA] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2631),
    [sym_comment] = ACTIONS(78),
  },
  [800] = {
    [ts_builtin_sym_end] = ACTIONS(2640),
    [anon_sym_export] = ACTIONS(2642),
    [anon_sym_default] = ACTIONS(2642),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_RBRACE] = ACTIONS(2640),
    [anon_sym_import] = ACTIONS(2642),
    [anon_sym_var] = ACTIONS(2642),
    [anon_sym_let] = ACTIONS(2642),
    [anon_sym_const] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(2642),
    [anon_sym_else] = ACTIONS(2642),
    [anon_sym_switch] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_await] = ACTIONS(2642),
    [anon_sym_while] = ACTIONS(2642),
    [anon_sym_do] = ACTIONS(2642),
    [anon_sym_try] = ACTIONS(2642),
    [anon_sym_with] = ACTIONS(2642),
    [anon_sym_break] = ACTIONS(2642),
    [anon_sym_continue] = ACTIONS(2642),
    [anon_sym_debugger] = ACTIONS(2642),
    [anon_sym_return] = ACTIONS(2642),
    [anon_sym_throw] = ACTIONS(2642),
    [anon_sym_SEMI] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2642),
    [anon_sym_yield] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2640),
    [anon_sym_SLASH] = ACTIONS(2642),
    [anon_sym_class] = ACTIONS(2642),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_function] = ACTIONS(2642),
    [anon_sym_EQ_GT] = ACTIONS(2640),
    [anon_sym_new] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2640),
    [anon_sym_typeof] = ACTIONS(2642),
    [anon_sym_void] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2640),
    [anon_sym_DASH_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(2640),
    [anon_sym_SQUOTE] = ACTIONS(2640),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2640),
    [sym_number] = ACTIONS(2640),
    [sym_identifier] = ACTIONS(2642),
    [sym_this] = ACTIONS(2642),
    [sym_super] = ACTIONS(2642),
    [sym_true] = ACTIONS(2642),
    [sym_false] = ACTIONS(2642),
    [sym_null] = ACTIONS(2642),
    [sym_undefined] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(2640),
    [anon_sym_get] = ACTIONS(2642),
    [anon_sym_set] = ACTIONS(2642),
  },
  [801] = {
    [anon_sym_export] = ACTIONS(1852),
    [anon_sym_LBRACE] = ACTIONS(1850),
    [anon_sym_import] = ACTIONS(1852),
    [anon_sym_var] = ACTIONS(1852),
    [anon_sym_let] = ACTIONS(1852),
    [anon_sym_const] = ACTIONS(1852),
    [anon_sym_if] = ACTIONS(1852),
    [anon_sym_switch] = ACTIONS(1852),
    [anon_sym_for] = ACTIONS(1852),
    [anon_sym_LPAREN] = ACTIONS(1850),
    [anon_sym_await] = ACTIONS(1852),
    [anon_sym_while] = ACTIONS(1852),
    [anon_sym_do] = ACTIONS(1852),
    [anon_sym_try] = ACTIONS(1852),
    [anon_sym_with] = ACTIONS(1852),
    [anon_sym_break] = ACTIONS(1852),
    [anon_sym_continue] = ACTIONS(1852),
    [anon_sym_debugger] = ACTIONS(1852),
    [anon_sym_return] = ACTIONS(1852),
    [anon_sym_throw] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1850),
    [anon_sym_yield] = ACTIONS(1852),
    [anon_sym_LBRACK] = ACTIONS(1850),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_SLASH] = ACTIONS(1852),
    [anon_sym_class] = ACTIONS(1852),
    [anon_sym_async] = ACTIONS(1852),
    [anon_sym_function] = ACTIONS(1852),
    [anon_sym_EQ_GT] = ACTIONS(1850),
    [anon_sym_new] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1852),
    [anon_sym_BANG] = ACTIONS(1850),
    [anon_sym_TILDE] = ACTIONS(1850),
    [anon_sym_typeof] = ACTIONS(1852),
    [anon_sym_void] = ACTIONS(1852),
    [anon_sym_delete] = ACTIONS(1852),
    [anon_sym_PLUS_PLUS] = ACTIONS(1850),
    [anon_sym_DASH_DASH] = ACTIONS(1850),
    [anon_sym_DQUOTE] = ACTIONS(1850),
    [anon_sym_SQUOTE] = ACTIONS(1850),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1850),
    [sym_number] = ACTIONS(1850),
    [sym_identifier] = ACTIONS(1852),
    [sym_this] = ACTIONS(1852),
    [sym_super] = ACTIONS(1852),
    [sym_true] = ACTIONS(1852),
    [sym_false] = ACTIONS(1852),
    [sym_null] = ACTIONS(1852),
    [sym_undefined] = ACTIONS(1852),
    [anon_sym_AT] = ACTIONS(1850),
    [anon_sym_get] = ACTIONS(1852),
    [anon_sym_set] = ACTIONS(1852),
  },
  [802] = {
    [sym_export_statement] = STATE(1153),
    [sym__declaration] = STATE(1153),
    [sym_import_statement] = STATE(1153),
    [sym_expression_statement] = STATE(1153),
    [sym_variable_declaration] = STATE(1153),
    [sym_lexical_declaration] = STATE(1153),
    [sym_statement_block] = STATE(1153),
    [sym_if_statement] = STATE(1153),
    [sym_switch_statement] = STATE(1153),
    [sym_for_statement] = STATE(1153),
    [sym_for_in_statement] = STATE(1153),
    [sym_for_of_statement] = STATE(1153),
    [sym_while_statement] = STATE(1153),
    [sym_do_statement] = STATE(1153),
    [sym_try_statement] = STATE(1153),
    [sym_with_statement] = STATE(1153),
    [sym_break_statement] = STATE(1153),
    [sym_continue_statement] = STATE(1153),
    [sym_debugger_statement] = STATE(1153),
    [sym_return_statement] = STATE(1153),
    [sym_throw_statement] = STATE(1153),
    [sym_empty_statement] = STATE(1153),
    [sym_labeled_statement] = STATE(1153),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [803] = {
    [sym_expression_statement] = STATE(1157),
    [sym_variable_declaration] = STATE(1157),
    [sym_lexical_declaration] = STATE(1157),
    [sym_empty_statement] = STATE(1157),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(1158),
    [sym_array] = STATE(1159),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_var] = ACTIONS(2644),
    [anon_sym_let] = ACTIONS(2646),
    [anon_sym_const] = ACTIONS(2646),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(2648),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [804] = {
    [anon_sym_LPAREN] = ACTIONS(2650),
    [sym_comment] = ACTIONS(78),
  },
  [805] = {
    [sym_export_statement] = STATE(485),
    [sym__declaration] = STATE(485),
    [sym_import_statement] = STATE(485),
    [sym_expression_statement] = STATE(485),
    [sym_variable_declaration] = STATE(485),
    [sym_lexical_declaration] = STATE(485),
    [sym_statement_block] = STATE(485),
    [sym_if_statement] = STATE(485),
    [sym_switch_statement] = STATE(485),
    [sym_for_statement] = STATE(485),
    [sym_for_in_statement] = STATE(485),
    [sym_for_of_statement] = STATE(485),
    [sym_while_statement] = STATE(485),
    [sym_do_statement] = STATE(485),
    [sym_try_statement] = STATE(485),
    [sym_with_statement] = STATE(485),
    [sym_break_statement] = STATE(485),
    [sym_continue_statement] = STATE(485),
    [sym_debugger_statement] = STATE(485),
    [sym_return_statement] = STATE(485),
    [sym_throw_statement] = STATE(485),
    [sym_empty_statement] = STATE(485),
    [sym_labeled_statement] = STATE(485),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [806] = {
    [sym_export_statement] = STATE(502),
    [sym__declaration] = STATE(502),
    [sym_import_statement] = STATE(502),
    [sym_expression_statement] = STATE(502),
    [sym_variable_declaration] = STATE(502),
    [sym_lexical_declaration] = STATE(502),
    [sym_statement_block] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_switch_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_for_in_statement] = STATE(502),
    [sym_for_of_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_do_statement] = STATE(502),
    [sym_try_statement] = STATE(502),
    [sym_with_statement] = STATE(502),
    [sym_break_statement] = STATE(502),
    [sym_continue_statement] = STATE(502),
    [sym_debugger_statement] = STATE(502),
    [sym_return_statement] = STATE(502),
    [sym_throw_statement] = STATE(502),
    [sym_empty_statement] = STATE(502),
    [sym_labeled_statement] = STATE(502),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [807] = {
    [sym_export_statement] = STATE(619),
    [sym__declaration] = STATE(619),
    [sym_import_statement] = STATE(619),
    [sym_expression_statement] = STATE(619),
    [sym_variable_declaration] = STATE(619),
    [sym_lexical_declaration] = STATE(619),
    [sym_statement_block] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(619),
    [sym_for_in_statement] = STATE(619),
    [sym_for_of_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_do_statement] = STATE(619),
    [sym_try_statement] = STATE(619),
    [sym_with_statement] = STATE(619),
    [sym_break_statement] = STATE(619),
    [sym_continue_statement] = STATE(619),
    [sym_debugger_statement] = STATE(619),
    [sym_return_statement] = STATE(619),
    [sym_throw_statement] = STATE(619),
    [sym_empty_statement] = STATE(619),
    [sym_labeled_statement] = STATE(619),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [808] = {
    [sym_export_statement] = STATE(1161),
    [sym__declaration] = STATE(1161),
    [sym_import_statement] = STATE(1161),
    [sym_expression_statement] = STATE(1161),
    [sym_variable_declaration] = STATE(1161),
    [sym_lexical_declaration] = STATE(1161),
    [sym_statement_block] = STATE(1161),
    [sym_if_statement] = STATE(1161),
    [sym_switch_statement] = STATE(1161),
    [sym_for_statement] = STATE(1161),
    [sym_for_in_statement] = STATE(1161),
    [sym_for_of_statement] = STATE(1161),
    [sym_while_statement] = STATE(1161),
    [sym_do_statement] = STATE(1161),
    [sym_try_statement] = STATE(1161),
    [sym_with_statement] = STATE(1161),
    [sym_break_statement] = STATE(1161),
    [sym_continue_statement] = STATE(1161),
    [sym_debugger_statement] = STATE(1161),
    [sym_return_statement] = STATE(1161),
    [sym_throw_statement] = STATE(1161),
    [sym_empty_statement] = STATE(1161),
    [sym_labeled_statement] = STATE(1161),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [809] = {
    [anon_sym_COLON] = ACTIONS(2652),
    [sym_comment] = ACTIONS(78),
  },
  [810] = {
    [ts_builtin_sym_end] = ACTIONS(2654),
    [anon_sym_export] = ACTIONS(2656),
    [anon_sym_default] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_import] = ACTIONS(2656),
    [anon_sym_var] = ACTIONS(2656),
    [anon_sym_let] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2656),
    [anon_sym_else] = ACTIONS(2656),
    [anon_sym_switch] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2654),
    [anon_sym_await] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(2656),
    [anon_sym_do] = ACTIONS(2656),
    [anon_sym_try] = ACTIONS(2656),
    [anon_sym_with] = ACTIONS(2656),
    [anon_sym_break] = ACTIONS(2656),
    [anon_sym_continue] = ACTIONS(2656),
    [anon_sym_debugger] = ACTIONS(2656),
    [anon_sym_return] = ACTIONS(2656),
    [anon_sym_throw] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym_case] = ACTIONS(2656),
    [anon_sym_yield] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_async] = ACTIONS(2656),
    [anon_sym_function] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2656),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2654),
    [anon_sym_typeof] = ACTIONS(2656),
    [anon_sym_void] = ACTIONS(2656),
    [anon_sym_delete] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2654),
    [anon_sym_DASH_DASH] = ACTIONS(2654),
    [anon_sym_DQUOTE] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2654),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2654),
    [sym_number] = ACTIONS(2654),
    [sym_identifier] = ACTIONS(2656),
    [sym_this] = ACTIONS(2656),
    [sym_super] = ACTIONS(2656),
    [sym_true] = ACTIONS(2656),
    [sym_false] = ACTIONS(2656),
    [sym_null] = ACTIONS(2656),
    [sym_undefined] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2654),
    [anon_sym_get] = ACTIONS(2656),
    [anon_sym_set] = ACTIONS(2656),
  },
  [811] = {
    [sym_parenthesized_expression] = STATE(1172),
    [sym__expression] = STATE(1172),
    [sym_yield_expression] = STATE(1172),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1172),
    [sym_jsx_fragment] = STATE(1172),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1172),
    [sym_anonymous_class] = STATE(1172),
    [sym_class] = STATE(1172),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1172),
    [sym_generator_function] = STATE(1172),
    [sym_call_expression] = STATE(1172),
    [sym_new_expression] = STATE(1172),
    [sym_await_expression] = STATE(1172),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1172),
    [sym_augmented_assignment_expression] = STATE(1172),
    [sym_ternary_expression] = STATE(1172),
    [sym_binary_expression] = STATE(1172),
    [sym_unary_expression] = STATE(1172),
    [sym_update_expression] = STATE(1172),
    [sym_sequence_expression] = STATE(1176),
    [sym_string] = STATE(1172),
    [sym_template_string] = STATE(1172),
    [sym_regex] = STATE(1172),
    [sym_meta_property] = STATE(1172),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2674),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [812] = {
    [sym_switch_case] = STATE(1179),
    [sym_switch_default] = STATE(1179),
    [aux_sym_switch_body_repeat1] = STATE(1179),
    [anon_sym_default] = ACTIONS(1728),
    [anon_sym_RBRACE] = ACTIONS(2682),
    [anon_sym_case] = ACTIONS(1732),
    [sym_comment] = ACTIONS(78),
  },
  [813] = {
    [sym__initializer] = STATE(363),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(2684),
    [anon_sym_of] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [814] = {
    [sym__initializer] = STATE(367),
    [sym__automatic_semicolon] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(2688),
    [anon_sym_of] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [815] = {
    [sym__initializer] = STATE(368),
    [sym__automatic_semicolon] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_of] = ACTIONS(2694),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [816] = {
    [sym_parenthesized_expression] = STATE(1195),
    [sym__expression] = STATE(1195),
    [sym_yield_expression] = STATE(1195),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1195),
    [sym_jsx_fragment] = STATE(1195),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1195),
    [sym_anonymous_class] = STATE(1195),
    [sym_class] = STATE(1195),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1195),
    [sym_generator_function] = STATE(1195),
    [sym_call_expression] = STATE(1195),
    [sym_new_expression] = STATE(1195),
    [sym_await_expression] = STATE(1195),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1195),
    [sym_augmented_assignment_expression] = STATE(1195),
    [sym_ternary_expression] = STATE(1195),
    [sym_binary_expression] = STATE(1195),
    [sym_unary_expression] = STATE(1195),
    [sym_update_expression] = STATE(1195),
    [sym_sequence_expression] = STATE(1199),
    [sym_string] = STATE(1195),
    [sym_template_string] = STATE(1195),
    [sym_regex] = STATE(1195),
    [sym_meta_property] = STATE(1195),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2712),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(2716),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2716),
    [sym_false] = ACTIONS(2716),
    [sym_null] = ACTIONS(2716),
    [sym_undefined] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [817] = {
    [sym_parenthesized_expression] = STATE(1210),
    [sym__expression] = STATE(1210),
    [sym_yield_expression] = STATE(1210),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1210),
    [sym_jsx_fragment] = STATE(1210),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1210),
    [sym_anonymous_class] = STATE(1210),
    [sym_class] = STATE(1210),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1210),
    [sym_generator_function] = STATE(1210),
    [sym_call_expression] = STATE(1210),
    [sym_new_expression] = STATE(1210),
    [sym_await_expression] = STATE(1210),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1210),
    [sym_augmented_assignment_expression] = STATE(1210),
    [sym_ternary_expression] = STATE(1210),
    [sym_binary_expression] = STATE(1210),
    [sym_unary_expression] = STATE(1210),
    [sym_update_expression] = STATE(1210),
    [sym_string] = STATE(1210),
    [sym_template_string] = STATE(1210),
    [sym_regex] = STATE(1210),
    [sym_meta_property] = STATE(1210),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2736),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(2740),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2740),
    [sym_false] = ACTIONS(2740),
    [sym_null] = ACTIONS(2740),
    [sym_undefined] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [818] = {
    [sym_parenthesized_expression] = STATE(1216),
    [sym__expression] = STATE(1216),
    [sym_yield_expression] = STATE(1216),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1216),
    [sym_jsx_fragment] = STATE(1216),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1216),
    [sym_anonymous_class] = STATE(1216),
    [sym_class] = STATE(1216),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1216),
    [sym_generator_function] = STATE(1216),
    [sym_call_expression] = STATE(1216),
    [sym_new_expression] = STATE(1216),
    [sym_await_expression] = STATE(1216),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1216),
    [sym_augmented_assignment_expression] = STATE(1216),
    [sym_ternary_expression] = STATE(1216),
    [sym_binary_expression] = STATE(1216),
    [sym_unary_expression] = STATE(1216),
    [sym_update_expression] = STATE(1216),
    [sym_sequence_expression] = STATE(1217),
    [sym_string] = STATE(1216),
    [sym_template_string] = STATE(1216),
    [sym_regex] = STATE(1216),
    [sym_meta_property] = STATE(1216),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(2748),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2748),
    [sym_false] = ACTIONS(2748),
    [sym_null] = ACTIONS(2748),
    [sym_undefined] = ACTIONS(2748),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [819] = {
    [sym_parenthesized_expression] = STATE(1218),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1218),
    [sym_jsx_fragment] = STATE(1218),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1218),
    [sym_anonymous_class] = STATE(1218),
    [sym_class] = STATE(1218),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1218),
    [sym_generator_function] = STATE(1218),
    [sym_call_expression] = STATE(1218),
    [sym_new_expression] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_sequence_expression] = STATE(1219),
    [sym_string] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2750),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(2752),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2752),
    [sym_false] = ACTIONS(2752),
    [sym_null] = ACTIONS(2752),
    [sym_undefined] = ACTIONS(2752),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [820] = {
    [sym_parenthesized_expression] = STATE(1220),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1220),
    [sym_jsx_fragment] = STATE(1220),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1220),
    [sym_anonymous_class] = STATE(1220),
    [sym_class] = STATE(1220),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_new_expression] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_string] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2754),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(2756),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2756),
    [sym_false] = ACTIONS(2756),
    [sym_null] = ACTIONS(2756),
    [sym_undefined] = ACTIONS(2756),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [821] = {
    [sym_parenthesized_expression] = STATE(1221),
    [sym__expression] = STATE(1221),
    [sym_yield_expression] = STATE(1221),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1221),
    [sym_jsx_fragment] = STATE(1221),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1221),
    [sym_anonymous_class] = STATE(1221),
    [sym_class] = STATE(1221),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1221),
    [sym_generator_function] = STATE(1221),
    [sym_call_expression] = STATE(1221),
    [sym_new_expression] = STATE(1221),
    [sym_await_expression] = STATE(1221),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1221),
    [sym_augmented_assignment_expression] = STATE(1221),
    [sym_ternary_expression] = STATE(1221),
    [sym_binary_expression] = STATE(1221),
    [sym_unary_expression] = STATE(1221),
    [sym_update_expression] = STATE(1221),
    [sym_sequence_expression] = STATE(1222),
    [sym_string] = STATE(1221),
    [sym_template_string] = STATE(1221),
    [sym_regex] = STATE(1221),
    [sym_meta_property] = STATE(1221),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(2758),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(2760),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_null] = ACTIONS(2760),
    [sym_undefined] = ACTIONS(2760),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [822] = {
    [sym_parenthesized_expression] = STATE(1223),
    [sym__expression] = STATE(1223),
    [sym_yield_expression] = STATE(1223),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1223),
    [sym_jsx_fragment] = STATE(1223),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1223),
    [sym_anonymous_class] = STATE(1223),
    [sym_class] = STATE(1223),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1223),
    [sym_generator_function] = STATE(1223),
    [sym_call_expression] = STATE(1223),
    [sym_new_expression] = STATE(1223),
    [sym_await_expression] = STATE(1223),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1223),
    [sym_augmented_assignment_expression] = STATE(1223),
    [sym_ternary_expression] = STATE(1223),
    [sym_binary_expression] = STATE(1223),
    [sym_unary_expression] = STATE(1223),
    [sym_update_expression] = STATE(1223),
    [sym_string] = STATE(1223),
    [sym_template_string] = STATE(1223),
    [sym_regex] = STATE(1223),
    [sym_meta_property] = STATE(1223),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2762),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(2764),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2764),
    [sym_false] = ACTIONS(2764),
    [sym_null] = ACTIONS(2764),
    [sym_undefined] = ACTIONS(2764),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [823] = {
    [sym_object] = STATE(1225),
    [sym_array] = STATE(1226),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2766),
  },
  [824] = {
    [anon_sym_of] = ACTIONS(2686),
    [sym_comment] = ACTIONS(78),
  },
  [825] = {
    [anon_sym_of] = ACTIONS(2690),
    [sym_comment] = ACTIONS(78),
  },
  [826] = {
    [anon_sym_of] = ACTIONS(2694),
    [sym_comment] = ACTIONS(78),
  },
  [827] = {
    [anon_sym_STAR] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_COMMA] = ACTIONS(1545),
    [anon_sym_RBRACE] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_RPAREN] = ACTIONS(1545),
    [anon_sym_in] = ACTIONS(1547),
    [anon_sym_of] = ACTIONS(1545),
    [anon_sym_COLON] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(1545),
    [anon_sym_RBRACK] = ACTIONS(1545),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_GT] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1547),
    [anon_sym_DOT] = ACTIONS(1545),
    [anon_sym_EQ] = ACTIONS(1547),
    [anon_sym_QMARK] = ACTIONS(1545),
    [anon_sym_AMP_AMP] = ACTIONS(1545),
    [anon_sym_PIPE_PIPE] = ACTIONS(1545),
    [anon_sym_GT_GT] = ACTIONS(1547),
    [anon_sym_GT_GT_GT] = ACTIONS(1545),
    [anon_sym_LT_LT] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1547),
    [anon_sym_CARET] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1545),
    [anon_sym_LT_EQ] = ACTIONS(1545),
    [anon_sym_EQ_EQ] = ACTIONS(1547),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1545),
    [anon_sym_BANG_EQ] = ACTIONS(1547),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1545),
    [anon_sym_GT_EQ] = ACTIONS(1545),
    [anon_sym_instanceof] = ACTIONS(1545),
    [anon_sym_PLUS_PLUS] = ACTIONS(1545),
    [anon_sym_DASH_DASH] = ACTIONS(1545),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1545),
  },
  [828] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2768),
    [sym_comment] = ACTIONS(78),
  },
  [829] = {
    [anon_sym_STAR] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1633),
    [anon_sym_RBRACE] = ACTIONS(1633),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [anon_sym_RPAREN] = ACTIONS(1633),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_of] = ACTIONS(1633),
    [anon_sym_COLON] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1633),
    [anon_sym_RBRACK] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1635),
    [anon_sym_QMARK] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1633),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1633),
    [anon_sym_GT_EQ] = ACTIONS(1633),
    [anon_sym_instanceof] = ACTIONS(1633),
    [anon_sym_PLUS_PLUS] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1633),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1633),
  },
  [830] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(78),
  },
  [831] = {
    [aux_sym_object_repeat1] = STATE(1229),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(78),
  },
  [832] = {
    [anon_sym_STAR] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(1850),
    [anon_sym_COMMA] = ACTIONS(1850),
    [anon_sym_RBRACE] = ACTIONS(1850),
    [anon_sym_LPAREN] = ACTIONS(1850),
    [anon_sym_RPAREN] = ACTIONS(1850),
    [anon_sym_in] = ACTIONS(1852),
    [anon_sym_COLON] = ACTIONS(1850),
    [anon_sym_LBRACK] = ACTIONS(1850),
    [anon_sym_RBRACK] = ACTIONS(1850),
    [anon_sym_LT] = ACTIONS(1852),
    [anon_sym_GT] = ACTIONS(1852),
    [anon_sym_SLASH] = ACTIONS(1852),
    [anon_sym_DOT] = ACTIONS(1850),
    [anon_sym_QMARK] = ACTIONS(1850),
    [anon_sym_AMP_AMP] = ACTIONS(1850),
    [anon_sym_PIPE_PIPE] = ACTIONS(1850),
    [anon_sym_GT_GT] = ACTIONS(1852),
    [anon_sym_GT_GT_GT] = ACTIONS(1850),
    [anon_sym_LT_LT] = ACTIONS(1850),
    [anon_sym_AMP] = ACTIONS(1852),
    [anon_sym_CARET] = ACTIONS(1850),
    [anon_sym_PIPE] = ACTIONS(1852),
    [anon_sym_PLUS] = ACTIONS(1852),
    [anon_sym_DASH] = ACTIONS(1852),
    [anon_sym_PERCENT] = ACTIONS(1850),
    [anon_sym_LT_EQ] = ACTIONS(1850),
    [anon_sym_EQ_EQ] = ACTIONS(1852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1850),
    [anon_sym_BANG_EQ] = ACTIONS(1852),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1850),
    [anon_sym_GT_EQ] = ACTIONS(1850),
    [anon_sym_instanceof] = ACTIONS(1850),
    [anon_sym_PLUS_PLUS] = ACTIONS(1850),
    [anon_sym_DASH_DASH] = ACTIONS(1850),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1850),
  },
  [833] = {
    [anon_sym_STAR] = ACTIONS(1962),
    [anon_sym_LBRACE] = ACTIONS(1962),
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_RBRACE] = ACTIONS(1962),
    [anon_sym_LPAREN] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_in] = ACTIONS(1964),
    [anon_sym_of] = ACTIONS(1962),
    [anon_sym_COLON] = ACTIONS(1962),
    [anon_sym_LBRACK] = ACTIONS(1962),
    [anon_sym_RBRACK] = ACTIONS(1962),
    [anon_sym_LT] = ACTIONS(1964),
    [anon_sym_GT] = ACTIONS(1964),
    [anon_sym_SLASH] = ACTIONS(1964),
    [anon_sym_DOT] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1964),
    [anon_sym_QMARK] = ACTIONS(1962),
    [anon_sym_AMP_AMP] = ACTIONS(1962),
    [anon_sym_PIPE_PIPE] = ACTIONS(1962),
    [anon_sym_GT_GT] = ACTIONS(1964),
    [anon_sym_GT_GT_GT] = ACTIONS(1962),
    [anon_sym_LT_LT] = ACTIONS(1962),
    [anon_sym_AMP] = ACTIONS(1964),
    [anon_sym_CARET] = ACTIONS(1962),
    [anon_sym_PIPE] = ACTIONS(1964),
    [anon_sym_PLUS] = ACTIONS(1964),
    [anon_sym_DASH] = ACTIONS(1964),
    [anon_sym_PERCENT] = ACTIONS(1962),
    [anon_sym_LT_EQ] = ACTIONS(1962),
    [anon_sym_EQ_EQ] = ACTIONS(1964),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1962),
    [anon_sym_BANG_EQ] = ACTIONS(1964),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1962),
    [anon_sym_GT_EQ] = ACTIONS(1962),
    [anon_sym_instanceof] = ACTIONS(1962),
    [anon_sym_PLUS_PLUS] = ACTIONS(1962),
    [anon_sym_DASH_DASH] = ACTIONS(1962),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1962),
  },
  [834] = {
    [aux_sym_array_repeat1] = STATE(530),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(2772),
    [sym_comment] = ACTIONS(78),
  },
  [835] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(2774),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [836] = {
    [sym_jsx_element] = STATE(665),
    [sym_jsx_expression] = STATE(665),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_self_closing_element] = STATE(665),
    [aux_sym_jsx_element_repeat1] = STATE(665),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(2776),
    [sym_jsx_text] = ACTIONS(1263),
    [sym_comment] = ACTIONS(78),
  },
  [837] = {
    [anon_sym_GT] = ACTIONS(2778),
    [sym_comment] = ACTIONS(78),
  },
  [838] = {
    [sym_jsx_expression] = STATE(940),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(940),
    [aux_sym_jsx_opening_element_repeat1] = STATE(940),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(2780),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [839] = {
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_LBRACE] = ACTIONS(2023),
    [anon_sym_COMMA] = ACTIONS(2023),
    [anon_sym_RBRACE] = ACTIONS(2023),
    [anon_sym_LPAREN] = ACTIONS(2023),
    [anon_sym_RPAREN] = ACTIONS(2023),
    [anon_sym_in] = ACTIONS(2025),
    [anon_sym_COLON] = ACTIONS(2023),
    [anon_sym_LBRACK] = ACTIONS(2023),
    [anon_sym_RBRACK] = ACTIONS(2023),
    [anon_sym_LT] = ACTIONS(2025),
    [anon_sym_GT] = ACTIONS(2025),
    [anon_sym_SLASH] = ACTIONS(2025),
    [anon_sym_DOT] = ACTIONS(2023),
    [anon_sym_QMARK] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_PIPE_PIPE] = ACTIONS(2023),
    [anon_sym_GT_GT] = ACTIONS(2025),
    [anon_sym_GT_GT_GT] = ACTIONS(2023),
    [anon_sym_LT_LT] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2025),
    [anon_sym_CARET] = ACTIONS(2023),
    [anon_sym_PIPE] = ACTIONS(2025),
    [anon_sym_PLUS] = ACTIONS(2025),
    [anon_sym_DASH] = ACTIONS(2025),
    [anon_sym_PERCENT] = ACTIONS(2023),
    [anon_sym_LT_EQ] = ACTIONS(2023),
    [anon_sym_EQ_EQ] = ACTIONS(2025),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2023),
    [anon_sym_BANG_EQ] = ACTIONS(2025),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2023),
    [anon_sym_GT_EQ] = ACTIONS(2023),
    [anon_sym_instanceof] = ACTIONS(2025),
    [anon_sym_PLUS_PLUS] = ACTIONS(2023),
    [anon_sym_DASH_DASH] = ACTIONS(2023),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2023),
    [sym_regex_flags] = ACTIONS(2782),
  },
  [840] = {
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_COMMA] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_COLON] = ACTIONS(2029),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_RBRACK] = ACTIONS(2029),
    [anon_sym_LT] = ACTIONS(2031),
    [anon_sym_GT] = ACTIONS(2031),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_DOT] = ACTIONS(2029),
    [anon_sym_QMARK] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [anon_sym_GT_GT] = ACTIONS(2031),
    [anon_sym_GT_GT_GT] = ACTIONS(2029),
    [anon_sym_LT_LT] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2031),
    [anon_sym_CARET] = ACTIONS(2029),
    [anon_sym_PIPE] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_PERCENT] = ACTIONS(2029),
    [anon_sym_LT_EQ] = ACTIONS(2029),
    [anon_sym_EQ_EQ] = ACTIONS(2031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2029),
    [anon_sym_BANG_EQ] = ACTIONS(2031),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2029),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_instanceof] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2029),
  },
  [841] = {
    [sym_string] = STATE(552),
    [sym_decorator] = STATE(553),
    [sym_public_field_definition] = STATE(550),
    [sym_method_definition] = STATE(551),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [aux_sym_export_statement_repeat1] = STATE(553),
    [aux_sym_class_body_repeat1] = STATE(954),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
  },
  [842] = {
    [sym_class_body] = STATE(1237),
    [anon_sym_LBRACE] = ACTIONS(717),
    [sym_comment] = ACTIONS(78),
  },
  [843] = {
    [anon_sym_STAR] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2105),
    [anon_sym_COMMA] = ACTIONS(2105),
    [anon_sym_RBRACE] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2105),
    [anon_sym_RPAREN] = ACTIONS(2105),
    [anon_sym_in] = ACTIONS(2107),
    [anon_sym_COLON] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2105),
    [anon_sym_RBRACK] = ACTIONS(2105),
    [anon_sym_LT] = ACTIONS(2107),
    [anon_sym_GT] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(2107),
    [anon_sym_DOT] = ACTIONS(2105),
    [anon_sym_QMARK] = ACTIONS(2105),
    [anon_sym_AMP_AMP] = ACTIONS(2105),
    [anon_sym_PIPE_PIPE] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2107),
    [anon_sym_GT_GT_GT] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2107),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_PIPE] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2107),
    [anon_sym_DASH] = ACTIONS(2107),
    [anon_sym_PERCENT] = ACTIONS(2105),
    [anon_sym_LT_EQ] = ACTIONS(2105),
    [anon_sym_EQ_EQ] = ACTIONS(2107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2105),
    [anon_sym_BANG_EQ] = ACTIONS(2107),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2105),
    [anon_sym_GT_EQ] = ACTIONS(2105),
    [anon_sym_instanceof] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2105),
    [anon_sym_DASH_DASH] = ACTIONS(2105),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2105),
  },
  [844] = {
    [anon_sym_STAR] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2109),
    [anon_sym_COMMA] = ACTIONS(2109),
    [anon_sym_RBRACE] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2109),
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_in] = ACTIONS(2111),
    [anon_sym_COLON] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2109),
    [anon_sym_RBRACK] = ACTIONS(2109),
    [anon_sym_LT] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2111),
    [anon_sym_DOT] = ACTIONS(2109),
    [anon_sym_QMARK] = ACTIONS(2109),
    [anon_sym_AMP_AMP] = ACTIONS(2109),
    [anon_sym_PIPE_PIPE] = ACTIONS(2109),
    [anon_sym_GT_GT] = ACTIONS(2111),
    [anon_sym_GT_GT_GT] = ACTIONS(2109),
    [anon_sym_LT_LT] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_CARET] = ACTIONS(2109),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2111),
    [anon_sym_DASH] = ACTIONS(2111),
    [anon_sym_PERCENT] = ACTIONS(2109),
    [anon_sym_LT_EQ] = ACTIONS(2109),
    [anon_sym_EQ_EQ] = ACTIONS(2111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2109),
    [anon_sym_BANG_EQ] = ACTIONS(2111),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2109),
    [anon_sym_GT_EQ] = ACTIONS(2109),
    [anon_sym_instanceof] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2109),
    [anon_sym_DASH_DASH] = ACTIONS(2109),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2109),
  },
  [845] = {
    [anon_sym_COMMA] = ACTIONS(2786),
    [anon_sym_RPAREN] = ACTIONS(2786),
    [sym_comment] = ACTIONS(78),
  },
  [846] = {
    [sym__initializer] = STATE(729),
    [anon_sym_COMMA] = ACTIONS(2788),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [anon_sym_EQ] = ACTIONS(2119),
    [sym_comment] = ACTIONS(78),
  },
  [847] = {
    [sym__initializer] = STATE(730),
    [anon_sym_COMMA] = ACTIONS(2790),
    [anon_sym_RPAREN] = ACTIONS(2790),
    [anon_sym_EQ] = ACTIONS(2119),
    [sym_comment] = ACTIONS(78),
  },
  [848] = {
    [anon_sym_COMMA] = ACTIONS(2788),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [sym_comment] = ACTIONS(78),
  },
  [849] = {
    [sym__initializer] = STATE(731),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RPAREN] = ACTIONS(2792),
    [anon_sym_EQ] = ACTIONS(2119),
    [sym_comment] = ACTIONS(78),
  },
  [850] = {
    [anon_sym_STAR] = ACTIONS(2127),
    [anon_sym_LBRACE] = ACTIONS(2125),
    [anon_sym_COMMA] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2125),
    [anon_sym_LPAREN] = ACTIONS(2125),
    [anon_sym_RPAREN] = ACTIONS(2125),
    [anon_sym_in] = ACTIONS(2127),
    [anon_sym_COLON] = ACTIONS(2125),
    [anon_sym_LBRACK] = ACTIONS(2125),
    [anon_sym_RBRACK] = ACTIONS(2125),
    [anon_sym_LT] = ACTIONS(2127),
    [anon_sym_GT] = ACTIONS(2127),
    [anon_sym_SLASH] = ACTIONS(2127),
    [anon_sym_DOT] = ACTIONS(2125),
    [anon_sym_EQ] = ACTIONS(2127),
    [anon_sym_PLUS_EQ] = ACTIONS(2125),
    [anon_sym_DASH_EQ] = ACTIONS(2125),
    [anon_sym_STAR_EQ] = ACTIONS(2125),
    [anon_sym_SLASH_EQ] = ACTIONS(2125),
    [anon_sym_PERCENT_EQ] = ACTIONS(2125),
    [anon_sym_CARET_EQ] = ACTIONS(2125),
    [anon_sym_AMP_EQ] = ACTIONS(2125),
    [anon_sym_PIPE_EQ] = ACTIONS(2125),
    [anon_sym_GT_GT_EQ] = ACTIONS(2125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2125),
    [anon_sym_LT_LT_EQ] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2125),
    [anon_sym_AMP_AMP] = ACTIONS(2125),
    [anon_sym_PIPE_PIPE] = ACTIONS(2125),
    [anon_sym_GT_GT] = ACTIONS(2127),
    [anon_sym_GT_GT_GT] = ACTIONS(2127),
    [anon_sym_LT_LT] = ACTIONS(2127),
    [anon_sym_AMP] = ACTIONS(2127),
    [anon_sym_CARET] = ACTIONS(2127),
    [anon_sym_PIPE] = ACTIONS(2127),
    [anon_sym_PLUS] = ACTIONS(2127),
    [anon_sym_DASH] = ACTIONS(2127),
    [anon_sym_PERCENT] = ACTIONS(2127),
    [anon_sym_LT_EQ] = ACTIONS(2125),
    [anon_sym_EQ_EQ] = ACTIONS(2127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2125),
    [anon_sym_BANG_EQ] = ACTIONS(2127),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2125),
    [anon_sym_GT_EQ] = ACTIONS(2125),
    [anon_sym_instanceof] = ACTIONS(2125),
    [anon_sym_PLUS_PLUS] = ACTIONS(2125),
    [anon_sym_DASH_DASH] = ACTIONS(2125),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2125),
  },
  [851] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [852] = {
    [sym_formal_parameters] = STATE(1238),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [853] = {
    [sym_statement_block] = STATE(1239),
    [anon_sym_LBRACE] = ACTIONS(1802),
    [sym_comment] = ACTIONS(78),
  },
  [854] = {
    [anon_sym_STAR] = ACTIONS(2131),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(2131),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_in] = ACTIONS(2133),
    [anon_sym_COLON] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(2131),
    [anon_sym_RBRACK] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2133),
    [anon_sym_GT] = ACTIONS(2133),
    [anon_sym_SLASH] = ACTIONS(2133),
    [anon_sym_DOT] = ACTIONS(2131),
    [anon_sym_QMARK] = ACTIONS(2131),
    [anon_sym_AMP_AMP] = ACTIONS(2131),
    [anon_sym_PIPE_PIPE] = ACTIONS(2131),
    [anon_sym_GT_GT] = ACTIONS(2133),
    [anon_sym_GT_GT_GT] = ACTIONS(2131),
    [anon_sym_LT_LT] = ACTIONS(2131),
    [anon_sym_AMP] = ACTIONS(2133),
    [anon_sym_CARET] = ACTIONS(2131),
    [anon_sym_PIPE] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_PERCENT] = ACTIONS(2131),
    [anon_sym_LT_EQ] = ACTIONS(2131),
    [anon_sym_EQ_EQ] = ACTIONS(2133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2131),
    [anon_sym_BANG_EQ] = ACTIONS(2133),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2131),
    [anon_sym_GT_EQ] = ACTIONS(2131),
    [anon_sym_instanceof] = ACTIONS(2131),
    [anon_sym_PLUS_PLUS] = ACTIONS(2131),
    [anon_sym_DASH_DASH] = ACTIONS(2131),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2131),
  },
  [855] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [856] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2135),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [857] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1241),
    [sym__expression] = STATE(1241),
    [sym_yield_expression] = STATE(1241),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1241),
    [sym_jsx_fragment] = STATE(1241),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1241),
    [sym_anonymous_class] = STATE(1241),
    [sym_class] = STATE(1241),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1241),
    [sym_generator_function] = STATE(1241),
    [sym_call_expression] = STATE(1241),
    [sym_new_expression] = STATE(1241),
    [sym_await_expression] = STATE(1241),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1241),
    [sym_augmented_assignment_expression] = STATE(1241),
    [sym_ternary_expression] = STATE(1241),
    [sym_binary_expression] = STATE(1241),
    [sym_unary_expression] = STATE(1241),
    [sym_update_expression] = STATE(1241),
    [sym_string] = STATE(1241),
    [sym_template_string] = STATE(1241),
    [sym_regex] = STATE(1241),
    [sym_meta_property] = STATE(1241),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(2796),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2796),
    [sym_false] = ACTIONS(2796),
    [sym_null] = ACTIONS(2796),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [858] = {
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_EQ_GT] = ACTIONS(2798),
    [sym_comment] = ACTIONS(78),
  },
  [859] = {
    [aux_sym_formal_parameters_repeat1] = STATE(859),
    [anon_sym_COMMA] = ACTIONS(2800),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [sym_comment] = ACTIONS(78),
  },
  [860] = {
    [sym_formal_parameters] = STATE(1242),
    [anon_sym_LPAREN] = ACTIONS(329),
    [sym_comment] = ACTIONS(78),
  },
  [861] = {
    [sym_statement_block] = STATE(1243),
    [anon_sym_LBRACE] = ACTIONS(1802),
    [sym_comment] = ACTIONS(78),
  },
  [862] = {
    [sym_export_statement] = STATE(867),
    [sym__declaration] = STATE(867),
    [sym_import_statement] = STATE(867),
    [sym_expression_statement] = STATE(867),
    [sym_variable_declaration] = STATE(867),
    [sym_lexical_declaration] = STATE(867),
    [sym_statement_block] = STATE(867),
    [sym_if_statement] = STATE(867),
    [sym_switch_statement] = STATE(867),
    [sym_for_statement] = STATE(867),
    [sym_for_in_statement] = STATE(867),
    [sym_for_of_statement] = STATE(867),
    [sym_while_statement] = STATE(867),
    [sym_do_statement] = STATE(867),
    [sym_try_statement] = STATE(867),
    [sym_with_statement] = STATE(867),
    [sym_break_statement] = STATE(867),
    [sym_continue_statement] = STATE(867),
    [sym_debugger_statement] = STATE(867),
    [sym_return_statement] = STATE(867),
    [sym_throw_statement] = STATE(867),
    [sym_empty_statement] = STATE(867),
    [sym_labeled_statement] = STATE(867),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(867),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [863] = {
    [anon_sym_STAR] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_COMMA] = ACTIONS(2143),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_LPAREN] = ACTIONS(2143),
    [anon_sym_RPAREN] = ACTIONS(2143),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_COLON] = ACTIONS(2143),
    [anon_sym_LBRACK] = ACTIONS(2143),
    [anon_sym_RBRACK] = ACTIONS(2143),
    [anon_sym_LT] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2145),
    [anon_sym_SLASH] = ACTIONS(2145),
    [anon_sym_DOT] = ACTIONS(2143),
    [anon_sym_QMARK] = ACTIONS(2143),
    [anon_sym_AMP_AMP] = ACTIONS(2143),
    [anon_sym_PIPE_PIPE] = ACTIONS(2143),
    [anon_sym_GT_GT] = ACTIONS(2145),
    [anon_sym_GT_GT_GT] = ACTIONS(2143),
    [anon_sym_LT_LT] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2143),
    [anon_sym_PIPE] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_PERCENT] = ACTIONS(2143),
    [anon_sym_LT_EQ] = ACTIONS(2143),
    [anon_sym_EQ_EQ] = ACTIONS(2145),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2143),
    [anon_sym_BANG_EQ] = ACTIONS(2145),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2143),
    [anon_sym_GT_EQ] = ACTIONS(2143),
    [anon_sym_instanceof] = ACTIONS(2143),
    [anon_sym_PLUS_PLUS] = ACTIONS(2143),
    [anon_sym_DASH_DASH] = ACTIONS(2143),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2143),
  },
  [864] = {
    [sym__initializer] = STATE(201),
    [sym_string] = STATE(292),
    [sym_formal_parameters] = STATE(200),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(828),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(531),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(545),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(323),
    [anon_sym_DASH_EQ] = ACTIONS(323),
    [anon_sym_STAR_EQ] = ACTIONS(323),
    [anon_sym_SLASH_EQ] = ACTIONS(323),
    [anon_sym_PERCENT_EQ] = ACTIONS(323),
    [anon_sym_CARET_EQ] = ACTIONS(323),
    [anon_sym_AMP_EQ] = ACTIONS(323),
    [anon_sym_PIPE_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_LT_LT_EQ] = ACTIONS(323),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(547),
    [anon_sym_get] = ACTIONS(549),
    [anon_sym_set] = ACTIONS(549),
  },
  [865] = {
    [sym__initializer] = STATE(329),
    [aux_sym_object_repeat1] = STATE(828),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(580),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(586),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [866] = {
    [sym__initializer] = STATE(201),
    [sym_string] = STATE(292),
    [sym__property_name] = STATE(292),
    [sym_computed_property_name] = STATE(292),
    [aux_sym_object_repeat1] = STATE(828),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_LPAREN] = ACTIONS(588),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(545),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_async] = ACTIONS(497),
    [anon_sym_PLUS_EQ] = ACTIONS(323),
    [anon_sym_DASH_EQ] = ACTIONS(323),
    [anon_sym_STAR_EQ] = ACTIONS(323),
    [anon_sym_SLASH_EQ] = ACTIONS(323),
    [anon_sym_PERCENT_EQ] = ACTIONS(323),
    [anon_sym_CARET_EQ] = ACTIONS(323),
    [anon_sym_AMP_EQ] = ACTIONS(323),
    [anon_sym_PIPE_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(323),
    [anon_sym_LT_LT_EQ] = ACTIONS(323),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_number] = ACTIONS(499),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_get] = ACTIONS(497),
    [anon_sym_set] = ACTIONS(497),
  },
  [867] = {
    [sym_export_statement] = STATE(338),
    [sym__declaration] = STATE(338),
    [sym_import_statement] = STATE(338),
    [sym_expression_statement] = STATE(338),
    [sym_variable_declaration] = STATE(338),
    [sym_lexical_declaration] = STATE(338),
    [sym_statement_block] = STATE(338),
    [sym_if_statement] = STATE(338),
    [sym_switch_statement] = STATE(338),
    [sym_for_statement] = STATE(338),
    [sym_for_in_statement] = STATE(338),
    [sym_for_of_statement] = STATE(338),
    [sym_while_statement] = STATE(338),
    [sym_do_statement] = STATE(338),
    [sym_try_statement] = STATE(338),
    [sym_with_statement] = STATE(338),
    [sym_break_statement] = STATE(338),
    [sym_continue_statement] = STATE(338),
    [sym_debugger_statement] = STATE(338),
    [sym_return_statement] = STATE(338),
    [sym_throw_statement] = STATE(338),
    [sym_empty_statement] = STATE(338),
    [sym_labeled_statement] = STATE(338),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(338),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(2805),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [868] = {
    [sym_string] = STATE(342),
    [sym_decorator] = STATE(343),
    [sym_method_definition] = STATE(831),
    [sym__property_name] = STATE(342),
    [sym_computed_property_name] = STATE(342),
    [aux_sym_export_statement_repeat1] = STATE(343),
    [anon_sym_export] = ACTIONS(599),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_class] = ACTIONS(601),
    [anon_sym_async] = ACTIONS(603),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(605),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(607),
    [anon_sym_set] = ACTIONS(607),
  },
  [869] = {
    [anon_sym_STAR] = ACTIONS(2157),
    [anon_sym_LBRACE] = ACTIONS(2157),
    [anon_sym_COMMA] = ACTIONS(2157),
    [anon_sym_RBRACE] = ACTIONS(2157),
    [anon_sym_LPAREN] = ACTIONS(2157),
    [anon_sym_RPAREN] = ACTIONS(2157),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK] = ACTIONS(2157),
    [anon_sym_RBRACK] = ACTIONS(2157),
    [anon_sym_LT] = ACTIONS(2159),
    [anon_sym_GT] = ACTIONS(2159),
    [anon_sym_SLASH] = ACTIONS(2159),
    [anon_sym_DOT] = ACTIONS(2157),
    [anon_sym_QMARK] = ACTIONS(2157),
    [anon_sym_AMP_AMP] = ACTIONS(2157),
    [anon_sym_PIPE_PIPE] = ACTIONS(2157),
    [anon_sym_GT_GT] = ACTIONS(2159),
    [anon_sym_GT_GT_GT] = ACTIONS(2157),
    [anon_sym_LT_LT] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_CARET] = ACTIONS(2157),
    [anon_sym_PIPE] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PERCENT] = ACTIONS(2157),
    [anon_sym_LT_EQ] = ACTIONS(2157),
    [anon_sym_EQ_EQ] = ACTIONS(2159),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2157),
    [anon_sym_BANG_EQ] = ACTIONS(2159),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2157),
    [anon_sym_GT_EQ] = ACTIONS(2157),
    [anon_sym_instanceof] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2157),
  },
  [870] = {
    [sym_parenthesized_expression] = STATE(880),
    [sym__expression] = STATE(880),
    [sym_yield_expression] = STATE(880),
    [sym_object] = STATE(125),
    [sym_assignment_pattern] = STATE(126),
    [sym_array] = STATE(127),
    [sym_jsx_element] = STATE(880),
    [sym_jsx_fragment] = STATE(880),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(880),
    [sym_anonymous_class] = STATE(880),
    [sym_class] = STATE(880),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(880),
    [sym_generator_function] = STATE(880),
    [sym_call_expression] = STATE(880),
    [sym_new_expression] = STATE(880),
    [sym_await_expression] = STATE(880),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(880),
    [sym_augmented_assignment_expression] = STATE(880),
    [sym_spread_element] = STATE(881),
    [sym_ternary_expression] = STATE(880),
    [sym_binary_expression] = STATE(880),
    [sym_unary_expression] = STATE(880),
    [sym_update_expression] = STATE(880),
    [sym_string] = STATE(880),
    [sym_template_string] = STATE(880),
    [sym_regex] = STATE(880),
    [sym_meta_property] = STATE(880),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [sym_rest_parameter] = STATE(126),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [aux_sym_array_repeat1] = STATE(882),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(174),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1834),
    [sym_identifier] = ACTIONS(198),
    [sym_this] = ACTIONS(1836),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1836),
    [sym_false] = ACTIONS(1836),
    [sym_null] = ACTIONS(1836),
    [sym_undefined] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(204),
    [anon_sym_set] = ACTIONS(204),
  },
  [871] = {
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_LBRACE] = ACTIONS(2165),
    [anon_sym_COMMA] = ACTIONS(2165),
    [anon_sym_RBRACE] = ACTIONS(2165),
    [anon_sym_LPAREN] = ACTIONS(2165),
    [anon_sym_RPAREN] = ACTIONS(2165),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK] = ACTIONS(2165),
    [anon_sym_RBRACK] = ACTIONS(2165),
    [anon_sym_LT] = ACTIONS(2167),
    [anon_sym_GT] = ACTIONS(2167),
    [anon_sym_SLASH] = ACTIONS(2167),
    [anon_sym_DOT] = ACTIONS(2165),
    [anon_sym_QMARK] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(2165),
    [anon_sym_PIPE_PIPE] = ACTIONS(2165),
    [anon_sym_GT_GT] = ACTIONS(2167),
    [anon_sym_GT_GT_GT] = ACTIONS(2165),
    [anon_sym_LT_LT] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_CARET] = ACTIONS(2165),
    [anon_sym_PIPE] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_PERCENT] = ACTIONS(2165),
    [anon_sym_LT_EQ] = ACTIONS(2165),
    [anon_sym_EQ_EQ] = ACTIONS(2167),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2165),
    [anon_sym_BANG_EQ] = ACTIONS(2167),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2165),
    [anon_sym_GT_EQ] = ACTIONS(2165),
    [anon_sym_instanceof] = ACTIONS(2165),
    [anon_sym_PLUS_PLUS] = ACTIONS(2165),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2165),
  },
  [872] = {
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_LPAREN] = ACTIONS(2169),
    [anon_sym_RPAREN] = ACTIONS(2169),
    [anon_sym_in] = ACTIONS(2171),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2169),
    [anon_sym_RBRACK] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2171),
    [anon_sym_GT] = ACTIONS(2171),
    [anon_sym_SLASH] = ACTIONS(2171),
    [anon_sym_DOT] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_PIPE_PIPE] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2171),
    [anon_sym_GT_GT_GT] = ACTIONS(2169),
    [anon_sym_LT_LT] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2171),
    [anon_sym_CARET] = ACTIONS(2169),
    [anon_sym_PIPE] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_PERCENT] = ACTIONS(2169),
    [anon_sym_LT_EQ] = ACTIONS(2169),
    [anon_sym_EQ_EQ] = ACTIONS(2171),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2171),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2169),
    [anon_sym_instanceof] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2169),
  },
  [873] = {
    [anon_sym_STAR] = ACTIONS(2193),
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(2193),
    [anon_sym_RBRACE] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_RPAREN] = ACTIONS(2193),
    [anon_sym_in] = ACTIONS(2195),
    [anon_sym_COLON] = ACTIONS(2193),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_RBRACK] = ACTIONS(2193),
    [anon_sym_LT] = ACTIONS(2195),
    [anon_sym_GT] = ACTIONS(2195),
    [anon_sym_SLASH] = ACTIONS(2195),
    [anon_sym_DOT] = ACTIONS(2193),
    [anon_sym_QMARK] = ACTIONS(2193),
    [anon_sym_AMP_AMP] = ACTIONS(2193),
    [anon_sym_PIPE_PIPE] = ACTIONS(2193),
    [anon_sym_GT_GT] = ACTIONS(2195),
    [anon_sym_GT_GT_GT] = ACTIONS(2193),
    [anon_sym_LT_LT] = ACTIONS(2193),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_CARET] = ACTIONS(2193),
    [anon_sym_PIPE] = ACTIONS(2195),
    [anon_sym_PLUS] = ACTIONS(2195),
    [anon_sym_DASH] = ACTIONS(2195),
    [anon_sym_PERCENT] = ACTIONS(2193),
    [anon_sym_LT_EQ] = ACTIONS(2193),
    [anon_sym_EQ_EQ] = ACTIONS(2195),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2193),
    [anon_sym_BANG_EQ] = ACTIONS(2195),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2193),
    [anon_sym_GT_EQ] = ACTIONS(2193),
    [anon_sym_instanceof] = ACTIONS(2193),
    [anon_sym_PLUS_PLUS] = ACTIONS(2193),
    [anon_sym_DASH_DASH] = ACTIONS(2193),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2193),
  },
  [874] = {
    [anon_sym_STAR] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(2211),
    [anon_sym_RBRACE] = ACTIONS(2211),
    [anon_sym_LPAREN] = ACTIONS(2211),
    [anon_sym_RPAREN] = ACTIONS(2211),
    [anon_sym_in] = ACTIONS(2213),
    [anon_sym_COLON] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(2211),
    [anon_sym_LT] = ACTIONS(2213),
    [anon_sym_GT] = ACTIONS(2213),
    [anon_sym_SLASH] = ACTIONS(2213),
    [anon_sym_DOT] = ACTIONS(2211),
    [anon_sym_QMARK] = ACTIONS(2211),
    [anon_sym_AMP_AMP] = ACTIONS(2211),
    [anon_sym_PIPE_PIPE] = ACTIONS(2211),
    [anon_sym_GT_GT] = ACTIONS(2213),
    [anon_sym_GT_GT_GT] = ACTIONS(2211),
    [anon_sym_LT_LT] = ACTIONS(2211),
    [anon_sym_AMP] = ACTIONS(2213),
    [anon_sym_CARET] = ACTIONS(2211),
    [anon_sym_PIPE] = ACTIONS(2213),
    [anon_sym_PLUS] = ACTIONS(2213),
    [anon_sym_DASH] = ACTIONS(2213),
    [anon_sym_PERCENT] = ACTIONS(2211),
    [anon_sym_LT_EQ] = ACTIONS(2211),
    [anon_sym_EQ_EQ] = ACTIONS(2213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2211),
    [anon_sym_BANG_EQ] = ACTIONS(2213),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2211),
    [anon_sym_GT_EQ] = ACTIONS(2211),
    [anon_sym_instanceof] = ACTIONS(2211),
    [anon_sym_PLUS_PLUS] = ACTIONS(2211),
    [anon_sym_DASH_DASH] = ACTIONS(2211),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2211),
  },
  [875] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [876] = {
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_LBRACE] = ACTIONS(2231),
    [anon_sym_COMMA] = ACTIONS(2231),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_RPAREN] = ACTIONS(2231),
    [anon_sym_in] = ACTIONS(2233),
    [anon_sym_COLON] = ACTIONS(2231),
    [anon_sym_LBRACK] = ACTIONS(2231),
    [anon_sym_RBRACK] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_DOT] = ACTIONS(2231),
    [anon_sym_EQ] = ACTIONS(2233),
    [anon_sym_PLUS_EQ] = ACTIONS(2231),
    [anon_sym_DASH_EQ] = ACTIONS(2231),
    [anon_sym_STAR_EQ] = ACTIONS(2231),
    [anon_sym_SLASH_EQ] = ACTIONS(2231),
    [anon_sym_PERCENT_EQ] = ACTIONS(2231),
    [anon_sym_CARET_EQ] = ACTIONS(2231),
    [anon_sym_AMP_EQ] = ACTIONS(2231),
    [anon_sym_PIPE_EQ] = ACTIONS(2231),
    [anon_sym_GT_GT_EQ] = ACTIONS(2231),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2231),
    [anon_sym_LT_LT_EQ] = ACTIONS(2231),
    [anon_sym_QMARK] = ACTIONS(2231),
    [anon_sym_AMP_AMP] = ACTIONS(2231),
    [anon_sym_PIPE_PIPE] = ACTIONS(2231),
    [anon_sym_GT_GT] = ACTIONS(2233),
    [anon_sym_GT_GT_GT] = ACTIONS(2233),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PLUS] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_LT_EQ] = ACTIONS(2231),
    [anon_sym_EQ_EQ] = ACTIONS(2233),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2231),
    [anon_sym_BANG_EQ] = ACTIONS(2233),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2231),
    [anon_sym_GT_EQ] = ACTIONS(2231),
    [anon_sym_instanceof] = ACTIONS(2231),
    [anon_sym_PLUS_PLUS] = ACTIONS(2231),
    [anon_sym_DASH_DASH] = ACTIONS(2231),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2231),
  },
  [877] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [878] = {
    [anon_sym_LBRACE] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(78),
  },
  [879] = {
    [anon_sym_export] = ACTIONS(2243),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_RBRACK] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2243),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_SLASH] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2243),
    [anon_sym_class] = ACTIONS(2243),
    [anon_sym_async] = ACTIONS(2243),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_GT_GT_GT] = ACTIONS(2241),
    [anon_sym_LT_LT] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_instanceof] = ACTIONS(2243),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [anon_sym_DQUOTE] = ACTIONS(2241),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2241),
    [sym_number] = ACTIONS(2241),
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_AT] = ACTIONS(2241),
    [anon_sym_static] = ACTIONS(2243),
    [anon_sym_get] = ACTIONS(2243),
    [anon_sym_set] = ACTIONS(2243),
  },
  [880] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [aux_sym_array_repeat1] = STATE(1248),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2811),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [881] = {
    [aux_sym_array_repeat1] = STATE(1248),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2811),
    [sym_comment] = ACTIONS(78),
  },
  [882] = {
    [aux_sym_array_repeat1] = STATE(998),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(2811),
    [sym_comment] = ACTIONS(78),
  },
  [883] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [884] = {
    [anon_sym_RBRACK] = ACTIONS(2813),
    [sym_comment] = ACTIONS(78),
  },
  [885] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2225),
    [anon_sym_GT_GT_GT] = ACTIONS(2223),
    [anon_sym_LT_LT] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2223),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [886] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [887] = {
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_RPAREN] = ACTIONS(2261),
    [anon_sym_COLON] = ACTIONS(2261),
    [anon_sym_RBRACK] = ACTIONS(2261),
    [sym_comment] = ACTIONS(78),
  },
  [888] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [889] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [890] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [891] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [892] = {
    [anon_sym_LBRACE] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(2817),
    [sym_comment] = ACTIONS(78),
  },
  [893] = {
    [anon_sym_LBRACE] = ACTIONS(2819),
    [anon_sym_EQ_GT] = ACTIONS(2819),
    [sym_comment] = ACTIONS(78),
  },
  [894] = {
    [sym_nested_identifier] = STATE(1253),
    [sym_jsx_namespace_name] = STATE(1254),
    [sym_jsx_identifier] = ACTIONS(2821),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2823),
  },
  [895] = {
    [anon_sym_STAR] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_RBRACE] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2349),
    [anon_sym_GT] = ACTIONS(2349),
    [anon_sym_SLASH] = ACTIONS(2349),
    [anon_sym_DOT] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2349),
    [anon_sym_GT_GT_GT] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2349),
    [anon_sym_DASH] = ACTIONS(2349),
    [anon_sym_PERCENT] = ACTIONS(2347),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2347),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2347),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_instanceof] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2347),
  },
  [896] = {
    [sym_class_heritage] = STATE(1255),
    [sym_class_body] = STATE(1237),
    [anon_sym_LBRACE] = ACTIONS(717),
    [anon_sym_extends] = ACTIONS(1023),
    [sym_comment] = ACTIONS(78),
  },
  [897] = {
    [sym_class_body] = STATE(1256),
    [anon_sym_LBRACE] = ACTIONS(717),
    [sym_comment] = ACTIONS(78),
  },
  [898] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2825),
  },
  [899] = {
    [sym_parenthesized_expression] = STATE(1257),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [900] = {
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_await] = ACTIONS(2829),
    [sym_comment] = ACTIONS(78),
  },
  [901] = {
    [sym_parenthesized_expression] = STATE(1260),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [902] = {
    [sym_parenthesized_expression] = STATE(1261),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [903] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [904] = {
    [anon_sym_else] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(1722),
    [sym_comment] = ACTIONS(78),
  },
  [905] = {
    [sym_variable_declarator] = STATE(93),
    [sym_object] = STATE(1265),
    [sym_array] = STATE(1266),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2835),
  },
  [906] = {
    [sym_variable_declarator] = STATE(96),
    [sym_object] = STATE(1265),
    [sym_array] = STATE(1266),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2835),
  },
  [907] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_of] = ACTIONS(2839),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [908] = {
    [sym_expression_statement] = STATE(1269),
    [sym_empty_statement] = STATE(1269),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [909] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2841),
    [anon_sym_of] = ACTIONS(2843),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [910] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(2845),
    [anon_sym_of] = ACTIONS(2847),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [911] = {
    [sym_object] = STATE(1276),
    [sym_array] = STATE(1277),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_var] = ACTIONS(2849),
    [anon_sym_let] = ACTIONS(2849),
    [anon_sym_const] = ACTIONS(2849),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2851),
  },
  [912] = {
    [sym_parenthesized_expression] = STATE(124),
    [sym__expression] = STATE(124),
    [sym_yield_expression] = STATE(124),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(124),
    [sym_jsx_fragment] = STATE(124),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(124),
    [sym_anonymous_class] = STATE(124),
    [sym_class] = STATE(124),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(124),
    [sym_generator_function] = STATE(124),
    [sym_call_expression] = STATE(124),
    [sym_new_expression] = STATE(124),
    [sym_await_expression] = STATE(124),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(124),
    [sym_augmented_assignment_expression] = STATE(124),
    [sym_ternary_expression] = STATE(124),
    [sym_binary_expression] = STATE(124),
    [sym_unary_expression] = STATE(124),
    [sym_update_expression] = STATE(124),
    [sym_sequence_expression] = STATE(131),
    [sym_string] = STATE(124),
    [sym_template_string] = STATE(124),
    [sym_regex] = STATE(124),
    [sym_meta_property] = STATE(124),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(196),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(200),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(200),
    [sym_false] = ACTIONS(200),
    [sym_null] = ACTIONS(200),
    [sym_undefined] = ACTIONS(200),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [913] = {
    [sym__automatic_semicolon] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2853),
    [sym_comment] = ACTIONS(78),
  },
  [914] = {
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2855),
  },
  [915] = {
    [ts_builtin_sym_end] = ACTIONS(2857),
    [anon_sym_export] = ACTIONS(2859),
    [anon_sym_default] = ACTIONS(2859),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_RBRACE] = ACTIONS(2857),
    [anon_sym_import] = ACTIONS(2859),
    [anon_sym_var] = ACTIONS(2859),
    [anon_sym_let] = ACTIONS(2859),
    [anon_sym_const] = ACTIONS(2859),
    [anon_sym_if] = ACTIONS(2859),
    [anon_sym_else] = ACTIONS(2859),
    [anon_sym_switch] = ACTIONS(2859),
    [anon_sym_for] = ACTIONS(2859),
    [anon_sym_LPAREN] = ACTIONS(2857),
    [anon_sym_await] = ACTIONS(2859),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_do] = ACTIONS(2859),
    [anon_sym_try] = ACTIONS(2859),
    [anon_sym_with] = ACTIONS(2859),
    [anon_sym_break] = ACTIONS(2859),
    [anon_sym_continue] = ACTIONS(2859),
    [anon_sym_debugger] = ACTIONS(2859),
    [anon_sym_return] = ACTIONS(2859),
    [anon_sym_throw] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_case] = ACTIONS(2859),
    [anon_sym_finally] = ACTIONS(2859),
    [anon_sym_yield] = ACTIONS(2859),
    [anon_sym_LBRACK] = ACTIONS(2857),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_SLASH] = ACTIONS(2859),
    [anon_sym_class] = ACTIONS(2859),
    [anon_sym_async] = ACTIONS(2859),
    [anon_sym_function] = ACTIONS(2859),
    [anon_sym_EQ_GT] = ACTIONS(2857),
    [anon_sym_new] = ACTIONS(2859),
    [anon_sym_PLUS] = ACTIONS(2859),
    [anon_sym_DASH] = ACTIONS(2859),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_TILDE] = ACTIONS(2857),
    [anon_sym_typeof] = ACTIONS(2859),
    [anon_sym_void] = ACTIONS(2859),
    [anon_sym_delete] = ACTIONS(2859),
    [anon_sym_PLUS_PLUS] = ACTIONS(2857),
    [anon_sym_DASH_DASH] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2857),
    [anon_sym_SQUOTE] = ACTIONS(2857),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2857),
    [sym_number] = ACTIONS(2857),
    [sym_identifier] = ACTIONS(2859),
    [sym_this] = ACTIONS(2859),
    [sym_super] = ACTIONS(2859),
    [sym_true] = ACTIONS(2859),
    [sym_false] = ACTIONS(2859),
    [sym_null] = ACTIONS(2859),
    [sym_undefined] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(2857),
    [anon_sym_get] = ACTIONS(2859),
    [anon_sym_set] = ACTIONS(2859),
  },
  [916] = {
    [ts_builtin_sym_end] = ACTIONS(2861),
    [anon_sym_export] = ACTIONS(2863),
    [anon_sym_default] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2861),
    [anon_sym_RBRACE] = ACTIONS(2861),
    [anon_sym_import] = ACTIONS(2863),
    [anon_sym_var] = ACTIONS(2863),
    [anon_sym_let] = ACTIONS(2863),
    [anon_sym_const] = ACTIONS(2863),
    [anon_sym_if] = ACTIONS(2863),
    [anon_sym_else] = ACTIONS(2863),
    [anon_sym_switch] = ACTIONS(2863),
    [anon_sym_for] = ACTIONS(2863),
    [anon_sym_LPAREN] = ACTIONS(2861),
    [anon_sym_await] = ACTIONS(2863),
    [anon_sym_while] = ACTIONS(2863),
    [anon_sym_do] = ACTIONS(2863),
    [anon_sym_try] = ACTIONS(2863),
    [anon_sym_with] = ACTIONS(2863),
    [anon_sym_break] = ACTIONS(2863),
    [anon_sym_continue] = ACTIONS(2863),
    [anon_sym_debugger] = ACTIONS(2863),
    [anon_sym_return] = ACTIONS(2863),
    [anon_sym_throw] = ACTIONS(2863),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym_case] = ACTIONS(2863),
    [anon_sym_yield] = ACTIONS(2863),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_SLASH] = ACTIONS(2863),
    [anon_sym_class] = ACTIONS(2863),
    [anon_sym_async] = ACTIONS(2863),
    [anon_sym_function] = ACTIONS(2863),
    [anon_sym_EQ_GT] = ACTIONS(2861),
    [anon_sym_new] = ACTIONS(2863),
    [anon_sym_PLUS] = ACTIONS(2863),
    [anon_sym_DASH] = ACTIONS(2863),
    [anon_sym_BANG] = ACTIONS(2861),
    [anon_sym_TILDE] = ACTIONS(2861),
    [anon_sym_typeof] = ACTIONS(2863),
    [anon_sym_void] = ACTIONS(2863),
    [anon_sym_delete] = ACTIONS(2863),
    [anon_sym_PLUS_PLUS] = ACTIONS(2861),
    [anon_sym_DASH_DASH] = ACTIONS(2861),
    [anon_sym_DQUOTE] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2861),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2861),
    [sym_number] = ACTIONS(2861),
    [sym_identifier] = ACTIONS(2863),
    [sym_this] = ACTIONS(2863),
    [sym_super] = ACTIONS(2863),
    [sym_true] = ACTIONS(2863),
    [sym_false] = ACTIONS(2863),
    [sym_null] = ACTIONS(2863),
    [sym_undefined] = ACTIONS(2863),
    [anon_sym_AT] = ACTIONS(2861),
    [anon_sym_get] = ACTIONS(2863),
    [anon_sym_set] = ACTIONS(2863),
  },
  [917] = {
    [ts_builtin_sym_end] = ACTIONS(2865),
    [anon_sym_export] = ACTIONS(2867),
    [anon_sym_default] = ACTIONS(2867),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_import] = ACTIONS(2867),
    [anon_sym_var] = ACTIONS(2867),
    [anon_sym_let] = ACTIONS(2867),
    [anon_sym_const] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2867),
    [anon_sym_else] = ACTIONS(2867),
    [anon_sym_switch] = ACTIONS(2867),
    [anon_sym_for] = ACTIONS(2867),
    [anon_sym_LPAREN] = ACTIONS(2865),
    [anon_sym_await] = ACTIONS(2867),
    [anon_sym_while] = ACTIONS(2867),
    [anon_sym_do] = ACTIONS(2867),
    [anon_sym_try] = ACTIONS(2867),
    [anon_sym_with] = ACTIONS(2867),
    [anon_sym_break] = ACTIONS(2867),
    [anon_sym_continue] = ACTIONS(2867),
    [anon_sym_debugger] = ACTIONS(2867),
    [anon_sym_return] = ACTIONS(2867),
    [anon_sym_throw] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym_case] = ACTIONS(2867),
    [anon_sym_yield] = ACTIONS(2867),
    [anon_sym_LBRACK] = ACTIONS(2865),
    [anon_sym_LT] = ACTIONS(2865),
    [anon_sym_SLASH] = ACTIONS(2867),
    [anon_sym_class] = ACTIONS(2867),
    [anon_sym_async] = ACTIONS(2867),
    [anon_sym_function] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(2865),
    [anon_sym_new] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2867),
    [anon_sym_DASH] = ACTIONS(2867),
    [anon_sym_BANG] = ACTIONS(2865),
    [anon_sym_TILDE] = ACTIONS(2865),
    [anon_sym_typeof] = ACTIONS(2867),
    [anon_sym_void] = ACTIONS(2867),
    [anon_sym_delete] = ACTIONS(2867),
    [anon_sym_PLUS_PLUS] = ACTIONS(2865),
    [anon_sym_DASH_DASH] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(2865),
    [anon_sym_SQUOTE] = ACTIONS(2865),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2865),
    [sym_number] = ACTIONS(2865),
    [sym_identifier] = ACTIONS(2867),
    [sym_this] = ACTIONS(2867),
    [sym_super] = ACTIONS(2867),
    [sym_true] = ACTIONS(2867),
    [sym_false] = ACTIONS(2867),
    [sym_null] = ACTIONS(2867),
    [sym_undefined] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2865),
    [anon_sym_get] = ACTIONS(2867),
    [anon_sym_set] = ACTIONS(2867),
  },
  [918] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [919] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [920] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2135),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [921] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1280),
    [sym__expression] = STATE(1280),
    [sym_yield_expression] = STATE(1280),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(1280),
    [sym_jsx_fragment] = STATE(1280),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1280),
    [sym_anonymous_class] = STATE(1280),
    [sym_class] = STATE(1280),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1280),
    [sym_generator_function] = STATE(1280),
    [sym_call_expression] = STATE(1280),
    [sym_new_expression] = STATE(1280),
    [sym_await_expression] = STATE(1280),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(1280),
    [sym_augmented_assignment_expression] = STATE(1280),
    [sym_ternary_expression] = STATE(1280),
    [sym_binary_expression] = STATE(1280),
    [sym_unary_expression] = STATE(1280),
    [sym_update_expression] = STATE(1280),
    [sym_string] = STATE(1280),
    [sym_template_string] = STATE(1280),
    [sym_regex] = STATE(1280),
    [sym_meta_property] = STATE(1280),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2869),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(2871),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2871),
    [sym_false] = ACTIONS(2871),
    [sym_null] = ACTIONS(2871),
    [sym_undefined] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [922] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [923] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [924] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2873),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [925] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [926] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [927] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [928] = {
    [sym__automatic_semicolon] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_in] = ACTIONS(2877),
    [anon_sym_of] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_EQ] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2875),
    [anon_sym_instanceof] = ACTIONS(2875),
    [anon_sym_PLUS_PLUS] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2875),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2875),
  },
  [929] = {
    [anon_sym_GT] = ACTIONS(2879),
    [sym_comment] = ACTIONS(78),
  },
  [930] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(2881),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [931] = {
    [anon_sym_LBRACE] = ACTIONS(2883),
    [anon_sym_GT] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2311),
    [sym_jsx_identifier] = ACTIONS(2883),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2311),
  },
  [932] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [933] = {
    [anon_sym_RBRACE] = ACTIONS(2885),
    [sym_comment] = ACTIONS(78),
  },
  [934] = {
    [anon_sym_LBRACE] = ACTIONS(2887),
    [anon_sym_GT] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(2889),
    [sym_jsx_identifier] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2887),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2889),
  },
  [935] = {
    [sym__automatic_semicolon] = ACTIONS(2891),
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_SEMI] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_GT_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_LT] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_LT_EQ] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2891),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_instanceof] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2891),
  },
  [936] = {
    [sym_jsx_element] = STATE(1288),
    [sym_jsx_fragment] = STATE(1288),
    [sym_jsx_expression] = STATE(1288),
    [sym_jsx_opening_element] = STATE(1289),
    [sym_jsx_self_closing_element] = STATE(1288),
    [sym_string] = STATE(1288),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(78),
  },
  [937] = {
    [sym_jsx_element] = STATE(1290),
    [sym_jsx_fragment] = STATE(1290),
    [sym_jsx_expression] = STATE(1290),
    [sym_jsx_opening_element] = STATE(1289),
    [sym_jsx_self_closing_element] = STATE(1290),
    [sym_string] = STATE(1290),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_LT] = ACTIONS(2895),
    [anon_sym_DQUOTE] = ACTIONS(2897),
    [anon_sym_SQUOTE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(78),
  },
  [938] = {
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2901),
    [sym_jsx_text] = ACTIONS(2901),
    [sym_comment] = ACTIONS(78),
  },
  [939] = {
    [anon_sym_GT] = ACTIONS(2903),
    [sym_comment] = ACTIONS(78),
  },
  [940] = {
    [sym_jsx_expression] = STATE(940),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(940),
    [aux_sym_jsx_opening_element_repeat1] = STATE(940),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2908),
    [anon_sym_SLASH] = ACTIONS(2910),
    [sym_jsx_identifier] = ACTIONS(2912),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2915),
  },
  [941] = {
    [anon_sym_LBRACE] = ACTIONS(2918),
    [anon_sym_GT] = ACTIONS(2918),
    [anon_sym_SLASH] = ACTIONS(2920),
    [sym_jsx_identifier] = ACTIONS(2918),
    [anon_sym_DOT] = ACTIONS(2918),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2920),
  },
  [942] = {
    [sym__automatic_semicolon] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2922),
    [anon_sym_RBRACE] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_RPAREN] = ACTIONS(2922),
    [anon_sym_in] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_GT] = ACTIONS(2924),
    [anon_sym_SLASH] = ACTIONS(2924),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2924),
    [anon_sym_GT_GT_GT] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_DASH] = ACTIONS(2924),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_LT_EQ] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2924),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2922),
    [anon_sym_GT_EQ] = ACTIONS(2922),
    [anon_sym_instanceof] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2922),
  },
  [943] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2926),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [944] = {
    [sym__automatic_semicolon] = ACTIONS(1121),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_SEMI] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(1121),
    [sym_comment] = ACTIONS(78),
  },
  [945] = {
    [aux_sym_string_repeat1] = STATE(612),
    [anon_sym_DQUOTE] = ACTIONS(2928),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(1127),
    [sym_escape_sequence] = ACTIONS(1127),
    [sym_comment] = ACTIONS(298),
  },
  [946] = {
    [aux_sym_string_repeat2] = STATE(613),
    [anon_sym_SQUOTE] = ACTIONS(2928),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(1129),
    [sym_escape_sequence] = ACTIONS(1129),
    [sym_comment] = ACTIONS(298),
  },
  [947] = {
    [sym__automatic_semicolon] = ACTIONS(2930),
    [anon_sym_SEMI] = ACTIONS(2930),
    [sym_comment] = ACTIONS(78),
  },
  [948] = {
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(2932),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_AT] = ACTIONS(2932),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_set] = ACTIONS(2934),
  },
  [949] = {
    [anon_sym_STAR] = ACTIONS(2932),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2932),
    [anon_sym_SQUOTE] = ACTIONS(2932),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(2932),
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_AT] = ACTIONS(2932),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_set] = ACTIONS(2934),
  },
  [950] = {
    [sym__automatic_semicolon] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [sym_comment] = ACTIONS(78),
  },
  [951] = {
    [sym_string] = STATE(552),
    [sym_public_field_definition] = STATE(1295),
    [sym_method_definition] = STATE(1296),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
  },
  [952] = {
    [sym_decorator] = STATE(952),
    [aux_sym_export_statement_repeat1] = STATE(952),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_async] = ACTIONS(1669),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_SQUOTE] = ACTIONS(1398),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1669),
    [anon_sym_AT] = ACTIONS(1400),
    [anon_sym_static] = ACTIONS(1669),
    [anon_sym_get] = ACTIONS(1669),
    [anon_sym_set] = ACTIONS(1669),
  },
  [953] = {
    [sym__automatic_semicolon] = ACTIONS(2938),
    [ts_builtin_sym_end] = ACTIONS(2938),
    [anon_sym_export] = ACTIONS(2940),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_default] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2938),
    [anon_sym_RBRACE] = ACTIONS(2938),
    [anon_sym_import] = ACTIONS(2940),
    [anon_sym_var] = ACTIONS(2940),
    [anon_sym_let] = ACTIONS(2940),
    [anon_sym_const] = ACTIONS(2940),
    [anon_sym_if] = ACTIONS(2940),
    [anon_sym_else] = ACTIONS(2940),
    [anon_sym_switch] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_RPAREN] = ACTIONS(2938),
    [anon_sym_in] = ACTIONS(2940),
    [anon_sym_await] = ACTIONS(2940),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_do] = ACTIONS(2940),
    [anon_sym_try] = ACTIONS(2940),
    [anon_sym_with] = ACTIONS(2940),
    [anon_sym_break] = ACTIONS(2940),
    [anon_sym_continue] = ACTIONS(2940),
    [anon_sym_debugger] = ACTIONS(2940),
    [anon_sym_return] = ACTIONS(2940),
    [anon_sym_throw] = ACTIONS(2940),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_case] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2940),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_GT] = ACTIONS(2940),
    [anon_sym_SLASH] = ACTIONS(2940),
    [anon_sym_DOT] = ACTIONS(2940),
    [anon_sym_class] = ACTIONS(2940),
    [anon_sym_async] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2940),
    [anon_sym_EQ_GT] = ACTIONS(2938),
    [anon_sym_new] = ACTIONS(2940),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_GT_GT] = ACTIONS(2940),
    [anon_sym_GT_GT_GT] = ACTIONS(2938),
    [anon_sym_LT_LT] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2940),
    [anon_sym_CARET] = ACTIONS(2938),
    [anon_sym_PIPE] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2940),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_LT_EQ] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2940),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2940),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2938),
    [anon_sym_instanceof] = ACTIONS(2940),
    [anon_sym_BANG] = ACTIONS(2940),
    [anon_sym_TILDE] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(2940),
    [anon_sym_void] = ACTIONS(2940),
    [anon_sym_delete] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_SQUOTE] = ACTIONS(2938),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2938),
    [sym_number] = ACTIONS(2938),
    [sym_identifier] = ACTIONS(2940),
    [sym_this] = ACTIONS(2940),
    [sym_super] = ACTIONS(2940),
    [sym_true] = ACTIONS(2940),
    [sym_false] = ACTIONS(2940),
    [sym_null] = ACTIONS(2940),
    [sym_undefined] = ACTIONS(2940),
    [anon_sym_AT] = ACTIONS(2938),
    [anon_sym_get] = ACTIONS(2940),
    [anon_sym_set] = ACTIONS(2940),
  },
  [954] = {
    [sym_string] = STATE(552),
    [sym_decorator] = STATE(553),
    [sym_public_field_definition] = STATE(550),
    [sym_method_definition] = STATE(551),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [aux_sym_export_statement_repeat1] = STATE(553),
    [aux_sym_class_body_repeat1] = STATE(954),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2945),
    [anon_sym_async] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2954),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(2957),
    [sym_identifier] = ACTIONS(2960),
    [anon_sym_AT] = ACTIONS(2963),
    [anon_sym_static] = ACTIONS(2966),
    [anon_sym_get] = ACTIONS(2969),
    [anon_sym_set] = ACTIONS(2969),
  },
  [955] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [956] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [957] = {
    [sym_parenthesized_expression] = STATE(1297),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1297),
    [sym_jsx_fragment] = STATE(1297),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1297),
    [sym_anonymous_class] = STATE(1297),
    [sym_class] = STATE(1297),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1297),
    [sym_generator_function] = STATE(1297),
    [sym_call_expression] = STATE(1297),
    [sym_new_expression] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_string] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2972),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(2974),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2974),
    [sym_false] = ACTIONS(2974),
    [sym_null] = ACTIONS(2974),
    [sym_undefined] = ACTIONS(2974),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [958] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(1298),
    [sym__expression] = STATE(1298),
    [sym_yield_expression] = STATE(1298),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1298),
    [sym_jsx_fragment] = STATE(1298),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1298),
    [sym_anonymous_class] = STATE(1298),
    [sym_class] = STATE(1298),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1298),
    [sym_generator_function] = STATE(1298),
    [sym_call_expression] = STATE(1298),
    [sym_new_expression] = STATE(1298),
    [sym_await_expression] = STATE(1298),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1298),
    [sym_augmented_assignment_expression] = STATE(1298),
    [sym_ternary_expression] = STATE(1298),
    [sym_binary_expression] = STATE(1298),
    [sym_unary_expression] = STATE(1298),
    [sym_update_expression] = STATE(1298),
    [sym_string] = STATE(1298),
    [sym_template_string] = STATE(1298),
    [sym_regex] = STATE(1298),
    [sym_meta_property] = STATE(1298),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2976),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(2978),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2978),
    [sym_false] = ACTIONS(2978),
    [sym_null] = ACTIONS(2978),
    [sym_undefined] = ACTIONS(2978),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [959] = {
    [sym_parenthesized_expression] = STATE(1299),
    [sym__expression] = STATE(1299),
    [sym_yield_expression] = STATE(1299),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1299),
    [sym_jsx_fragment] = STATE(1299),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1299),
    [sym_anonymous_class] = STATE(1299),
    [sym_class] = STATE(1299),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1299),
    [sym_generator_function] = STATE(1299),
    [sym_call_expression] = STATE(1299),
    [sym_new_expression] = STATE(1299),
    [sym_await_expression] = STATE(1299),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1299),
    [sym_augmented_assignment_expression] = STATE(1299),
    [sym_ternary_expression] = STATE(1299),
    [sym_binary_expression] = STATE(1299),
    [sym_unary_expression] = STATE(1299),
    [sym_update_expression] = STATE(1299),
    [sym_string] = STATE(1299),
    [sym_template_string] = STATE(1299),
    [sym_regex] = STATE(1299),
    [sym_meta_property] = STATE(1299),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2980),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(2982),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2982),
    [sym_false] = ACTIONS(2982),
    [sym_null] = ACTIONS(2982),
    [sym_undefined] = ACTIONS(2982),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [960] = {
    [anon_sym_EQ_GT] = ACTIONS(2984),
    [sym_comment] = ACTIONS(78),
  },
  [961] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [962] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(960),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(2067),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(2071),
  },
  [963] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(2067),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [964] = {
    [sym_parenthesized_expression] = STATE(1301),
    [sym__expression] = STATE(1301),
    [sym_yield_expression] = STATE(1301),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1301),
    [sym_jsx_fragment] = STATE(1301),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1301),
    [sym_anonymous_class] = STATE(1301),
    [sym_class] = STATE(1301),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1301),
    [sym_generator_function] = STATE(1301),
    [sym_call_expression] = STATE(1301),
    [sym_new_expression] = STATE(1301),
    [sym_await_expression] = STATE(1301),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1301),
    [sym_augmented_assignment_expression] = STATE(1301),
    [sym_ternary_expression] = STATE(1301),
    [sym_binary_expression] = STATE(1301),
    [sym_unary_expression] = STATE(1301),
    [sym_update_expression] = STATE(1301),
    [sym_string] = STATE(1301),
    [sym_template_string] = STATE(1301),
    [sym_regex] = STATE(1301),
    [sym_meta_property] = STATE(1301),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2986),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(2988),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2988),
    [sym_false] = ACTIONS(2988),
    [sym_null] = ACTIONS(2988),
    [sym_undefined] = ACTIONS(2988),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [965] = {
    [sym_parenthesized_expression] = STATE(1302),
    [sym__expression] = STATE(1302),
    [sym_yield_expression] = STATE(1302),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1302),
    [sym_jsx_fragment] = STATE(1302),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1302),
    [sym_anonymous_class] = STATE(1302),
    [sym_class] = STATE(1302),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1302),
    [sym_generator_function] = STATE(1302),
    [sym_call_expression] = STATE(1302),
    [sym_new_expression] = STATE(1302),
    [sym_await_expression] = STATE(1302),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1302),
    [sym_augmented_assignment_expression] = STATE(1302),
    [sym_ternary_expression] = STATE(1302),
    [sym_binary_expression] = STATE(1302),
    [sym_unary_expression] = STATE(1302),
    [sym_update_expression] = STATE(1302),
    [sym_string] = STATE(1302),
    [sym_template_string] = STATE(1302),
    [sym_regex] = STATE(1302),
    [sym_meta_property] = STATE(1302),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2990),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(2992),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2992),
    [sym_false] = ACTIONS(2992),
    [sym_null] = ACTIONS(2992),
    [sym_undefined] = ACTIONS(2992),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [966] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [967] = {
    [sym_parenthesized_expression] = STATE(1303),
    [sym__expression] = STATE(1303),
    [sym_yield_expression] = STATE(1303),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1303),
    [sym_jsx_fragment] = STATE(1303),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1303),
    [sym_anonymous_class] = STATE(1303),
    [sym_class] = STATE(1303),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1303),
    [sym_generator_function] = STATE(1303),
    [sym_call_expression] = STATE(1303),
    [sym_new_expression] = STATE(1303),
    [sym_await_expression] = STATE(1303),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1303),
    [sym_augmented_assignment_expression] = STATE(1303),
    [sym_ternary_expression] = STATE(1303),
    [sym_binary_expression] = STATE(1303),
    [sym_unary_expression] = STATE(1303),
    [sym_update_expression] = STATE(1303),
    [sym_string] = STATE(1303),
    [sym_template_string] = STATE(1303),
    [sym_regex] = STATE(1303),
    [sym_meta_property] = STATE(1303),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2994),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(2996),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2996),
    [sym_false] = ACTIONS(2996),
    [sym_null] = ACTIONS(2996),
    [sym_undefined] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [968] = {
    [sym_parenthesized_expression] = STATE(1304),
    [sym__expression] = STATE(1304),
    [sym_yield_expression] = STATE(1304),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1304),
    [sym_jsx_fragment] = STATE(1304),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1304),
    [sym_anonymous_class] = STATE(1304),
    [sym_class] = STATE(1304),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1304),
    [sym_generator_function] = STATE(1304),
    [sym_call_expression] = STATE(1304),
    [sym_new_expression] = STATE(1304),
    [sym_await_expression] = STATE(1304),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1304),
    [sym_augmented_assignment_expression] = STATE(1304),
    [sym_ternary_expression] = STATE(1304),
    [sym_binary_expression] = STATE(1304),
    [sym_unary_expression] = STATE(1304),
    [sym_update_expression] = STATE(1304),
    [sym_string] = STATE(1304),
    [sym_template_string] = STATE(1304),
    [sym_regex] = STATE(1304),
    [sym_meta_property] = STATE(1304),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2998),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(3000),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3000),
    [sym_false] = ACTIONS(3000),
    [sym_null] = ACTIONS(3000),
    [sym_undefined] = ACTIONS(3000),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [969] = {
    [sym_parenthesized_expression] = STATE(1305),
    [sym__expression] = STATE(1305),
    [sym_yield_expression] = STATE(1305),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1305),
    [sym_jsx_fragment] = STATE(1305),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1305),
    [sym_anonymous_class] = STATE(1305),
    [sym_class] = STATE(1305),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1305),
    [sym_generator_function] = STATE(1305),
    [sym_call_expression] = STATE(1305),
    [sym_new_expression] = STATE(1305),
    [sym_await_expression] = STATE(1305),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1305),
    [sym_augmented_assignment_expression] = STATE(1305),
    [sym_ternary_expression] = STATE(1305),
    [sym_binary_expression] = STATE(1305),
    [sym_unary_expression] = STATE(1305),
    [sym_update_expression] = STATE(1305),
    [sym_string] = STATE(1305),
    [sym_template_string] = STATE(1305),
    [sym_regex] = STATE(1305),
    [sym_meta_property] = STATE(1305),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3002),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(3004),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3004),
    [sym_false] = ACTIONS(3004),
    [sym_null] = ACTIONS(3004),
    [sym_undefined] = ACTIONS(3004),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [970] = {
    [sym_parenthesized_expression] = STATE(1306),
    [sym__expression] = STATE(1306),
    [sym_yield_expression] = STATE(1306),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1306),
    [sym_jsx_fragment] = STATE(1306),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1306),
    [sym_anonymous_class] = STATE(1306),
    [sym_class] = STATE(1306),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1306),
    [sym_generator_function] = STATE(1306),
    [sym_call_expression] = STATE(1306),
    [sym_new_expression] = STATE(1306),
    [sym_await_expression] = STATE(1306),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1306),
    [sym_augmented_assignment_expression] = STATE(1306),
    [sym_ternary_expression] = STATE(1306),
    [sym_binary_expression] = STATE(1306),
    [sym_unary_expression] = STATE(1306),
    [sym_update_expression] = STATE(1306),
    [sym_string] = STATE(1306),
    [sym_template_string] = STATE(1306),
    [sym_regex] = STATE(1306),
    [sym_meta_property] = STATE(1306),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3006),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(3008),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3008),
    [sym_false] = ACTIONS(3008),
    [sym_null] = ACTIONS(3008),
    [sym_undefined] = ACTIONS(3008),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [971] = {
    [sym__automatic_semicolon] = ACTIONS(3010),
    [ts_builtin_sym_end] = ACTIONS(3010),
    [anon_sym_export] = ACTIONS(3012),
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_import] = ACTIONS(3012),
    [anon_sym_var] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_else] = ACTIONS(3012),
    [anon_sym_switch] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_RPAREN] = ACTIONS(3010),
    [anon_sym_in] = ACTIONS(3012),
    [anon_sym_await] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_break] = ACTIONS(3012),
    [anon_sym_continue] = ACTIONS(3012),
    [anon_sym_debugger] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_throw] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3012),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_class] = ACTIONS(3012),
    [anon_sym_async] = ACTIONS(3012),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_EQ_GT] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_PIPE_PIPE] = ACTIONS(3010),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_GT_GT_GT] = ACTIONS(3010),
    [anon_sym_LT_LT] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3010),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3010),
    [anon_sym_LT_EQ] = ACTIONS(3010),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3010),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3010),
    [anon_sym_GT_EQ] = ACTIONS(3010),
    [anon_sym_instanceof] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3012),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_typeof] = ACTIONS(3012),
    [anon_sym_void] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3010),
    [sym_number] = ACTIONS(3010),
    [sym_identifier] = ACTIONS(3012),
    [sym_this] = ACTIONS(3012),
    [sym_super] = ACTIONS(3012),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [sym_null] = ACTIONS(3012),
    [sym_undefined] = ACTIONS(3012),
    [anon_sym_AT] = ACTIONS(3010),
    [anon_sym_get] = ACTIONS(3012),
    [anon_sym_set] = ACTIONS(3012),
  },
  [972] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [aux_sym_array_repeat1] = STATE(1095),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [973] = {
    [sym_statement_block] = STATE(1307),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(78),
  },
  [974] = {
    [sym__automatic_semicolon] = ACTIONS(3014),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_import] = ACTIONS(3016),
    [anon_sym_var] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_else] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3016),
    [anon_sym_await] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_with] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_debugger] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_yield] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3016),
    [anon_sym_GT] = ACTIONS(3016),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_DOT] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(3016),
    [anon_sym_EQ_GT] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_QMARK] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3016),
    [anon_sym_GT_GT_GT] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3016),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3014),
    [anon_sym_instanceof] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_typeof] = ACTIONS(3016),
    [anon_sym_void] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [sym_number] = ACTIONS(3014),
    [sym_identifier] = ACTIONS(3016),
    [sym_this] = ACTIONS(3016),
    [sym_super] = ACTIONS(3016),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [sym_null] = ACTIONS(3016),
    [sym_undefined] = ACTIONS(3016),
    [anon_sym_AT] = ACTIONS(3014),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
  },
  [975] = {
    [sym__automatic_semicolon] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3020),
    [anon_sym_GT] = ACTIONS(3020),
    [anon_sym_SLASH] = ACTIONS(3020),
    [anon_sym_DOT] = ACTIONS(3018),
    [anon_sym_QMARK] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE] = ACTIONS(3018),
    [anon_sym_GT_GT] = ACTIONS(3020),
    [anon_sym_GT_GT_GT] = ACTIONS(3018),
    [anon_sym_LT_LT] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_CARET] = ACTIONS(3018),
    [anon_sym_PIPE] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PERCENT] = ACTIONS(3018),
    [anon_sym_LT_EQ] = ACTIONS(3018),
    [anon_sym_EQ_EQ] = ACTIONS(3020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3018),
    [anon_sym_BANG_EQ] = ACTIONS(3020),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3018),
    [anon_sym_GT_EQ] = ACTIONS(3018),
    [anon_sym_instanceof] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3018),
  },
  [976] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [977] = {
    [sym_statement_block] = STATE(1308),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(78),
  },
  [978] = {
    [sym__automatic_semicolon] = ACTIONS(3022),
    [ts_builtin_sym_end] = ACTIONS(3022),
    [anon_sym_export] = ACTIONS(3024),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_import] = ACTIONS(3024),
    [anon_sym_var] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_else] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3022),
    [anon_sym_RPAREN] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3024),
    [anon_sym_await] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_debugger] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3024),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_async] = ACTIONS(3024),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_EQ_GT] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_QMARK] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_PIPE_PIPE] = ACTIONS(3022),
    [anon_sym_GT_GT] = ACTIONS(3024),
    [anon_sym_GT_GT_GT] = ACTIONS(3022),
    [anon_sym_LT_LT] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_CARET] = ACTIONS(3022),
    [anon_sym_PIPE] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3022),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_EQ_EQ] = ACTIONS(3024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3022),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3022),
    [anon_sym_instanceof] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3024),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_typeof] = ACTIONS(3024),
    [anon_sym_void] = ACTIONS(3024),
    [anon_sym_delete] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3022),
    [sym_number] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3024),
    [sym_this] = ACTIONS(3024),
    [sym_super] = ACTIONS(3024),
    [sym_true] = ACTIONS(3024),
    [sym_false] = ACTIONS(3024),
    [sym_null] = ACTIONS(3024),
    [sym_undefined] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(3022),
    [anon_sym_get] = ACTIONS(3024),
    [anon_sym_set] = ACTIONS(3024),
  },
  [979] = {
    [sym__automatic_semicolon] = ACTIONS(517),
    [ts_builtin_sym_end] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_default] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_import] = ACTIONS(519),
    [anon_sym_var] = ACTIONS(519),
    [anon_sym_let] = ACTIONS(519),
    [anon_sym_const] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(519),
    [anon_sym_else] = ACTIONS(519),
    [anon_sym_switch] = ACTIONS(519),
    [anon_sym_for] = ACTIONS(519),
    [anon_sym_LPAREN] = ACTIONS(517),
    [anon_sym_RPAREN] = ACTIONS(517),
    [anon_sym_in] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(519),
    [anon_sym_while] = ACTIONS(519),
    [anon_sym_do] = ACTIONS(519),
    [anon_sym_try] = ACTIONS(519),
    [anon_sym_with] = ACTIONS(519),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(519),
    [anon_sym_debugger] = ACTIONS(519),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_throw] = ACTIONS(519),
    [anon_sym_SEMI] = ACTIONS(517),
    [anon_sym_case] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_SLASH] = ACTIONS(519),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_PIPE_PIPE] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(519),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(519),
    [anon_sym_DASH] = ACTIONS(519),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ] = ACTIONS(519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ] = ACTIONS(519),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(517),
    [anon_sym_GT_EQ] = ACTIONS(517),
    [anon_sym_instanceof] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_TILDE] = ACTIONS(517),
    [anon_sym_typeof] = ACTIONS(519),
    [anon_sym_void] = ACTIONS(519),
    [anon_sym_delete] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(517),
    [anon_sym_DASH_DASH] = ACTIONS(517),
    [anon_sym_DQUOTE] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(517),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [sym_number] = ACTIONS(517),
    [sym_identifier] = ACTIONS(519),
    [sym_this] = ACTIONS(519),
    [sym_super] = ACTIONS(519),
    [sym_true] = ACTIONS(519),
    [sym_false] = ACTIONS(519),
    [sym_null] = ACTIONS(519),
    [sym_undefined] = ACTIONS(519),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
  },
  [980] = {
    [sym__automatic_semicolon] = ACTIONS(1648),
    [ts_builtin_sym_end] = ACTIONS(1648),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_STAR] = ACTIONS(1648),
    [anon_sym_default] = ACTIONS(1650),
    [anon_sym_LBRACE] = ACTIONS(1648),
    [anon_sym_COMMA] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_import] = ACTIONS(1650),
    [anon_sym_var] = ACTIONS(1650),
    [anon_sym_let] = ACTIONS(1650),
    [anon_sym_const] = ACTIONS(1650),
    [anon_sym_if] = ACTIONS(1650),
    [anon_sym_else] = ACTIONS(1650),
    [anon_sym_switch] = ACTIONS(1650),
    [anon_sym_for] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1648),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_in] = ACTIONS(1650),
    [anon_sym_await] = ACTIONS(1650),
    [anon_sym_while] = ACTIONS(1650),
    [anon_sym_do] = ACTIONS(1650),
    [anon_sym_try] = ACTIONS(1650),
    [anon_sym_with] = ACTIONS(1650),
    [anon_sym_break] = ACTIONS(1650),
    [anon_sym_continue] = ACTIONS(1650),
    [anon_sym_debugger] = ACTIONS(1650),
    [anon_sym_return] = ACTIONS(1650),
    [anon_sym_throw] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1650),
    [anon_sym_yield] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(1650),
    [anon_sym_GT] = ACTIONS(1650),
    [anon_sym_SLASH] = ACTIONS(1650),
    [anon_sym_DOT] = ACTIONS(1650),
    [anon_sym_class] = ACTIONS(1650),
    [anon_sym_async] = ACTIONS(1650),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1648),
    [anon_sym_new] = ACTIONS(1650),
    [anon_sym_QMARK] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_GT_GT] = ACTIONS(1650),
    [anon_sym_GT_GT_GT] = ACTIONS(1648),
    [anon_sym_LT_LT] = ACTIONS(1648),
    [anon_sym_AMP] = ACTIONS(1650),
    [anon_sym_CARET] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_PERCENT] = ACTIONS(1648),
    [anon_sym_LT_EQ] = ACTIONS(1648),
    [anon_sym_EQ_EQ] = ACTIONS(1650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1648),
    [anon_sym_BANG_EQ] = ACTIONS(1650),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1648),
    [anon_sym_GT_EQ] = ACTIONS(1648),
    [anon_sym_instanceof] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1650),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_typeof] = ACTIONS(1650),
    [anon_sym_void] = ACTIONS(1650),
    [anon_sym_delete] = ACTIONS(1650),
    [anon_sym_PLUS_PLUS] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [anon_sym_SQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_number] = ACTIONS(1648),
    [sym_identifier] = ACTIONS(1650),
    [sym_this] = ACTIONS(1650),
    [sym_super] = ACTIONS(1650),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_null] = ACTIONS(1650),
    [sym_undefined] = ACTIONS(1650),
    [anon_sym_AT] = ACTIONS(1648),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
  },
  [981] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(439),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(439),
    [sym_class] = STATE(439),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(439),
    [sym_generator_function] = STATE(439),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(439),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(439),
    [sym_template_string] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_meta_property] = STATE(439),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [982] = {
    [anon_sym_EQ_GT] = ACTIONS(3026),
    [sym_comment] = ACTIONS(78),
  },
  [983] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(982),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(2149),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(2151),
  },
  [984] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(2149),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [985] = {
    [sym__automatic_semicolon] = ACTIONS(2241),
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2243),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_SLASH] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2241),
    [anon_sym_EQ_GT] = ACTIONS(691),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_GT_GT_GT] = ACTIONS(2241),
    [anon_sym_LT_LT] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_instanceof] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2241),
  },
  [986] = {
    [sym_parenthesized_expression] = STATE(995),
    [sym__expression] = STATE(995),
    [sym_yield_expression] = STATE(995),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(995),
    [sym_jsx_fragment] = STATE(995),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(995),
    [sym_anonymous_class] = STATE(995),
    [sym_class] = STATE(995),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(995),
    [sym_generator_function] = STATE(995),
    [sym_call_expression] = STATE(995),
    [sym_new_expression] = STATE(995),
    [sym_await_expression] = STATE(995),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(995),
    [sym_augmented_assignment_expression] = STATE(995),
    [sym_ternary_expression] = STATE(995),
    [sym_binary_expression] = STATE(995),
    [sym_unary_expression] = STATE(995),
    [sym_update_expression] = STATE(995),
    [sym_string] = STATE(995),
    [sym_template_string] = STATE(995),
    [sym_regex] = STATE(995),
    [sym_meta_property] = STATE(995),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(2245),
    [sym_identifier] = ACTIONS(3028),
    [sym_this] = ACTIONS(2247),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(2247),
    [sym_false] = ACTIONS(2247),
    [sym_null] = ACTIONS(2247),
    [sym_undefined] = ACTIONS(2247),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [987] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [988] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [989] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [990] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(1109),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [991] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1097),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_GT_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1111),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1111),
    [anon_sym_GT_EQ] = ACTIONS(1111),
    [anon_sym_instanceof] = ACTIONS(1111),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [992] = {
    [sym_parenthesized_expression] = STATE(1312),
    [sym__expression] = STATE(1312),
    [sym_yield_expression] = STATE(1312),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1312),
    [sym_jsx_fragment] = STATE(1312),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1312),
    [sym_anonymous_class] = STATE(1312),
    [sym_class] = STATE(1312),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1312),
    [sym_generator_function] = STATE(1312),
    [sym_call_expression] = STATE(1312),
    [sym_new_expression] = STATE(1312),
    [sym_await_expression] = STATE(1312),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1312),
    [sym_augmented_assignment_expression] = STATE(1312),
    [sym_ternary_expression] = STATE(1312),
    [sym_binary_expression] = STATE(1312),
    [sym_unary_expression] = STATE(1312),
    [sym_update_expression] = STATE(1312),
    [sym_sequence_expression] = STATE(887),
    [sym_string] = STATE(1312),
    [sym_template_string] = STATE(1312),
    [sym_regex] = STATE(1312),
    [sym_meta_property] = STATE(1312),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3032),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(3034),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [sym_null] = ACTIONS(3034),
    [sym_undefined] = ACTIONS(3034),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [993] = {
    [sym__template_chars] = ACTIONS(3036),
    [sym_escape_sequence] = ACTIONS(3036),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3036),
  },
  [994] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(1938),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1938),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [995] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1581),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [996] = {
    [sym__automatic_semicolon] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_COMMA] = ACTIONS(3038),
    [anon_sym_RBRACE] = ACTIONS(3038),
    [anon_sym_LPAREN] = ACTIONS(3038),
    [anon_sym_RPAREN] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3040),
    [anon_sym_SEMI] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_SLASH] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3038),
    [anon_sym_QMARK] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_PIPE_PIPE] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_GT_GT_GT] = ACTIONS(3038),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_CARET] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_PERCENT] = ACTIONS(3038),
    [anon_sym_LT_EQ] = ACTIONS(3038),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3038),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3038),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_instanceof] = ACTIONS(3038),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3038),
  },
  [997] = {
    [aux_sym_array_repeat1] = STATE(998),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3042),
    [sym_comment] = ACTIONS(78),
  },
  [998] = {
    [aux_sym_array_repeat1] = STATE(998),
    [anon_sym_COMMA] = ACTIONS(3044),
    [anon_sym_RPAREN] = ACTIONS(1938),
    [sym_comment] = ACTIONS(78),
  },
  [999] = {
    [sym_parenthesized_expression] = STATE(1314),
    [sym__expression] = STATE(1314),
    [sym_yield_expression] = STATE(1314),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(1314),
    [sym_jsx_fragment] = STATE(1314),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1314),
    [sym_anonymous_class] = STATE(1314),
    [sym_class] = STATE(1314),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1314),
    [sym_generator_function] = STATE(1314),
    [sym_call_expression] = STATE(1314),
    [sym_new_expression] = STATE(1314),
    [sym_await_expression] = STATE(1314),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(1314),
    [sym_augmented_assignment_expression] = STATE(1314),
    [sym_ternary_expression] = STATE(1314),
    [sym_binary_expression] = STATE(1314),
    [sym_unary_expression] = STATE(1314),
    [sym_update_expression] = STATE(1314),
    [sym_sequence_expression] = STATE(887),
    [sym_string] = STATE(1314),
    [sym_template_string] = STATE(1314),
    [sym_regex] = STATE(1314),
    [sym_meta_property] = STATE(1314),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3047),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(3049),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_undefined] = ACTIONS(3049),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [1000] = {
    [sym__automatic_semicolon] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_COMMA] = ACTIONS(3051),
    [anon_sym_RBRACE] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_in] = ACTIONS(3053),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_GT] = ACTIONS(3053),
    [anon_sym_SLASH] = ACTIONS(3053),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_PLUS_EQ] = ACTIONS(3051),
    [anon_sym_DASH_EQ] = ACTIONS(3051),
    [anon_sym_STAR_EQ] = ACTIONS(3051),
    [anon_sym_SLASH_EQ] = ACTIONS(3051),
    [anon_sym_PERCENT_EQ] = ACTIONS(3051),
    [anon_sym_CARET_EQ] = ACTIONS(3051),
    [anon_sym_AMP_EQ] = ACTIONS(3051),
    [anon_sym_PIPE_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3051),
    [anon_sym_LT_LT_EQ] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_GT_GT] = ACTIONS(3053),
    [anon_sym_GT_GT_GT] = ACTIONS(3053),
    [anon_sym_LT_LT] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_CARET] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(3053),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_PERCENT] = ACTIONS(3053),
    [anon_sym_LT_EQ] = ACTIONS(3051),
    [anon_sym_EQ_EQ] = ACTIONS(3053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3053),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3051),
    [anon_sym_GT_EQ] = ACTIONS(3051),
    [anon_sym_instanceof] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3051),
  },
  [1001] = {
    [anon_sym_export] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_LPAREN] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3057),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_class] = ACTIONS(3055),
    [anon_sym_async] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3057),
    [anon_sym_SQUOTE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(3057),
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3057),
    [anon_sym_static] = ACTIONS(3055),
    [anon_sym_get] = ACTIONS(3055),
    [anon_sym_set] = ACTIONS(3055),
  },
  [1002] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1003] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1004] = {
    [sym_parenthesized_expression] = STATE(1315),
    [sym__expression] = STATE(1315),
    [sym_yield_expression] = STATE(1315),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1315),
    [sym_jsx_fragment] = STATE(1315),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1315),
    [sym_anonymous_class] = STATE(1315),
    [sym_class] = STATE(1315),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1315),
    [sym_generator_function] = STATE(1315),
    [sym_call_expression] = STATE(1315),
    [sym_new_expression] = STATE(1315),
    [sym_await_expression] = STATE(1315),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1315),
    [sym_augmented_assignment_expression] = STATE(1315),
    [sym_ternary_expression] = STATE(1315),
    [sym_binary_expression] = STATE(1315),
    [sym_unary_expression] = STATE(1315),
    [sym_update_expression] = STATE(1315),
    [sym_string] = STATE(1315),
    [sym_template_string] = STATE(1315),
    [sym_regex] = STATE(1315),
    [sym_meta_property] = STATE(1315),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3059),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3061),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_null] = ACTIONS(3061),
    [sym_undefined] = ACTIONS(3061),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1005] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(1316),
    [sym__expression] = STATE(1316),
    [sym_yield_expression] = STATE(1316),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1316),
    [sym_jsx_fragment] = STATE(1316),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1316),
    [sym_anonymous_class] = STATE(1316),
    [sym_class] = STATE(1316),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1316),
    [sym_generator_function] = STATE(1316),
    [sym_call_expression] = STATE(1316),
    [sym_new_expression] = STATE(1316),
    [sym_await_expression] = STATE(1316),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1316),
    [sym_augmented_assignment_expression] = STATE(1316),
    [sym_ternary_expression] = STATE(1316),
    [sym_binary_expression] = STATE(1316),
    [sym_unary_expression] = STATE(1316),
    [sym_update_expression] = STATE(1316),
    [sym_string] = STATE(1316),
    [sym_template_string] = STATE(1316),
    [sym_regex] = STATE(1316),
    [sym_meta_property] = STATE(1316),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3063),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3065),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_undefined] = ACTIONS(3065),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1006] = {
    [sym_parenthesized_expression] = STATE(1317),
    [sym__expression] = STATE(1317),
    [sym_yield_expression] = STATE(1317),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1317),
    [sym_jsx_fragment] = STATE(1317),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1317),
    [sym_anonymous_class] = STATE(1317),
    [sym_class] = STATE(1317),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1317),
    [sym_generator_function] = STATE(1317),
    [sym_call_expression] = STATE(1317),
    [sym_new_expression] = STATE(1317),
    [sym_await_expression] = STATE(1317),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1317),
    [sym_augmented_assignment_expression] = STATE(1317),
    [sym_ternary_expression] = STATE(1317),
    [sym_binary_expression] = STATE(1317),
    [sym_unary_expression] = STATE(1317),
    [sym_update_expression] = STATE(1317),
    [sym_string] = STATE(1317),
    [sym_template_string] = STATE(1317),
    [sym_regex] = STATE(1317),
    [sym_meta_property] = STATE(1317),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3067),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3069),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_null] = ACTIONS(3069),
    [sym_undefined] = ACTIONS(3069),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1007] = {
    [anon_sym_EQ_GT] = ACTIONS(3071),
    [sym_comment] = ACTIONS(78),
  },
  [1008] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1009] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(1007),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(2273),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(2277),
  },
  [1010] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(2273),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [1011] = {
    [sym_parenthesized_expression] = STATE(1319),
    [sym__expression] = STATE(1319),
    [sym_yield_expression] = STATE(1319),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1319),
    [sym_jsx_fragment] = STATE(1319),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1319),
    [sym_anonymous_class] = STATE(1319),
    [sym_class] = STATE(1319),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1319),
    [sym_generator_function] = STATE(1319),
    [sym_call_expression] = STATE(1319),
    [sym_new_expression] = STATE(1319),
    [sym_await_expression] = STATE(1319),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1319),
    [sym_augmented_assignment_expression] = STATE(1319),
    [sym_ternary_expression] = STATE(1319),
    [sym_binary_expression] = STATE(1319),
    [sym_unary_expression] = STATE(1319),
    [sym_update_expression] = STATE(1319),
    [sym_string] = STATE(1319),
    [sym_template_string] = STATE(1319),
    [sym_regex] = STATE(1319),
    [sym_meta_property] = STATE(1319),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3073),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3075),
    [sym_false] = ACTIONS(3075),
    [sym_null] = ACTIONS(3075),
    [sym_undefined] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1012] = {
    [sym_parenthesized_expression] = STATE(1320),
    [sym__expression] = STATE(1320),
    [sym_yield_expression] = STATE(1320),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1320),
    [sym_jsx_fragment] = STATE(1320),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1320),
    [sym_anonymous_class] = STATE(1320),
    [sym_class] = STATE(1320),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1320),
    [sym_generator_function] = STATE(1320),
    [sym_call_expression] = STATE(1320),
    [sym_new_expression] = STATE(1320),
    [sym_await_expression] = STATE(1320),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1320),
    [sym_augmented_assignment_expression] = STATE(1320),
    [sym_ternary_expression] = STATE(1320),
    [sym_binary_expression] = STATE(1320),
    [sym_unary_expression] = STATE(1320),
    [sym_update_expression] = STATE(1320),
    [sym_string] = STATE(1320),
    [sym_template_string] = STATE(1320),
    [sym_regex] = STATE(1320),
    [sym_meta_property] = STATE(1320),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3077),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3079),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3079),
    [sym_false] = ACTIONS(3079),
    [sym_null] = ACTIONS(3079),
    [sym_undefined] = ACTIONS(3079),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1013] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1014] = {
    [sym_parenthesized_expression] = STATE(1321),
    [sym__expression] = STATE(1321),
    [sym_yield_expression] = STATE(1321),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(1321),
    [sym_jsx_fragment] = STATE(1321),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1321),
    [sym_anonymous_class] = STATE(1321),
    [sym_class] = STATE(1321),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1321),
    [sym_generator_function] = STATE(1321),
    [sym_call_expression] = STATE(1321),
    [sym_new_expression] = STATE(1321),
    [sym_await_expression] = STATE(1321),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(1321),
    [sym_augmented_assignment_expression] = STATE(1321),
    [sym_ternary_expression] = STATE(1321),
    [sym_binary_expression] = STATE(1321),
    [sym_unary_expression] = STATE(1321),
    [sym_update_expression] = STATE(1321),
    [sym_string] = STATE(1321),
    [sym_template_string] = STATE(1321),
    [sym_regex] = STATE(1321),
    [sym_meta_property] = STATE(1321),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3081),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(3083),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3083),
    [sym_false] = ACTIONS(3083),
    [sym_null] = ACTIONS(3083),
    [sym_undefined] = ACTIONS(3083),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1015] = {
    [sym_parenthesized_expression] = STATE(1322),
    [sym__expression] = STATE(1322),
    [sym_yield_expression] = STATE(1322),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1322),
    [sym_jsx_fragment] = STATE(1322),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1322),
    [sym_anonymous_class] = STATE(1322),
    [sym_class] = STATE(1322),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1322),
    [sym_generator_function] = STATE(1322),
    [sym_call_expression] = STATE(1322),
    [sym_new_expression] = STATE(1322),
    [sym_await_expression] = STATE(1322),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1322),
    [sym_augmented_assignment_expression] = STATE(1322),
    [sym_ternary_expression] = STATE(1322),
    [sym_binary_expression] = STATE(1322),
    [sym_unary_expression] = STATE(1322),
    [sym_update_expression] = STATE(1322),
    [sym_string] = STATE(1322),
    [sym_template_string] = STATE(1322),
    [sym_regex] = STATE(1322),
    [sym_meta_property] = STATE(1322),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3085),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3087),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3087),
    [sym_false] = ACTIONS(3087),
    [sym_null] = ACTIONS(3087),
    [sym_undefined] = ACTIONS(3087),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1016] = {
    [sym_parenthesized_expression] = STATE(1323),
    [sym__expression] = STATE(1323),
    [sym_yield_expression] = STATE(1323),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1323),
    [sym_jsx_fragment] = STATE(1323),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1323),
    [sym_anonymous_class] = STATE(1323),
    [sym_class] = STATE(1323),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1323),
    [sym_generator_function] = STATE(1323),
    [sym_call_expression] = STATE(1323),
    [sym_new_expression] = STATE(1323),
    [sym_await_expression] = STATE(1323),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1323),
    [sym_augmented_assignment_expression] = STATE(1323),
    [sym_ternary_expression] = STATE(1323),
    [sym_binary_expression] = STATE(1323),
    [sym_unary_expression] = STATE(1323),
    [sym_update_expression] = STATE(1323),
    [sym_string] = STATE(1323),
    [sym_template_string] = STATE(1323),
    [sym_regex] = STATE(1323),
    [sym_meta_property] = STATE(1323),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3089),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3091),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3091),
    [sym_false] = ACTIONS(3091),
    [sym_null] = ACTIONS(3091),
    [sym_undefined] = ACTIONS(3091),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1017] = {
    [sym_parenthesized_expression] = STATE(1324),
    [sym__expression] = STATE(1324),
    [sym_yield_expression] = STATE(1324),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1324),
    [sym_jsx_fragment] = STATE(1324),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1324),
    [sym_anonymous_class] = STATE(1324),
    [sym_class] = STATE(1324),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1324),
    [sym_generator_function] = STATE(1324),
    [sym_call_expression] = STATE(1324),
    [sym_new_expression] = STATE(1324),
    [sym_await_expression] = STATE(1324),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1324),
    [sym_augmented_assignment_expression] = STATE(1324),
    [sym_ternary_expression] = STATE(1324),
    [sym_binary_expression] = STATE(1324),
    [sym_unary_expression] = STATE(1324),
    [sym_update_expression] = STATE(1324),
    [sym_string] = STATE(1324),
    [sym_template_string] = STATE(1324),
    [sym_regex] = STATE(1324),
    [sym_meta_property] = STATE(1324),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3093),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3095),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3095),
    [sym_false] = ACTIONS(3095),
    [sym_null] = ACTIONS(3095),
    [sym_undefined] = ACTIONS(3095),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1018] = {
    [sym_parenthesized_expression] = STATE(1325),
    [sym__expression] = STATE(1325),
    [sym_yield_expression] = STATE(1325),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1325),
    [sym_jsx_fragment] = STATE(1325),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1325),
    [sym_anonymous_class] = STATE(1325),
    [sym_class] = STATE(1325),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1325),
    [sym_generator_function] = STATE(1325),
    [sym_call_expression] = STATE(1325),
    [sym_new_expression] = STATE(1325),
    [sym_await_expression] = STATE(1325),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1325),
    [sym_augmented_assignment_expression] = STATE(1325),
    [sym_ternary_expression] = STATE(1325),
    [sym_binary_expression] = STATE(1325),
    [sym_unary_expression] = STATE(1325),
    [sym_update_expression] = STATE(1325),
    [sym_string] = STATE(1325),
    [sym_template_string] = STATE(1325),
    [sym_regex] = STATE(1325),
    [sym_meta_property] = STATE(1325),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3097),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3099),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1019] = {
    [sym_parenthesized_expression] = STATE(1326),
    [sym__expression] = STATE(1326),
    [sym_yield_expression] = STATE(1326),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1326),
    [sym_jsx_fragment] = STATE(1326),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1326),
    [sym_anonymous_class] = STATE(1326),
    [sym_class] = STATE(1326),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1326),
    [sym_generator_function] = STATE(1326),
    [sym_call_expression] = STATE(1326),
    [sym_new_expression] = STATE(1326),
    [sym_await_expression] = STATE(1326),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1326),
    [sym_augmented_assignment_expression] = STATE(1326),
    [sym_ternary_expression] = STATE(1326),
    [sym_binary_expression] = STATE(1326),
    [sym_unary_expression] = STATE(1326),
    [sym_update_expression] = STATE(1326),
    [sym_string] = STATE(1326),
    [sym_template_string] = STATE(1326),
    [sym_regex] = STATE(1326),
    [sym_meta_property] = STATE(1326),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3101),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3103),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3103),
    [sym_false] = ACTIONS(3103),
    [sym_null] = ACTIONS(3103),
    [sym_undefined] = ACTIONS(3103),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1020] = {
    [sym_parenthesized_expression] = STATE(1327),
    [sym__expression] = STATE(1327),
    [sym_yield_expression] = STATE(1327),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1327),
    [sym_jsx_fragment] = STATE(1327),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1327),
    [sym_anonymous_class] = STATE(1327),
    [sym_class] = STATE(1327),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1327),
    [sym_generator_function] = STATE(1327),
    [sym_call_expression] = STATE(1327),
    [sym_new_expression] = STATE(1327),
    [sym_await_expression] = STATE(1327),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1327),
    [sym_augmented_assignment_expression] = STATE(1327),
    [sym_ternary_expression] = STATE(1327),
    [sym_binary_expression] = STATE(1327),
    [sym_unary_expression] = STATE(1327),
    [sym_update_expression] = STATE(1327),
    [sym_string] = STATE(1327),
    [sym_template_string] = STATE(1327),
    [sym_regex] = STATE(1327),
    [sym_meta_property] = STATE(1327),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_RBRACE] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(2323),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3105),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3107),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3107),
    [sym_false] = ACTIONS(3107),
    [sym_null] = ACTIONS(3107),
    [sym_undefined] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1021] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(1331),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(3115),
  },
  [1022] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(1332),
    [sym__expression] = STATE(1332),
    [sym_yield_expression] = STATE(1332),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1332),
    [sym_jsx_fragment] = STATE(1332),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1332),
    [sym_anonymous_class] = STATE(1332),
    [sym_class] = STATE(1332),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1332),
    [sym_generator_function] = STATE(1332),
    [sym_call_expression] = STATE(1332),
    [sym_new_expression] = STATE(1332),
    [sym_await_expression] = STATE(1332),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1332),
    [sym_augmented_assignment_expression] = STATE(1332),
    [sym_ternary_expression] = STATE(1332),
    [sym_binary_expression] = STATE(1332),
    [sym_unary_expression] = STATE(1332),
    [sym_update_expression] = STATE(1332),
    [sym_string] = STATE(1332),
    [sym_template_string] = STATE(1332),
    [sym_regex] = STATE(1332),
    [sym_meta_property] = STATE(1332),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3117),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3119),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3119),
    [sym_false] = ACTIONS(3119),
    [sym_null] = ACTIONS(3119),
    [sym_undefined] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1023] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(3121),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(3123),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [1024] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1025] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1026] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(3127),
    [anon_sym_DASH_EQ] = ACTIONS(3127),
    [anon_sym_STAR_EQ] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3127),
    [anon_sym_AMP_EQ] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3127),
    [anon_sym_GT_GT_EQ] = ACTIONS(3127),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1027] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_PLUS_EQ] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [1028] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1029] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1030] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1031] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_PLUS_EQ] = ACTIONS(3127),
    [anon_sym_DASH_EQ] = ACTIONS(3127),
    [anon_sym_STAR_EQ] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3127),
    [anon_sym_AMP_EQ] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3127),
    [anon_sym_GT_GT_EQ] = ACTIONS(3127),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1032] = {
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [sym_comment] = ACTIONS(78),
  },
  [1033] = {
    [anon_sym_LBRACE] = ACTIONS(3147),
    [anon_sym_LT] = ACTIONS(3147),
    [sym_jsx_text] = ACTIONS(3147),
    [sym_comment] = ACTIONS(78),
  },
  [1034] = {
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(78),
  },
  [1035] = {
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(3149),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
  },
  [1036] = {
    [anon_sym_GT] = ACTIONS(3149),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
  },
  [1037] = {
    [anon_sym_GT] = ACTIONS(3149),
    [sym_comment] = ACTIONS(78),
  },
  [1038] = {
    [anon_sym_GT] = ACTIONS(3151),
    [sym_comment] = ACTIONS(78),
  },
  [1039] = {
    [sym_jsx_expression] = STATE(940),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(940),
    [aux_sym_jsx_opening_element_repeat1] = STATE(940),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(3153),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [1040] = {
    [sym_nested_identifier] = STATE(1347),
    [sym_jsx_namespace_name] = STATE(1348),
    [sym_jsx_identifier] = ACTIONS(3155),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3157),
  },
  [1041] = {
    [anon_sym_LBRACE] = ACTIONS(2349),
    [anon_sym_LT] = ACTIONS(2349),
    [sym_jsx_text] = ACTIONS(2349),
    [sym_comment] = ACTIONS(78),
  },
  [1042] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [1043] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(3159),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1044] = {
    [sym_class_body] = STATE(1350),
    [anon_sym_LBRACE] = ACTIONS(302),
    [sym_comment] = ACTIONS(78),
  },
  [1045] = {
    [sym__automatic_semicolon] = ACTIONS(3161),
    [anon_sym_STAR] = ACTIONS(3161),
    [anon_sym_COMMA] = ACTIONS(3161),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_LPAREN] = ACTIONS(3161),
    [anon_sym_RPAREN] = ACTIONS(3161),
    [anon_sym_in] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3161),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_DOT] = ACTIONS(3161),
    [anon_sym_QMARK] = ACTIONS(3161),
    [anon_sym_AMP_AMP] = ACTIONS(3161),
    [anon_sym_PIPE_PIPE] = ACTIONS(3161),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_GT_GT_GT] = ACTIONS(3161),
    [anon_sym_LT_LT] = ACTIONS(3161),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3161),
    [anon_sym_LT_EQ] = ACTIONS(3161),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3161),
    [anon_sym_BANG_EQ] = ACTIONS(3163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3161),
    [anon_sym_GT_EQ] = ACTIONS(3161),
    [anon_sym_instanceof] = ACTIONS(3161),
    [anon_sym_PLUS_PLUS] = ACTIONS(3161),
    [anon_sym_DASH_DASH] = ACTIONS(3161),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3161),
  },
  [1046] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1047] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1048] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2135),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1049] = {
    [sym_statement_block] = STATE(975),
    [sym_parenthesized_expression] = STATE(1351),
    [sym__expression] = STATE(1351),
    [sym_yield_expression] = STATE(1351),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1351),
    [sym_jsx_fragment] = STATE(1351),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1351),
    [sym_anonymous_class] = STATE(1351),
    [sym_class] = STATE(1351),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1351),
    [sym_generator_function] = STATE(1351),
    [sym_call_expression] = STATE(1351),
    [sym_new_expression] = STATE(1351),
    [sym_await_expression] = STATE(1351),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1351),
    [sym_augmented_assignment_expression] = STATE(1351),
    [sym_ternary_expression] = STATE(1351),
    [sym_binary_expression] = STATE(1351),
    [sym_unary_expression] = STATE(1351),
    [sym_update_expression] = STATE(1351),
    [sym_string] = STATE(1351),
    [sym_template_string] = STATE(1351),
    [sym_regex] = STATE(1351),
    [sym_meta_property] = STATE(1351),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3165),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(3167),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_undefined] = ACTIONS(3167),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [1050] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1051] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1052] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1053] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1054] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1055] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1056] = {
    [anon_sym_COMMA] = ACTIONS(3171),
    [anon_sym_RBRACE] = ACTIONS(3171),
    [sym_comment] = ACTIONS(78),
  },
  [1057] = {
    [sym__automatic_semicolon] = ACTIONS(3173),
    [anon_sym_from] = ACTIONS(3173),
    [anon_sym_SEMI] = ACTIONS(3173),
    [sym_comment] = ACTIONS(78),
  },
  [1058] = {
    [anon_sym_COMMA] = ACTIONS(3175),
    [anon_sym_RBRACE] = ACTIONS(3175),
    [sym_comment] = ACTIONS(78),
  },
  [1059] = {
    [sym__import_export_specifier] = STATE(1058),
    [anon_sym_RBRACE] = ACTIONS(3177),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(477),
  },
  [1060] = {
    [aux_sym_export_clause_repeat1] = STATE(1060),
    [anon_sym_COMMA] = ACTIONS(3179),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [sym_comment] = ACTIONS(78),
  },
  [1061] = {
    [sym__automatic_semicolon] = ACTIONS(2029),
    [ts_builtin_sym_end] = ACTIONS(2029),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_var] = ACTIONS(2031),
    [anon_sym_let] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_LPAREN] = ACTIONS(2029),
    [anon_sym_await] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_with] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_debugger] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_yield] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_LT] = ACTIONS(2029),
    [anon_sym_SLASH] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_async] = ACTIONS(2031),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_EQ_GT] = ACTIONS(2029),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_typeof] = ACTIONS(2031),
    [anon_sym_void] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2029),
    [sym_number] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2031),
    [sym_this] = ACTIONS(2031),
    [sym_super] = ACTIONS(2031),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [sym_null] = ACTIONS(2031),
    [sym_undefined] = ACTIONS(2031),
    [anon_sym_AT] = ACTIONS(2029),
    [anon_sym_get] = ACTIONS(2031),
    [anon_sym_set] = ACTIONS(2031),
  },
  [1062] = {
    [sym_string] = STATE(552),
    [sym_decorator] = STATE(553),
    [sym_public_field_definition] = STATE(550),
    [sym_method_definition] = STATE(551),
    [sym__property_name] = STATE(552),
    [sym_computed_property_name] = STATE(552),
    [aux_sym_export_statement_repeat1] = STATE(553),
    [aux_sym_class_body_repeat1] = STATE(954),
    [anon_sym_STAR] = ACTIONS(112),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_DQUOTE] = ACTIONS(987),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(991),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_static] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(997),
    [anon_sym_set] = ACTIONS(997),
  },
  [1063] = {
    [sym__automatic_semicolon] = ACTIONS(3010),
    [ts_builtin_sym_end] = ACTIONS(3010),
    [anon_sym_export] = ACTIONS(3012),
    [anon_sym_default] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_import] = ACTIONS(3012),
    [anon_sym_var] = ACTIONS(3012),
    [anon_sym_let] = ACTIONS(3012),
    [anon_sym_const] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_else] = ACTIONS(3012),
    [anon_sym_switch] = ACTIONS(3012),
    [anon_sym_for] = ACTIONS(3012),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_await] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_try] = ACTIONS(3012),
    [anon_sym_with] = ACTIONS(3012),
    [anon_sym_break] = ACTIONS(3012),
    [anon_sym_continue] = ACTIONS(3012),
    [anon_sym_debugger] = ACTIONS(3012),
    [anon_sym_return] = ACTIONS(3012),
    [anon_sym_throw] = ACTIONS(3012),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym_case] = ACTIONS(3012),
    [anon_sym_yield] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3010),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_class] = ACTIONS(3012),
    [anon_sym_async] = ACTIONS(3012),
    [anon_sym_function] = ACTIONS(3012),
    [anon_sym_EQ_GT] = ACTIONS(3010),
    [anon_sym_new] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3010),
    [anon_sym_TILDE] = ACTIONS(3010),
    [anon_sym_typeof] = ACTIONS(3012),
    [anon_sym_void] = ACTIONS(3012),
    [anon_sym_delete] = ACTIONS(3012),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [anon_sym_DQUOTE] = ACTIONS(3010),
    [anon_sym_SQUOTE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3010),
    [sym_number] = ACTIONS(3010),
    [sym_identifier] = ACTIONS(3012),
    [sym_this] = ACTIONS(3012),
    [sym_super] = ACTIONS(3012),
    [sym_true] = ACTIONS(3012),
    [sym_false] = ACTIONS(3012),
    [sym_null] = ACTIONS(3012),
    [sym_undefined] = ACTIONS(3012),
    [anon_sym_AT] = ACTIONS(3010),
    [anon_sym_get] = ACTIONS(3012),
    [anon_sym_set] = ACTIONS(3012),
  },
  [1064] = {
    [sym_statement_block] = STATE(1356),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(78),
  },
  [1065] = {
    [sym__automatic_semicolon] = ACTIONS(3014),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_import] = ACTIONS(3016),
    [anon_sym_var] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_else] = ACTIONS(3016),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_await] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_with] = ACTIONS(3016),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_debugger] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_yield] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_function] = ACTIONS(3016),
    [anon_sym_EQ_GT] = ACTIONS(3014),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_TILDE] = ACTIONS(3014),
    [anon_sym_typeof] = ACTIONS(3016),
    [anon_sym_void] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [sym_number] = ACTIONS(3014),
    [sym_identifier] = ACTIONS(3016),
    [sym_this] = ACTIONS(3016),
    [sym_super] = ACTIONS(3016),
    [sym_true] = ACTIONS(3016),
    [sym_false] = ACTIONS(3016),
    [sym_null] = ACTIONS(3016),
    [sym_undefined] = ACTIONS(3016),
    [anon_sym_AT] = ACTIONS(3014),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
  },
  [1066] = {
    [sym_statement_block] = STATE(1357),
    [anon_sym_LBRACE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(78),
  },
  [1067] = {
    [sym__automatic_semicolon] = ACTIONS(3022),
    [ts_builtin_sym_end] = ACTIONS(3022),
    [anon_sym_export] = ACTIONS(3024),
    [anon_sym_default] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_import] = ACTIONS(3024),
    [anon_sym_var] = ACTIONS(3024),
    [anon_sym_let] = ACTIONS(3024),
    [anon_sym_const] = ACTIONS(3024),
    [anon_sym_if] = ACTIONS(3024),
    [anon_sym_else] = ACTIONS(3024),
    [anon_sym_switch] = ACTIONS(3024),
    [anon_sym_for] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3022),
    [anon_sym_await] = ACTIONS(3024),
    [anon_sym_while] = ACTIONS(3024),
    [anon_sym_do] = ACTIONS(3024),
    [anon_sym_try] = ACTIONS(3024),
    [anon_sym_with] = ACTIONS(3024),
    [anon_sym_break] = ACTIONS(3024),
    [anon_sym_continue] = ACTIONS(3024),
    [anon_sym_debugger] = ACTIONS(3024),
    [anon_sym_return] = ACTIONS(3024),
    [anon_sym_throw] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym_case] = ACTIONS(3024),
    [anon_sym_yield] = ACTIONS(3024),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3022),
    [anon_sym_SLASH] = ACTIONS(3024),
    [anon_sym_class] = ACTIONS(3024),
    [anon_sym_async] = ACTIONS(3024),
    [anon_sym_function] = ACTIONS(3024),
    [anon_sym_EQ_GT] = ACTIONS(3022),
    [anon_sym_new] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_typeof] = ACTIONS(3024),
    [anon_sym_void] = ACTIONS(3024),
    [anon_sym_delete] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3022),
    [sym_number] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3024),
    [sym_this] = ACTIONS(3024),
    [sym_super] = ACTIONS(3024),
    [sym_true] = ACTIONS(3024),
    [sym_false] = ACTIONS(3024),
    [sym_null] = ACTIONS(3024),
    [sym_undefined] = ACTIONS(3024),
    [anon_sym_AT] = ACTIONS(3022),
    [anon_sym_get] = ACTIONS(3024),
    [anon_sym_set] = ACTIONS(3024),
  },
  [1068] = {
    [sym__automatic_semicolon] = ACTIONS(517),
    [ts_builtin_sym_end] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(519),
    [anon_sym_default] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_import] = ACTIONS(519),
    [anon_sym_var] = ACTIONS(519),
    [anon_sym_let] = ACTIONS(519),
    [anon_sym_const] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(519),
    [anon_sym_else] = ACTIONS(519),
    [anon_sym_switch] = ACTIONS(519),
    [anon_sym_for] = ACTIONS(519),
    [anon_sym_LPAREN] = ACTIONS(517),
    [anon_sym_await] = ACTIONS(519),
    [anon_sym_while] = ACTIONS(519),
    [anon_sym_do] = ACTIONS(519),
    [anon_sym_try] = ACTIONS(519),
    [anon_sym_with] = ACTIONS(519),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_continue] = ACTIONS(519),
    [anon_sym_debugger] = ACTIONS(519),
    [anon_sym_return] = ACTIONS(519),
    [anon_sym_throw] = ACTIONS(519),
    [anon_sym_SEMI] = ACTIONS(517),
    [anon_sym_case] = ACTIONS(519),
    [anon_sym_yield] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(519),
    [anon_sym_class] = ACTIONS(519),
    [anon_sym_async] = ACTIONS(519),
    [anon_sym_function] = ACTIONS(519),
    [anon_sym_EQ_GT] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(519),
    [anon_sym_DASH] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(517),
    [anon_sym_typeof] = ACTIONS(519),
    [anon_sym_void] = ACTIONS(519),
    [anon_sym_delete] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(517),
    [anon_sym_DASH_DASH] = ACTIONS(517),
    [anon_sym_DQUOTE] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(517),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(517),
    [sym_number] = ACTIONS(517),
    [sym_identifier] = ACTIONS(519),
    [sym_this] = ACTIONS(519),
    [sym_super] = ACTIONS(519),
    [sym_true] = ACTIONS(519),
    [sym_false] = ACTIONS(519),
    [sym_null] = ACTIONS(519),
    [sym_undefined] = ACTIONS(519),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_get] = ACTIONS(519),
    [anon_sym_set] = ACTIONS(519),
  },
  [1069] = {
    [sym_export_statement] = STATE(338),
    [sym__declaration] = STATE(338),
    [sym_import_statement] = STATE(338),
    [sym_expression_statement] = STATE(338),
    [sym_variable_declaration] = STATE(338),
    [sym_lexical_declaration] = STATE(338),
    [sym_statement_block] = STATE(338),
    [sym_if_statement] = STATE(338),
    [sym_switch_statement] = STATE(338),
    [sym_for_statement] = STATE(338),
    [sym_for_in_statement] = STATE(338),
    [sym_for_of_statement] = STATE(338),
    [sym_while_statement] = STATE(338),
    [sym_do_statement] = STATE(338),
    [sym_try_statement] = STATE(338),
    [sym_with_statement] = STATE(338),
    [sym_break_statement] = STATE(338),
    [sym_continue_statement] = STATE(338),
    [sym_debugger_statement] = STATE(338),
    [sym_return_statement] = STATE(338),
    [sym_throw_statement] = STATE(338),
    [sym_empty_statement] = STATE(338),
    [sym_labeled_statement] = STATE(338),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(338),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(3186),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1070] = {
    [sym_class_body] = STATE(1359),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [sym_comment] = ACTIONS(78),
  },
  [1071] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(845),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1072] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(897),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1073] = {
    [sym_parenthesized_expression] = STATE(1360),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1360),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1360),
    [sym_jsx_fragment] = STATE(1360),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1360),
    [sym_anonymous_class] = STATE(1360),
    [sym_class] = STATE(1360),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1360),
    [sym_generator_function] = STATE(1360),
    [sym_call_expression] = STATE(1360),
    [sym_new_expression] = STATE(1360),
    [sym_await_expression] = STATE(1360),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1360),
    [sym_augmented_assignment_expression] = STATE(1360),
    [sym_ternary_expression] = STATE(1360),
    [sym_binary_expression] = STATE(1360),
    [sym_unary_expression] = STATE(1360),
    [sym_update_expression] = STATE(1360),
    [sym_string] = STATE(1360),
    [sym_template_string] = STATE(1360),
    [sym_regex] = STATE(1360),
    [sym_meta_property] = STATE(1360),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3188),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(3190),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3190),
    [sym_false] = ACTIONS(3190),
    [sym_null] = ACTIONS(3190),
    [sym_undefined] = ACTIONS(3190),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1074] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1361),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1361),
    [sym_jsx_fragment] = STATE(1361),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1361),
    [sym_anonymous_class] = STATE(1361),
    [sym_class] = STATE(1361),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1361),
    [sym_generator_function] = STATE(1361),
    [sym_call_expression] = STATE(1361),
    [sym_new_expression] = STATE(1361),
    [sym_await_expression] = STATE(1361),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1361),
    [sym_augmented_assignment_expression] = STATE(1361),
    [sym_ternary_expression] = STATE(1361),
    [sym_binary_expression] = STATE(1361),
    [sym_unary_expression] = STATE(1361),
    [sym_update_expression] = STATE(1361),
    [sym_string] = STATE(1361),
    [sym_template_string] = STATE(1361),
    [sym_regex] = STATE(1361),
    [sym_meta_property] = STATE(1361),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3192),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(3194),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3194),
    [sym_false] = ACTIONS(3194),
    [sym_null] = ACTIONS(3194),
    [sym_undefined] = ACTIONS(3194),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1075] = {
    [sym_parenthesized_expression] = STATE(1362),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1362),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1362),
    [sym_jsx_fragment] = STATE(1362),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1362),
    [sym_anonymous_class] = STATE(1362),
    [sym_class] = STATE(1362),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1362),
    [sym_generator_function] = STATE(1362),
    [sym_call_expression] = STATE(1362),
    [sym_new_expression] = STATE(1362),
    [sym_await_expression] = STATE(1362),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1362),
    [sym_augmented_assignment_expression] = STATE(1362),
    [sym_ternary_expression] = STATE(1362),
    [sym_binary_expression] = STATE(1362),
    [sym_unary_expression] = STATE(1362),
    [sym_update_expression] = STATE(1362),
    [sym_string] = STATE(1362),
    [sym_template_string] = STATE(1362),
    [sym_regex] = STATE(1362),
    [sym_meta_property] = STATE(1362),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3196),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(3198),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3198),
    [sym_false] = ACTIONS(3198),
    [sym_null] = ACTIONS(3198),
    [sym_undefined] = ACTIONS(3198),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1076] = {
    [anon_sym_EQ_GT] = ACTIONS(3200),
    [sym_comment] = ACTIONS(78),
  },
  [1077] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1078] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(1076),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_RBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(2432),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(2436),
  },
  [1079] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(2432),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [1080] = {
    [sym_parenthesized_expression] = STATE(1364),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1364),
    [sym_jsx_fragment] = STATE(1364),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1364),
    [sym_anonymous_class] = STATE(1364),
    [sym_class] = STATE(1364),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1364),
    [sym_generator_function] = STATE(1364),
    [sym_call_expression] = STATE(1364),
    [sym_new_expression] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_string] = STATE(1364),
    [sym_template_string] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(3204),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3204),
    [sym_false] = ACTIONS(3204),
    [sym_null] = ACTIONS(3204),
    [sym_undefined] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1081] = {
    [sym_parenthesized_expression] = STATE(1365),
    [sym__expression] = STATE(1365),
    [sym_yield_expression] = STATE(1365),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1365),
    [sym_jsx_fragment] = STATE(1365),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1365),
    [sym_anonymous_class] = STATE(1365),
    [sym_class] = STATE(1365),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1365),
    [sym_generator_function] = STATE(1365),
    [sym_call_expression] = STATE(1365),
    [sym_new_expression] = STATE(1365),
    [sym_await_expression] = STATE(1365),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1365),
    [sym_augmented_assignment_expression] = STATE(1365),
    [sym_ternary_expression] = STATE(1365),
    [sym_binary_expression] = STATE(1365),
    [sym_unary_expression] = STATE(1365),
    [sym_update_expression] = STATE(1365),
    [sym_string] = STATE(1365),
    [sym_template_string] = STATE(1365),
    [sym_regex] = STATE(1365),
    [sym_meta_property] = STATE(1365),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3206),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(3208),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3208),
    [sym_false] = ACTIONS(3208),
    [sym_null] = ACTIONS(3208),
    [sym_undefined] = ACTIONS(3208),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1082] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1083] = {
    [anon_sym_LPAREN] = ACTIONS(2513),
    [sym_comment] = ACTIONS(78),
  },
  [1084] = {
    [sym_parenthesized_expression] = STATE(1366),
    [sym__expression] = STATE(1366),
    [sym_yield_expression] = STATE(1366),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1366),
    [sym_jsx_fragment] = STATE(1366),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1366),
    [sym_anonymous_class] = STATE(1366),
    [sym_class] = STATE(1366),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1366),
    [sym_generator_function] = STATE(1366),
    [sym_call_expression] = STATE(1366),
    [sym_new_expression] = STATE(1366),
    [sym_await_expression] = STATE(1366),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1366),
    [sym_augmented_assignment_expression] = STATE(1366),
    [sym_ternary_expression] = STATE(1366),
    [sym_binary_expression] = STATE(1366),
    [sym_unary_expression] = STATE(1366),
    [sym_update_expression] = STATE(1366),
    [sym_string] = STATE(1366),
    [sym_template_string] = STATE(1366),
    [sym_regex] = STATE(1366),
    [sym_meta_property] = STATE(1366),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3210),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3212),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3212),
    [sym_false] = ACTIONS(3212),
    [sym_null] = ACTIONS(3212),
    [sym_undefined] = ACTIONS(3212),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1085] = {
    [sym_parenthesized_expression] = STATE(1367),
    [sym__expression] = STATE(1367),
    [sym_yield_expression] = STATE(1367),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1367),
    [sym_jsx_fragment] = STATE(1367),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1367),
    [sym_anonymous_class] = STATE(1367),
    [sym_class] = STATE(1367),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1367),
    [sym_generator_function] = STATE(1367),
    [sym_call_expression] = STATE(1367),
    [sym_new_expression] = STATE(1367),
    [sym_await_expression] = STATE(1367),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1367),
    [sym_augmented_assignment_expression] = STATE(1367),
    [sym_ternary_expression] = STATE(1367),
    [sym_binary_expression] = STATE(1367),
    [sym_unary_expression] = STATE(1367),
    [sym_update_expression] = STATE(1367),
    [sym_string] = STATE(1367),
    [sym_template_string] = STATE(1367),
    [sym_regex] = STATE(1367),
    [sym_meta_property] = STATE(1367),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(3216),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3216),
    [sym_false] = ACTIONS(3216),
    [sym_null] = ACTIONS(3216),
    [sym_undefined] = ACTIONS(3216),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1086] = {
    [sym_parenthesized_expression] = STATE(1368),
    [sym__expression] = STATE(1368),
    [sym_yield_expression] = STATE(1368),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1368),
    [sym_jsx_fragment] = STATE(1368),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1368),
    [sym_anonymous_class] = STATE(1368),
    [sym_class] = STATE(1368),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1368),
    [sym_generator_function] = STATE(1368),
    [sym_call_expression] = STATE(1368),
    [sym_new_expression] = STATE(1368),
    [sym_await_expression] = STATE(1368),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1368),
    [sym_augmented_assignment_expression] = STATE(1368),
    [sym_ternary_expression] = STATE(1368),
    [sym_binary_expression] = STATE(1368),
    [sym_unary_expression] = STATE(1368),
    [sym_update_expression] = STATE(1368),
    [sym_string] = STATE(1368),
    [sym_template_string] = STATE(1368),
    [sym_regex] = STATE(1368),
    [sym_meta_property] = STATE(1368),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(3220),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3220),
    [sym_false] = ACTIONS(3220),
    [sym_null] = ACTIONS(3220),
    [sym_undefined] = ACTIONS(3220),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1087] = {
    [sym_parenthesized_expression] = STATE(1369),
    [sym__expression] = STATE(1369),
    [sym_yield_expression] = STATE(1369),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1369),
    [sym_jsx_fragment] = STATE(1369),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1369),
    [sym_anonymous_class] = STATE(1369),
    [sym_class] = STATE(1369),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1369),
    [sym_generator_function] = STATE(1369),
    [sym_call_expression] = STATE(1369),
    [sym_new_expression] = STATE(1369),
    [sym_await_expression] = STATE(1369),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1369),
    [sym_augmented_assignment_expression] = STATE(1369),
    [sym_ternary_expression] = STATE(1369),
    [sym_binary_expression] = STATE(1369),
    [sym_unary_expression] = STATE(1369),
    [sym_update_expression] = STATE(1369),
    [sym_string] = STATE(1369),
    [sym_template_string] = STATE(1369),
    [sym_regex] = STATE(1369),
    [sym_meta_property] = STATE(1369),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3222),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(3224),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3224),
    [sym_false] = ACTIONS(3224),
    [sym_null] = ACTIONS(3224),
    [sym_undefined] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1088] = {
    [anon_sym_STAR] = ACTIONS(3226),
    [anon_sym_COMMA] = ACTIONS(3226),
    [anon_sym_RBRACE] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_SQUOTE] = ACTIONS(3226),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(3226),
    [sym_identifier] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_static] = ACTIONS(3228),
    [anon_sym_get] = ACTIONS(3228),
    [anon_sym_set] = ACTIONS(3228),
  },
  [1089] = {
    [anon_sym_COMMA] = ACTIONS(1545),
    [anon_sym_RPAREN] = ACTIONS(1545),
    [anon_sym_EQ] = ACTIONS(1545),
    [sym_comment] = ACTIONS(78),
  },
  [1090] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(3230),
    [sym_comment] = ACTIONS(78),
  },
  [1091] = {
    [anon_sym_COMMA] = ACTIONS(1633),
    [anon_sym_RPAREN] = ACTIONS(1633),
    [anon_sym_EQ] = ACTIONS(1633),
    [sym_comment] = ACTIONS(78),
  },
  [1092] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [sym_comment] = ACTIONS(78),
  },
  [1093] = {
    [aux_sym_object_repeat1] = STATE(1372),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [sym_comment] = ACTIONS(78),
  },
  [1094] = {
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_COLON] = ACTIONS(2513),
    [anon_sym_EQ] = ACTIONS(1962),
    [sym_comment] = ACTIONS(78),
  },
  [1095] = {
    [aux_sym_array_repeat1] = STATE(530),
    [anon_sym_COMMA] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(3234),
    [sym_comment] = ACTIONS(78),
  },
  [1096] = {
    [anon_sym_COMMA] = ACTIONS(1962),
    [anon_sym_RPAREN] = ACTIONS(1962),
    [anon_sym_EQ] = ACTIONS(1962),
    [sym_comment] = ACTIONS(78),
  },
  [1097] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1098] = {
    [sym_export_statement] = STATE(1374),
    [sym__declaration] = STATE(1374),
    [sym_import_statement] = STATE(1374),
    [sym_expression_statement] = STATE(1374),
    [sym_variable_declaration] = STATE(1374),
    [sym_lexical_declaration] = STATE(1374),
    [sym_statement_block] = STATE(1374),
    [sym_if_statement] = STATE(1374),
    [sym_switch_statement] = STATE(1374),
    [sym_for_statement] = STATE(1374),
    [sym_for_in_statement] = STATE(1374),
    [sym_for_of_statement] = STATE(1374),
    [sym_while_statement] = STATE(1374),
    [sym_do_statement] = STATE(1374),
    [sym_try_statement] = STATE(1374),
    [sym_with_statement] = STATE(1374),
    [sym_break_statement] = STATE(1374),
    [sym_continue_statement] = STATE(1374),
    [sym_debugger_statement] = STATE(1374),
    [sym_return_statement] = STATE(1374),
    [sym_throw_statement] = STATE(1374),
    [sym_empty_statement] = STATE(1374),
    [sym_labeled_statement] = STATE(1374),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1099] = {
    [sym_expression_statement] = STATE(1378),
    [sym_variable_declaration] = STATE(1378),
    [sym_lexical_declaration] = STATE(1378),
    [sym_empty_statement] = STATE(1378),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(1379),
    [sym_array] = STATE(1380),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_var] = ACTIONS(3236),
    [anon_sym_let] = ACTIONS(3238),
    [anon_sym_const] = ACTIONS(3238),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3240),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1100] = {
    [anon_sym_LPAREN] = ACTIONS(3242),
    [sym_comment] = ACTIONS(78),
  },
  [1101] = {
    [sym_export_statement] = STATE(485),
    [sym__declaration] = STATE(485),
    [sym_import_statement] = STATE(485),
    [sym_expression_statement] = STATE(485),
    [sym_variable_declaration] = STATE(485),
    [sym_lexical_declaration] = STATE(485),
    [sym_statement_block] = STATE(485),
    [sym_if_statement] = STATE(485),
    [sym_switch_statement] = STATE(485),
    [sym_for_statement] = STATE(485),
    [sym_for_in_statement] = STATE(485),
    [sym_for_of_statement] = STATE(485),
    [sym_while_statement] = STATE(485),
    [sym_do_statement] = STATE(485),
    [sym_try_statement] = STATE(485),
    [sym_with_statement] = STATE(485),
    [sym_break_statement] = STATE(485),
    [sym_continue_statement] = STATE(485),
    [sym_debugger_statement] = STATE(485),
    [sym_return_statement] = STATE(485),
    [sym_throw_statement] = STATE(485),
    [sym_empty_statement] = STATE(485),
    [sym_labeled_statement] = STATE(485),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1102] = {
    [sym_export_statement] = STATE(502),
    [sym__declaration] = STATE(502),
    [sym_import_statement] = STATE(502),
    [sym_expression_statement] = STATE(502),
    [sym_variable_declaration] = STATE(502),
    [sym_lexical_declaration] = STATE(502),
    [sym_statement_block] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_switch_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_for_in_statement] = STATE(502),
    [sym_for_of_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_do_statement] = STATE(502),
    [sym_try_statement] = STATE(502),
    [sym_with_statement] = STATE(502),
    [sym_break_statement] = STATE(502),
    [sym_continue_statement] = STATE(502),
    [sym_debugger_statement] = STATE(502),
    [sym_return_statement] = STATE(502),
    [sym_throw_statement] = STATE(502),
    [sym_empty_statement] = STATE(502),
    [sym_labeled_statement] = STATE(502),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1103] = {
    [sym_export_statement] = STATE(619),
    [sym__declaration] = STATE(619),
    [sym_import_statement] = STATE(619),
    [sym_expression_statement] = STATE(619),
    [sym_variable_declaration] = STATE(619),
    [sym_lexical_declaration] = STATE(619),
    [sym_statement_block] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(619),
    [sym_for_in_statement] = STATE(619),
    [sym_for_of_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_do_statement] = STATE(619),
    [sym_try_statement] = STATE(619),
    [sym_with_statement] = STATE(619),
    [sym_break_statement] = STATE(619),
    [sym_continue_statement] = STATE(619),
    [sym_debugger_statement] = STATE(619),
    [sym_return_statement] = STATE(619),
    [sym_throw_statement] = STATE(619),
    [sym_empty_statement] = STATE(619),
    [sym_labeled_statement] = STATE(619),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1104] = {
    [sym_export_statement] = STATE(1161),
    [sym__declaration] = STATE(1161),
    [sym_import_statement] = STATE(1161),
    [sym_expression_statement] = STATE(1161),
    [sym_variable_declaration] = STATE(1161),
    [sym_lexical_declaration] = STATE(1161),
    [sym_statement_block] = STATE(1161),
    [sym_if_statement] = STATE(1161),
    [sym_switch_statement] = STATE(1161),
    [sym_for_statement] = STATE(1161),
    [sym_for_in_statement] = STATE(1161),
    [sym_for_of_statement] = STATE(1161),
    [sym_while_statement] = STATE(1161),
    [sym_do_statement] = STATE(1161),
    [sym_try_statement] = STATE(1161),
    [sym_with_statement] = STATE(1161),
    [sym_break_statement] = STATE(1161),
    [sym_continue_statement] = STATE(1161),
    [sym_debugger_statement] = STATE(1161),
    [sym_return_statement] = STATE(1161),
    [sym_throw_statement] = STATE(1161),
    [sym_empty_statement] = STATE(1161),
    [sym_labeled_statement] = STATE(1161),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1105] = {
    [sym__initializer] = STATE(363),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(3244),
    [anon_sym_of] = ACTIONS(3246),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1106] = {
    [sym__initializer] = STATE(367),
    [sym__automatic_semicolon] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(3248),
    [anon_sym_of] = ACTIONS(3250),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1107] = {
    [sym__initializer] = STATE(368),
    [sym__automatic_semicolon] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(3252),
    [anon_sym_of] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1108] = {
    [sym_parenthesized_expression] = STATE(1388),
    [sym__expression] = STATE(1388),
    [sym_yield_expression] = STATE(1388),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1388),
    [sym_jsx_fragment] = STATE(1388),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1388),
    [sym_anonymous_class] = STATE(1388),
    [sym_class] = STATE(1388),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1388),
    [sym_generator_function] = STATE(1388),
    [sym_call_expression] = STATE(1388),
    [sym_new_expression] = STATE(1388),
    [sym_await_expression] = STATE(1388),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1388),
    [sym_augmented_assignment_expression] = STATE(1388),
    [sym_ternary_expression] = STATE(1388),
    [sym_binary_expression] = STATE(1388),
    [sym_unary_expression] = STATE(1388),
    [sym_update_expression] = STATE(1388),
    [sym_sequence_expression] = STATE(1389),
    [sym_string] = STATE(1388),
    [sym_template_string] = STATE(1388),
    [sym_regex] = STATE(1388),
    [sym_meta_property] = STATE(1388),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3256),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3258),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3258),
    [sym_false] = ACTIONS(3258),
    [sym_null] = ACTIONS(3258),
    [sym_undefined] = ACTIONS(3258),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1109] = {
    [sym_parenthesized_expression] = STATE(1390),
    [sym__expression] = STATE(1390),
    [sym_yield_expression] = STATE(1390),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1390),
    [sym_jsx_fragment] = STATE(1390),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1390),
    [sym_anonymous_class] = STATE(1390),
    [sym_class] = STATE(1390),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1390),
    [sym_generator_function] = STATE(1390),
    [sym_call_expression] = STATE(1390),
    [sym_new_expression] = STATE(1390),
    [sym_await_expression] = STATE(1390),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1390),
    [sym_augmented_assignment_expression] = STATE(1390),
    [sym_ternary_expression] = STATE(1390),
    [sym_binary_expression] = STATE(1390),
    [sym_unary_expression] = STATE(1390),
    [sym_update_expression] = STATE(1390),
    [sym_string] = STATE(1390),
    [sym_template_string] = STATE(1390),
    [sym_regex] = STATE(1390),
    [sym_meta_property] = STATE(1390),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3260),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3262),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3262),
    [sym_false] = ACTIONS(3262),
    [sym_null] = ACTIONS(3262),
    [sym_undefined] = ACTIONS(3262),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1110] = {
    [sym_parenthesized_expression] = STATE(1392),
    [sym__expression] = STATE(1392),
    [sym_yield_expression] = STATE(1392),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1392),
    [sym_jsx_fragment] = STATE(1392),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1392),
    [sym_anonymous_class] = STATE(1392),
    [sym_class] = STATE(1392),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1392),
    [sym_generator_function] = STATE(1392),
    [sym_call_expression] = STATE(1392),
    [sym_new_expression] = STATE(1392),
    [sym_await_expression] = STATE(1392),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1392),
    [sym_augmented_assignment_expression] = STATE(1392),
    [sym_ternary_expression] = STATE(1392),
    [sym_binary_expression] = STATE(1392),
    [sym_unary_expression] = STATE(1392),
    [sym_update_expression] = STATE(1392),
    [sym_sequence_expression] = STATE(1393),
    [sym_string] = STATE(1392),
    [sym_template_string] = STATE(1392),
    [sym_regex] = STATE(1392),
    [sym_meta_property] = STATE(1392),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(3264),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3266),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3268),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3268),
    [sym_false] = ACTIONS(3268),
    [sym_null] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1111] = {
    [sym_parenthesized_expression] = STATE(1394),
    [sym__expression] = STATE(1394),
    [sym_yield_expression] = STATE(1394),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1394),
    [sym_jsx_fragment] = STATE(1394),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1394),
    [sym_anonymous_class] = STATE(1394),
    [sym_class] = STATE(1394),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1394),
    [sym_generator_function] = STATE(1394),
    [sym_call_expression] = STATE(1394),
    [sym_new_expression] = STATE(1394),
    [sym_await_expression] = STATE(1394),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1394),
    [sym_augmented_assignment_expression] = STATE(1394),
    [sym_ternary_expression] = STATE(1394),
    [sym_binary_expression] = STATE(1394),
    [sym_unary_expression] = STATE(1394),
    [sym_update_expression] = STATE(1394),
    [sym_sequence_expression] = STATE(1395),
    [sym_string] = STATE(1394),
    [sym_template_string] = STATE(1394),
    [sym_regex] = STATE(1394),
    [sym_meta_property] = STATE(1394),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3270),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3272),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3272),
    [sym_false] = ACTIONS(3272),
    [sym_null] = ACTIONS(3272),
    [sym_undefined] = ACTIONS(3272),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1112] = {
    [sym_parenthesized_expression] = STATE(1396),
    [sym__expression] = STATE(1396),
    [sym_yield_expression] = STATE(1396),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1396),
    [sym_jsx_fragment] = STATE(1396),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1396),
    [sym_anonymous_class] = STATE(1396),
    [sym_class] = STATE(1396),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1396),
    [sym_generator_function] = STATE(1396),
    [sym_call_expression] = STATE(1396),
    [sym_new_expression] = STATE(1396),
    [sym_await_expression] = STATE(1396),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1396),
    [sym_augmented_assignment_expression] = STATE(1396),
    [sym_ternary_expression] = STATE(1396),
    [sym_binary_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1396),
    [sym_update_expression] = STATE(1396),
    [sym_string] = STATE(1396),
    [sym_template_string] = STATE(1396),
    [sym_regex] = STATE(1396),
    [sym_meta_property] = STATE(1396),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3276),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3276),
    [sym_false] = ACTIONS(3276),
    [sym_null] = ACTIONS(3276),
    [sym_undefined] = ACTIONS(3276),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1113] = {
    [sym_parenthesized_expression] = STATE(1397),
    [sym__expression] = STATE(1397),
    [sym_yield_expression] = STATE(1397),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1397),
    [sym_jsx_fragment] = STATE(1397),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1397),
    [sym_anonymous_class] = STATE(1397),
    [sym_class] = STATE(1397),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1397),
    [sym_generator_function] = STATE(1397),
    [sym_call_expression] = STATE(1397),
    [sym_new_expression] = STATE(1397),
    [sym_await_expression] = STATE(1397),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1397),
    [sym_augmented_assignment_expression] = STATE(1397),
    [sym_ternary_expression] = STATE(1397),
    [sym_binary_expression] = STATE(1397),
    [sym_unary_expression] = STATE(1397),
    [sym_update_expression] = STATE(1397),
    [sym_sequence_expression] = STATE(1398),
    [sym_string] = STATE(1397),
    [sym_template_string] = STATE(1397),
    [sym_regex] = STATE(1397),
    [sym_meta_property] = STATE(1397),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3280),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3280),
    [sym_false] = ACTIONS(3280),
    [sym_null] = ACTIONS(3280),
    [sym_undefined] = ACTIONS(3280),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1114] = {
    [sym_parenthesized_expression] = STATE(1399),
    [sym__expression] = STATE(1399),
    [sym_yield_expression] = STATE(1399),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1399),
    [sym_jsx_fragment] = STATE(1399),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1399),
    [sym_anonymous_class] = STATE(1399),
    [sym_class] = STATE(1399),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1399),
    [sym_generator_function] = STATE(1399),
    [sym_call_expression] = STATE(1399),
    [sym_new_expression] = STATE(1399),
    [sym_await_expression] = STATE(1399),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1399),
    [sym_augmented_assignment_expression] = STATE(1399),
    [sym_ternary_expression] = STATE(1399),
    [sym_binary_expression] = STATE(1399),
    [sym_unary_expression] = STATE(1399),
    [sym_update_expression] = STATE(1399),
    [sym_string] = STATE(1399),
    [sym_template_string] = STATE(1399),
    [sym_regex] = STATE(1399),
    [sym_meta_property] = STATE(1399),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3282),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3284),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3284),
    [sym_false] = ACTIONS(3284),
    [sym_null] = ACTIONS(3284),
    [sym_undefined] = ACTIONS(3284),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1115] = {
    [sym_object] = STATE(1401),
    [sym_array] = STATE(1402),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3286),
  },
  [1116] = {
    [anon_sym_of] = ACTIONS(3246),
    [sym_comment] = ACTIONS(78),
  },
  [1117] = {
    [anon_sym_of] = ACTIONS(3250),
    [sym_comment] = ACTIONS(78),
  },
  [1118] = {
    [anon_sym_of] = ACTIONS(3254),
    [sym_comment] = ACTIONS(78),
  },
  [1119] = {
    [sym_statement_block] = STATE(1403),
    [anon_sym_LBRACE] = ACTIONS(226),
    [sym_comment] = ACTIONS(78),
  },
  [1120] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1121] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2135),
    [anon_sym_RBRACE] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1122] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1404),
    [sym__expression] = STATE(1404),
    [sym_yield_expression] = STATE(1404),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1404),
    [sym_jsx_fragment] = STATE(1404),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1404),
    [sym_anonymous_class] = STATE(1404),
    [sym_class] = STATE(1404),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1404),
    [sym_generator_function] = STATE(1404),
    [sym_call_expression] = STATE(1404),
    [sym_new_expression] = STATE(1404),
    [sym_await_expression] = STATE(1404),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1404),
    [sym_augmented_assignment_expression] = STATE(1404),
    [sym_ternary_expression] = STATE(1404),
    [sym_binary_expression] = STATE(1404),
    [sym_unary_expression] = STATE(1404),
    [sym_update_expression] = STATE(1404),
    [sym_string] = STATE(1404),
    [sym_template_string] = STATE(1404),
    [sym_regex] = STATE(1404),
    [sym_meta_property] = STATE(1404),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3288),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(3290),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3290),
    [sym_false] = ACTIONS(3290),
    [sym_null] = ACTIONS(3290),
    [sym_undefined] = ACTIONS(3290),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [1123] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1124] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1125] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1126] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1127] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1128] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1129] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1130] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(897),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1131] = {
    [sym_statement_block] = STATE(581),
    [sym_parenthesized_expression] = STATE(1406),
    [sym__expression] = STATE(1406),
    [sym_yield_expression] = STATE(1406),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1406),
    [sym_jsx_fragment] = STATE(1406),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1406),
    [sym_anonymous_class] = STATE(1406),
    [sym_class] = STATE(1406),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1406),
    [sym_generator_function] = STATE(1406),
    [sym_call_expression] = STATE(1406),
    [sym_new_expression] = STATE(1406),
    [sym_await_expression] = STATE(1406),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1406),
    [sym_augmented_assignment_expression] = STATE(1406),
    [sym_ternary_expression] = STATE(1406),
    [sym_binary_expression] = STATE(1406),
    [sym_unary_expression] = STATE(1406),
    [sym_update_expression] = STATE(1406),
    [sym_string] = STATE(1406),
    [sym_template_string] = STATE(1406),
    [sym_regex] = STATE(1406),
    [sym_meta_property] = STATE(1406),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3294),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(3296),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3296),
    [sym_false] = ACTIONS(3296),
    [sym_null] = ACTIONS(3296),
    [sym_undefined] = ACTIONS(3296),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1132] = {
    [sym_parenthesized_expression] = STATE(1407),
    [sym__expression] = STATE(1407),
    [sym_yield_expression] = STATE(1407),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1407),
    [sym_jsx_fragment] = STATE(1407),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1407),
    [sym_anonymous_class] = STATE(1407),
    [sym_class] = STATE(1407),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1407),
    [sym_generator_function] = STATE(1407),
    [sym_call_expression] = STATE(1407),
    [sym_new_expression] = STATE(1407),
    [sym_await_expression] = STATE(1407),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1407),
    [sym_augmented_assignment_expression] = STATE(1407),
    [sym_ternary_expression] = STATE(1407),
    [sym_binary_expression] = STATE(1407),
    [sym_unary_expression] = STATE(1407),
    [sym_update_expression] = STATE(1407),
    [sym_string] = STATE(1407),
    [sym_template_string] = STATE(1407),
    [sym_regex] = STATE(1407),
    [sym_meta_property] = STATE(1407),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3298),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(3300),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3300),
    [sym_false] = ACTIONS(3300),
    [sym_null] = ACTIONS(3300),
    [sym_undefined] = ACTIONS(3300),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1133] = {
    [anon_sym_EQ_GT] = ACTIONS(3302),
    [sym_comment] = ACTIONS(78),
  },
  [1134] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1135] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(603),
    [sym_formal_parameters] = STATE(1133),
    [sym__automatic_semicolon] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(2561),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(2565),
  },
  [1136] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(604),
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(2561),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [1137] = {
    [sym_parenthesized_expression] = STATE(1409),
    [sym__expression] = STATE(1409),
    [sym_yield_expression] = STATE(1409),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1409),
    [sym_jsx_fragment] = STATE(1409),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1409),
    [sym_anonymous_class] = STATE(1409),
    [sym_class] = STATE(1409),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1409),
    [sym_generator_function] = STATE(1409),
    [sym_call_expression] = STATE(1409),
    [sym_new_expression] = STATE(1409),
    [sym_await_expression] = STATE(1409),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1409),
    [sym_augmented_assignment_expression] = STATE(1409),
    [sym_ternary_expression] = STATE(1409),
    [sym_binary_expression] = STATE(1409),
    [sym_unary_expression] = STATE(1409),
    [sym_update_expression] = STATE(1409),
    [sym_string] = STATE(1409),
    [sym_template_string] = STATE(1409),
    [sym_regex] = STATE(1409),
    [sym_meta_property] = STATE(1409),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3304),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(3306),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3306),
    [sym_false] = ACTIONS(3306),
    [sym_null] = ACTIONS(3306),
    [sym_undefined] = ACTIONS(3306),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1138] = {
    [sym_parenthesized_expression] = STATE(1410),
    [sym__expression] = STATE(1410),
    [sym_yield_expression] = STATE(1410),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1410),
    [sym_jsx_fragment] = STATE(1410),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1410),
    [sym_anonymous_class] = STATE(1410),
    [sym_class] = STATE(1410),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1410),
    [sym_generator_function] = STATE(1410),
    [sym_call_expression] = STATE(1410),
    [sym_new_expression] = STATE(1410),
    [sym_await_expression] = STATE(1410),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1410),
    [sym_augmented_assignment_expression] = STATE(1410),
    [sym_ternary_expression] = STATE(1410),
    [sym_binary_expression] = STATE(1410),
    [sym_unary_expression] = STATE(1410),
    [sym_update_expression] = STATE(1410),
    [sym_string] = STATE(1410),
    [sym_template_string] = STATE(1410),
    [sym_regex] = STATE(1410),
    [sym_meta_property] = STATE(1410),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3308),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(3310),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3310),
    [sym_false] = ACTIONS(3310),
    [sym_null] = ACTIONS(3310),
    [sym_undefined] = ACTIONS(3310),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1139] = {
    [sym_parenthesized_expression] = STATE(632),
    [sym__expression] = STATE(632),
    [sym_yield_expression] = STATE(632),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(632),
    [sym_jsx_fragment] = STATE(632),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(632),
    [sym_anonymous_class] = STATE(632),
    [sym_class] = STATE(632),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(632),
    [sym_generator_function] = STATE(632),
    [sym_call_expression] = STATE(632),
    [sym_new_expression] = STATE(632),
    [sym_await_expression] = STATE(632),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(632),
    [sym_augmented_assignment_expression] = STATE(632),
    [sym_ternary_expression] = STATE(632),
    [sym_binary_expression] = STATE(632),
    [sym_unary_expression] = STATE(632),
    [sym_update_expression] = STATE(632),
    [sym_string] = STATE(632),
    [sym_template_string] = STATE(632),
    [sym_regex] = STATE(632),
    [sym_meta_property] = STATE(632),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(1191),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1191),
    [sym_false] = ACTIONS(1191),
    [sym_null] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1140] = {
    [sym_parenthesized_expression] = STATE(1411),
    [sym__expression] = STATE(1411),
    [sym_yield_expression] = STATE(1411),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1411),
    [sym_jsx_fragment] = STATE(1411),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1411),
    [sym_anonymous_class] = STATE(1411),
    [sym_class] = STATE(1411),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1411),
    [sym_generator_function] = STATE(1411),
    [sym_call_expression] = STATE(1411),
    [sym_new_expression] = STATE(1411),
    [sym_await_expression] = STATE(1411),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1411),
    [sym_augmented_assignment_expression] = STATE(1411),
    [sym_ternary_expression] = STATE(1411),
    [sym_binary_expression] = STATE(1411),
    [sym_unary_expression] = STATE(1411),
    [sym_update_expression] = STATE(1411),
    [sym_string] = STATE(1411),
    [sym_template_string] = STATE(1411),
    [sym_regex] = STATE(1411),
    [sym_meta_property] = STATE(1411),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3314),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_undefined] = ACTIONS(3314),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1141] = {
    [sym_parenthesized_expression] = STATE(1412),
    [sym__expression] = STATE(1412),
    [sym_yield_expression] = STATE(1412),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1412),
    [sym_jsx_fragment] = STATE(1412),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1412),
    [sym_anonymous_class] = STATE(1412),
    [sym_class] = STATE(1412),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1412),
    [sym_generator_function] = STATE(1412),
    [sym_call_expression] = STATE(1412),
    [sym_new_expression] = STATE(1412),
    [sym_await_expression] = STATE(1412),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1412),
    [sym_augmented_assignment_expression] = STATE(1412),
    [sym_ternary_expression] = STATE(1412),
    [sym_binary_expression] = STATE(1412),
    [sym_unary_expression] = STATE(1412),
    [sym_update_expression] = STATE(1412),
    [sym_string] = STATE(1412),
    [sym_template_string] = STATE(1412),
    [sym_regex] = STATE(1412),
    [sym_meta_property] = STATE(1412),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3316),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(3318),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3318),
    [sym_false] = ACTIONS(3318),
    [sym_null] = ACTIONS(3318),
    [sym_undefined] = ACTIONS(3318),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1142] = {
    [sym_parenthesized_expression] = STATE(1413),
    [sym__expression] = STATE(1413),
    [sym_yield_expression] = STATE(1413),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1413),
    [sym_jsx_fragment] = STATE(1413),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1413),
    [sym_anonymous_class] = STATE(1413),
    [sym_class] = STATE(1413),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1413),
    [sym_generator_function] = STATE(1413),
    [sym_call_expression] = STATE(1413),
    [sym_new_expression] = STATE(1413),
    [sym_await_expression] = STATE(1413),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1413),
    [sym_augmented_assignment_expression] = STATE(1413),
    [sym_ternary_expression] = STATE(1413),
    [sym_binary_expression] = STATE(1413),
    [sym_unary_expression] = STATE(1413),
    [sym_update_expression] = STATE(1413),
    [sym_string] = STATE(1413),
    [sym_template_string] = STATE(1413),
    [sym_regex] = STATE(1413),
    [sym_meta_property] = STATE(1413),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3320),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(3322),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3322),
    [sym_false] = ACTIONS(3322),
    [sym_null] = ACTIONS(3322),
    [sym_undefined] = ACTIONS(3322),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1143] = {
    [sym_parenthesized_expression] = STATE(1414),
    [sym__expression] = STATE(1414),
    [sym_yield_expression] = STATE(1414),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1414),
    [sym_jsx_fragment] = STATE(1414),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1414),
    [sym_anonymous_class] = STATE(1414),
    [sym_class] = STATE(1414),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1414),
    [sym_generator_function] = STATE(1414),
    [sym_call_expression] = STATE(1414),
    [sym_new_expression] = STATE(1414),
    [sym_await_expression] = STATE(1414),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1414),
    [sym_augmented_assignment_expression] = STATE(1414),
    [sym_ternary_expression] = STATE(1414),
    [sym_binary_expression] = STATE(1414),
    [sym_unary_expression] = STATE(1414),
    [sym_update_expression] = STATE(1414),
    [sym_string] = STATE(1414),
    [sym_template_string] = STATE(1414),
    [sym_regex] = STATE(1414),
    [sym_meta_property] = STATE(1414),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3324),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(3326),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3326),
    [sym_false] = ACTIONS(3326),
    [sym_null] = ACTIONS(3326),
    [sym_undefined] = ACTIONS(3326),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1144] = {
    [sym__automatic_semicolon] = ACTIONS(3328),
    [anon_sym_STAR] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3330),
    [anon_sym_of] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_DOT] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_GT_GT] = ACTIONS(3330),
    [anon_sym_GT_GT_GT] = ACTIONS(3328),
    [anon_sym_LT_LT] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3330),
    [anon_sym_CARET] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_PERCENT] = ACTIONS(3328),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_EQ_EQ] = ACTIONS(3330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3330),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_instanceof] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3328),
  },
  [1145] = {
    [anon_sym_from] = ACTIONS(3332),
    [sym_comment] = ACTIONS(78),
  },
  [1146] = {
    [anon_sym_COMMA] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [sym_comment] = ACTIONS(78),
  },
  [1147] = {
    [sym__import_export_specifier] = STATE(1146),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(477),
  },
  [1148] = {
    [aux_sym_named_imports_repeat1] = STATE(1148),
    [anon_sym_COMMA] = ACTIONS(3338),
    [anon_sym_RBRACE] = ACTIONS(3341),
    [sym_comment] = ACTIONS(78),
  },
  [1149] = {
    [sym__automatic_semicolon] = ACTIONS(2515),
    [anon_sym_COMMA] = ACTIONS(2515),
    [anon_sym_in] = ACTIONS(2515),
    [anon_sym_of] = ACTIONS(2515),
    [anon_sym_SEMI] = ACTIONS(2515),
    [anon_sym_EQ] = ACTIONS(2515),
    [sym_comment] = ACTIONS(78),
  },
  [1150] = {
    [sym__automatic_semicolon] = ACTIONS(2597),
    [anon_sym_COMMA] = ACTIONS(2597),
    [anon_sym_in] = ACTIONS(2597),
    [anon_sym_of] = ACTIONS(2597),
    [anon_sym_SEMI] = ACTIONS(2597),
    [anon_sym_EQ] = ACTIONS(2597),
    [sym_comment] = ACTIONS(78),
  },
  [1151] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(3343),
    [sym_comment] = ACTIONS(78),
  },
  [1152] = {
    [sym__automatic_semicolon] = ACTIONS(2875),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_in] = ACTIONS(2875),
    [anon_sym_of] = ACTIONS(2875),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_EQ] = ACTIONS(2875),
    [sym_comment] = ACTIONS(78),
  },
  [1153] = {
    [ts_builtin_sym_end] = ACTIONS(1722),
    [anon_sym_export] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_import] = ACTIONS(1724),
    [anon_sym_var] = ACTIONS(1724),
    [anon_sym_let] = ACTIONS(1724),
    [anon_sym_const] = ACTIONS(1724),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_else] = ACTIONS(3345),
    [anon_sym_switch] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1724),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_await] = ACTIONS(1724),
    [anon_sym_while] = ACTIONS(1724),
    [anon_sym_do] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(1724),
    [anon_sym_with] = ACTIONS(1724),
    [anon_sym_break] = ACTIONS(1724),
    [anon_sym_continue] = ACTIONS(1724),
    [anon_sym_debugger] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1724),
    [anon_sym_throw] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_yield] = ACTIONS(1724),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1724),
    [anon_sym_class] = ACTIONS(1724),
    [anon_sym_async] = ACTIONS(1724),
    [anon_sym_function] = ACTIONS(1724),
    [anon_sym_EQ_GT] = ACTIONS(1722),
    [anon_sym_new] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_typeof] = ACTIONS(1724),
    [anon_sym_void] = ACTIONS(1724),
    [anon_sym_delete] = ACTIONS(1724),
    [anon_sym_PLUS_PLUS] = ACTIONS(1722),
    [anon_sym_DASH_DASH] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [sym_number] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1724),
    [sym_this] = ACTIONS(1724),
    [sym_super] = ACTIONS(1724),
    [sym_true] = ACTIONS(1724),
    [sym_false] = ACTIONS(1724),
    [sym_null] = ACTIONS(1724),
    [sym_undefined] = ACTIONS(1724),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_get] = ACTIONS(1724),
    [anon_sym_set] = ACTIONS(1724),
  },
  [1154] = {
    [sym_variable_declarator] = STATE(93),
    [sym_object] = STATE(1420),
    [sym_array] = STATE(1421),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3347),
  },
  [1155] = {
    [sym_variable_declarator] = STATE(96),
    [sym_object] = STATE(1420),
    [sym_array] = STATE(1421),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3347),
  },
  [1156] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3349),
    [anon_sym_of] = ACTIONS(3351),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1157] = {
    [sym_expression_statement] = STATE(1424),
    [sym_empty_statement] = STATE(1424),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1158] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3353),
    [anon_sym_of] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1159] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3357),
    [anon_sym_of] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1160] = {
    [sym_object] = STATE(1431),
    [sym_array] = STATE(1432),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_var] = ACTIONS(3361),
    [anon_sym_let] = ACTIONS(3361),
    [anon_sym_const] = ACTIONS(3361),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3363),
  },
  [1161] = {
    [ts_builtin_sym_end] = ACTIONS(3365),
    [anon_sym_export] = ACTIONS(3367),
    [anon_sym_default] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3365),
    [anon_sym_RBRACE] = ACTIONS(3365),
    [anon_sym_import] = ACTIONS(3367),
    [anon_sym_var] = ACTIONS(3367),
    [anon_sym_let] = ACTIONS(3367),
    [anon_sym_const] = ACTIONS(3367),
    [anon_sym_if] = ACTIONS(3367),
    [anon_sym_else] = ACTIONS(3367),
    [anon_sym_switch] = ACTIONS(3367),
    [anon_sym_for] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3365),
    [anon_sym_await] = ACTIONS(3367),
    [anon_sym_while] = ACTIONS(3367),
    [anon_sym_do] = ACTIONS(3367),
    [anon_sym_try] = ACTIONS(3367),
    [anon_sym_with] = ACTIONS(3367),
    [anon_sym_break] = ACTIONS(3367),
    [anon_sym_continue] = ACTIONS(3367),
    [anon_sym_debugger] = ACTIONS(3367),
    [anon_sym_return] = ACTIONS(3367),
    [anon_sym_throw] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3365),
    [anon_sym_case] = ACTIONS(3367),
    [anon_sym_yield] = ACTIONS(3367),
    [anon_sym_LBRACK] = ACTIONS(3365),
    [anon_sym_LT] = ACTIONS(3365),
    [anon_sym_SLASH] = ACTIONS(3367),
    [anon_sym_class] = ACTIONS(3367),
    [anon_sym_async] = ACTIONS(3367),
    [anon_sym_function] = ACTIONS(3367),
    [anon_sym_EQ_GT] = ACTIONS(3365),
    [anon_sym_new] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3365),
    [anon_sym_TILDE] = ACTIONS(3365),
    [anon_sym_typeof] = ACTIONS(3367),
    [anon_sym_void] = ACTIONS(3367),
    [anon_sym_delete] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3365),
    [anon_sym_DASH_DASH] = ACTIONS(3365),
    [anon_sym_DQUOTE] = ACTIONS(3365),
    [anon_sym_SQUOTE] = ACTIONS(3365),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3365),
    [sym_number] = ACTIONS(3365),
    [sym_identifier] = ACTIONS(3367),
    [sym_this] = ACTIONS(3367),
    [sym_super] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_null] = ACTIONS(3367),
    [sym_undefined] = ACTIONS(3367),
    [anon_sym_AT] = ACTIONS(3365),
    [anon_sym_get] = ACTIONS(3367),
    [anon_sym_set] = ACTIONS(3367),
  },
  [1162] = {
    [sym_export_statement] = STATE(1438),
    [sym__declaration] = STATE(1438),
    [sym_import_statement] = STATE(1438),
    [sym_expression_statement] = STATE(1438),
    [sym_variable_declaration] = STATE(1438),
    [sym_lexical_declaration] = STATE(1438),
    [sym_statement_block] = STATE(1438),
    [sym_if_statement] = STATE(1438),
    [sym_switch_statement] = STATE(1438),
    [sym_for_statement] = STATE(1438),
    [sym_for_in_statement] = STATE(1438),
    [sym_for_of_statement] = STATE(1438),
    [sym_while_statement] = STATE(1438),
    [sym_do_statement] = STATE(1438),
    [sym_try_statement] = STATE(1438),
    [sym_with_statement] = STATE(1438),
    [sym_break_statement] = STATE(1438),
    [sym_continue_statement] = STATE(1438),
    [sym_debugger_statement] = STATE(1438),
    [sym_return_statement] = STATE(1438),
    [sym_throw_statement] = STATE(1438),
    [sym_empty_statement] = STATE(1438),
    [sym_labeled_statement] = STATE(1438),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(1438),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_default] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_case] = ACTIONS(3369),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1163] = {
    [sym_parenthesized_expression] = STATE(1439),
    [sym__expression] = STATE(1439),
    [sym_yield_expression] = STATE(1439),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1439),
    [sym_jsx_fragment] = STATE(1439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1439),
    [sym_anonymous_class] = STATE(1439),
    [sym_class] = STATE(1439),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1439),
    [sym_generator_function] = STATE(1439),
    [sym_call_expression] = STATE(1439),
    [sym_new_expression] = STATE(1439),
    [sym_await_expression] = STATE(1439),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1439),
    [sym_augmented_assignment_expression] = STATE(1439),
    [sym_ternary_expression] = STATE(1439),
    [sym_binary_expression] = STATE(1439),
    [sym_unary_expression] = STATE(1439),
    [sym_update_expression] = STATE(1439),
    [sym_string] = STATE(1439),
    [sym_template_string] = STATE(1439),
    [sym_regex] = STATE(1439),
    [sym_meta_property] = STATE(1439),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3383),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3385),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3385),
    [sym_false] = ACTIONS(3385),
    [sym_null] = ACTIONS(3385),
    [sym_undefined] = ACTIONS(3385),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1164] = {
    [sym_parenthesized_expression] = STATE(1440),
    [sym__expression] = STATE(1440),
    [sym_yield_expression] = STATE(1440),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1440),
    [sym_jsx_fragment] = STATE(1440),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1440),
    [sym_anonymous_class] = STATE(1440),
    [sym_class] = STATE(1440),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1440),
    [sym_generator_function] = STATE(1440),
    [sym_call_expression] = STATE(1440),
    [sym_new_expression] = STATE(1440),
    [sym_await_expression] = STATE(1440),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1440),
    [sym_augmented_assignment_expression] = STATE(1440),
    [sym_ternary_expression] = STATE(1440),
    [sym_binary_expression] = STATE(1440),
    [sym_unary_expression] = STATE(1440),
    [sym_update_expression] = STATE(1440),
    [sym_string] = STATE(1440),
    [sym_template_string] = STATE(1440),
    [sym_regex] = STATE(1440),
    [sym_meta_property] = STATE(1440),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_COLON] = ACTIONS(252),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(2668),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3387),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3389),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3389),
    [sym_false] = ACTIONS(3389),
    [sym_null] = ACTIONS(3389),
    [sym_undefined] = ACTIONS(3389),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1165] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(1444),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_COLON] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(3391),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(3393),
    [anon_sym_PLUS_EQ] = ACTIONS(3395),
    [anon_sym_DASH_EQ] = ACTIONS(3395),
    [anon_sym_STAR_EQ] = ACTIONS(3395),
    [anon_sym_SLASH_EQ] = ACTIONS(3395),
    [anon_sym_PERCENT_EQ] = ACTIONS(3395),
    [anon_sym_CARET_EQ] = ACTIONS(3395),
    [anon_sym_AMP_EQ] = ACTIONS(3395),
    [anon_sym_PIPE_EQ] = ACTIONS(3395),
    [anon_sym_GT_GT_EQ] = ACTIONS(3395),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3395),
    [anon_sym_LT_LT_EQ] = ACTIONS(3395),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(3397),
  },
  [1166] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(1445),
    [sym__expression] = STATE(1445),
    [sym_yield_expression] = STATE(1445),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1445),
    [sym_jsx_fragment] = STATE(1445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1445),
    [sym_anonymous_class] = STATE(1445),
    [sym_class] = STATE(1445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1445),
    [sym_generator_function] = STATE(1445),
    [sym_call_expression] = STATE(1445),
    [sym_new_expression] = STATE(1445),
    [sym_await_expression] = STATE(1445),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1445),
    [sym_augmented_assignment_expression] = STATE(1445),
    [sym_ternary_expression] = STATE(1445),
    [sym_binary_expression] = STATE(1445),
    [sym_unary_expression] = STATE(1445),
    [sym_update_expression] = STATE(1445),
    [sym_string] = STATE(1445),
    [sym_template_string] = STATE(1445),
    [sym_regex] = STATE(1445),
    [sym_meta_property] = STATE(1445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3399),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3401),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3401),
    [sym_false] = ACTIONS(3401),
    [sym_null] = ACTIONS(3401),
    [sym_undefined] = ACTIONS(3401),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1167] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(3403),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(3405),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [1168] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1169] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1170] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(3391),
    [anon_sym_EQ_GT] = ACTIONS(3393),
    [anon_sym_PLUS_EQ] = ACTIONS(3409),
    [anon_sym_DASH_EQ] = ACTIONS(3409),
    [anon_sym_STAR_EQ] = ACTIONS(3409),
    [anon_sym_SLASH_EQ] = ACTIONS(3409),
    [anon_sym_PERCENT_EQ] = ACTIONS(3409),
    [anon_sym_CARET_EQ] = ACTIONS(3409),
    [anon_sym_AMP_EQ] = ACTIONS(3409),
    [anon_sym_PIPE_EQ] = ACTIONS(3409),
    [anon_sym_GT_GT_EQ] = ACTIONS(3409),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3409),
    [anon_sym_LT_LT_EQ] = ACTIONS(3409),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1171] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_COLON] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(3391),
    [anon_sym_PLUS_EQ] = ACTIONS(3395),
    [anon_sym_DASH_EQ] = ACTIONS(3395),
    [anon_sym_STAR_EQ] = ACTIONS(3395),
    [anon_sym_SLASH_EQ] = ACTIONS(3395),
    [anon_sym_PERCENT_EQ] = ACTIONS(3395),
    [anon_sym_CARET_EQ] = ACTIONS(3395),
    [anon_sym_AMP_EQ] = ACTIONS(3395),
    [anon_sym_PIPE_EQ] = ACTIONS(3395),
    [anon_sym_GT_GT_EQ] = ACTIONS(3395),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3395),
    [anon_sym_LT_LT_EQ] = ACTIONS(3395),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [1172] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(3415),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1173] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3391),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1174] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3391),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1175] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_COLON] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3391),
    [anon_sym_PLUS_EQ] = ACTIONS(3409),
    [anon_sym_DASH_EQ] = ACTIONS(3409),
    [anon_sym_STAR_EQ] = ACTIONS(3409),
    [anon_sym_SLASH_EQ] = ACTIONS(3409),
    [anon_sym_PERCENT_EQ] = ACTIONS(3409),
    [anon_sym_CARET_EQ] = ACTIONS(3409),
    [anon_sym_AMP_EQ] = ACTIONS(3409),
    [anon_sym_PIPE_EQ] = ACTIONS(3409),
    [anon_sym_GT_GT_EQ] = ACTIONS(3409),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3409),
    [anon_sym_LT_LT_EQ] = ACTIONS(3409),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1176] = {
    [anon_sym_COLON] = ACTIONS(3415),
    [sym_comment] = ACTIONS(78),
  },
  [1177] = {
    [anon_sym_EQ_GT] = ACTIONS(3393),
    [sym_comment] = ACTIONS(78),
  },
  [1178] = {
    [ts_builtin_sym_end] = ACTIONS(3433),
    [anon_sym_export] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_import] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_else] = ACTIONS(3435),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_with] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_debugger] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LT] = ACTIONS(3433),
    [anon_sym_SLASH] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_function] = ACTIONS(3435),
    [anon_sym_EQ_GT] = ACTIONS(3433),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym_void] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3433),
    [sym_number] = ACTIONS(3433),
    [sym_identifier] = ACTIONS(3435),
    [sym_this] = ACTIONS(3435),
    [sym_super] = ACTIONS(3435),
    [sym_true] = ACTIONS(3435),
    [sym_false] = ACTIONS(3435),
    [sym_null] = ACTIONS(3435),
    [sym_undefined] = ACTIONS(3435),
    [anon_sym_AT] = ACTIONS(3433),
    [anon_sym_get] = ACTIONS(3435),
    [anon_sym_set] = ACTIONS(3435),
  },
  [1179] = {
    [sym_switch_case] = STATE(1179),
    [sym_switch_default] = STATE(1179),
    [aux_sym_switch_body_repeat1] = STATE(1179),
    [anon_sym_default] = ACTIONS(3437),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_case] = ACTIONS(3442),
    [sym_comment] = ACTIONS(78),
  },
  [1180] = {
    [sym_parenthesized_expression] = STATE(1457),
    [sym__expression] = STATE(1457),
    [sym_yield_expression] = STATE(1457),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1457),
    [sym_jsx_fragment] = STATE(1457),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1457),
    [sym_anonymous_class] = STATE(1457),
    [sym_class] = STATE(1457),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1457),
    [sym_generator_function] = STATE(1457),
    [sym_call_expression] = STATE(1457),
    [sym_new_expression] = STATE(1457),
    [sym_await_expression] = STATE(1457),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1457),
    [sym_augmented_assignment_expression] = STATE(1457),
    [sym_ternary_expression] = STATE(1457),
    [sym_binary_expression] = STATE(1457),
    [sym_unary_expression] = STATE(1457),
    [sym_update_expression] = STATE(1457),
    [sym_sequence_expression] = STATE(1458),
    [sym_string] = STATE(1457),
    [sym_template_string] = STATE(1457),
    [sym_regex] = STATE(1457),
    [sym_meta_property] = STATE(1457),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3445),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3447),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [sym_null] = ACTIONS(3447),
    [sym_undefined] = ACTIONS(3447),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1181] = {
    [sym_parenthesized_expression] = STATE(1459),
    [sym__expression] = STATE(1459),
    [sym_yield_expression] = STATE(1459),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1459),
    [sym_jsx_fragment] = STATE(1459),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1459),
    [sym_anonymous_class] = STATE(1459),
    [sym_class] = STATE(1459),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1459),
    [sym_generator_function] = STATE(1459),
    [sym_call_expression] = STATE(1459),
    [sym_new_expression] = STATE(1459),
    [sym_await_expression] = STATE(1459),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1459),
    [sym_augmented_assignment_expression] = STATE(1459),
    [sym_ternary_expression] = STATE(1459),
    [sym_binary_expression] = STATE(1459),
    [sym_unary_expression] = STATE(1459),
    [sym_update_expression] = STATE(1459),
    [sym_string] = STATE(1459),
    [sym_template_string] = STATE(1459),
    [sym_regex] = STATE(1459),
    [sym_meta_property] = STATE(1459),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3449),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3451),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3451),
    [sym_false] = ACTIONS(3451),
    [sym_null] = ACTIONS(3451),
    [sym_undefined] = ACTIONS(3451),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1182] = {
    [sym_parenthesized_expression] = STATE(1460),
    [sym__expression] = STATE(1460),
    [sym_yield_expression] = STATE(1460),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1460),
    [sym_jsx_fragment] = STATE(1460),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1460),
    [sym_anonymous_class] = STATE(1460),
    [sym_class] = STATE(1460),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1460),
    [sym_generator_function] = STATE(1460),
    [sym_call_expression] = STATE(1460),
    [sym_new_expression] = STATE(1460),
    [sym_await_expression] = STATE(1460),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1460),
    [sym_augmented_assignment_expression] = STATE(1460),
    [sym_ternary_expression] = STATE(1460),
    [sym_binary_expression] = STATE(1460),
    [sym_unary_expression] = STATE(1460),
    [sym_update_expression] = STATE(1460),
    [sym_sequence_expression] = STATE(1461),
    [sym_string] = STATE(1460),
    [sym_template_string] = STATE(1460),
    [sym_regex] = STATE(1460),
    [sym_meta_property] = STATE(1460),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3453),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3455),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [sym_null] = ACTIONS(3455),
    [sym_undefined] = ACTIONS(3455),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1183] = {
    [sym_parenthesized_expression] = STATE(1462),
    [sym__expression] = STATE(1462),
    [sym_yield_expression] = STATE(1462),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1462),
    [sym_jsx_fragment] = STATE(1462),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1462),
    [sym_anonymous_class] = STATE(1462),
    [sym_class] = STATE(1462),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1462),
    [sym_generator_function] = STATE(1462),
    [sym_call_expression] = STATE(1462),
    [sym_new_expression] = STATE(1462),
    [sym_await_expression] = STATE(1462),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1462),
    [sym_augmented_assignment_expression] = STATE(1462),
    [sym_ternary_expression] = STATE(1462),
    [sym_binary_expression] = STATE(1462),
    [sym_unary_expression] = STATE(1462),
    [sym_update_expression] = STATE(1462),
    [sym_string] = STATE(1462),
    [sym_template_string] = STATE(1462),
    [sym_regex] = STATE(1462),
    [sym_meta_property] = STATE(1462),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3457),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3459),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3459),
    [sym_false] = ACTIONS(3459),
    [sym_null] = ACTIONS(3459),
    [sym_undefined] = ACTIONS(3459),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1184] = {
    [sym_parenthesized_expression] = STATE(1463),
    [sym__expression] = STATE(1463),
    [sym_yield_expression] = STATE(1463),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1463),
    [sym_jsx_fragment] = STATE(1463),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1463),
    [sym_anonymous_class] = STATE(1463),
    [sym_class] = STATE(1463),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1463),
    [sym_generator_function] = STATE(1463),
    [sym_call_expression] = STATE(1463),
    [sym_new_expression] = STATE(1463),
    [sym_await_expression] = STATE(1463),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1463),
    [sym_augmented_assignment_expression] = STATE(1463),
    [sym_ternary_expression] = STATE(1463),
    [sym_binary_expression] = STATE(1463),
    [sym_unary_expression] = STATE(1463),
    [sym_update_expression] = STATE(1463),
    [sym_sequence_expression] = STATE(1464),
    [sym_string] = STATE(1463),
    [sym_template_string] = STATE(1463),
    [sym_regex] = STATE(1463),
    [sym_meta_property] = STATE(1463),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3461),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3463),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3463),
    [sym_false] = ACTIONS(3463),
    [sym_null] = ACTIONS(3463),
    [sym_undefined] = ACTIONS(3463),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1185] = {
    [sym_parenthesized_expression] = STATE(1465),
    [sym__expression] = STATE(1465),
    [sym_yield_expression] = STATE(1465),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1465),
    [sym_jsx_fragment] = STATE(1465),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1465),
    [sym_anonymous_class] = STATE(1465),
    [sym_class] = STATE(1465),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1465),
    [sym_generator_function] = STATE(1465),
    [sym_call_expression] = STATE(1465),
    [sym_new_expression] = STATE(1465),
    [sym_await_expression] = STATE(1465),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1465),
    [sym_augmented_assignment_expression] = STATE(1465),
    [sym_ternary_expression] = STATE(1465),
    [sym_binary_expression] = STATE(1465),
    [sym_unary_expression] = STATE(1465),
    [sym_update_expression] = STATE(1465),
    [sym_string] = STATE(1465),
    [sym_template_string] = STATE(1465),
    [sym_regex] = STATE(1465),
    [sym_meta_property] = STATE(1465),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3465),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3467),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3467),
    [sym_false] = ACTIONS(3467),
    [sym_null] = ACTIONS(3467),
    [sym_undefined] = ACTIONS(3467),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1186] = {
    [sym_parenthesized_expression] = STATE(1466),
    [sym__expression] = STATE(1466),
    [sym_yield_expression] = STATE(1466),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1466),
    [sym_jsx_fragment] = STATE(1466),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1466),
    [sym_anonymous_class] = STATE(1466),
    [sym_class] = STATE(1466),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1466),
    [sym_generator_function] = STATE(1466),
    [sym_call_expression] = STATE(1466),
    [sym_new_expression] = STATE(1466),
    [sym_await_expression] = STATE(1466),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1466),
    [sym_augmented_assignment_expression] = STATE(1466),
    [sym_ternary_expression] = STATE(1466),
    [sym_binary_expression] = STATE(1466),
    [sym_unary_expression] = STATE(1466),
    [sym_update_expression] = STATE(1466),
    [sym_string] = STATE(1466),
    [sym_template_string] = STATE(1466),
    [sym_regex] = STATE(1466),
    [sym_meta_property] = STATE(1466),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3469),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3471),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3471),
    [sym_false] = ACTIONS(3471),
    [sym_null] = ACTIONS(3471),
    [sym_undefined] = ACTIONS(3471),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1187] = {
    [sym_parenthesized_expression] = STATE(1467),
    [sym__expression] = STATE(1467),
    [sym_yield_expression] = STATE(1467),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1467),
    [sym_jsx_fragment] = STATE(1467),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1467),
    [sym_anonymous_class] = STATE(1467),
    [sym_class] = STATE(1467),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1467),
    [sym_generator_function] = STATE(1467),
    [sym_call_expression] = STATE(1467),
    [sym_new_expression] = STATE(1467),
    [sym_await_expression] = STATE(1467),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1467),
    [sym_augmented_assignment_expression] = STATE(1467),
    [sym_ternary_expression] = STATE(1467),
    [sym_binary_expression] = STATE(1467),
    [sym_unary_expression] = STATE(1467),
    [sym_update_expression] = STATE(1467),
    [sym_string] = STATE(1467),
    [sym_template_string] = STATE(1467),
    [sym_regex] = STATE(1467),
    [sym_meta_property] = STATE(1467),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [sym__automatic_semicolon] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(252),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(2706),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3473),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3475),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3475),
    [sym_false] = ACTIONS(3475),
    [sym_null] = ACTIONS(3475),
    [sym_undefined] = ACTIONS(3475),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1188] = {
    [sym__initializer] = STATE(201),
    [sym_formal_parameters] = STATE(1471),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(3477),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(3479),
    [anon_sym_PLUS_EQ] = ACTIONS(3481),
    [anon_sym_DASH_EQ] = ACTIONS(3481),
    [anon_sym_STAR_EQ] = ACTIONS(3481),
    [anon_sym_SLASH_EQ] = ACTIONS(3481),
    [anon_sym_PERCENT_EQ] = ACTIONS(3481),
    [anon_sym_CARET_EQ] = ACTIONS(3481),
    [anon_sym_AMP_EQ] = ACTIONS(3481),
    [anon_sym_PIPE_EQ] = ACTIONS(3481),
    [anon_sym_GT_GT_EQ] = ACTIONS(3481),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3481),
    [anon_sym_LT_LT_EQ] = ACTIONS(3481),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(3483),
  },
  [1189] = {
    [sym_statement_block] = STATE(206),
    [sym_parenthesized_expression] = STATE(1472),
    [sym__expression] = STATE(1472),
    [sym_yield_expression] = STATE(1472),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1472),
    [sym_jsx_fragment] = STATE(1472),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1472),
    [sym_anonymous_class] = STATE(1472),
    [sym_class] = STATE(1472),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1472),
    [sym_generator_function] = STATE(1472),
    [sym_call_expression] = STATE(1472),
    [sym_new_expression] = STATE(1472),
    [sym_await_expression] = STATE(1472),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1472),
    [sym_augmented_assignment_expression] = STATE(1472),
    [sym_ternary_expression] = STATE(1472),
    [sym_binary_expression] = STATE(1472),
    [sym_unary_expression] = STATE(1472),
    [sym_update_expression] = STATE(1472),
    [sym_string] = STATE(1472),
    [sym_template_string] = STATE(1472),
    [sym_regex] = STATE(1472),
    [sym_meta_property] = STATE(1472),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3485),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3487),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3487),
    [sym_false] = ACTIONS(3487),
    [sym_null] = ACTIONS(3487),
    [sym_undefined] = ACTIONS(3487),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1190] = {
    [sym_parenthesized_expression] = STATE(214),
    [sym__expression] = STATE(218),
    [sym_yield_expression] = STATE(218),
    [sym_object] = STATE(219),
    [sym_array] = STATE(220),
    [sym_jsx_element] = STATE(218),
    [sym_jsx_fragment] = STATE(218),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(218),
    [sym_anonymous_class] = STATE(214),
    [sym_class] = STATE(214),
    [sym_function] = STATE(221),
    [sym_arrow_function] = STATE(214),
    [sym_generator_function] = STATE(214),
    [sym_call_expression] = STATE(218),
    [sym_new_expression] = STATE(214),
    [sym_await_expression] = STATE(218),
    [sym_member_expression] = STATE(222),
    [sym_subscript_expression] = STATE(222),
    [sym_assignment_expression] = STATE(218),
    [sym_augmented_assignment_expression] = STATE(218),
    [sym_ternary_expression] = STATE(218),
    [sym_binary_expression] = STATE(218),
    [sym_unary_expression] = STATE(218),
    [sym_update_expression] = STATE(218),
    [sym_string] = STATE(214),
    [sym_template_string] = STATE(214),
    [sym_regex] = STATE(214),
    [sym_meta_property] = STATE(214),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_DOT] = ACTIONS(343),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(3489),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(353),
    [sym_identifier] = ACTIONS(3491),
    [sym_this] = ACTIONS(357),
    [sym_super] = ACTIONS(359),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_null] = ACTIONS(357),
    [sym_undefined] = ACTIONS(357),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(361),
    [anon_sym_set] = ACTIONS(361),
  },
  [1191] = {
    [sym_parenthesized_expression] = STATE(223),
    [sym__expression] = STATE(223),
    [sym_yield_expression] = STATE(223),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(223),
    [sym_jsx_fragment] = STATE(223),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(223),
    [sym_anonymous_class] = STATE(223),
    [sym_class] = STATE(223),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(223),
    [sym_generator_function] = STATE(223),
    [sym_call_expression] = STATE(223),
    [sym_new_expression] = STATE(223),
    [sym_await_expression] = STATE(223),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(223),
    [sym_augmented_assignment_expression] = STATE(223),
    [sym_ternary_expression] = STATE(223),
    [sym_binary_expression] = STATE(223),
    [sym_unary_expression] = STATE(223),
    [sym_update_expression] = STATE(223),
    [sym_string] = STATE(223),
    [sym_template_string] = STATE(223),
    [sym_regex] = STATE(223),
    [sym_meta_property] = STATE(223),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(363),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(365),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(365),
    [sym_false] = ACTIONS(365),
    [sym_null] = ACTIONS(365),
    [sym_undefined] = ACTIONS(365),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1192] = {
    [sym_parenthesized_expression] = STATE(224),
    [sym__expression] = STATE(224),
    [sym_yield_expression] = STATE(224),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(224),
    [sym_jsx_fragment] = STATE(224),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(224),
    [sym_anonymous_class] = STATE(224),
    [sym_class] = STATE(224),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(224),
    [sym_generator_function] = STATE(224),
    [sym_call_expression] = STATE(224),
    [sym_new_expression] = STATE(224),
    [sym_await_expression] = STATE(224),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(224),
    [sym_augmented_assignment_expression] = STATE(224),
    [sym_ternary_expression] = STATE(224),
    [sym_binary_expression] = STATE(224),
    [sym_unary_expression] = STATE(224),
    [sym_update_expression] = STATE(224),
    [sym_string] = STATE(224),
    [sym_template_string] = STATE(224),
    [sym_regex] = STATE(224),
    [sym_meta_property] = STATE(224),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(367),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(369),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(369),
    [sym_false] = ACTIONS(369),
    [sym_null] = ACTIONS(369),
    [sym_undefined] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1193] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(3477),
    [anon_sym_EQ_GT] = ACTIONS(3479),
    [anon_sym_PLUS_EQ] = ACTIONS(3495),
    [anon_sym_DASH_EQ] = ACTIONS(3495),
    [anon_sym_STAR_EQ] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_PERCENT_EQ] = ACTIONS(3495),
    [anon_sym_CARET_EQ] = ACTIONS(3495),
    [anon_sym_AMP_EQ] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_GT_GT_EQ] = ACTIONS(3495),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3495),
    [anon_sym_LT_LT_EQ] = ACTIONS(3495),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1194] = {
    [sym__initializer] = STATE(201),
    [sym__automatic_semicolon] = ACTIONS(308),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_COMMA] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(3477),
    [anon_sym_PLUS_EQ] = ACTIONS(3481),
    [anon_sym_DASH_EQ] = ACTIONS(3481),
    [anon_sym_STAR_EQ] = ACTIONS(3481),
    [anon_sym_SLASH_EQ] = ACTIONS(3481),
    [anon_sym_PERCENT_EQ] = ACTIONS(3481),
    [anon_sym_CARET_EQ] = ACTIONS(3481),
    [anon_sym_AMP_EQ] = ACTIONS(3481),
    [anon_sym_PIPE_EQ] = ACTIONS(3481),
    [anon_sym_GT_GT_EQ] = ACTIONS(3481),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3481),
    [anon_sym_LT_LT_EQ] = ACTIONS(3481),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [1195] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(3499),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1196] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3477),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1197] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3477),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1198] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3477),
    [anon_sym_PLUS_EQ] = ACTIONS(3495),
    [anon_sym_DASH_EQ] = ACTIONS(3495),
    [anon_sym_STAR_EQ] = ACTIONS(3495),
    [anon_sym_SLASH_EQ] = ACTIONS(3495),
    [anon_sym_PERCENT_EQ] = ACTIONS(3495),
    [anon_sym_CARET_EQ] = ACTIONS(3495),
    [anon_sym_AMP_EQ] = ACTIONS(3495),
    [anon_sym_PIPE_EQ] = ACTIONS(3495),
    [anon_sym_GT_GT_EQ] = ACTIONS(3495),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3495),
    [anon_sym_LT_LT_EQ] = ACTIONS(3495),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1199] = {
    [anon_sym_RPAREN] = ACTIONS(3499),
    [sym_comment] = ACTIONS(78),
  },
  [1200] = {
    [anon_sym_EQ_GT] = ACTIONS(3479),
    [sym_comment] = ACTIONS(78),
  },
  [1201] = {
    [sym_parenthesized_expression] = STATE(1483),
    [sym__expression] = STATE(1483),
    [sym_yield_expression] = STATE(1483),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1483),
    [sym_jsx_fragment] = STATE(1483),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1483),
    [sym_anonymous_class] = STATE(1483),
    [sym_class] = STATE(1483),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1483),
    [sym_generator_function] = STATE(1483),
    [sym_call_expression] = STATE(1483),
    [sym_new_expression] = STATE(1483),
    [sym_await_expression] = STATE(1483),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1483),
    [sym_augmented_assignment_expression] = STATE(1483),
    [sym_ternary_expression] = STATE(1483),
    [sym_binary_expression] = STATE(1483),
    [sym_unary_expression] = STATE(1483),
    [sym_update_expression] = STATE(1483),
    [sym_string] = STATE(1483),
    [sym_template_string] = STATE(1483),
    [sym_regex] = STATE(1483),
    [sym_meta_property] = STATE(1483),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3503),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3505),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3505),
    [sym_false] = ACTIONS(3505),
    [sym_null] = ACTIONS(3505),
    [sym_undefined] = ACTIONS(3505),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1202] = {
    [sym_parenthesized_expression] = STATE(1484),
    [sym__expression] = STATE(1484),
    [sym_yield_expression] = STATE(1484),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1484),
    [sym_jsx_fragment] = STATE(1484),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1484),
    [sym_anonymous_class] = STATE(1484),
    [sym_class] = STATE(1484),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1484),
    [sym_generator_function] = STATE(1484),
    [sym_call_expression] = STATE(1484),
    [sym_new_expression] = STATE(1484),
    [sym_await_expression] = STATE(1484),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1484),
    [sym_augmented_assignment_expression] = STATE(1484),
    [sym_ternary_expression] = STATE(1484),
    [sym_binary_expression] = STATE(1484),
    [sym_unary_expression] = STATE(1484),
    [sym_update_expression] = STATE(1484),
    [sym_string] = STATE(1484),
    [sym_template_string] = STATE(1484),
    [sym_regex] = STATE(1484),
    [sym_meta_property] = STATE(1484),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_in] = ACTIONS(254),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(697),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(254),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(254),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(252),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3507),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3509),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3509),
    [sym_false] = ACTIONS(3509),
    [sym_null] = ACTIONS(3509),
    [sym_undefined] = ACTIONS(3509),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1203] = {
    [sym__initializer] = STATE(426),
    [sym_formal_parameters] = STATE(1488),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(3511),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(3513),
    [anon_sym_PLUS_EQ] = ACTIONS(3515),
    [anon_sym_DASH_EQ] = ACTIONS(3515),
    [anon_sym_STAR_EQ] = ACTIONS(3515),
    [anon_sym_SLASH_EQ] = ACTIONS(3515),
    [anon_sym_PERCENT_EQ] = ACTIONS(3515),
    [anon_sym_CARET_EQ] = ACTIONS(3515),
    [anon_sym_AMP_EQ] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3515),
    [anon_sym_GT_GT_EQ] = ACTIONS(3515),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3515),
    [anon_sym_LT_LT_EQ] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(310),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym_identifier] = ACTIONS(3517),
  },
  [1204] = {
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(1489),
    [sym__expression] = STATE(1489),
    [sym_yield_expression] = STATE(1489),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1489),
    [sym_jsx_fragment] = STATE(1489),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1489),
    [sym_anonymous_class] = STATE(1489),
    [sym_class] = STATE(1489),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1489),
    [sym_generator_function] = STATE(1489),
    [sym_call_expression] = STATE(1489),
    [sym_new_expression] = STATE(1489),
    [sym_await_expression] = STATE(1489),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1489),
    [sym_augmented_assignment_expression] = STATE(1489),
    [sym_ternary_expression] = STATE(1489),
    [sym_binary_expression] = STATE(1489),
    [sym_unary_expression] = STATE(1489),
    [sym_update_expression] = STATE(1489),
    [sym_string] = STATE(1489),
    [sym_template_string] = STATE(1489),
    [sym_regex] = STATE(1489),
    [sym_meta_property] = STATE(1489),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3519),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3521),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3521),
    [sym_false] = ACTIONS(3521),
    [sym_null] = ACTIONS(3521),
    [sym_undefined] = ACTIONS(3521),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1205] = {
    [sym_parenthesized_expression] = STATE(436),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(440),
    [sym_array] = STATE(441),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(436),
    [sym_class] = STATE(436),
    [sym_function] = STATE(442),
    [sym_arrow_function] = STATE(436),
    [sym_generator_function] = STATE(436),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(436),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(443),
    [sym_subscript_expression] = STATE(443),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(436),
    [sym_template_string] = STATE(436),
    [sym_regex] = STATE(436),
    [sym_meta_property] = STATE(436),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(3523),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(753),
    [sym_identifier] = ACTIONS(3525),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_null] = ACTIONS(757),
    [sym_undefined] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(759),
    [anon_sym_set] = ACTIONS(759),
  },
  [1206] = {
    [sym_parenthesized_expression] = STATE(445),
    [sym__expression] = STATE(445),
    [sym_yield_expression] = STATE(445),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(445),
    [sym_jsx_fragment] = STATE(445),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(445),
    [sym_anonymous_class] = STATE(445),
    [sym_class] = STATE(445),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(445),
    [sym_generator_function] = STATE(445),
    [sym_call_expression] = STATE(445),
    [sym_new_expression] = STATE(445),
    [sym_await_expression] = STATE(445),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(445),
    [sym_augmented_assignment_expression] = STATE(445),
    [sym_ternary_expression] = STATE(445),
    [sym_binary_expression] = STATE(445),
    [sym_unary_expression] = STATE(445),
    [sym_update_expression] = STATE(445),
    [sym_string] = STATE(445),
    [sym_template_string] = STATE(445),
    [sym_regex] = STATE(445),
    [sym_meta_property] = STATE(445),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(763),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_null] = ACTIONS(765),
    [sym_undefined] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1207] = {
    [sym_parenthesized_expression] = STATE(446),
    [sym__expression] = STATE(446),
    [sym_yield_expression] = STATE(446),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(446),
    [sym_jsx_fragment] = STATE(446),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(446),
    [sym_anonymous_class] = STATE(446),
    [sym_class] = STATE(446),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(446),
    [sym_generator_function] = STATE(446),
    [sym_call_expression] = STATE(446),
    [sym_new_expression] = STATE(446),
    [sym_await_expression] = STATE(446),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(446),
    [sym_augmented_assignment_expression] = STATE(446),
    [sym_ternary_expression] = STATE(446),
    [sym_binary_expression] = STATE(446),
    [sym_unary_expression] = STATE(446),
    [sym_update_expression] = STATE(446),
    [sym_string] = STATE(446),
    [sym_template_string] = STATE(446),
    [sym_regex] = STATE(446),
    [sym_meta_property] = STATE(446),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(767),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_null] = ACTIONS(769),
    [sym_undefined] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1208] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(3511),
    [anon_sym_EQ_GT] = ACTIONS(3513),
    [anon_sym_PLUS_EQ] = ACTIONS(3529),
    [anon_sym_DASH_EQ] = ACTIONS(3529),
    [anon_sym_STAR_EQ] = ACTIONS(3529),
    [anon_sym_SLASH_EQ] = ACTIONS(3529),
    [anon_sym_PERCENT_EQ] = ACTIONS(3529),
    [anon_sym_CARET_EQ] = ACTIONS(3529),
    [anon_sym_AMP_EQ] = ACTIONS(3529),
    [anon_sym_PIPE_EQ] = ACTIONS(3529),
    [anon_sym_GT_GT_EQ] = ACTIONS(3529),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3529),
    [anon_sym_LT_LT_EQ] = ACTIONS(3529),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1209] = {
    [sym__initializer] = STATE(426),
    [anon_sym_STAR] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_in] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(310),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(3511),
    [anon_sym_PLUS_EQ] = ACTIONS(3515),
    [anon_sym_DASH_EQ] = ACTIONS(3515),
    [anon_sym_STAR_EQ] = ACTIONS(3515),
    [anon_sym_SLASH_EQ] = ACTIONS(3515),
    [anon_sym_PERCENT_EQ] = ACTIONS(3515),
    [anon_sym_CARET_EQ] = ACTIONS(3515),
    [anon_sym_AMP_EQ] = ACTIONS(3515),
    [anon_sym_PIPE_EQ] = ACTIONS(3515),
    [anon_sym_GT_GT_EQ] = ACTIONS(3515),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3515),
    [anon_sym_LT_LT_EQ] = ACTIONS(3515),
    [anon_sym_QMARK] = ACTIONS(308),
    [anon_sym_AMP_AMP] = ACTIONS(308),
    [anon_sym_PIPE_PIPE] = ACTIONS(308),
    [anon_sym_GT_GT] = ACTIONS(310),
    [anon_sym_GT_GT_GT] = ACTIONS(310),
    [anon_sym_LT_LT] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_PERCENT] = ACTIONS(310),
    [anon_sym_LT_EQ] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(308),
    [anon_sym_BANG_EQ] = ACTIONS(310),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(308),
    [anon_sym_GT_EQ] = ACTIONS(308),
    [anon_sym_instanceof] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(308),
  },
  [1210] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3533),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1211] = {
    [sym__initializer] = STATE(528),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1212] = {
    [sym__initializer] = STATE(529),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1213] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(385),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(3511),
    [anon_sym_PLUS_EQ] = ACTIONS(3529),
    [anon_sym_DASH_EQ] = ACTIONS(3529),
    [anon_sym_STAR_EQ] = ACTIONS(3529),
    [anon_sym_SLASH_EQ] = ACTIONS(3529),
    [anon_sym_PERCENT_EQ] = ACTIONS(3529),
    [anon_sym_CARET_EQ] = ACTIONS(3529),
    [anon_sym_AMP_EQ] = ACTIONS(3529),
    [anon_sym_PIPE_EQ] = ACTIONS(3529),
    [anon_sym_GT_GT_EQ] = ACTIONS(3529),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3529),
    [anon_sym_LT_LT_EQ] = ACTIONS(3529),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1214] = {
    [anon_sym_EQ_GT] = ACTIONS(3513),
    [sym_comment] = ACTIONS(78),
  },
  [1215] = {
    [sym_export_statement] = STATE(1500),
    [sym__declaration] = STATE(1500),
    [sym_import_statement] = STATE(1500),
    [sym_expression_statement] = STATE(1500),
    [sym_variable_declaration] = STATE(1500),
    [sym_lexical_declaration] = STATE(1500),
    [sym_statement_block] = STATE(1500),
    [sym_if_statement] = STATE(1500),
    [sym_switch_statement] = STATE(1500),
    [sym_for_statement] = STATE(1500),
    [sym_for_in_statement] = STATE(1500),
    [sym_for_of_statement] = STATE(1500),
    [sym_while_statement] = STATE(1500),
    [sym_do_statement] = STATE(1500),
    [sym_try_statement] = STATE(1500),
    [sym_with_statement] = STATE(1500),
    [sym_break_statement] = STATE(1500),
    [sym_continue_statement] = STATE(1500),
    [sym_debugger_statement] = STATE(1500),
    [sym_return_statement] = STATE(1500),
    [sym_throw_statement] = STATE(1500),
    [sym_empty_statement] = STATE(1500),
    [sym_labeled_statement] = STATE(1500),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1216] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3551),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1217] = {
    [anon_sym_RPAREN] = ACTIONS(3551),
    [sym_comment] = ACTIONS(78),
  },
  [1218] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(3553),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1219] = {
    [anon_sym_RPAREN] = ACTIONS(3553),
    [sym_comment] = ACTIONS(78),
  },
  [1220] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3555),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1221] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(3557),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1222] = {
    [anon_sym_RPAREN] = ACTIONS(3557),
    [sym_comment] = ACTIONS(78),
  },
  [1223] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3559),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1224] = {
    [anon_sym_of] = ACTIONS(3561),
    [sym_comment] = ACTIONS(78),
  },
  [1225] = {
    [anon_sym_of] = ACTIONS(3563),
    [sym_comment] = ACTIONS(78),
  },
  [1226] = {
    [anon_sym_of] = ACTIONS(3565),
    [sym_comment] = ACTIONS(78),
  },
  [1227] = {
    [anon_sym_STAR] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(2515),
    [anon_sym_COMMA] = ACTIONS(2515),
    [anon_sym_RBRACE] = ACTIONS(2515),
    [anon_sym_LPAREN] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_in] = ACTIONS(2517),
    [anon_sym_of] = ACTIONS(2515),
    [anon_sym_COLON] = ACTIONS(2515),
    [anon_sym_LBRACK] = ACTIONS(2515),
    [anon_sym_RBRACK] = ACTIONS(2515),
    [anon_sym_LT] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2517),
    [anon_sym_SLASH] = ACTIONS(2517),
    [anon_sym_DOT] = ACTIONS(2515),
    [anon_sym_EQ] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(2515),
    [anon_sym_AMP_AMP] = ACTIONS(2515),
    [anon_sym_PIPE_PIPE] = ACTIONS(2515),
    [anon_sym_GT_GT] = ACTIONS(2517),
    [anon_sym_GT_GT_GT] = ACTIONS(2515),
    [anon_sym_LT_LT] = ACTIONS(2515),
    [anon_sym_AMP] = ACTIONS(2517),
    [anon_sym_CARET] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2517),
    [anon_sym_PLUS] = ACTIONS(2517),
    [anon_sym_DASH] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2515),
    [anon_sym_LT_EQ] = ACTIONS(2515),
    [anon_sym_EQ_EQ] = ACTIONS(2517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2515),
    [anon_sym_BANG_EQ] = ACTIONS(2517),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2515),
    [anon_sym_GT_EQ] = ACTIONS(2515),
    [anon_sym_instanceof] = ACTIONS(2515),
    [anon_sym_PLUS_PLUS] = ACTIONS(2515),
    [anon_sym_DASH_DASH] = ACTIONS(2515),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2515),
  },
  [1228] = {
    [anon_sym_STAR] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(2597),
    [anon_sym_COMMA] = ACTIONS(2597),
    [anon_sym_RBRACE] = ACTIONS(2597),
    [anon_sym_LPAREN] = ACTIONS(2597),
    [anon_sym_RPAREN] = ACTIONS(2597),
    [anon_sym_in] = ACTIONS(2599),
    [anon_sym_of] = ACTIONS(2597),
    [anon_sym_COLON] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2597),
    [anon_sym_RBRACK] = ACTIONS(2597),
    [anon_sym_LT] = ACTIONS(2599),
    [anon_sym_GT] = ACTIONS(2599),
    [anon_sym_SLASH] = ACTIONS(2599),
    [anon_sym_DOT] = ACTIONS(2597),
    [anon_sym_EQ] = ACTIONS(2599),
    [anon_sym_QMARK] = ACTIONS(2597),
    [anon_sym_AMP_AMP] = ACTIONS(2597),
    [anon_sym_PIPE_PIPE] = ACTIONS(2597),
    [anon_sym_GT_GT] = ACTIONS(2599),
    [anon_sym_GT_GT_GT] = ACTIONS(2597),
    [anon_sym_LT_LT] = ACTIONS(2597),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_CARET] = ACTIONS(2597),
    [anon_sym_PIPE] = ACTIONS(2599),
    [anon_sym_PLUS] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2599),
    [anon_sym_PERCENT] = ACTIONS(2597),
    [anon_sym_LT_EQ] = ACTIONS(2597),
    [anon_sym_EQ_EQ] = ACTIONS(2599),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2597),
    [anon_sym_BANG_EQ] = ACTIONS(2599),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2597),
    [anon_sym_GT_EQ] = ACTIONS(2597),
    [anon_sym_instanceof] = ACTIONS(2597),
    [anon_sym_PLUS_PLUS] = ACTIONS(2597),
    [anon_sym_DASH_DASH] = ACTIONS(2597),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2597),
  },
  [1229] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(3567),
    [sym_comment] = ACTIONS(78),
  },
  [1230] = {
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_LBRACE] = ACTIONS(2875),
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_LPAREN] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_in] = ACTIONS(2877),
    [anon_sym_of] = ACTIONS(2875),
    [anon_sym_COLON] = ACTIONS(2875),
    [anon_sym_LBRACK] = ACTIONS(2875),
    [anon_sym_RBRACK] = ACTIONS(2875),
    [anon_sym_LT] = ACTIONS(2877),
    [anon_sym_GT] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2877),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_EQ] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2875),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_GT_GT] = ACTIONS(2877),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_AMP] = ACTIONS(2877),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_PIPE] = ACTIONS(2877),
    [anon_sym_PLUS] = ACTIONS(2877),
    [anon_sym_DASH] = ACTIONS(2877),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2877),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2877),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2875),
    [anon_sym_instanceof] = ACTIONS(2875),
    [anon_sym_PLUS_PLUS] = ACTIONS(2875),
    [anon_sym_DASH_DASH] = ACTIONS(2875),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2875),
  },
  [1231] = {
    [anon_sym_GT] = ACTIONS(3569),
    [sym_comment] = ACTIONS(78),
  },
  [1232] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(3571),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [1233] = {
    [anon_sym_STAR] = ACTIONS(2891),
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2891),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_LPAREN] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_in] = ACTIONS(2893),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_LBRACK] = ACTIONS(2891),
    [anon_sym_RBRACK] = ACTIONS(2891),
    [anon_sym_LT] = ACTIONS(2893),
    [anon_sym_GT] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2893),
    [anon_sym_DOT] = ACTIONS(2891),
    [anon_sym_QMARK] = ACTIONS(2891),
    [anon_sym_AMP_AMP] = ACTIONS(2891),
    [anon_sym_PIPE_PIPE] = ACTIONS(2891),
    [anon_sym_GT_GT] = ACTIONS(2893),
    [anon_sym_GT_GT_GT] = ACTIONS(2891),
    [anon_sym_LT_LT] = ACTIONS(2891),
    [anon_sym_AMP] = ACTIONS(2893),
    [anon_sym_CARET] = ACTIONS(2891),
    [anon_sym_PIPE] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2893),
    [anon_sym_DASH] = ACTIONS(2893),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_LT_EQ] = ACTIONS(2891),
    [anon_sym_EQ_EQ] = ACTIONS(2893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2891),
    [anon_sym_BANG_EQ] = ACTIONS(2893),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2891),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_instanceof] = ACTIONS(2891),
    [anon_sym_PLUS_PLUS] = ACTIONS(2891),
    [anon_sym_DASH_DASH] = ACTIONS(2891),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2891),
  },
  [1234] = {
    [anon_sym_GT] = ACTIONS(3573),
    [sym_comment] = ACTIONS(78),
  },
  [1235] = {
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2922),
    [anon_sym_RBRACE] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(2922),
    [anon_sym_RPAREN] = ACTIONS(2922),
    [anon_sym_in] = ACTIONS(2924),
    [anon_sym_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2922),
    [anon_sym_RBRACK] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2924),
    [anon_sym_GT] = ACTIONS(2924),
    [anon_sym_SLASH] = ACTIONS(2924),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_PIPE_PIPE] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2924),
    [anon_sym_GT_GT_GT] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_DASH] = ACTIONS(2924),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_LT_EQ] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2924),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2922),
    [anon_sym_BANG_EQ] = ACTIONS(2924),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2922),
    [anon_sym_GT_EQ] = ACTIONS(2922),
    [anon_sym_instanceof] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2922),
  },
  [1236] = {
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2938),
    [anon_sym_RBRACE] = ACTIONS(2938),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_RPAREN] = ACTIONS(2938),
    [anon_sym_in] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_RBRACK] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2940),
    [anon_sym_GT] = ACTIONS(2940),
    [anon_sym_SLASH] = ACTIONS(2940),
    [anon_sym_DOT] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_PIPE_PIPE] = ACTIONS(2938),
    [anon_sym_GT_GT] = ACTIONS(2940),
    [anon_sym_GT_GT_GT] = ACTIONS(2938),
    [anon_sym_LT_LT] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2940),
    [anon_sym_CARET] = ACTIONS(2938),
    [anon_sym_PIPE] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2940),
    [anon_sym_PERCENT] = ACTIONS(2938),
    [anon_sym_LT_EQ] = ACTIONS(2938),
    [anon_sym_EQ_EQ] = ACTIONS(2940),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2938),
    [anon_sym_BANG_EQ] = ACTIONS(2940),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2938),
    [anon_sym_instanceof] = ACTIONS(2938),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2938),
  },
  [1237] = {
    [anon_sym_STAR] = ACTIONS(3010),
    [anon_sym_LBRACE] = ACTIONS(3010),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_LPAREN] = ACTIONS(3010),
    [anon_sym_RPAREN] = ACTIONS(3010),
    [anon_sym_in] = ACTIONS(3012),
    [anon_sym_COLON] = ACTIONS(3010),
    [anon_sym_LBRACK] = ACTIONS(3010),
    [anon_sym_RBRACK] = ACTIONS(3010),
    [anon_sym_LT] = ACTIONS(3012),
    [anon_sym_GT] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3010),
    [anon_sym_QMARK] = ACTIONS(3010),
    [anon_sym_AMP_AMP] = ACTIONS(3010),
    [anon_sym_PIPE_PIPE] = ACTIONS(3010),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_GT_GT_GT] = ACTIONS(3010),
    [anon_sym_LT_LT] = ACTIONS(3010),
    [anon_sym_AMP] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3010),
    [anon_sym_PIPE] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_DASH] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3010),
    [anon_sym_LT_EQ] = ACTIONS(3010),
    [anon_sym_EQ_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3010),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3010),
    [anon_sym_GT_EQ] = ACTIONS(3010),
    [anon_sym_instanceof] = ACTIONS(3010),
    [anon_sym_PLUS_PLUS] = ACTIONS(3010),
    [anon_sym_DASH_DASH] = ACTIONS(3010),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3010),
  },
  [1238] = {
    [sym_statement_block] = STATE(1513),
    [anon_sym_LBRACE] = ACTIONS(1802),
    [sym_comment] = ACTIONS(78),
  },
  [1239] = {
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3016),
    [anon_sym_COLON] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_RBRACK] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3016),
    [anon_sym_GT] = ACTIONS(3016),
    [anon_sym_SLASH] = ACTIONS(3016),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_QMARK] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3016),
    [anon_sym_GT_GT_GT] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3016),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3014),
    [anon_sym_instanceof] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3014),
  },
  [1240] = {
    [anon_sym_STAR] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3020),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_RBRACK] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3020),
    [anon_sym_GT] = ACTIONS(3020),
    [anon_sym_SLASH] = ACTIONS(3020),
    [anon_sym_DOT] = ACTIONS(3018),
    [anon_sym_QMARK] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE] = ACTIONS(3018),
    [anon_sym_GT_GT] = ACTIONS(3020),
    [anon_sym_GT_GT_GT] = ACTIONS(3018),
    [anon_sym_LT_LT] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_CARET] = ACTIONS(3018),
    [anon_sym_PIPE] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PERCENT] = ACTIONS(3018),
    [anon_sym_LT_EQ] = ACTIONS(3018),
    [anon_sym_EQ_EQ] = ACTIONS(3020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3018),
    [anon_sym_BANG_EQ] = ACTIONS(3020),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3018),
    [anon_sym_GT_EQ] = ACTIONS(3018),
    [anon_sym_instanceof] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3018),
  },
  [1241] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1242] = {
    [sym_statement_block] = STATE(1514),
    [anon_sym_LBRACE] = ACTIONS(1802),
    [sym_comment] = ACTIONS(78),
  },
  [1243] = {
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_LPAREN] = ACTIONS(3022),
    [anon_sym_RPAREN] = ACTIONS(3022),
    [anon_sym_in] = ACTIONS(3024),
    [anon_sym_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK] = ACTIONS(3022),
    [anon_sym_RBRACK] = ACTIONS(3022),
    [anon_sym_LT] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3024),
    [anon_sym_SLASH] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3022),
    [anon_sym_QMARK] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_PIPE_PIPE] = ACTIONS(3022),
    [anon_sym_GT_GT] = ACTIONS(3024),
    [anon_sym_GT_GT_GT] = ACTIONS(3022),
    [anon_sym_LT_LT] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3024),
    [anon_sym_CARET] = ACTIONS(3022),
    [anon_sym_PIPE] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3022),
    [anon_sym_LT_EQ] = ACTIONS(3022),
    [anon_sym_EQ_EQ] = ACTIONS(3024),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3022),
    [anon_sym_BANG_EQ] = ACTIONS(3024),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3022),
    [anon_sym_GT_EQ] = ACTIONS(3022),
    [anon_sym_instanceof] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3022),
  },
  [1244] = {
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_LBRACE] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(517),
    [anon_sym_RBRACE] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(517),
    [anon_sym_RPAREN] = ACTIONS(517),
    [anon_sym_in] = ACTIONS(519),
    [anon_sym_COLON] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(517),
    [anon_sym_RBRACK] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_SLASH] = ACTIONS(519),
    [anon_sym_DOT] = ACTIONS(517),
    [anon_sym_QMARK] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(517),
    [anon_sym_PIPE_PIPE] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_GT_GT_GT] = ACTIONS(517),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(519),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(519),
    [anon_sym_DASH] = ACTIONS(519),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_LT_EQ] = ACTIONS(517),
    [anon_sym_EQ_EQ] = ACTIONS(519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(517),
    [anon_sym_BANG_EQ] = ACTIONS(519),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(517),
    [anon_sym_GT_EQ] = ACTIONS(517),
    [anon_sym_instanceof] = ACTIONS(517),
    [anon_sym_PLUS_PLUS] = ACTIONS(517),
    [anon_sym_DASH_DASH] = ACTIONS(517),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(517),
  },
  [1245] = {
    [anon_sym_STAR] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1648),
    [anon_sym_COMMA] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_LPAREN] = ACTIONS(1648),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_in] = ACTIONS(1650),
    [anon_sym_COLON] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_RBRACK] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(1650),
    [anon_sym_GT] = ACTIONS(1650),
    [anon_sym_SLASH] = ACTIONS(1650),
    [anon_sym_DOT] = ACTIONS(1648),
    [anon_sym_QMARK] = ACTIONS(1648),
    [anon_sym_AMP_AMP] = ACTIONS(1648),
    [anon_sym_PIPE_PIPE] = ACTIONS(1648),
    [anon_sym_GT_GT] = ACTIONS(1650),
    [anon_sym_GT_GT_GT] = ACTIONS(1648),
    [anon_sym_LT_LT] = ACTIONS(1648),
    [anon_sym_AMP] = ACTIONS(1650),
    [anon_sym_CARET] = ACTIONS(1648),
    [anon_sym_PIPE] = ACTIONS(1650),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_PERCENT] = ACTIONS(1648),
    [anon_sym_LT_EQ] = ACTIONS(1648),
    [anon_sym_EQ_EQ] = ACTIONS(1650),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1648),
    [anon_sym_BANG_EQ] = ACTIONS(1650),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1648),
    [anon_sym_GT_EQ] = ACTIONS(1648),
    [anon_sym_instanceof] = ACTIONS(1648),
    [anon_sym_PLUS_PLUS] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1648),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1648),
  },
  [1246] = {
    [anon_sym_STAR] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(2241),
    [anon_sym_COMMA] = ACTIONS(2241),
    [anon_sym_RBRACE] = ACTIONS(2241),
    [anon_sym_LPAREN] = ACTIONS(2241),
    [anon_sym_RPAREN] = ACTIONS(2241),
    [anon_sym_in] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(2241),
    [anon_sym_LBRACK] = ACTIONS(2241),
    [anon_sym_RBRACK] = ACTIONS(2241),
    [anon_sym_LT] = ACTIONS(2243),
    [anon_sym_GT] = ACTIONS(2243),
    [anon_sym_SLASH] = ACTIONS(2243),
    [anon_sym_DOT] = ACTIONS(2241),
    [anon_sym_EQ_GT] = ACTIONS(691),
    [anon_sym_QMARK] = ACTIONS(2241),
    [anon_sym_AMP_AMP] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2241),
    [anon_sym_GT_GT] = ACTIONS(2243),
    [anon_sym_GT_GT_GT] = ACTIONS(2241),
    [anon_sym_LT_LT] = ACTIONS(2241),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2241),
    [anon_sym_PIPE] = ACTIONS(2243),
    [anon_sym_PLUS] = ACTIONS(2243),
    [anon_sym_DASH] = ACTIONS(2243),
    [anon_sym_PERCENT] = ACTIONS(2241),
    [anon_sym_LT_EQ] = ACTIONS(2241),
    [anon_sym_EQ_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2241),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2241),
    [anon_sym_GT_EQ] = ACTIONS(2241),
    [anon_sym_instanceof] = ACTIONS(2241),
    [anon_sym_PLUS_PLUS] = ACTIONS(2241),
    [anon_sym_DASH_DASH] = ACTIONS(2241),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2241),
  },
  [1247] = {
    [anon_sym_export] = ACTIONS(3040),
    [anon_sym_STAR] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3038),
    [anon_sym_COMMA] = ACTIONS(3038),
    [anon_sym_RBRACE] = ACTIONS(3038),
    [anon_sym_LPAREN] = ACTIONS(3038),
    [anon_sym_RPAREN] = ACTIONS(3038),
    [anon_sym_in] = ACTIONS(3040),
    [anon_sym_COLON] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_RBRACK] = ACTIONS(3038),
    [anon_sym_LT] = ACTIONS(3040),
    [anon_sym_GT] = ACTIONS(3040),
    [anon_sym_SLASH] = ACTIONS(3040),
    [anon_sym_DOT] = ACTIONS(3040),
    [anon_sym_class] = ACTIONS(3040),
    [anon_sym_async] = ACTIONS(3040),
    [anon_sym_QMARK] = ACTIONS(3038),
    [anon_sym_AMP_AMP] = ACTIONS(3038),
    [anon_sym_PIPE_PIPE] = ACTIONS(3038),
    [anon_sym_GT_GT] = ACTIONS(3040),
    [anon_sym_GT_GT_GT] = ACTIONS(3038),
    [anon_sym_LT_LT] = ACTIONS(3038),
    [anon_sym_AMP] = ACTIONS(3040),
    [anon_sym_CARET] = ACTIONS(3038),
    [anon_sym_PIPE] = ACTIONS(3040),
    [anon_sym_PLUS] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3040),
    [anon_sym_PERCENT] = ACTIONS(3038),
    [anon_sym_LT_EQ] = ACTIONS(3038),
    [anon_sym_EQ_EQ] = ACTIONS(3040),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3038),
    [anon_sym_BANG_EQ] = ACTIONS(3040),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3038),
    [anon_sym_GT_EQ] = ACTIONS(3038),
    [anon_sym_instanceof] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3038),
    [anon_sym_DQUOTE] = ACTIONS(3038),
    [anon_sym_SQUOTE] = ACTIONS(3038),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3038),
    [sym_number] = ACTIONS(3038),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_AT] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3040),
    [anon_sym_get] = ACTIONS(3040),
    [anon_sym_set] = ACTIONS(3040),
  },
  [1248] = {
    [aux_sym_array_repeat1] = STATE(998),
    [anon_sym_COMMA] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(3575),
    [sym_comment] = ACTIONS(78),
  },
  [1249] = {
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3051),
    [anon_sym_RBRACE] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_in] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_RBRACK] = ACTIONS(3051),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_GT] = ACTIONS(3053),
    [anon_sym_SLASH] = ACTIONS(3053),
    [anon_sym_DOT] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_PLUS_EQ] = ACTIONS(3051),
    [anon_sym_DASH_EQ] = ACTIONS(3051),
    [anon_sym_STAR_EQ] = ACTIONS(3051),
    [anon_sym_SLASH_EQ] = ACTIONS(3051),
    [anon_sym_PERCENT_EQ] = ACTIONS(3051),
    [anon_sym_CARET_EQ] = ACTIONS(3051),
    [anon_sym_AMP_EQ] = ACTIONS(3051),
    [anon_sym_PIPE_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3051),
    [anon_sym_LT_LT_EQ] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_GT_GT] = ACTIONS(3053),
    [anon_sym_GT_GT_GT] = ACTIONS(3053),
    [anon_sym_LT_LT] = ACTIONS(3053),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_CARET] = ACTIONS(3053),
    [anon_sym_PIPE] = ACTIONS(3053),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_PERCENT] = ACTIONS(3053),
    [anon_sym_LT_EQ] = ACTIONS(3051),
    [anon_sym_EQ_EQ] = ACTIONS(3053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3051),
    [anon_sym_BANG_EQ] = ACTIONS(3053),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3051),
    [anon_sym_GT_EQ] = ACTIONS(3051),
    [anon_sym_instanceof] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3051),
  },
  [1250] = {
    [sym_parenthesized_expression] = STATE(1516),
    [sym__expression] = STATE(1516),
    [sym_yield_expression] = STATE(1516),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1516),
    [sym_jsx_fragment] = STATE(1516),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1516),
    [sym_anonymous_class] = STATE(1516),
    [sym_class] = STATE(1516),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1516),
    [sym_generator_function] = STATE(1516),
    [sym_call_expression] = STATE(1516),
    [sym_new_expression] = STATE(1516),
    [sym_await_expression] = STATE(1516),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1516),
    [sym_augmented_assignment_expression] = STATE(1516),
    [sym_ternary_expression] = STATE(1516),
    [sym_binary_expression] = STATE(1516),
    [sym_unary_expression] = STATE(1516),
    [sym_update_expression] = STATE(1516),
    [sym_string] = STATE(1516),
    [sym_template_string] = STATE(1516),
    [sym_regex] = STATE(1516),
    [sym_meta_property] = STATE(1516),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3577),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3579),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3579),
    [sym_false] = ACTIONS(3579),
    [sym_null] = ACTIONS(3579),
    [sym_undefined] = ACTIONS(3579),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1251] = {
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(3581),
    [sym_comment] = ACTIONS(78),
  },
  [1252] = {
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
  },
  [1253] = {
    [anon_sym_GT] = ACTIONS(3581),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
  },
  [1254] = {
    [anon_sym_GT] = ACTIONS(3581),
    [sym_comment] = ACTIONS(78),
  },
  [1255] = {
    [sym_class_body] = STATE(1518),
    [anon_sym_LBRACE] = ACTIONS(717),
    [sym_comment] = ACTIONS(78),
  },
  [1256] = {
    [anon_sym_STAR] = ACTIONS(3161),
    [anon_sym_LBRACE] = ACTIONS(3161),
    [anon_sym_COMMA] = ACTIONS(3161),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_LPAREN] = ACTIONS(3161),
    [anon_sym_RPAREN] = ACTIONS(3161),
    [anon_sym_in] = ACTIONS(3163),
    [anon_sym_COLON] = ACTIONS(3161),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_RBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_DOT] = ACTIONS(3161),
    [anon_sym_QMARK] = ACTIONS(3161),
    [anon_sym_AMP_AMP] = ACTIONS(3161),
    [anon_sym_PIPE_PIPE] = ACTIONS(3161),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_GT_GT_GT] = ACTIONS(3161),
    [anon_sym_LT_LT] = ACTIONS(3161),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_CARET] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3161),
    [anon_sym_LT_EQ] = ACTIONS(3161),
    [anon_sym_EQ_EQ] = ACTIONS(3163),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3161),
    [anon_sym_BANG_EQ] = ACTIONS(3163),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3161),
    [anon_sym_GT_EQ] = ACTIONS(3161),
    [anon_sym_instanceof] = ACTIONS(3161),
    [anon_sym_PLUS_PLUS] = ACTIONS(3161),
    [anon_sym_DASH_DASH] = ACTIONS(3161),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3161),
  },
  [1257] = {
    [sym_export_statement] = STATE(1519),
    [sym__declaration] = STATE(1519),
    [sym_import_statement] = STATE(1519),
    [sym_expression_statement] = STATE(1519),
    [sym_variable_declaration] = STATE(1519),
    [sym_lexical_declaration] = STATE(1519),
    [sym_statement_block] = STATE(1519),
    [sym_if_statement] = STATE(1519),
    [sym_switch_statement] = STATE(1519),
    [sym_for_statement] = STATE(1519),
    [sym_for_in_statement] = STATE(1519),
    [sym_for_of_statement] = STATE(1519),
    [sym_while_statement] = STATE(1519),
    [sym_do_statement] = STATE(1519),
    [sym_try_statement] = STATE(1519),
    [sym_with_statement] = STATE(1519),
    [sym_break_statement] = STATE(1519),
    [sym_continue_statement] = STATE(1519),
    [sym_debugger_statement] = STATE(1519),
    [sym_return_statement] = STATE(1519),
    [sym_throw_statement] = STATE(1519),
    [sym_empty_statement] = STATE(1519),
    [sym_labeled_statement] = STATE(1519),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1258] = {
    [sym_expression_statement] = STATE(1523),
    [sym_variable_declaration] = STATE(1523),
    [sym_lexical_declaration] = STATE(1523),
    [sym_empty_statement] = STATE(1523),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(1524),
    [sym_array] = STATE(1525),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_var] = ACTIONS(3583),
    [anon_sym_let] = ACTIONS(3585),
    [anon_sym_const] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3587),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1259] = {
    [anon_sym_LPAREN] = ACTIONS(3589),
    [sym_comment] = ACTIONS(78),
  },
  [1260] = {
    [sym_export_statement] = STATE(485),
    [sym__declaration] = STATE(485),
    [sym_import_statement] = STATE(485),
    [sym_expression_statement] = STATE(485),
    [sym_variable_declaration] = STATE(485),
    [sym_lexical_declaration] = STATE(485),
    [sym_statement_block] = STATE(485),
    [sym_if_statement] = STATE(485),
    [sym_switch_statement] = STATE(485),
    [sym_for_statement] = STATE(485),
    [sym_for_in_statement] = STATE(485),
    [sym_for_of_statement] = STATE(485),
    [sym_while_statement] = STATE(485),
    [sym_do_statement] = STATE(485),
    [sym_try_statement] = STATE(485),
    [sym_with_statement] = STATE(485),
    [sym_break_statement] = STATE(485),
    [sym_continue_statement] = STATE(485),
    [sym_debugger_statement] = STATE(485),
    [sym_return_statement] = STATE(485),
    [sym_throw_statement] = STATE(485),
    [sym_empty_statement] = STATE(485),
    [sym_labeled_statement] = STATE(485),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1261] = {
    [sym_export_statement] = STATE(502),
    [sym__declaration] = STATE(502),
    [sym_import_statement] = STATE(502),
    [sym_expression_statement] = STATE(502),
    [sym_variable_declaration] = STATE(502),
    [sym_lexical_declaration] = STATE(502),
    [sym_statement_block] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_switch_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_for_in_statement] = STATE(502),
    [sym_for_of_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_do_statement] = STATE(502),
    [sym_try_statement] = STATE(502),
    [sym_with_statement] = STATE(502),
    [sym_break_statement] = STATE(502),
    [sym_continue_statement] = STATE(502),
    [sym_debugger_statement] = STATE(502),
    [sym_return_statement] = STATE(502),
    [sym_throw_statement] = STATE(502),
    [sym_empty_statement] = STATE(502),
    [sym_labeled_statement] = STATE(502),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1262] = {
    [sym_export_statement] = STATE(619),
    [sym__declaration] = STATE(619),
    [sym_import_statement] = STATE(619),
    [sym_expression_statement] = STATE(619),
    [sym_variable_declaration] = STATE(619),
    [sym_lexical_declaration] = STATE(619),
    [sym_statement_block] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(619),
    [sym_for_in_statement] = STATE(619),
    [sym_for_of_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_do_statement] = STATE(619),
    [sym_try_statement] = STATE(619),
    [sym_with_statement] = STATE(619),
    [sym_break_statement] = STATE(619),
    [sym_continue_statement] = STATE(619),
    [sym_debugger_statement] = STATE(619),
    [sym_return_statement] = STATE(619),
    [sym_throw_statement] = STATE(619),
    [sym_empty_statement] = STATE(619),
    [sym_labeled_statement] = STATE(619),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1263] = {
    [sym_export_statement] = STATE(1161),
    [sym__declaration] = STATE(1161),
    [sym_import_statement] = STATE(1161),
    [sym_expression_statement] = STATE(1161),
    [sym_variable_declaration] = STATE(1161),
    [sym_lexical_declaration] = STATE(1161),
    [sym_statement_block] = STATE(1161),
    [sym_if_statement] = STATE(1161),
    [sym_switch_statement] = STATE(1161),
    [sym_for_statement] = STATE(1161),
    [sym_for_in_statement] = STATE(1161),
    [sym_for_of_statement] = STATE(1161),
    [sym_while_statement] = STATE(1161),
    [sym_do_statement] = STATE(1161),
    [sym_try_statement] = STATE(1161),
    [sym_with_statement] = STATE(1161),
    [sym_break_statement] = STATE(1161),
    [sym_continue_statement] = STATE(1161),
    [sym_debugger_statement] = STATE(1161),
    [sym_return_statement] = STATE(1161),
    [sym_throw_statement] = STATE(1161),
    [sym_empty_statement] = STATE(1161),
    [sym_labeled_statement] = STATE(1161),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1264] = {
    [sym__initializer] = STATE(363),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(3591),
    [anon_sym_of] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1265] = {
    [sym__initializer] = STATE(367),
    [sym__automatic_semicolon] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(3595),
    [anon_sym_of] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1266] = {
    [sym__initializer] = STATE(368),
    [sym__automatic_semicolon] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(3599),
    [anon_sym_of] = ACTIONS(3601),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1267] = {
    [sym_parenthesized_expression] = STATE(1533),
    [sym__expression] = STATE(1533),
    [sym_yield_expression] = STATE(1533),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1533),
    [sym_jsx_fragment] = STATE(1533),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1533),
    [sym_anonymous_class] = STATE(1533),
    [sym_class] = STATE(1533),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1533),
    [sym_generator_function] = STATE(1533),
    [sym_call_expression] = STATE(1533),
    [sym_new_expression] = STATE(1533),
    [sym_await_expression] = STATE(1533),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1533),
    [sym_augmented_assignment_expression] = STATE(1533),
    [sym_ternary_expression] = STATE(1533),
    [sym_binary_expression] = STATE(1533),
    [sym_unary_expression] = STATE(1533),
    [sym_update_expression] = STATE(1533),
    [sym_sequence_expression] = STATE(1534),
    [sym_string] = STATE(1533),
    [sym_template_string] = STATE(1533),
    [sym_regex] = STATE(1533),
    [sym_meta_property] = STATE(1533),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3603),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3605),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3605),
    [sym_false] = ACTIONS(3605),
    [sym_null] = ACTIONS(3605),
    [sym_undefined] = ACTIONS(3605),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1268] = {
    [sym_parenthesized_expression] = STATE(1535),
    [sym__expression] = STATE(1535),
    [sym_yield_expression] = STATE(1535),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1535),
    [sym_jsx_fragment] = STATE(1535),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1535),
    [sym_anonymous_class] = STATE(1535),
    [sym_class] = STATE(1535),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1535),
    [sym_generator_function] = STATE(1535),
    [sym_call_expression] = STATE(1535),
    [sym_new_expression] = STATE(1535),
    [sym_await_expression] = STATE(1535),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1535),
    [sym_augmented_assignment_expression] = STATE(1535),
    [sym_ternary_expression] = STATE(1535),
    [sym_binary_expression] = STATE(1535),
    [sym_unary_expression] = STATE(1535),
    [sym_update_expression] = STATE(1535),
    [sym_string] = STATE(1535),
    [sym_template_string] = STATE(1535),
    [sym_regex] = STATE(1535),
    [sym_meta_property] = STATE(1535),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3607),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3609),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3609),
    [sym_false] = ACTIONS(3609),
    [sym_null] = ACTIONS(3609),
    [sym_undefined] = ACTIONS(3609),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1269] = {
    [sym_parenthesized_expression] = STATE(1537),
    [sym__expression] = STATE(1537),
    [sym_yield_expression] = STATE(1537),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1537),
    [sym_jsx_fragment] = STATE(1537),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1537),
    [sym_anonymous_class] = STATE(1537),
    [sym_class] = STATE(1537),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1537),
    [sym_generator_function] = STATE(1537),
    [sym_call_expression] = STATE(1537),
    [sym_new_expression] = STATE(1537),
    [sym_await_expression] = STATE(1537),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1537),
    [sym_augmented_assignment_expression] = STATE(1537),
    [sym_ternary_expression] = STATE(1537),
    [sym_binary_expression] = STATE(1537),
    [sym_unary_expression] = STATE(1537),
    [sym_update_expression] = STATE(1537),
    [sym_sequence_expression] = STATE(1538),
    [sym_string] = STATE(1537),
    [sym_template_string] = STATE(1537),
    [sym_regex] = STATE(1537),
    [sym_meta_property] = STATE(1537),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(3611),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3613),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3615),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3615),
    [sym_false] = ACTIONS(3615),
    [sym_null] = ACTIONS(3615),
    [sym_undefined] = ACTIONS(3615),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1270] = {
    [sym_parenthesized_expression] = STATE(1539),
    [sym__expression] = STATE(1539),
    [sym_yield_expression] = STATE(1539),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1539),
    [sym_jsx_fragment] = STATE(1539),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1539),
    [sym_anonymous_class] = STATE(1539),
    [sym_class] = STATE(1539),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1539),
    [sym_generator_function] = STATE(1539),
    [sym_call_expression] = STATE(1539),
    [sym_new_expression] = STATE(1539),
    [sym_await_expression] = STATE(1539),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1539),
    [sym_augmented_assignment_expression] = STATE(1539),
    [sym_ternary_expression] = STATE(1539),
    [sym_binary_expression] = STATE(1539),
    [sym_unary_expression] = STATE(1539),
    [sym_update_expression] = STATE(1539),
    [sym_sequence_expression] = STATE(1540),
    [sym_string] = STATE(1539),
    [sym_template_string] = STATE(1539),
    [sym_regex] = STATE(1539),
    [sym_meta_property] = STATE(1539),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3617),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3619),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3619),
    [sym_false] = ACTIONS(3619),
    [sym_null] = ACTIONS(3619),
    [sym_undefined] = ACTIONS(3619),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1271] = {
    [sym_parenthesized_expression] = STATE(1541),
    [sym__expression] = STATE(1541),
    [sym_yield_expression] = STATE(1541),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1541),
    [sym_jsx_fragment] = STATE(1541),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1541),
    [sym_anonymous_class] = STATE(1541),
    [sym_class] = STATE(1541),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1541),
    [sym_generator_function] = STATE(1541),
    [sym_call_expression] = STATE(1541),
    [sym_new_expression] = STATE(1541),
    [sym_await_expression] = STATE(1541),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1541),
    [sym_augmented_assignment_expression] = STATE(1541),
    [sym_ternary_expression] = STATE(1541),
    [sym_binary_expression] = STATE(1541),
    [sym_unary_expression] = STATE(1541),
    [sym_update_expression] = STATE(1541),
    [sym_string] = STATE(1541),
    [sym_template_string] = STATE(1541),
    [sym_regex] = STATE(1541),
    [sym_meta_property] = STATE(1541),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3621),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3623),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3623),
    [sym_false] = ACTIONS(3623),
    [sym_null] = ACTIONS(3623),
    [sym_undefined] = ACTIONS(3623),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1272] = {
    [sym_parenthesized_expression] = STATE(1542),
    [sym__expression] = STATE(1542),
    [sym_yield_expression] = STATE(1542),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1542),
    [sym_jsx_fragment] = STATE(1542),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1542),
    [sym_anonymous_class] = STATE(1542),
    [sym_class] = STATE(1542),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1542),
    [sym_generator_function] = STATE(1542),
    [sym_call_expression] = STATE(1542),
    [sym_new_expression] = STATE(1542),
    [sym_await_expression] = STATE(1542),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1542),
    [sym_augmented_assignment_expression] = STATE(1542),
    [sym_ternary_expression] = STATE(1542),
    [sym_binary_expression] = STATE(1542),
    [sym_unary_expression] = STATE(1542),
    [sym_update_expression] = STATE(1542),
    [sym_sequence_expression] = STATE(1543),
    [sym_string] = STATE(1542),
    [sym_template_string] = STATE(1542),
    [sym_regex] = STATE(1542),
    [sym_meta_property] = STATE(1542),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3625),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3627),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3627),
    [sym_false] = ACTIONS(3627),
    [sym_null] = ACTIONS(3627),
    [sym_undefined] = ACTIONS(3627),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1273] = {
    [sym_parenthesized_expression] = STATE(1544),
    [sym__expression] = STATE(1544),
    [sym_yield_expression] = STATE(1544),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1544),
    [sym_jsx_fragment] = STATE(1544),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1544),
    [sym_anonymous_class] = STATE(1544),
    [sym_class] = STATE(1544),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1544),
    [sym_generator_function] = STATE(1544),
    [sym_call_expression] = STATE(1544),
    [sym_new_expression] = STATE(1544),
    [sym_await_expression] = STATE(1544),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1544),
    [sym_augmented_assignment_expression] = STATE(1544),
    [sym_ternary_expression] = STATE(1544),
    [sym_binary_expression] = STATE(1544),
    [sym_unary_expression] = STATE(1544),
    [sym_update_expression] = STATE(1544),
    [sym_string] = STATE(1544),
    [sym_template_string] = STATE(1544),
    [sym_regex] = STATE(1544),
    [sym_meta_property] = STATE(1544),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3629),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3631),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3631),
    [sym_false] = ACTIONS(3631),
    [sym_null] = ACTIONS(3631),
    [sym_undefined] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1274] = {
    [sym_object] = STATE(1546),
    [sym_array] = STATE(1547),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3633),
  },
  [1275] = {
    [anon_sym_of] = ACTIONS(3593),
    [sym_comment] = ACTIONS(78),
  },
  [1276] = {
    [anon_sym_of] = ACTIONS(3597),
    [sym_comment] = ACTIONS(78),
  },
  [1277] = {
    [anon_sym_of] = ACTIONS(3601),
    [sym_comment] = ACTIONS(78),
  },
  [1278] = {
    [ts_builtin_sym_end] = ACTIONS(3635),
    [anon_sym_export] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_import] = ACTIONS(3637),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_else] = ACTIONS(3637),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(3635),
    [anon_sym_await] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_with] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_debugger] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_yield] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [anon_sym_LT] = ACTIONS(3635),
    [anon_sym_SLASH] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_async] = ACTIONS(3637),
    [anon_sym_function] = ACTIONS(3637),
    [anon_sym_EQ_GT] = ACTIONS(3635),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_typeof] = ACTIONS(3637),
    [anon_sym_void] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_PLUS_PLUS] = ACTIONS(3635),
    [anon_sym_DASH_DASH] = ACTIONS(3635),
    [anon_sym_DQUOTE] = ACTIONS(3635),
    [anon_sym_SQUOTE] = ACTIONS(3635),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3635),
    [sym_number] = ACTIONS(3635),
    [sym_identifier] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [sym_super] = ACTIONS(3637),
    [sym_true] = ACTIONS(3637),
    [sym_false] = ACTIONS(3637),
    [sym_null] = ACTIONS(3637),
    [sym_undefined] = ACTIONS(3637),
    [anon_sym_AT] = ACTIONS(3635),
    [anon_sym_get] = ACTIONS(3637),
    [anon_sym_set] = ACTIONS(3637),
  },
  [1279] = {
    [anon_sym_RPAREN] = ACTIONS(3639),
    [sym_comment] = ACTIONS(78),
  },
  [1280] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1281] = {
    [sym_parenthesized_expression] = STATE(1549),
    [sym__expression] = STATE(1549),
    [sym_yield_expression] = STATE(1549),
    [sym_object] = STATE(177),
    [sym_array] = STATE(178),
    [sym_jsx_element] = STATE(1549),
    [sym_jsx_fragment] = STATE(1549),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1549),
    [sym_anonymous_class] = STATE(1549),
    [sym_class] = STATE(1549),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1549),
    [sym_generator_function] = STATE(1549),
    [sym_call_expression] = STATE(1549),
    [sym_new_expression] = STATE(1549),
    [sym_await_expression] = STATE(1549),
    [sym_member_expression] = STATE(179),
    [sym_subscript_expression] = STATE(179),
    [sym_assignment_expression] = STATE(1549),
    [sym_augmented_assignment_expression] = STATE(1549),
    [sym_ternary_expression] = STATE(1549),
    [sym_binary_expression] = STATE(1549),
    [sym_unary_expression] = STATE(1549),
    [sym_update_expression] = STATE(1549),
    [sym_string] = STATE(1549),
    [sym_template_string] = STATE(1549),
    [sym_regex] = STATE(1549),
    [sym_meta_property] = STATE(1549),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(266),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(272),
    [anon_sym_new] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_DASH] = ACTIONS(278),
    [anon_sym_BANG] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_typeof] = ACTIONS(278),
    [anon_sym_void] = ACTIONS(278),
    [anon_sym_delete] = ACTIONS(278),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3641),
    [sym_identifier] = ACTIONS(286),
    [sym_this] = ACTIONS(3643),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3643),
    [sym_false] = ACTIONS(3643),
    [sym_null] = ACTIONS(3643),
    [sym_undefined] = ACTIONS(3643),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(290),
    [anon_sym_set] = ACTIONS(290),
  },
  [1282] = {
    [sym__automatic_semicolon] = ACTIONS(3645),
    [anon_sym_STAR] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3645),
    [anon_sym_RBRACE] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_RPAREN] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3647),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_LT] = ACTIONS(3647),
    [anon_sym_GT] = ACTIONS(3647),
    [anon_sym_SLASH] = ACTIONS(3647),
    [anon_sym_DOT] = ACTIONS(3645),
    [anon_sym_QMARK] = ACTIONS(3645),
    [anon_sym_AMP_AMP] = ACTIONS(3645),
    [anon_sym_PIPE_PIPE] = ACTIONS(3645),
    [anon_sym_GT_GT] = ACTIONS(3647),
    [anon_sym_GT_GT_GT] = ACTIONS(3645),
    [anon_sym_LT_LT] = ACTIONS(3645),
    [anon_sym_AMP] = ACTIONS(3647),
    [anon_sym_CARET] = ACTIONS(3645),
    [anon_sym_PIPE] = ACTIONS(3647),
    [anon_sym_PLUS] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3647),
    [anon_sym_PERCENT] = ACTIONS(3645),
    [anon_sym_LT_EQ] = ACTIONS(3645),
    [anon_sym_EQ_EQ] = ACTIONS(3647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3645),
    [anon_sym_BANG_EQ] = ACTIONS(3647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3645),
    [anon_sym_GT_EQ] = ACTIONS(3645),
    [anon_sym_instanceof] = ACTIONS(3645),
    [anon_sym_PLUS_PLUS] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3645),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3645),
  },
  [1283] = {
    [anon_sym_GT] = ACTIONS(3649),
    [sym_comment] = ACTIONS(78),
  },
  [1284] = {
    [anon_sym_LBRACE] = ACTIONS(3651),
    [anon_sym_GT] = ACTIONS(3651),
    [anon_sym_SLASH] = ACTIONS(3147),
    [sym_jsx_identifier] = ACTIONS(3651),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3147),
  },
  [1285] = {
    [sym_nested_identifier] = STATE(1554),
    [sym_jsx_namespace_name] = STATE(1555),
    [anon_sym_GT] = ACTIONS(3653),
    [sym_jsx_identifier] = ACTIONS(3655),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3657),
  },
  [1286] = {
    [aux_sym_string_repeat1] = STATE(1557),
    [anon_sym_DQUOTE] = ACTIONS(3659),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(3661),
    [sym_escape_sequence] = ACTIONS(3661),
    [sym_comment] = ACTIONS(298),
  },
  [1287] = {
    [aux_sym_string_repeat2] = STATE(1558),
    [anon_sym_SQUOTE] = ACTIONS(3659),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(3663),
    [sym_escape_sequence] = ACTIONS(3663),
    [sym_comment] = ACTIONS(298),
  },
  [1288] = {
    [anon_sym_LBRACE] = ACTIONS(3665),
    [anon_sym_GT] = ACTIONS(3665),
    [anon_sym_SLASH] = ACTIONS(3667),
    [sym_jsx_identifier] = ACTIONS(3665),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3667),
  },
  [1289] = {
    [sym_jsx_element] = STATE(1561),
    [sym_jsx_expression] = STATE(1561),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_closing_element] = STATE(1560),
    [sym_jsx_self_closing_element] = STATE(1561),
    [aux_sym_jsx_element_repeat1] = STATE(1561),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(3669),
    [sym_jsx_text] = ACTIONS(3671),
    [sym_comment] = ACTIONS(78),
  },
  [1290] = {
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_GT] = ACTIONS(3673),
    [anon_sym_SLASH] = ACTIONS(3675),
    [sym_jsx_identifier] = ACTIONS(3673),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3675),
  },
  [1291] = {
    [sym__automatic_semicolon] = ACTIONS(3677),
    [anon_sym_STAR] = ACTIONS(3677),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_RBRACE] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_RPAREN] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3679),
    [anon_sym_SEMI] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3679),
    [anon_sym_GT] = ACTIONS(3679),
    [anon_sym_SLASH] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_QMARK] = ACTIONS(3677),
    [anon_sym_AMP_AMP] = ACTIONS(3677),
    [anon_sym_PIPE_PIPE] = ACTIONS(3677),
    [anon_sym_GT_GT] = ACTIONS(3679),
    [anon_sym_GT_GT_GT] = ACTIONS(3677),
    [anon_sym_LT_LT] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_CARET] = ACTIONS(3677),
    [anon_sym_PIPE] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3677),
    [anon_sym_LT_EQ] = ACTIONS(3677),
    [anon_sym_EQ_EQ] = ACTIONS(3679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3677),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3677),
    [anon_sym_GT_EQ] = ACTIONS(3677),
    [anon_sym_instanceof] = ACTIONS(3677),
    [anon_sym_PLUS_PLUS] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3677),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3677),
  },
  [1292] = {
    [sym__automatic_semicolon] = ACTIONS(2513),
    [anon_sym_LPAREN] = ACTIONS(2513),
    [anon_sym_SEMI] = ACTIONS(2513),
    [anon_sym_EQ] = ACTIONS(2513),
    [sym_comment] = ACTIONS(78),
  },
  [1293] = {
    [sym__automatic_semicolon] = ACTIONS(2193),
    [anon_sym_LPAREN] = ACTIONS(2193),
    [anon_sym_SEMI] = ACTIONS(2193),
    [anon_sym_EQ] = ACTIONS(2193),
    [sym_comment] = ACTIONS(78),
  },
  [1294] = {
    [anon_sym_STAR] = ACTIONS(3681),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_async] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(3681),
    [anon_sym_SQUOTE] = ACTIONS(3681),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(3681),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_AT] = ACTIONS(3681),
    [anon_sym_static] = ACTIONS(3683),
    [anon_sym_get] = ACTIONS(3683),
    [anon_sym_set] = ACTIONS(3683),
  },
  [1295] = {
    [sym__automatic_semicolon] = ACTIONS(3685),
    [anon_sym_SEMI] = ACTIONS(3685),
    [sym_comment] = ACTIONS(78),
  },
  [1296] = {
    [anon_sym_STAR] = ACTIONS(3681),
    [anon_sym_RBRACE] = ACTIONS(3681),
    [anon_sym_SEMI] = ACTIONS(3685),
    [anon_sym_LBRACK] = ACTIONS(3681),
    [anon_sym_async] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(3681),
    [anon_sym_SQUOTE] = ACTIONS(3681),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(3681),
    [sym_identifier] = ACTIONS(3683),
    [anon_sym_AT] = ACTIONS(3681),
    [anon_sym_static] = ACTIONS(3683),
    [anon_sym_get] = ACTIONS(3683),
    [anon_sym_set] = ACTIONS(3683),
  },
  [1297] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1298] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1299] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1300] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1563),
    [sym__expression] = STATE(1563),
    [sym_yield_expression] = STATE(1563),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1563),
    [sym_jsx_fragment] = STATE(1563),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1563),
    [sym_anonymous_class] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1563),
    [sym_generator_function] = STATE(1563),
    [sym_call_expression] = STATE(1563),
    [sym_new_expression] = STATE(1563),
    [sym_await_expression] = STATE(1563),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1563),
    [sym_augmented_assignment_expression] = STATE(1563),
    [sym_ternary_expression] = STATE(1563),
    [sym_binary_expression] = STATE(1563),
    [sym_unary_expression] = STATE(1563),
    [sym_update_expression] = STATE(1563),
    [sym_string] = STATE(1563),
    [sym_template_string] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_meta_property] = STATE(1563),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3687),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(3689),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3689),
    [sym_false] = ACTIONS(3689),
    [sym_null] = ACTIONS(3689),
    [sym_undefined] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [1301] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1302] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1303] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(3691),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1304] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1305] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1306] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1307] = {
    [sym__automatic_semicolon] = ACTIONS(3693),
    [ts_builtin_sym_end] = ACTIONS(3693),
    [anon_sym_export] = ACTIONS(3695),
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_import] = ACTIONS(3695),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_else] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_RPAREN] = ACTIONS(3693),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_await] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_with] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_debugger] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_GT] = ACTIONS(3695),
    [anon_sym_SLASH] = ACTIONS(3695),
    [anon_sym_DOT] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_async] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3695),
    [anon_sym_EQ_GT] = ACTIONS(3693),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_GT_GT] = ACTIONS(3695),
    [anon_sym_GT_GT_GT] = ACTIONS(3693),
    [anon_sym_LT_LT] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_CARET] = ACTIONS(3693),
    [anon_sym_PIPE] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_LT_EQ] = ACTIONS(3693),
    [anon_sym_EQ_EQ] = ACTIONS(3695),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3695),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3693),
    [anon_sym_GT_EQ] = ACTIONS(3693),
    [anon_sym_instanceof] = ACTIONS(3695),
    [anon_sym_BANG] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_typeof] = ACTIONS(3695),
    [anon_sym_void] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3693),
    [sym_number] = ACTIONS(3693),
    [sym_identifier] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [sym_super] = ACTIONS(3695),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [sym_null] = ACTIONS(3695),
    [sym_undefined] = ACTIONS(3695),
    [anon_sym_AT] = ACTIONS(3693),
    [anon_sym_get] = ACTIONS(3695),
    [anon_sym_set] = ACTIONS(3695),
  },
  [1308] = {
    [sym__automatic_semicolon] = ACTIONS(3697),
    [ts_builtin_sym_end] = ACTIONS(3697),
    [anon_sym_export] = ACTIONS(3699),
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3697),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_import] = ACTIONS(3699),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_else] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_RPAREN] = ACTIONS(3697),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_debugger] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_SLASH] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3699),
    [anon_sym_EQ_GT] = ACTIONS(3697),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3697),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_LT_EQ] = ACTIONS(3697),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3697),
    [anon_sym_GT_EQ] = ACTIONS(3697),
    [anon_sym_instanceof] = ACTIONS(3699),
    [anon_sym_BANG] = ACTIONS(3699),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym_void] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3697),
    [sym_number] = ACTIONS(3697),
    [sym_identifier] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [sym_super] = ACTIONS(3699),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [sym_null] = ACTIONS(3699),
    [sym_undefined] = ACTIONS(3699),
    [anon_sym_AT] = ACTIONS(3697),
    [anon_sym_get] = ACTIONS(3699),
    [anon_sym_set] = ACTIONS(3699),
  },
  [1309] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(439),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(439),
    [sym_class] = STATE(439),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(439),
    [sym_generator_function] = STATE(439),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(439),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(439),
    [sym_template_string] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_meta_property] = STATE(439),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [1310] = {
    [sym__initializer] = STATE(478),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(3701),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(3701),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(729),
    [anon_sym_EQ_GT] = ACTIONS(733),
    [anon_sym_PLUS_EQ] = ACTIONS(791),
    [anon_sym_DASH_EQ] = ACTIONS(791),
    [anon_sym_STAR_EQ] = ACTIONS(791),
    [anon_sym_SLASH_EQ] = ACTIONS(791),
    [anon_sym_PERCENT_EQ] = ACTIONS(791),
    [anon_sym_CARET_EQ] = ACTIONS(791),
    [anon_sym_AMP_EQ] = ACTIONS(791),
    [anon_sym_PIPE_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(791),
    [anon_sym_LT_LT_EQ] = ACTIONS(791),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1311] = {
    [sym_parenthesized_expression] = STATE(439),
    [sym__expression] = STATE(439),
    [sym_yield_expression] = STATE(439),
    [sym_object] = STATE(595),
    [sym_array] = STATE(596),
    [sym_jsx_element] = STATE(439),
    [sym_jsx_fragment] = STATE(439),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(439),
    [sym_anonymous_class] = STATE(439),
    [sym_class] = STATE(439),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(439),
    [sym_generator_function] = STATE(439),
    [sym_call_expression] = STATE(439),
    [sym_new_expression] = STATE(439),
    [sym_await_expression] = STATE(439),
    [sym_member_expression] = STATE(597),
    [sym_subscript_expression] = STATE(597),
    [sym_assignment_expression] = STATE(439),
    [sym_augmented_assignment_expression] = STATE(439),
    [sym_ternary_expression] = STATE(439),
    [sym_binary_expression] = STATE(439),
    [sym_unary_expression] = STATE(439),
    [sym_update_expression] = STATE(439),
    [sym_string] = STATE(439),
    [sym_template_string] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_meta_property] = STATE(439),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(598),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(339),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1067),
    [anon_sym_new] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_BANG] = ACTIONS(349),
    [anon_sym_TILDE] = ACTIONS(349),
    [anon_sym_typeof] = ACTIONS(347),
    [anon_sym_void] = ACTIONS(347),
    [anon_sym_delete] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1075),
    [sym_false] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1077),
  },
  [1312] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(2207),
    [anon_sym_RBRACE] = ACTIONS(2261),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1313] = {
    [sym__automatic_semicolon] = ACTIONS(3704),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_COMMA] = ACTIONS(3704),
    [anon_sym_RBRACE] = ACTIONS(3704),
    [anon_sym_LPAREN] = ACTIONS(3704),
    [anon_sym_RPAREN] = ACTIONS(3704),
    [anon_sym_in] = ACTIONS(3706),
    [anon_sym_SEMI] = ACTIONS(3704),
    [anon_sym_LBRACK] = ACTIONS(3704),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_DOT] = ACTIONS(3704),
    [anon_sym_QMARK] = ACTIONS(3704),
    [anon_sym_AMP_AMP] = ACTIONS(3704),
    [anon_sym_PIPE_PIPE] = ACTIONS(3704),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3704),
    [anon_sym_LT_LT] = ACTIONS(3704),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3704),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3704),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_EQ_EQ] = ACTIONS(3706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3704),
    [anon_sym_BANG_EQ] = ACTIONS(3706),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3704),
    [anon_sym_instanceof] = ACTIONS(3704),
    [anon_sym_PLUS_PLUS] = ACTIONS(3704),
    [anon_sym_DASH_DASH] = ACTIONS(3704),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3704),
  },
  [1314] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(2251),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2261),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1315] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1316] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1317] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1318] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1565),
    [sym__expression] = STATE(1565),
    [sym_yield_expression] = STATE(1565),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1565),
    [sym_jsx_fragment] = STATE(1565),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1565),
    [sym_anonymous_class] = STATE(1565),
    [sym_class] = STATE(1565),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1565),
    [sym_generator_function] = STATE(1565),
    [sym_call_expression] = STATE(1565),
    [sym_new_expression] = STATE(1565),
    [sym_await_expression] = STATE(1565),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1565),
    [sym_augmented_assignment_expression] = STATE(1565),
    [sym_ternary_expression] = STATE(1565),
    [sym_binary_expression] = STATE(1565),
    [sym_unary_expression] = STATE(1565),
    [sym_update_expression] = STATE(1565),
    [sym_string] = STATE(1565),
    [sym_template_string] = STATE(1565),
    [sym_regex] = STATE(1565),
    [sym_meta_property] = STATE(1565),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3708),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3710),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3710),
    [sym_false] = ACTIONS(3710),
    [sym_null] = ACTIONS(3710),
    [sym_undefined] = ACTIONS(3710),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1319] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1320] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1321] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(3712),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_COMMA] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(387),
    [anon_sym_SLASH] = ACTIONS(411),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(413),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(411),
    [anon_sym_GT_GT_GT] = ACTIONS(407),
    [anon_sym_LT_LT] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(387),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(425),
    [anon_sym_instanceof] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1322] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1323] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1324] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1325] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1326] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1327] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1328] = {
    [sym_parenthesized_expression] = STATE(1567),
    [sym__expression] = STATE(1567),
    [sym_yield_expression] = STATE(1567),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1567),
    [sym_jsx_fragment] = STATE(1567),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1567),
    [sym_anonymous_class] = STATE(1567),
    [sym_class] = STATE(1567),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1567),
    [sym_generator_function] = STATE(1567),
    [sym_call_expression] = STATE(1567),
    [sym_new_expression] = STATE(1567),
    [sym_await_expression] = STATE(1567),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1567),
    [sym_augmented_assignment_expression] = STATE(1567),
    [sym_ternary_expression] = STATE(1567),
    [sym_binary_expression] = STATE(1567),
    [sym_unary_expression] = STATE(1567),
    [sym_update_expression] = STATE(1567),
    [sym_string] = STATE(1567),
    [sym_template_string] = STATE(1567),
    [sym_regex] = STATE(1567),
    [sym_meta_property] = STATE(1567),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3716),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3718),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3718),
    [sym_false] = ACTIONS(3718),
    [sym_null] = ACTIONS(3718),
    [sym_undefined] = ACTIONS(3718),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1329] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(1568),
    [sym__expression] = STATE(1568),
    [sym_yield_expression] = STATE(1568),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1568),
    [sym_jsx_fragment] = STATE(1568),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1568),
    [sym_anonymous_class] = STATE(1568),
    [sym_class] = STATE(1568),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1568),
    [sym_generator_function] = STATE(1568),
    [sym_call_expression] = STATE(1568),
    [sym_new_expression] = STATE(1568),
    [sym_await_expression] = STATE(1568),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1568),
    [sym_augmented_assignment_expression] = STATE(1568),
    [sym_ternary_expression] = STATE(1568),
    [sym_binary_expression] = STATE(1568),
    [sym_unary_expression] = STATE(1568),
    [sym_update_expression] = STATE(1568),
    [sym_string] = STATE(1568),
    [sym_template_string] = STATE(1568),
    [sym_regex] = STATE(1568),
    [sym_meta_property] = STATE(1568),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3720),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3722),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3722),
    [sym_false] = ACTIONS(3722),
    [sym_null] = ACTIONS(3722),
    [sym_undefined] = ACTIONS(3722),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1330] = {
    [sym_parenthesized_expression] = STATE(1569),
    [sym__expression] = STATE(1569),
    [sym_yield_expression] = STATE(1569),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1569),
    [sym_jsx_fragment] = STATE(1569),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1569),
    [sym_anonymous_class] = STATE(1569),
    [sym_class] = STATE(1569),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1569),
    [sym_generator_function] = STATE(1569),
    [sym_call_expression] = STATE(1569),
    [sym_new_expression] = STATE(1569),
    [sym_await_expression] = STATE(1569),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1569),
    [sym_augmented_assignment_expression] = STATE(1569),
    [sym_ternary_expression] = STATE(1569),
    [sym_binary_expression] = STATE(1569),
    [sym_unary_expression] = STATE(1569),
    [sym_update_expression] = STATE(1569),
    [sym_string] = STATE(1569),
    [sym_template_string] = STATE(1569),
    [sym_regex] = STATE(1569),
    [sym_meta_property] = STATE(1569),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3724),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3726),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3726),
    [sym_false] = ACTIONS(3726),
    [sym_null] = ACTIONS(3726),
    [sym_undefined] = ACTIONS(3726),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1331] = {
    [anon_sym_EQ_GT] = ACTIONS(3728),
    [sym_comment] = ACTIONS(78),
  },
  [1332] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1333] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(1331),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(3115),
  },
  [1334] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [1335] = {
    [sym_parenthesized_expression] = STATE(1571),
    [sym__expression] = STATE(1571),
    [sym_yield_expression] = STATE(1571),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1571),
    [sym_jsx_fragment] = STATE(1571),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1571),
    [sym_anonymous_class] = STATE(1571),
    [sym_class] = STATE(1571),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1571),
    [sym_generator_function] = STATE(1571),
    [sym_call_expression] = STATE(1571),
    [sym_new_expression] = STATE(1571),
    [sym_await_expression] = STATE(1571),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1571),
    [sym_augmented_assignment_expression] = STATE(1571),
    [sym_ternary_expression] = STATE(1571),
    [sym_binary_expression] = STATE(1571),
    [sym_unary_expression] = STATE(1571),
    [sym_update_expression] = STATE(1571),
    [sym_string] = STATE(1571),
    [sym_template_string] = STATE(1571),
    [sym_regex] = STATE(1571),
    [sym_meta_property] = STATE(1571),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3730),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3732),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3732),
    [sym_false] = ACTIONS(3732),
    [sym_null] = ACTIONS(3732),
    [sym_undefined] = ACTIONS(3732),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1336] = {
    [sym_parenthesized_expression] = STATE(1572),
    [sym__expression] = STATE(1572),
    [sym_yield_expression] = STATE(1572),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1572),
    [sym_jsx_fragment] = STATE(1572),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1572),
    [sym_anonymous_class] = STATE(1572),
    [sym_class] = STATE(1572),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1572),
    [sym_generator_function] = STATE(1572),
    [sym_call_expression] = STATE(1572),
    [sym_new_expression] = STATE(1572),
    [sym_await_expression] = STATE(1572),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1572),
    [sym_augmented_assignment_expression] = STATE(1572),
    [sym_ternary_expression] = STATE(1572),
    [sym_binary_expression] = STATE(1572),
    [sym_unary_expression] = STATE(1572),
    [sym_update_expression] = STATE(1572),
    [sym_string] = STATE(1572),
    [sym_template_string] = STATE(1572),
    [sym_regex] = STATE(1572),
    [sym_meta_property] = STATE(1572),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3734),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3736),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3736),
    [sym_false] = ACTIONS(3736),
    [sym_null] = ACTIONS(3736),
    [sym_undefined] = ACTIONS(3736),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1337] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1338] = {
    [sym_parenthesized_expression] = STATE(1573),
    [sym__expression] = STATE(1573),
    [sym_yield_expression] = STATE(1573),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1573),
    [sym_jsx_fragment] = STATE(1573),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1573),
    [sym_anonymous_class] = STATE(1573),
    [sym_class] = STATE(1573),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1573),
    [sym_generator_function] = STATE(1573),
    [sym_call_expression] = STATE(1573),
    [sym_new_expression] = STATE(1573),
    [sym_await_expression] = STATE(1573),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1573),
    [sym_augmented_assignment_expression] = STATE(1573),
    [sym_ternary_expression] = STATE(1573),
    [sym_binary_expression] = STATE(1573),
    [sym_unary_expression] = STATE(1573),
    [sym_update_expression] = STATE(1573),
    [sym_string] = STATE(1573),
    [sym_template_string] = STATE(1573),
    [sym_regex] = STATE(1573),
    [sym_meta_property] = STATE(1573),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3738),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3740),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3740),
    [sym_false] = ACTIONS(3740),
    [sym_null] = ACTIONS(3740),
    [sym_undefined] = ACTIONS(3740),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1339] = {
    [sym_parenthesized_expression] = STATE(1574),
    [sym__expression] = STATE(1574),
    [sym_yield_expression] = STATE(1574),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1574),
    [sym_jsx_fragment] = STATE(1574),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1574),
    [sym_anonymous_class] = STATE(1574),
    [sym_class] = STATE(1574),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1574),
    [sym_generator_function] = STATE(1574),
    [sym_call_expression] = STATE(1574),
    [sym_new_expression] = STATE(1574),
    [sym_await_expression] = STATE(1574),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1574),
    [sym_augmented_assignment_expression] = STATE(1574),
    [sym_ternary_expression] = STATE(1574),
    [sym_binary_expression] = STATE(1574),
    [sym_unary_expression] = STATE(1574),
    [sym_update_expression] = STATE(1574),
    [sym_string] = STATE(1574),
    [sym_template_string] = STATE(1574),
    [sym_regex] = STATE(1574),
    [sym_meta_property] = STATE(1574),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3742),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3744),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3744),
    [sym_false] = ACTIONS(3744),
    [sym_null] = ACTIONS(3744),
    [sym_undefined] = ACTIONS(3744),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1340] = {
    [sym_parenthesized_expression] = STATE(1575),
    [sym__expression] = STATE(1575),
    [sym_yield_expression] = STATE(1575),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1575),
    [sym_jsx_fragment] = STATE(1575),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1575),
    [sym_anonymous_class] = STATE(1575),
    [sym_class] = STATE(1575),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1575),
    [sym_generator_function] = STATE(1575),
    [sym_call_expression] = STATE(1575),
    [sym_new_expression] = STATE(1575),
    [sym_await_expression] = STATE(1575),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1575),
    [sym_augmented_assignment_expression] = STATE(1575),
    [sym_ternary_expression] = STATE(1575),
    [sym_binary_expression] = STATE(1575),
    [sym_unary_expression] = STATE(1575),
    [sym_update_expression] = STATE(1575),
    [sym_string] = STATE(1575),
    [sym_template_string] = STATE(1575),
    [sym_regex] = STATE(1575),
    [sym_meta_property] = STATE(1575),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3746),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3748),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3748),
    [sym_false] = ACTIONS(3748),
    [sym_null] = ACTIONS(3748),
    [sym_undefined] = ACTIONS(3748),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1341] = {
    [sym_parenthesized_expression] = STATE(1576),
    [sym__expression] = STATE(1576),
    [sym_yield_expression] = STATE(1576),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1576),
    [sym_jsx_fragment] = STATE(1576),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1576),
    [sym_anonymous_class] = STATE(1576),
    [sym_class] = STATE(1576),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1576),
    [sym_generator_function] = STATE(1576),
    [sym_call_expression] = STATE(1576),
    [sym_new_expression] = STATE(1576),
    [sym_await_expression] = STATE(1576),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1576),
    [sym_augmented_assignment_expression] = STATE(1576),
    [sym_ternary_expression] = STATE(1576),
    [sym_binary_expression] = STATE(1576),
    [sym_unary_expression] = STATE(1576),
    [sym_update_expression] = STATE(1576),
    [sym_string] = STATE(1576),
    [sym_template_string] = STATE(1576),
    [sym_regex] = STATE(1576),
    [sym_meta_property] = STATE(1576),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3750),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(3752),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3752),
    [sym_false] = ACTIONS(3752),
    [sym_null] = ACTIONS(3752),
    [sym_undefined] = ACTIONS(3752),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1342] = {
    [sym__automatic_semicolon] = ACTIONS(3754),
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_RPAREN] = ACTIONS(3754),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [anon_sym_LT] = ACTIONS(3756),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3756),
    [anon_sym_DOT] = ACTIONS(3754),
    [anon_sym_QMARK] = ACTIONS(3754),
    [anon_sym_AMP_AMP] = ACTIONS(3754),
    [anon_sym_PIPE_PIPE] = ACTIONS(3754),
    [anon_sym_GT_GT] = ACTIONS(3756),
    [anon_sym_GT_GT_GT] = ACTIONS(3754),
    [anon_sym_LT_LT] = ACTIONS(3754),
    [anon_sym_AMP] = ACTIONS(3756),
    [anon_sym_CARET] = ACTIONS(3754),
    [anon_sym_PIPE] = ACTIONS(3756),
    [anon_sym_PLUS] = ACTIONS(3756),
    [anon_sym_DASH] = ACTIONS(3756),
    [anon_sym_PERCENT] = ACTIONS(3754),
    [anon_sym_LT_EQ] = ACTIONS(3754),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3754),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3754),
    [anon_sym_GT_EQ] = ACTIONS(3754),
    [anon_sym_instanceof] = ACTIONS(3754),
    [anon_sym_PLUS_PLUS] = ACTIONS(3754),
    [anon_sym_DASH_DASH] = ACTIONS(3754),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3754),
  },
  [1343] = {
    [anon_sym_LBRACE] = ACTIONS(2893),
    [anon_sym_LT] = ACTIONS(2893),
    [sym_jsx_text] = ACTIONS(2893),
    [sym_comment] = ACTIONS(78),
  },
  [1344] = {
    [anon_sym_GT] = ACTIONS(3758),
    [sym_comment] = ACTIONS(78),
  },
  [1345] = {
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(3760),
    [sym_comment] = ACTIONS(78),
  },
  [1346] = {
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(3760),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
  },
  [1347] = {
    [anon_sym_GT] = ACTIONS(3760),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
  },
  [1348] = {
    [anon_sym_GT] = ACTIONS(3760),
    [sym_comment] = ACTIONS(78),
  },
  [1349] = {
    [ts_builtin_sym_end] = ACTIONS(3762),
    [anon_sym_export] = ACTIONS(3764),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_RBRACE] = ACTIONS(3762),
    [anon_sym_import] = ACTIONS(3764),
    [anon_sym_var] = ACTIONS(3764),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3764),
    [anon_sym_if] = ACTIONS(3764),
    [anon_sym_else] = ACTIONS(3764),
    [anon_sym_switch] = ACTIONS(3764),
    [anon_sym_for] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_await] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3764),
    [anon_sym_do] = ACTIONS(3764),
    [anon_sym_try] = ACTIONS(3764),
    [anon_sym_with] = ACTIONS(3764),
    [anon_sym_break] = ACTIONS(3764),
    [anon_sym_continue] = ACTIONS(3764),
    [anon_sym_debugger] = ACTIONS(3764),
    [anon_sym_return] = ACTIONS(3764),
    [anon_sym_throw] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_case] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_SLASH] = ACTIONS(3764),
    [anon_sym_class] = ACTIONS(3764),
    [anon_sym_async] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3764),
    [anon_sym_EQ_GT] = ACTIONS(3762),
    [anon_sym_new] = ACTIONS(3764),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3762),
    [anon_sym_typeof] = ACTIONS(3764),
    [anon_sym_void] = ACTIONS(3764),
    [anon_sym_delete] = ACTIONS(3764),
    [anon_sym_PLUS_PLUS] = ACTIONS(3762),
    [anon_sym_DASH_DASH] = ACTIONS(3762),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_SQUOTE] = ACTIONS(3762),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3762),
    [sym_number] = ACTIONS(3762),
    [sym_identifier] = ACTIONS(3764),
    [sym_this] = ACTIONS(3764),
    [sym_super] = ACTIONS(3764),
    [sym_true] = ACTIONS(3764),
    [sym_false] = ACTIONS(3764),
    [sym_null] = ACTIONS(3764),
    [sym_undefined] = ACTIONS(3764),
    [anon_sym_AT] = ACTIONS(3762),
    [anon_sym_get] = ACTIONS(3764),
    [anon_sym_set] = ACTIONS(3764),
  },
  [1350] = {
    [sym__automatic_semicolon] = ACTIONS(3766),
    [ts_builtin_sym_end] = ACTIONS(3766),
    [anon_sym_export] = ACTIONS(3768),
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_default] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_import] = ACTIONS(3768),
    [anon_sym_var] = ACTIONS(3768),
    [anon_sym_let] = ACTIONS(3768),
    [anon_sym_const] = ACTIONS(3768),
    [anon_sym_if] = ACTIONS(3768),
    [anon_sym_else] = ACTIONS(3768),
    [anon_sym_switch] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_RPAREN] = ACTIONS(3766),
    [anon_sym_in] = ACTIONS(3768),
    [anon_sym_await] = ACTIONS(3768),
    [anon_sym_while] = ACTIONS(3768),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_try] = ACTIONS(3768),
    [anon_sym_with] = ACTIONS(3768),
    [anon_sym_break] = ACTIONS(3768),
    [anon_sym_continue] = ACTIONS(3768),
    [anon_sym_debugger] = ACTIONS(3768),
    [anon_sym_return] = ACTIONS(3768),
    [anon_sym_throw] = ACTIONS(3768),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_case] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_GT] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3768),
    [anon_sym_DOT] = ACTIONS(3768),
    [anon_sym_class] = ACTIONS(3768),
    [anon_sym_async] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3768),
    [anon_sym_EQ_GT] = ACTIONS(3766),
    [anon_sym_new] = ACTIONS(3768),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3768),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_PIPE] = ACTIONS(3768),
    [anon_sym_PLUS] = ACTIONS(3768),
    [anon_sym_DASH] = ACTIONS(3768),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3768),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_instanceof] = ACTIONS(3768),
    [anon_sym_BANG] = ACTIONS(3768),
    [anon_sym_TILDE] = ACTIONS(3766),
    [anon_sym_typeof] = ACTIONS(3768),
    [anon_sym_void] = ACTIONS(3768),
    [anon_sym_delete] = ACTIONS(3768),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3766),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3766),
    [sym_number] = ACTIONS(3766),
    [sym_identifier] = ACTIONS(3768),
    [sym_this] = ACTIONS(3768),
    [sym_super] = ACTIONS(3768),
    [sym_true] = ACTIONS(3768),
    [sym_false] = ACTIONS(3768),
    [sym_null] = ACTIONS(3768),
    [sym_undefined] = ACTIONS(3768),
    [anon_sym_AT] = ACTIONS(3766),
    [anon_sym_get] = ACTIONS(3768),
    [anon_sym_set] = ACTIONS(3768),
  },
  [1351] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1352] = {
    [sym_parenthesized_expression] = STATE(1579),
    [sym__expression] = STATE(1579),
    [sym_yield_expression] = STATE(1579),
    [sym_object] = STATE(274),
    [sym_array] = STATE(275),
    [sym_jsx_element] = STATE(1579),
    [sym_jsx_fragment] = STATE(1579),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1579),
    [sym_anonymous_class] = STATE(1579),
    [sym_class] = STATE(1579),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1579),
    [sym_generator_function] = STATE(1579),
    [sym_call_expression] = STATE(1579),
    [sym_new_expression] = STATE(1579),
    [sym_await_expression] = STATE(1579),
    [sym_member_expression] = STATE(276),
    [sym_subscript_expression] = STATE(276),
    [sym_assignment_expression] = STATE(1579),
    [sym_augmented_assignment_expression] = STATE(1579),
    [sym_ternary_expression] = STATE(1579),
    [sym_binary_expression] = STATE(1579),
    [sym_unary_expression] = STATE(1579),
    [sym_update_expression] = STATE(1579),
    [sym_string] = STATE(1579),
    [sym_template_string] = STATE(1579),
    [sym_regex] = STATE(1579),
    [sym_meta_property] = STATE(1579),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(277),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(455),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3770),
    [sym_identifier] = ACTIONS(467),
    [sym_this] = ACTIONS(3772),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3772),
    [sym_false] = ACTIONS(3772),
    [sym_null] = ACTIONS(3772),
    [sym_undefined] = ACTIONS(3772),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(471),
    [anon_sym_set] = ACTIONS(471),
  },
  [1353] = {
    [sym__automatic_semicolon] = ACTIONS(3774),
    [anon_sym_from] = ACTIONS(3774),
    [anon_sym_SEMI] = ACTIONS(3774),
    [sym_comment] = ACTIONS(78),
  },
  [1354] = {
    [sym__import_export_specifier] = STATE(1058),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(477),
  },
  [1355] = {
    [sym__automatic_semicolon] = ACTIONS(2938),
    [ts_builtin_sym_end] = ACTIONS(2938),
    [anon_sym_export] = ACTIONS(2940),
    [anon_sym_default] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_RBRACE] = ACTIONS(2938),
    [anon_sym_import] = ACTIONS(2940),
    [anon_sym_var] = ACTIONS(2940),
    [anon_sym_let] = ACTIONS(2940),
    [anon_sym_const] = ACTIONS(2940),
    [anon_sym_if] = ACTIONS(2940),
    [anon_sym_else] = ACTIONS(2940),
    [anon_sym_switch] = ACTIONS(2940),
    [anon_sym_for] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2938),
    [anon_sym_await] = ACTIONS(2940),
    [anon_sym_while] = ACTIONS(2940),
    [anon_sym_do] = ACTIONS(2940),
    [anon_sym_try] = ACTIONS(2940),
    [anon_sym_with] = ACTIONS(2940),
    [anon_sym_break] = ACTIONS(2940),
    [anon_sym_continue] = ACTIONS(2940),
    [anon_sym_debugger] = ACTIONS(2940),
    [anon_sym_return] = ACTIONS(2940),
    [anon_sym_throw] = ACTIONS(2940),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym_case] = ACTIONS(2940),
    [anon_sym_yield] = ACTIONS(2940),
    [anon_sym_LBRACK] = ACTIONS(2938),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2940),
    [anon_sym_class] = ACTIONS(2940),
    [anon_sym_async] = ACTIONS(2940),
    [anon_sym_function] = ACTIONS(2940),
    [anon_sym_EQ_GT] = ACTIONS(2938),
    [anon_sym_new] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2940),
    [anon_sym_BANG] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2938),
    [anon_sym_typeof] = ACTIONS(2940),
    [anon_sym_void] = ACTIONS(2940),
    [anon_sym_delete] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [anon_sym_SQUOTE] = ACTIONS(2938),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(2938),
    [sym_number] = ACTIONS(2938),
    [sym_identifier] = ACTIONS(2940),
    [sym_this] = ACTIONS(2940),
    [sym_super] = ACTIONS(2940),
    [sym_true] = ACTIONS(2940),
    [sym_false] = ACTIONS(2940),
    [sym_null] = ACTIONS(2940),
    [sym_undefined] = ACTIONS(2940),
    [anon_sym_AT] = ACTIONS(2938),
    [anon_sym_get] = ACTIONS(2940),
    [anon_sym_set] = ACTIONS(2940),
  },
  [1356] = {
    [sym__automatic_semicolon] = ACTIONS(3693),
    [ts_builtin_sym_end] = ACTIONS(3693),
    [anon_sym_export] = ACTIONS(3695),
    [anon_sym_default] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_import] = ACTIONS(3695),
    [anon_sym_var] = ACTIONS(3695),
    [anon_sym_let] = ACTIONS(3695),
    [anon_sym_const] = ACTIONS(3695),
    [anon_sym_if] = ACTIONS(3695),
    [anon_sym_else] = ACTIONS(3695),
    [anon_sym_switch] = ACTIONS(3695),
    [anon_sym_for] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_await] = ACTIONS(3695),
    [anon_sym_while] = ACTIONS(3695),
    [anon_sym_do] = ACTIONS(3695),
    [anon_sym_try] = ACTIONS(3695),
    [anon_sym_with] = ACTIONS(3695),
    [anon_sym_break] = ACTIONS(3695),
    [anon_sym_continue] = ACTIONS(3695),
    [anon_sym_debugger] = ACTIONS(3695),
    [anon_sym_return] = ACTIONS(3695),
    [anon_sym_throw] = ACTIONS(3695),
    [anon_sym_SEMI] = ACTIONS(3693),
    [anon_sym_case] = ACTIONS(3695),
    [anon_sym_yield] = ACTIONS(3695),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_LT] = ACTIONS(3693),
    [anon_sym_SLASH] = ACTIONS(3695),
    [anon_sym_class] = ACTIONS(3695),
    [anon_sym_async] = ACTIONS(3695),
    [anon_sym_function] = ACTIONS(3695),
    [anon_sym_EQ_GT] = ACTIONS(3693),
    [anon_sym_new] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_BANG] = ACTIONS(3693),
    [anon_sym_TILDE] = ACTIONS(3693),
    [anon_sym_typeof] = ACTIONS(3695),
    [anon_sym_void] = ACTIONS(3695),
    [anon_sym_delete] = ACTIONS(3695),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [anon_sym_DQUOTE] = ACTIONS(3693),
    [anon_sym_SQUOTE] = ACTIONS(3693),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3693),
    [sym_number] = ACTIONS(3693),
    [sym_identifier] = ACTIONS(3695),
    [sym_this] = ACTIONS(3695),
    [sym_super] = ACTIONS(3695),
    [sym_true] = ACTIONS(3695),
    [sym_false] = ACTIONS(3695),
    [sym_null] = ACTIONS(3695),
    [sym_undefined] = ACTIONS(3695),
    [anon_sym_AT] = ACTIONS(3693),
    [anon_sym_get] = ACTIONS(3695),
    [anon_sym_set] = ACTIONS(3695),
  },
  [1357] = {
    [sym__automatic_semicolon] = ACTIONS(3697),
    [ts_builtin_sym_end] = ACTIONS(3697),
    [anon_sym_export] = ACTIONS(3699),
    [anon_sym_default] = ACTIONS(3699),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_import] = ACTIONS(3699),
    [anon_sym_var] = ACTIONS(3699),
    [anon_sym_let] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3699),
    [anon_sym_if] = ACTIONS(3699),
    [anon_sym_else] = ACTIONS(3699),
    [anon_sym_switch] = ACTIONS(3699),
    [anon_sym_for] = ACTIONS(3699),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_await] = ACTIONS(3699),
    [anon_sym_while] = ACTIONS(3699),
    [anon_sym_do] = ACTIONS(3699),
    [anon_sym_try] = ACTIONS(3699),
    [anon_sym_with] = ACTIONS(3699),
    [anon_sym_break] = ACTIONS(3699),
    [anon_sym_continue] = ACTIONS(3699),
    [anon_sym_debugger] = ACTIONS(3699),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_throw] = ACTIONS(3699),
    [anon_sym_SEMI] = ACTIONS(3697),
    [anon_sym_case] = ACTIONS(3699),
    [anon_sym_yield] = ACTIONS(3699),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3697),
    [anon_sym_SLASH] = ACTIONS(3699),
    [anon_sym_class] = ACTIONS(3699),
    [anon_sym_async] = ACTIONS(3699),
    [anon_sym_function] = ACTIONS(3699),
    [anon_sym_EQ_GT] = ACTIONS(3697),
    [anon_sym_new] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_BANG] = ACTIONS(3697),
    [anon_sym_TILDE] = ACTIONS(3697),
    [anon_sym_typeof] = ACTIONS(3699),
    [anon_sym_void] = ACTIONS(3699),
    [anon_sym_delete] = ACTIONS(3699),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [anon_sym_DQUOTE] = ACTIONS(3697),
    [anon_sym_SQUOTE] = ACTIONS(3697),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3697),
    [sym_number] = ACTIONS(3697),
    [sym_identifier] = ACTIONS(3699),
    [sym_this] = ACTIONS(3699),
    [sym_super] = ACTIONS(3699),
    [sym_true] = ACTIONS(3699),
    [sym_false] = ACTIONS(3699),
    [sym_null] = ACTIONS(3699),
    [sym_undefined] = ACTIONS(3699),
    [anon_sym_AT] = ACTIONS(3697),
    [anon_sym_get] = ACTIONS(3699),
    [anon_sym_set] = ACTIONS(3699),
  },
  [1358] = {
    [sym__automatic_semicolon] = ACTIONS(1648),
    [ts_builtin_sym_end] = ACTIONS(1648),
    [anon_sym_export] = ACTIONS(1650),
    [anon_sym_default] = ACTIONS(1650),
    [anon_sym_LBRACE] = ACTIONS(1648),
    [anon_sym_RBRACE] = ACTIONS(1648),
    [anon_sym_import] = ACTIONS(1650),
    [anon_sym_var] = ACTIONS(1650),
    [anon_sym_let] = ACTIONS(1650),
    [anon_sym_const] = ACTIONS(1650),
    [anon_sym_if] = ACTIONS(1650),
    [anon_sym_else] = ACTIONS(1650),
    [anon_sym_switch] = ACTIONS(1650),
    [anon_sym_for] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1648),
    [anon_sym_await] = ACTIONS(1650),
    [anon_sym_while] = ACTIONS(1650),
    [anon_sym_do] = ACTIONS(1650),
    [anon_sym_try] = ACTIONS(1650),
    [anon_sym_with] = ACTIONS(1650),
    [anon_sym_break] = ACTIONS(1650),
    [anon_sym_continue] = ACTIONS(1650),
    [anon_sym_debugger] = ACTIONS(1650),
    [anon_sym_return] = ACTIONS(1650),
    [anon_sym_throw] = ACTIONS(1650),
    [anon_sym_SEMI] = ACTIONS(1648),
    [anon_sym_case] = ACTIONS(1650),
    [anon_sym_yield] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(1648),
    [anon_sym_LT] = ACTIONS(1648),
    [anon_sym_SLASH] = ACTIONS(1650),
    [anon_sym_class] = ACTIONS(1650),
    [anon_sym_async] = ACTIONS(1650),
    [anon_sym_function] = ACTIONS(1650),
    [anon_sym_EQ_GT] = ACTIONS(1648),
    [anon_sym_new] = ACTIONS(1650),
    [anon_sym_PLUS] = ACTIONS(1650),
    [anon_sym_DASH] = ACTIONS(1650),
    [anon_sym_BANG] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_typeof] = ACTIONS(1650),
    [anon_sym_void] = ACTIONS(1650),
    [anon_sym_delete] = ACTIONS(1650),
    [anon_sym_PLUS_PLUS] = ACTIONS(1648),
    [anon_sym_DASH_DASH] = ACTIONS(1648),
    [anon_sym_DQUOTE] = ACTIONS(1648),
    [anon_sym_SQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_number] = ACTIONS(1648),
    [sym_identifier] = ACTIONS(1650),
    [sym_this] = ACTIONS(1650),
    [sym_super] = ACTIONS(1650),
    [sym_true] = ACTIONS(1650),
    [sym_false] = ACTIONS(1650),
    [sym_null] = ACTIONS(1650),
    [sym_undefined] = ACTIONS(1650),
    [anon_sym_AT] = ACTIONS(1648),
    [anon_sym_get] = ACTIONS(1650),
    [anon_sym_set] = ACTIONS(1650),
  },
  [1359] = {
    [sym__automatic_semicolon] = ACTIONS(3766),
    [ts_builtin_sym_end] = ACTIONS(3766),
    [anon_sym_export] = ACTIONS(3768),
    [anon_sym_default] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_import] = ACTIONS(3768),
    [anon_sym_var] = ACTIONS(3768),
    [anon_sym_let] = ACTIONS(3768),
    [anon_sym_const] = ACTIONS(3768),
    [anon_sym_if] = ACTIONS(3768),
    [anon_sym_else] = ACTIONS(3768),
    [anon_sym_switch] = ACTIONS(3768),
    [anon_sym_for] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_await] = ACTIONS(3768),
    [anon_sym_while] = ACTIONS(3768),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_try] = ACTIONS(3768),
    [anon_sym_with] = ACTIONS(3768),
    [anon_sym_break] = ACTIONS(3768),
    [anon_sym_continue] = ACTIONS(3768),
    [anon_sym_debugger] = ACTIONS(3768),
    [anon_sym_return] = ACTIONS(3768),
    [anon_sym_throw] = ACTIONS(3768),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_case] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3768),
    [anon_sym_class] = ACTIONS(3768),
    [anon_sym_async] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3768),
    [anon_sym_EQ_GT] = ACTIONS(3766),
    [anon_sym_new] = ACTIONS(3768),
    [anon_sym_PLUS] = ACTIONS(3768),
    [anon_sym_DASH] = ACTIONS(3768),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [anon_sym_typeof] = ACTIONS(3768),
    [anon_sym_void] = ACTIONS(3768),
    [anon_sym_delete] = ACTIONS(3768),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3766),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3766),
    [sym_number] = ACTIONS(3766),
    [sym_identifier] = ACTIONS(3768),
    [sym_this] = ACTIONS(3768),
    [sym_super] = ACTIONS(3768),
    [sym_true] = ACTIONS(3768),
    [sym_false] = ACTIONS(3768),
    [sym_null] = ACTIONS(3768),
    [sym_undefined] = ACTIONS(3768),
    [anon_sym_AT] = ACTIONS(3766),
    [anon_sym_get] = ACTIONS(3768),
    [anon_sym_set] = ACTIONS(3768),
  },
  [1360] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2129),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1361] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2131),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1362] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2135),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1363] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1580),
    [sym__expression] = STATE(1580),
    [sym_yield_expression] = STATE(1580),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1580),
    [sym_jsx_fragment] = STATE(1580),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1580),
    [sym_anonymous_class] = STATE(1580),
    [sym_class] = STATE(1580),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1580),
    [sym_generator_function] = STATE(1580),
    [sym_call_expression] = STATE(1580),
    [sym_new_expression] = STATE(1580),
    [sym_await_expression] = STATE(1580),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1580),
    [sym_augmented_assignment_expression] = STATE(1580),
    [sym_ternary_expression] = STATE(1580),
    [sym_binary_expression] = STATE(1580),
    [sym_unary_expression] = STATE(1580),
    [sym_update_expression] = STATE(1580),
    [sym_string] = STATE(1580),
    [sym_template_string] = STATE(1580),
    [sym_regex] = STATE(1580),
    [sym_meta_property] = STATE(1580),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3776),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(3778),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3778),
    [sym_false] = ACTIONS(3778),
    [sym_null] = ACTIONS(3778),
    [sym_undefined] = ACTIONS(3778),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1364] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1365] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2235),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1366] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(3780),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1367] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1368] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1369] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1370] = {
    [anon_sym_COMMA] = ACTIONS(2515),
    [anon_sym_RPAREN] = ACTIONS(2515),
    [anon_sym_EQ] = ACTIONS(2515),
    [sym_comment] = ACTIONS(78),
  },
  [1371] = {
    [anon_sym_COMMA] = ACTIONS(2597),
    [anon_sym_RPAREN] = ACTIONS(2597),
    [anon_sym_EQ] = ACTIONS(2597),
    [sym_comment] = ACTIONS(78),
  },
  [1372] = {
    [aux_sym_object_repeat1] = STATE(344),
    [anon_sym_COMMA] = ACTIONS(114),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [sym_comment] = ACTIONS(78),
  },
  [1373] = {
    [anon_sym_COMMA] = ACTIONS(2875),
    [anon_sym_RPAREN] = ACTIONS(2875),
    [anon_sym_EQ] = ACTIONS(2875),
    [sym_comment] = ACTIONS(78),
  },
  [1374] = {
    [anon_sym_export] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_import] = ACTIONS(1724),
    [anon_sym_var] = ACTIONS(1724),
    [anon_sym_let] = ACTIONS(1724),
    [anon_sym_const] = ACTIONS(1724),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_else] = ACTIONS(3784),
    [anon_sym_switch] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1724),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_await] = ACTIONS(1724),
    [anon_sym_while] = ACTIONS(1724),
    [anon_sym_do] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(1724),
    [anon_sym_with] = ACTIONS(1724),
    [anon_sym_break] = ACTIONS(1724),
    [anon_sym_continue] = ACTIONS(1724),
    [anon_sym_debugger] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1724),
    [anon_sym_throw] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_yield] = ACTIONS(1724),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1724),
    [anon_sym_class] = ACTIONS(1724),
    [anon_sym_async] = ACTIONS(1724),
    [anon_sym_function] = ACTIONS(1724),
    [anon_sym_EQ_GT] = ACTIONS(1722),
    [anon_sym_new] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_typeof] = ACTIONS(1724),
    [anon_sym_void] = ACTIONS(1724),
    [anon_sym_delete] = ACTIONS(1724),
    [anon_sym_PLUS_PLUS] = ACTIONS(1722),
    [anon_sym_DASH_DASH] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [sym_number] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1724),
    [sym_this] = ACTIONS(1724),
    [sym_super] = ACTIONS(1724),
    [sym_true] = ACTIONS(1724),
    [sym_false] = ACTIONS(1724),
    [sym_null] = ACTIONS(1724),
    [sym_undefined] = ACTIONS(1724),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_get] = ACTIONS(1724),
    [anon_sym_set] = ACTIONS(1724),
  },
  [1375] = {
    [sym_variable_declarator] = STATE(93),
    [sym_object] = STATE(1585),
    [sym_array] = STATE(1586),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3786),
  },
  [1376] = {
    [sym_variable_declarator] = STATE(96),
    [sym_object] = STATE(1585),
    [sym_array] = STATE(1586),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3786),
  },
  [1377] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3788),
    [anon_sym_of] = ACTIONS(3790),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1378] = {
    [sym_expression_statement] = STATE(1589),
    [sym_empty_statement] = STATE(1589),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1379] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3792),
    [anon_sym_of] = ACTIONS(3794),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1380] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(3796),
    [anon_sym_of] = ACTIONS(3798),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1381] = {
    [sym_object] = STATE(1596),
    [sym_array] = STATE(1597),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_var] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3802),
  },
  [1382] = {
    [sym_parenthesized_expression] = STATE(1598),
    [sym__expression] = STATE(1598),
    [sym_yield_expression] = STATE(1598),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1598),
    [sym_jsx_fragment] = STATE(1598),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1598),
    [sym_anonymous_class] = STATE(1598),
    [sym_class] = STATE(1598),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1598),
    [sym_generator_function] = STATE(1598),
    [sym_call_expression] = STATE(1598),
    [sym_new_expression] = STATE(1598),
    [sym_await_expression] = STATE(1598),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1598),
    [sym_augmented_assignment_expression] = STATE(1598),
    [sym_ternary_expression] = STATE(1598),
    [sym_binary_expression] = STATE(1598),
    [sym_unary_expression] = STATE(1598),
    [sym_update_expression] = STATE(1598),
    [sym_sequence_expression] = STATE(1599),
    [sym_string] = STATE(1598),
    [sym_template_string] = STATE(1598),
    [sym_regex] = STATE(1598),
    [sym_meta_property] = STATE(1598),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3804),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3806),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3806),
    [sym_false] = ACTIONS(3806),
    [sym_null] = ACTIONS(3806),
    [sym_undefined] = ACTIONS(3806),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1383] = {
    [sym_parenthesized_expression] = STATE(1600),
    [sym__expression] = STATE(1600),
    [sym_yield_expression] = STATE(1600),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1600),
    [sym_jsx_fragment] = STATE(1600),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1600),
    [sym_anonymous_class] = STATE(1600),
    [sym_class] = STATE(1600),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1600),
    [sym_generator_function] = STATE(1600),
    [sym_call_expression] = STATE(1600),
    [sym_new_expression] = STATE(1600),
    [sym_await_expression] = STATE(1600),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1600),
    [sym_augmented_assignment_expression] = STATE(1600),
    [sym_ternary_expression] = STATE(1600),
    [sym_binary_expression] = STATE(1600),
    [sym_unary_expression] = STATE(1600),
    [sym_update_expression] = STATE(1600),
    [sym_string] = STATE(1600),
    [sym_template_string] = STATE(1600),
    [sym_regex] = STATE(1600),
    [sym_meta_property] = STATE(1600),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3808),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3810),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3810),
    [sym_false] = ACTIONS(3810),
    [sym_null] = ACTIONS(3810),
    [sym_undefined] = ACTIONS(3810),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1384] = {
    [sym_parenthesized_expression] = STATE(1601),
    [sym__expression] = STATE(1601),
    [sym_yield_expression] = STATE(1601),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1601),
    [sym_jsx_fragment] = STATE(1601),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1601),
    [sym_anonymous_class] = STATE(1601),
    [sym_class] = STATE(1601),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1601),
    [sym_generator_function] = STATE(1601),
    [sym_call_expression] = STATE(1601),
    [sym_new_expression] = STATE(1601),
    [sym_await_expression] = STATE(1601),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1601),
    [sym_augmented_assignment_expression] = STATE(1601),
    [sym_ternary_expression] = STATE(1601),
    [sym_binary_expression] = STATE(1601),
    [sym_unary_expression] = STATE(1601),
    [sym_update_expression] = STATE(1601),
    [sym_sequence_expression] = STATE(1602),
    [sym_string] = STATE(1601),
    [sym_template_string] = STATE(1601),
    [sym_regex] = STATE(1601),
    [sym_meta_property] = STATE(1601),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3812),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3814),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3814),
    [sym_false] = ACTIONS(3814),
    [sym_null] = ACTIONS(3814),
    [sym_undefined] = ACTIONS(3814),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1385] = {
    [sym_parenthesized_expression] = STATE(1603),
    [sym__expression] = STATE(1603),
    [sym_yield_expression] = STATE(1603),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1603),
    [sym_jsx_fragment] = STATE(1603),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1603),
    [sym_anonymous_class] = STATE(1603),
    [sym_class] = STATE(1603),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1603),
    [sym_generator_function] = STATE(1603),
    [sym_call_expression] = STATE(1603),
    [sym_new_expression] = STATE(1603),
    [sym_await_expression] = STATE(1603),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1603),
    [sym_augmented_assignment_expression] = STATE(1603),
    [sym_ternary_expression] = STATE(1603),
    [sym_binary_expression] = STATE(1603),
    [sym_unary_expression] = STATE(1603),
    [sym_update_expression] = STATE(1603),
    [sym_string] = STATE(1603),
    [sym_template_string] = STATE(1603),
    [sym_regex] = STATE(1603),
    [sym_meta_property] = STATE(1603),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3816),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3818),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3818),
    [sym_false] = ACTIONS(3818),
    [sym_null] = ACTIONS(3818),
    [sym_undefined] = ACTIONS(3818),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1386] = {
    [sym_parenthesized_expression] = STATE(1604),
    [sym__expression] = STATE(1604),
    [sym_yield_expression] = STATE(1604),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1604),
    [sym_jsx_fragment] = STATE(1604),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1604),
    [sym_anonymous_class] = STATE(1604),
    [sym_class] = STATE(1604),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1604),
    [sym_generator_function] = STATE(1604),
    [sym_call_expression] = STATE(1604),
    [sym_new_expression] = STATE(1604),
    [sym_await_expression] = STATE(1604),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1604),
    [sym_augmented_assignment_expression] = STATE(1604),
    [sym_ternary_expression] = STATE(1604),
    [sym_binary_expression] = STATE(1604),
    [sym_unary_expression] = STATE(1604),
    [sym_update_expression] = STATE(1604),
    [sym_sequence_expression] = STATE(1605),
    [sym_string] = STATE(1604),
    [sym_template_string] = STATE(1604),
    [sym_regex] = STATE(1604),
    [sym_meta_property] = STATE(1604),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3820),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3822),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3822),
    [sym_false] = ACTIONS(3822),
    [sym_null] = ACTIONS(3822),
    [sym_undefined] = ACTIONS(3822),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1387] = {
    [sym_parenthesized_expression] = STATE(1606),
    [sym__expression] = STATE(1606),
    [sym_yield_expression] = STATE(1606),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1606),
    [sym_jsx_fragment] = STATE(1606),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1606),
    [sym_anonymous_class] = STATE(1606),
    [sym_class] = STATE(1606),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1606),
    [sym_generator_function] = STATE(1606),
    [sym_call_expression] = STATE(1606),
    [sym_new_expression] = STATE(1606),
    [sym_await_expression] = STATE(1606),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1606),
    [sym_augmented_assignment_expression] = STATE(1606),
    [sym_ternary_expression] = STATE(1606),
    [sym_binary_expression] = STATE(1606),
    [sym_unary_expression] = STATE(1606),
    [sym_update_expression] = STATE(1606),
    [sym_string] = STATE(1606),
    [sym_template_string] = STATE(1606),
    [sym_regex] = STATE(1606),
    [sym_meta_property] = STATE(1606),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3824),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3826),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3826),
    [sym_false] = ACTIONS(3826),
    [sym_null] = ACTIONS(3826),
    [sym_undefined] = ACTIONS(3826),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1388] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(3828),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1389] = {
    [anon_sym_RPAREN] = ACTIONS(3828),
    [sym_comment] = ACTIONS(78),
  },
  [1390] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3830),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1391] = {
    [sym_export_statement] = STATE(1500),
    [sym__declaration] = STATE(1500),
    [sym_import_statement] = STATE(1500),
    [sym_expression_statement] = STATE(1500),
    [sym_variable_declaration] = STATE(1500),
    [sym_lexical_declaration] = STATE(1500),
    [sym_statement_block] = STATE(1500),
    [sym_if_statement] = STATE(1500),
    [sym_switch_statement] = STATE(1500),
    [sym_for_statement] = STATE(1500),
    [sym_for_in_statement] = STATE(1500),
    [sym_for_of_statement] = STATE(1500),
    [sym_while_statement] = STATE(1500),
    [sym_do_statement] = STATE(1500),
    [sym_try_statement] = STATE(1500),
    [sym_with_statement] = STATE(1500),
    [sym_break_statement] = STATE(1500),
    [sym_continue_statement] = STATE(1500),
    [sym_debugger_statement] = STATE(1500),
    [sym_return_statement] = STATE(1500),
    [sym_throw_statement] = STATE(1500),
    [sym_empty_statement] = STATE(1500),
    [sym_labeled_statement] = STATE(1500),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1392] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3832),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1393] = {
    [anon_sym_RPAREN] = ACTIONS(3832),
    [sym_comment] = ACTIONS(78),
  },
  [1394] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(3834),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1395] = {
    [anon_sym_RPAREN] = ACTIONS(3834),
    [sym_comment] = ACTIONS(78),
  },
  [1396] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3836),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1397] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(3838),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1398] = {
    [anon_sym_RPAREN] = ACTIONS(3838),
    [sym_comment] = ACTIONS(78),
  },
  [1399] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3840),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1400] = {
    [anon_sym_of] = ACTIONS(3842),
    [sym_comment] = ACTIONS(78),
  },
  [1401] = {
    [anon_sym_of] = ACTIONS(3844),
    [sym_comment] = ACTIONS(78),
  },
  [1402] = {
    [anon_sym_of] = ACTIONS(3846),
    [sym_comment] = ACTIONS(78),
  },
  [1403] = {
    [anon_sym_STAR] = ACTIONS(3848),
    [anon_sym_COMMA] = ACTIONS(3848),
    [anon_sym_RBRACE] = ACTIONS(3848),
    [anon_sym_SEMI] = ACTIONS(3848),
    [anon_sym_LBRACK] = ACTIONS(3848),
    [anon_sym_async] = ACTIONS(3850),
    [anon_sym_DQUOTE] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(3848),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(3848),
    [sym_identifier] = ACTIONS(3850),
    [anon_sym_AT] = ACTIONS(3848),
    [anon_sym_static] = ACTIONS(3850),
    [anon_sym_get] = ACTIONS(3850),
    [anon_sym_set] = ACTIONS(3850),
  },
  [1404] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1405] = {
    [sym_parenthesized_expression] = STATE(1617),
    [sym__expression] = STATE(1617),
    [sym_yield_expression] = STATE(1617),
    [sym_object] = STATE(323),
    [sym_array] = STATE(324),
    [sym_jsx_element] = STATE(1617),
    [sym_jsx_fragment] = STATE(1617),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1617),
    [sym_anonymous_class] = STATE(1617),
    [sym_class] = STATE(1617),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1617),
    [sym_generator_function] = STATE(1617),
    [sym_call_expression] = STATE(1617),
    [sym_new_expression] = STATE(1617),
    [sym_await_expression] = STATE(1617),
    [sym_member_expression] = STATE(325),
    [sym_subscript_expression] = STATE(325),
    [sym_assignment_expression] = STATE(1617),
    [sym_augmented_assignment_expression] = STATE(1617),
    [sym_ternary_expression] = STATE(1617),
    [sym_binary_expression] = STATE(1617),
    [sym_unary_expression] = STATE(1617),
    [sym_update_expression] = STATE(1617),
    [sym_string] = STATE(1617),
    [sym_template_string] = STATE(1617),
    [sym_regex] = STATE(1617),
    [sym_meta_property] = STATE(1617),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(326),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(555),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_TILDE] = ACTIONS(563),
    [anon_sym_typeof] = ACTIONS(561),
    [anon_sym_void] = ACTIONS(561),
    [anon_sym_delete] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3852),
    [sym_identifier] = ACTIONS(569),
    [sym_this] = ACTIONS(3854),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3854),
    [sym_false] = ACTIONS(3854),
    [sym_null] = ACTIONS(3854),
    [sym_undefined] = ACTIONS(3854),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(573),
    [anon_sym_set] = ACTIONS(573),
  },
  [1406] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1407] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2135),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(2135),
    [anon_sym_RBRACE] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1408] = {
    [sym_statement_block] = STATE(975),
    [sym_parenthesized_expression] = STATE(1618),
    [sym__expression] = STATE(1618),
    [sym_yield_expression] = STATE(1618),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1618),
    [sym_jsx_fragment] = STATE(1618),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1618),
    [sym_anonymous_class] = STATE(1618),
    [sym_class] = STATE(1618),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1618),
    [sym_generator_function] = STATE(1618),
    [sym_call_expression] = STATE(1618),
    [sym_new_expression] = STATE(1618),
    [sym_await_expression] = STATE(1618),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1618),
    [sym_augmented_assignment_expression] = STATE(1618),
    [sym_ternary_expression] = STATE(1618),
    [sym_binary_expression] = STATE(1618),
    [sym_unary_expression] = STATE(1618),
    [sym_update_expression] = STATE(1618),
    [sym_string] = STATE(1618),
    [sym_template_string] = STATE(1618),
    [sym_regex] = STATE(1618),
    [sym_meta_property] = STATE(1618),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3856),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(3858),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3858),
    [sym_false] = ACTIONS(3858),
    [sym_null] = ACTIONS(3858),
    [sym_undefined] = ACTIONS(3858),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1409] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1410] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1411] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(3860),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1412] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1413] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1414] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1415] = {
    [anon_sym_from] = ACTIONS(3862),
    [sym_comment] = ACTIONS(78),
  },
  [1416] = {
    [sym__import_export_specifier] = STATE(1146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(477),
  },
  [1417] = {
    [sym__automatic_semicolon] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3328),
    [anon_sym_of] = ACTIONS(3328),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(3328),
    [sym_comment] = ACTIONS(78),
  },
  [1418] = {
    [sym_export_statement] = STATE(1161),
    [sym__declaration] = STATE(1161),
    [sym_import_statement] = STATE(1161),
    [sym_expression_statement] = STATE(1161),
    [sym_variable_declaration] = STATE(1161),
    [sym_lexical_declaration] = STATE(1161),
    [sym_statement_block] = STATE(1161),
    [sym_if_statement] = STATE(1161),
    [sym_switch_statement] = STATE(1161),
    [sym_for_statement] = STATE(1161),
    [sym_for_in_statement] = STATE(1161),
    [sym_for_of_statement] = STATE(1161),
    [sym_while_statement] = STATE(1161),
    [sym_do_statement] = STATE(1161),
    [sym_try_statement] = STATE(1161),
    [sym_with_statement] = STATE(1161),
    [sym_break_statement] = STATE(1161),
    [sym_continue_statement] = STATE(1161),
    [sym_debugger_statement] = STATE(1161),
    [sym_return_statement] = STATE(1161),
    [sym_throw_statement] = STATE(1161),
    [sym_empty_statement] = STATE(1161),
    [sym_labeled_statement] = STATE(1161),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1419] = {
    [sym__initializer] = STATE(363),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(3864),
    [anon_sym_of] = ACTIONS(3866),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1420] = {
    [sym__initializer] = STATE(367),
    [sym__automatic_semicolon] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(3868),
    [anon_sym_of] = ACTIONS(3870),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1421] = {
    [sym__initializer] = STATE(368),
    [sym__automatic_semicolon] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(3872),
    [anon_sym_of] = ACTIONS(3874),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1422] = {
    [sym_parenthesized_expression] = STATE(1626),
    [sym__expression] = STATE(1626),
    [sym_yield_expression] = STATE(1626),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1626),
    [sym_jsx_fragment] = STATE(1626),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1626),
    [sym_anonymous_class] = STATE(1626),
    [sym_class] = STATE(1626),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1626),
    [sym_generator_function] = STATE(1626),
    [sym_call_expression] = STATE(1626),
    [sym_new_expression] = STATE(1626),
    [sym_await_expression] = STATE(1626),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1626),
    [sym_augmented_assignment_expression] = STATE(1626),
    [sym_ternary_expression] = STATE(1626),
    [sym_binary_expression] = STATE(1626),
    [sym_unary_expression] = STATE(1626),
    [sym_update_expression] = STATE(1626),
    [sym_sequence_expression] = STATE(1627),
    [sym_string] = STATE(1626),
    [sym_template_string] = STATE(1626),
    [sym_regex] = STATE(1626),
    [sym_meta_property] = STATE(1626),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3876),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3878),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3878),
    [sym_false] = ACTIONS(3878),
    [sym_null] = ACTIONS(3878),
    [sym_undefined] = ACTIONS(3878),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1423] = {
    [sym_parenthesized_expression] = STATE(1628),
    [sym__expression] = STATE(1628),
    [sym_yield_expression] = STATE(1628),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1628),
    [sym_jsx_fragment] = STATE(1628),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1628),
    [sym_anonymous_class] = STATE(1628),
    [sym_class] = STATE(1628),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1628),
    [sym_generator_function] = STATE(1628),
    [sym_call_expression] = STATE(1628),
    [sym_new_expression] = STATE(1628),
    [sym_await_expression] = STATE(1628),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1628),
    [sym_augmented_assignment_expression] = STATE(1628),
    [sym_ternary_expression] = STATE(1628),
    [sym_binary_expression] = STATE(1628),
    [sym_unary_expression] = STATE(1628),
    [sym_update_expression] = STATE(1628),
    [sym_string] = STATE(1628),
    [sym_template_string] = STATE(1628),
    [sym_regex] = STATE(1628),
    [sym_meta_property] = STATE(1628),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3880),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3882),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3882),
    [sym_false] = ACTIONS(3882),
    [sym_null] = ACTIONS(3882),
    [sym_undefined] = ACTIONS(3882),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1424] = {
    [sym_parenthesized_expression] = STATE(1630),
    [sym__expression] = STATE(1630),
    [sym_yield_expression] = STATE(1630),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1630),
    [sym_jsx_fragment] = STATE(1630),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1630),
    [sym_anonymous_class] = STATE(1630),
    [sym_class] = STATE(1630),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1630),
    [sym_generator_function] = STATE(1630),
    [sym_call_expression] = STATE(1630),
    [sym_new_expression] = STATE(1630),
    [sym_await_expression] = STATE(1630),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1630),
    [sym_augmented_assignment_expression] = STATE(1630),
    [sym_ternary_expression] = STATE(1630),
    [sym_binary_expression] = STATE(1630),
    [sym_unary_expression] = STATE(1630),
    [sym_update_expression] = STATE(1630),
    [sym_sequence_expression] = STATE(1631),
    [sym_string] = STATE(1630),
    [sym_template_string] = STATE(1630),
    [sym_regex] = STATE(1630),
    [sym_meta_property] = STATE(1630),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(3884),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3886),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(3888),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3888),
    [sym_false] = ACTIONS(3888),
    [sym_null] = ACTIONS(3888),
    [sym_undefined] = ACTIONS(3888),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1425] = {
    [sym_parenthesized_expression] = STATE(1632),
    [sym__expression] = STATE(1632),
    [sym_yield_expression] = STATE(1632),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1632),
    [sym_jsx_fragment] = STATE(1632),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1632),
    [sym_anonymous_class] = STATE(1632),
    [sym_class] = STATE(1632),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1632),
    [sym_generator_function] = STATE(1632),
    [sym_call_expression] = STATE(1632),
    [sym_new_expression] = STATE(1632),
    [sym_await_expression] = STATE(1632),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1632),
    [sym_augmented_assignment_expression] = STATE(1632),
    [sym_ternary_expression] = STATE(1632),
    [sym_binary_expression] = STATE(1632),
    [sym_unary_expression] = STATE(1632),
    [sym_update_expression] = STATE(1632),
    [sym_sequence_expression] = STATE(1633),
    [sym_string] = STATE(1632),
    [sym_template_string] = STATE(1632),
    [sym_regex] = STATE(1632),
    [sym_meta_property] = STATE(1632),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3890),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3892),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3892),
    [sym_false] = ACTIONS(3892),
    [sym_null] = ACTIONS(3892),
    [sym_undefined] = ACTIONS(3892),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1426] = {
    [sym_parenthesized_expression] = STATE(1634),
    [sym__expression] = STATE(1634),
    [sym_yield_expression] = STATE(1634),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1634),
    [sym_jsx_fragment] = STATE(1634),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1634),
    [sym_anonymous_class] = STATE(1634),
    [sym_class] = STATE(1634),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1634),
    [sym_generator_function] = STATE(1634),
    [sym_call_expression] = STATE(1634),
    [sym_new_expression] = STATE(1634),
    [sym_await_expression] = STATE(1634),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1634),
    [sym_augmented_assignment_expression] = STATE(1634),
    [sym_ternary_expression] = STATE(1634),
    [sym_binary_expression] = STATE(1634),
    [sym_unary_expression] = STATE(1634),
    [sym_update_expression] = STATE(1634),
    [sym_string] = STATE(1634),
    [sym_template_string] = STATE(1634),
    [sym_regex] = STATE(1634),
    [sym_meta_property] = STATE(1634),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3894),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3896),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3896),
    [sym_false] = ACTIONS(3896),
    [sym_null] = ACTIONS(3896),
    [sym_undefined] = ACTIONS(3896),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1427] = {
    [sym_parenthesized_expression] = STATE(1635),
    [sym__expression] = STATE(1635),
    [sym_yield_expression] = STATE(1635),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1635),
    [sym_jsx_fragment] = STATE(1635),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1635),
    [sym_anonymous_class] = STATE(1635),
    [sym_class] = STATE(1635),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1635),
    [sym_generator_function] = STATE(1635),
    [sym_call_expression] = STATE(1635),
    [sym_new_expression] = STATE(1635),
    [sym_await_expression] = STATE(1635),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1635),
    [sym_augmented_assignment_expression] = STATE(1635),
    [sym_ternary_expression] = STATE(1635),
    [sym_binary_expression] = STATE(1635),
    [sym_unary_expression] = STATE(1635),
    [sym_update_expression] = STATE(1635),
    [sym_sequence_expression] = STATE(1636),
    [sym_string] = STATE(1635),
    [sym_template_string] = STATE(1635),
    [sym_regex] = STATE(1635),
    [sym_meta_property] = STATE(1635),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3898),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3900),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3900),
    [sym_false] = ACTIONS(3900),
    [sym_null] = ACTIONS(3900),
    [sym_undefined] = ACTIONS(3900),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1428] = {
    [sym_parenthesized_expression] = STATE(1637),
    [sym__expression] = STATE(1637),
    [sym_yield_expression] = STATE(1637),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1637),
    [sym_jsx_fragment] = STATE(1637),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1637),
    [sym_anonymous_class] = STATE(1637),
    [sym_class] = STATE(1637),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1637),
    [sym_generator_function] = STATE(1637),
    [sym_call_expression] = STATE(1637),
    [sym_new_expression] = STATE(1637),
    [sym_await_expression] = STATE(1637),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1637),
    [sym_augmented_assignment_expression] = STATE(1637),
    [sym_ternary_expression] = STATE(1637),
    [sym_binary_expression] = STATE(1637),
    [sym_unary_expression] = STATE(1637),
    [sym_update_expression] = STATE(1637),
    [sym_string] = STATE(1637),
    [sym_template_string] = STATE(1637),
    [sym_regex] = STATE(1637),
    [sym_meta_property] = STATE(1637),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3902),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(3904),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3904),
    [sym_false] = ACTIONS(3904),
    [sym_null] = ACTIONS(3904),
    [sym_undefined] = ACTIONS(3904),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1429] = {
    [sym_object] = STATE(1639),
    [sym_array] = STATE(1640),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3906),
  },
  [1430] = {
    [anon_sym_of] = ACTIONS(3866),
    [sym_comment] = ACTIONS(78),
  },
  [1431] = {
    [anon_sym_of] = ACTIONS(3870),
    [sym_comment] = ACTIONS(78),
  },
  [1432] = {
    [anon_sym_of] = ACTIONS(3874),
    [sym_comment] = ACTIONS(78),
  },
  [1433] = {
    [sym_parenthesized_expression] = STATE(1641),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [1434] = {
    [anon_sym_LPAREN] = ACTIONS(3908),
    [anon_sym_await] = ACTIONS(3910),
    [sym_comment] = ACTIONS(78),
  },
  [1435] = {
    [sym_parenthesized_expression] = STATE(1644),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [1436] = {
    [sym_parenthesized_expression] = STATE(1645),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [1437] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(3912),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1438] = {
    [sym_export_statement] = STATE(1647),
    [sym__declaration] = STATE(1647),
    [sym_import_statement] = STATE(1647),
    [sym_expression_statement] = STATE(1647),
    [sym_variable_declaration] = STATE(1647),
    [sym_lexical_declaration] = STATE(1647),
    [sym_statement_block] = STATE(1647),
    [sym_if_statement] = STATE(1647),
    [sym_switch_statement] = STATE(1647),
    [sym_for_statement] = STATE(1647),
    [sym_for_in_statement] = STATE(1647),
    [sym_for_of_statement] = STATE(1647),
    [sym_while_statement] = STATE(1647),
    [sym_do_statement] = STATE(1647),
    [sym_try_statement] = STATE(1647),
    [sym_with_statement] = STATE(1647),
    [sym_break_statement] = STATE(1647),
    [sym_continue_statement] = STATE(1647),
    [sym_debugger_statement] = STATE(1647),
    [sym_return_statement] = STATE(1647),
    [sym_throw_statement] = STATE(1647),
    [sym_empty_statement] = STATE(1647),
    [sym_labeled_statement] = STATE(1647),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(1647),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_default] = ACTIONS(3914),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(3916),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_case] = ACTIONS(3914),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1439] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1440] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1441] = {
    [sym_parenthesized_expression] = STATE(1648),
    [sym__expression] = STATE(1648),
    [sym_yield_expression] = STATE(1648),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1648),
    [sym_jsx_fragment] = STATE(1648),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1648),
    [sym_anonymous_class] = STATE(1648),
    [sym_class] = STATE(1648),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1648),
    [sym_generator_function] = STATE(1648),
    [sym_call_expression] = STATE(1648),
    [sym_new_expression] = STATE(1648),
    [sym_await_expression] = STATE(1648),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1648),
    [sym_augmented_assignment_expression] = STATE(1648),
    [sym_ternary_expression] = STATE(1648),
    [sym_binary_expression] = STATE(1648),
    [sym_unary_expression] = STATE(1648),
    [sym_update_expression] = STATE(1648),
    [sym_string] = STATE(1648),
    [sym_template_string] = STATE(1648),
    [sym_regex] = STATE(1648),
    [sym_meta_property] = STATE(1648),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3918),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3920),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3920),
    [sym_false] = ACTIONS(3920),
    [sym_null] = ACTIONS(3920),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1442] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(1649),
    [sym__expression] = STATE(1649),
    [sym_yield_expression] = STATE(1649),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1649),
    [sym_jsx_fragment] = STATE(1649),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1649),
    [sym_anonymous_class] = STATE(1649),
    [sym_class] = STATE(1649),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1649),
    [sym_generator_function] = STATE(1649),
    [sym_call_expression] = STATE(1649),
    [sym_new_expression] = STATE(1649),
    [sym_await_expression] = STATE(1649),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1649),
    [sym_augmented_assignment_expression] = STATE(1649),
    [sym_ternary_expression] = STATE(1649),
    [sym_binary_expression] = STATE(1649),
    [sym_unary_expression] = STATE(1649),
    [sym_update_expression] = STATE(1649),
    [sym_string] = STATE(1649),
    [sym_template_string] = STATE(1649),
    [sym_regex] = STATE(1649),
    [sym_meta_property] = STATE(1649),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3922),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3924),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3924),
    [sym_false] = ACTIONS(3924),
    [sym_null] = ACTIONS(3924),
    [sym_undefined] = ACTIONS(3924),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1443] = {
    [sym_parenthesized_expression] = STATE(1650),
    [sym__expression] = STATE(1650),
    [sym_yield_expression] = STATE(1650),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1650),
    [sym_jsx_fragment] = STATE(1650),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1650),
    [sym_anonymous_class] = STATE(1650),
    [sym_class] = STATE(1650),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1650),
    [sym_generator_function] = STATE(1650),
    [sym_call_expression] = STATE(1650),
    [sym_new_expression] = STATE(1650),
    [sym_await_expression] = STATE(1650),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1650),
    [sym_augmented_assignment_expression] = STATE(1650),
    [sym_ternary_expression] = STATE(1650),
    [sym_binary_expression] = STATE(1650),
    [sym_unary_expression] = STATE(1650),
    [sym_update_expression] = STATE(1650),
    [sym_string] = STATE(1650),
    [sym_template_string] = STATE(1650),
    [sym_regex] = STATE(1650),
    [sym_meta_property] = STATE(1650),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3926),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3928),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3928),
    [sym_false] = ACTIONS(3928),
    [sym_null] = ACTIONS(3928),
    [sym_undefined] = ACTIONS(3928),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1444] = {
    [anon_sym_EQ_GT] = ACTIONS(3930),
    [sym_comment] = ACTIONS(78),
  },
  [1445] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1446] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(1444),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(3393),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(3397),
  },
  [1447] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(3393),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [1448] = {
    [sym_parenthesized_expression] = STATE(1652),
    [sym__expression] = STATE(1652),
    [sym_yield_expression] = STATE(1652),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1652),
    [sym_jsx_fragment] = STATE(1652),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1652),
    [sym_anonymous_class] = STATE(1652),
    [sym_class] = STATE(1652),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1652),
    [sym_generator_function] = STATE(1652),
    [sym_call_expression] = STATE(1652),
    [sym_new_expression] = STATE(1652),
    [sym_await_expression] = STATE(1652),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1652),
    [sym_augmented_assignment_expression] = STATE(1652),
    [sym_ternary_expression] = STATE(1652),
    [sym_binary_expression] = STATE(1652),
    [sym_unary_expression] = STATE(1652),
    [sym_update_expression] = STATE(1652),
    [sym_string] = STATE(1652),
    [sym_template_string] = STATE(1652),
    [sym_regex] = STATE(1652),
    [sym_meta_property] = STATE(1652),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3932),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3934),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3934),
    [sym_false] = ACTIONS(3934),
    [sym_null] = ACTIONS(3934),
    [sym_undefined] = ACTIONS(3934),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1449] = {
    [sym_parenthesized_expression] = STATE(1653),
    [sym__expression] = STATE(1653),
    [sym_yield_expression] = STATE(1653),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1653),
    [sym_jsx_fragment] = STATE(1653),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1653),
    [sym_anonymous_class] = STATE(1653),
    [sym_class] = STATE(1653),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1653),
    [sym_generator_function] = STATE(1653),
    [sym_call_expression] = STATE(1653),
    [sym_new_expression] = STATE(1653),
    [sym_await_expression] = STATE(1653),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1653),
    [sym_augmented_assignment_expression] = STATE(1653),
    [sym_ternary_expression] = STATE(1653),
    [sym_binary_expression] = STATE(1653),
    [sym_unary_expression] = STATE(1653),
    [sym_update_expression] = STATE(1653),
    [sym_string] = STATE(1653),
    [sym_template_string] = STATE(1653),
    [sym_regex] = STATE(1653),
    [sym_meta_property] = STATE(1653),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3936),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3938),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3938),
    [sym_false] = ACTIONS(3938),
    [sym_null] = ACTIONS(3938),
    [sym_undefined] = ACTIONS(3938),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1450] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1451] = {
    [sym_parenthesized_expression] = STATE(1654),
    [sym__expression] = STATE(1654),
    [sym_yield_expression] = STATE(1654),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1654),
    [sym_jsx_fragment] = STATE(1654),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1654),
    [sym_anonymous_class] = STATE(1654),
    [sym_class] = STATE(1654),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1654),
    [sym_generator_function] = STATE(1654),
    [sym_call_expression] = STATE(1654),
    [sym_new_expression] = STATE(1654),
    [sym_await_expression] = STATE(1654),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1654),
    [sym_augmented_assignment_expression] = STATE(1654),
    [sym_ternary_expression] = STATE(1654),
    [sym_binary_expression] = STATE(1654),
    [sym_unary_expression] = STATE(1654),
    [sym_update_expression] = STATE(1654),
    [sym_sequence_expression] = STATE(887),
    [sym_string] = STATE(1654),
    [sym_template_string] = STATE(1654),
    [sym_regex] = STATE(1654),
    [sym_meta_property] = STATE(1654),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3940),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3942),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [sym_null] = ACTIONS(3942),
    [sym_undefined] = ACTIONS(3942),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1452] = {
    [sym_export_statement] = STATE(1655),
    [sym__declaration] = STATE(1655),
    [sym_import_statement] = STATE(1655),
    [sym_expression_statement] = STATE(1655),
    [sym_variable_declaration] = STATE(1655),
    [sym_lexical_declaration] = STATE(1655),
    [sym_statement_block] = STATE(1655),
    [sym_if_statement] = STATE(1655),
    [sym_switch_statement] = STATE(1655),
    [sym_for_statement] = STATE(1655),
    [sym_for_in_statement] = STATE(1655),
    [sym_for_of_statement] = STATE(1655),
    [sym_while_statement] = STATE(1655),
    [sym_do_statement] = STATE(1655),
    [sym_try_statement] = STATE(1655),
    [sym_with_statement] = STATE(1655),
    [sym_break_statement] = STATE(1655),
    [sym_continue_statement] = STATE(1655),
    [sym_debugger_statement] = STATE(1655),
    [sym_return_statement] = STATE(1655),
    [sym_throw_statement] = STATE(1655),
    [sym_empty_statement] = STATE(1655),
    [sym_labeled_statement] = STATE(1655),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(1655),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_default] = ACTIONS(3944),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_case] = ACTIONS(3944),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1453] = {
    [sym_parenthesized_expression] = STATE(1656),
    [sym__expression] = STATE(1656),
    [sym_yield_expression] = STATE(1656),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1656),
    [sym_jsx_fragment] = STATE(1656),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1656),
    [sym_anonymous_class] = STATE(1656),
    [sym_class] = STATE(1656),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1656),
    [sym_generator_function] = STATE(1656),
    [sym_call_expression] = STATE(1656),
    [sym_new_expression] = STATE(1656),
    [sym_await_expression] = STATE(1656),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1656),
    [sym_augmented_assignment_expression] = STATE(1656),
    [sym_ternary_expression] = STATE(1656),
    [sym_binary_expression] = STATE(1656),
    [sym_unary_expression] = STATE(1656),
    [sym_update_expression] = STATE(1656),
    [sym_string] = STATE(1656),
    [sym_template_string] = STATE(1656),
    [sym_regex] = STATE(1656),
    [sym_meta_property] = STATE(1656),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3948),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(3950),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3950),
    [sym_false] = ACTIONS(3950),
    [sym_null] = ACTIONS(3950),
    [sym_undefined] = ACTIONS(3950),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1454] = {
    [sym_parenthesized_expression] = STATE(1657),
    [sym__expression] = STATE(1657),
    [sym_yield_expression] = STATE(1657),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1657),
    [sym_jsx_fragment] = STATE(1657),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1657),
    [sym_anonymous_class] = STATE(1657),
    [sym_class] = STATE(1657),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1657),
    [sym_generator_function] = STATE(1657),
    [sym_call_expression] = STATE(1657),
    [sym_new_expression] = STATE(1657),
    [sym_await_expression] = STATE(1657),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1657),
    [sym_augmented_assignment_expression] = STATE(1657),
    [sym_ternary_expression] = STATE(1657),
    [sym_binary_expression] = STATE(1657),
    [sym_unary_expression] = STATE(1657),
    [sym_update_expression] = STATE(1657),
    [sym_string] = STATE(1657),
    [sym_template_string] = STATE(1657),
    [sym_regex] = STATE(1657),
    [sym_meta_property] = STATE(1657),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3952),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3954),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3954),
    [sym_false] = ACTIONS(3954),
    [sym_null] = ACTIONS(3954),
    [sym_undefined] = ACTIONS(3954),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1455] = {
    [sym_parenthesized_expression] = STATE(1658),
    [sym__expression] = STATE(1658),
    [sym_yield_expression] = STATE(1658),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1658),
    [sym_jsx_fragment] = STATE(1658),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1658),
    [sym_anonymous_class] = STATE(1658),
    [sym_class] = STATE(1658),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1658),
    [sym_generator_function] = STATE(1658),
    [sym_call_expression] = STATE(1658),
    [sym_new_expression] = STATE(1658),
    [sym_await_expression] = STATE(1658),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1658),
    [sym_augmented_assignment_expression] = STATE(1658),
    [sym_ternary_expression] = STATE(1658),
    [sym_binary_expression] = STATE(1658),
    [sym_unary_expression] = STATE(1658),
    [sym_update_expression] = STATE(1658),
    [sym_string] = STATE(1658),
    [sym_template_string] = STATE(1658),
    [sym_regex] = STATE(1658),
    [sym_meta_property] = STATE(1658),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3956),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3958),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3958),
    [sym_false] = ACTIONS(3958),
    [sym_null] = ACTIONS(3958),
    [sym_undefined] = ACTIONS(3958),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1456] = {
    [sym_parenthesized_expression] = STATE(1659),
    [sym__expression] = STATE(1659),
    [sym_yield_expression] = STATE(1659),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1659),
    [sym_jsx_fragment] = STATE(1659),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1659),
    [sym_anonymous_class] = STATE(1659),
    [sym_class] = STATE(1659),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1659),
    [sym_generator_function] = STATE(1659),
    [sym_call_expression] = STATE(1659),
    [sym_new_expression] = STATE(1659),
    [sym_await_expression] = STATE(1659),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1659),
    [sym_augmented_assignment_expression] = STATE(1659),
    [sym_ternary_expression] = STATE(1659),
    [sym_binary_expression] = STATE(1659),
    [sym_unary_expression] = STATE(1659),
    [sym_update_expression] = STATE(1659),
    [sym_string] = STATE(1659),
    [sym_template_string] = STATE(1659),
    [sym_regex] = STATE(1659),
    [sym_meta_property] = STATE(1659),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(3960),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(3962),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(3962),
    [sym_false] = ACTIONS(3962),
    [sym_null] = ACTIONS(3962),
    [sym_undefined] = ACTIONS(3962),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1457] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3964),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1458] = {
    [anon_sym_RPAREN] = ACTIONS(3964),
    [sym_comment] = ACTIONS(78),
  },
  [1459] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3966),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1460] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3968),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1461] = {
    [anon_sym_RPAREN] = ACTIONS(3968),
    [sym_comment] = ACTIONS(78),
  },
  [1462] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3970),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1463] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3972),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1464] = {
    [anon_sym_RPAREN] = ACTIONS(3972),
    [sym_comment] = ACTIONS(78),
  },
  [1465] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3974),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1466] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(845),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1467] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(897),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1468] = {
    [sym_parenthesized_expression] = STATE(1666),
    [sym__expression] = STATE(1666),
    [sym_yield_expression] = STATE(1666),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1666),
    [sym_jsx_fragment] = STATE(1666),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1666),
    [sym_anonymous_class] = STATE(1666),
    [sym_class] = STATE(1666),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1666),
    [sym_generator_function] = STATE(1666),
    [sym_call_expression] = STATE(1666),
    [sym_new_expression] = STATE(1666),
    [sym_await_expression] = STATE(1666),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1666),
    [sym_augmented_assignment_expression] = STATE(1666),
    [sym_ternary_expression] = STATE(1666),
    [sym_binary_expression] = STATE(1666),
    [sym_unary_expression] = STATE(1666),
    [sym_update_expression] = STATE(1666),
    [sym_string] = STATE(1666),
    [sym_template_string] = STATE(1666),
    [sym_regex] = STATE(1666),
    [sym_meta_property] = STATE(1666),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3990),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3992),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3992),
    [sym_false] = ACTIONS(3992),
    [sym_null] = ACTIONS(3992),
    [sym_undefined] = ACTIONS(3992),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1469] = {
    [sym_statement_block] = STATE(581),
    [sym_parenthesized_expression] = STATE(1667),
    [sym__expression] = STATE(1667),
    [sym_yield_expression] = STATE(1667),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1667),
    [sym_jsx_fragment] = STATE(1667),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1667),
    [sym_anonymous_class] = STATE(1667),
    [sym_class] = STATE(1667),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1667),
    [sym_generator_function] = STATE(1667),
    [sym_call_expression] = STATE(1667),
    [sym_new_expression] = STATE(1667),
    [sym_await_expression] = STATE(1667),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1667),
    [sym_augmented_assignment_expression] = STATE(1667),
    [sym_ternary_expression] = STATE(1667),
    [sym_binary_expression] = STATE(1667),
    [sym_unary_expression] = STATE(1667),
    [sym_update_expression] = STATE(1667),
    [sym_string] = STATE(1667),
    [sym_template_string] = STATE(1667),
    [sym_regex] = STATE(1667),
    [sym_meta_property] = STATE(1667),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3994),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(3996),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(3996),
    [sym_false] = ACTIONS(3996),
    [sym_null] = ACTIONS(3996),
    [sym_undefined] = ACTIONS(3996),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1470] = {
    [sym_parenthesized_expression] = STATE(1668),
    [sym__expression] = STATE(1668),
    [sym_yield_expression] = STATE(1668),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1668),
    [sym_jsx_fragment] = STATE(1668),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1668),
    [sym_anonymous_class] = STATE(1668),
    [sym_class] = STATE(1668),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1668),
    [sym_generator_function] = STATE(1668),
    [sym_call_expression] = STATE(1668),
    [sym_new_expression] = STATE(1668),
    [sym_await_expression] = STATE(1668),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1668),
    [sym_augmented_assignment_expression] = STATE(1668),
    [sym_ternary_expression] = STATE(1668),
    [sym_binary_expression] = STATE(1668),
    [sym_unary_expression] = STATE(1668),
    [sym_update_expression] = STATE(1668),
    [sym_string] = STATE(1668),
    [sym_template_string] = STATE(1668),
    [sym_regex] = STATE(1668),
    [sym_meta_property] = STATE(1668),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(3998),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4000),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4000),
    [sym_false] = ACTIONS(4000),
    [sym_null] = ACTIONS(4000),
    [sym_undefined] = ACTIONS(4000),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1471] = {
    [anon_sym_EQ_GT] = ACTIONS(4002),
    [sym_comment] = ACTIONS(78),
  },
  [1472] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1473] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(603),
    [sym_formal_parameters] = STATE(1471),
    [sym__automatic_semicolon] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_COMMA] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_SEMI] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(315),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(319),
    [anon_sym_EQ_GT] = ACTIONS(3479),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(3483),
  },
  [1474] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(604),
    [sym__automatic_semicolon] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(3479),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [1475] = {
    [sym_parenthesized_expression] = STATE(1670),
    [sym__expression] = STATE(1670),
    [sym_yield_expression] = STATE(1670),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1670),
    [sym_jsx_fragment] = STATE(1670),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1670),
    [sym_anonymous_class] = STATE(1670),
    [sym_class] = STATE(1670),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1670),
    [sym_generator_function] = STATE(1670),
    [sym_call_expression] = STATE(1670),
    [sym_new_expression] = STATE(1670),
    [sym_await_expression] = STATE(1670),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1670),
    [sym_augmented_assignment_expression] = STATE(1670),
    [sym_ternary_expression] = STATE(1670),
    [sym_binary_expression] = STATE(1670),
    [sym_unary_expression] = STATE(1670),
    [sym_update_expression] = STATE(1670),
    [sym_string] = STATE(1670),
    [sym_template_string] = STATE(1670),
    [sym_regex] = STATE(1670),
    [sym_meta_property] = STATE(1670),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4004),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4006),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4006),
    [sym_false] = ACTIONS(4006),
    [sym_null] = ACTIONS(4006),
    [sym_undefined] = ACTIONS(4006),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1476] = {
    [sym_parenthesized_expression] = STATE(1671),
    [sym__expression] = STATE(1671),
    [sym_yield_expression] = STATE(1671),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1671),
    [sym_jsx_fragment] = STATE(1671),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1671),
    [sym_anonymous_class] = STATE(1671),
    [sym_class] = STATE(1671),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1671),
    [sym_generator_function] = STATE(1671),
    [sym_call_expression] = STATE(1671),
    [sym_new_expression] = STATE(1671),
    [sym_await_expression] = STATE(1671),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1671),
    [sym_augmented_assignment_expression] = STATE(1671),
    [sym_ternary_expression] = STATE(1671),
    [sym_binary_expression] = STATE(1671),
    [sym_unary_expression] = STATE(1671),
    [sym_update_expression] = STATE(1671),
    [sym_string] = STATE(1671),
    [sym_template_string] = STATE(1671),
    [sym_regex] = STATE(1671),
    [sym_meta_property] = STATE(1671),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4008),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4010),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4010),
    [sym_false] = ACTIONS(4010),
    [sym_null] = ACTIONS(4010),
    [sym_undefined] = ACTIONS(4010),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1477] = {
    [sym_parenthesized_expression] = STATE(632),
    [sym__expression] = STATE(632),
    [sym_yield_expression] = STATE(632),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(632),
    [sym_jsx_fragment] = STATE(632),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(632),
    [sym_anonymous_class] = STATE(632),
    [sym_class] = STATE(632),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(632),
    [sym_generator_function] = STATE(632),
    [sym_call_expression] = STATE(632),
    [sym_new_expression] = STATE(632),
    [sym_await_expression] = STATE(632),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(632),
    [sym_augmented_assignment_expression] = STATE(632),
    [sym_ternary_expression] = STATE(632),
    [sym_binary_expression] = STATE(632),
    [sym_unary_expression] = STATE(632),
    [sym_update_expression] = STATE(632),
    [sym_string] = STATE(632),
    [sym_template_string] = STATE(632),
    [sym_regex] = STATE(632),
    [sym_meta_property] = STATE(632),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(1189),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(1191),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(1191),
    [sym_false] = ACTIONS(1191),
    [sym_null] = ACTIONS(1191),
    [sym_undefined] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1478] = {
    [sym_export_statement] = STATE(1672),
    [sym__declaration] = STATE(1672),
    [sym_import_statement] = STATE(1672),
    [sym_expression_statement] = STATE(1672),
    [sym_variable_declaration] = STATE(1672),
    [sym_lexical_declaration] = STATE(1672),
    [sym_statement_block] = STATE(1672),
    [sym_if_statement] = STATE(1672),
    [sym_switch_statement] = STATE(1672),
    [sym_for_statement] = STATE(1672),
    [sym_for_in_statement] = STATE(1672),
    [sym_for_of_statement] = STATE(1672),
    [sym_while_statement] = STATE(1672),
    [sym_do_statement] = STATE(1672),
    [sym_try_statement] = STATE(1672),
    [sym_with_statement] = STATE(1672),
    [sym_break_statement] = STATE(1672),
    [sym_continue_statement] = STATE(1672),
    [sym_debugger_statement] = STATE(1672),
    [sym_return_statement] = STATE(1672),
    [sym_throw_statement] = STATE(1672),
    [sym_empty_statement] = STATE(1672),
    [sym_labeled_statement] = STATE(1672),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1479] = {
    [sym_parenthesized_expression] = STATE(1673),
    [sym__expression] = STATE(1673),
    [sym_yield_expression] = STATE(1673),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1673),
    [sym_jsx_fragment] = STATE(1673),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1673),
    [sym_anonymous_class] = STATE(1673),
    [sym_class] = STATE(1673),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1673),
    [sym_generator_function] = STATE(1673),
    [sym_call_expression] = STATE(1673),
    [sym_new_expression] = STATE(1673),
    [sym_await_expression] = STATE(1673),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1673),
    [sym_augmented_assignment_expression] = STATE(1673),
    [sym_ternary_expression] = STATE(1673),
    [sym_binary_expression] = STATE(1673),
    [sym_unary_expression] = STATE(1673),
    [sym_update_expression] = STATE(1673),
    [sym_string] = STATE(1673),
    [sym_template_string] = STATE(1673),
    [sym_regex] = STATE(1673),
    [sym_meta_property] = STATE(1673),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4012),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(4014),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [sym_null] = ACTIONS(4014),
    [sym_undefined] = ACTIONS(4014),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1480] = {
    [sym_parenthesized_expression] = STATE(1674),
    [sym__expression] = STATE(1674),
    [sym_yield_expression] = STATE(1674),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1674),
    [sym_jsx_fragment] = STATE(1674),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1674),
    [sym_anonymous_class] = STATE(1674),
    [sym_class] = STATE(1674),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1674),
    [sym_generator_function] = STATE(1674),
    [sym_call_expression] = STATE(1674),
    [sym_new_expression] = STATE(1674),
    [sym_await_expression] = STATE(1674),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1674),
    [sym_augmented_assignment_expression] = STATE(1674),
    [sym_ternary_expression] = STATE(1674),
    [sym_binary_expression] = STATE(1674),
    [sym_unary_expression] = STATE(1674),
    [sym_update_expression] = STATE(1674),
    [sym_string] = STATE(1674),
    [sym_template_string] = STATE(1674),
    [sym_regex] = STATE(1674),
    [sym_meta_property] = STATE(1674),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4016),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4018),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4018),
    [sym_false] = ACTIONS(4018),
    [sym_null] = ACTIONS(4018),
    [sym_undefined] = ACTIONS(4018),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1481] = {
    [sym_parenthesized_expression] = STATE(1675),
    [sym__expression] = STATE(1675),
    [sym_yield_expression] = STATE(1675),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1675),
    [sym_jsx_fragment] = STATE(1675),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1675),
    [sym_anonymous_class] = STATE(1675),
    [sym_class] = STATE(1675),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1675),
    [sym_generator_function] = STATE(1675),
    [sym_call_expression] = STATE(1675),
    [sym_new_expression] = STATE(1675),
    [sym_await_expression] = STATE(1675),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1675),
    [sym_augmented_assignment_expression] = STATE(1675),
    [sym_ternary_expression] = STATE(1675),
    [sym_binary_expression] = STATE(1675),
    [sym_unary_expression] = STATE(1675),
    [sym_update_expression] = STATE(1675),
    [sym_string] = STATE(1675),
    [sym_template_string] = STATE(1675),
    [sym_regex] = STATE(1675),
    [sym_meta_property] = STATE(1675),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4020),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4022),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4022),
    [sym_false] = ACTIONS(4022),
    [sym_null] = ACTIONS(4022),
    [sym_undefined] = ACTIONS(4022),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1482] = {
    [sym_parenthesized_expression] = STATE(1676),
    [sym__expression] = STATE(1676),
    [sym_yield_expression] = STATE(1676),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1676),
    [sym_jsx_fragment] = STATE(1676),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1676),
    [sym_anonymous_class] = STATE(1676),
    [sym_class] = STATE(1676),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1676),
    [sym_generator_function] = STATE(1676),
    [sym_call_expression] = STATE(1676),
    [sym_new_expression] = STATE(1676),
    [sym_await_expression] = STATE(1676),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1676),
    [sym_augmented_assignment_expression] = STATE(1676),
    [sym_ternary_expression] = STATE(1676),
    [sym_binary_expression] = STATE(1676),
    [sym_unary_expression] = STATE(1676),
    [sym_update_expression] = STATE(1676),
    [sym_string] = STATE(1676),
    [sym_template_string] = STATE(1676),
    [sym_regex] = STATE(1676),
    [sym_meta_property] = STATE(1676),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4024),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4026),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4026),
    [sym_false] = ACTIONS(4026),
    [sym_null] = ACTIONS(4026),
    [sym_undefined] = ACTIONS(4026),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1483] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1484] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1485] = {
    [sym_parenthesized_expression] = STATE(1677),
    [sym__expression] = STATE(1677),
    [sym_yield_expression] = STATE(1677),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1677),
    [sym_jsx_fragment] = STATE(1677),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1677),
    [sym_anonymous_class] = STATE(1677),
    [sym_class] = STATE(1677),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1677),
    [sym_generator_function] = STATE(1677),
    [sym_call_expression] = STATE(1677),
    [sym_new_expression] = STATE(1677),
    [sym_await_expression] = STATE(1677),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1677),
    [sym_augmented_assignment_expression] = STATE(1677),
    [sym_ternary_expression] = STATE(1677),
    [sym_binary_expression] = STATE(1677),
    [sym_unary_expression] = STATE(1677),
    [sym_update_expression] = STATE(1677),
    [sym_string] = STATE(1677),
    [sym_template_string] = STATE(1677),
    [sym_regex] = STATE(1677),
    [sym_meta_property] = STATE(1677),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4028),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4030),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4030),
    [sym_false] = ACTIONS(4030),
    [sym_null] = ACTIONS(4030),
    [sym_undefined] = ACTIONS(4030),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1486] = {
    [sym_statement_block] = STATE(854),
    [sym_parenthesized_expression] = STATE(1678),
    [sym__expression] = STATE(1678),
    [sym_yield_expression] = STATE(1678),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1678),
    [sym_jsx_fragment] = STATE(1678),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1678),
    [sym_anonymous_class] = STATE(1678),
    [sym_class] = STATE(1678),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1678),
    [sym_generator_function] = STATE(1678),
    [sym_call_expression] = STATE(1678),
    [sym_new_expression] = STATE(1678),
    [sym_await_expression] = STATE(1678),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1678),
    [sym_augmented_assignment_expression] = STATE(1678),
    [sym_ternary_expression] = STATE(1678),
    [sym_binary_expression] = STATE(1678),
    [sym_unary_expression] = STATE(1678),
    [sym_update_expression] = STATE(1678),
    [sym_string] = STATE(1678),
    [sym_template_string] = STATE(1678),
    [sym_regex] = STATE(1678),
    [sym_meta_property] = STATE(1678),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4032),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4034),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4034),
    [sym_false] = ACTIONS(4034),
    [sym_null] = ACTIONS(4034),
    [sym_undefined] = ACTIONS(4034),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1487] = {
    [sym_parenthesized_expression] = STATE(1679),
    [sym__expression] = STATE(1679),
    [sym_yield_expression] = STATE(1679),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1679),
    [sym_jsx_fragment] = STATE(1679),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1679),
    [sym_anonymous_class] = STATE(1679),
    [sym_class] = STATE(1679),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1679),
    [sym_generator_function] = STATE(1679),
    [sym_call_expression] = STATE(1679),
    [sym_new_expression] = STATE(1679),
    [sym_await_expression] = STATE(1679),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1679),
    [sym_augmented_assignment_expression] = STATE(1679),
    [sym_ternary_expression] = STATE(1679),
    [sym_binary_expression] = STATE(1679),
    [sym_unary_expression] = STATE(1679),
    [sym_update_expression] = STATE(1679),
    [sym_string] = STATE(1679),
    [sym_template_string] = STATE(1679),
    [sym_regex] = STATE(1679),
    [sym_meta_property] = STATE(1679),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4036),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4038),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_undefined] = ACTIONS(4038),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1488] = {
    [anon_sym_EQ_GT] = ACTIONS(4040),
    [sym_comment] = ACTIONS(78),
  },
  [1489] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1061),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1490] = {
    [sym__initializer] = STATE(426),
    [sym_arguments] = STATE(871),
    [sym_formal_parameters] = STATE(1488),
    [anon_sym_STAR] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1081),
    [anon_sym_RPAREN] = ACTIONS(1081),
    [anon_sym_in] = ACTIONS(1083),
    [anon_sym_LBRACK] = ACTIONS(1081),
    [anon_sym_LT] = ACTIONS(1083),
    [anon_sym_GT] = ACTIONS(1083),
    [anon_sym_SLASH] = ACTIONS(1083),
    [anon_sym_DOT] = ACTIONS(727),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_function] = ACTIONS(731),
    [anon_sym_EQ_GT] = ACTIONS(3513),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1081),
    [anon_sym_AMP_AMP] = ACTIONS(1081),
    [anon_sym_PIPE_PIPE] = ACTIONS(1081),
    [anon_sym_GT_GT] = ACTIONS(1083),
    [anon_sym_GT_GT_GT] = ACTIONS(1083),
    [anon_sym_LT_LT] = ACTIONS(1083),
    [anon_sym_AMP] = ACTIONS(1083),
    [anon_sym_CARET] = ACTIONS(1083),
    [anon_sym_PIPE] = ACTIONS(1083),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_PERCENT] = ACTIONS(1083),
    [anon_sym_LT_EQ] = ACTIONS(1081),
    [anon_sym_EQ_EQ] = ACTIONS(1083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1081),
    [anon_sym_BANG_EQ] = ACTIONS(1083),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1081),
    [anon_sym_GT_EQ] = ACTIONS(1081),
    [anon_sym_instanceof] = ACTIONS(1083),
    [anon_sym_PLUS_PLUS] = ACTIONS(1081),
    [anon_sym_DASH_DASH] = ACTIONS(1081),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_identifier] = ACTIONS(3517),
  },
  [1491] = {
    [sym__initializer] = STATE(478),
    [sym_arguments] = STATE(872),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(3513),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_STAR_EQ] = ACTIONS(1087),
    [anon_sym_SLASH_EQ] = ACTIONS(1087),
    [anon_sym_PERCENT_EQ] = ACTIONS(1087),
    [anon_sym_CARET_EQ] = ACTIONS(1087),
    [anon_sym_AMP_EQ] = ACTIONS(1087),
    [anon_sym_PIPE_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(1087),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_AMP_AMP] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_GT_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1091),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1091),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_instanceof] = ACTIONS(1089),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_DASH_DASH] = ACTIONS(1089),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1089),
  },
  [1492] = {
    [sym_parenthesized_expression] = STATE(1681),
    [sym__expression] = STATE(1681),
    [sym_yield_expression] = STATE(1681),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1681),
    [sym_jsx_fragment] = STATE(1681),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1681),
    [sym_anonymous_class] = STATE(1681),
    [sym_class] = STATE(1681),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1681),
    [sym_generator_function] = STATE(1681),
    [sym_call_expression] = STATE(1681),
    [sym_new_expression] = STATE(1681),
    [sym_await_expression] = STATE(1681),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1681),
    [sym_augmented_assignment_expression] = STATE(1681),
    [sym_ternary_expression] = STATE(1681),
    [sym_binary_expression] = STATE(1681),
    [sym_unary_expression] = STATE(1681),
    [sym_update_expression] = STATE(1681),
    [sym_string] = STATE(1681),
    [sym_template_string] = STATE(1681),
    [sym_regex] = STATE(1681),
    [sym_meta_property] = STATE(1681),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4042),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4044),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [sym_null] = ACTIONS(4044),
    [sym_undefined] = ACTIONS(4044),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1493] = {
    [sym_parenthesized_expression] = STATE(1682),
    [sym__expression] = STATE(1682),
    [sym_yield_expression] = STATE(1682),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1682),
    [sym_jsx_fragment] = STATE(1682),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1682),
    [sym_anonymous_class] = STATE(1682),
    [sym_class] = STATE(1682),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1682),
    [sym_generator_function] = STATE(1682),
    [sym_call_expression] = STATE(1682),
    [sym_new_expression] = STATE(1682),
    [sym_await_expression] = STATE(1682),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1682),
    [sym_augmented_assignment_expression] = STATE(1682),
    [sym_ternary_expression] = STATE(1682),
    [sym_binary_expression] = STATE(1682),
    [sym_unary_expression] = STATE(1682),
    [sym_update_expression] = STATE(1682),
    [sym_string] = STATE(1682),
    [sym_template_string] = STATE(1682),
    [sym_regex] = STATE(1682),
    [sym_meta_property] = STATE(1682),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4046),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4048),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4048),
    [sym_false] = ACTIONS(4048),
    [sym_null] = ACTIONS(4048),
    [sym_undefined] = ACTIONS(4048),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1494] = {
    [sym_parenthesized_expression] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_yield_expression] = STATE(885),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(885),
    [sym_jsx_fragment] = STATE(885),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(885),
    [sym_anonymous_class] = STATE(885),
    [sym_class] = STATE(885),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(885),
    [sym_generator_function] = STATE(885),
    [sym_call_expression] = STATE(885),
    [sym_new_expression] = STATE(885),
    [sym_await_expression] = STATE(885),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(885),
    [sym_augmented_assignment_expression] = STATE(885),
    [sym_ternary_expression] = STATE(885),
    [sym_binary_expression] = STATE(885),
    [sym_unary_expression] = STATE(885),
    [sym_update_expression] = STATE(885),
    [sym_string] = STATE(885),
    [sym_template_string] = STATE(885),
    [sym_regex] = STATE(885),
    [sym_meta_property] = STATE(885),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(1844),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(1844),
    [sym_false] = ACTIONS(1844),
    [sym_null] = ACTIONS(1844),
    [sym_undefined] = ACTIONS(1844),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1495] = {
    [sym_export_statement] = STATE(1683),
    [sym__declaration] = STATE(1683),
    [sym_import_statement] = STATE(1683),
    [sym_expression_statement] = STATE(1683),
    [sym_variable_declaration] = STATE(1683),
    [sym_lexical_declaration] = STATE(1683),
    [sym_statement_block] = STATE(1683),
    [sym_if_statement] = STATE(1683),
    [sym_switch_statement] = STATE(1683),
    [sym_for_statement] = STATE(1683),
    [sym_for_in_statement] = STATE(1683),
    [sym_for_of_statement] = STATE(1683),
    [sym_while_statement] = STATE(1683),
    [sym_do_statement] = STATE(1683),
    [sym_try_statement] = STATE(1683),
    [sym_with_statement] = STATE(1683),
    [sym_break_statement] = STATE(1683),
    [sym_continue_statement] = STATE(1683),
    [sym_debugger_statement] = STATE(1683),
    [sym_return_statement] = STATE(1683),
    [sym_throw_statement] = STATE(1683),
    [sym_empty_statement] = STATE(1683),
    [sym_labeled_statement] = STATE(1683),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1496] = {
    [sym_parenthesized_expression] = STATE(1684),
    [sym__expression] = STATE(1684),
    [sym_yield_expression] = STATE(1684),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1684),
    [sym_jsx_fragment] = STATE(1684),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1684),
    [sym_anonymous_class] = STATE(1684),
    [sym_class] = STATE(1684),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1684),
    [sym_generator_function] = STATE(1684),
    [sym_call_expression] = STATE(1684),
    [sym_new_expression] = STATE(1684),
    [sym_await_expression] = STATE(1684),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1684),
    [sym_augmented_assignment_expression] = STATE(1684),
    [sym_ternary_expression] = STATE(1684),
    [sym_binary_expression] = STATE(1684),
    [sym_unary_expression] = STATE(1684),
    [sym_update_expression] = STATE(1684),
    [sym_string] = STATE(1684),
    [sym_template_string] = STATE(1684),
    [sym_regex] = STATE(1684),
    [sym_meta_property] = STATE(1684),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4050),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(4052),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4052),
    [sym_false] = ACTIONS(4052),
    [sym_null] = ACTIONS(4052),
    [sym_undefined] = ACTIONS(4052),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1497] = {
    [sym_parenthesized_expression] = STATE(1685),
    [sym__expression] = STATE(1685),
    [sym_yield_expression] = STATE(1685),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1685),
    [sym_jsx_fragment] = STATE(1685),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1685),
    [sym_anonymous_class] = STATE(1685),
    [sym_class] = STATE(1685),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1685),
    [sym_generator_function] = STATE(1685),
    [sym_call_expression] = STATE(1685),
    [sym_new_expression] = STATE(1685),
    [sym_await_expression] = STATE(1685),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1685),
    [sym_augmented_assignment_expression] = STATE(1685),
    [sym_ternary_expression] = STATE(1685),
    [sym_binary_expression] = STATE(1685),
    [sym_unary_expression] = STATE(1685),
    [sym_update_expression] = STATE(1685),
    [sym_string] = STATE(1685),
    [sym_template_string] = STATE(1685),
    [sym_regex] = STATE(1685),
    [sym_meta_property] = STATE(1685),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4054),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4056),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4056),
    [sym_false] = ACTIONS(4056),
    [sym_null] = ACTIONS(4056),
    [sym_undefined] = ACTIONS(4056),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1498] = {
    [sym_parenthesized_expression] = STATE(1686),
    [sym__expression] = STATE(1686),
    [sym_yield_expression] = STATE(1686),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1686),
    [sym_jsx_fragment] = STATE(1686),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1686),
    [sym_anonymous_class] = STATE(1686),
    [sym_class] = STATE(1686),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1686),
    [sym_generator_function] = STATE(1686),
    [sym_call_expression] = STATE(1686),
    [sym_new_expression] = STATE(1686),
    [sym_await_expression] = STATE(1686),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1686),
    [sym_augmented_assignment_expression] = STATE(1686),
    [sym_ternary_expression] = STATE(1686),
    [sym_binary_expression] = STATE(1686),
    [sym_unary_expression] = STATE(1686),
    [sym_update_expression] = STATE(1686),
    [sym_string] = STATE(1686),
    [sym_template_string] = STATE(1686),
    [sym_regex] = STATE(1686),
    [sym_meta_property] = STATE(1686),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4058),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4060),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4060),
    [sym_false] = ACTIONS(4060),
    [sym_null] = ACTIONS(4060),
    [sym_undefined] = ACTIONS(4060),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1499] = {
    [sym_parenthesized_expression] = STATE(1687),
    [sym__expression] = STATE(1687),
    [sym_yield_expression] = STATE(1687),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1687),
    [sym_jsx_fragment] = STATE(1687),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1687),
    [sym_anonymous_class] = STATE(1687),
    [sym_class] = STATE(1687),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1687),
    [sym_generator_function] = STATE(1687),
    [sym_call_expression] = STATE(1687),
    [sym_new_expression] = STATE(1687),
    [sym_await_expression] = STATE(1687),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1687),
    [sym_augmented_assignment_expression] = STATE(1687),
    [sym_ternary_expression] = STATE(1687),
    [sym_binary_expression] = STATE(1687),
    [sym_unary_expression] = STATE(1687),
    [sym_update_expression] = STATE(1687),
    [sym_string] = STATE(1687),
    [sym_template_string] = STATE(1687),
    [sym_regex] = STATE(1687),
    [sym_meta_property] = STATE(1687),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4062),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4064),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4064),
    [sym_false] = ACTIONS(4064),
    [sym_null] = ACTIONS(4064),
    [sym_undefined] = ACTIONS(4064),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1500] = {
    [ts_builtin_sym_end] = ACTIONS(4066),
    [anon_sym_export] = ACTIONS(4068),
    [anon_sym_default] = ACTIONS(4068),
    [anon_sym_LBRACE] = ACTIONS(4066),
    [anon_sym_RBRACE] = ACTIONS(4066),
    [anon_sym_import] = ACTIONS(4068),
    [anon_sym_var] = ACTIONS(4068),
    [anon_sym_let] = ACTIONS(4068),
    [anon_sym_const] = ACTIONS(4068),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_else] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_for] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_await] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_try] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4068),
    [anon_sym_break] = ACTIONS(4068),
    [anon_sym_continue] = ACTIONS(4068),
    [anon_sym_debugger] = ACTIONS(4068),
    [anon_sym_return] = ACTIONS(4068),
    [anon_sym_throw] = ACTIONS(4068),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym_case] = ACTIONS(4068),
    [anon_sym_yield] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(4066),
    [anon_sym_SLASH] = ACTIONS(4068),
    [anon_sym_class] = ACTIONS(4068),
    [anon_sym_async] = ACTIONS(4068),
    [anon_sym_function] = ACTIONS(4068),
    [anon_sym_EQ_GT] = ACTIONS(4066),
    [anon_sym_new] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4068),
    [anon_sym_DASH] = ACTIONS(4068),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_TILDE] = ACTIONS(4066),
    [anon_sym_typeof] = ACTIONS(4068),
    [anon_sym_void] = ACTIONS(4068),
    [anon_sym_delete] = ACTIONS(4068),
    [anon_sym_PLUS_PLUS] = ACTIONS(4066),
    [anon_sym_DASH_DASH] = ACTIONS(4066),
    [anon_sym_DQUOTE] = ACTIONS(4066),
    [anon_sym_SQUOTE] = ACTIONS(4066),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4066),
    [sym_number] = ACTIONS(4066),
    [sym_identifier] = ACTIONS(4068),
    [sym_this] = ACTIONS(4068),
    [sym_super] = ACTIONS(4068),
    [sym_true] = ACTIONS(4068),
    [sym_false] = ACTIONS(4068),
    [sym_null] = ACTIONS(4068),
    [sym_undefined] = ACTIONS(4068),
    [anon_sym_AT] = ACTIONS(4066),
    [anon_sym_get] = ACTIONS(4068),
    [anon_sym_set] = ACTIONS(4068),
  },
  [1501] = {
    [sym_export_statement] = STATE(1688),
    [sym__declaration] = STATE(1688),
    [sym_import_statement] = STATE(1688),
    [sym_expression_statement] = STATE(1688),
    [sym_variable_declaration] = STATE(1688),
    [sym_lexical_declaration] = STATE(1688),
    [sym_statement_block] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_switch_statement] = STATE(1688),
    [sym_for_statement] = STATE(1688),
    [sym_for_in_statement] = STATE(1688),
    [sym_for_of_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_do_statement] = STATE(1688),
    [sym_try_statement] = STATE(1688),
    [sym_with_statement] = STATE(1688),
    [sym_break_statement] = STATE(1688),
    [sym_continue_statement] = STATE(1688),
    [sym_debugger_statement] = STATE(1688),
    [sym_return_statement] = STATE(1688),
    [sym_throw_statement] = STATE(1688),
    [sym_empty_statement] = STATE(1688),
    [sym_labeled_statement] = STATE(1688),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1502] = {
    [sym_export_statement] = STATE(1689),
    [sym__declaration] = STATE(1689),
    [sym_import_statement] = STATE(1689),
    [sym_expression_statement] = STATE(1689),
    [sym_variable_declaration] = STATE(1689),
    [sym_lexical_declaration] = STATE(1689),
    [sym_statement_block] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_switch_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_for_in_statement] = STATE(1689),
    [sym_for_of_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_do_statement] = STATE(1689),
    [sym_try_statement] = STATE(1689),
    [sym_with_statement] = STATE(1689),
    [sym_break_statement] = STATE(1689),
    [sym_continue_statement] = STATE(1689),
    [sym_debugger_statement] = STATE(1689),
    [sym_return_statement] = STATE(1689),
    [sym_throw_statement] = STATE(1689),
    [sym_empty_statement] = STATE(1689),
    [sym_labeled_statement] = STATE(1689),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1503] = {
    [sym_export_statement] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym_import_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_lexical_declaration] = STATE(1690),
    [sym_statement_block] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_for_in_statement] = STATE(1690),
    [sym_for_of_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_try_statement] = STATE(1690),
    [sym_with_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_debugger_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_throw_statement] = STATE(1690),
    [sym_empty_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1504] = {
    [sym_export_statement] = STATE(1691),
    [sym__declaration] = STATE(1691),
    [sym_import_statement] = STATE(1691),
    [sym_expression_statement] = STATE(1691),
    [sym_variable_declaration] = STATE(1691),
    [sym_lexical_declaration] = STATE(1691),
    [sym_statement_block] = STATE(1691),
    [sym_if_statement] = STATE(1691),
    [sym_switch_statement] = STATE(1691),
    [sym_for_statement] = STATE(1691),
    [sym_for_in_statement] = STATE(1691),
    [sym_for_of_statement] = STATE(1691),
    [sym_while_statement] = STATE(1691),
    [sym_do_statement] = STATE(1691),
    [sym_try_statement] = STATE(1691),
    [sym_with_statement] = STATE(1691),
    [sym_break_statement] = STATE(1691),
    [sym_continue_statement] = STATE(1691),
    [sym_debugger_statement] = STATE(1691),
    [sym_return_statement] = STATE(1691),
    [sym_throw_statement] = STATE(1691),
    [sym_empty_statement] = STATE(1691),
    [sym_labeled_statement] = STATE(1691),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1505] = {
    [sym_export_statement] = STATE(1692),
    [sym__declaration] = STATE(1692),
    [sym_import_statement] = STATE(1692),
    [sym_expression_statement] = STATE(1692),
    [sym_variable_declaration] = STATE(1692),
    [sym_lexical_declaration] = STATE(1692),
    [sym_statement_block] = STATE(1692),
    [sym_if_statement] = STATE(1692),
    [sym_switch_statement] = STATE(1692),
    [sym_for_statement] = STATE(1692),
    [sym_for_in_statement] = STATE(1692),
    [sym_for_of_statement] = STATE(1692),
    [sym_while_statement] = STATE(1692),
    [sym_do_statement] = STATE(1692),
    [sym_try_statement] = STATE(1692),
    [sym_with_statement] = STATE(1692),
    [sym_break_statement] = STATE(1692),
    [sym_continue_statement] = STATE(1692),
    [sym_debugger_statement] = STATE(1692),
    [sym_return_statement] = STATE(1692),
    [sym_throw_statement] = STATE(1692),
    [sym_empty_statement] = STATE(1692),
    [sym_labeled_statement] = STATE(1692),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1506] = {
    [sym_parenthesized_expression] = STATE(1693),
    [sym__expression] = STATE(1693),
    [sym_yield_expression] = STATE(1693),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1693),
    [sym_jsx_fragment] = STATE(1693),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1693),
    [sym_anonymous_class] = STATE(1693),
    [sym_class] = STATE(1693),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1693),
    [sym_generator_function] = STATE(1693),
    [sym_call_expression] = STATE(1693),
    [sym_new_expression] = STATE(1693),
    [sym_await_expression] = STATE(1693),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1693),
    [sym_augmented_assignment_expression] = STATE(1693),
    [sym_ternary_expression] = STATE(1693),
    [sym_binary_expression] = STATE(1693),
    [sym_unary_expression] = STATE(1693),
    [sym_update_expression] = STATE(1693),
    [sym_string] = STATE(1693),
    [sym_template_string] = STATE(1693),
    [sym_regex] = STATE(1693),
    [sym_meta_property] = STATE(1693),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4070),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4072),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4072),
    [sym_false] = ACTIONS(4072),
    [sym_null] = ACTIONS(4072),
    [sym_undefined] = ACTIONS(4072),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1507] = {
    [sym_parenthesized_expression] = STATE(1694),
    [sym__expression] = STATE(1694),
    [sym_yield_expression] = STATE(1694),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1694),
    [sym_jsx_fragment] = STATE(1694),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1694),
    [sym_anonymous_class] = STATE(1694),
    [sym_class] = STATE(1694),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1694),
    [sym_generator_function] = STATE(1694),
    [sym_call_expression] = STATE(1694),
    [sym_new_expression] = STATE(1694),
    [sym_await_expression] = STATE(1694),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1694),
    [sym_augmented_assignment_expression] = STATE(1694),
    [sym_ternary_expression] = STATE(1694),
    [sym_binary_expression] = STATE(1694),
    [sym_unary_expression] = STATE(1694),
    [sym_update_expression] = STATE(1694),
    [sym_string] = STATE(1694),
    [sym_template_string] = STATE(1694),
    [sym_regex] = STATE(1694),
    [sym_meta_property] = STATE(1694),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4074),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4076),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4076),
    [sym_false] = ACTIONS(4076),
    [sym_null] = ACTIONS(4076),
    [sym_undefined] = ACTIONS(4076),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1508] = {
    [sym_parenthesized_expression] = STATE(1695),
    [sym__expression] = STATE(1695),
    [sym_yield_expression] = STATE(1695),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1695),
    [sym_jsx_fragment] = STATE(1695),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1695),
    [sym_anonymous_class] = STATE(1695),
    [sym_class] = STATE(1695),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1695),
    [sym_generator_function] = STATE(1695),
    [sym_call_expression] = STATE(1695),
    [sym_new_expression] = STATE(1695),
    [sym_await_expression] = STATE(1695),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1695),
    [sym_augmented_assignment_expression] = STATE(1695),
    [sym_ternary_expression] = STATE(1695),
    [sym_binary_expression] = STATE(1695),
    [sym_unary_expression] = STATE(1695),
    [sym_update_expression] = STATE(1695),
    [sym_string] = STATE(1695),
    [sym_template_string] = STATE(1695),
    [sym_regex] = STATE(1695),
    [sym_meta_property] = STATE(1695),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4078),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4080),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4080),
    [sym_false] = ACTIONS(4080),
    [sym_null] = ACTIONS(4080),
    [sym_undefined] = ACTIONS(4080),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1509] = {
    [anon_sym_STAR] = ACTIONS(3328),
    [anon_sym_LBRACE] = ACTIONS(3328),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3330),
    [anon_sym_of] = ACTIONS(3328),
    [anon_sym_COLON] = ACTIONS(3328),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_RBRACK] = ACTIONS(3328),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_DOT] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(3330),
    [anon_sym_QMARK] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_GT_GT] = ACTIONS(3330),
    [anon_sym_GT_GT_GT] = ACTIONS(3328),
    [anon_sym_LT_LT] = ACTIONS(3328),
    [anon_sym_AMP] = ACTIONS(3330),
    [anon_sym_CARET] = ACTIONS(3328),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_PERCENT] = ACTIONS(3328),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_EQ_EQ] = ACTIONS(3330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3330),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_instanceof] = ACTIONS(3328),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3328),
  },
  [1510] = {
    [anon_sym_STAR] = ACTIONS(3645),
    [anon_sym_LBRACE] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3645),
    [anon_sym_RBRACE] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(3645),
    [anon_sym_RPAREN] = ACTIONS(3645),
    [anon_sym_in] = ACTIONS(3647),
    [anon_sym_COLON] = ACTIONS(3645),
    [anon_sym_LBRACK] = ACTIONS(3645),
    [anon_sym_RBRACK] = ACTIONS(3645),
    [anon_sym_LT] = ACTIONS(3647),
    [anon_sym_GT] = ACTIONS(3647),
    [anon_sym_SLASH] = ACTIONS(3647),
    [anon_sym_DOT] = ACTIONS(3645),
    [anon_sym_QMARK] = ACTIONS(3645),
    [anon_sym_AMP_AMP] = ACTIONS(3645),
    [anon_sym_PIPE_PIPE] = ACTIONS(3645),
    [anon_sym_GT_GT] = ACTIONS(3647),
    [anon_sym_GT_GT_GT] = ACTIONS(3645),
    [anon_sym_LT_LT] = ACTIONS(3645),
    [anon_sym_AMP] = ACTIONS(3647),
    [anon_sym_CARET] = ACTIONS(3645),
    [anon_sym_PIPE] = ACTIONS(3647),
    [anon_sym_PLUS] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3647),
    [anon_sym_PERCENT] = ACTIONS(3645),
    [anon_sym_LT_EQ] = ACTIONS(3645),
    [anon_sym_EQ_EQ] = ACTIONS(3647),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3645),
    [anon_sym_BANG_EQ] = ACTIONS(3647),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3645),
    [anon_sym_GT_EQ] = ACTIONS(3645),
    [anon_sym_instanceof] = ACTIONS(3645),
    [anon_sym_PLUS_PLUS] = ACTIONS(3645),
    [anon_sym_DASH_DASH] = ACTIONS(3645),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3645),
  },
  [1511] = {
    [anon_sym_GT] = ACTIONS(4082),
    [sym_comment] = ACTIONS(78),
  },
  [1512] = {
    [anon_sym_STAR] = ACTIONS(3677),
    [anon_sym_LBRACE] = ACTIONS(3677),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_RBRACE] = ACTIONS(3677),
    [anon_sym_LPAREN] = ACTIONS(3677),
    [anon_sym_RPAREN] = ACTIONS(3677),
    [anon_sym_in] = ACTIONS(3679),
    [anon_sym_COLON] = ACTIONS(3677),
    [anon_sym_LBRACK] = ACTIONS(3677),
    [anon_sym_RBRACK] = ACTIONS(3677),
    [anon_sym_LT] = ACTIONS(3679),
    [anon_sym_GT] = ACTIONS(3679),
    [anon_sym_SLASH] = ACTIONS(3679),
    [anon_sym_DOT] = ACTIONS(3677),
    [anon_sym_QMARK] = ACTIONS(3677),
    [anon_sym_AMP_AMP] = ACTIONS(3677),
    [anon_sym_PIPE_PIPE] = ACTIONS(3677),
    [anon_sym_GT_GT] = ACTIONS(3679),
    [anon_sym_GT_GT_GT] = ACTIONS(3677),
    [anon_sym_LT_LT] = ACTIONS(3677),
    [anon_sym_AMP] = ACTIONS(3679),
    [anon_sym_CARET] = ACTIONS(3677),
    [anon_sym_PIPE] = ACTIONS(3679),
    [anon_sym_PLUS] = ACTIONS(3679),
    [anon_sym_DASH] = ACTIONS(3679),
    [anon_sym_PERCENT] = ACTIONS(3677),
    [anon_sym_LT_EQ] = ACTIONS(3677),
    [anon_sym_EQ_EQ] = ACTIONS(3679),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3677),
    [anon_sym_BANG_EQ] = ACTIONS(3679),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3677),
    [anon_sym_GT_EQ] = ACTIONS(3677),
    [anon_sym_instanceof] = ACTIONS(3677),
    [anon_sym_PLUS_PLUS] = ACTIONS(3677),
    [anon_sym_DASH_DASH] = ACTIONS(3677),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3677),
  },
  [1513] = {
    [anon_sym_STAR] = ACTIONS(3693),
    [anon_sym_LBRACE] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3693),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_RPAREN] = ACTIONS(3693),
    [anon_sym_in] = ACTIONS(3695),
    [anon_sym_COLON] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3693),
    [anon_sym_RBRACK] = ACTIONS(3693),
    [anon_sym_LT] = ACTIONS(3695),
    [anon_sym_GT] = ACTIONS(3695),
    [anon_sym_SLASH] = ACTIONS(3695),
    [anon_sym_DOT] = ACTIONS(3693),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_AMP_AMP] = ACTIONS(3693),
    [anon_sym_PIPE_PIPE] = ACTIONS(3693),
    [anon_sym_GT_GT] = ACTIONS(3695),
    [anon_sym_GT_GT_GT] = ACTIONS(3693),
    [anon_sym_LT_LT] = ACTIONS(3693),
    [anon_sym_AMP] = ACTIONS(3695),
    [anon_sym_CARET] = ACTIONS(3693),
    [anon_sym_PIPE] = ACTIONS(3695),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_PERCENT] = ACTIONS(3693),
    [anon_sym_LT_EQ] = ACTIONS(3693),
    [anon_sym_EQ_EQ] = ACTIONS(3695),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3693),
    [anon_sym_BANG_EQ] = ACTIONS(3695),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3693),
    [anon_sym_GT_EQ] = ACTIONS(3693),
    [anon_sym_instanceof] = ACTIONS(3693),
    [anon_sym_PLUS_PLUS] = ACTIONS(3693),
    [anon_sym_DASH_DASH] = ACTIONS(3693),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3693),
  },
  [1514] = {
    [anon_sym_STAR] = ACTIONS(3697),
    [anon_sym_LBRACE] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3697),
    [anon_sym_RBRACE] = ACTIONS(3697),
    [anon_sym_LPAREN] = ACTIONS(3697),
    [anon_sym_RPAREN] = ACTIONS(3697),
    [anon_sym_in] = ACTIONS(3699),
    [anon_sym_COLON] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3697),
    [anon_sym_RBRACK] = ACTIONS(3697),
    [anon_sym_LT] = ACTIONS(3699),
    [anon_sym_GT] = ACTIONS(3699),
    [anon_sym_SLASH] = ACTIONS(3699),
    [anon_sym_DOT] = ACTIONS(3697),
    [anon_sym_QMARK] = ACTIONS(3697),
    [anon_sym_AMP_AMP] = ACTIONS(3697),
    [anon_sym_PIPE_PIPE] = ACTIONS(3697),
    [anon_sym_GT_GT] = ACTIONS(3699),
    [anon_sym_GT_GT_GT] = ACTIONS(3697),
    [anon_sym_LT_LT] = ACTIONS(3697),
    [anon_sym_AMP] = ACTIONS(3699),
    [anon_sym_CARET] = ACTIONS(3697),
    [anon_sym_PIPE] = ACTIONS(3699),
    [anon_sym_PLUS] = ACTIONS(3699),
    [anon_sym_DASH] = ACTIONS(3699),
    [anon_sym_PERCENT] = ACTIONS(3697),
    [anon_sym_LT_EQ] = ACTIONS(3697),
    [anon_sym_EQ_EQ] = ACTIONS(3699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3697),
    [anon_sym_BANG_EQ] = ACTIONS(3699),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3697),
    [anon_sym_GT_EQ] = ACTIONS(3697),
    [anon_sym_instanceof] = ACTIONS(3697),
    [anon_sym_PLUS_PLUS] = ACTIONS(3697),
    [anon_sym_DASH_DASH] = ACTIONS(3697),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3697),
  },
  [1515] = {
    [anon_sym_export] = ACTIONS(3706),
    [anon_sym_STAR] = ACTIONS(3704),
    [anon_sym_LBRACE] = ACTIONS(3704),
    [anon_sym_COMMA] = ACTIONS(3704),
    [anon_sym_RBRACE] = ACTIONS(3704),
    [anon_sym_LPAREN] = ACTIONS(3704),
    [anon_sym_RPAREN] = ACTIONS(3704),
    [anon_sym_in] = ACTIONS(3706),
    [anon_sym_COLON] = ACTIONS(3704),
    [anon_sym_LBRACK] = ACTIONS(3704),
    [anon_sym_RBRACK] = ACTIONS(3704),
    [anon_sym_LT] = ACTIONS(3706),
    [anon_sym_GT] = ACTIONS(3706),
    [anon_sym_SLASH] = ACTIONS(3706),
    [anon_sym_DOT] = ACTIONS(3706),
    [anon_sym_class] = ACTIONS(3706),
    [anon_sym_async] = ACTIONS(3706),
    [anon_sym_QMARK] = ACTIONS(3704),
    [anon_sym_AMP_AMP] = ACTIONS(3704),
    [anon_sym_PIPE_PIPE] = ACTIONS(3704),
    [anon_sym_GT_GT] = ACTIONS(3706),
    [anon_sym_GT_GT_GT] = ACTIONS(3704),
    [anon_sym_LT_LT] = ACTIONS(3704),
    [anon_sym_AMP] = ACTIONS(3706),
    [anon_sym_CARET] = ACTIONS(3704),
    [anon_sym_PIPE] = ACTIONS(3706),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_PERCENT] = ACTIONS(3704),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_EQ_EQ] = ACTIONS(3706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3704),
    [anon_sym_BANG_EQ] = ACTIONS(3706),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3704),
    [anon_sym_instanceof] = ACTIONS(3706),
    [anon_sym_PLUS_PLUS] = ACTIONS(3704),
    [anon_sym_DASH_DASH] = ACTIONS(3704),
    [anon_sym_DQUOTE] = ACTIONS(3704),
    [anon_sym_SQUOTE] = ACTIONS(3704),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3704),
    [sym_number] = ACTIONS(3704),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_AT] = ACTIONS(3704),
    [anon_sym_static] = ACTIONS(3706),
    [anon_sym_get] = ACTIONS(3706),
    [anon_sym_set] = ACTIONS(3706),
  },
  [1516] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1517] = {
    [anon_sym_STAR] = ACTIONS(3754),
    [anon_sym_LBRACE] = ACTIONS(3754),
    [anon_sym_COMMA] = ACTIONS(3754),
    [anon_sym_RBRACE] = ACTIONS(3754),
    [anon_sym_LPAREN] = ACTIONS(3754),
    [anon_sym_RPAREN] = ACTIONS(3754),
    [anon_sym_in] = ACTIONS(3756),
    [anon_sym_COLON] = ACTIONS(3754),
    [anon_sym_LBRACK] = ACTIONS(3754),
    [anon_sym_RBRACK] = ACTIONS(3754),
    [anon_sym_LT] = ACTIONS(3756),
    [anon_sym_GT] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(3756),
    [anon_sym_DOT] = ACTIONS(3754),
    [anon_sym_QMARK] = ACTIONS(3754),
    [anon_sym_AMP_AMP] = ACTIONS(3754),
    [anon_sym_PIPE_PIPE] = ACTIONS(3754),
    [anon_sym_GT_GT] = ACTIONS(3756),
    [anon_sym_GT_GT_GT] = ACTIONS(3754),
    [anon_sym_LT_LT] = ACTIONS(3754),
    [anon_sym_AMP] = ACTIONS(3756),
    [anon_sym_CARET] = ACTIONS(3754),
    [anon_sym_PIPE] = ACTIONS(3756),
    [anon_sym_PLUS] = ACTIONS(3756),
    [anon_sym_DASH] = ACTIONS(3756),
    [anon_sym_PERCENT] = ACTIONS(3754),
    [anon_sym_LT_EQ] = ACTIONS(3754),
    [anon_sym_EQ_EQ] = ACTIONS(3756),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3754),
    [anon_sym_BANG_EQ] = ACTIONS(3756),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3754),
    [anon_sym_GT_EQ] = ACTIONS(3754),
    [anon_sym_instanceof] = ACTIONS(3754),
    [anon_sym_PLUS_PLUS] = ACTIONS(3754),
    [anon_sym_DASH_DASH] = ACTIONS(3754),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3754),
  },
  [1518] = {
    [anon_sym_STAR] = ACTIONS(3766),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_COMMA] = ACTIONS(3766),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [anon_sym_RPAREN] = ACTIONS(3766),
    [anon_sym_in] = ACTIONS(3768),
    [anon_sym_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [anon_sym_RBRACK] = ACTIONS(3766),
    [anon_sym_LT] = ACTIONS(3768),
    [anon_sym_GT] = ACTIONS(3768),
    [anon_sym_SLASH] = ACTIONS(3768),
    [anon_sym_DOT] = ACTIONS(3766),
    [anon_sym_QMARK] = ACTIONS(3766),
    [anon_sym_AMP_AMP] = ACTIONS(3766),
    [anon_sym_PIPE_PIPE] = ACTIONS(3766),
    [anon_sym_GT_GT] = ACTIONS(3768),
    [anon_sym_GT_GT_GT] = ACTIONS(3766),
    [anon_sym_LT_LT] = ACTIONS(3766),
    [anon_sym_AMP] = ACTIONS(3768),
    [anon_sym_CARET] = ACTIONS(3766),
    [anon_sym_PIPE] = ACTIONS(3768),
    [anon_sym_PLUS] = ACTIONS(3768),
    [anon_sym_DASH] = ACTIONS(3768),
    [anon_sym_PERCENT] = ACTIONS(3766),
    [anon_sym_LT_EQ] = ACTIONS(3766),
    [anon_sym_EQ_EQ] = ACTIONS(3768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3766),
    [anon_sym_BANG_EQ] = ACTIONS(3768),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3766),
    [anon_sym_GT_EQ] = ACTIONS(3766),
    [anon_sym_instanceof] = ACTIONS(3766),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(3766),
  },
  [1519] = {
    [anon_sym_else] = ACTIONS(4084),
    [anon_sym_while] = ACTIONS(1722),
    [sym_comment] = ACTIONS(78),
  },
  [1520] = {
    [sym_variable_declarator] = STATE(93),
    [sym_object] = STATE(1699),
    [sym_array] = STATE(1700),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4086),
  },
  [1521] = {
    [sym_variable_declarator] = STATE(96),
    [sym_object] = STATE(1699),
    [sym_array] = STATE(1700),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4086),
  },
  [1522] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(4088),
    [anon_sym_of] = ACTIONS(4090),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1523] = {
    [sym_expression_statement] = STATE(1703),
    [sym_empty_statement] = STATE(1703),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1524] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(4092),
    [anon_sym_of] = ACTIONS(4094),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1525] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(4096),
    [anon_sym_of] = ACTIONS(4098),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1526] = {
    [sym_object] = STATE(1710),
    [sym_array] = STATE(1711),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_var] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4102),
  },
  [1527] = {
    [sym_parenthesized_expression] = STATE(1712),
    [sym__expression] = STATE(1712),
    [sym_yield_expression] = STATE(1712),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1712),
    [sym_jsx_fragment] = STATE(1712),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1712),
    [sym_anonymous_class] = STATE(1712),
    [sym_class] = STATE(1712),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1712),
    [sym_generator_function] = STATE(1712),
    [sym_call_expression] = STATE(1712),
    [sym_new_expression] = STATE(1712),
    [sym_await_expression] = STATE(1712),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1712),
    [sym_augmented_assignment_expression] = STATE(1712),
    [sym_ternary_expression] = STATE(1712),
    [sym_binary_expression] = STATE(1712),
    [sym_unary_expression] = STATE(1712),
    [sym_update_expression] = STATE(1712),
    [sym_sequence_expression] = STATE(1713),
    [sym_string] = STATE(1712),
    [sym_template_string] = STATE(1712),
    [sym_regex] = STATE(1712),
    [sym_meta_property] = STATE(1712),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4104),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4106),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4106),
    [sym_false] = ACTIONS(4106),
    [sym_null] = ACTIONS(4106),
    [sym_undefined] = ACTIONS(4106),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1528] = {
    [sym_parenthesized_expression] = STATE(1714),
    [sym__expression] = STATE(1714),
    [sym_yield_expression] = STATE(1714),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1714),
    [sym_jsx_fragment] = STATE(1714),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1714),
    [sym_anonymous_class] = STATE(1714),
    [sym_class] = STATE(1714),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1714),
    [sym_generator_function] = STATE(1714),
    [sym_call_expression] = STATE(1714),
    [sym_new_expression] = STATE(1714),
    [sym_await_expression] = STATE(1714),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1714),
    [sym_augmented_assignment_expression] = STATE(1714),
    [sym_ternary_expression] = STATE(1714),
    [sym_binary_expression] = STATE(1714),
    [sym_unary_expression] = STATE(1714),
    [sym_update_expression] = STATE(1714),
    [sym_string] = STATE(1714),
    [sym_template_string] = STATE(1714),
    [sym_regex] = STATE(1714),
    [sym_meta_property] = STATE(1714),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4108),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4110),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4110),
    [sym_false] = ACTIONS(4110),
    [sym_null] = ACTIONS(4110),
    [sym_undefined] = ACTIONS(4110),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1529] = {
    [sym_parenthesized_expression] = STATE(1715),
    [sym__expression] = STATE(1715),
    [sym_yield_expression] = STATE(1715),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1715),
    [sym_jsx_fragment] = STATE(1715),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1715),
    [sym_anonymous_class] = STATE(1715),
    [sym_class] = STATE(1715),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1715),
    [sym_generator_function] = STATE(1715),
    [sym_call_expression] = STATE(1715),
    [sym_new_expression] = STATE(1715),
    [sym_await_expression] = STATE(1715),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1715),
    [sym_augmented_assignment_expression] = STATE(1715),
    [sym_ternary_expression] = STATE(1715),
    [sym_binary_expression] = STATE(1715),
    [sym_unary_expression] = STATE(1715),
    [sym_update_expression] = STATE(1715),
    [sym_sequence_expression] = STATE(1716),
    [sym_string] = STATE(1715),
    [sym_template_string] = STATE(1715),
    [sym_regex] = STATE(1715),
    [sym_meta_property] = STATE(1715),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4112),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4114),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4114),
    [sym_false] = ACTIONS(4114),
    [sym_null] = ACTIONS(4114),
    [sym_undefined] = ACTIONS(4114),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1530] = {
    [sym_parenthesized_expression] = STATE(1717),
    [sym__expression] = STATE(1717),
    [sym_yield_expression] = STATE(1717),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1717),
    [sym_jsx_fragment] = STATE(1717),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1717),
    [sym_anonymous_class] = STATE(1717),
    [sym_class] = STATE(1717),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1717),
    [sym_generator_function] = STATE(1717),
    [sym_call_expression] = STATE(1717),
    [sym_new_expression] = STATE(1717),
    [sym_await_expression] = STATE(1717),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1717),
    [sym_augmented_assignment_expression] = STATE(1717),
    [sym_ternary_expression] = STATE(1717),
    [sym_binary_expression] = STATE(1717),
    [sym_unary_expression] = STATE(1717),
    [sym_update_expression] = STATE(1717),
    [sym_string] = STATE(1717),
    [sym_template_string] = STATE(1717),
    [sym_regex] = STATE(1717),
    [sym_meta_property] = STATE(1717),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4116),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4118),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4118),
    [sym_false] = ACTIONS(4118),
    [sym_null] = ACTIONS(4118),
    [sym_undefined] = ACTIONS(4118),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1531] = {
    [sym_parenthesized_expression] = STATE(1718),
    [sym__expression] = STATE(1718),
    [sym_yield_expression] = STATE(1718),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1718),
    [sym_jsx_fragment] = STATE(1718),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1718),
    [sym_anonymous_class] = STATE(1718),
    [sym_class] = STATE(1718),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1718),
    [sym_generator_function] = STATE(1718),
    [sym_call_expression] = STATE(1718),
    [sym_new_expression] = STATE(1718),
    [sym_await_expression] = STATE(1718),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1718),
    [sym_augmented_assignment_expression] = STATE(1718),
    [sym_ternary_expression] = STATE(1718),
    [sym_binary_expression] = STATE(1718),
    [sym_unary_expression] = STATE(1718),
    [sym_update_expression] = STATE(1718),
    [sym_sequence_expression] = STATE(1719),
    [sym_string] = STATE(1718),
    [sym_template_string] = STATE(1718),
    [sym_regex] = STATE(1718),
    [sym_meta_property] = STATE(1718),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4120),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4122),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4122),
    [sym_false] = ACTIONS(4122),
    [sym_null] = ACTIONS(4122),
    [sym_undefined] = ACTIONS(4122),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1532] = {
    [sym_parenthesized_expression] = STATE(1720),
    [sym__expression] = STATE(1720),
    [sym_yield_expression] = STATE(1720),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1720),
    [sym_jsx_fragment] = STATE(1720),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1720),
    [sym_anonymous_class] = STATE(1720),
    [sym_class] = STATE(1720),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1720),
    [sym_generator_function] = STATE(1720),
    [sym_call_expression] = STATE(1720),
    [sym_new_expression] = STATE(1720),
    [sym_await_expression] = STATE(1720),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1720),
    [sym_augmented_assignment_expression] = STATE(1720),
    [sym_ternary_expression] = STATE(1720),
    [sym_binary_expression] = STATE(1720),
    [sym_unary_expression] = STATE(1720),
    [sym_update_expression] = STATE(1720),
    [sym_string] = STATE(1720),
    [sym_template_string] = STATE(1720),
    [sym_regex] = STATE(1720),
    [sym_meta_property] = STATE(1720),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4124),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4126),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4126),
    [sym_false] = ACTIONS(4126),
    [sym_null] = ACTIONS(4126),
    [sym_undefined] = ACTIONS(4126),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1533] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4128),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1534] = {
    [anon_sym_RPAREN] = ACTIONS(4128),
    [sym_comment] = ACTIONS(78),
  },
  [1535] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4130),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1536] = {
    [sym_export_statement] = STATE(1500),
    [sym__declaration] = STATE(1500),
    [sym_import_statement] = STATE(1500),
    [sym_expression_statement] = STATE(1500),
    [sym_variable_declaration] = STATE(1500),
    [sym_lexical_declaration] = STATE(1500),
    [sym_statement_block] = STATE(1500),
    [sym_if_statement] = STATE(1500),
    [sym_switch_statement] = STATE(1500),
    [sym_for_statement] = STATE(1500),
    [sym_for_in_statement] = STATE(1500),
    [sym_for_of_statement] = STATE(1500),
    [sym_while_statement] = STATE(1500),
    [sym_do_statement] = STATE(1500),
    [sym_try_statement] = STATE(1500),
    [sym_with_statement] = STATE(1500),
    [sym_break_statement] = STATE(1500),
    [sym_continue_statement] = STATE(1500),
    [sym_debugger_statement] = STATE(1500),
    [sym_return_statement] = STATE(1500),
    [sym_throw_statement] = STATE(1500),
    [sym_empty_statement] = STATE(1500),
    [sym_labeled_statement] = STATE(1500),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1537] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4132),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1538] = {
    [anon_sym_RPAREN] = ACTIONS(4132),
    [sym_comment] = ACTIONS(78),
  },
  [1539] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4134),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1540] = {
    [anon_sym_RPAREN] = ACTIONS(4134),
    [sym_comment] = ACTIONS(78),
  },
  [1541] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4136),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1542] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4138),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1543] = {
    [anon_sym_RPAREN] = ACTIONS(4138),
    [sym_comment] = ACTIONS(78),
  },
  [1544] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4140),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1545] = {
    [anon_sym_of] = ACTIONS(4142),
    [sym_comment] = ACTIONS(78),
  },
  [1546] = {
    [anon_sym_of] = ACTIONS(4144),
    [sym_comment] = ACTIONS(78),
  },
  [1547] = {
    [anon_sym_of] = ACTIONS(4146),
    [sym_comment] = ACTIONS(78),
  },
  [1548] = {
    [sym_statement_block] = STATE(1731),
    [anon_sym_LBRACE] = ACTIONS(226),
    [sym_comment] = ACTIONS(78),
  },
  [1549] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(3712),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_SLASH] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(949),
    [anon_sym_PIPE_PIPE] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(945),
    [anon_sym_GT_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(951),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(937),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(959),
    [anon_sym_BANG_EQ] = ACTIONS(937),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(959),
    [anon_sym_GT_EQ] = ACTIONS(959),
    [anon_sym_instanceof] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1550] = {
    [sym__automatic_semicolon] = ACTIONS(4148),
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_in] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_GT] = ACTIONS(4148),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_BANG_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_instanceof] = ACTIONS(4148),
    [anon_sym_PLUS_PLUS] = ACTIONS(4148),
    [anon_sym_DASH_DASH] = ACTIONS(4148),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4148),
  },
  [1551] = {
    [sym_jsx_element] = STATE(1733),
    [sym_jsx_expression] = STATE(1733),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_self_closing_element] = STATE(1733),
    [aux_sym_jsx_element_repeat1] = STATE(1733),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(4152),
    [sym_jsx_text] = ACTIONS(4154),
    [sym_comment] = ACTIONS(78),
  },
  [1552] = {
    [sym_jsx_expression] = STATE(1735),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(1735),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1735),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(4156),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [1553] = {
    [sym_jsx_expression] = STATE(1735),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(1735),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1735),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(4156),
    [sym_jsx_identifier] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [1554] = {
    [sym_jsx_expression] = STATE(1735),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(1735),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1735),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(4156),
    [sym_jsx_identifier] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [1555] = {
    [sym_jsx_expression] = STATE(1735),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(1735),
    [aux_sym_jsx_opening_element_repeat1] = STATE(1735),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(969),
    [anon_sym_SLASH] = ACTIONS(4156),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [1556] = {
    [anon_sym_LBRACE] = ACTIONS(1121),
    [anon_sym_GT] = ACTIONS(1121),
    [anon_sym_SLASH] = ACTIONS(1123),
    [sym_jsx_identifier] = ACTIONS(1121),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1123),
  },
  [1557] = {
    [aux_sym_string_repeat1] = STATE(612),
    [anon_sym_DQUOTE] = ACTIONS(4158),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(1127),
    [sym_escape_sequence] = ACTIONS(1127),
    [sym_comment] = ACTIONS(298),
  },
  [1558] = {
    [aux_sym_string_repeat2] = STATE(613),
    [anon_sym_SQUOTE] = ACTIONS(4158),
    [aux_sym_SLASH_LBRACK_CARET_SQUOTE_BSLASH_BSLASH_BSLASHn_RBRACK_PLUS_SLASH] = ACTIONS(1129),
    [sym_escape_sequence] = ACTIONS(1129),
    [sym_comment] = ACTIONS(298),
  },
  [1559] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(4160),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [1560] = {
    [anon_sym_LBRACE] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_SLASH] = ACTIONS(1261),
    [sym_jsx_identifier] = ACTIONS(1259),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1261),
  },
  [1561] = {
    [sym_jsx_element] = STATE(665),
    [sym_jsx_expression] = STATE(665),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_closing_element] = STATE(1738),
    [sym_jsx_self_closing_element] = STATE(665),
    [aux_sym_jsx_element_repeat1] = STATE(665),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(3669),
    [sym_jsx_text] = ACTIONS(1263),
    [sym_comment] = ACTIONS(78),
  },
  [1562] = {
    [anon_sym_STAR] = ACTIONS(4162),
    [anon_sym_RBRACE] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_async] = ACTIONS(4164),
    [anon_sym_DQUOTE] = ACTIONS(4162),
    [anon_sym_SQUOTE] = ACTIONS(4162),
    [sym_comment] = ACTIONS(78),
    [sym_number] = ACTIONS(4162),
    [sym_identifier] = ACTIONS(4164),
    [anon_sym_AT] = ACTIONS(4162),
    [anon_sym_static] = ACTIONS(4164),
    [anon_sym_get] = ACTIONS(4164),
    [anon_sym_set] = ACTIONS(4164),
  },
  [1563] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1564] = {
    [sym_parenthesized_expression] = STATE(1739),
    [sym__expression] = STATE(1739),
    [sym_yield_expression] = STATE(1739),
    [sym_object] = STATE(565),
    [sym_array] = STATE(566),
    [sym_jsx_element] = STATE(1739),
    [sym_jsx_fragment] = STATE(1739),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1739),
    [sym_anonymous_class] = STATE(1739),
    [sym_class] = STATE(1739),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1739),
    [sym_generator_function] = STATE(1739),
    [sym_call_expression] = STATE(1739),
    [sym_new_expression] = STATE(1739),
    [sym_await_expression] = STATE(1739),
    [sym_member_expression] = STATE(567),
    [sym_subscript_expression] = STATE(567),
    [sym_assignment_expression] = STATE(1739),
    [sym_augmented_assignment_expression] = STATE(1739),
    [sym_ternary_expression] = STATE(1739),
    [sym_binary_expression] = STATE(1739),
    [sym_unary_expression] = STATE(1739),
    [sym_update_expression] = STATE(1739),
    [sym_string] = STATE(1739),
    [sym_template_string] = STATE(1739),
    [sym_regex] = STATE(1739),
    [sym_meta_property] = STATE(1739),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(999),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1005),
    [anon_sym_new] = ACTIONS(1007),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_BANG] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_typeof] = ACTIONS(1009),
    [anon_sym_void] = ACTIONS(1009),
    [anon_sym_delete] = ACTIONS(1009),
    [anon_sym_PLUS_PLUS] = ACTIONS(1013),
    [anon_sym_DASH_DASH] = ACTIONS(1013),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4166),
    [sym_identifier] = ACTIONS(1017),
    [sym_this] = ACTIONS(4168),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4168),
    [sym_false] = ACTIONS(4168),
    [sym_null] = ACTIONS(4168),
    [sym_undefined] = ACTIONS(4168),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1021),
    [anon_sym_set] = ACTIONS(1021),
  },
  [1565] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1566] = {
    [sym_parenthesized_expression] = STATE(1740),
    [sym__expression] = STATE(1740),
    [sym_yield_expression] = STATE(1740),
    [sym_object] = STATE(645),
    [sym_array] = STATE(646),
    [sym_jsx_element] = STATE(1740),
    [sym_jsx_fragment] = STATE(1740),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1740),
    [sym_anonymous_class] = STATE(1740),
    [sym_class] = STATE(1740),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1740),
    [sym_generator_function] = STATE(1740),
    [sym_call_expression] = STATE(1740),
    [sym_new_expression] = STATE(1740),
    [sym_await_expression] = STATE(1740),
    [sym_member_expression] = STATE(647),
    [sym_subscript_expression] = STATE(647),
    [sym_assignment_expression] = STATE(1740),
    [sym_augmented_assignment_expression] = STATE(1740),
    [sym_ternary_expression] = STATE(1740),
    [sym_binary_expression] = STATE(1740),
    [sym_unary_expression] = STATE(1740),
    [sym_update_expression] = STATE(1740),
    [sym_string] = STATE(1740),
    [sym_template_string] = STATE(1740),
    [sym_regex] = STATE(1740),
    [sym_meta_property] = STATE(1740),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(648),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1197),
    [anon_sym_yield] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1203),
    [anon_sym_new] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1209),
    [anon_sym_TILDE] = ACTIONS(1209),
    [anon_sym_typeof] = ACTIONS(1207),
    [anon_sym_void] = ACTIONS(1207),
    [anon_sym_delete] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1211),
    [anon_sym_DASH_DASH] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4170),
    [sym_identifier] = ACTIONS(1215),
    [sym_this] = ACTIONS(4172),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4172),
    [sym_false] = ACTIONS(4172),
    [sym_null] = ACTIONS(4172),
    [sym_undefined] = ACTIONS(4172),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1219),
    [anon_sym_set] = ACTIONS(1219),
  },
  [1567] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1568] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1569] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1570] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1741),
    [sym__expression] = STATE(1741),
    [sym_yield_expression] = STATE(1741),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1741),
    [sym_jsx_fragment] = STATE(1741),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1741),
    [sym_anonymous_class] = STATE(1741),
    [sym_class] = STATE(1741),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1741),
    [sym_generator_function] = STATE(1741),
    [sym_call_expression] = STATE(1741),
    [sym_new_expression] = STATE(1741),
    [sym_await_expression] = STATE(1741),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1741),
    [sym_augmented_assignment_expression] = STATE(1741),
    [sym_ternary_expression] = STATE(1741),
    [sym_binary_expression] = STATE(1741),
    [sym_unary_expression] = STATE(1741),
    [sym_update_expression] = STATE(1741),
    [sym_string] = STATE(1741),
    [sym_template_string] = STATE(1741),
    [sym_regex] = STATE(1741),
    [sym_meta_property] = STATE(1741),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4174),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(4176),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4176),
    [sym_false] = ACTIONS(4176),
    [sym_null] = ACTIONS(4176),
    [sym_undefined] = ACTIONS(4176),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1571] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1572] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1573] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(4178),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1574] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1575] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1576] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1577] = {
    [anon_sym_LBRACE] = ACTIONS(3679),
    [anon_sym_LT] = ACTIONS(3679),
    [sym_jsx_text] = ACTIONS(3679),
    [sym_comment] = ACTIONS(78),
  },
  [1578] = {
    [anon_sym_LBRACE] = ACTIONS(3756),
    [anon_sym_LT] = ACTIONS(3756),
    [sym_jsx_text] = ACTIONS(3756),
    [sym_comment] = ACTIONS(78),
  },
  [1579] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(3712),
    [anon_sym_STAR] = ACTIONS(1433),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_GT_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1449),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [anon_sym_instanceof] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1580] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1581] = {
    [sym_parenthesized_expression] = STATE(1743),
    [sym__expression] = STATE(1743),
    [sym_yield_expression] = STATE(1743),
    [sym_object] = STATE(712),
    [sym_array] = STATE(713),
    [sym_jsx_element] = STATE(1743),
    [sym_jsx_fragment] = STATE(1743),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1743),
    [sym_anonymous_class] = STATE(1743),
    [sym_class] = STATE(1743),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1743),
    [sym_generator_function] = STATE(1743),
    [sym_call_expression] = STATE(1743),
    [sym_new_expression] = STATE(1743),
    [sym_await_expression] = STATE(1743),
    [sym_member_expression] = STATE(714),
    [sym_subscript_expression] = STATE(714),
    [sym_assignment_expression] = STATE(1743),
    [sym_augmented_assignment_expression] = STATE(1743),
    [sym_ternary_expression] = STATE(1743),
    [sym_binary_expression] = STATE(1743),
    [sym_unary_expression] = STATE(1743),
    [sym_update_expression] = STATE(1743),
    [sym_string] = STATE(1743),
    [sym_template_string] = STATE(1743),
    [sym_regex] = STATE(1743),
    [sym_meta_property] = STATE(1743),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(715),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(1477),
    [anon_sym_yield] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(1483),
    [anon_sym_new] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1489),
    [anon_sym_TILDE] = ACTIONS(1489),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4180),
    [sym_identifier] = ACTIONS(1495),
    [sym_this] = ACTIONS(4182),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_undefined] = ACTIONS(4182),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1499),
    [anon_sym_set] = ACTIONS(1499),
  },
  [1582] = {
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(3328),
    [sym_comment] = ACTIONS(78),
  },
  [1583] = {
    [sym_export_statement] = STATE(1161),
    [sym__declaration] = STATE(1161),
    [sym_import_statement] = STATE(1161),
    [sym_expression_statement] = STATE(1161),
    [sym_variable_declaration] = STATE(1161),
    [sym_lexical_declaration] = STATE(1161),
    [sym_statement_block] = STATE(1161),
    [sym_if_statement] = STATE(1161),
    [sym_switch_statement] = STATE(1161),
    [sym_for_statement] = STATE(1161),
    [sym_for_in_statement] = STATE(1161),
    [sym_for_of_statement] = STATE(1161),
    [sym_while_statement] = STATE(1161),
    [sym_do_statement] = STATE(1161),
    [sym_try_statement] = STATE(1161),
    [sym_with_statement] = STATE(1161),
    [sym_break_statement] = STATE(1161),
    [sym_continue_statement] = STATE(1161),
    [sym_debugger_statement] = STATE(1161),
    [sym_return_statement] = STATE(1161),
    [sym_throw_statement] = STATE(1161),
    [sym_empty_statement] = STATE(1161),
    [sym_labeled_statement] = STATE(1161),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1584] = {
    [sym__initializer] = STATE(363),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(4184),
    [anon_sym_of] = ACTIONS(4186),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1585] = {
    [sym__initializer] = STATE(367),
    [sym__automatic_semicolon] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(4188),
    [anon_sym_of] = ACTIONS(4190),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1586] = {
    [sym__initializer] = STATE(368),
    [sym__automatic_semicolon] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(4192),
    [anon_sym_of] = ACTIONS(4194),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1587] = {
    [sym_parenthesized_expression] = STATE(1750),
    [sym__expression] = STATE(1750),
    [sym_yield_expression] = STATE(1750),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1750),
    [sym_jsx_fragment] = STATE(1750),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1750),
    [sym_anonymous_class] = STATE(1750),
    [sym_class] = STATE(1750),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1750),
    [sym_generator_function] = STATE(1750),
    [sym_call_expression] = STATE(1750),
    [sym_new_expression] = STATE(1750),
    [sym_await_expression] = STATE(1750),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1750),
    [sym_augmented_assignment_expression] = STATE(1750),
    [sym_ternary_expression] = STATE(1750),
    [sym_binary_expression] = STATE(1750),
    [sym_unary_expression] = STATE(1750),
    [sym_update_expression] = STATE(1750),
    [sym_sequence_expression] = STATE(1751),
    [sym_string] = STATE(1750),
    [sym_template_string] = STATE(1750),
    [sym_regex] = STATE(1750),
    [sym_meta_property] = STATE(1750),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4196),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4198),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4198),
    [sym_false] = ACTIONS(4198),
    [sym_null] = ACTIONS(4198),
    [sym_undefined] = ACTIONS(4198),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1588] = {
    [sym_parenthesized_expression] = STATE(1752),
    [sym__expression] = STATE(1752),
    [sym_yield_expression] = STATE(1752),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1752),
    [sym_jsx_fragment] = STATE(1752),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1752),
    [sym_anonymous_class] = STATE(1752),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1752),
    [sym_await_expression] = STATE(1752),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1752),
    [sym_augmented_assignment_expression] = STATE(1752),
    [sym_ternary_expression] = STATE(1752),
    [sym_binary_expression] = STATE(1752),
    [sym_unary_expression] = STATE(1752),
    [sym_update_expression] = STATE(1752),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4200),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4202),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4202),
    [sym_false] = ACTIONS(4202),
    [sym_null] = ACTIONS(4202),
    [sym_undefined] = ACTIONS(4202),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1589] = {
    [sym_parenthesized_expression] = STATE(1754),
    [sym__expression] = STATE(1754),
    [sym_yield_expression] = STATE(1754),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1754),
    [sym_jsx_fragment] = STATE(1754),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1754),
    [sym_anonymous_class] = STATE(1754),
    [sym_class] = STATE(1754),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1754),
    [sym_generator_function] = STATE(1754),
    [sym_call_expression] = STATE(1754),
    [sym_new_expression] = STATE(1754),
    [sym_await_expression] = STATE(1754),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1754),
    [sym_augmented_assignment_expression] = STATE(1754),
    [sym_ternary_expression] = STATE(1754),
    [sym_binary_expression] = STATE(1754),
    [sym_unary_expression] = STATE(1754),
    [sym_update_expression] = STATE(1754),
    [sym_sequence_expression] = STATE(1755),
    [sym_string] = STATE(1754),
    [sym_template_string] = STATE(1754),
    [sym_regex] = STATE(1754),
    [sym_meta_property] = STATE(1754),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4206),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4208),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4208),
    [sym_false] = ACTIONS(4208),
    [sym_null] = ACTIONS(4208),
    [sym_undefined] = ACTIONS(4208),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1590] = {
    [sym_parenthesized_expression] = STATE(1756),
    [sym__expression] = STATE(1756),
    [sym_yield_expression] = STATE(1756),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1756),
    [sym_jsx_fragment] = STATE(1756),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1756),
    [sym_anonymous_class] = STATE(1756),
    [sym_class] = STATE(1756),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1756),
    [sym_generator_function] = STATE(1756),
    [sym_call_expression] = STATE(1756),
    [sym_new_expression] = STATE(1756),
    [sym_await_expression] = STATE(1756),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1756),
    [sym_augmented_assignment_expression] = STATE(1756),
    [sym_ternary_expression] = STATE(1756),
    [sym_binary_expression] = STATE(1756),
    [sym_unary_expression] = STATE(1756),
    [sym_update_expression] = STATE(1756),
    [sym_sequence_expression] = STATE(1757),
    [sym_string] = STATE(1756),
    [sym_template_string] = STATE(1756),
    [sym_regex] = STATE(1756),
    [sym_meta_property] = STATE(1756),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4210),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4212),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4212),
    [sym_false] = ACTIONS(4212),
    [sym_null] = ACTIONS(4212),
    [sym_undefined] = ACTIONS(4212),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1591] = {
    [sym_parenthesized_expression] = STATE(1758),
    [sym__expression] = STATE(1758),
    [sym_yield_expression] = STATE(1758),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1758),
    [sym_jsx_fragment] = STATE(1758),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1758),
    [sym_anonymous_class] = STATE(1758),
    [sym_class] = STATE(1758),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1758),
    [sym_generator_function] = STATE(1758),
    [sym_call_expression] = STATE(1758),
    [sym_new_expression] = STATE(1758),
    [sym_await_expression] = STATE(1758),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1758),
    [sym_augmented_assignment_expression] = STATE(1758),
    [sym_ternary_expression] = STATE(1758),
    [sym_binary_expression] = STATE(1758),
    [sym_unary_expression] = STATE(1758),
    [sym_update_expression] = STATE(1758),
    [sym_string] = STATE(1758),
    [sym_template_string] = STATE(1758),
    [sym_regex] = STATE(1758),
    [sym_meta_property] = STATE(1758),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4214),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4216),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4216),
    [sym_false] = ACTIONS(4216),
    [sym_null] = ACTIONS(4216),
    [sym_undefined] = ACTIONS(4216),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1592] = {
    [sym_parenthesized_expression] = STATE(1759),
    [sym__expression] = STATE(1759),
    [sym_yield_expression] = STATE(1759),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1759),
    [sym_jsx_fragment] = STATE(1759),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1759),
    [sym_anonymous_class] = STATE(1759),
    [sym_class] = STATE(1759),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1759),
    [sym_generator_function] = STATE(1759),
    [sym_call_expression] = STATE(1759),
    [sym_new_expression] = STATE(1759),
    [sym_await_expression] = STATE(1759),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1759),
    [sym_augmented_assignment_expression] = STATE(1759),
    [sym_ternary_expression] = STATE(1759),
    [sym_binary_expression] = STATE(1759),
    [sym_unary_expression] = STATE(1759),
    [sym_update_expression] = STATE(1759),
    [sym_sequence_expression] = STATE(1760),
    [sym_string] = STATE(1759),
    [sym_template_string] = STATE(1759),
    [sym_regex] = STATE(1759),
    [sym_meta_property] = STATE(1759),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4218),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4220),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4220),
    [sym_false] = ACTIONS(4220),
    [sym_null] = ACTIONS(4220),
    [sym_undefined] = ACTIONS(4220),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1593] = {
    [sym_parenthesized_expression] = STATE(1761),
    [sym__expression] = STATE(1761),
    [sym_yield_expression] = STATE(1761),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1761),
    [sym_jsx_fragment] = STATE(1761),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1761),
    [sym_anonymous_class] = STATE(1761),
    [sym_class] = STATE(1761),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1761),
    [sym_generator_function] = STATE(1761),
    [sym_call_expression] = STATE(1761),
    [sym_new_expression] = STATE(1761),
    [sym_await_expression] = STATE(1761),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1761),
    [sym_augmented_assignment_expression] = STATE(1761),
    [sym_ternary_expression] = STATE(1761),
    [sym_binary_expression] = STATE(1761),
    [sym_unary_expression] = STATE(1761),
    [sym_update_expression] = STATE(1761),
    [sym_string] = STATE(1761),
    [sym_template_string] = STATE(1761),
    [sym_regex] = STATE(1761),
    [sym_meta_property] = STATE(1761),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4222),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4224),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4224),
    [sym_false] = ACTIONS(4224),
    [sym_null] = ACTIONS(4224),
    [sym_undefined] = ACTIONS(4224),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1594] = {
    [sym_object] = STATE(1763),
    [sym_array] = STATE(1764),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4226),
  },
  [1595] = {
    [anon_sym_of] = ACTIONS(4186),
    [sym_comment] = ACTIONS(78),
  },
  [1596] = {
    [anon_sym_of] = ACTIONS(4190),
    [sym_comment] = ACTIONS(78),
  },
  [1597] = {
    [anon_sym_of] = ACTIONS(4194),
    [sym_comment] = ACTIONS(78),
  },
  [1598] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4228),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1599] = {
    [anon_sym_RPAREN] = ACTIONS(4228),
    [sym_comment] = ACTIONS(78),
  },
  [1600] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1601] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4232),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1602] = {
    [anon_sym_RPAREN] = ACTIONS(4232),
    [sym_comment] = ACTIONS(78),
  },
  [1603] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4234),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1604] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4236),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1605] = {
    [anon_sym_RPAREN] = ACTIONS(4236),
    [sym_comment] = ACTIONS(78),
  },
  [1606] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4238),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1607] = {
    [sym_export_statement] = STATE(1672),
    [sym__declaration] = STATE(1672),
    [sym_import_statement] = STATE(1672),
    [sym_expression_statement] = STATE(1672),
    [sym_variable_declaration] = STATE(1672),
    [sym_lexical_declaration] = STATE(1672),
    [sym_statement_block] = STATE(1672),
    [sym_if_statement] = STATE(1672),
    [sym_switch_statement] = STATE(1672),
    [sym_for_statement] = STATE(1672),
    [sym_for_in_statement] = STATE(1672),
    [sym_for_of_statement] = STATE(1672),
    [sym_while_statement] = STATE(1672),
    [sym_do_statement] = STATE(1672),
    [sym_try_statement] = STATE(1672),
    [sym_with_statement] = STATE(1672),
    [sym_break_statement] = STATE(1672),
    [sym_continue_statement] = STATE(1672),
    [sym_debugger_statement] = STATE(1672),
    [sym_return_statement] = STATE(1672),
    [sym_throw_statement] = STATE(1672),
    [sym_empty_statement] = STATE(1672),
    [sym_labeled_statement] = STATE(1672),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1608] = {
    [sym_export_statement] = STATE(1683),
    [sym__declaration] = STATE(1683),
    [sym_import_statement] = STATE(1683),
    [sym_expression_statement] = STATE(1683),
    [sym_variable_declaration] = STATE(1683),
    [sym_lexical_declaration] = STATE(1683),
    [sym_statement_block] = STATE(1683),
    [sym_if_statement] = STATE(1683),
    [sym_switch_statement] = STATE(1683),
    [sym_for_statement] = STATE(1683),
    [sym_for_in_statement] = STATE(1683),
    [sym_for_of_statement] = STATE(1683),
    [sym_while_statement] = STATE(1683),
    [sym_do_statement] = STATE(1683),
    [sym_try_statement] = STATE(1683),
    [sym_with_statement] = STATE(1683),
    [sym_break_statement] = STATE(1683),
    [sym_continue_statement] = STATE(1683),
    [sym_debugger_statement] = STATE(1683),
    [sym_return_statement] = STATE(1683),
    [sym_throw_statement] = STATE(1683),
    [sym_empty_statement] = STATE(1683),
    [sym_labeled_statement] = STATE(1683),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1609] = {
    [sym_export_statement] = STATE(1688),
    [sym__declaration] = STATE(1688),
    [sym_import_statement] = STATE(1688),
    [sym_expression_statement] = STATE(1688),
    [sym_variable_declaration] = STATE(1688),
    [sym_lexical_declaration] = STATE(1688),
    [sym_statement_block] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_switch_statement] = STATE(1688),
    [sym_for_statement] = STATE(1688),
    [sym_for_in_statement] = STATE(1688),
    [sym_for_of_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_do_statement] = STATE(1688),
    [sym_try_statement] = STATE(1688),
    [sym_with_statement] = STATE(1688),
    [sym_break_statement] = STATE(1688),
    [sym_continue_statement] = STATE(1688),
    [sym_debugger_statement] = STATE(1688),
    [sym_return_statement] = STATE(1688),
    [sym_throw_statement] = STATE(1688),
    [sym_empty_statement] = STATE(1688),
    [sym_labeled_statement] = STATE(1688),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1610] = {
    [sym_export_statement] = STATE(1689),
    [sym__declaration] = STATE(1689),
    [sym_import_statement] = STATE(1689),
    [sym_expression_statement] = STATE(1689),
    [sym_variable_declaration] = STATE(1689),
    [sym_lexical_declaration] = STATE(1689),
    [sym_statement_block] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_switch_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_for_in_statement] = STATE(1689),
    [sym_for_of_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_do_statement] = STATE(1689),
    [sym_try_statement] = STATE(1689),
    [sym_with_statement] = STATE(1689),
    [sym_break_statement] = STATE(1689),
    [sym_continue_statement] = STATE(1689),
    [sym_debugger_statement] = STATE(1689),
    [sym_return_statement] = STATE(1689),
    [sym_throw_statement] = STATE(1689),
    [sym_empty_statement] = STATE(1689),
    [sym_labeled_statement] = STATE(1689),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1611] = {
    [sym_export_statement] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym_import_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_lexical_declaration] = STATE(1690),
    [sym_statement_block] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_for_in_statement] = STATE(1690),
    [sym_for_of_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_try_statement] = STATE(1690),
    [sym_with_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_debugger_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_throw_statement] = STATE(1690),
    [sym_empty_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1612] = {
    [sym_export_statement] = STATE(1691),
    [sym__declaration] = STATE(1691),
    [sym_import_statement] = STATE(1691),
    [sym_expression_statement] = STATE(1691),
    [sym_variable_declaration] = STATE(1691),
    [sym_lexical_declaration] = STATE(1691),
    [sym_statement_block] = STATE(1691),
    [sym_if_statement] = STATE(1691),
    [sym_switch_statement] = STATE(1691),
    [sym_for_statement] = STATE(1691),
    [sym_for_in_statement] = STATE(1691),
    [sym_for_of_statement] = STATE(1691),
    [sym_while_statement] = STATE(1691),
    [sym_do_statement] = STATE(1691),
    [sym_try_statement] = STATE(1691),
    [sym_with_statement] = STATE(1691),
    [sym_break_statement] = STATE(1691),
    [sym_continue_statement] = STATE(1691),
    [sym_debugger_statement] = STATE(1691),
    [sym_return_statement] = STATE(1691),
    [sym_throw_statement] = STATE(1691),
    [sym_empty_statement] = STATE(1691),
    [sym_labeled_statement] = STATE(1691),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1613] = {
    [sym_export_statement] = STATE(1692),
    [sym__declaration] = STATE(1692),
    [sym_import_statement] = STATE(1692),
    [sym_expression_statement] = STATE(1692),
    [sym_variable_declaration] = STATE(1692),
    [sym_lexical_declaration] = STATE(1692),
    [sym_statement_block] = STATE(1692),
    [sym_if_statement] = STATE(1692),
    [sym_switch_statement] = STATE(1692),
    [sym_for_statement] = STATE(1692),
    [sym_for_in_statement] = STATE(1692),
    [sym_for_of_statement] = STATE(1692),
    [sym_while_statement] = STATE(1692),
    [sym_do_statement] = STATE(1692),
    [sym_try_statement] = STATE(1692),
    [sym_with_statement] = STATE(1692),
    [sym_break_statement] = STATE(1692),
    [sym_continue_statement] = STATE(1692),
    [sym_debugger_statement] = STATE(1692),
    [sym_return_statement] = STATE(1692),
    [sym_throw_statement] = STATE(1692),
    [sym_empty_statement] = STATE(1692),
    [sym_labeled_statement] = STATE(1692),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1614] = {
    [sym_parenthesized_expression] = STATE(1771),
    [sym__expression] = STATE(1771),
    [sym_yield_expression] = STATE(1771),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1771),
    [sym_jsx_fragment] = STATE(1771),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1771),
    [sym_anonymous_class] = STATE(1771),
    [sym_class] = STATE(1771),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1771),
    [sym_generator_function] = STATE(1771),
    [sym_call_expression] = STATE(1771),
    [sym_new_expression] = STATE(1771),
    [sym_await_expression] = STATE(1771),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1771),
    [sym_augmented_assignment_expression] = STATE(1771),
    [sym_ternary_expression] = STATE(1771),
    [sym_binary_expression] = STATE(1771),
    [sym_unary_expression] = STATE(1771),
    [sym_update_expression] = STATE(1771),
    [sym_string] = STATE(1771),
    [sym_template_string] = STATE(1771),
    [sym_regex] = STATE(1771),
    [sym_meta_property] = STATE(1771),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4240),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4242),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4242),
    [sym_false] = ACTIONS(4242),
    [sym_null] = ACTIONS(4242),
    [sym_undefined] = ACTIONS(4242),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1615] = {
    [sym_parenthesized_expression] = STATE(1772),
    [sym__expression] = STATE(1772),
    [sym_yield_expression] = STATE(1772),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1772),
    [sym_jsx_fragment] = STATE(1772),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1772),
    [sym_anonymous_class] = STATE(1772),
    [sym_class] = STATE(1772),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1772),
    [sym_generator_function] = STATE(1772),
    [sym_call_expression] = STATE(1772),
    [sym_new_expression] = STATE(1772),
    [sym_await_expression] = STATE(1772),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1772),
    [sym_augmented_assignment_expression] = STATE(1772),
    [sym_ternary_expression] = STATE(1772),
    [sym_binary_expression] = STATE(1772),
    [sym_unary_expression] = STATE(1772),
    [sym_update_expression] = STATE(1772),
    [sym_string] = STATE(1772),
    [sym_template_string] = STATE(1772),
    [sym_regex] = STATE(1772),
    [sym_meta_property] = STATE(1772),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4246),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4246),
    [sym_false] = ACTIONS(4246),
    [sym_null] = ACTIONS(4246),
    [sym_undefined] = ACTIONS(4246),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1616] = {
    [sym_parenthesized_expression] = STATE(1773),
    [sym__expression] = STATE(1773),
    [sym_yield_expression] = STATE(1773),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1773),
    [sym_jsx_fragment] = STATE(1773),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1773),
    [sym_anonymous_class] = STATE(1773),
    [sym_class] = STATE(1773),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1773),
    [sym_generator_function] = STATE(1773),
    [sym_call_expression] = STATE(1773),
    [sym_new_expression] = STATE(1773),
    [sym_await_expression] = STATE(1773),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1773),
    [sym_augmented_assignment_expression] = STATE(1773),
    [sym_ternary_expression] = STATE(1773),
    [sym_binary_expression] = STATE(1773),
    [sym_unary_expression] = STATE(1773),
    [sym_update_expression] = STATE(1773),
    [sym_string] = STATE(1773),
    [sym_template_string] = STATE(1773),
    [sym_regex] = STATE(1773),
    [sym_meta_property] = STATE(1773),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4248),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4250),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4250),
    [sym_false] = ACTIONS(4250),
    [sym_null] = ACTIONS(4250),
    [sym_undefined] = ACTIONS(4250),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1617] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(3712),
    [anon_sym_RBRACE] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1583),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_GT_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_PLUS] = ACTIONS(1595),
    [anon_sym_DASH] = ACTIONS(1595),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_LT_EQ] = ACTIONS(1597),
    [anon_sym_EQ_EQ] = ACTIONS(1575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1597),
    [anon_sym_BANG_EQ] = ACTIONS(1575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1597),
    [anon_sym_GT_EQ] = ACTIONS(1597),
    [anon_sym_instanceof] = ACTIONS(1597),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1618] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1619] = {
    [sym_parenthesized_expression] = STATE(1774),
    [sym__expression] = STATE(1774),
    [sym_yield_expression] = STATE(1774),
    [sym_object] = STATE(775),
    [sym_array] = STATE(776),
    [sym_jsx_element] = STATE(1774),
    [sym_jsx_fragment] = STATE(1774),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1774),
    [sym_anonymous_class] = STATE(1774),
    [sym_class] = STATE(1774),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1774),
    [sym_generator_function] = STATE(1774),
    [sym_call_expression] = STATE(1774),
    [sym_new_expression] = STATE(1774),
    [sym_await_expression] = STATE(1774),
    [sym_member_expression] = STATE(777),
    [sym_subscript_expression] = STATE(777),
    [sym_assignment_expression] = STATE(1774),
    [sym_augmented_assignment_expression] = STATE(1774),
    [sym_ternary_expression] = STATE(1774),
    [sym_binary_expression] = STATE(1774),
    [sym_unary_expression] = STATE(1774),
    [sym_update_expression] = STATE(1774),
    [sym_string] = STATE(1774),
    [sym_template_string] = STATE(1774),
    [sym_regex] = STATE(1774),
    [sym_meta_property] = STATE(1774),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(778),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1607),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_DASH_DASH] = ACTIONS(1613),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4252),
    [sym_identifier] = ACTIONS(1617),
    [sym_this] = ACTIONS(4254),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4254),
    [sym_false] = ACTIONS(4254),
    [sym_null] = ACTIONS(4254),
    [sym_undefined] = ACTIONS(4254),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(1621),
    [anon_sym_set] = ACTIONS(1621),
  },
  [1620] = {
    [sym_parenthesized_expression] = STATE(1775),
    [sym__expression] = STATE(1775),
    [sym_yield_expression] = STATE(1775),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1775),
    [sym_jsx_fragment] = STATE(1775),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1775),
    [sym_anonymous_class] = STATE(1775),
    [sym_class] = STATE(1775),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1775),
    [sym_generator_function] = STATE(1775),
    [sym_call_expression] = STATE(1775),
    [sym_new_expression] = STATE(1775),
    [sym_await_expression] = STATE(1775),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1775),
    [sym_augmented_assignment_expression] = STATE(1775),
    [sym_ternary_expression] = STATE(1775),
    [sym_binary_expression] = STATE(1775),
    [sym_unary_expression] = STATE(1775),
    [sym_update_expression] = STATE(1775),
    [sym_sequence_expression] = STATE(1776),
    [sym_string] = STATE(1775),
    [sym_template_string] = STATE(1775),
    [sym_regex] = STATE(1775),
    [sym_meta_property] = STATE(1775),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4256),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4258),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4258),
    [sym_false] = ACTIONS(4258),
    [sym_null] = ACTIONS(4258),
    [sym_undefined] = ACTIONS(4258),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1621] = {
    [sym_parenthesized_expression] = STATE(1777),
    [sym__expression] = STATE(1777),
    [sym_yield_expression] = STATE(1777),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1777),
    [sym_jsx_fragment] = STATE(1777),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1777),
    [sym_anonymous_class] = STATE(1777),
    [sym_class] = STATE(1777),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1777),
    [sym_generator_function] = STATE(1777),
    [sym_call_expression] = STATE(1777),
    [sym_new_expression] = STATE(1777),
    [sym_await_expression] = STATE(1777),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1777),
    [sym_augmented_assignment_expression] = STATE(1777),
    [sym_ternary_expression] = STATE(1777),
    [sym_binary_expression] = STATE(1777),
    [sym_unary_expression] = STATE(1777),
    [sym_update_expression] = STATE(1777),
    [sym_string] = STATE(1777),
    [sym_template_string] = STATE(1777),
    [sym_regex] = STATE(1777),
    [sym_meta_property] = STATE(1777),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4260),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4262),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4262),
    [sym_false] = ACTIONS(4262),
    [sym_null] = ACTIONS(4262),
    [sym_undefined] = ACTIONS(4262),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1622] = {
    [sym_parenthesized_expression] = STATE(1778),
    [sym__expression] = STATE(1778),
    [sym_yield_expression] = STATE(1778),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1778),
    [sym_jsx_fragment] = STATE(1778),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1778),
    [sym_anonymous_class] = STATE(1778),
    [sym_class] = STATE(1778),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1778),
    [sym_generator_function] = STATE(1778),
    [sym_call_expression] = STATE(1778),
    [sym_new_expression] = STATE(1778),
    [sym_await_expression] = STATE(1778),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1778),
    [sym_augmented_assignment_expression] = STATE(1778),
    [sym_ternary_expression] = STATE(1778),
    [sym_binary_expression] = STATE(1778),
    [sym_unary_expression] = STATE(1778),
    [sym_update_expression] = STATE(1778),
    [sym_sequence_expression] = STATE(1779),
    [sym_string] = STATE(1778),
    [sym_template_string] = STATE(1778),
    [sym_regex] = STATE(1778),
    [sym_meta_property] = STATE(1778),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4264),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4266),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4266),
    [sym_false] = ACTIONS(4266),
    [sym_null] = ACTIONS(4266),
    [sym_undefined] = ACTIONS(4266),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1623] = {
    [sym_parenthesized_expression] = STATE(1780),
    [sym__expression] = STATE(1780),
    [sym_yield_expression] = STATE(1780),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1780),
    [sym_jsx_fragment] = STATE(1780),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1780),
    [sym_anonymous_class] = STATE(1780),
    [sym_class] = STATE(1780),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1780),
    [sym_generator_function] = STATE(1780),
    [sym_call_expression] = STATE(1780),
    [sym_new_expression] = STATE(1780),
    [sym_await_expression] = STATE(1780),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1780),
    [sym_augmented_assignment_expression] = STATE(1780),
    [sym_ternary_expression] = STATE(1780),
    [sym_binary_expression] = STATE(1780),
    [sym_unary_expression] = STATE(1780),
    [sym_update_expression] = STATE(1780),
    [sym_string] = STATE(1780),
    [sym_template_string] = STATE(1780),
    [sym_regex] = STATE(1780),
    [sym_meta_property] = STATE(1780),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4268),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4270),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4270),
    [sym_false] = ACTIONS(4270),
    [sym_null] = ACTIONS(4270),
    [sym_undefined] = ACTIONS(4270),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1624] = {
    [sym_parenthesized_expression] = STATE(1781),
    [sym__expression] = STATE(1781),
    [sym_yield_expression] = STATE(1781),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1781),
    [sym_jsx_fragment] = STATE(1781),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1781),
    [sym_anonymous_class] = STATE(1781),
    [sym_class] = STATE(1781),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1781),
    [sym_generator_function] = STATE(1781),
    [sym_call_expression] = STATE(1781),
    [sym_new_expression] = STATE(1781),
    [sym_await_expression] = STATE(1781),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1781),
    [sym_augmented_assignment_expression] = STATE(1781),
    [sym_ternary_expression] = STATE(1781),
    [sym_binary_expression] = STATE(1781),
    [sym_unary_expression] = STATE(1781),
    [sym_update_expression] = STATE(1781),
    [sym_sequence_expression] = STATE(1782),
    [sym_string] = STATE(1781),
    [sym_template_string] = STATE(1781),
    [sym_regex] = STATE(1781),
    [sym_meta_property] = STATE(1781),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4272),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4274),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4274),
    [sym_false] = ACTIONS(4274),
    [sym_null] = ACTIONS(4274),
    [sym_undefined] = ACTIONS(4274),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1625] = {
    [sym_parenthesized_expression] = STATE(1783),
    [sym__expression] = STATE(1783),
    [sym_yield_expression] = STATE(1783),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1783),
    [sym_jsx_fragment] = STATE(1783),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1783),
    [sym_anonymous_class] = STATE(1783),
    [sym_class] = STATE(1783),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1783),
    [sym_generator_function] = STATE(1783),
    [sym_call_expression] = STATE(1783),
    [sym_new_expression] = STATE(1783),
    [sym_await_expression] = STATE(1783),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1783),
    [sym_augmented_assignment_expression] = STATE(1783),
    [sym_ternary_expression] = STATE(1783),
    [sym_binary_expression] = STATE(1783),
    [sym_unary_expression] = STATE(1783),
    [sym_update_expression] = STATE(1783),
    [sym_string] = STATE(1783),
    [sym_template_string] = STATE(1783),
    [sym_regex] = STATE(1783),
    [sym_meta_property] = STATE(1783),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4276),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4278),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4278),
    [sym_false] = ACTIONS(4278),
    [sym_null] = ACTIONS(4278),
    [sym_undefined] = ACTIONS(4278),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1626] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4280),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1627] = {
    [anon_sym_RPAREN] = ACTIONS(4280),
    [sym_comment] = ACTIONS(78),
  },
  [1628] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4282),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1629] = {
    [sym_export_statement] = STATE(1500),
    [sym__declaration] = STATE(1500),
    [sym_import_statement] = STATE(1500),
    [sym_expression_statement] = STATE(1500),
    [sym_variable_declaration] = STATE(1500),
    [sym_lexical_declaration] = STATE(1500),
    [sym_statement_block] = STATE(1500),
    [sym_if_statement] = STATE(1500),
    [sym_switch_statement] = STATE(1500),
    [sym_for_statement] = STATE(1500),
    [sym_for_in_statement] = STATE(1500),
    [sym_for_of_statement] = STATE(1500),
    [sym_while_statement] = STATE(1500),
    [sym_do_statement] = STATE(1500),
    [sym_try_statement] = STATE(1500),
    [sym_with_statement] = STATE(1500),
    [sym_break_statement] = STATE(1500),
    [sym_continue_statement] = STATE(1500),
    [sym_debugger_statement] = STATE(1500),
    [sym_return_statement] = STATE(1500),
    [sym_throw_statement] = STATE(1500),
    [sym_empty_statement] = STATE(1500),
    [sym_labeled_statement] = STATE(1500),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1630] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4284),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1631] = {
    [anon_sym_RPAREN] = ACTIONS(4284),
    [sym_comment] = ACTIONS(78),
  },
  [1632] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4286),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1633] = {
    [anon_sym_RPAREN] = ACTIONS(4286),
    [sym_comment] = ACTIONS(78),
  },
  [1634] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4288),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1635] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4290),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1636] = {
    [anon_sym_RPAREN] = ACTIONS(4290),
    [sym_comment] = ACTIONS(78),
  },
  [1637] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4292),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1638] = {
    [anon_sym_of] = ACTIONS(4294),
    [sym_comment] = ACTIONS(78),
  },
  [1639] = {
    [anon_sym_of] = ACTIONS(4296),
    [sym_comment] = ACTIONS(78),
  },
  [1640] = {
    [anon_sym_of] = ACTIONS(4298),
    [sym_comment] = ACTIONS(78),
  },
  [1641] = {
    [sym_export_statement] = STATE(1799),
    [sym__declaration] = STATE(1799),
    [sym_import_statement] = STATE(1799),
    [sym_expression_statement] = STATE(1799),
    [sym_variable_declaration] = STATE(1799),
    [sym_lexical_declaration] = STATE(1799),
    [sym_statement_block] = STATE(1799),
    [sym_if_statement] = STATE(1799),
    [sym_switch_statement] = STATE(1799),
    [sym_for_statement] = STATE(1799),
    [sym_for_in_statement] = STATE(1799),
    [sym_for_of_statement] = STATE(1799),
    [sym_while_statement] = STATE(1799),
    [sym_do_statement] = STATE(1799),
    [sym_try_statement] = STATE(1799),
    [sym_with_statement] = STATE(1799),
    [sym_break_statement] = STATE(1799),
    [sym_continue_statement] = STATE(1799),
    [sym_debugger_statement] = STATE(1799),
    [sym_return_statement] = STATE(1799),
    [sym_throw_statement] = STATE(1799),
    [sym_empty_statement] = STATE(1799),
    [sym_labeled_statement] = STATE(1799),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1642] = {
    [sym_expression_statement] = STATE(1803),
    [sym_variable_declaration] = STATE(1803),
    [sym_lexical_declaration] = STATE(1803),
    [sym_empty_statement] = STATE(1803),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(1804),
    [sym_array] = STATE(1805),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_var] = ACTIONS(4310),
    [anon_sym_let] = ACTIONS(4312),
    [anon_sym_const] = ACTIONS(4312),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4314),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1643] = {
    [anon_sym_LPAREN] = ACTIONS(4316),
    [sym_comment] = ACTIONS(78),
  },
  [1644] = {
    [sym_export_statement] = STATE(485),
    [sym__declaration] = STATE(485),
    [sym_import_statement] = STATE(485),
    [sym_expression_statement] = STATE(485),
    [sym_variable_declaration] = STATE(485),
    [sym_lexical_declaration] = STATE(485),
    [sym_statement_block] = STATE(485),
    [sym_if_statement] = STATE(485),
    [sym_switch_statement] = STATE(485),
    [sym_for_statement] = STATE(485),
    [sym_for_in_statement] = STATE(485),
    [sym_for_of_statement] = STATE(485),
    [sym_while_statement] = STATE(485),
    [sym_do_statement] = STATE(485),
    [sym_try_statement] = STATE(485),
    [sym_with_statement] = STATE(485),
    [sym_break_statement] = STATE(485),
    [sym_continue_statement] = STATE(485),
    [sym_debugger_statement] = STATE(485),
    [sym_return_statement] = STATE(485),
    [sym_throw_statement] = STATE(485),
    [sym_empty_statement] = STATE(485),
    [sym_labeled_statement] = STATE(485),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1645] = {
    [sym_export_statement] = STATE(502),
    [sym__declaration] = STATE(502),
    [sym_import_statement] = STATE(502),
    [sym_expression_statement] = STATE(502),
    [sym_variable_declaration] = STATE(502),
    [sym_lexical_declaration] = STATE(502),
    [sym_statement_block] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_switch_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_for_in_statement] = STATE(502),
    [sym_for_of_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_do_statement] = STATE(502),
    [sym_try_statement] = STATE(502),
    [sym_with_statement] = STATE(502),
    [sym_break_statement] = STATE(502),
    [sym_continue_statement] = STATE(502),
    [sym_debugger_statement] = STATE(502),
    [sym_return_statement] = STATE(502),
    [sym_throw_statement] = STATE(502),
    [sym_empty_statement] = STATE(502),
    [sym_labeled_statement] = STATE(502),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1646] = {
    [sym_export_statement] = STATE(619),
    [sym__declaration] = STATE(619),
    [sym_import_statement] = STATE(619),
    [sym_expression_statement] = STATE(619),
    [sym_variable_declaration] = STATE(619),
    [sym_lexical_declaration] = STATE(619),
    [sym_statement_block] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(619),
    [sym_for_in_statement] = STATE(619),
    [sym_for_of_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_do_statement] = STATE(619),
    [sym_try_statement] = STATE(619),
    [sym_with_statement] = STATE(619),
    [sym_break_statement] = STATE(619),
    [sym_continue_statement] = STATE(619),
    [sym_debugger_statement] = STATE(619),
    [sym_return_statement] = STATE(619),
    [sym_throw_statement] = STATE(619),
    [sym_empty_statement] = STATE(619),
    [sym_labeled_statement] = STATE(619),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1647] = {
    [sym_export_statement] = STATE(1647),
    [sym__declaration] = STATE(1647),
    [sym_import_statement] = STATE(1647),
    [sym_expression_statement] = STATE(1647),
    [sym_variable_declaration] = STATE(1647),
    [sym_lexical_declaration] = STATE(1647),
    [sym_statement_block] = STATE(1647),
    [sym_if_statement] = STATE(1647),
    [sym_switch_statement] = STATE(1647),
    [sym_for_statement] = STATE(1647),
    [sym_for_in_statement] = STATE(1647),
    [sym_for_of_statement] = STATE(1647),
    [sym_while_statement] = STATE(1647),
    [sym_do_statement] = STATE(1647),
    [sym_try_statement] = STATE(1647),
    [sym_with_statement] = STATE(1647),
    [sym_break_statement] = STATE(1647),
    [sym_continue_statement] = STATE(1647),
    [sym_debugger_statement] = STATE(1647),
    [sym_return_statement] = STATE(1647),
    [sym_throw_statement] = STATE(1647),
    [sym_empty_statement] = STATE(1647),
    [sym_labeled_statement] = STATE(1647),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(1647),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_default] = ACTIONS(4318),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_import] = ACTIONS(1277),
    [anon_sym_var] = ACTIONS(1280),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1283),
    [anon_sym_if] = ACTIONS(4320),
    [anon_sym_switch] = ACTIONS(1289),
    [anon_sym_for] = ACTIONS(4323),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_await] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(4326),
    [anon_sym_do] = ACTIONS(1304),
    [anon_sym_try] = ACTIONS(1307),
    [anon_sym_with] = ACTIONS(4329),
    [anon_sym_break] = ACTIONS(1313),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_debugger] = ACTIONS(1319),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(1328),
    [anon_sym_case] = ACTIONS(4318),
    [anon_sym_yield] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1340),
    [anon_sym_class] = ACTIONS(1343),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_function] = ACTIONS(1349),
    [anon_sym_EQ_GT] = ACTIONS(1352),
    [anon_sym_new] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1358),
    [anon_sym_DASH] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_TILDE] = ACTIONS(1361),
    [anon_sym_typeof] = ACTIONS(1358),
    [anon_sym_void] = ACTIONS(1358),
    [anon_sym_delete] = ACTIONS(1358),
    [anon_sym_PLUS_PLUS] = ACTIONS(1364),
    [anon_sym_DASH_DASH] = ACTIONS(1364),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1370),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1373),
    [sym_number] = ACTIONS(1376),
    [sym_identifier] = ACTIONS(4332),
    [sym_this] = ACTIONS(1382),
    [sym_super] = ACTIONS(1385),
    [sym_true] = ACTIONS(1382),
    [sym_false] = ACTIONS(1382),
    [sym_null] = ACTIONS(1382),
    [sym_undefined] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1388),
    [anon_sym_get] = ACTIONS(1391),
    [anon_sym_set] = ACTIONS(1391),
  },
  [1648] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1649] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1650] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1651] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1807),
    [sym__expression] = STATE(1807),
    [sym_yield_expression] = STATE(1807),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1807),
    [sym_jsx_fragment] = STATE(1807),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1807),
    [sym_anonymous_class] = STATE(1807),
    [sym_class] = STATE(1807),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1807),
    [sym_generator_function] = STATE(1807),
    [sym_call_expression] = STATE(1807),
    [sym_new_expression] = STATE(1807),
    [sym_await_expression] = STATE(1807),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1807),
    [sym_augmented_assignment_expression] = STATE(1807),
    [sym_ternary_expression] = STATE(1807),
    [sym_binary_expression] = STATE(1807),
    [sym_unary_expression] = STATE(1807),
    [sym_update_expression] = STATE(1807),
    [sym_string] = STATE(1807),
    [sym_template_string] = STATE(1807),
    [sym_regex] = STATE(1807),
    [sym_meta_property] = STATE(1807),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4335),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(4337),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4337),
    [sym_false] = ACTIONS(4337),
    [sym_null] = ACTIONS(4337),
    [sym_undefined] = ACTIONS(4337),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1652] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1653] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1654] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(3413),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(2261),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1655] = {
    [sym_export_statement] = STATE(1647),
    [sym__declaration] = STATE(1647),
    [sym_import_statement] = STATE(1647),
    [sym_expression_statement] = STATE(1647),
    [sym_variable_declaration] = STATE(1647),
    [sym_lexical_declaration] = STATE(1647),
    [sym_statement_block] = STATE(1647),
    [sym_if_statement] = STATE(1647),
    [sym_switch_statement] = STATE(1647),
    [sym_for_statement] = STATE(1647),
    [sym_for_in_statement] = STATE(1647),
    [sym_for_of_statement] = STATE(1647),
    [sym_while_statement] = STATE(1647),
    [sym_do_statement] = STATE(1647),
    [sym_try_statement] = STATE(1647),
    [sym_with_statement] = STATE(1647),
    [sym_break_statement] = STATE(1647),
    [sym_continue_statement] = STATE(1647),
    [sym_debugger_statement] = STATE(1647),
    [sym_return_statement] = STATE(1647),
    [sym_throw_statement] = STATE(1647),
    [sym_empty_statement] = STATE(1647),
    [sym_labeled_statement] = STATE(1647),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_program_repeat1] = STATE(1647),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_default] = ACTIONS(4339),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_RBRACE] = ACTIONS(4341),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_case] = ACTIONS(4339),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1656] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(4343),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1657] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1658] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1659] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1660] = {
    [sym_export_statement] = STATE(1809),
    [sym__declaration] = STATE(1809),
    [sym_import_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_variable_declaration] = STATE(1809),
    [sym_lexical_declaration] = STATE(1809),
    [sym_statement_block] = STATE(1809),
    [sym_if_statement] = STATE(1809),
    [sym_switch_statement] = STATE(1809),
    [sym_for_statement] = STATE(1809),
    [sym_for_in_statement] = STATE(1809),
    [sym_for_of_statement] = STATE(1809),
    [sym_while_statement] = STATE(1809),
    [sym_do_statement] = STATE(1809),
    [sym_try_statement] = STATE(1809),
    [sym_with_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_debugger_statement] = STATE(1809),
    [sym_return_statement] = STATE(1809),
    [sym_throw_statement] = STATE(1809),
    [sym_empty_statement] = STATE(1809),
    [sym_labeled_statement] = STATE(1809),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1661] = {
    [sym_export_statement] = STATE(1810),
    [sym__declaration] = STATE(1810),
    [sym_import_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_variable_declaration] = STATE(1810),
    [sym_lexical_declaration] = STATE(1810),
    [sym_statement_block] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_for_in_statement] = STATE(1810),
    [sym_for_of_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_with_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_debugger_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_throw_statement] = STATE(1810),
    [sym_empty_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1662] = {
    [sym_export_statement] = STATE(1811),
    [sym__declaration] = STATE(1811),
    [sym_import_statement] = STATE(1811),
    [sym_expression_statement] = STATE(1811),
    [sym_variable_declaration] = STATE(1811),
    [sym_lexical_declaration] = STATE(1811),
    [sym_statement_block] = STATE(1811),
    [sym_if_statement] = STATE(1811),
    [sym_switch_statement] = STATE(1811),
    [sym_for_statement] = STATE(1811),
    [sym_for_in_statement] = STATE(1811),
    [sym_for_of_statement] = STATE(1811),
    [sym_while_statement] = STATE(1811),
    [sym_do_statement] = STATE(1811),
    [sym_try_statement] = STATE(1811),
    [sym_with_statement] = STATE(1811),
    [sym_break_statement] = STATE(1811),
    [sym_continue_statement] = STATE(1811),
    [sym_debugger_statement] = STATE(1811),
    [sym_return_statement] = STATE(1811),
    [sym_throw_statement] = STATE(1811),
    [sym_empty_statement] = STATE(1811),
    [sym_labeled_statement] = STATE(1811),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1663] = {
    [sym_export_statement] = STATE(1812),
    [sym__declaration] = STATE(1812),
    [sym_import_statement] = STATE(1812),
    [sym_expression_statement] = STATE(1812),
    [sym_variable_declaration] = STATE(1812),
    [sym_lexical_declaration] = STATE(1812),
    [sym_statement_block] = STATE(1812),
    [sym_if_statement] = STATE(1812),
    [sym_switch_statement] = STATE(1812),
    [sym_for_statement] = STATE(1812),
    [sym_for_in_statement] = STATE(1812),
    [sym_for_of_statement] = STATE(1812),
    [sym_while_statement] = STATE(1812),
    [sym_do_statement] = STATE(1812),
    [sym_try_statement] = STATE(1812),
    [sym_with_statement] = STATE(1812),
    [sym_break_statement] = STATE(1812),
    [sym_continue_statement] = STATE(1812),
    [sym_debugger_statement] = STATE(1812),
    [sym_return_statement] = STATE(1812),
    [sym_throw_statement] = STATE(1812),
    [sym_empty_statement] = STATE(1812),
    [sym_labeled_statement] = STATE(1812),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1664] = {
    [sym_export_statement] = STATE(1813),
    [sym__declaration] = STATE(1813),
    [sym_import_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_variable_declaration] = STATE(1813),
    [sym_lexical_declaration] = STATE(1813),
    [sym_statement_block] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_for_in_statement] = STATE(1813),
    [sym_for_of_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_with_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_debugger_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_throw_statement] = STATE(1813),
    [sym_empty_statement] = STATE(1813),
    [sym_labeled_statement] = STATE(1813),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1665] = {
    [sym_export_statement] = STATE(1814),
    [sym__declaration] = STATE(1814),
    [sym_import_statement] = STATE(1814),
    [sym_expression_statement] = STATE(1814),
    [sym_variable_declaration] = STATE(1814),
    [sym_lexical_declaration] = STATE(1814),
    [sym_statement_block] = STATE(1814),
    [sym_if_statement] = STATE(1814),
    [sym_switch_statement] = STATE(1814),
    [sym_for_statement] = STATE(1814),
    [sym_for_in_statement] = STATE(1814),
    [sym_for_of_statement] = STATE(1814),
    [sym_while_statement] = STATE(1814),
    [sym_do_statement] = STATE(1814),
    [sym_try_statement] = STATE(1814),
    [sym_with_statement] = STATE(1814),
    [sym_break_statement] = STATE(1814),
    [sym_continue_statement] = STATE(1814),
    [sym_debugger_statement] = STATE(1814),
    [sym_return_statement] = STATE(1814),
    [sym_throw_statement] = STATE(1814),
    [sym_empty_statement] = STATE(1814),
    [sym_labeled_statement] = STATE(1814),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1666] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2129),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2129),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(2129),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1667] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2131),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2131),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(2131),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1668] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2135),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(2135),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1669] = {
    [sym_statement_block] = STATE(975),
    [sym_parenthesized_expression] = STATE(1815),
    [sym__expression] = STATE(1815),
    [sym_yield_expression] = STATE(1815),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1815),
    [sym_jsx_fragment] = STATE(1815),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1815),
    [sym_anonymous_class] = STATE(1815),
    [sym_class] = STATE(1815),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1815),
    [sym_generator_function] = STATE(1815),
    [sym_call_expression] = STATE(1815),
    [sym_new_expression] = STATE(1815),
    [sym_await_expression] = STATE(1815),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1815),
    [sym_augmented_assignment_expression] = STATE(1815),
    [sym_ternary_expression] = STATE(1815),
    [sym_binary_expression] = STATE(1815),
    [sym_unary_expression] = STATE(1815),
    [sym_update_expression] = STATE(1815),
    [sym_string] = STATE(1815),
    [sym_template_string] = STATE(1815),
    [sym_regex] = STATE(1815),
    [sym_meta_property] = STATE(1815),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4345),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4347),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4347),
    [sym_false] = ACTIONS(4347),
    [sym_null] = ACTIONS(4347),
    [sym_undefined] = ACTIONS(4347),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1670] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1671] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1672] = {
    [ts_builtin_sym_end] = ACTIONS(4349),
    [anon_sym_export] = ACTIONS(4351),
    [anon_sym_default] = ACTIONS(4351),
    [anon_sym_LBRACE] = ACTIONS(4349),
    [anon_sym_RBRACE] = ACTIONS(4349),
    [anon_sym_import] = ACTIONS(4351),
    [anon_sym_var] = ACTIONS(4351),
    [anon_sym_let] = ACTIONS(4351),
    [anon_sym_const] = ACTIONS(4351),
    [anon_sym_if] = ACTIONS(4351),
    [anon_sym_else] = ACTIONS(4351),
    [anon_sym_switch] = ACTIONS(4351),
    [anon_sym_for] = ACTIONS(4351),
    [anon_sym_LPAREN] = ACTIONS(4349),
    [anon_sym_await] = ACTIONS(4351),
    [anon_sym_while] = ACTIONS(4351),
    [anon_sym_do] = ACTIONS(4351),
    [anon_sym_try] = ACTIONS(4351),
    [anon_sym_with] = ACTIONS(4351),
    [anon_sym_break] = ACTIONS(4351),
    [anon_sym_continue] = ACTIONS(4351),
    [anon_sym_debugger] = ACTIONS(4351),
    [anon_sym_return] = ACTIONS(4351),
    [anon_sym_throw] = ACTIONS(4351),
    [anon_sym_SEMI] = ACTIONS(4349),
    [anon_sym_case] = ACTIONS(4351),
    [anon_sym_yield] = ACTIONS(4351),
    [anon_sym_LBRACK] = ACTIONS(4349),
    [anon_sym_LT] = ACTIONS(4349),
    [anon_sym_SLASH] = ACTIONS(4351),
    [anon_sym_class] = ACTIONS(4351),
    [anon_sym_async] = ACTIONS(4351),
    [anon_sym_function] = ACTIONS(4351),
    [anon_sym_EQ_GT] = ACTIONS(4349),
    [anon_sym_new] = ACTIONS(4351),
    [anon_sym_PLUS] = ACTIONS(4351),
    [anon_sym_DASH] = ACTIONS(4351),
    [anon_sym_BANG] = ACTIONS(4349),
    [anon_sym_TILDE] = ACTIONS(4349),
    [anon_sym_typeof] = ACTIONS(4351),
    [anon_sym_void] = ACTIONS(4351),
    [anon_sym_delete] = ACTIONS(4351),
    [anon_sym_PLUS_PLUS] = ACTIONS(4349),
    [anon_sym_DASH_DASH] = ACTIONS(4349),
    [anon_sym_DQUOTE] = ACTIONS(4349),
    [anon_sym_SQUOTE] = ACTIONS(4349),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4349),
    [sym_number] = ACTIONS(4349),
    [sym_identifier] = ACTIONS(4351),
    [sym_this] = ACTIONS(4351),
    [sym_super] = ACTIONS(4351),
    [sym_true] = ACTIONS(4351),
    [sym_false] = ACTIONS(4351),
    [sym_null] = ACTIONS(4351),
    [sym_undefined] = ACTIONS(4351),
    [anon_sym_AT] = ACTIONS(4349),
    [anon_sym_get] = ACTIONS(4351),
    [anon_sym_set] = ACTIONS(4351),
  },
  [1673] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(4353),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1674] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1675] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1676] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1677] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1678] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1679] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2135),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1680] = {
    [sym_statement_block] = STATE(1240),
    [sym_parenthesized_expression] = STATE(1817),
    [sym__expression] = STATE(1817),
    [sym_yield_expression] = STATE(1817),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1817),
    [sym_jsx_fragment] = STATE(1817),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1817),
    [sym_anonymous_class] = STATE(1817),
    [sym_class] = STATE(1817),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1817),
    [sym_generator_function] = STATE(1817),
    [sym_call_expression] = STATE(1817),
    [sym_new_expression] = STATE(1817),
    [sym_await_expression] = STATE(1817),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1817),
    [sym_augmented_assignment_expression] = STATE(1817),
    [sym_ternary_expression] = STATE(1817),
    [sym_binary_expression] = STATE(1817),
    [sym_unary_expression] = STATE(1817),
    [sym_update_expression] = STATE(1817),
    [sym_string] = STATE(1817),
    [sym_template_string] = STATE(1817),
    [sym_regex] = STATE(1817),
    [sym_meta_property] = STATE(1817),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4355),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4357),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4357),
    [sym_false] = ACTIONS(4357),
    [sym_null] = ACTIONS(4357),
    [sym_undefined] = ACTIONS(4357),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1681] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1682] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2235),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1683] = {
    [ts_builtin_sym_end] = ACTIONS(4359),
    [anon_sym_export] = ACTIONS(4361),
    [anon_sym_default] = ACTIONS(4361),
    [anon_sym_LBRACE] = ACTIONS(4359),
    [anon_sym_RBRACE] = ACTIONS(4359),
    [anon_sym_import] = ACTIONS(4361),
    [anon_sym_var] = ACTIONS(4361),
    [anon_sym_let] = ACTIONS(4361),
    [anon_sym_const] = ACTIONS(4361),
    [anon_sym_if] = ACTIONS(4361),
    [anon_sym_else] = ACTIONS(4361),
    [anon_sym_switch] = ACTIONS(4361),
    [anon_sym_for] = ACTIONS(4361),
    [anon_sym_LPAREN] = ACTIONS(4359),
    [anon_sym_await] = ACTIONS(4361),
    [anon_sym_while] = ACTIONS(4361),
    [anon_sym_do] = ACTIONS(4361),
    [anon_sym_try] = ACTIONS(4361),
    [anon_sym_with] = ACTIONS(4361),
    [anon_sym_break] = ACTIONS(4361),
    [anon_sym_continue] = ACTIONS(4361),
    [anon_sym_debugger] = ACTIONS(4361),
    [anon_sym_return] = ACTIONS(4361),
    [anon_sym_throw] = ACTIONS(4361),
    [anon_sym_SEMI] = ACTIONS(4359),
    [anon_sym_case] = ACTIONS(4361),
    [anon_sym_yield] = ACTIONS(4361),
    [anon_sym_LBRACK] = ACTIONS(4359),
    [anon_sym_LT] = ACTIONS(4359),
    [anon_sym_SLASH] = ACTIONS(4361),
    [anon_sym_class] = ACTIONS(4361),
    [anon_sym_async] = ACTIONS(4361),
    [anon_sym_function] = ACTIONS(4361),
    [anon_sym_EQ_GT] = ACTIONS(4359),
    [anon_sym_new] = ACTIONS(4361),
    [anon_sym_PLUS] = ACTIONS(4361),
    [anon_sym_DASH] = ACTIONS(4361),
    [anon_sym_BANG] = ACTIONS(4359),
    [anon_sym_TILDE] = ACTIONS(4359),
    [anon_sym_typeof] = ACTIONS(4361),
    [anon_sym_void] = ACTIONS(4361),
    [anon_sym_delete] = ACTIONS(4361),
    [anon_sym_PLUS_PLUS] = ACTIONS(4359),
    [anon_sym_DASH_DASH] = ACTIONS(4359),
    [anon_sym_DQUOTE] = ACTIONS(4359),
    [anon_sym_SQUOTE] = ACTIONS(4359),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4359),
    [sym_number] = ACTIONS(4359),
    [sym_identifier] = ACTIONS(4361),
    [sym_this] = ACTIONS(4361),
    [sym_super] = ACTIONS(4361),
    [sym_true] = ACTIONS(4361),
    [sym_false] = ACTIONS(4361),
    [sym_null] = ACTIONS(4361),
    [sym_undefined] = ACTIONS(4361),
    [anon_sym_AT] = ACTIONS(4359),
    [anon_sym_get] = ACTIONS(4361),
    [anon_sym_set] = ACTIONS(4361),
  },
  [1684] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(4363),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1685] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1686] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1687] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1688] = {
    [ts_builtin_sym_end] = ACTIONS(4365),
    [anon_sym_export] = ACTIONS(4367),
    [anon_sym_default] = ACTIONS(4367),
    [anon_sym_LBRACE] = ACTIONS(4365),
    [anon_sym_RBRACE] = ACTIONS(4365),
    [anon_sym_import] = ACTIONS(4367),
    [anon_sym_var] = ACTIONS(4367),
    [anon_sym_let] = ACTIONS(4367),
    [anon_sym_const] = ACTIONS(4367),
    [anon_sym_if] = ACTIONS(4367),
    [anon_sym_else] = ACTIONS(4367),
    [anon_sym_switch] = ACTIONS(4367),
    [anon_sym_for] = ACTIONS(4367),
    [anon_sym_LPAREN] = ACTIONS(4365),
    [anon_sym_await] = ACTIONS(4367),
    [anon_sym_while] = ACTIONS(4367),
    [anon_sym_do] = ACTIONS(4367),
    [anon_sym_try] = ACTIONS(4367),
    [anon_sym_with] = ACTIONS(4367),
    [anon_sym_break] = ACTIONS(4367),
    [anon_sym_continue] = ACTIONS(4367),
    [anon_sym_debugger] = ACTIONS(4367),
    [anon_sym_return] = ACTIONS(4367),
    [anon_sym_throw] = ACTIONS(4367),
    [anon_sym_SEMI] = ACTIONS(4365),
    [anon_sym_case] = ACTIONS(4367),
    [anon_sym_yield] = ACTIONS(4367),
    [anon_sym_LBRACK] = ACTIONS(4365),
    [anon_sym_LT] = ACTIONS(4365),
    [anon_sym_SLASH] = ACTIONS(4367),
    [anon_sym_class] = ACTIONS(4367),
    [anon_sym_async] = ACTIONS(4367),
    [anon_sym_function] = ACTIONS(4367),
    [anon_sym_EQ_GT] = ACTIONS(4365),
    [anon_sym_new] = ACTIONS(4367),
    [anon_sym_PLUS] = ACTIONS(4367),
    [anon_sym_DASH] = ACTIONS(4367),
    [anon_sym_BANG] = ACTIONS(4365),
    [anon_sym_TILDE] = ACTIONS(4365),
    [anon_sym_typeof] = ACTIONS(4367),
    [anon_sym_void] = ACTIONS(4367),
    [anon_sym_delete] = ACTIONS(4367),
    [anon_sym_PLUS_PLUS] = ACTIONS(4365),
    [anon_sym_DASH_DASH] = ACTIONS(4365),
    [anon_sym_DQUOTE] = ACTIONS(4365),
    [anon_sym_SQUOTE] = ACTIONS(4365),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4365),
    [sym_number] = ACTIONS(4365),
    [sym_identifier] = ACTIONS(4367),
    [sym_this] = ACTIONS(4367),
    [sym_super] = ACTIONS(4367),
    [sym_true] = ACTIONS(4367),
    [sym_false] = ACTIONS(4367),
    [sym_null] = ACTIONS(4367),
    [sym_undefined] = ACTIONS(4367),
    [anon_sym_AT] = ACTIONS(4365),
    [anon_sym_get] = ACTIONS(4367),
    [anon_sym_set] = ACTIONS(4367),
  },
  [1689] = {
    [ts_builtin_sym_end] = ACTIONS(4369),
    [anon_sym_export] = ACTIONS(4371),
    [anon_sym_default] = ACTIONS(4371),
    [anon_sym_LBRACE] = ACTIONS(4369),
    [anon_sym_RBRACE] = ACTIONS(4369),
    [anon_sym_import] = ACTIONS(4371),
    [anon_sym_var] = ACTIONS(4371),
    [anon_sym_let] = ACTIONS(4371),
    [anon_sym_const] = ACTIONS(4371),
    [anon_sym_if] = ACTIONS(4371),
    [anon_sym_else] = ACTIONS(4371),
    [anon_sym_switch] = ACTIONS(4371),
    [anon_sym_for] = ACTIONS(4371),
    [anon_sym_LPAREN] = ACTIONS(4369),
    [anon_sym_await] = ACTIONS(4371),
    [anon_sym_while] = ACTIONS(4371),
    [anon_sym_do] = ACTIONS(4371),
    [anon_sym_try] = ACTIONS(4371),
    [anon_sym_with] = ACTIONS(4371),
    [anon_sym_break] = ACTIONS(4371),
    [anon_sym_continue] = ACTIONS(4371),
    [anon_sym_debugger] = ACTIONS(4371),
    [anon_sym_return] = ACTIONS(4371),
    [anon_sym_throw] = ACTIONS(4371),
    [anon_sym_SEMI] = ACTIONS(4369),
    [anon_sym_case] = ACTIONS(4371),
    [anon_sym_yield] = ACTIONS(4371),
    [anon_sym_LBRACK] = ACTIONS(4369),
    [anon_sym_LT] = ACTIONS(4369),
    [anon_sym_SLASH] = ACTIONS(4371),
    [anon_sym_class] = ACTIONS(4371),
    [anon_sym_async] = ACTIONS(4371),
    [anon_sym_function] = ACTIONS(4371),
    [anon_sym_EQ_GT] = ACTIONS(4369),
    [anon_sym_new] = ACTIONS(4371),
    [anon_sym_PLUS] = ACTIONS(4371),
    [anon_sym_DASH] = ACTIONS(4371),
    [anon_sym_BANG] = ACTIONS(4369),
    [anon_sym_TILDE] = ACTIONS(4369),
    [anon_sym_typeof] = ACTIONS(4371),
    [anon_sym_void] = ACTIONS(4371),
    [anon_sym_delete] = ACTIONS(4371),
    [anon_sym_PLUS_PLUS] = ACTIONS(4369),
    [anon_sym_DASH_DASH] = ACTIONS(4369),
    [anon_sym_DQUOTE] = ACTIONS(4369),
    [anon_sym_SQUOTE] = ACTIONS(4369),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4369),
    [sym_number] = ACTIONS(4369),
    [sym_identifier] = ACTIONS(4371),
    [sym_this] = ACTIONS(4371),
    [sym_super] = ACTIONS(4371),
    [sym_true] = ACTIONS(4371),
    [sym_false] = ACTIONS(4371),
    [sym_null] = ACTIONS(4371),
    [sym_undefined] = ACTIONS(4371),
    [anon_sym_AT] = ACTIONS(4369),
    [anon_sym_get] = ACTIONS(4371),
    [anon_sym_set] = ACTIONS(4371),
  },
  [1690] = {
    [ts_builtin_sym_end] = ACTIONS(4373),
    [anon_sym_export] = ACTIONS(4375),
    [anon_sym_default] = ACTIONS(4375),
    [anon_sym_LBRACE] = ACTIONS(4373),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_import] = ACTIONS(4375),
    [anon_sym_var] = ACTIONS(4375),
    [anon_sym_let] = ACTIONS(4375),
    [anon_sym_const] = ACTIONS(4375),
    [anon_sym_if] = ACTIONS(4375),
    [anon_sym_else] = ACTIONS(4375),
    [anon_sym_switch] = ACTIONS(4375),
    [anon_sym_for] = ACTIONS(4375),
    [anon_sym_LPAREN] = ACTIONS(4373),
    [anon_sym_await] = ACTIONS(4375),
    [anon_sym_while] = ACTIONS(4375),
    [anon_sym_do] = ACTIONS(4375),
    [anon_sym_try] = ACTIONS(4375),
    [anon_sym_with] = ACTIONS(4375),
    [anon_sym_break] = ACTIONS(4375),
    [anon_sym_continue] = ACTIONS(4375),
    [anon_sym_debugger] = ACTIONS(4375),
    [anon_sym_return] = ACTIONS(4375),
    [anon_sym_throw] = ACTIONS(4375),
    [anon_sym_SEMI] = ACTIONS(4373),
    [anon_sym_case] = ACTIONS(4375),
    [anon_sym_yield] = ACTIONS(4375),
    [anon_sym_LBRACK] = ACTIONS(4373),
    [anon_sym_LT] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(4375),
    [anon_sym_class] = ACTIONS(4375),
    [anon_sym_async] = ACTIONS(4375),
    [anon_sym_function] = ACTIONS(4375),
    [anon_sym_EQ_GT] = ACTIONS(4373),
    [anon_sym_new] = ACTIONS(4375),
    [anon_sym_PLUS] = ACTIONS(4375),
    [anon_sym_DASH] = ACTIONS(4375),
    [anon_sym_BANG] = ACTIONS(4373),
    [anon_sym_TILDE] = ACTIONS(4373),
    [anon_sym_typeof] = ACTIONS(4375),
    [anon_sym_void] = ACTIONS(4375),
    [anon_sym_delete] = ACTIONS(4375),
    [anon_sym_PLUS_PLUS] = ACTIONS(4373),
    [anon_sym_DASH_DASH] = ACTIONS(4373),
    [anon_sym_DQUOTE] = ACTIONS(4373),
    [anon_sym_SQUOTE] = ACTIONS(4373),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4373),
    [sym_number] = ACTIONS(4373),
    [sym_identifier] = ACTIONS(4375),
    [sym_this] = ACTIONS(4375),
    [sym_super] = ACTIONS(4375),
    [sym_true] = ACTIONS(4375),
    [sym_false] = ACTIONS(4375),
    [sym_null] = ACTIONS(4375),
    [sym_undefined] = ACTIONS(4375),
    [anon_sym_AT] = ACTIONS(4373),
    [anon_sym_get] = ACTIONS(4375),
    [anon_sym_set] = ACTIONS(4375),
  },
  [1691] = {
    [ts_builtin_sym_end] = ACTIONS(4377),
    [anon_sym_export] = ACTIONS(4379),
    [anon_sym_default] = ACTIONS(4379),
    [anon_sym_LBRACE] = ACTIONS(4377),
    [anon_sym_RBRACE] = ACTIONS(4377),
    [anon_sym_import] = ACTIONS(4379),
    [anon_sym_var] = ACTIONS(4379),
    [anon_sym_let] = ACTIONS(4379),
    [anon_sym_const] = ACTIONS(4379),
    [anon_sym_if] = ACTIONS(4379),
    [anon_sym_else] = ACTIONS(4379),
    [anon_sym_switch] = ACTIONS(4379),
    [anon_sym_for] = ACTIONS(4379),
    [anon_sym_LPAREN] = ACTIONS(4377),
    [anon_sym_await] = ACTIONS(4379),
    [anon_sym_while] = ACTIONS(4379),
    [anon_sym_do] = ACTIONS(4379),
    [anon_sym_try] = ACTIONS(4379),
    [anon_sym_with] = ACTIONS(4379),
    [anon_sym_break] = ACTIONS(4379),
    [anon_sym_continue] = ACTIONS(4379),
    [anon_sym_debugger] = ACTIONS(4379),
    [anon_sym_return] = ACTIONS(4379),
    [anon_sym_throw] = ACTIONS(4379),
    [anon_sym_SEMI] = ACTIONS(4377),
    [anon_sym_case] = ACTIONS(4379),
    [anon_sym_yield] = ACTIONS(4379),
    [anon_sym_LBRACK] = ACTIONS(4377),
    [anon_sym_LT] = ACTIONS(4377),
    [anon_sym_SLASH] = ACTIONS(4379),
    [anon_sym_class] = ACTIONS(4379),
    [anon_sym_async] = ACTIONS(4379),
    [anon_sym_function] = ACTIONS(4379),
    [anon_sym_EQ_GT] = ACTIONS(4377),
    [anon_sym_new] = ACTIONS(4379),
    [anon_sym_PLUS] = ACTIONS(4379),
    [anon_sym_DASH] = ACTIONS(4379),
    [anon_sym_BANG] = ACTIONS(4377),
    [anon_sym_TILDE] = ACTIONS(4377),
    [anon_sym_typeof] = ACTIONS(4379),
    [anon_sym_void] = ACTIONS(4379),
    [anon_sym_delete] = ACTIONS(4379),
    [anon_sym_PLUS_PLUS] = ACTIONS(4377),
    [anon_sym_DASH_DASH] = ACTIONS(4377),
    [anon_sym_DQUOTE] = ACTIONS(4377),
    [anon_sym_SQUOTE] = ACTIONS(4377),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4377),
    [sym_number] = ACTIONS(4377),
    [sym_identifier] = ACTIONS(4379),
    [sym_this] = ACTIONS(4379),
    [sym_super] = ACTIONS(4379),
    [sym_true] = ACTIONS(4379),
    [sym_false] = ACTIONS(4379),
    [sym_null] = ACTIONS(4379),
    [sym_undefined] = ACTIONS(4379),
    [anon_sym_AT] = ACTIONS(4377),
    [anon_sym_get] = ACTIONS(4379),
    [anon_sym_set] = ACTIONS(4379),
  },
  [1692] = {
    [ts_builtin_sym_end] = ACTIONS(4381),
    [anon_sym_export] = ACTIONS(4383),
    [anon_sym_default] = ACTIONS(4383),
    [anon_sym_LBRACE] = ACTIONS(4381),
    [anon_sym_RBRACE] = ACTIONS(4381),
    [anon_sym_import] = ACTIONS(4383),
    [anon_sym_var] = ACTIONS(4383),
    [anon_sym_let] = ACTIONS(4383),
    [anon_sym_const] = ACTIONS(4383),
    [anon_sym_if] = ACTIONS(4383),
    [anon_sym_else] = ACTIONS(4383),
    [anon_sym_switch] = ACTIONS(4383),
    [anon_sym_for] = ACTIONS(4383),
    [anon_sym_LPAREN] = ACTIONS(4381),
    [anon_sym_await] = ACTIONS(4383),
    [anon_sym_while] = ACTIONS(4383),
    [anon_sym_do] = ACTIONS(4383),
    [anon_sym_try] = ACTIONS(4383),
    [anon_sym_with] = ACTIONS(4383),
    [anon_sym_break] = ACTIONS(4383),
    [anon_sym_continue] = ACTIONS(4383),
    [anon_sym_debugger] = ACTIONS(4383),
    [anon_sym_return] = ACTIONS(4383),
    [anon_sym_throw] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4381),
    [anon_sym_case] = ACTIONS(4383),
    [anon_sym_yield] = ACTIONS(4383),
    [anon_sym_LBRACK] = ACTIONS(4381),
    [anon_sym_LT] = ACTIONS(4381),
    [anon_sym_SLASH] = ACTIONS(4383),
    [anon_sym_class] = ACTIONS(4383),
    [anon_sym_async] = ACTIONS(4383),
    [anon_sym_function] = ACTIONS(4383),
    [anon_sym_EQ_GT] = ACTIONS(4381),
    [anon_sym_new] = ACTIONS(4383),
    [anon_sym_PLUS] = ACTIONS(4383),
    [anon_sym_DASH] = ACTIONS(4383),
    [anon_sym_BANG] = ACTIONS(4381),
    [anon_sym_TILDE] = ACTIONS(4381),
    [anon_sym_typeof] = ACTIONS(4383),
    [anon_sym_void] = ACTIONS(4383),
    [anon_sym_delete] = ACTIONS(4383),
    [anon_sym_PLUS_PLUS] = ACTIONS(4381),
    [anon_sym_DASH_DASH] = ACTIONS(4381),
    [anon_sym_DQUOTE] = ACTIONS(4381),
    [anon_sym_SQUOTE] = ACTIONS(4381),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4381),
    [sym_number] = ACTIONS(4381),
    [sym_identifier] = ACTIONS(4383),
    [sym_this] = ACTIONS(4383),
    [sym_super] = ACTIONS(4383),
    [sym_true] = ACTIONS(4383),
    [sym_false] = ACTIONS(4383),
    [sym_null] = ACTIONS(4383),
    [sym_undefined] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(4381),
    [anon_sym_get] = ACTIONS(4383),
    [anon_sym_set] = ACTIONS(4383),
  },
  [1693] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4385),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1694] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4387),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1695] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4389),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1696] = {
    [anon_sym_STAR] = ACTIONS(4148),
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4148),
    [anon_sym_in] = ACTIONS(4150),
    [anon_sym_COLON] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4148),
    [anon_sym_RBRACK] = ACTIONS(4148),
    [anon_sym_LT] = ACTIONS(4150),
    [anon_sym_GT] = ACTIONS(4150),
    [anon_sym_SLASH] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(4148),
    [anon_sym_QMARK] = ACTIONS(4148),
    [anon_sym_AMP_AMP] = ACTIONS(4148),
    [anon_sym_PIPE_PIPE] = ACTIONS(4148),
    [anon_sym_GT_GT] = ACTIONS(4150),
    [anon_sym_GT_GT_GT] = ACTIONS(4148),
    [anon_sym_LT_LT] = ACTIONS(4148),
    [anon_sym_AMP] = ACTIONS(4150),
    [anon_sym_CARET] = ACTIONS(4148),
    [anon_sym_PIPE] = ACTIONS(4150),
    [anon_sym_PLUS] = ACTIONS(4150),
    [anon_sym_DASH] = ACTIONS(4150),
    [anon_sym_PERCENT] = ACTIONS(4148),
    [anon_sym_LT_EQ] = ACTIONS(4148),
    [anon_sym_EQ_EQ] = ACTIONS(4150),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4148),
    [anon_sym_BANG_EQ] = ACTIONS(4150),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4148),
    [anon_sym_GT_EQ] = ACTIONS(4148),
    [anon_sym_instanceof] = ACTIONS(4148),
    [anon_sym_PLUS_PLUS] = ACTIONS(4148),
    [anon_sym_DASH_DASH] = ACTIONS(4148),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4148),
  },
  [1697] = {
    [sym_export_statement] = STATE(1161),
    [sym__declaration] = STATE(1161),
    [sym_import_statement] = STATE(1161),
    [sym_expression_statement] = STATE(1161),
    [sym_variable_declaration] = STATE(1161),
    [sym_lexical_declaration] = STATE(1161),
    [sym_statement_block] = STATE(1161),
    [sym_if_statement] = STATE(1161),
    [sym_switch_statement] = STATE(1161),
    [sym_for_statement] = STATE(1161),
    [sym_for_in_statement] = STATE(1161),
    [sym_for_of_statement] = STATE(1161),
    [sym_while_statement] = STATE(1161),
    [sym_do_statement] = STATE(1161),
    [sym_try_statement] = STATE(1161),
    [sym_with_statement] = STATE(1161),
    [sym_break_statement] = STATE(1161),
    [sym_continue_statement] = STATE(1161),
    [sym_debugger_statement] = STATE(1161),
    [sym_return_statement] = STATE(1161),
    [sym_throw_statement] = STATE(1161),
    [sym_empty_statement] = STATE(1161),
    [sym_labeled_statement] = STATE(1161),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1698] = {
    [sym__initializer] = STATE(363),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(4391),
    [anon_sym_of] = ACTIONS(4393),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1699] = {
    [sym__initializer] = STATE(367),
    [sym__automatic_semicolon] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(4395),
    [anon_sym_of] = ACTIONS(4397),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1700] = {
    [sym__initializer] = STATE(368),
    [sym__automatic_semicolon] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(4399),
    [anon_sym_of] = ACTIONS(4401),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1701] = {
    [sym_parenthesized_expression] = STATE(1828),
    [sym__expression] = STATE(1828),
    [sym_yield_expression] = STATE(1828),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1828),
    [sym_jsx_fragment] = STATE(1828),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1828),
    [sym_anonymous_class] = STATE(1828),
    [sym_class] = STATE(1828),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1828),
    [sym_generator_function] = STATE(1828),
    [sym_call_expression] = STATE(1828),
    [sym_new_expression] = STATE(1828),
    [sym_await_expression] = STATE(1828),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1828),
    [sym_augmented_assignment_expression] = STATE(1828),
    [sym_ternary_expression] = STATE(1828),
    [sym_binary_expression] = STATE(1828),
    [sym_unary_expression] = STATE(1828),
    [sym_update_expression] = STATE(1828),
    [sym_sequence_expression] = STATE(1829),
    [sym_string] = STATE(1828),
    [sym_template_string] = STATE(1828),
    [sym_regex] = STATE(1828),
    [sym_meta_property] = STATE(1828),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4403),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4405),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4405),
    [sym_false] = ACTIONS(4405),
    [sym_null] = ACTIONS(4405),
    [sym_undefined] = ACTIONS(4405),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1702] = {
    [sym_parenthesized_expression] = STATE(1830),
    [sym__expression] = STATE(1830),
    [sym_yield_expression] = STATE(1830),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1830),
    [sym_jsx_fragment] = STATE(1830),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1830),
    [sym_anonymous_class] = STATE(1830),
    [sym_class] = STATE(1830),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1830),
    [sym_generator_function] = STATE(1830),
    [sym_call_expression] = STATE(1830),
    [sym_new_expression] = STATE(1830),
    [sym_await_expression] = STATE(1830),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1830),
    [sym_augmented_assignment_expression] = STATE(1830),
    [sym_ternary_expression] = STATE(1830),
    [sym_binary_expression] = STATE(1830),
    [sym_unary_expression] = STATE(1830),
    [sym_update_expression] = STATE(1830),
    [sym_string] = STATE(1830),
    [sym_template_string] = STATE(1830),
    [sym_regex] = STATE(1830),
    [sym_meta_property] = STATE(1830),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4407),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4409),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4409),
    [sym_false] = ACTIONS(4409),
    [sym_null] = ACTIONS(4409),
    [sym_undefined] = ACTIONS(4409),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1703] = {
    [sym_parenthesized_expression] = STATE(1832),
    [sym__expression] = STATE(1832),
    [sym_yield_expression] = STATE(1832),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1832),
    [sym_jsx_fragment] = STATE(1832),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1832),
    [sym_anonymous_class] = STATE(1832),
    [sym_class] = STATE(1832),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1832),
    [sym_generator_function] = STATE(1832),
    [sym_call_expression] = STATE(1832),
    [sym_new_expression] = STATE(1832),
    [sym_await_expression] = STATE(1832),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1832),
    [sym_augmented_assignment_expression] = STATE(1832),
    [sym_ternary_expression] = STATE(1832),
    [sym_binary_expression] = STATE(1832),
    [sym_unary_expression] = STATE(1832),
    [sym_update_expression] = STATE(1832),
    [sym_sequence_expression] = STATE(1833),
    [sym_string] = STATE(1832),
    [sym_template_string] = STATE(1832),
    [sym_regex] = STATE(1832),
    [sym_meta_property] = STATE(1832),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(4411),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4413),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4415),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4415),
    [sym_false] = ACTIONS(4415),
    [sym_null] = ACTIONS(4415),
    [sym_undefined] = ACTIONS(4415),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1704] = {
    [sym_parenthesized_expression] = STATE(1834),
    [sym__expression] = STATE(1834),
    [sym_yield_expression] = STATE(1834),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1834),
    [sym_jsx_fragment] = STATE(1834),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1834),
    [sym_anonymous_class] = STATE(1834),
    [sym_class] = STATE(1834),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1834),
    [sym_generator_function] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_await_expression] = STATE(1834),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1834),
    [sym_augmented_assignment_expression] = STATE(1834),
    [sym_ternary_expression] = STATE(1834),
    [sym_binary_expression] = STATE(1834),
    [sym_unary_expression] = STATE(1834),
    [sym_update_expression] = STATE(1834),
    [sym_sequence_expression] = STATE(1835),
    [sym_string] = STATE(1834),
    [sym_template_string] = STATE(1834),
    [sym_regex] = STATE(1834),
    [sym_meta_property] = STATE(1834),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4417),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4419),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4419),
    [sym_false] = ACTIONS(4419),
    [sym_null] = ACTIONS(4419),
    [sym_undefined] = ACTIONS(4419),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1705] = {
    [sym_parenthesized_expression] = STATE(1836),
    [sym__expression] = STATE(1836),
    [sym_yield_expression] = STATE(1836),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1836),
    [sym_jsx_fragment] = STATE(1836),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1836),
    [sym_anonymous_class] = STATE(1836),
    [sym_class] = STATE(1836),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1836),
    [sym_generator_function] = STATE(1836),
    [sym_call_expression] = STATE(1836),
    [sym_new_expression] = STATE(1836),
    [sym_await_expression] = STATE(1836),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1836),
    [sym_augmented_assignment_expression] = STATE(1836),
    [sym_ternary_expression] = STATE(1836),
    [sym_binary_expression] = STATE(1836),
    [sym_unary_expression] = STATE(1836),
    [sym_update_expression] = STATE(1836),
    [sym_string] = STATE(1836),
    [sym_template_string] = STATE(1836),
    [sym_regex] = STATE(1836),
    [sym_meta_property] = STATE(1836),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4421),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4423),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4423),
    [sym_false] = ACTIONS(4423),
    [sym_null] = ACTIONS(4423),
    [sym_undefined] = ACTIONS(4423),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1706] = {
    [sym_parenthesized_expression] = STATE(1837),
    [sym__expression] = STATE(1837),
    [sym_yield_expression] = STATE(1837),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1837),
    [sym_jsx_fragment] = STATE(1837),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1837),
    [sym_anonymous_class] = STATE(1837),
    [sym_class] = STATE(1837),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1837),
    [sym_generator_function] = STATE(1837),
    [sym_call_expression] = STATE(1837),
    [sym_new_expression] = STATE(1837),
    [sym_await_expression] = STATE(1837),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1837),
    [sym_augmented_assignment_expression] = STATE(1837),
    [sym_ternary_expression] = STATE(1837),
    [sym_binary_expression] = STATE(1837),
    [sym_unary_expression] = STATE(1837),
    [sym_update_expression] = STATE(1837),
    [sym_sequence_expression] = STATE(1838),
    [sym_string] = STATE(1837),
    [sym_template_string] = STATE(1837),
    [sym_regex] = STATE(1837),
    [sym_meta_property] = STATE(1837),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4425),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4427),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4427),
    [sym_false] = ACTIONS(4427),
    [sym_null] = ACTIONS(4427),
    [sym_undefined] = ACTIONS(4427),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1707] = {
    [sym_parenthesized_expression] = STATE(1839),
    [sym__expression] = STATE(1839),
    [sym_yield_expression] = STATE(1839),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1839),
    [sym_jsx_fragment] = STATE(1839),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1839),
    [sym_anonymous_class] = STATE(1839),
    [sym_class] = STATE(1839),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1839),
    [sym_generator_function] = STATE(1839),
    [sym_call_expression] = STATE(1839),
    [sym_new_expression] = STATE(1839),
    [sym_await_expression] = STATE(1839),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1839),
    [sym_augmented_assignment_expression] = STATE(1839),
    [sym_ternary_expression] = STATE(1839),
    [sym_binary_expression] = STATE(1839),
    [sym_unary_expression] = STATE(1839),
    [sym_update_expression] = STATE(1839),
    [sym_string] = STATE(1839),
    [sym_template_string] = STATE(1839),
    [sym_regex] = STATE(1839),
    [sym_meta_property] = STATE(1839),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4429),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4431),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4431),
    [sym_false] = ACTIONS(4431),
    [sym_null] = ACTIONS(4431),
    [sym_undefined] = ACTIONS(4431),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1708] = {
    [sym_object] = STATE(1841),
    [sym_array] = STATE(1842),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4433),
  },
  [1709] = {
    [anon_sym_of] = ACTIONS(4393),
    [sym_comment] = ACTIONS(78),
  },
  [1710] = {
    [anon_sym_of] = ACTIONS(4397),
    [sym_comment] = ACTIONS(78),
  },
  [1711] = {
    [anon_sym_of] = ACTIONS(4401),
    [sym_comment] = ACTIONS(78),
  },
  [1712] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4435),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1713] = {
    [anon_sym_RPAREN] = ACTIONS(4435),
    [sym_comment] = ACTIONS(78),
  },
  [1714] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4437),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1715] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4439),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1716] = {
    [anon_sym_RPAREN] = ACTIONS(4439),
    [sym_comment] = ACTIONS(78),
  },
  [1717] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4441),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1718] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4443),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1719] = {
    [anon_sym_RPAREN] = ACTIONS(4443),
    [sym_comment] = ACTIONS(78),
  },
  [1720] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4445),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1721] = {
    [sym_export_statement] = STATE(1672),
    [sym__declaration] = STATE(1672),
    [sym_import_statement] = STATE(1672),
    [sym_expression_statement] = STATE(1672),
    [sym_variable_declaration] = STATE(1672),
    [sym_lexical_declaration] = STATE(1672),
    [sym_statement_block] = STATE(1672),
    [sym_if_statement] = STATE(1672),
    [sym_switch_statement] = STATE(1672),
    [sym_for_statement] = STATE(1672),
    [sym_for_in_statement] = STATE(1672),
    [sym_for_of_statement] = STATE(1672),
    [sym_while_statement] = STATE(1672),
    [sym_do_statement] = STATE(1672),
    [sym_try_statement] = STATE(1672),
    [sym_with_statement] = STATE(1672),
    [sym_break_statement] = STATE(1672),
    [sym_continue_statement] = STATE(1672),
    [sym_debugger_statement] = STATE(1672),
    [sym_return_statement] = STATE(1672),
    [sym_throw_statement] = STATE(1672),
    [sym_empty_statement] = STATE(1672),
    [sym_labeled_statement] = STATE(1672),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1722] = {
    [sym_export_statement] = STATE(1683),
    [sym__declaration] = STATE(1683),
    [sym_import_statement] = STATE(1683),
    [sym_expression_statement] = STATE(1683),
    [sym_variable_declaration] = STATE(1683),
    [sym_lexical_declaration] = STATE(1683),
    [sym_statement_block] = STATE(1683),
    [sym_if_statement] = STATE(1683),
    [sym_switch_statement] = STATE(1683),
    [sym_for_statement] = STATE(1683),
    [sym_for_in_statement] = STATE(1683),
    [sym_for_of_statement] = STATE(1683),
    [sym_while_statement] = STATE(1683),
    [sym_do_statement] = STATE(1683),
    [sym_try_statement] = STATE(1683),
    [sym_with_statement] = STATE(1683),
    [sym_break_statement] = STATE(1683),
    [sym_continue_statement] = STATE(1683),
    [sym_debugger_statement] = STATE(1683),
    [sym_return_statement] = STATE(1683),
    [sym_throw_statement] = STATE(1683),
    [sym_empty_statement] = STATE(1683),
    [sym_labeled_statement] = STATE(1683),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1723] = {
    [sym_export_statement] = STATE(1688),
    [sym__declaration] = STATE(1688),
    [sym_import_statement] = STATE(1688),
    [sym_expression_statement] = STATE(1688),
    [sym_variable_declaration] = STATE(1688),
    [sym_lexical_declaration] = STATE(1688),
    [sym_statement_block] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_switch_statement] = STATE(1688),
    [sym_for_statement] = STATE(1688),
    [sym_for_in_statement] = STATE(1688),
    [sym_for_of_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_do_statement] = STATE(1688),
    [sym_try_statement] = STATE(1688),
    [sym_with_statement] = STATE(1688),
    [sym_break_statement] = STATE(1688),
    [sym_continue_statement] = STATE(1688),
    [sym_debugger_statement] = STATE(1688),
    [sym_return_statement] = STATE(1688),
    [sym_throw_statement] = STATE(1688),
    [sym_empty_statement] = STATE(1688),
    [sym_labeled_statement] = STATE(1688),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1724] = {
    [sym_export_statement] = STATE(1689),
    [sym__declaration] = STATE(1689),
    [sym_import_statement] = STATE(1689),
    [sym_expression_statement] = STATE(1689),
    [sym_variable_declaration] = STATE(1689),
    [sym_lexical_declaration] = STATE(1689),
    [sym_statement_block] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_switch_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_for_in_statement] = STATE(1689),
    [sym_for_of_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_do_statement] = STATE(1689),
    [sym_try_statement] = STATE(1689),
    [sym_with_statement] = STATE(1689),
    [sym_break_statement] = STATE(1689),
    [sym_continue_statement] = STATE(1689),
    [sym_debugger_statement] = STATE(1689),
    [sym_return_statement] = STATE(1689),
    [sym_throw_statement] = STATE(1689),
    [sym_empty_statement] = STATE(1689),
    [sym_labeled_statement] = STATE(1689),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1725] = {
    [sym_export_statement] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym_import_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_lexical_declaration] = STATE(1690),
    [sym_statement_block] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_for_in_statement] = STATE(1690),
    [sym_for_of_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_try_statement] = STATE(1690),
    [sym_with_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_debugger_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_throw_statement] = STATE(1690),
    [sym_empty_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1726] = {
    [sym_export_statement] = STATE(1691),
    [sym__declaration] = STATE(1691),
    [sym_import_statement] = STATE(1691),
    [sym_expression_statement] = STATE(1691),
    [sym_variable_declaration] = STATE(1691),
    [sym_lexical_declaration] = STATE(1691),
    [sym_statement_block] = STATE(1691),
    [sym_if_statement] = STATE(1691),
    [sym_switch_statement] = STATE(1691),
    [sym_for_statement] = STATE(1691),
    [sym_for_in_statement] = STATE(1691),
    [sym_for_of_statement] = STATE(1691),
    [sym_while_statement] = STATE(1691),
    [sym_do_statement] = STATE(1691),
    [sym_try_statement] = STATE(1691),
    [sym_with_statement] = STATE(1691),
    [sym_break_statement] = STATE(1691),
    [sym_continue_statement] = STATE(1691),
    [sym_debugger_statement] = STATE(1691),
    [sym_return_statement] = STATE(1691),
    [sym_throw_statement] = STATE(1691),
    [sym_empty_statement] = STATE(1691),
    [sym_labeled_statement] = STATE(1691),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1727] = {
    [sym_export_statement] = STATE(1692),
    [sym__declaration] = STATE(1692),
    [sym_import_statement] = STATE(1692),
    [sym_expression_statement] = STATE(1692),
    [sym_variable_declaration] = STATE(1692),
    [sym_lexical_declaration] = STATE(1692),
    [sym_statement_block] = STATE(1692),
    [sym_if_statement] = STATE(1692),
    [sym_switch_statement] = STATE(1692),
    [sym_for_statement] = STATE(1692),
    [sym_for_in_statement] = STATE(1692),
    [sym_for_of_statement] = STATE(1692),
    [sym_while_statement] = STATE(1692),
    [sym_do_statement] = STATE(1692),
    [sym_try_statement] = STATE(1692),
    [sym_with_statement] = STATE(1692),
    [sym_break_statement] = STATE(1692),
    [sym_continue_statement] = STATE(1692),
    [sym_debugger_statement] = STATE(1692),
    [sym_return_statement] = STATE(1692),
    [sym_throw_statement] = STATE(1692),
    [sym_empty_statement] = STATE(1692),
    [sym_labeled_statement] = STATE(1692),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1728] = {
    [sym_parenthesized_expression] = STATE(1849),
    [sym__expression] = STATE(1849),
    [sym_yield_expression] = STATE(1849),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1849),
    [sym_jsx_fragment] = STATE(1849),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1849),
    [sym_anonymous_class] = STATE(1849),
    [sym_class] = STATE(1849),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1849),
    [sym_generator_function] = STATE(1849),
    [sym_call_expression] = STATE(1849),
    [sym_new_expression] = STATE(1849),
    [sym_await_expression] = STATE(1849),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1849),
    [sym_augmented_assignment_expression] = STATE(1849),
    [sym_ternary_expression] = STATE(1849),
    [sym_binary_expression] = STATE(1849),
    [sym_unary_expression] = STATE(1849),
    [sym_update_expression] = STATE(1849),
    [sym_string] = STATE(1849),
    [sym_template_string] = STATE(1849),
    [sym_regex] = STATE(1849),
    [sym_meta_property] = STATE(1849),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4447),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4449),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4449),
    [sym_false] = ACTIONS(4449),
    [sym_null] = ACTIONS(4449),
    [sym_undefined] = ACTIONS(4449),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1729] = {
    [sym_parenthesized_expression] = STATE(1850),
    [sym__expression] = STATE(1850),
    [sym_yield_expression] = STATE(1850),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1850),
    [sym_jsx_fragment] = STATE(1850),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1850),
    [sym_anonymous_class] = STATE(1850),
    [sym_class] = STATE(1850),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1850),
    [sym_generator_function] = STATE(1850),
    [sym_call_expression] = STATE(1850),
    [sym_new_expression] = STATE(1850),
    [sym_await_expression] = STATE(1850),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1850),
    [sym_augmented_assignment_expression] = STATE(1850),
    [sym_ternary_expression] = STATE(1850),
    [sym_binary_expression] = STATE(1850),
    [sym_unary_expression] = STATE(1850),
    [sym_update_expression] = STATE(1850),
    [sym_string] = STATE(1850),
    [sym_template_string] = STATE(1850),
    [sym_regex] = STATE(1850),
    [sym_meta_property] = STATE(1850),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4451),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4453),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4453),
    [sym_false] = ACTIONS(4453),
    [sym_null] = ACTIONS(4453),
    [sym_undefined] = ACTIONS(4453),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1730] = {
    [sym_parenthesized_expression] = STATE(1851),
    [sym__expression] = STATE(1851),
    [sym_yield_expression] = STATE(1851),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1851),
    [sym_jsx_fragment] = STATE(1851),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1851),
    [sym_anonymous_class] = STATE(1851),
    [sym_class] = STATE(1851),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1851),
    [sym_generator_function] = STATE(1851),
    [sym_call_expression] = STATE(1851),
    [sym_new_expression] = STATE(1851),
    [sym_await_expression] = STATE(1851),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1851),
    [sym_augmented_assignment_expression] = STATE(1851),
    [sym_ternary_expression] = STATE(1851),
    [sym_binary_expression] = STATE(1851),
    [sym_unary_expression] = STATE(1851),
    [sym_update_expression] = STATE(1851),
    [sym_string] = STATE(1851),
    [sym_template_string] = STATE(1851),
    [sym_regex] = STATE(1851),
    [sym_meta_property] = STATE(1851),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4455),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4457),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4457),
    [sym_false] = ACTIONS(4457),
    [sym_null] = ACTIONS(4457),
    [sym_undefined] = ACTIONS(4457),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1731] = {
    [ts_builtin_sym_end] = ACTIONS(4459),
    [anon_sym_export] = ACTIONS(4461),
    [anon_sym_default] = ACTIONS(4461),
    [anon_sym_LBRACE] = ACTIONS(4459),
    [anon_sym_RBRACE] = ACTIONS(4459),
    [anon_sym_import] = ACTIONS(4461),
    [anon_sym_var] = ACTIONS(4461),
    [anon_sym_let] = ACTIONS(4461),
    [anon_sym_const] = ACTIONS(4461),
    [anon_sym_if] = ACTIONS(4461),
    [anon_sym_else] = ACTIONS(4461),
    [anon_sym_switch] = ACTIONS(4461),
    [anon_sym_for] = ACTIONS(4461),
    [anon_sym_LPAREN] = ACTIONS(4459),
    [anon_sym_await] = ACTIONS(4461),
    [anon_sym_while] = ACTIONS(4461),
    [anon_sym_do] = ACTIONS(4461),
    [anon_sym_try] = ACTIONS(4461),
    [anon_sym_with] = ACTIONS(4461),
    [anon_sym_break] = ACTIONS(4461),
    [anon_sym_continue] = ACTIONS(4461),
    [anon_sym_debugger] = ACTIONS(4461),
    [anon_sym_return] = ACTIONS(4461),
    [anon_sym_throw] = ACTIONS(4461),
    [anon_sym_SEMI] = ACTIONS(4459),
    [anon_sym_case] = ACTIONS(4461),
    [anon_sym_finally] = ACTIONS(4461),
    [anon_sym_yield] = ACTIONS(4461),
    [anon_sym_LBRACK] = ACTIONS(4459),
    [anon_sym_LT] = ACTIONS(4459),
    [anon_sym_SLASH] = ACTIONS(4461),
    [anon_sym_class] = ACTIONS(4461),
    [anon_sym_async] = ACTIONS(4461),
    [anon_sym_function] = ACTIONS(4461),
    [anon_sym_EQ_GT] = ACTIONS(4459),
    [anon_sym_new] = ACTIONS(4461),
    [anon_sym_PLUS] = ACTIONS(4461),
    [anon_sym_DASH] = ACTIONS(4461),
    [anon_sym_BANG] = ACTIONS(4459),
    [anon_sym_TILDE] = ACTIONS(4459),
    [anon_sym_typeof] = ACTIONS(4461),
    [anon_sym_void] = ACTIONS(4461),
    [anon_sym_delete] = ACTIONS(4461),
    [anon_sym_PLUS_PLUS] = ACTIONS(4459),
    [anon_sym_DASH_DASH] = ACTIONS(4459),
    [anon_sym_DQUOTE] = ACTIONS(4459),
    [anon_sym_SQUOTE] = ACTIONS(4459),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4459),
    [sym_number] = ACTIONS(4459),
    [sym_identifier] = ACTIONS(4461),
    [sym_this] = ACTIONS(4461),
    [sym_super] = ACTIONS(4461),
    [sym_true] = ACTIONS(4461),
    [sym_false] = ACTIONS(4461),
    [sym_null] = ACTIONS(4461),
    [sym_undefined] = ACTIONS(4461),
    [anon_sym_AT] = ACTIONS(4459),
    [anon_sym_get] = ACTIONS(4461),
    [anon_sym_set] = ACTIONS(4461),
  },
  [1732] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(4463),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [1733] = {
    [sym_jsx_element] = STATE(665),
    [sym_jsx_expression] = STATE(665),
    [sym_jsx_opening_element] = STATE(254),
    [sym_jsx_self_closing_element] = STATE(665),
    [aux_sym_jsx_element_repeat1] = STATE(665),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(4465),
    [sym_jsx_text] = ACTIONS(1263),
    [sym_comment] = ACTIONS(78),
  },
  [1734] = {
    [anon_sym_GT] = ACTIONS(4467),
    [sym_comment] = ACTIONS(78),
  },
  [1735] = {
    [sym_jsx_expression] = STATE(940),
    [sym_jsx_namespace_name] = STATE(538),
    [sym_jsx_attribute] = STATE(940),
    [aux_sym_jsx_opening_element_repeat1] = STATE(940),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(4469),
    [sym_jsx_identifier] = ACTIONS(973),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(975),
  },
  [1736] = {
    [anon_sym_LBRACE] = ACTIONS(2193),
    [anon_sym_GT] = ACTIONS(2193),
    [anon_sym_SLASH] = ACTIONS(2195),
    [sym_jsx_identifier] = ACTIONS(2193),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2195),
  },
  [1737] = {
    [sym_nested_identifier] = STATE(1858),
    [sym_jsx_namespace_name] = STATE(1859),
    [sym_jsx_identifier] = ACTIONS(4471),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4473),
  },
  [1738] = {
    [anon_sym_LBRACE] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(2349),
    [sym_jsx_identifier] = ACTIONS(2347),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2349),
  },
  [1739] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2089),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2091),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2089),
    [anon_sym_GT_GT_GT] = ACTIONS(2085),
    [anon_sym_LT_LT] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2097),
    [anon_sym_CARET] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2099),
    [anon_sym_PLUS] = ACTIONS(2101),
    [anon_sym_DASH] = ACTIONS(2101),
    [anon_sym_PERCENT] = ACTIONS(2085),
    [anon_sym_LT_EQ] = ACTIONS(2103),
    [anon_sym_EQ_EQ] = ACTIONS(2081),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2103),
    [anon_sym_BANG_EQ] = ACTIONS(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2103),
    [anon_sym_GT_EQ] = ACTIONS(2103),
    [anon_sym_instanceof] = ACTIONS(2103),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1740] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2287),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2297),
    [anon_sym_AMP_AMP] = ACTIONS(2299),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_GT_GT_GT] = ACTIONS(2291),
    [anon_sym_LT_LT] = ACTIONS(2291),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2291),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2309),
    [anon_sym_instanceof] = ACTIONS(2309),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1741] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1742] = {
    [sym_parenthesized_expression] = STATE(1860),
    [sym__expression] = STATE(1860),
    [sym_yield_expression] = STATE(1860),
    [sym_object] = STATE(1029),
    [sym_array] = STATE(1030),
    [sym_jsx_element] = STATE(1860),
    [sym_jsx_fragment] = STATE(1860),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1860),
    [sym_anonymous_class] = STATE(1860),
    [sym_class] = STATE(1860),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1860),
    [sym_generator_function] = STATE(1860),
    [sym_call_expression] = STATE(1860),
    [sym_new_expression] = STATE(1860),
    [sym_await_expression] = STATE(1860),
    [sym_member_expression] = STATE(1031),
    [sym_subscript_expression] = STATE(1031),
    [sym_assignment_expression] = STATE(1860),
    [sym_augmented_assignment_expression] = STATE(1860),
    [sym_ternary_expression] = STATE(1860),
    [sym_binary_expression] = STATE(1860),
    [sym_unary_expression] = STATE(1860),
    [sym_update_expression] = STATE(1860),
    [sym_string] = STATE(1860),
    [sym_template_string] = STATE(1860),
    [sym_regex] = STATE(1860),
    [sym_meta_property] = STATE(1860),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [anon_sym_BANG] = ACTIONS(2325),
    [anon_sym_TILDE] = ACTIONS(2325),
    [anon_sym_typeof] = ACTIONS(2323),
    [anon_sym_void] = ACTIONS(2323),
    [anon_sym_delete] = ACTIONS(2323),
    [anon_sym_PLUS_PLUS] = ACTIONS(2327),
    [anon_sym_DASH_DASH] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4475),
    [sym_identifier] = ACTIONS(2331),
    [sym_this] = ACTIONS(4477),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4477),
    [sym_false] = ACTIONS(4477),
    [sym_null] = ACTIONS(4477),
    [sym_undefined] = ACTIONS(4477),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
  },
  [1743] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_RBRACK] = ACTIONS(3712),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(2456),
    [anon_sym_AMP_AMP] = ACTIONS(2458),
    [anon_sym_PIPE_PIPE] = ACTIONS(2460),
    [anon_sym_GT_GT] = ACTIONS(2454),
    [anon_sym_GT_GT_GT] = ACTIONS(2450),
    [anon_sym_LT_LT] = ACTIONS(2450),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_PIPE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PERCENT] = ACTIONS(2450),
    [anon_sym_LT_EQ] = ACTIONS(2468),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2468),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2468),
    [anon_sym_GT_EQ] = ACTIONS(2468),
    [anon_sym_instanceof] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1744] = {
    [sym_parenthesized_expression] = STATE(1861),
    [sym__expression] = STATE(1861),
    [sym_yield_expression] = STATE(1861),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1861),
    [sym_jsx_fragment] = STATE(1861),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1861),
    [sym_anonymous_class] = STATE(1861),
    [sym_class] = STATE(1861),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1861),
    [sym_generator_function] = STATE(1861),
    [sym_call_expression] = STATE(1861),
    [sym_new_expression] = STATE(1861),
    [sym_await_expression] = STATE(1861),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1861),
    [sym_augmented_assignment_expression] = STATE(1861),
    [sym_ternary_expression] = STATE(1861),
    [sym_binary_expression] = STATE(1861),
    [sym_unary_expression] = STATE(1861),
    [sym_update_expression] = STATE(1861),
    [sym_sequence_expression] = STATE(1862),
    [sym_string] = STATE(1861),
    [sym_template_string] = STATE(1861),
    [sym_regex] = STATE(1861),
    [sym_meta_property] = STATE(1861),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4479),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4481),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4481),
    [sym_false] = ACTIONS(4481),
    [sym_null] = ACTIONS(4481),
    [sym_undefined] = ACTIONS(4481),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1745] = {
    [sym_parenthesized_expression] = STATE(1863),
    [sym__expression] = STATE(1863),
    [sym_yield_expression] = STATE(1863),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1863),
    [sym_jsx_fragment] = STATE(1863),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1863),
    [sym_anonymous_class] = STATE(1863),
    [sym_class] = STATE(1863),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1863),
    [sym_generator_function] = STATE(1863),
    [sym_call_expression] = STATE(1863),
    [sym_new_expression] = STATE(1863),
    [sym_await_expression] = STATE(1863),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1863),
    [sym_augmented_assignment_expression] = STATE(1863),
    [sym_ternary_expression] = STATE(1863),
    [sym_binary_expression] = STATE(1863),
    [sym_unary_expression] = STATE(1863),
    [sym_update_expression] = STATE(1863),
    [sym_string] = STATE(1863),
    [sym_template_string] = STATE(1863),
    [sym_regex] = STATE(1863),
    [sym_meta_property] = STATE(1863),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4483),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4485),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4485),
    [sym_false] = ACTIONS(4485),
    [sym_null] = ACTIONS(4485),
    [sym_undefined] = ACTIONS(4485),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1746] = {
    [sym_parenthesized_expression] = STATE(1864),
    [sym__expression] = STATE(1864),
    [sym_yield_expression] = STATE(1864),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1864),
    [sym_jsx_fragment] = STATE(1864),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1864),
    [sym_anonymous_class] = STATE(1864),
    [sym_class] = STATE(1864),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1864),
    [sym_generator_function] = STATE(1864),
    [sym_call_expression] = STATE(1864),
    [sym_new_expression] = STATE(1864),
    [sym_await_expression] = STATE(1864),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1864),
    [sym_augmented_assignment_expression] = STATE(1864),
    [sym_ternary_expression] = STATE(1864),
    [sym_binary_expression] = STATE(1864),
    [sym_unary_expression] = STATE(1864),
    [sym_update_expression] = STATE(1864),
    [sym_sequence_expression] = STATE(1865),
    [sym_string] = STATE(1864),
    [sym_template_string] = STATE(1864),
    [sym_regex] = STATE(1864),
    [sym_meta_property] = STATE(1864),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4487),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4489),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4489),
    [sym_false] = ACTIONS(4489),
    [sym_null] = ACTIONS(4489),
    [sym_undefined] = ACTIONS(4489),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1747] = {
    [sym_parenthesized_expression] = STATE(1866),
    [sym__expression] = STATE(1866),
    [sym_yield_expression] = STATE(1866),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1866),
    [sym_jsx_fragment] = STATE(1866),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1866),
    [sym_anonymous_class] = STATE(1866),
    [sym_class] = STATE(1866),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1866),
    [sym_generator_function] = STATE(1866),
    [sym_call_expression] = STATE(1866),
    [sym_new_expression] = STATE(1866),
    [sym_await_expression] = STATE(1866),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1866),
    [sym_augmented_assignment_expression] = STATE(1866),
    [sym_ternary_expression] = STATE(1866),
    [sym_binary_expression] = STATE(1866),
    [sym_unary_expression] = STATE(1866),
    [sym_update_expression] = STATE(1866),
    [sym_string] = STATE(1866),
    [sym_template_string] = STATE(1866),
    [sym_regex] = STATE(1866),
    [sym_meta_property] = STATE(1866),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4491),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4493),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4493),
    [sym_false] = ACTIONS(4493),
    [sym_null] = ACTIONS(4493),
    [sym_undefined] = ACTIONS(4493),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1748] = {
    [sym_parenthesized_expression] = STATE(1867),
    [sym__expression] = STATE(1867),
    [sym_yield_expression] = STATE(1867),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1867),
    [sym_jsx_fragment] = STATE(1867),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1867),
    [sym_anonymous_class] = STATE(1867),
    [sym_class] = STATE(1867),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1867),
    [sym_generator_function] = STATE(1867),
    [sym_call_expression] = STATE(1867),
    [sym_new_expression] = STATE(1867),
    [sym_await_expression] = STATE(1867),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1867),
    [sym_augmented_assignment_expression] = STATE(1867),
    [sym_ternary_expression] = STATE(1867),
    [sym_binary_expression] = STATE(1867),
    [sym_unary_expression] = STATE(1867),
    [sym_update_expression] = STATE(1867),
    [sym_sequence_expression] = STATE(1868),
    [sym_string] = STATE(1867),
    [sym_template_string] = STATE(1867),
    [sym_regex] = STATE(1867),
    [sym_meta_property] = STATE(1867),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4495),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4497),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4497),
    [sym_false] = ACTIONS(4497),
    [sym_null] = ACTIONS(4497),
    [sym_undefined] = ACTIONS(4497),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1749] = {
    [sym_parenthesized_expression] = STATE(1869),
    [sym__expression] = STATE(1869),
    [sym_yield_expression] = STATE(1869),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1869),
    [sym_jsx_fragment] = STATE(1869),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1869),
    [sym_anonymous_class] = STATE(1869),
    [sym_class] = STATE(1869),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1869),
    [sym_generator_function] = STATE(1869),
    [sym_call_expression] = STATE(1869),
    [sym_new_expression] = STATE(1869),
    [sym_await_expression] = STATE(1869),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1869),
    [sym_augmented_assignment_expression] = STATE(1869),
    [sym_ternary_expression] = STATE(1869),
    [sym_binary_expression] = STATE(1869),
    [sym_unary_expression] = STATE(1869),
    [sym_update_expression] = STATE(1869),
    [sym_string] = STATE(1869),
    [sym_template_string] = STATE(1869),
    [sym_regex] = STATE(1869),
    [sym_meta_property] = STATE(1869),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4499),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4501),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4501),
    [sym_false] = ACTIONS(4501),
    [sym_null] = ACTIONS(4501),
    [sym_undefined] = ACTIONS(4501),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1750] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4503),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1751] = {
    [anon_sym_RPAREN] = ACTIONS(4503),
    [sym_comment] = ACTIONS(78),
  },
  [1752] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4505),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1753] = {
    [sym_export_statement] = STATE(1500),
    [sym__declaration] = STATE(1500),
    [sym_import_statement] = STATE(1500),
    [sym_expression_statement] = STATE(1500),
    [sym_variable_declaration] = STATE(1500),
    [sym_lexical_declaration] = STATE(1500),
    [sym_statement_block] = STATE(1500),
    [sym_if_statement] = STATE(1500),
    [sym_switch_statement] = STATE(1500),
    [sym_for_statement] = STATE(1500),
    [sym_for_in_statement] = STATE(1500),
    [sym_for_of_statement] = STATE(1500),
    [sym_while_statement] = STATE(1500),
    [sym_do_statement] = STATE(1500),
    [sym_try_statement] = STATE(1500),
    [sym_with_statement] = STATE(1500),
    [sym_break_statement] = STATE(1500),
    [sym_continue_statement] = STATE(1500),
    [sym_debugger_statement] = STATE(1500),
    [sym_return_statement] = STATE(1500),
    [sym_throw_statement] = STATE(1500),
    [sym_empty_statement] = STATE(1500),
    [sym_labeled_statement] = STATE(1500),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1754] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4507),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1755] = {
    [anon_sym_RPAREN] = ACTIONS(4507),
    [sym_comment] = ACTIONS(78),
  },
  [1756] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4509),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1757] = {
    [anon_sym_RPAREN] = ACTIONS(4509),
    [sym_comment] = ACTIONS(78),
  },
  [1758] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4511),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1759] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4513),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1760] = {
    [anon_sym_RPAREN] = ACTIONS(4513),
    [sym_comment] = ACTIONS(78),
  },
  [1761] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4515),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1762] = {
    [anon_sym_of] = ACTIONS(4517),
    [sym_comment] = ACTIONS(78),
  },
  [1763] = {
    [anon_sym_of] = ACTIONS(4519),
    [sym_comment] = ACTIONS(78),
  },
  [1764] = {
    [anon_sym_of] = ACTIONS(4521),
    [sym_comment] = ACTIONS(78),
  },
  [1765] = {
    [sym_export_statement] = STATE(1809),
    [sym__declaration] = STATE(1809),
    [sym_import_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_variable_declaration] = STATE(1809),
    [sym_lexical_declaration] = STATE(1809),
    [sym_statement_block] = STATE(1809),
    [sym_if_statement] = STATE(1809),
    [sym_switch_statement] = STATE(1809),
    [sym_for_statement] = STATE(1809),
    [sym_for_in_statement] = STATE(1809),
    [sym_for_of_statement] = STATE(1809),
    [sym_while_statement] = STATE(1809),
    [sym_do_statement] = STATE(1809),
    [sym_try_statement] = STATE(1809),
    [sym_with_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_debugger_statement] = STATE(1809),
    [sym_return_statement] = STATE(1809),
    [sym_throw_statement] = STATE(1809),
    [sym_empty_statement] = STATE(1809),
    [sym_labeled_statement] = STATE(1809),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1766] = {
    [sym_export_statement] = STATE(1810),
    [sym__declaration] = STATE(1810),
    [sym_import_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_variable_declaration] = STATE(1810),
    [sym_lexical_declaration] = STATE(1810),
    [sym_statement_block] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_for_in_statement] = STATE(1810),
    [sym_for_of_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_with_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_debugger_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_throw_statement] = STATE(1810),
    [sym_empty_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1767] = {
    [sym_export_statement] = STATE(1811),
    [sym__declaration] = STATE(1811),
    [sym_import_statement] = STATE(1811),
    [sym_expression_statement] = STATE(1811),
    [sym_variable_declaration] = STATE(1811),
    [sym_lexical_declaration] = STATE(1811),
    [sym_statement_block] = STATE(1811),
    [sym_if_statement] = STATE(1811),
    [sym_switch_statement] = STATE(1811),
    [sym_for_statement] = STATE(1811),
    [sym_for_in_statement] = STATE(1811),
    [sym_for_of_statement] = STATE(1811),
    [sym_while_statement] = STATE(1811),
    [sym_do_statement] = STATE(1811),
    [sym_try_statement] = STATE(1811),
    [sym_with_statement] = STATE(1811),
    [sym_break_statement] = STATE(1811),
    [sym_continue_statement] = STATE(1811),
    [sym_debugger_statement] = STATE(1811),
    [sym_return_statement] = STATE(1811),
    [sym_throw_statement] = STATE(1811),
    [sym_empty_statement] = STATE(1811),
    [sym_labeled_statement] = STATE(1811),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1768] = {
    [sym_export_statement] = STATE(1812),
    [sym__declaration] = STATE(1812),
    [sym_import_statement] = STATE(1812),
    [sym_expression_statement] = STATE(1812),
    [sym_variable_declaration] = STATE(1812),
    [sym_lexical_declaration] = STATE(1812),
    [sym_statement_block] = STATE(1812),
    [sym_if_statement] = STATE(1812),
    [sym_switch_statement] = STATE(1812),
    [sym_for_statement] = STATE(1812),
    [sym_for_in_statement] = STATE(1812),
    [sym_for_of_statement] = STATE(1812),
    [sym_while_statement] = STATE(1812),
    [sym_do_statement] = STATE(1812),
    [sym_try_statement] = STATE(1812),
    [sym_with_statement] = STATE(1812),
    [sym_break_statement] = STATE(1812),
    [sym_continue_statement] = STATE(1812),
    [sym_debugger_statement] = STATE(1812),
    [sym_return_statement] = STATE(1812),
    [sym_throw_statement] = STATE(1812),
    [sym_empty_statement] = STATE(1812),
    [sym_labeled_statement] = STATE(1812),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1769] = {
    [sym_export_statement] = STATE(1813),
    [sym__declaration] = STATE(1813),
    [sym_import_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_variable_declaration] = STATE(1813),
    [sym_lexical_declaration] = STATE(1813),
    [sym_statement_block] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_for_in_statement] = STATE(1813),
    [sym_for_of_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_with_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_debugger_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_throw_statement] = STATE(1813),
    [sym_empty_statement] = STATE(1813),
    [sym_labeled_statement] = STATE(1813),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1770] = {
    [sym_export_statement] = STATE(1814),
    [sym__declaration] = STATE(1814),
    [sym_import_statement] = STATE(1814),
    [sym_expression_statement] = STATE(1814),
    [sym_variable_declaration] = STATE(1814),
    [sym_lexical_declaration] = STATE(1814),
    [sym_statement_block] = STATE(1814),
    [sym_if_statement] = STATE(1814),
    [sym_switch_statement] = STATE(1814),
    [sym_for_statement] = STATE(1814),
    [sym_for_in_statement] = STATE(1814),
    [sym_for_of_statement] = STATE(1814),
    [sym_while_statement] = STATE(1814),
    [sym_do_statement] = STATE(1814),
    [sym_try_statement] = STATE(1814),
    [sym_with_statement] = STATE(1814),
    [sym_break_statement] = STATE(1814),
    [sym_continue_statement] = STATE(1814),
    [sym_debugger_statement] = STATE(1814),
    [sym_return_statement] = STATE(1814),
    [sym_throw_statement] = STATE(1814),
    [sym_empty_statement] = STATE(1814),
    [sym_labeled_statement] = STATE(1814),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1771] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4523),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1772] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4525),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1773] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4527),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1774] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(3712),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_COMMA] = ACTIONS(3712),
    [anon_sym_RBRACE] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_in] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2575),
    [anon_sym_GT] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2581),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2583),
    [anon_sym_AMP_AMP] = ACTIONS(2585),
    [anon_sym_PIPE_PIPE] = ACTIONS(2587),
    [anon_sym_GT_GT] = ACTIONS(2581),
    [anon_sym_GT_GT_GT] = ACTIONS(2579),
    [anon_sym_LT_LT] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PERCENT] = ACTIONS(2579),
    [anon_sym_LT_EQ] = ACTIONS(2595),
    [anon_sym_EQ_EQ] = ACTIONS(2575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2595),
    [anon_sym_BANG_EQ] = ACTIONS(2575),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2595),
    [anon_sym_GT_EQ] = ACTIONS(2595),
    [anon_sym_instanceof] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1775] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4529),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1776] = {
    [anon_sym_RPAREN] = ACTIONS(4529),
    [sym_comment] = ACTIONS(78),
  },
  [1777] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4531),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1778] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4533),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1779] = {
    [anon_sym_RPAREN] = ACTIONS(4533),
    [sym_comment] = ACTIONS(78),
  },
  [1780] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4535),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1781] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4537),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1782] = {
    [anon_sym_RPAREN] = ACTIONS(4537),
    [sym_comment] = ACTIONS(78),
  },
  [1783] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4539),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1784] = {
    [sym_export_statement] = STATE(1672),
    [sym__declaration] = STATE(1672),
    [sym_import_statement] = STATE(1672),
    [sym_expression_statement] = STATE(1672),
    [sym_variable_declaration] = STATE(1672),
    [sym_lexical_declaration] = STATE(1672),
    [sym_statement_block] = STATE(1672),
    [sym_if_statement] = STATE(1672),
    [sym_switch_statement] = STATE(1672),
    [sym_for_statement] = STATE(1672),
    [sym_for_in_statement] = STATE(1672),
    [sym_for_of_statement] = STATE(1672),
    [sym_while_statement] = STATE(1672),
    [sym_do_statement] = STATE(1672),
    [sym_try_statement] = STATE(1672),
    [sym_with_statement] = STATE(1672),
    [sym_break_statement] = STATE(1672),
    [sym_continue_statement] = STATE(1672),
    [sym_debugger_statement] = STATE(1672),
    [sym_return_statement] = STATE(1672),
    [sym_throw_statement] = STATE(1672),
    [sym_empty_statement] = STATE(1672),
    [sym_labeled_statement] = STATE(1672),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1785] = {
    [sym_export_statement] = STATE(1683),
    [sym__declaration] = STATE(1683),
    [sym_import_statement] = STATE(1683),
    [sym_expression_statement] = STATE(1683),
    [sym_variable_declaration] = STATE(1683),
    [sym_lexical_declaration] = STATE(1683),
    [sym_statement_block] = STATE(1683),
    [sym_if_statement] = STATE(1683),
    [sym_switch_statement] = STATE(1683),
    [sym_for_statement] = STATE(1683),
    [sym_for_in_statement] = STATE(1683),
    [sym_for_of_statement] = STATE(1683),
    [sym_while_statement] = STATE(1683),
    [sym_do_statement] = STATE(1683),
    [sym_try_statement] = STATE(1683),
    [sym_with_statement] = STATE(1683),
    [sym_break_statement] = STATE(1683),
    [sym_continue_statement] = STATE(1683),
    [sym_debugger_statement] = STATE(1683),
    [sym_return_statement] = STATE(1683),
    [sym_throw_statement] = STATE(1683),
    [sym_empty_statement] = STATE(1683),
    [sym_labeled_statement] = STATE(1683),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1786] = {
    [sym_export_statement] = STATE(1688),
    [sym__declaration] = STATE(1688),
    [sym_import_statement] = STATE(1688),
    [sym_expression_statement] = STATE(1688),
    [sym_variable_declaration] = STATE(1688),
    [sym_lexical_declaration] = STATE(1688),
    [sym_statement_block] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_switch_statement] = STATE(1688),
    [sym_for_statement] = STATE(1688),
    [sym_for_in_statement] = STATE(1688),
    [sym_for_of_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_do_statement] = STATE(1688),
    [sym_try_statement] = STATE(1688),
    [sym_with_statement] = STATE(1688),
    [sym_break_statement] = STATE(1688),
    [sym_continue_statement] = STATE(1688),
    [sym_debugger_statement] = STATE(1688),
    [sym_return_statement] = STATE(1688),
    [sym_throw_statement] = STATE(1688),
    [sym_empty_statement] = STATE(1688),
    [sym_labeled_statement] = STATE(1688),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1787] = {
    [sym_export_statement] = STATE(1689),
    [sym__declaration] = STATE(1689),
    [sym_import_statement] = STATE(1689),
    [sym_expression_statement] = STATE(1689),
    [sym_variable_declaration] = STATE(1689),
    [sym_lexical_declaration] = STATE(1689),
    [sym_statement_block] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_switch_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_for_in_statement] = STATE(1689),
    [sym_for_of_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_do_statement] = STATE(1689),
    [sym_try_statement] = STATE(1689),
    [sym_with_statement] = STATE(1689),
    [sym_break_statement] = STATE(1689),
    [sym_continue_statement] = STATE(1689),
    [sym_debugger_statement] = STATE(1689),
    [sym_return_statement] = STATE(1689),
    [sym_throw_statement] = STATE(1689),
    [sym_empty_statement] = STATE(1689),
    [sym_labeled_statement] = STATE(1689),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1788] = {
    [sym_export_statement] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym_import_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_lexical_declaration] = STATE(1690),
    [sym_statement_block] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_for_in_statement] = STATE(1690),
    [sym_for_of_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_try_statement] = STATE(1690),
    [sym_with_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_debugger_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_throw_statement] = STATE(1690),
    [sym_empty_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1789] = {
    [sym_export_statement] = STATE(1691),
    [sym__declaration] = STATE(1691),
    [sym_import_statement] = STATE(1691),
    [sym_expression_statement] = STATE(1691),
    [sym_variable_declaration] = STATE(1691),
    [sym_lexical_declaration] = STATE(1691),
    [sym_statement_block] = STATE(1691),
    [sym_if_statement] = STATE(1691),
    [sym_switch_statement] = STATE(1691),
    [sym_for_statement] = STATE(1691),
    [sym_for_in_statement] = STATE(1691),
    [sym_for_of_statement] = STATE(1691),
    [sym_while_statement] = STATE(1691),
    [sym_do_statement] = STATE(1691),
    [sym_try_statement] = STATE(1691),
    [sym_with_statement] = STATE(1691),
    [sym_break_statement] = STATE(1691),
    [sym_continue_statement] = STATE(1691),
    [sym_debugger_statement] = STATE(1691),
    [sym_return_statement] = STATE(1691),
    [sym_throw_statement] = STATE(1691),
    [sym_empty_statement] = STATE(1691),
    [sym_labeled_statement] = STATE(1691),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1790] = {
    [sym_export_statement] = STATE(1692),
    [sym__declaration] = STATE(1692),
    [sym_import_statement] = STATE(1692),
    [sym_expression_statement] = STATE(1692),
    [sym_variable_declaration] = STATE(1692),
    [sym_lexical_declaration] = STATE(1692),
    [sym_statement_block] = STATE(1692),
    [sym_if_statement] = STATE(1692),
    [sym_switch_statement] = STATE(1692),
    [sym_for_statement] = STATE(1692),
    [sym_for_in_statement] = STATE(1692),
    [sym_for_of_statement] = STATE(1692),
    [sym_while_statement] = STATE(1692),
    [sym_do_statement] = STATE(1692),
    [sym_try_statement] = STATE(1692),
    [sym_with_statement] = STATE(1692),
    [sym_break_statement] = STATE(1692),
    [sym_continue_statement] = STATE(1692),
    [sym_debugger_statement] = STATE(1692),
    [sym_return_statement] = STATE(1692),
    [sym_throw_statement] = STATE(1692),
    [sym_empty_statement] = STATE(1692),
    [sym_labeled_statement] = STATE(1692),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1791] = {
    [sym_parenthesized_expression] = STATE(1889),
    [sym__expression] = STATE(1889),
    [sym_yield_expression] = STATE(1889),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1889),
    [sym_jsx_fragment] = STATE(1889),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1889),
    [sym_anonymous_class] = STATE(1889),
    [sym_class] = STATE(1889),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1889),
    [sym_generator_function] = STATE(1889),
    [sym_call_expression] = STATE(1889),
    [sym_new_expression] = STATE(1889),
    [sym_await_expression] = STATE(1889),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1889),
    [sym_augmented_assignment_expression] = STATE(1889),
    [sym_ternary_expression] = STATE(1889),
    [sym_binary_expression] = STATE(1889),
    [sym_unary_expression] = STATE(1889),
    [sym_update_expression] = STATE(1889),
    [sym_string] = STATE(1889),
    [sym_template_string] = STATE(1889),
    [sym_regex] = STATE(1889),
    [sym_meta_property] = STATE(1889),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4541),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4543),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4543),
    [sym_false] = ACTIONS(4543),
    [sym_null] = ACTIONS(4543),
    [sym_undefined] = ACTIONS(4543),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1792] = {
    [sym_parenthesized_expression] = STATE(1890),
    [sym__expression] = STATE(1890),
    [sym_yield_expression] = STATE(1890),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1890),
    [sym_jsx_fragment] = STATE(1890),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1890),
    [sym_anonymous_class] = STATE(1890),
    [sym_class] = STATE(1890),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1890),
    [sym_generator_function] = STATE(1890),
    [sym_call_expression] = STATE(1890),
    [sym_new_expression] = STATE(1890),
    [sym_await_expression] = STATE(1890),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1890),
    [sym_augmented_assignment_expression] = STATE(1890),
    [sym_ternary_expression] = STATE(1890),
    [sym_binary_expression] = STATE(1890),
    [sym_unary_expression] = STATE(1890),
    [sym_update_expression] = STATE(1890),
    [sym_string] = STATE(1890),
    [sym_template_string] = STATE(1890),
    [sym_regex] = STATE(1890),
    [sym_meta_property] = STATE(1890),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4545),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4547),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4547),
    [sym_false] = ACTIONS(4547),
    [sym_null] = ACTIONS(4547),
    [sym_undefined] = ACTIONS(4547),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1793] = {
    [sym_parenthesized_expression] = STATE(1891),
    [sym__expression] = STATE(1891),
    [sym_yield_expression] = STATE(1891),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1891),
    [sym_jsx_fragment] = STATE(1891),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1891),
    [sym_anonymous_class] = STATE(1891),
    [sym_class] = STATE(1891),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1891),
    [sym_generator_function] = STATE(1891),
    [sym_call_expression] = STATE(1891),
    [sym_new_expression] = STATE(1891),
    [sym_await_expression] = STATE(1891),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1891),
    [sym_augmented_assignment_expression] = STATE(1891),
    [sym_ternary_expression] = STATE(1891),
    [sym_binary_expression] = STATE(1891),
    [sym_unary_expression] = STATE(1891),
    [sym_update_expression] = STATE(1891),
    [sym_string] = STATE(1891),
    [sym_template_string] = STATE(1891),
    [sym_regex] = STATE(1891),
    [sym_meta_property] = STATE(1891),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4549),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4551),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4551),
    [sym_false] = ACTIONS(4551),
    [sym_null] = ACTIONS(4551),
    [sym_undefined] = ACTIONS(4551),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1794] = {
    [sym_parenthesized_expression] = STATE(1892),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [1795] = {
    [anon_sym_LPAREN] = ACTIONS(4553),
    [anon_sym_await] = ACTIONS(4555),
    [sym_comment] = ACTIONS(78),
  },
  [1796] = {
    [sym_parenthesized_expression] = STATE(1895),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [1797] = {
    [sym_parenthesized_expression] = STATE(1896),
    [anon_sym_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(78),
  },
  [1798] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_COLON] = ACTIONS(4557),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1799] = {
    [anon_sym_export] = ACTIONS(1724),
    [anon_sym_default] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_import] = ACTIONS(1724),
    [anon_sym_var] = ACTIONS(1724),
    [anon_sym_let] = ACTIONS(1724),
    [anon_sym_const] = ACTIONS(1724),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_else] = ACTIONS(4559),
    [anon_sym_switch] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1724),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_await] = ACTIONS(1724),
    [anon_sym_while] = ACTIONS(1724),
    [anon_sym_do] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(1724),
    [anon_sym_with] = ACTIONS(1724),
    [anon_sym_break] = ACTIONS(1724),
    [anon_sym_continue] = ACTIONS(1724),
    [anon_sym_debugger] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1724),
    [anon_sym_throw] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_case] = ACTIONS(1724),
    [anon_sym_yield] = ACTIONS(1724),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1724),
    [anon_sym_class] = ACTIONS(1724),
    [anon_sym_async] = ACTIONS(1724),
    [anon_sym_function] = ACTIONS(1724),
    [anon_sym_EQ_GT] = ACTIONS(1722),
    [anon_sym_new] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_typeof] = ACTIONS(1724),
    [anon_sym_void] = ACTIONS(1724),
    [anon_sym_delete] = ACTIONS(1724),
    [anon_sym_PLUS_PLUS] = ACTIONS(1722),
    [anon_sym_DASH_DASH] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [sym_number] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1724),
    [sym_this] = ACTIONS(1724),
    [sym_super] = ACTIONS(1724),
    [sym_true] = ACTIONS(1724),
    [sym_false] = ACTIONS(1724),
    [sym_null] = ACTIONS(1724),
    [sym_undefined] = ACTIONS(1724),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_get] = ACTIONS(1724),
    [anon_sym_set] = ACTIONS(1724),
  },
  [1800] = {
    [sym_variable_declarator] = STATE(93),
    [sym_object] = STATE(1900),
    [sym_array] = STATE(1901),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4561),
  },
  [1801] = {
    [sym_variable_declarator] = STATE(96),
    [sym_object] = STATE(1900),
    [sym_array] = STATE(1901),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4561),
  },
  [1802] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(4563),
    [anon_sym_of] = ACTIONS(4565),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1803] = {
    [sym_expression_statement] = STATE(1904),
    [sym_empty_statement] = STATE(1904),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1804] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(4567),
    [anon_sym_of] = ACTIONS(4569),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1805] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(4571),
    [anon_sym_of] = ACTIONS(4573),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1806] = {
    [sym_object] = STATE(1911),
    [sym_array] = STATE(1912),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_var] = ACTIONS(4575),
    [anon_sym_let] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4575),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4577),
  },
  [1807] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1808] = {
    [sym_parenthesized_expression] = STATE(1913),
    [sym__expression] = STATE(1913),
    [sym_yield_expression] = STATE(1913),
    [sym_object] = STATE(1173),
    [sym_array] = STATE(1174),
    [sym_jsx_element] = STATE(1913),
    [sym_jsx_fragment] = STATE(1913),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1913),
    [sym_anonymous_class] = STATE(1913),
    [sym_class] = STATE(1913),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1913),
    [sym_generator_function] = STATE(1913),
    [sym_call_expression] = STATE(1913),
    [sym_new_expression] = STATE(1913),
    [sym_await_expression] = STATE(1913),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1913),
    [sym_augmented_assignment_expression] = STATE(1913),
    [sym_ternary_expression] = STATE(1913),
    [sym_binary_expression] = STATE(1913),
    [sym_unary_expression] = STATE(1913),
    [sym_update_expression] = STATE(1913),
    [sym_string] = STATE(1913),
    [sym_template_string] = STATE(1913),
    [sym_regex] = STATE(1913),
    [sym_meta_property] = STATE(1913),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_typeof] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4579),
    [sym_identifier] = ACTIONS(2676),
    [sym_this] = ACTIONS(4581),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4581),
    [sym_false] = ACTIONS(4581),
    [sym_null] = ACTIONS(4581),
    [sym_undefined] = ACTIONS(4581),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2680),
    [anon_sym_set] = ACTIONS(2680),
  },
  [1809] = {
    [ts_builtin_sym_end] = ACTIONS(4583),
    [anon_sym_export] = ACTIONS(4585),
    [anon_sym_default] = ACTIONS(4585),
    [anon_sym_LBRACE] = ACTIONS(4583),
    [anon_sym_RBRACE] = ACTIONS(4583),
    [anon_sym_import] = ACTIONS(4585),
    [anon_sym_var] = ACTIONS(4585),
    [anon_sym_let] = ACTIONS(4585),
    [anon_sym_const] = ACTIONS(4585),
    [anon_sym_if] = ACTIONS(4585),
    [anon_sym_else] = ACTIONS(4585),
    [anon_sym_switch] = ACTIONS(4585),
    [anon_sym_for] = ACTIONS(4585),
    [anon_sym_LPAREN] = ACTIONS(4583),
    [anon_sym_await] = ACTIONS(4585),
    [anon_sym_while] = ACTIONS(4585),
    [anon_sym_do] = ACTIONS(4585),
    [anon_sym_try] = ACTIONS(4585),
    [anon_sym_with] = ACTIONS(4585),
    [anon_sym_break] = ACTIONS(4585),
    [anon_sym_continue] = ACTIONS(4585),
    [anon_sym_debugger] = ACTIONS(4585),
    [anon_sym_return] = ACTIONS(4585),
    [anon_sym_throw] = ACTIONS(4585),
    [anon_sym_SEMI] = ACTIONS(4583),
    [anon_sym_case] = ACTIONS(4585),
    [anon_sym_yield] = ACTIONS(4585),
    [anon_sym_LBRACK] = ACTIONS(4583),
    [anon_sym_LT] = ACTIONS(4583),
    [anon_sym_SLASH] = ACTIONS(4585),
    [anon_sym_class] = ACTIONS(4585),
    [anon_sym_async] = ACTIONS(4585),
    [anon_sym_function] = ACTIONS(4585),
    [anon_sym_EQ_GT] = ACTIONS(4583),
    [anon_sym_new] = ACTIONS(4585),
    [anon_sym_PLUS] = ACTIONS(4585),
    [anon_sym_DASH] = ACTIONS(4585),
    [anon_sym_BANG] = ACTIONS(4583),
    [anon_sym_TILDE] = ACTIONS(4583),
    [anon_sym_typeof] = ACTIONS(4585),
    [anon_sym_void] = ACTIONS(4585),
    [anon_sym_delete] = ACTIONS(4585),
    [anon_sym_PLUS_PLUS] = ACTIONS(4583),
    [anon_sym_DASH_DASH] = ACTIONS(4583),
    [anon_sym_DQUOTE] = ACTIONS(4583),
    [anon_sym_SQUOTE] = ACTIONS(4583),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4583),
    [sym_number] = ACTIONS(4583),
    [sym_identifier] = ACTIONS(4585),
    [sym_this] = ACTIONS(4585),
    [sym_super] = ACTIONS(4585),
    [sym_true] = ACTIONS(4585),
    [sym_false] = ACTIONS(4585),
    [sym_null] = ACTIONS(4585),
    [sym_undefined] = ACTIONS(4585),
    [anon_sym_AT] = ACTIONS(4583),
    [anon_sym_get] = ACTIONS(4585),
    [anon_sym_set] = ACTIONS(4585),
  },
  [1810] = {
    [ts_builtin_sym_end] = ACTIONS(4587),
    [anon_sym_export] = ACTIONS(4589),
    [anon_sym_default] = ACTIONS(4589),
    [anon_sym_LBRACE] = ACTIONS(4587),
    [anon_sym_RBRACE] = ACTIONS(4587),
    [anon_sym_import] = ACTIONS(4589),
    [anon_sym_var] = ACTIONS(4589),
    [anon_sym_let] = ACTIONS(4589),
    [anon_sym_const] = ACTIONS(4589),
    [anon_sym_if] = ACTIONS(4589),
    [anon_sym_else] = ACTIONS(4589),
    [anon_sym_switch] = ACTIONS(4589),
    [anon_sym_for] = ACTIONS(4589),
    [anon_sym_LPAREN] = ACTIONS(4587),
    [anon_sym_await] = ACTIONS(4589),
    [anon_sym_while] = ACTIONS(4589),
    [anon_sym_do] = ACTIONS(4589),
    [anon_sym_try] = ACTIONS(4589),
    [anon_sym_with] = ACTIONS(4589),
    [anon_sym_break] = ACTIONS(4589),
    [anon_sym_continue] = ACTIONS(4589),
    [anon_sym_debugger] = ACTIONS(4589),
    [anon_sym_return] = ACTIONS(4589),
    [anon_sym_throw] = ACTIONS(4589),
    [anon_sym_SEMI] = ACTIONS(4587),
    [anon_sym_case] = ACTIONS(4589),
    [anon_sym_yield] = ACTIONS(4589),
    [anon_sym_LBRACK] = ACTIONS(4587),
    [anon_sym_LT] = ACTIONS(4587),
    [anon_sym_SLASH] = ACTIONS(4589),
    [anon_sym_class] = ACTIONS(4589),
    [anon_sym_async] = ACTIONS(4589),
    [anon_sym_function] = ACTIONS(4589),
    [anon_sym_EQ_GT] = ACTIONS(4587),
    [anon_sym_new] = ACTIONS(4589),
    [anon_sym_PLUS] = ACTIONS(4589),
    [anon_sym_DASH] = ACTIONS(4589),
    [anon_sym_BANG] = ACTIONS(4587),
    [anon_sym_TILDE] = ACTIONS(4587),
    [anon_sym_typeof] = ACTIONS(4589),
    [anon_sym_void] = ACTIONS(4589),
    [anon_sym_delete] = ACTIONS(4589),
    [anon_sym_PLUS_PLUS] = ACTIONS(4587),
    [anon_sym_DASH_DASH] = ACTIONS(4587),
    [anon_sym_DQUOTE] = ACTIONS(4587),
    [anon_sym_SQUOTE] = ACTIONS(4587),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4587),
    [sym_number] = ACTIONS(4587),
    [sym_identifier] = ACTIONS(4589),
    [sym_this] = ACTIONS(4589),
    [sym_super] = ACTIONS(4589),
    [sym_true] = ACTIONS(4589),
    [sym_false] = ACTIONS(4589),
    [sym_null] = ACTIONS(4589),
    [sym_undefined] = ACTIONS(4589),
    [anon_sym_AT] = ACTIONS(4587),
    [anon_sym_get] = ACTIONS(4589),
    [anon_sym_set] = ACTIONS(4589),
  },
  [1811] = {
    [ts_builtin_sym_end] = ACTIONS(4591),
    [anon_sym_export] = ACTIONS(4593),
    [anon_sym_default] = ACTIONS(4593),
    [anon_sym_LBRACE] = ACTIONS(4591),
    [anon_sym_RBRACE] = ACTIONS(4591),
    [anon_sym_import] = ACTIONS(4593),
    [anon_sym_var] = ACTIONS(4593),
    [anon_sym_let] = ACTIONS(4593),
    [anon_sym_const] = ACTIONS(4593),
    [anon_sym_if] = ACTIONS(4593),
    [anon_sym_else] = ACTIONS(4593),
    [anon_sym_switch] = ACTIONS(4593),
    [anon_sym_for] = ACTIONS(4593),
    [anon_sym_LPAREN] = ACTIONS(4591),
    [anon_sym_await] = ACTIONS(4593),
    [anon_sym_while] = ACTIONS(4593),
    [anon_sym_do] = ACTIONS(4593),
    [anon_sym_try] = ACTIONS(4593),
    [anon_sym_with] = ACTIONS(4593),
    [anon_sym_break] = ACTIONS(4593),
    [anon_sym_continue] = ACTIONS(4593),
    [anon_sym_debugger] = ACTIONS(4593),
    [anon_sym_return] = ACTIONS(4593),
    [anon_sym_throw] = ACTIONS(4593),
    [anon_sym_SEMI] = ACTIONS(4591),
    [anon_sym_case] = ACTIONS(4593),
    [anon_sym_yield] = ACTIONS(4593),
    [anon_sym_LBRACK] = ACTIONS(4591),
    [anon_sym_LT] = ACTIONS(4591),
    [anon_sym_SLASH] = ACTIONS(4593),
    [anon_sym_class] = ACTIONS(4593),
    [anon_sym_async] = ACTIONS(4593),
    [anon_sym_function] = ACTIONS(4593),
    [anon_sym_EQ_GT] = ACTIONS(4591),
    [anon_sym_new] = ACTIONS(4593),
    [anon_sym_PLUS] = ACTIONS(4593),
    [anon_sym_DASH] = ACTIONS(4593),
    [anon_sym_BANG] = ACTIONS(4591),
    [anon_sym_TILDE] = ACTIONS(4591),
    [anon_sym_typeof] = ACTIONS(4593),
    [anon_sym_void] = ACTIONS(4593),
    [anon_sym_delete] = ACTIONS(4593),
    [anon_sym_PLUS_PLUS] = ACTIONS(4591),
    [anon_sym_DASH_DASH] = ACTIONS(4591),
    [anon_sym_DQUOTE] = ACTIONS(4591),
    [anon_sym_SQUOTE] = ACTIONS(4591),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4591),
    [sym_number] = ACTIONS(4591),
    [sym_identifier] = ACTIONS(4593),
    [sym_this] = ACTIONS(4593),
    [sym_super] = ACTIONS(4593),
    [sym_true] = ACTIONS(4593),
    [sym_false] = ACTIONS(4593),
    [sym_null] = ACTIONS(4593),
    [sym_undefined] = ACTIONS(4593),
    [anon_sym_AT] = ACTIONS(4591),
    [anon_sym_get] = ACTIONS(4593),
    [anon_sym_set] = ACTIONS(4593),
  },
  [1812] = {
    [ts_builtin_sym_end] = ACTIONS(4595),
    [anon_sym_export] = ACTIONS(4597),
    [anon_sym_default] = ACTIONS(4597),
    [anon_sym_LBRACE] = ACTIONS(4595),
    [anon_sym_RBRACE] = ACTIONS(4595),
    [anon_sym_import] = ACTIONS(4597),
    [anon_sym_var] = ACTIONS(4597),
    [anon_sym_let] = ACTIONS(4597),
    [anon_sym_const] = ACTIONS(4597),
    [anon_sym_if] = ACTIONS(4597),
    [anon_sym_else] = ACTIONS(4597),
    [anon_sym_switch] = ACTIONS(4597),
    [anon_sym_for] = ACTIONS(4597),
    [anon_sym_LPAREN] = ACTIONS(4595),
    [anon_sym_await] = ACTIONS(4597),
    [anon_sym_while] = ACTIONS(4597),
    [anon_sym_do] = ACTIONS(4597),
    [anon_sym_try] = ACTIONS(4597),
    [anon_sym_with] = ACTIONS(4597),
    [anon_sym_break] = ACTIONS(4597),
    [anon_sym_continue] = ACTIONS(4597),
    [anon_sym_debugger] = ACTIONS(4597),
    [anon_sym_return] = ACTIONS(4597),
    [anon_sym_throw] = ACTIONS(4597),
    [anon_sym_SEMI] = ACTIONS(4595),
    [anon_sym_case] = ACTIONS(4597),
    [anon_sym_yield] = ACTIONS(4597),
    [anon_sym_LBRACK] = ACTIONS(4595),
    [anon_sym_LT] = ACTIONS(4595),
    [anon_sym_SLASH] = ACTIONS(4597),
    [anon_sym_class] = ACTIONS(4597),
    [anon_sym_async] = ACTIONS(4597),
    [anon_sym_function] = ACTIONS(4597),
    [anon_sym_EQ_GT] = ACTIONS(4595),
    [anon_sym_new] = ACTIONS(4597),
    [anon_sym_PLUS] = ACTIONS(4597),
    [anon_sym_DASH] = ACTIONS(4597),
    [anon_sym_BANG] = ACTIONS(4595),
    [anon_sym_TILDE] = ACTIONS(4595),
    [anon_sym_typeof] = ACTIONS(4597),
    [anon_sym_void] = ACTIONS(4597),
    [anon_sym_delete] = ACTIONS(4597),
    [anon_sym_PLUS_PLUS] = ACTIONS(4595),
    [anon_sym_DASH_DASH] = ACTIONS(4595),
    [anon_sym_DQUOTE] = ACTIONS(4595),
    [anon_sym_SQUOTE] = ACTIONS(4595),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4595),
    [sym_number] = ACTIONS(4595),
    [sym_identifier] = ACTIONS(4597),
    [sym_this] = ACTIONS(4597),
    [sym_super] = ACTIONS(4597),
    [sym_true] = ACTIONS(4597),
    [sym_false] = ACTIONS(4597),
    [sym_null] = ACTIONS(4597),
    [sym_undefined] = ACTIONS(4597),
    [anon_sym_AT] = ACTIONS(4595),
    [anon_sym_get] = ACTIONS(4597),
    [anon_sym_set] = ACTIONS(4597),
  },
  [1813] = {
    [ts_builtin_sym_end] = ACTIONS(4599),
    [anon_sym_export] = ACTIONS(4601),
    [anon_sym_default] = ACTIONS(4601),
    [anon_sym_LBRACE] = ACTIONS(4599),
    [anon_sym_RBRACE] = ACTIONS(4599),
    [anon_sym_import] = ACTIONS(4601),
    [anon_sym_var] = ACTIONS(4601),
    [anon_sym_let] = ACTIONS(4601),
    [anon_sym_const] = ACTIONS(4601),
    [anon_sym_if] = ACTIONS(4601),
    [anon_sym_else] = ACTIONS(4601),
    [anon_sym_switch] = ACTIONS(4601),
    [anon_sym_for] = ACTIONS(4601),
    [anon_sym_LPAREN] = ACTIONS(4599),
    [anon_sym_await] = ACTIONS(4601),
    [anon_sym_while] = ACTIONS(4601),
    [anon_sym_do] = ACTIONS(4601),
    [anon_sym_try] = ACTIONS(4601),
    [anon_sym_with] = ACTIONS(4601),
    [anon_sym_break] = ACTIONS(4601),
    [anon_sym_continue] = ACTIONS(4601),
    [anon_sym_debugger] = ACTIONS(4601),
    [anon_sym_return] = ACTIONS(4601),
    [anon_sym_throw] = ACTIONS(4601),
    [anon_sym_SEMI] = ACTIONS(4599),
    [anon_sym_case] = ACTIONS(4601),
    [anon_sym_yield] = ACTIONS(4601),
    [anon_sym_LBRACK] = ACTIONS(4599),
    [anon_sym_LT] = ACTIONS(4599),
    [anon_sym_SLASH] = ACTIONS(4601),
    [anon_sym_class] = ACTIONS(4601),
    [anon_sym_async] = ACTIONS(4601),
    [anon_sym_function] = ACTIONS(4601),
    [anon_sym_EQ_GT] = ACTIONS(4599),
    [anon_sym_new] = ACTIONS(4601),
    [anon_sym_PLUS] = ACTIONS(4601),
    [anon_sym_DASH] = ACTIONS(4601),
    [anon_sym_BANG] = ACTIONS(4599),
    [anon_sym_TILDE] = ACTIONS(4599),
    [anon_sym_typeof] = ACTIONS(4601),
    [anon_sym_void] = ACTIONS(4601),
    [anon_sym_delete] = ACTIONS(4601),
    [anon_sym_PLUS_PLUS] = ACTIONS(4599),
    [anon_sym_DASH_DASH] = ACTIONS(4599),
    [anon_sym_DQUOTE] = ACTIONS(4599),
    [anon_sym_SQUOTE] = ACTIONS(4599),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4599),
    [sym_number] = ACTIONS(4599),
    [sym_identifier] = ACTIONS(4601),
    [sym_this] = ACTIONS(4601),
    [sym_super] = ACTIONS(4601),
    [sym_true] = ACTIONS(4601),
    [sym_false] = ACTIONS(4601),
    [sym_null] = ACTIONS(4601),
    [sym_undefined] = ACTIONS(4601),
    [anon_sym_AT] = ACTIONS(4599),
    [anon_sym_get] = ACTIONS(4601),
    [anon_sym_set] = ACTIONS(4601),
  },
  [1814] = {
    [ts_builtin_sym_end] = ACTIONS(4603),
    [anon_sym_export] = ACTIONS(4605),
    [anon_sym_default] = ACTIONS(4605),
    [anon_sym_LBRACE] = ACTIONS(4603),
    [anon_sym_RBRACE] = ACTIONS(4603),
    [anon_sym_import] = ACTIONS(4605),
    [anon_sym_var] = ACTIONS(4605),
    [anon_sym_let] = ACTIONS(4605),
    [anon_sym_const] = ACTIONS(4605),
    [anon_sym_if] = ACTIONS(4605),
    [anon_sym_else] = ACTIONS(4605),
    [anon_sym_switch] = ACTIONS(4605),
    [anon_sym_for] = ACTIONS(4605),
    [anon_sym_LPAREN] = ACTIONS(4603),
    [anon_sym_await] = ACTIONS(4605),
    [anon_sym_while] = ACTIONS(4605),
    [anon_sym_do] = ACTIONS(4605),
    [anon_sym_try] = ACTIONS(4605),
    [anon_sym_with] = ACTIONS(4605),
    [anon_sym_break] = ACTIONS(4605),
    [anon_sym_continue] = ACTIONS(4605),
    [anon_sym_debugger] = ACTIONS(4605),
    [anon_sym_return] = ACTIONS(4605),
    [anon_sym_throw] = ACTIONS(4605),
    [anon_sym_SEMI] = ACTIONS(4603),
    [anon_sym_case] = ACTIONS(4605),
    [anon_sym_yield] = ACTIONS(4605),
    [anon_sym_LBRACK] = ACTIONS(4603),
    [anon_sym_LT] = ACTIONS(4603),
    [anon_sym_SLASH] = ACTIONS(4605),
    [anon_sym_class] = ACTIONS(4605),
    [anon_sym_async] = ACTIONS(4605),
    [anon_sym_function] = ACTIONS(4605),
    [anon_sym_EQ_GT] = ACTIONS(4603),
    [anon_sym_new] = ACTIONS(4605),
    [anon_sym_PLUS] = ACTIONS(4605),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_BANG] = ACTIONS(4603),
    [anon_sym_TILDE] = ACTIONS(4603),
    [anon_sym_typeof] = ACTIONS(4605),
    [anon_sym_void] = ACTIONS(4605),
    [anon_sym_delete] = ACTIONS(4605),
    [anon_sym_PLUS_PLUS] = ACTIONS(4603),
    [anon_sym_DASH_DASH] = ACTIONS(4603),
    [anon_sym_DQUOTE] = ACTIONS(4603),
    [anon_sym_SQUOTE] = ACTIONS(4603),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4603),
    [sym_number] = ACTIONS(4603),
    [sym_identifier] = ACTIONS(4605),
    [sym_this] = ACTIONS(4605),
    [sym_super] = ACTIONS(4605),
    [sym_true] = ACTIONS(4605),
    [sym_false] = ACTIONS(4605),
    [sym_null] = ACTIONS(4605),
    [sym_undefined] = ACTIONS(4605),
    [anon_sym_AT] = ACTIONS(4603),
    [anon_sym_get] = ACTIONS(4605),
    [anon_sym_set] = ACTIONS(4605),
  },
  [1815] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(3018),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1816] = {
    [sym_parenthesized_expression] = STATE(1914),
    [sym__expression] = STATE(1914),
    [sym_yield_expression] = STATE(1914),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1914),
    [sym_jsx_fragment] = STATE(1914),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1914),
    [sym_anonymous_class] = STATE(1914),
    [sym_class] = STATE(1914),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1914),
    [sym_generator_function] = STATE(1914),
    [sym_call_expression] = STATE(1914),
    [sym_new_expression] = STATE(1914),
    [sym_await_expression] = STATE(1914),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1914),
    [sym_augmented_assignment_expression] = STATE(1914),
    [sym_ternary_expression] = STATE(1914),
    [sym_binary_expression] = STATE(1914),
    [sym_unary_expression] = STATE(1914),
    [sym_update_expression] = STATE(1914),
    [sym_string] = STATE(1914),
    [sym_template_string] = STATE(1914),
    [sym_regex] = STATE(1914),
    [sym_meta_property] = STATE(1914),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4607),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4609),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4609),
    [sym_false] = ACTIONS(4609),
    [sym_null] = ACTIONS(4609),
    [sym_undefined] = ACTIONS(4609),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1817] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1818] = {
    [sym_parenthesized_expression] = STATE(1915),
    [sym__expression] = STATE(1915),
    [sym_yield_expression] = STATE(1915),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1915),
    [sym_jsx_fragment] = STATE(1915),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1915),
    [sym_anonymous_class] = STATE(1915),
    [sym_class] = STATE(1915),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1915),
    [sym_generator_function] = STATE(1915),
    [sym_call_expression] = STATE(1915),
    [sym_new_expression] = STATE(1915),
    [sym_await_expression] = STATE(1915),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1915),
    [sym_augmented_assignment_expression] = STATE(1915),
    [sym_ternary_expression] = STATE(1915),
    [sym_binary_expression] = STATE(1915),
    [sym_unary_expression] = STATE(1915),
    [sym_update_expression] = STATE(1915),
    [sym_string] = STATE(1915),
    [sym_template_string] = STATE(1915),
    [sym_regex] = STATE(1915),
    [sym_meta_property] = STATE(1915),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4611),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4613),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4613),
    [sym_false] = ACTIONS(4613),
    [sym_null] = ACTIONS(4613),
    [sym_undefined] = ACTIONS(4613),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1819] = {
    [sym_export_statement] = STATE(1916),
    [sym__declaration] = STATE(1916),
    [sym_import_statement] = STATE(1916),
    [sym_expression_statement] = STATE(1916),
    [sym_variable_declaration] = STATE(1916),
    [sym_lexical_declaration] = STATE(1916),
    [sym_statement_block] = STATE(1916),
    [sym_if_statement] = STATE(1916),
    [sym_switch_statement] = STATE(1916),
    [sym_for_statement] = STATE(1916),
    [sym_for_in_statement] = STATE(1916),
    [sym_for_of_statement] = STATE(1916),
    [sym_while_statement] = STATE(1916),
    [sym_do_statement] = STATE(1916),
    [sym_try_statement] = STATE(1916),
    [sym_with_statement] = STATE(1916),
    [sym_break_statement] = STATE(1916),
    [sym_continue_statement] = STATE(1916),
    [sym_debugger_statement] = STATE(1916),
    [sym_return_statement] = STATE(1916),
    [sym_throw_statement] = STATE(1916),
    [sym_empty_statement] = STATE(1916),
    [sym_labeled_statement] = STATE(1916),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1820] = {
    [sym_export_statement] = STATE(1917),
    [sym__declaration] = STATE(1917),
    [sym_import_statement] = STATE(1917),
    [sym_expression_statement] = STATE(1917),
    [sym_variable_declaration] = STATE(1917),
    [sym_lexical_declaration] = STATE(1917),
    [sym_statement_block] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_switch_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_for_in_statement] = STATE(1917),
    [sym_for_of_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_do_statement] = STATE(1917),
    [sym_try_statement] = STATE(1917),
    [sym_with_statement] = STATE(1917),
    [sym_break_statement] = STATE(1917),
    [sym_continue_statement] = STATE(1917),
    [sym_debugger_statement] = STATE(1917),
    [sym_return_statement] = STATE(1917),
    [sym_throw_statement] = STATE(1917),
    [sym_empty_statement] = STATE(1917),
    [sym_labeled_statement] = STATE(1917),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1821] = {
    [sym_export_statement] = STATE(1918),
    [sym__declaration] = STATE(1918),
    [sym_import_statement] = STATE(1918),
    [sym_expression_statement] = STATE(1918),
    [sym_variable_declaration] = STATE(1918),
    [sym_lexical_declaration] = STATE(1918),
    [sym_statement_block] = STATE(1918),
    [sym_if_statement] = STATE(1918),
    [sym_switch_statement] = STATE(1918),
    [sym_for_statement] = STATE(1918),
    [sym_for_in_statement] = STATE(1918),
    [sym_for_of_statement] = STATE(1918),
    [sym_while_statement] = STATE(1918),
    [sym_do_statement] = STATE(1918),
    [sym_try_statement] = STATE(1918),
    [sym_with_statement] = STATE(1918),
    [sym_break_statement] = STATE(1918),
    [sym_continue_statement] = STATE(1918),
    [sym_debugger_statement] = STATE(1918),
    [sym_return_statement] = STATE(1918),
    [sym_throw_statement] = STATE(1918),
    [sym_empty_statement] = STATE(1918),
    [sym_labeled_statement] = STATE(1918),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(30),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(36),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(84),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1822] = {
    [sym_parenthesized_expression] = STATE(1919),
    [sym__expression] = STATE(1919),
    [sym_yield_expression] = STATE(1919),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1919),
    [sym_jsx_fragment] = STATE(1919),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1919),
    [sym_anonymous_class] = STATE(1919),
    [sym_class] = STATE(1919),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1919),
    [sym_generator_function] = STATE(1919),
    [sym_call_expression] = STATE(1919),
    [sym_new_expression] = STATE(1919),
    [sym_await_expression] = STATE(1919),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1919),
    [sym_augmented_assignment_expression] = STATE(1919),
    [sym_ternary_expression] = STATE(1919),
    [sym_binary_expression] = STATE(1919),
    [sym_unary_expression] = STATE(1919),
    [sym_update_expression] = STATE(1919),
    [sym_sequence_expression] = STATE(1920),
    [sym_string] = STATE(1919),
    [sym_template_string] = STATE(1919),
    [sym_regex] = STATE(1919),
    [sym_meta_property] = STATE(1919),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4615),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4617),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4617),
    [sym_false] = ACTIONS(4617),
    [sym_null] = ACTIONS(4617),
    [sym_undefined] = ACTIONS(4617),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1823] = {
    [sym_parenthesized_expression] = STATE(1921),
    [sym__expression] = STATE(1921),
    [sym_yield_expression] = STATE(1921),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1921),
    [sym_jsx_fragment] = STATE(1921),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1921),
    [sym_anonymous_class] = STATE(1921),
    [sym_class] = STATE(1921),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1921),
    [sym_generator_function] = STATE(1921),
    [sym_call_expression] = STATE(1921),
    [sym_new_expression] = STATE(1921),
    [sym_await_expression] = STATE(1921),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1921),
    [sym_ternary_expression] = STATE(1921),
    [sym_binary_expression] = STATE(1921),
    [sym_unary_expression] = STATE(1921),
    [sym_update_expression] = STATE(1921),
    [sym_string] = STATE(1921),
    [sym_template_string] = STATE(1921),
    [sym_regex] = STATE(1921),
    [sym_meta_property] = STATE(1921),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4619),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4621),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4621),
    [sym_false] = ACTIONS(4621),
    [sym_null] = ACTIONS(4621),
    [sym_undefined] = ACTIONS(4621),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1824] = {
    [sym_parenthesized_expression] = STATE(1922),
    [sym__expression] = STATE(1922),
    [sym_yield_expression] = STATE(1922),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1922),
    [sym_jsx_fragment] = STATE(1922),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1922),
    [sym_anonymous_class] = STATE(1922),
    [sym_class] = STATE(1922),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1922),
    [sym_generator_function] = STATE(1922),
    [sym_call_expression] = STATE(1922),
    [sym_new_expression] = STATE(1922),
    [sym_await_expression] = STATE(1922),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1922),
    [sym_ternary_expression] = STATE(1922),
    [sym_binary_expression] = STATE(1922),
    [sym_unary_expression] = STATE(1922),
    [sym_update_expression] = STATE(1922),
    [sym_sequence_expression] = STATE(1923),
    [sym_string] = STATE(1922),
    [sym_template_string] = STATE(1922),
    [sym_regex] = STATE(1922),
    [sym_meta_property] = STATE(1922),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4623),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4625),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4625),
    [sym_false] = ACTIONS(4625),
    [sym_null] = ACTIONS(4625),
    [sym_undefined] = ACTIONS(4625),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1825] = {
    [sym_parenthesized_expression] = STATE(1924),
    [sym__expression] = STATE(1924),
    [sym_yield_expression] = STATE(1924),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1924),
    [sym_jsx_fragment] = STATE(1924),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1924),
    [sym_anonymous_class] = STATE(1924),
    [sym_class] = STATE(1924),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1924),
    [sym_generator_function] = STATE(1924),
    [sym_call_expression] = STATE(1924),
    [sym_new_expression] = STATE(1924),
    [sym_await_expression] = STATE(1924),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1924),
    [sym_augmented_assignment_expression] = STATE(1924),
    [sym_ternary_expression] = STATE(1924),
    [sym_binary_expression] = STATE(1924),
    [sym_unary_expression] = STATE(1924),
    [sym_update_expression] = STATE(1924),
    [sym_string] = STATE(1924),
    [sym_template_string] = STATE(1924),
    [sym_regex] = STATE(1924),
    [sym_meta_property] = STATE(1924),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4627),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4629),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4629),
    [sym_false] = ACTIONS(4629),
    [sym_null] = ACTIONS(4629),
    [sym_undefined] = ACTIONS(4629),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1826] = {
    [sym_parenthesized_expression] = STATE(1925),
    [sym__expression] = STATE(1925),
    [sym_yield_expression] = STATE(1925),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1925),
    [sym_jsx_fragment] = STATE(1925),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1925),
    [sym_anonymous_class] = STATE(1925),
    [sym_class] = STATE(1925),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1925),
    [sym_generator_function] = STATE(1925),
    [sym_call_expression] = STATE(1925),
    [sym_new_expression] = STATE(1925),
    [sym_await_expression] = STATE(1925),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1925),
    [sym_augmented_assignment_expression] = STATE(1925),
    [sym_ternary_expression] = STATE(1925),
    [sym_binary_expression] = STATE(1925),
    [sym_unary_expression] = STATE(1925),
    [sym_update_expression] = STATE(1925),
    [sym_sequence_expression] = STATE(1926),
    [sym_string] = STATE(1925),
    [sym_template_string] = STATE(1925),
    [sym_regex] = STATE(1925),
    [sym_meta_property] = STATE(1925),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4631),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4633),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4633),
    [sym_false] = ACTIONS(4633),
    [sym_null] = ACTIONS(4633),
    [sym_undefined] = ACTIONS(4633),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1827] = {
    [sym_parenthesized_expression] = STATE(1927),
    [sym__expression] = STATE(1927),
    [sym_yield_expression] = STATE(1927),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1927),
    [sym_jsx_fragment] = STATE(1927),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1927),
    [sym_anonymous_class] = STATE(1927),
    [sym_class] = STATE(1927),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1927),
    [sym_generator_function] = STATE(1927),
    [sym_call_expression] = STATE(1927),
    [sym_new_expression] = STATE(1927),
    [sym_await_expression] = STATE(1927),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1927),
    [sym_ternary_expression] = STATE(1927),
    [sym_binary_expression] = STATE(1927),
    [sym_unary_expression] = STATE(1927),
    [sym_update_expression] = STATE(1927),
    [sym_string] = STATE(1927),
    [sym_template_string] = STATE(1927),
    [sym_regex] = STATE(1927),
    [sym_meta_property] = STATE(1927),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4635),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4637),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4637),
    [sym_false] = ACTIONS(4637),
    [sym_null] = ACTIONS(4637),
    [sym_undefined] = ACTIONS(4637),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1828] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4639),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1829] = {
    [anon_sym_RPAREN] = ACTIONS(4639),
    [sym_comment] = ACTIONS(78),
  },
  [1830] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4641),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1831] = {
    [sym_export_statement] = STATE(1500),
    [sym__declaration] = STATE(1500),
    [sym_import_statement] = STATE(1500),
    [sym_expression_statement] = STATE(1500),
    [sym_variable_declaration] = STATE(1500),
    [sym_lexical_declaration] = STATE(1500),
    [sym_statement_block] = STATE(1500),
    [sym_if_statement] = STATE(1500),
    [sym_switch_statement] = STATE(1500),
    [sym_for_statement] = STATE(1500),
    [sym_for_in_statement] = STATE(1500),
    [sym_for_of_statement] = STATE(1500),
    [sym_while_statement] = STATE(1500),
    [sym_do_statement] = STATE(1500),
    [sym_try_statement] = STATE(1500),
    [sym_with_statement] = STATE(1500),
    [sym_break_statement] = STATE(1500),
    [sym_continue_statement] = STATE(1500),
    [sym_debugger_statement] = STATE(1500),
    [sym_return_statement] = STATE(1500),
    [sym_throw_statement] = STATE(1500),
    [sym_empty_statement] = STATE(1500),
    [sym_labeled_statement] = STATE(1500),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1832] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4643),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1833] = {
    [anon_sym_RPAREN] = ACTIONS(4643),
    [sym_comment] = ACTIONS(78),
  },
  [1834] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4645),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1835] = {
    [anon_sym_RPAREN] = ACTIONS(4645),
    [sym_comment] = ACTIONS(78),
  },
  [1836] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4647),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1837] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4649),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1838] = {
    [anon_sym_RPAREN] = ACTIONS(4649),
    [sym_comment] = ACTIONS(78),
  },
  [1839] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4651),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1840] = {
    [anon_sym_of] = ACTIONS(4653),
    [sym_comment] = ACTIONS(78),
  },
  [1841] = {
    [anon_sym_of] = ACTIONS(4655),
    [sym_comment] = ACTIONS(78),
  },
  [1842] = {
    [anon_sym_of] = ACTIONS(4657),
    [sym_comment] = ACTIONS(78),
  },
  [1843] = {
    [sym_export_statement] = STATE(1809),
    [sym__declaration] = STATE(1809),
    [sym_import_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_variable_declaration] = STATE(1809),
    [sym_lexical_declaration] = STATE(1809),
    [sym_statement_block] = STATE(1809),
    [sym_if_statement] = STATE(1809),
    [sym_switch_statement] = STATE(1809),
    [sym_for_statement] = STATE(1809),
    [sym_for_in_statement] = STATE(1809),
    [sym_for_of_statement] = STATE(1809),
    [sym_while_statement] = STATE(1809),
    [sym_do_statement] = STATE(1809),
    [sym_try_statement] = STATE(1809),
    [sym_with_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_debugger_statement] = STATE(1809),
    [sym_return_statement] = STATE(1809),
    [sym_throw_statement] = STATE(1809),
    [sym_empty_statement] = STATE(1809),
    [sym_labeled_statement] = STATE(1809),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1844] = {
    [sym_export_statement] = STATE(1810),
    [sym__declaration] = STATE(1810),
    [sym_import_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_variable_declaration] = STATE(1810),
    [sym_lexical_declaration] = STATE(1810),
    [sym_statement_block] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_for_in_statement] = STATE(1810),
    [sym_for_of_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_with_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_debugger_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_throw_statement] = STATE(1810),
    [sym_empty_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1845] = {
    [sym_export_statement] = STATE(1811),
    [sym__declaration] = STATE(1811),
    [sym_import_statement] = STATE(1811),
    [sym_expression_statement] = STATE(1811),
    [sym_variable_declaration] = STATE(1811),
    [sym_lexical_declaration] = STATE(1811),
    [sym_statement_block] = STATE(1811),
    [sym_if_statement] = STATE(1811),
    [sym_switch_statement] = STATE(1811),
    [sym_for_statement] = STATE(1811),
    [sym_for_in_statement] = STATE(1811),
    [sym_for_of_statement] = STATE(1811),
    [sym_while_statement] = STATE(1811),
    [sym_do_statement] = STATE(1811),
    [sym_try_statement] = STATE(1811),
    [sym_with_statement] = STATE(1811),
    [sym_break_statement] = STATE(1811),
    [sym_continue_statement] = STATE(1811),
    [sym_debugger_statement] = STATE(1811),
    [sym_return_statement] = STATE(1811),
    [sym_throw_statement] = STATE(1811),
    [sym_empty_statement] = STATE(1811),
    [sym_labeled_statement] = STATE(1811),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1846] = {
    [sym_export_statement] = STATE(1812),
    [sym__declaration] = STATE(1812),
    [sym_import_statement] = STATE(1812),
    [sym_expression_statement] = STATE(1812),
    [sym_variable_declaration] = STATE(1812),
    [sym_lexical_declaration] = STATE(1812),
    [sym_statement_block] = STATE(1812),
    [sym_if_statement] = STATE(1812),
    [sym_switch_statement] = STATE(1812),
    [sym_for_statement] = STATE(1812),
    [sym_for_in_statement] = STATE(1812),
    [sym_for_of_statement] = STATE(1812),
    [sym_while_statement] = STATE(1812),
    [sym_do_statement] = STATE(1812),
    [sym_try_statement] = STATE(1812),
    [sym_with_statement] = STATE(1812),
    [sym_break_statement] = STATE(1812),
    [sym_continue_statement] = STATE(1812),
    [sym_debugger_statement] = STATE(1812),
    [sym_return_statement] = STATE(1812),
    [sym_throw_statement] = STATE(1812),
    [sym_empty_statement] = STATE(1812),
    [sym_labeled_statement] = STATE(1812),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1847] = {
    [sym_export_statement] = STATE(1813),
    [sym__declaration] = STATE(1813),
    [sym_import_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_variable_declaration] = STATE(1813),
    [sym_lexical_declaration] = STATE(1813),
    [sym_statement_block] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_for_in_statement] = STATE(1813),
    [sym_for_of_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_with_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_debugger_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_throw_statement] = STATE(1813),
    [sym_empty_statement] = STATE(1813),
    [sym_labeled_statement] = STATE(1813),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1848] = {
    [sym_export_statement] = STATE(1814),
    [sym__declaration] = STATE(1814),
    [sym_import_statement] = STATE(1814),
    [sym_expression_statement] = STATE(1814),
    [sym_variable_declaration] = STATE(1814),
    [sym_lexical_declaration] = STATE(1814),
    [sym_statement_block] = STATE(1814),
    [sym_if_statement] = STATE(1814),
    [sym_switch_statement] = STATE(1814),
    [sym_for_statement] = STATE(1814),
    [sym_for_in_statement] = STATE(1814),
    [sym_for_of_statement] = STATE(1814),
    [sym_while_statement] = STATE(1814),
    [sym_do_statement] = STATE(1814),
    [sym_try_statement] = STATE(1814),
    [sym_with_statement] = STATE(1814),
    [sym_break_statement] = STATE(1814),
    [sym_continue_statement] = STATE(1814),
    [sym_debugger_statement] = STATE(1814),
    [sym_return_statement] = STATE(1814),
    [sym_throw_statement] = STATE(1814),
    [sym_empty_statement] = STATE(1814),
    [sym_labeled_statement] = STATE(1814),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1849] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4659),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1850] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4661),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1851] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4663),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1852] = {
    [anon_sym_GT] = ACTIONS(4665),
    [sym_comment] = ACTIONS(78),
  },
  [1853] = {
    [sym_nested_identifier] = STATE(659),
    [sym_jsx_namespace_name] = STATE(660),
    [anon_sym_SLASH] = ACTIONS(4667),
    [sym_jsx_identifier] = ACTIONS(1251),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(1253),
  },
  [1854] = {
    [anon_sym_LBRACE] = ACTIONS(2891),
    [anon_sym_GT] = ACTIONS(2891),
    [anon_sym_SLASH] = ACTIONS(2893),
    [sym_jsx_identifier] = ACTIONS(2891),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(2893),
  },
  [1855] = {
    [anon_sym_GT] = ACTIONS(4669),
    [sym_comment] = ACTIONS(78),
  },
  [1856] = {
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(4671),
    [sym_comment] = ACTIONS(78),
  },
  [1857] = {
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_GT] = ACTIONS(4671),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
  },
  [1858] = {
    [anon_sym_GT] = ACTIONS(4671),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_comment] = ACTIONS(78),
  },
  [1859] = {
    [anon_sym_GT] = ACTIONS(4671),
    [sym_comment] = ACTIONS(78),
  },
  [1860] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3125),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3125),
    [anon_sym_GT] = ACTIONS(3125),
    [anon_sym_SLASH] = ACTIONS(3131),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3131),
    [anon_sym_GT_GT_GT] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3139),
    [anon_sym_CARET] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_DASH] = ACTIONS(3143),
    [anon_sym_PERCENT] = ACTIONS(3129),
    [anon_sym_LT_EQ] = ACTIONS(3145),
    [anon_sym_EQ_EQ] = ACTIONS(3125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3145),
    [anon_sym_GT_EQ] = ACTIONS(3145),
    [anon_sym_instanceof] = ACTIONS(3145),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1861] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4673),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1862] = {
    [anon_sym_RPAREN] = ACTIONS(4673),
    [sym_comment] = ACTIONS(78),
  },
  [1863] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4675),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1864] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4677),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1865] = {
    [anon_sym_RPAREN] = ACTIONS(4677),
    [sym_comment] = ACTIONS(78),
  },
  [1866] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4679),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1867] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4681),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1868] = {
    [anon_sym_RPAREN] = ACTIONS(4681),
    [sym_comment] = ACTIONS(78),
  },
  [1869] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4683),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1870] = {
    [sym_export_statement] = STATE(1672),
    [sym__declaration] = STATE(1672),
    [sym_import_statement] = STATE(1672),
    [sym_expression_statement] = STATE(1672),
    [sym_variable_declaration] = STATE(1672),
    [sym_lexical_declaration] = STATE(1672),
    [sym_statement_block] = STATE(1672),
    [sym_if_statement] = STATE(1672),
    [sym_switch_statement] = STATE(1672),
    [sym_for_statement] = STATE(1672),
    [sym_for_in_statement] = STATE(1672),
    [sym_for_of_statement] = STATE(1672),
    [sym_while_statement] = STATE(1672),
    [sym_do_statement] = STATE(1672),
    [sym_try_statement] = STATE(1672),
    [sym_with_statement] = STATE(1672),
    [sym_break_statement] = STATE(1672),
    [sym_continue_statement] = STATE(1672),
    [sym_debugger_statement] = STATE(1672),
    [sym_return_statement] = STATE(1672),
    [sym_throw_statement] = STATE(1672),
    [sym_empty_statement] = STATE(1672),
    [sym_labeled_statement] = STATE(1672),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1871] = {
    [sym_export_statement] = STATE(1683),
    [sym__declaration] = STATE(1683),
    [sym_import_statement] = STATE(1683),
    [sym_expression_statement] = STATE(1683),
    [sym_variable_declaration] = STATE(1683),
    [sym_lexical_declaration] = STATE(1683),
    [sym_statement_block] = STATE(1683),
    [sym_if_statement] = STATE(1683),
    [sym_switch_statement] = STATE(1683),
    [sym_for_statement] = STATE(1683),
    [sym_for_in_statement] = STATE(1683),
    [sym_for_of_statement] = STATE(1683),
    [sym_while_statement] = STATE(1683),
    [sym_do_statement] = STATE(1683),
    [sym_try_statement] = STATE(1683),
    [sym_with_statement] = STATE(1683),
    [sym_break_statement] = STATE(1683),
    [sym_continue_statement] = STATE(1683),
    [sym_debugger_statement] = STATE(1683),
    [sym_return_statement] = STATE(1683),
    [sym_throw_statement] = STATE(1683),
    [sym_empty_statement] = STATE(1683),
    [sym_labeled_statement] = STATE(1683),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1872] = {
    [sym_export_statement] = STATE(1688),
    [sym__declaration] = STATE(1688),
    [sym_import_statement] = STATE(1688),
    [sym_expression_statement] = STATE(1688),
    [sym_variable_declaration] = STATE(1688),
    [sym_lexical_declaration] = STATE(1688),
    [sym_statement_block] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_switch_statement] = STATE(1688),
    [sym_for_statement] = STATE(1688),
    [sym_for_in_statement] = STATE(1688),
    [sym_for_of_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_do_statement] = STATE(1688),
    [sym_try_statement] = STATE(1688),
    [sym_with_statement] = STATE(1688),
    [sym_break_statement] = STATE(1688),
    [sym_continue_statement] = STATE(1688),
    [sym_debugger_statement] = STATE(1688),
    [sym_return_statement] = STATE(1688),
    [sym_throw_statement] = STATE(1688),
    [sym_empty_statement] = STATE(1688),
    [sym_labeled_statement] = STATE(1688),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1873] = {
    [sym_export_statement] = STATE(1689),
    [sym__declaration] = STATE(1689),
    [sym_import_statement] = STATE(1689),
    [sym_expression_statement] = STATE(1689),
    [sym_variable_declaration] = STATE(1689),
    [sym_lexical_declaration] = STATE(1689),
    [sym_statement_block] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_switch_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_for_in_statement] = STATE(1689),
    [sym_for_of_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_do_statement] = STATE(1689),
    [sym_try_statement] = STATE(1689),
    [sym_with_statement] = STATE(1689),
    [sym_break_statement] = STATE(1689),
    [sym_continue_statement] = STATE(1689),
    [sym_debugger_statement] = STATE(1689),
    [sym_return_statement] = STATE(1689),
    [sym_throw_statement] = STATE(1689),
    [sym_empty_statement] = STATE(1689),
    [sym_labeled_statement] = STATE(1689),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1874] = {
    [sym_export_statement] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym_import_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_lexical_declaration] = STATE(1690),
    [sym_statement_block] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_for_in_statement] = STATE(1690),
    [sym_for_of_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_try_statement] = STATE(1690),
    [sym_with_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_debugger_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_throw_statement] = STATE(1690),
    [sym_empty_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1875] = {
    [sym_export_statement] = STATE(1691),
    [sym__declaration] = STATE(1691),
    [sym_import_statement] = STATE(1691),
    [sym_expression_statement] = STATE(1691),
    [sym_variable_declaration] = STATE(1691),
    [sym_lexical_declaration] = STATE(1691),
    [sym_statement_block] = STATE(1691),
    [sym_if_statement] = STATE(1691),
    [sym_switch_statement] = STATE(1691),
    [sym_for_statement] = STATE(1691),
    [sym_for_in_statement] = STATE(1691),
    [sym_for_of_statement] = STATE(1691),
    [sym_while_statement] = STATE(1691),
    [sym_do_statement] = STATE(1691),
    [sym_try_statement] = STATE(1691),
    [sym_with_statement] = STATE(1691),
    [sym_break_statement] = STATE(1691),
    [sym_continue_statement] = STATE(1691),
    [sym_debugger_statement] = STATE(1691),
    [sym_return_statement] = STATE(1691),
    [sym_throw_statement] = STATE(1691),
    [sym_empty_statement] = STATE(1691),
    [sym_labeled_statement] = STATE(1691),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1876] = {
    [sym_export_statement] = STATE(1692),
    [sym__declaration] = STATE(1692),
    [sym_import_statement] = STATE(1692),
    [sym_expression_statement] = STATE(1692),
    [sym_variable_declaration] = STATE(1692),
    [sym_lexical_declaration] = STATE(1692),
    [sym_statement_block] = STATE(1692),
    [sym_if_statement] = STATE(1692),
    [sym_switch_statement] = STATE(1692),
    [sym_for_statement] = STATE(1692),
    [sym_for_in_statement] = STATE(1692),
    [sym_for_of_statement] = STATE(1692),
    [sym_while_statement] = STATE(1692),
    [sym_do_statement] = STATE(1692),
    [sym_try_statement] = STATE(1692),
    [sym_with_statement] = STATE(1692),
    [sym_break_statement] = STATE(1692),
    [sym_continue_statement] = STATE(1692),
    [sym_debugger_statement] = STATE(1692),
    [sym_return_statement] = STATE(1692),
    [sym_throw_statement] = STATE(1692),
    [sym_empty_statement] = STATE(1692),
    [sym_labeled_statement] = STATE(1692),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1877] = {
    [sym_parenthesized_expression] = STATE(1951),
    [sym__expression] = STATE(1951),
    [sym_yield_expression] = STATE(1951),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1951),
    [sym_jsx_fragment] = STATE(1951),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1951),
    [sym_anonymous_class] = STATE(1951),
    [sym_class] = STATE(1951),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1951),
    [sym_generator_function] = STATE(1951),
    [sym_call_expression] = STATE(1951),
    [sym_new_expression] = STATE(1951),
    [sym_await_expression] = STATE(1951),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1951),
    [sym_augmented_assignment_expression] = STATE(1951),
    [sym_ternary_expression] = STATE(1951),
    [sym_binary_expression] = STATE(1951),
    [sym_unary_expression] = STATE(1951),
    [sym_update_expression] = STATE(1951),
    [sym_string] = STATE(1951),
    [sym_template_string] = STATE(1951),
    [sym_regex] = STATE(1951),
    [sym_meta_property] = STATE(1951),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4685),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4687),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4687),
    [sym_false] = ACTIONS(4687),
    [sym_null] = ACTIONS(4687),
    [sym_undefined] = ACTIONS(4687),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1878] = {
    [sym_parenthesized_expression] = STATE(1952),
    [sym__expression] = STATE(1952),
    [sym_yield_expression] = STATE(1952),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1952),
    [sym_jsx_fragment] = STATE(1952),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1952),
    [sym_anonymous_class] = STATE(1952),
    [sym_class] = STATE(1952),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1952),
    [sym_generator_function] = STATE(1952),
    [sym_call_expression] = STATE(1952),
    [sym_new_expression] = STATE(1952),
    [sym_await_expression] = STATE(1952),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1952),
    [sym_augmented_assignment_expression] = STATE(1952),
    [sym_ternary_expression] = STATE(1952),
    [sym_binary_expression] = STATE(1952),
    [sym_unary_expression] = STATE(1952),
    [sym_update_expression] = STATE(1952),
    [sym_string] = STATE(1952),
    [sym_template_string] = STATE(1952),
    [sym_regex] = STATE(1952),
    [sym_meta_property] = STATE(1952),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4689),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4691),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4691),
    [sym_false] = ACTIONS(4691),
    [sym_null] = ACTIONS(4691),
    [sym_undefined] = ACTIONS(4691),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1879] = {
    [sym_parenthesized_expression] = STATE(1953),
    [sym__expression] = STATE(1953),
    [sym_yield_expression] = STATE(1953),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1953),
    [sym_jsx_fragment] = STATE(1953),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1953),
    [sym_anonymous_class] = STATE(1953),
    [sym_class] = STATE(1953),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1953),
    [sym_generator_function] = STATE(1953),
    [sym_call_expression] = STATE(1953),
    [sym_new_expression] = STATE(1953),
    [sym_await_expression] = STATE(1953),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1953),
    [sym_augmented_assignment_expression] = STATE(1953),
    [sym_ternary_expression] = STATE(1953),
    [sym_binary_expression] = STATE(1953),
    [sym_unary_expression] = STATE(1953),
    [sym_update_expression] = STATE(1953),
    [sym_string] = STATE(1953),
    [sym_template_string] = STATE(1953),
    [sym_regex] = STATE(1953),
    [sym_meta_property] = STATE(1953),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4693),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4695),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4695),
    [sym_false] = ACTIONS(4695),
    [sym_null] = ACTIONS(4695),
    [sym_undefined] = ACTIONS(4695),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1880] = {
    [sym_export_statement] = STATE(1916),
    [sym__declaration] = STATE(1916),
    [sym_import_statement] = STATE(1916),
    [sym_expression_statement] = STATE(1916),
    [sym_variable_declaration] = STATE(1916),
    [sym_lexical_declaration] = STATE(1916),
    [sym_statement_block] = STATE(1916),
    [sym_if_statement] = STATE(1916),
    [sym_switch_statement] = STATE(1916),
    [sym_for_statement] = STATE(1916),
    [sym_for_in_statement] = STATE(1916),
    [sym_for_of_statement] = STATE(1916),
    [sym_while_statement] = STATE(1916),
    [sym_do_statement] = STATE(1916),
    [sym_try_statement] = STATE(1916),
    [sym_with_statement] = STATE(1916),
    [sym_break_statement] = STATE(1916),
    [sym_continue_statement] = STATE(1916),
    [sym_debugger_statement] = STATE(1916),
    [sym_return_statement] = STATE(1916),
    [sym_throw_statement] = STATE(1916),
    [sym_empty_statement] = STATE(1916),
    [sym_labeled_statement] = STATE(1916),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1881] = {
    [sym_export_statement] = STATE(1917),
    [sym__declaration] = STATE(1917),
    [sym_import_statement] = STATE(1917),
    [sym_expression_statement] = STATE(1917),
    [sym_variable_declaration] = STATE(1917),
    [sym_lexical_declaration] = STATE(1917),
    [sym_statement_block] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_switch_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_for_in_statement] = STATE(1917),
    [sym_for_of_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_do_statement] = STATE(1917),
    [sym_try_statement] = STATE(1917),
    [sym_with_statement] = STATE(1917),
    [sym_break_statement] = STATE(1917),
    [sym_continue_statement] = STATE(1917),
    [sym_debugger_statement] = STATE(1917),
    [sym_return_statement] = STATE(1917),
    [sym_throw_statement] = STATE(1917),
    [sym_empty_statement] = STATE(1917),
    [sym_labeled_statement] = STATE(1917),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1882] = {
    [sym_export_statement] = STATE(1918),
    [sym__declaration] = STATE(1918),
    [sym_import_statement] = STATE(1918),
    [sym_expression_statement] = STATE(1918),
    [sym_variable_declaration] = STATE(1918),
    [sym_lexical_declaration] = STATE(1918),
    [sym_statement_block] = STATE(1918),
    [sym_if_statement] = STATE(1918),
    [sym_switch_statement] = STATE(1918),
    [sym_for_statement] = STATE(1918),
    [sym_for_in_statement] = STATE(1918),
    [sym_for_of_statement] = STATE(1918),
    [sym_while_statement] = STATE(1918),
    [sym_do_statement] = STATE(1918),
    [sym_try_statement] = STATE(1918),
    [sym_with_statement] = STATE(1918),
    [sym_break_statement] = STATE(1918),
    [sym_continue_statement] = STATE(1918),
    [sym_debugger_statement] = STATE(1918),
    [sym_return_statement] = STATE(1918),
    [sym_throw_statement] = STATE(1918),
    [sym_empty_statement] = STATE(1918),
    [sym_labeled_statement] = STATE(1918),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(118),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(120),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(122),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(124),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(597),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1883] = {
    [sym_export_statement] = STATE(1809),
    [sym__declaration] = STATE(1809),
    [sym_import_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_variable_declaration] = STATE(1809),
    [sym_lexical_declaration] = STATE(1809),
    [sym_statement_block] = STATE(1809),
    [sym_if_statement] = STATE(1809),
    [sym_switch_statement] = STATE(1809),
    [sym_for_statement] = STATE(1809),
    [sym_for_in_statement] = STATE(1809),
    [sym_for_of_statement] = STATE(1809),
    [sym_while_statement] = STATE(1809),
    [sym_do_statement] = STATE(1809),
    [sym_try_statement] = STATE(1809),
    [sym_with_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_debugger_statement] = STATE(1809),
    [sym_return_statement] = STATE(1809),
    [sym_throw_statement] = STATE(1809),
    [sym_empty_statement] = STATE(1809),
    [sym_labeled_statement] = STATE(1809),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1884] = {
    [sym_export_statement] = STATE(1810),
    [sym__declaration] = STATE(1810),
    [sym_import_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_variable_declaration] = STATE(1810),
    [sym_lexical_declaration] = STATE(1810),
    [sym_statement_block] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_for_in_statement] = STATE(1810),
    [sym_for_of_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_with_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_debugger_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_throw_statement] = STATE(1810),
    [sym_empty_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1885] = {
    [sym_export_statement] = STATE(1811),
    [sym__declaration] = STATE(1811),
    [sym_import_statement] = STATE(1811),
    [sym_expression_statement] = STATE(1811),
    [sym_variable_declaration] = STATE(1811),
    [sym_lexical_declaration] = STATE(1811),
    [sym_statement_block] = STATE(1811),
    [sym_if_statement] = STATE(1811),
    [sym_switch_statement] = STATE(1811),
    [sym_for_statement] = STATE(1811),
    [sym_for_in_statement] = STATE(1811),
    [sym_for_of_statement] = STATE(1811),
    [sym_while_statement] = STATE(1811),
    [sym_do_statement] = STATE(1811),
    [sym_try_statement] = STATE(1811),
    [sym_with_statement] = STATE(1811),
    [sym_break_statement] = STATE(1811),
    [sym_continue_statement] = STATE(1811),
    [sym_debugger_statement] = STATE(1811),
    [sym_return_statement] = STATE(1811),
    [sym_throw_statement] = STATE(1811),
    [sym_empty_statement] = STATE(1811),
    [sym_labeled_statement] = STATE(1811),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1886] = {
    [sym_export_statement] = STATE(1812),
    [sym__declaration] = STATE(1812),
    [sym_import_statement] = STATE(1812),
    [sym_expression_statement] = STATE(1812),
    [sym_variable_declaration] = STATE(1812),
    [sym_lexical_declaration] = STATE(1812),
    [sym_statement_block] = STATE(1812),
    [sym_if_statement] = STATE(1812),
    [sym_switch_statement] = STATE(1812),
    [sym_for_statement] = STATE(1812),
    [sym_for_in_statement] = STATE(1812),
    [sym_for_of_statement] = STATE(1812),
    [sym_while_statement] = STATE(1812),
    [sym_do_statement] = STATE(1812),
    [sym_try_statement] = STATE(1812),
    [sym_with_statement] = STATE(1812),
    [sym_break_statement] = STATE(1812),
    [sym_continue_statement] = STATE(1812),
    [sym_debugger_statement] = STATE(1812),
    [sym_return_statement] = STATE(1812),
    [sym_throw_statement] = STATE(1812),
    [sym_empty_statement] = STATE(1812),
    [sym_labeled_statement] = STATE(1812),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1887] = {
    [sym_export_statement] = STATE(1813),
    [sym__declaration] = STATE(1813),
    [sym_import_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_variable_declaration] = STATE(1813),
    [sym_lexical_declaration] = STATE(1813),
    [sym_statement_block] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_for_in_statement] = STATE(1813),
    [sym_for_of_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_with_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_debugger_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_throw_statement] = STATE(1813),
    [sym_empty_statement] = STATE(1813),
    [sym_labeled_statement] = STATE(1813),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1888] = {
    [sym_export_statement] = STATE(1814),
    [sym__declaration] = STATE(1814),
    [sym_import_statement] = STATE(1814),
    [sym_expression_statement] = STATE(1814),
    [sym_variable_declaration] = STATE(1814),
    [sym_lexical_declaration] = STATE(1814),
    [sym_statement_block] = STATE(1814),
    [sym_if_statement] = STATE(1814),
    [sym_switch_statement] = STATE(1814),
    [sym_for_statement] = STATE(1814),
    [sym_for_in_statement] = STATE(1814),
    [sym_for_of_statement] = STATE(1814),
    [sym_while_statement] = STATE(1814),
    [sym_do_statement] = STATE(1814),
    [sym_try_statement] = STATE(1814),
    [sym_with_statement] = STATE(1814),
    [sym_break_statement] = STATE(1814),
    [sym_continue_statement] = STATE(1814),
    [sym_debugger_statement] = STATE(1814),
    [sym_return_statement] = STATE(1814),
    [sym_throw_statement] = STATE(1814),
    [sym_empty_statement] = STATE(1814),
    [sym_labeled_statement] = STATE(1814),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1889] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4697),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1890] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4699),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1891] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4701),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1892] = {
    [sym_export_statement] = STATE(1957),
    [sym__declaration] = STATE(1957),
    [sym_import_statement] = STATE(1957),
    [sym_expression_statement] = STATE(1957),
    [sym_variable_declaration] = STATE(1957),
    [sym_lexical_declaration] = STATE(1957),
    [sym_statement_block] = STATE(1957),
    [sym_if_statement] = STATE(1957),
    [sym_switch_statement] = STATE(1957),
    [sym_for_statement] = STATE(1957),
    [sym_for_in_statement] = STATE(1957),
    [sym_for_of_statement] = STATE(1957),
    [sym_while_statement] = STATE(1957),
    [sym_do_statement] = STATE(1957),
    [sym_try_statement] = STATE(1957),
    [sym_with_statement] = STATE(1957),
    [sym_break_statement] = STATE(1957),
    [sym_continue_statement] = STATE(1957),
    [sym_debugger_statement] = STATE(1957),
    [sym_return_statement] = STATE(1957),
    [sym_throw_statement] = STATE(1957),
    [sym_empty_statement] = STATE(1957),
    [sym_labeled_statement] = STATE(1957),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1893] = {
    [sym_expression_statement] = STATE(1961),
    [sym_variable_declaration] = STATE(1961),
    [sym_lexical_declaration] = STATE(1961),
    [sym_empty_statement] = STATE(1961),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(1962),
    [sym_array] = STATE(1963),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_var] = ACTIONS(4703),
    [anon_sym_let] = ACTIONS(4705),
    [anon_sym_const] = ACTIONS(4705),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4707),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1894] = {
    [anon_sym_LPAREN] = ACTIONS(4709),
    [sym_comment] = ACTIONS(78),
  },
  [1895] = {
    [sym_export_statement] = STATE(485),
    [sym__declaration] = STATE(485),
    [sym_import_statement] = STATE(485),
    [sym_expression_statement] = STATE(485),
    [sym_variable_declaration] = STATE(485),
    [sym_lexical_declaration] = STATE(485),
    [sym_statement_block] = STATE(485),
    [sym_if_statement] = STATE(485),
    [sym_switch_statement] = STATE(485),
    [sym_for_statement] = STATE(485),
    [sym_for_in_statement] = STATE(485),
    [sym_for_of_statement] = STATE(485),
    [sym_while_statement] = STATE(485),
    [sym_do_statement] = STATE(485),
    [sym_try_statement] = STATE(485),
    [sym_with_statement] = STATE(485),
    [sym_break_statement] = STATE(485),
    [sym_continue_statement] = STATE(485),
    [sym_debugger_statement] = STATE(485),
    [sym_return_statement] = STATE(485),
    [sym_throw_statement] = STATE(485),
    [sym_empty_statement] = STATE(485),
    [sym_labeled_statement] = STATE(485),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1896] = {
    [sym_export_statement] = STATE(502),
    [sym__declaration] = STATE(502),
    [sym_import_statement] = STATE(502),
    [sym_expression_statement] = STATE(502),
    [sym_variable_declaration] = STATE(502),
    [sym_lexical_declaration] = STATE(502),
    [sym_statement_block] = STATE(502),
    [sym_if_statement] = STATE(502),
    [sym_switch_statement] = STATE(502),
    [sym_for_statement] = STATE(502),
    [sym_for_in_statement] = STATE(502),
    [sym_for_of_statement] = STATE(502),
    [sym_while_statement] = STATE(502),
    [sym_do_statement] = STATE(502),
    [sym_try_statement] = STATE(502),
    [sym_with_statement] = STATE(502),
    [sym_break_statement] = STATE(502),
    [sym_continue_statement] = STATE(502),
    [sym_debugger_statement] = STATE(502),
    [sym_return_statement] = STATE(502),
    [sym_throw_statement] = STATE(502),
    [sym_empty_statement] = STATE(502),
    [sym_labeled_statement] = STATE(502),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1897] = {
    [sym_export_statement] = STATE(619),
    [sym__declaration] = STATE(619),
    [sym_import_statement] = STATE(619),
    [sym_expression_statement] = STATE(619),
    [sym_variable_declaration] = STATE(619),
    [sym_lexical_declaration] = STATE(619),
    [sym_statement_block] = STATE(619),
    [sym_if_statement] = STATE(619),
    [sym_switch_statement] = STATE(619),
    [sym_for_statement] = STATE(619),
    [sym_for_in_statement] = STATE(619),
    [sym_for_of_statement] = STATE(619),
    [sym_while_statement] = STATE(619),
    [sym_do_statement] = STATE(619),
    [sym_try_statement] = STATE(619),
    [sym_with_statement] = STATE(619),
    [sym_break_statement] = STATE(619),
    [sym_continue_statement] = STATE(619),
    [sym_debugger_statement] = STATE(619),
    [sym_return_statement] = STATE(619),
    [sym_throw_statement] = STATE(619),
    [sym_empty_statement] = STATE(619),
    [sym_labeled_statement] = STATE(619),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1898] = {
    [sym_export_statement] = STATE(1161),
    [sym__declaration] = STATE(1161),
    [sym_import_statement] = STATE(1161),
    [sym_expression_statement] = STATE(1161),
    [sym_variable_declaration] = STATE(1161),
    [sym_lexical_declaration] = STATE(1161),
    [sym_statement_block] = STATE(1161),
    [sym_if_statement] = STATE(1161),
    [sym_switch_statement] = STATE(1161),
    [sym_for_statement] = STATE(1161),
    [sym_for_in_statement] = STATE(1161),
    [sym_for_of_statement] = STATE(1161),
    [sym_while_statement] = STATE(1161),
    [sym_do_statement] = STATE(1161),
    [sym_try_statement] = STATE(1161),
    [sym_with_statement] = STATE(1161),
    [sym_break_statement] = STATE(1161),
    [sym_continue_statement] = STATE(1161),
    [sym_debugger_statement] = STATE(1161),
    [sym_return_statement] = STATE(1161),
    [sym_throw_statement] = STATE(1161),
    [sym_empty_statement] = STATE(1161),
    [sym_labeled_statement] = STATE(1161),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1899] = {
    [sym__initializer] = STATE(363),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(4711),
    [anon_sym_of] = ACTIONS(4713),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1900] = {
    [sym__initializer] = STATE(367),
    [sym__automatic_semicolon] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(4715),
    [anon_sym_of] = ACTIONS(4717),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1901] = {
    [sym__initializer] = STATE(368),
    [sym__automatic_semicolon] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(4719),
    [anon_sym_of] = ACTIONS(4721),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [1902] = {
    [sym_parenthesized_expression] = STATE(1971),
    [sym__expression] = STATE(1971),
    [sym_yield_expression] = STATE(1971),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1971),
    [sym_jsx_fragment] = STATE(1971),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1971),
    [sym_anonymous_class] = STATE(1971),
    [sym_class] = STATE(1971),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1971),
    [sym_generator_function] = STATE(1971),
    [sym_call_expression] = STATE(1971),
    [sym_new_expression] = STATE(1971),
    [sym_await_expression] = STATE(1971),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1971),
    [sym_augmented_assignment_expression] = STATE(1971),
    [sym_ternary_expression] = STATE(1971),
    [sym_binary_expression] = STATE(1971),
    [sym_unary_expression] = STATE(1971),
    [sym_update_expression] = STATE(1971),
    [sym_sequence_expression] = STATE(1972),
    [sym_string] = STATE(1971),
    [sym_template_string] = STATE(1971),
    [sym_regex] = STATE(1971),
    [sym_meta_property] = STATE(1971),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4723),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4725),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4725),
    [sym_false] = ACTIONS(4725),
    [sym_null] = ACTIONS(4725),
    [sym_undefined] = ACTIONS(4725),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1903] = {
    [sym_parenthesized_expression] = STATE(1973),
    [sym__expression] = STATE(1973),
    [sym_yield_expression] = STATE(1973),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1973),
    [sym_jsx_fragment] = STATE(1973),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1973),
    [sym_anonymous_class] = STATE(1973),
    [sym_class] = STATE(1973),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1973),
    [sym_generator_function] = STATE(1973),
    [sym_call_expression] = STATE(1973),
    [sym_new_expression] = STATE(1973),
    [sym_await_expression] = STATE(1973),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1973),
    [sym_augmented_assignment_expression] = STATE(1973),
    [sym_ternary_expression] = STATE(1973),
    [sym_binary_expression] = STATE(1973),
    [sym_unary_expression] = STATE(1973),
    [sym_update_expression] = STATE(1973),
    [sym_string] = STATE(1973),
    [sym_template_string] = STATE(1973),
    [sym_regex] = STATE(1973),
    [sym_meta_property] = STATE(1973),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4727),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4729),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4729),
    [sym_false] = ACTIONS(4729),
    [sym_null] = ACTIONS(4729),
    [sym_undefined] = ACTIONS(4729),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1904] = {
    [sym_parenthesized_expression] = STATE(1975),
    [sym__expression] = STATE(1975),
    [sym_yield_expression] = STATE(1975),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(1975),
    [sym_jsx_fragment] = STATE(1975),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1975),
    [sym_anonymous_class] = STATE(1975),
    [sym_class] = STATE(1975),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1975),
    [sym_generator_function] = STATE(1975),
    [sym_call_expression] = STATE(1975),
    [sym_new_expression] = STATE(1975),
    [sym_await_expression] = STATE(1975),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(1975),
    [sym_augmented_assignment_expression] = STATE(1975),
    [sym_ternary_expression] = STATE(1975),
    [sym_binary_expression] = STATE(1975),
    [sym_unary_expression] = STATE(1975),
    [sym_update_expression] = STATE(1975),
    [sym_sequence_expression] = STATE(1976),
    [sym_string] = STATE(1975),
    [sym_template_string] = STATE(1975),
    [sym_regex] = STATE(1975),
    [sym_meta_property] = STATE(1975),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4733),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4735),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4735),
    [sym_false] = ACTIONS(4735),
    [sym_null] = ACTIONS(4735),
    [sym_undefined] = ACTIONS(4735),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1905] = {
    [sym_parenthesized_expression] = STATE(1977),
    [sym__expression] = STATE(1977),
    [sym_yield_expression] = STATE(1977),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1977),
    [sym_jsx_fragment] = STATE(1977),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1977),
    [sym_anonymous_class] = STATE(1977),
    [sym_class] = STATE(1977),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1977),
    [sym_generator_function] = STATE(1977),
    [sym_call_expression] = STATE(1977),
    [sym_new_expression] = STATE(1977),
    [sym_await_expression] = STATE(1977),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1977),
    [sym_augmented_assignment_expression] = STATE(1977),
    [sym_ternary_expression] = STATE(1977),
    [sym_binary_expression] = STATE(1977),
    [sym_unary_expression] = STATE(1977),
    [sym_update_expression] = STATE(1977),
    [sym_sequence_expression] = STATE(1978),
    [sym_string] = STATE(1977),
    [sym_template_string] = STATE(1977),
    [sym_regex] = STATE(1977),
    [sym_meta_property] = STATE(1977),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4737),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4739),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4739),
    [sym_false] = ACTIONS(4739),
    [sym_null] = ACTIONS(4739),
    [sym_undefined] = ACTIONS(4739),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1906] = {
    [sym_parenthesized_expression] = STATE(1979),
    [sym__expression] = STATE(1979),
    [sym_yield_expression] = STATE(1979),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1979),
    [sym_jsx_fragment] = STATE(1979),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1979),
    [sym_anonymous_class] = STATE(1979),
    [sym_class] = STATE(1979),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1979),
    [sym_generator_function] = STATE(1979),
    [sym_call_expression] = STATE(1979),
    [sym_new_expression] = STATE(1979),
    [sym_await_expression] = STATE(1979),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1979),
    [sym_augmented_assignment_expression] = STATE(1979),
    [sym_ternary_expression] = STATE(1979),
    [sym_binary_expression] = STATE(1979),
    [sym_unary_expression] = STATE(1979),
    [sym_update_expression] = STATE(1979),
    [sym_string] = STATE(1979),
    [sym_template_string] = STATE(1979),
    [sym_regex] = STATE(1979),
    [sym_meta_property] = STATE(1979),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4741),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4743),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4743),
    [sym_false] = ACTIONS(4743),
    [sym_null] = ACTIONS(4743),
    [sym_undefined] = ACTIONS(4743),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1907] = {
    [sym_parenthesized_expression] = STATE(1980),
    [sym__expression] = STATE(1980),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(1980),
    [sym_jsx_fragment] = STATE(1980),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(1980),
    [sym_anonymous_class] = STATE(1980),
    [sym_class] = STATE(1980),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(1980),
    [sym_generator_function] = STATE(1980),
    [sym_call_expression] = STATE(1980),
    [sym_new_expression] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1980),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym_ternary_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_update_expression] = STATE(1980),
    [sym_sequence_expression] = STATE(1981),
    [sym_string] = STATE(1980),
    [sym_template_string] = STATE(1980),
    [sym_regex] = STATE(1980),
    [sym_meta_property] = STATE(1980),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4745),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4747),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4747),
    [sym_false] = ACTIONS(4747),
    [sym_null] = ACTIONS(4747),
    [sym_undefined] = ACTIONS(4747),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [1908] = {
    [sym_parenthesized_expression] = STATE(1982),
    [sym__expression] = STATE(1982),
    [sym_yield_expression] = STATE(1982),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1982),
    [sym_jsx_fragment] = STATE(1982),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1982),
    [sym_anonymous_class] = STATE(1982),
    [sym_class] = STATE(1982),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1982),
    [sym_generator_function] = STATE(1982),
    [sym_call_expression] = STATE(1982),
    [sym_new_expression] = STATE(1982),
    [sym_await_expression] = STATE(1982),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1982),
    [sym_augmented_assignment_expression] = STATE(1982),
    [sym_ternary_expression] = STATE(1982),
    [sym_binary_expression] = STATE(1982),
    [sym_unary_expression] = STATE(1982),
    [sym_update_expression] = STATE(1982),
    [sym_string] = STATE(1982),
    [sym_template_string] = STATE(1982),
    [sym_regex] = STATE(1982),
    [sym_meta_property] = STATE(1982),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4749),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4751),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4751),
    [sym_false] = ACTIONS(4751),
    [sym_null] = ACTIONS(4751),
    [sym_undefined] = ACTIONS(4751),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1909] = {
    [sym_object] = STATE(1984),
    [sym_array] = STATE(1985),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4753),
  },
  [1910] = {
    [anon_sym_of] = ACTIONS(4713),
    [sym_comment] = ACTIONS(78),
  },
  [1911] = {
    [anon_sym_of] = ACTIONS(4717),
    [sym_comment] = ACTIONS(78),
  },
  [1912] = {
    [anon_sym_of] = ACTIONS(4721),
    [sym_comment] = ACTIONS(78),
  },
  [1913] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_in] = ACTIONS(3407),
    [anon_sym_COLON] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3407),
    [anon_sym_GT] = ACTIONS(3407),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3419),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3417),
    [anon_sym_GT_GT_GT] = ACTIONS(3411),
    [anon_sym_LT_LT] = ACTIONS(3411),
    [anon_sym_AMP] = ACTIONS(3425),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_PERCENT] = ACTIONS(3411),
    [anon_sym_LT_EQ] = ACTIONS(3431),
    [anon_sym_EQ_EQ] = ACTIONS(3407),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3431),
    [anon_sym_BANG_EQ] = ACTIONS(3407),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3431),
    [anon_sym_GT_EQ] = ACTIONS(3431),
    [anon_sym_instanceof] = ACTIONS(3431),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1914] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(3712),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [anon_sym_in] = ACTIONS(3493),
    [anon_sym_SEMI] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(3493),
    [anon_sym_GT] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(3976),
    [anon_sym_AMP_AMP] = ACTIONS(3978),
    [anon_sym_PIPE_PIPE] = ACTIONS(3980),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(3982),
    [anon_sym_CARET] = ACTIONS(3980),
    [anon_sym_PIPE] = ACTIONS(3984),
    [anon_sym_PLUS] = ACTIONS(3986),
    [anon_sym_DASH] = ACTIONS(3986),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(3988),
    [anon_sym_EQ_EQ] = ACTIONS(3493),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3988),
    [anon_sym_BANG_EQ] = ACTIONS(3493),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3988),
    [anon_sym_GT_EQ] = ACTIONS(3988),
    [anon_sym_instanceof] = ACTIONS(3988),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1915] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(3712),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1916] = {
    [ts_builtin_sym_end] = ACTIONS(4755),
    [anon_sym_export] = ACTIONS(4757),
    [anon_sym_default] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4755),
    [anon_sym_RBRACE] = ACTIONS(4755),
    [anon_sym_import] = ACTIONS(4757),
    [anon_sym_var] = ACTIONS(4757),
    [anon_sym_let] = ACTIONS(4757),
    [anon_sym_const] = ACTIONS(4757),
    [anon_sym_if] = ACTIONS(4757),
    [anon_sym_else] = ACTIONS(4757),
    [anon_sym_switch] = ACTIONS(4757),
    [anon_sym_for] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4755),
    [anon_sym_await] = ACTIONS(4757),
    [anon_sym_while] = ACTIONS(4757),
    [anon_sym_do] = ACTIONS(4757),
    [anon_sym_try] = ACTIONS(4757),
    [anon_sym_with] = ACTIONS(4757),
    [anon_sym_break] = ACTIONS(4757),
    [anon_sym_continue] = ACTIONS(4757),
    [anon_sym_debugger] = ACTIONS(4757),
    [anon_sym_return] = ACTIONS(4757),
    [anon_sym_throw] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4755),
    [anon_sym_case] = ACTIONS(4757),
    [anon_sym_yield] = ACTIONS(4757),
    [anon_sym_LBRACK] = ACTIONS(4755),
    [anon_sym_LT] = ACTIONS(4755),
    [anon_sym_SLASH] = ACTIONS(4757),
    [anon_sym_class] = ACTIONS(4757),
    [anon_sym_async] = ACTIONS(4757),
    [anon_sym_function] = ACTIONS(4757),
    [anon_sym_EQ_GT] = ACTIONS(4755),
    [anon_sym_new] = ACTIONS(4757),
    [anon_sym_PLUS] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_BANG] = ACTIONS(4755),
    [anon_sym_TILDE] = ACTIONS(4755),
    [anon_sym_typeof] = ACTIONS(4757),
    [anon_sym_void] = ACTIONS(4757),
    [anon_sym_delete] = ACTIONS(4757),
    [anon_sym_PLUS_PLUS] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4755),
    [anon_sym_DQUOTE] = ACTIONS(4755),
    [anon_sym_SQUOTE] = ACTIONS(4755),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4755),
    [sym_number] = ACTIONS(4755),
    [sym_identifier] = ACTIONS(4757),
    [sym_this] = ACTIONS(4757),
    [sym_super] = ACTIONS(4757),
    [sym_true] = ACTIONS(4757),
    [sym_false] = ACTIONS(4757),
    [sym_null] = ACTIONS(4757),
    [sym_undefined] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4755),
    [anon_sym_get] = ACTIONS(4757),
    [anon_sym_set] = ACTIONS(4757),
  },
  [1917] = {
    [ts_builtin_sym_end] = ACTIONS(4759),
    [anon_sym_export] = ACTIONS(4761),
    [anon_sym_default] = ACTIONS(4761),
    [anon_sym_LBRACE] = ACTIONS(4759),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [anon_sym_import] = ACTIONS(4761),
    [anon_sym_var] = ACTIONS(4761),
    [anon_sym_let] = ACTIONS(4761),
    [anon_sym_const] = ACTIONS(4761),
    [anon_sym_if] = ACTIONS(4761),
    [anon_sym_else] = ACTIONS(4761),
    [anon_sym_switch] = ACTIONS(4761),
    [anon_sym_for] = ACTIONS(4761),
    [anon_sym_LPAREN] = ACTIONS(4759),
    [anon_sym_await] = ACTIONS(4761),
    [anon_sym_while] = ACTIONS(4761),
    [anon_sym_do] = ACTIONS(4761),
    [anon_sym_try] = ACTIONS(4761),
    [anon_sym_with] = ACTIONS(4761),
    [anon_sym_break] = ACTIONS(4761),
    [anon_sym_continue] = ACTIONS(4761),
    [anon_sym_debugger] = ACTIONS(4761),
    [anon_sym_return] = ACTIONS(4761),
    [anon_sym_throw] = ACTIONS(4761),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_case] = ACTIONS(4761),
    [anon_sym_yield] = ACTIONS(4761),
    [anon_sym_LBRACK] = ACTIONS(4759),
    [anon_sym_LT] = ACTIONS(4759),
    [anon_sym_SLASH] = ACTIONS(4761),
    [anon_sym_class] = ACTIONS(4761),
    [anon_sym_async] = ACTIONS(4761),
    [anon_sym_function] = ACTIONS(4761),
    [anon_sym_EQ_GT] = ACTIONS(4759),
    [anon_sym_new] = ACTIONS(4761),
    [anon_sym_PLUS] = ACTIONS(4761),
    [anon_sym_DASH] = ACTIONS(4761),
    [anon_sym_BANG] = ACTIONS(4759),
    [anon_sym_TILDE] = ACTIONS(4759),
    [anon_sym_typeof] = ACTIONS(4761),
    [anon_sym_void] = ACTIONS(4761),
    [anon_sym_delete] = ACTIONS(4761),
    [anon_sym_PLUS_PLUS] = ACTIONS(4759),
    [anon_sym_DASH_DASH] = ACTIONS(4759),
    [anon_sym_DQUOTE] = ACTIONS(4759),
    [anon_sym_SQUOTE] = ACTIONS(4759),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4759),
    [sym_number] = ACTIONS(4759),
    [sym_identifier] = ACTIONS(4761),
    [sym_this] = ACTIONS(4761),
    [sym_super] = ACTIONS(4761),
    [sym_true] = ACTIONS(4761),
    [sym_false] = ACTIONS(4761),
    [sym_null] = ACTIONS(4761),
    [sym_undefined] = ACTIONS(4761),
    [anon_sym_AT] = ACTIONS(4759),
    [anon_sym_get] = ACTIONS(4761),
    [anon_sym_set] = ACTIONS(4761),
  },
  [1918] = {
    [ts_builtin_sym_end] = ACTIONS(4763),
    [anon_sym_export] = ACTIONS(4765),
    [anon_sym_default] = ACTIONS(4765),
    [anon_sym_LBRACE] = ACTIONS(4763),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_import] = ACTIONS(4765),
    [anon_sym_var] = ACTIONS(4765),
    [anon_sym_let] = ACTIONS(4765),
    [anon_sym_const] = ACTIONS(4765),
    [anon_sym_if] = ACTIONS(4765),
    [anon_sym_else] = ACTIONS(4765),
    [anon_sym_switch] = ACTIONS(4765),
    [anon_sym_for] = ACTIONS(4765),
    [anon_sym_LPAREN] = ACTIONS(4763),
    [anon_sym_await] = ACTIONS(4765),
    [anon_sym_while] = ACTIONS(4765),
    [anon_sym_do] = ACTIONS(4765),
    [anon_sym_try] = ACTIONS(4765),
    [anon_sym_with] = ACTIONS(4765),
    [anon_sym_break] = ACTIONS(4765),
    [anon_sym_continue] = ACTIONS(4765),
    [anon_sym_debugger] = ACTIONS(4765),
    [anon_sym_return] = ACTIONS(4765),
    [anon_sym_throw] = ACTIONS(4765),
    [anon_sym_SEMI] = ACTIONS(4763),
    [anon_sym_case] = ACTIONS(4765),
    [anon_sym_yield] = ACTIONS(4765),
    [anon_sym_LBRACK] = ACTIONS(4763),
    [anon_sym_LT] = ACTIONS(4763),
    [anon_sym_SLASH] = ACTIONS(4765),
    [anon_sym_class] = ACTIONS(4765),
    [anon_sym_async] = ACTIONS(4765),
    [anon_sym_function] = ACTIONS(4765),
    [anon_sym_EQ_GT] = ACTIONS(4763),
    [anon_sym_new] = ACTIONS(4765),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_BANG] = ACTIONS(4763),
    [anon_sym_TILDE] = ACTIONS(4763),
    [anon_sym_typeof] = ACTIONS(4765),
    [anon_sym_void] = ACTIONS(4765),
    [anon_sym_delete] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4763),
    [anon_sym_DASH_DASH] = ACTIONS(4763),
    [anon_sym_DQUOTE] = ACTIONS(4763),
    [anon_sym_SQUOTE] = ACTIONS(4763),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(4763),
    [sym_number] = ACTIONS(4763),
    [sym_identifier] = ACTIONS(4765),
    [sym_this] = ACTIONS(4765),
    [sym_super] = ACTIONS(4765),
    [sym_true] = ACTIONS(4765),
    [sym_false] = ACTIONS(4765),
    [sym_null] = ACTIONS(4765),
    [sym_undefined] = ACTIONS(4765),
    [anon_sym_AT] = ACTIONS(4763),
    [anon_sym_get] = ACTIONS(4765),
    [anon_sym_set] = ACTIONS(4765),
  },
  [1919] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1920] = {
    [anon_sym_RPAREN] = ACTIONS(4767),
    [sym_comment] = ACTIONS(78),
  },
  [1921] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4769),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1922] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1923] = {
    [anon_sym_RPAREN] = ACTIONS(4771),
    [sym_comment] = ACTIONS(78),
  },
  [1924] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4773),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1925] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1926] = {
    [anon_sym_RPAREN] = ACTIONS(4775),
    [sym_comment] = ACTIONS(78),
  },
  [1927] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4777),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1928] = {
    [sym_export_statement] = STATE(1672),
    [sym__declaration] = STATE(1672),
    [sym_import_statement] = STATE(1672),
    [sym_expression_statement] = STATE(1672),
    [sym_variable_declaration] = STATE(1672),
    [sym_lexical_declaration] = STATE(1672),
    [sym_statement_block] = STATE(1672),
    [sym_if_statement] = STATE(1672),
    [sym_switch_statement] = STATE(1672),
    [sym_for_statement] = STATE(1672),
    [sym_for_in_statement] = STATE(1672),
    [sym_for_of_statement] = STATE(1672),
    [sym_while_statement] = STATE(1672),
    [sym_do_statement] = STATE(1672),
    [sym_try_statement] = STATE(1672),
    [sym_with_statement] = STATE(1672),
    [sym_break_statement] = STATE(1672),
    [sym_continue_statement] = STATE(1672),
    [sym_debugger_statement] = STATE(1672),
    [sym_return_statement] = STATE(1672),
    [sym_throw_statement] = STATE(1672),
    [sym_empty_statement] = STATE(1672),
    [sym_labeled_statement] = STATE(1672),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1929] = {
    [sym_export_statement] = STATE(1683),
    [sym__declaration] = STATE(1683),
    [sym_import_statement] = STATE(1683),
    [sym_expression_statement] = STATE(1683),
    [sym_variable_declaration] = STATE(1683),
    [sym_lexical_declaration] = STATE(1683),
    [sym_statement_block] = STATE(1683),
    [sym_if_statement] = STATE(1683),
    [sym_switch_statement] = STATE(1683),
    [sym_for_statement] = STATE(1683),
    [sym_for_in_statement] = STATE(1683),
    [sym_for_of_statement] = STATE(1683),
    [sym_while_statement] = STATE(1683),
    [sym_do_statement] = STATE(1683),
    [sym_try_statement] = STATE(1683),
    [sym_with_statement] = STATE(1683),
    [sym_break_statement] = STATE(1683),
    [sym_continue_statement] = STATE(1683),
    [sym_debugger_statement] = STATE(1683),
    [sym_return_statement] = STATE(1683),
    [sym_throw_statement] = STATE(1683),
    [sym_empty_statement] = STATE(1683),
    [sym_labeled_statement] = STATE(1683),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1930] = {
    [sym_export_statement] = STATE(1688),
    [sym__declaration] = STATE(1688),
    [sym_import_statement] = STATE(1688),
    [sym_expression_statement] = STATE(1688),
    [sym_variable_declaration] = STATE(1688),
    [sym_lexical_declaration] = STATE(1688),
    [sym_statement_block] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_switch_statement] = STATE(1688),
    [sym_for_statement] = STATE(1688),
    [sym_for_in_statement] = STATE(1688),
    [sym_for_of_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_do_statement] = STATE(1688),
    [sym_try_statement] = STATE(1688),
    [sym_with_statement] = STATE(1688),
    [sym_break_statement] = STATE(1688),
    [sym_continue_statement] = STATE(1688),
    [sym_debugger_statement] = STATE(1688),
    [sym_return_statement] = STATE(1688),
    [sym_throw_statement] = STATE(1688),
    [sym_empty_statement] = STATE(1688),
    [sym_labeled_statement] = STATE(1688),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1931] = {
    [sym_export_statement] = STATE(1689),
    [sym__declaration] = STATE(1689),
    [sym_import_statement] = STATE(1689),
    [sym_expression_statement] = STATE(1689),
    [sym_variable_declaration] = STATE(1689),
    [sym_lexical_declaration] = STATE(1689),
    [sym_statement_block] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_switch_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_for_in_statement] = STATE(1689),
    [sym_for_of_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_do_statement] = STATE(1689),
    [sym_try_statement] = STATE(1689),
    [sym_with_statement] = STATE(1689),
    [sym_break_statement] = STATE(1689),
    [sym_continue_statement] = STATE(1689),
    [sym_debugger_statement] = STATE(1689),
    [sym_return_statement] = STATE(1689),
    [sym_throw_statement] = STATE(1689),
    [sym_empty_statement] = STATE(1689),
    [sym_labeled_statement] = STATE(1689),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1932] = {
    [sym_export_statement] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym_import_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_lexical_declaration] = STATE(1690),
    [sym_statement_block] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_for_in_statement] = STATE(1690),
    [sym_for_of_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_try_statement] = STATE(1690),
    [sym_with_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_debugger_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_throw_statement] = STATE(1690),
    [sym_empty_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1933] = {
    [sym_export_statement] = STATE(1691),
    [sym__declaration] = STATE(1691),
    [sym_import_statement] = STATE(1691),
    [sym_expression_statement] = STATE(1691),
    [sym_variable_declaration] = STATE(1691),
    [sym_lexical_declaration] = STATE(1691),
    [sym_statement_block] = STATE(1691),
    [sym_if_statement] = STATE(1691),
    [sym_switch_statement] = STATE(1691),
    [sym_for_statement] = STATE(1691),
    [sym_for_in_statement] = STATE(1691),
    [sym_for_of_statement] = STATE(1691),
    [sym_while_statement] = STATE(1691),
    [sym_do_statement] = STATE(1691),
    [sym_try_statement] = STATE(1691),
    [sym_with_statement] = STATE(1691),
    [sym_break_statement] = STATE(1691),
    [sym_continue_statement] = STATE(1691),
    [sym_debugger_statement] = STATE(1691),
    [sym_return_statement] = STATE(1691),
    [sym_throw_statement] = STATE(1691),
    [sym_empty_statement] = STATE(1691),
    [sym_labeled_statement] = STATE(1691),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1934] = {
    [sym_export_statement] = STATE(1692),
    [sym__declaration] = STATE(1692),
    [sym_import_statement] = STATE(1692),
    [sym_expression_statement] = STATE(1692),
    [sym_variable_declaration] = STATE(1692),
    [sym_lexical_declaration] = STATE(1692),
    [sym_statement_block] = STATE(1692),
    [sym_if_statement] = STATE(1692),
    [sym_switch_statement] = STATE(1692),
    [sym_for_statement] = STATE(1692),
    [sym_for_in_statement] = STATE(1692),
    [sym_for_of_statement] = STATE(1692),
    [sym_while_statement] = STATE(1692),
    [sym_do_statement] = STATE(1692),
    [sym_try_statement] = STATE(1692),
    [sym_with_statement] = STATE(1692),
    [sym_break_statement] = STATE(1692),
    [sym_continue_statement] = STATE(1692),
    [sym_debugger_statement] = STATE(1692),
    [sym_return_statement] = STATE(1692),
    [sym_throw_statement] = STATE(1692),
    [sym_empty_statement] = STATE(1692),
    [sym_labeled_statement] = STATE(1692),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1935] = {
    [sym_parenthesized_expression] = STATE(1992),
    [sym__expression] = STATE(1992),
    [sym_yield_expression] = STATE(1992),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1992),
    [sym_jsx_fragment] = STATE(1992),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1992),
    [sym_anonymous_class] = STATE(1992),
    [sym_class] = STATE(1992),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1992),
    [sym_generator_function] = STATE(1992),
    [sym_call_expression] = STATE(1992),
    [sym_new_expression] = STATE(1992),
    [sym_await_expression] = STATE(1992),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1992),
    [sym_augmented_assignment_expression] = STATE(1992),
    [sym_ternary_expression] = STATE(1992),
    [sym_binary_expression] = STATE(1992),
    [sym_unary_expression] = STATE(1992),
    [sym_update_expression] = STATE(1992),
    [sym_string] = STATE(1992),
    [sym_template_string] = STATE(1992),
    [sym_regex] = STATE(1992),
    [sym_meta_property] = STATE(1992),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4779),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4781),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4781),
    [sym_false] = ACTIONS(4781),
    [sym_null] = ACTIONS(4781),
    [sym_undefined] = ACTIONS(4781),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1936] = {
    [sym_parenthesized_expression] = STATE(1993),
    [sym__expression] = STATE(1993),
    [sym_yield_expression] = STATE(1993),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1993),
    [sym_jsx_fragment] = STATE(1993),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1993),
    [sym_anonymous_class] = STATE(1993),
    [sym_class] = STATE(1993),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1993),
    [sym_generator_function] = STATE(1993),
    [sym_call_expression] = STATE(1993),
    [sym_new_expression] = STATE(1993),
    [sym_await_expression] = STATE(1993),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1993),
    [sym_augmented_assignment_expression] = STATE(1993),
    [sym_ternary_expression] = STATE(1993),
    [sym_binary_expression] = STATE(1993),
    [sym_unary_expression] = STATE(1993),
    [sym_update_expression] = STATE(1993),
    [sym_string] = STATE(1993),
    [sym_template_string] = STATE(1993),
    [sym_regex] = STATE(1993),
    [sym_meta_property] = STATE(1993),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4783),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4785),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4785),
    [sym_false] = ACTIONS(4785),
    [sym_null] = ACTIONS(4785),
    [sym_undefined] = ACTIONS(4785),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1937] = {
    [sym_parenthesized_expression] = STATE(1994),
    [sym__expression] = STATE(1994),
    [sym_yield_expression] = STATE(1994),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(1994),
    [sym_jsx_fragment] = STATE(1994),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(1994),
    [sym_anonymous_class] = STATE(1994),
    [sym_class] = STATE(1994),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(1994),
    [sym_generator_function] = STATE(1994),
    [sym_call_expression] = STATE(1994),
    [sym_new_expression] = STATE(1994),
    [sym_await_expression] = STATE(1994),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(1994),
    [sym_augmented_assignment_expression] = STATE(1994),
    [sym_ternary_expression] = STATE(1994),
    [sym_binary_expression] = STATE(1994),
    [sym_unary_expression] = STATE(1994),
    [sym_update_expression] = STATE(1994),
    [sym_string] = STATE(1994),
    [sym_template_string] = STATE(1994),
    [sym_regex] = STATE(1994),
    [sym_meta_property] = STATE(1994),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4787),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4789),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4789),
    [sym_false] = ACTIONS(4789),
    [sym_null] = ACTIONS(4789),
    [sym_undefined] = ACTIONS(4789),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1938] = {
    [sym_export_statement] = STATE(1916),
    [sym__declaration] = STATE(1916),
    [sym_import_statement] = STATE(1916),
    [sym_expression_statement] = STATE(1916),
    [sym_variable_declaration] = STATE(1916),
    [sym_lexical_declaration] = STATE(1916),
    [sym_statement_block] = STATE(1916),
    [sym_if_statement] = STATE(1916),
    [sym_switch_statement] = STATE(1916),
    [sym_for_statement] = STATE(1916),
    [sym_for_in_statement] = STATE(1916),
    [sym_for_of_statement] = STATE(1916),
    [sym_while_statement] = STATE(1916),
    [sym_do_statement] = STATE(1916),
    [sym_try_statement] = STATE(1916),
    [sym_with_statement] = STATE(1916),
    [sym_break_statement] = STATE(1916),
    [sym_continue_statement] = STATE(1916),
    [sym_debugger_statement] = STATE(1916),
    [sym_return_statement] = STATE(1916),
    [sym_throw_statement] = STATE(1916),
    [sym_empty_statement] = STATE(1916),
    [sym_labeled_statement] = STATE(1916),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1939] = {
    [sym_export_statement] = STATE(1917),
    [sym__declaration] = STATE(1917),
    [sym_import_statement] = STATE(1917),
    [sym_expression_statement] = STATE(1917),
    [sym_variable_declaration] = STATE(1917),
    [sym_lexical_declaration] = STATE(1917),
    [sym_statement_block] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_switch_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_for_in_statement] = STATE(1917),
    [sym_for_of_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_do_statement] = STATE(1917),
    [sym_try_statement] = STATE(1917),
    [sym_with_statement] = STATE(1917),
    [sym_break_statement] = STATE(1917),
    [sym_continue_statement] = STATE(1917),
    [sym_debugger_statement] = STATE(1917),
    [sym_return_statement] = STATE(1917),
    [sym_throw_statement] = STATE(1917),
    [sym_empty_statement] = STATE(1917),
    [sym_labeled_statement] = STATE(1917),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1940] = {
    [sym_export_statement] = STATE(1918),
    [sym__declaration] = STATE(1918),
    [sym_import_statement] = STATE(1918),
    [sym_expression_statement] = STATE(1918),
    [sym_variable_declaration] = STATE(1918),
    [sym_lexical_declaration] = STATE(1918),
    [sym_statement_block] = STATE(1918),
    [sym_if_statement] = STATE(1918),
    [sym_switch_statement] = STATE(1918),
    [sym_for_statement] = STATE(1918),
    [sym_for_in_statement] = STATE(1918),
    [sym_for_of_statement] = STATE(1918),
    [sym_while_statement] = STATE(1918),
    [sym_do_statement] = STATE(1918),
    [sym_try_statement] = STATE(1918),
    [sym_with_statement] = STATE(1918),
    [sym_break_statement] = STATE(1918),
    [sym_continue_statement] = STATE(1918),
    [sym_debugger_statement] = STATE(1918),
    [sym_return_statement] = STATE(1918),
    [sym_throw_statement] = STATE(1918),
    [sym_empty_statement] = STATE(1918),
    [sym_labeled_statement] = STATE(1918),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(216),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(218),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(220),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(224),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1941] = {
    [anon_sym_LBRACE] = ACTIONS(3645),
    [anon_sym_GT] = ACTIONS(3645),
    [anon_sym_SLASH] = ACTIONS(3647),
    [sym_jsx_identifier] = ACTIONS(3645),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3647),
  },
  [1942] = {
    [anon_sym_GT] = ACTIONS(4791),
    [sym_comment] = ACTIONS(78),
  },
  [1943] = {
    [anon_sym_LBRACE] = ACTIONS(3677),
    [anon_sym_GT] = ACTIONS(3677),
    [anon_sym_SLASH] = ACTIONS(3679),
    [sym_jsx_identifier] = ACTIONS(3677),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3679),
  },
  [1944] = {
    [anon_sym_LBRACE] = ACTIONS(3754),
    [anon_sym_GT] = ACTIONS(3754),
    [anon_sym_SLASH] = ACTIONS(3756),
    [sym_jsx_identifier] = ACTIONS(3754),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(3756),
  },
  [1945] = {
    [sym_export_statement] = STATE(1809),
    [sym__declaration] = STATE(1809),
    [sym_import_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_variable_declaration] = STATE(1809),
    [sym_lexical_declaration] = STATE(1809),
    [sym_statement_block] = STATE(1809),
    [sym_if_statement] = STATE(1809),
    [sym_switch_statement] = STATE(1809),
    [sym_for_statement] = STATE(1809),
    [sym_for_in_statement] = STATE(1809),
    [sym_for_of_statement] = STATE(1809),
    [sym_while_statement] = STATE(1809),
    [sym_do_statement] = STATE(1809),
    [sym_try_statement] = STATE(1809),
    [sym_with_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_debugger_statement] = STATE(1809),
    [sym_return_statement] = STATE(1809),
    [sym_throw_statement] = STATE(1809),
    [sym_empty_statement] = STATE(1809),
    [sym_labeled_statement] = STATE(1809),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1946] = {
    [sym_export_statement] = STATE(1810),
    [sym__declaration] = STATE(1810),
    [sym_import_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_variable_declaration] = STATE(1810),
    [sym_lexical_declaration] = STATE(1810),
    [sym_statement_block] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_for_in_statement] = STATE(1810),
    [sym_for_of_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_with_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_debugger_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_throw_statement] = STATE(1810),
    [sym_empty_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1947] = {
    [sym_export_statement] = STATE(1811),
    [sym__declaration] = STATE(1811),
    [sym_import_statement] = STATE(1811),
    [sym_expression_statement] = STATE(1811),
    [sym_variable_declaration] = STATE(1811),
    [sym_lexical_declaration] = STATE(1811),
    [sym_statement_block] = STATE(1811),
    [sym_if_statement] = STATE(1811),
    [sym_switch_statement] = STATE(1811),
    [sym_for_statement] = STATE(1811),
    [sym_for_in_statement] = STATE(1811),
    [sym_for_of_statement] = STATE(1811),
    [sym_while_statement] = STATE(1811),
    [sym_do_statement] = STATE(1811),
    [sym_try_statement] = STATE(1811),
    [sym_with_statement] = STATE(1811),
    [sym_break_statement] = STATE(1811),
    [sym_continue_statement] = STATE(1811),
    [sym_debugger_statement] = STATE(1811),
    [sym_return_statement] = STATE(1811),
    [sym_throw_statement] = STATE(1811),
    [sym_empty_statement] = STATE(1811),
    [sym_labeled_statement] = STATE(1811),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1948] = {
    [sym_export_statement] = STATE(1812),
    [sym__declaration] = STATE(1812),
    [sym_import_statement] = STATE(1812),
    [sym_expression_statement] = STATE(1812),
    [sym_variable_declaration] = STATE(1812),
    [sym_lexical_declaration] = STATE(1812),
    [sym_statement_block] = STATE(1812),
    [sym_if_statement] = STATE(1812),
    [sym_switch_statement] = STATE(1812),
    [sym_for_statement] = STATE(1812),
    [sym_for_in_statement] = STATE(1812),
    [sym_for_of_statement] = STATE(1812),
    [sym_while_statement] = STATE(1812),
    [sym_do_statement] = STATE(1812),
    [sym_try_statement] = STATE(1812),
    [sym_with_statement] = STATE(1812),
    [sym_break_statement] = STATE(1812),
    [sym_continue_statement] = STATE(1812),
    [sym_debugger_statement] = STATE(1812),
    [sym_return_statement] = STATE(1812),
    [sym_throw_statement] = STATE(1812),
    [sym_empty_statement] = STATE(1812),
    [sym_labeled_statement] = STATE(1812),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1949] = {
    [sym_export_statement] = STATE(1813),
    [sym__declaration] = STATE(1813),
    [sym_import_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_variable_declaration] = STATE(1813),
    [sym_lexical_declaration] = STATE(1813),
    [sym_statement_block] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_for_in_statement] = STATE(1813),
    [sym_for_of_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_with_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_debugger_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_throw_statement] = STATE(1813),
    [sym_empty_statement] = STATE(1813),
    [sym_labeled_statement] = STATE(1813),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1950] = {
    [sym_export_statement] = STATE(1814),
    [sym__declaration] = STATE(1814),
    [sym_import_statement] = STATE(1814),
    [sym_expression_statement] = STATE(1814),
    [sym_variable_declaration] = STATE(1814),
    [sym_lexical_declaration] = STATE(1814),
    [sym_statement_block] = STATE(1814),
    [sym_if_statement] = STATE(1814),
    [sym_switch_statement] = STATE(1814),
    [sym_for_statement] = STATE(1814),
    [sym_for_in_statement] = STATE(1814),
    [sym_for_of_statement] = STATE(1814),
    [sym_while_statement] = STATE(1814),
    [sym_do_statement] = STATE(1814),
    [sym_try_statement] = STATE(1814),
    [sym_with_statement] = STATE(1814),
    [sym_break_statement] = STATE(1814),
    [sym_continue_statement] = STATE(1814),
    [sym_debugger_statement] = STATE(1814),
    [sym_return_statement] = STATE(1814),
    [sym_throw_statement] = STATE(1814),
    [sym_empty_statement] = STATE(1814),
    [sym_labeled_statement] = STATE(1814),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1951] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4793),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1952] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4795),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1953] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4797),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1954] = {
    [sym_export_statement] = STATE(1916),
    [sym__declaration] = STATE(1916),
    [sym_import_statement] = STATE(1916),
    [sym_expression_statement] = STATE(1916),
    [sym_variable_declaration] = STATE(1916),
    [sym_lexical_declaration] = STATE(1916),
    [sym_statement_block] = STATE(1916),
    [sym_if_statement] = STATE(1916),
    [sym_switch_statement] = STATE(1916),
    [sym_for_statement] = STATE(1916),
    [sym_for_in_statement] = STATE(1916),
    [sym_for_of_statement] = STATE(1916),
    [sym_while_statement] = STATE(1916),
    [sym_do_statement] = STATE(1916),
    [sym_try_statement] = STATE(1916),
    [sym_with_statement] = STATE(1916),
    [sym_break_statement] = STATE(1916),
    [sym_continue_statement] = STATE(1916),
    [sym_debugger_statement] = STATE(1916),
    [sym_return_statement] = STATE(1916),
    [sym_throw_statement] = STATE(1916),
    [sym_empty_statement] = STATE(1916),
    [sym_labeled_statement] = STATE(1916),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1955] = {
    [sym_export_statement] = STATE(1917),
    [sym__declaration] = STATE(1917),
    [sym_import_statement] = STATE(1917),
    [sym_expression_statement] = STATE(1917),
    [sym_variable_declaration] = STATE(1917),
    [sym_lexical_declaration] = STATE(1917),
    [sym_statement_block] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_switch_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_for_in_statement] = STATE(1917),
    [sym_for_of_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_do_statement] = STATE(1917),
    [sym_try_statement] = STATE(1917),
    [sym_with_statement] = STATE(1917),
    [sym_break_statement] = STATE(1917),
    [sym_continue_statement] = STATE(1917),
    [sym_debugger_statement] = STATE(1917),
    [sym_return_statement] = STATE(1917),
    [sym_throw_statement] = STATE(1917),
    [sym_empty_statement] = STATE(1917),
    [sym_labeled_statement] = STATE(1917),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1956] = {
    [sym_export_statement] = STATE(1918),
    [sym__declaration] = STATE(1918),
    [sym_import_statement] = STATE(1918),
    [sym_expression_statement] = STATE(1918),
    [sym_variable_declaration] = STATE(1918),
    [sym_lexical_declaration] = STATE(1918),
    [sym_statement_block] = STATE(1918),
    [sym_if_statement] = STATE(1918),
    [sym_switch_statement] = STATE(1918),
    [sym_for_statement] = STATE(1918),
    [sym_for_in_statement] = STATE(1918),
    [sym_for_of_statement] = STATE(1918),
    [sym_while_statement] = STATE(1918),
    [sym_do_statement] = STATE(1918),
    [sym_try_statement] = STATE(1918),
    [sym_with_statement] = STATE(1918),
    [sym_break_statement] = STATE(1918),
    [sym_continue_statement] = STATE(1918),
    [sym_debugger_statement] = STATE(1918),
    [sym_return_statement] = STATE(1918),
    [sym_throw_statement] = STATE(1918),
    [sym_empty_statement] = STATE(1918),
    [sym_labeled_statement] = STATE(1918),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(661),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(665),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(667),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1957] = {
    [anon_sym_export] = ACTIONS(1724),
    [anon_sym_default] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1722),
    [anon_sym_RBRACE] = ACTIONS(1722),
    [anon_sym_import] = ACTIONS(1724),
    [anon_sym_var] = ACTIONS(1724),
    [anon_sym_let] = ACTIONS(1724),
    [anon_sym_const] = ACTIONS(1724),
    [anon_sym_if] = ACTIONS(1724),
    [anon_sym_else] = ACTIONS(4799),
    [anon_sym_switch] = ACTIONS(1724),
    [anon_sym_for] = ACTIONS(1724),
    [anon_sym_LPAREN] = ACTIONS(1722),
    [anon_sym_await] = ACTIONS(1724),
    [anon_sym_while] = ACTIONS(1724),
    [anon_sym_do] = ACTIONS(1724),
    [anon_sym_try] = ACTIONS(1724),
    [anon_sym_with] = ACTIONS(1724),
    [anon_sym_break] = ACTIONS(1724),
    [anon_sym_continue] = ACTIONS(1724),
    [anon_sym_debugger] = ACTIONS(1724),
    [anon_sym_return] = ACTIONS(1724),
    [anon_sym_throw] = ACTIONS(1724),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_case] = ACTIONS(1724),
    [anon_sym_yield] = ACTIONS(1724),
    [anon_sym_LBRACK] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_SLASH] = ACTIONS(1724),
    [anon_sym_class] = ACTIONS(1724),
    [anon_sym_async] = ACTIONS(1724),
    [anon_sym_function] = ACTIONS(1724),
    [anon_sym_EQ_GT] = ACTIONS(1722),
    [anon_sym_new] = ACTIONS(1724),
    [anon_sym_PLUS] = ACTIONS(1724),
    [anon_sym_DASH] = ACTIONS(1724),
    [anon_sym_BANG] = ACTIONS(1722),
    [anon_sym_TILDE] = ACTIONS(1722),
    [anon_sym_typeof] = ACTIONS(1724),
    [anon_sym_void] = ACTIONS(1724),
    [anon_sym_delete] = ACTIONS(1724),
    [anon_sym_PLUS_PLUS] = ACTIONS(1722),
    [anon_sym_DASH_DASH] = ACTIONS(1722),
    [anon_sym_DQUOTE] = ACTIONS(1722),
    [anon_sym_SQUOTE] = ACTIONS(1722),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(1722),
    [sym_number] = ACTIONS(1722),
    [sym_identifier] = ACTIONS(1724),
    [sym_this] = ACTIONS(1724),
    [sym_super] = ACTIONS(1724),
    [sym_true] = ACTIONS(1724),
    [sym_false] = ACTIONS(1724),
    [sym_null] = ACTIONS(1724),
    [sym_undefined] = ACTIONS(1724),
    [anon_sym_AT] = ACTIONS(1722),
    [anon_sym_get] = ACTIONS(1724),
    [anon_sym_set] = ACTIONS(1724),
  },
  [1958] = {
    [sym_variable_declarator] = STATE(93),
    [sym_object] = STATE(2001),
    [sym_array] = STATE(2002),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4801),
  },
  [1959] = {
    [sym_variable_declarator] = STATE(96),
    [sym_object] = STATE(2001),
    [sym_array] = STATE(2002),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(146),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4801),
  },
  [1960] = {
    [sym__initializer] = STATE(235),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(385),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(4803),
    [anon_sym_of] = ACTIONS(4805),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_PLUS_EQ] = ACTIONS(393),
    [anon_sym_DASH_EQ] = ACTIONS(393),
    [anon_sym_STAR_EQ] = ACTIONS(393),
    [anon_sym_SLASH_EQ] = ACTIONS(393),
    [anon_sym_PERCENT_EQ] = ACTIONS(393),
    [anon_sym_CARET_EQ] = ACTIONS(393),
    [anon_sym_AMP_EQ] = ACTIONS(393),
    [anon_sym_PIPE_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(393),
    [anon_sym_LT_LT_EQ] = ACTIONS(393),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(385),
    [anon_sym_LT_LT] = ACTIONS(385),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(385),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(385),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1961] = {
    [sym_expression_statement] = STATE(2005),
    [sym_empty_statement] = STATE(2005),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(42),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(42),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(210),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1962] = {
    [sym__initializer] = STATE(250),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(4807),
    [anon_sym_of] = ACTIONS(4809),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1963] = {
    [sym__initializer] = STATE(251),
    [sym__automatic_semicolon] = ACTIONS(383),
    [anon_sym_STAR] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_in] = ACTIONS(4811),
    [anon_sym_of] = ACTIONS(4813),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(385),
    [anon_sym_GT] = ACTIONS(385),
    [anon_sym_SLASH] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(383),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(385),
    [anon_sym_GT_GT_GT] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_PERCENT] = ACTIONS(383),
    [anon_sym_LT_EQ] = ACTIONS(383),
    [anon_sym_EQ_EQ] = ACTIONS(385),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(383),
    [anon_sym_BANG_EQ] = ACTIONS(385),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(383),
    [anon_sym_GT_EQ] = ACTIONS(383),
    [anon_sym_instanceof] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(383),
  },
  [1964] = {
    [sym_object] = STATE(2012),
    [sym_array] = STATE(2013),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_var] = ACTIONS(4815),
    [anon_sym_let] = ACTIONS(4815),
    [anon_sym_const] = ACTIONS(4815),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4817),
  },
  [1965] = {
    [sym_parenthesized_expression] = STATE(2014),
    [sym__expression] = STATE(2014),
    [sym_yield_expression] = STATE(2014),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(2014),
    [sym_jsx_fragment] = STATE(2014),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2014),
    [sym_anonymous_class] = STATE(2014),
    [sym_class] = STATE(2014),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2014),
    [sym_generator_function] = STATE(2014),
    [sym_call_expression] = STATE(2014),
    [sym_new_expression] = STATE(2014),
    [sym_await_expression] = STATE(2014),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(2014),
    [sym_augmented_assignment_expression] = STATE(2014),
    [sym_ternary_expression] = STATE(2014),
    [sym_binary_expression] = STATE(2014),
    [sym_unary_expression] = STATE(2014),
    [sym_update_expression] = STATE(2014),
    [sym_sequence_expression] = STATE(2015),
    [sym_string] = STATE(2014),
    [sym_template_string] = STATE(2014),
    [sym_regex] = STATE(2014),
    [sym_meta_property] = STATE(2014),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4819),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4821),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4821),
    [sym_false] = ACTIONS(4821),
    [sym_null] = ACTIONS(4821),
    [sym_undefined] = ACTIONS(4821),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1966] = {
    [sym_parenthesized_expression] = STATE(2016),
    [sym__expression] = STATE(2016),
    [sym_yield_expression] = STATE(2016),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2016),
    [sym_jsx_fragment] = STATE(2016),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2016),
    [sym_anonymous_class] = STATE(2016),
    [sym_class] = STATE(2016),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2016),
    [sym_generator_function] = STATE(2016),
    [sym_call_expression] = STATE(2016),
    [sym_new_expression] = STATE(2016),
    [sym_await_expression] = STATE(2016),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2016),
    [sym_augmented_assignment_expression] = STATE(2016),
    [sym_ternary_expression] = STATE(2016),
    [sym_binary_expression] = STATE(2016),
    [sym_unary_expression] = STATE(2016),
    [sym_update_expression] = STATE(2016),
    [sym_string] = STATE(2016),
    [sym_template_string] = STATE(2016),
    [sym_regex] = STATE(2016),
    [sym_meta_property] = STATE(2016),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4823),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4825),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4825),
    [sym_false] = ACTIONS(4825),
    [sym_null] = ACTIONS(4825),
    [sym_undefined] = ACTIONS(4825),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1967] = {
    [sym_parenthesized_expression] = STATE(2017),
    [sym__expression] = STATE(2017),
    [sym_yield_expression] = STATE(2017),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(2017),
    [sym_jsx_fragment] = STATE(2017),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2017),
    [sym_anonymous_class] = STATE(2017),
    [sym_class] = STATE(2017),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2017),
    [sym_generator_function] = STATE(2017),
    [sym_call_expression] = STATE(2017),
    [sym_new_expression] = STATE(2017),
    [sym_await_expression] = STATE(2017),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(2017),
    [sym_augmented_assignment_expression] = STATE(2017),
    [sym_ternary_expression] = STATE(2017),
    [sym_binary_expression] = STATE(2017),
    [sym_unary_expression] = STATE(2017),
    [sym_update_expression] = STATE(2017),
    [sym_sequence_expression] = STATE(2018),
    [sym_string] = STATE(2017),
    [sym_template_string] = STATE(2017),
    [sym_regex] = STATE(2017),
    [sym_meta_property] = STATE(2017),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4827),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4829),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4829),
    [sym_false] = ACTIONS(4829),
    [sym_null] = ACTIONS(4829),
    [sym_undefined] = ACTIONS(4829),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1968] = {
    [sym_parenthesized_expression] = STATE(2019),
    [sym__expression] = STATE(2019),
    [sym_yield_expression] = STATE(2019),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2019),
    [sym_jsx_fragment] = STATE(2019),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2019),
    [sym_anonymous_class] = STATE(2019),
    [sym_class] = STATE(2019),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2019),
    [sym_generator_function] = STATE(2019),
    [sym_call_expression] = STATE(2019),
    [sym_new_expression] = STATE(2019),
    [sym_await_expression] = STATE(2019),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2019),
    [sym_augmented_assignment_expression] = STATE(2019),
    [sym_ternary_expression] = STATE(2019),
    [sym_binary_expression] = STATE(2019),
    [sym_unary_expression] = STATE(2019),
    [sym_update_expression] = STATE(2019),
    [sym_string] = STATE(2019),
    [sym_template_string] = STATE(2019),
    [sym_regex] = STATE(2019),
    [sym_meta_property] = STATE(2019),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4831),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4833),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4833),
    [sym_false] = ACTIONS(4833),
    [sym_null] = ACTIONS(4833),
    [sym_undefined] = ACTIONS(4833),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1969] = {
    [sym_parenthesized_expression] = STATE(2020),
    [sym__expression] = STATE(2020),
    [sym_yield_expression] = STATE(2020),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(2020),
    [sym_jsx_fragment] = STATE(2020),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2020),
    [sym_anonymous_class] = STATE(2020),
    [sym_class] = STATE(2020),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2020),
    [sym_generator_function] = STATE(2020),
    [sym_call_expression] = STATE(2020),
    [sym_new_expression] = STATE(2020),
    [sym_await_expression] = STATE(2020),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(2020),
    [sym_augmented_assignment_expression] = STATE(2020),
    [sym_ternary_expression] = STATE(2020),
    [sym_binary_expression] = STATE(2020),
    [sym_unary_expression] = STATE(2020),
    [sym_update_expression] = STATE(2020),
    [sym_sequence_expression] = STATE(2021),
    [sym_string] = STATE(2020),
    [sym_template_string] = STATE(2020),
    [sym_regex] = STATE(2020),
    [sym_meta_property] = STATE(2020),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4835),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4837),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4837),
    [sym_false] = ACTIONS(4837),
    [sym_null] = ACTIONS(4837),
    [sym_undefined] = ACTIONS(4837),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [1970] = {
    [sym_parenthesized_expression] = STATE(2022),
    [sym__expression] = STATE(2022),
    [sym_yield_expression] = STATE(2022),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2022),
    [sym_jsx_fragment] = STATE(2022),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2022),
    [sym_anonymous_class] = STATE(2022),
    [sym_class] = STATE(2022),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2022),
    [sym_generator_function] = STATE(2022),
    [sym_call_expression] = STATE(2022),
    [sym_new_expression] = STATE(2022),
    [sym_await_expression] = STATE(2022),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2022),
    [sym_augmented_assignment_expression] = STATE(2022),
    [sym_ternary_expression] = STATE(2022),
    [sym_binary_expression] = STATE(2022),
    [sym_unary_expression] = STATE(2022),
    [sym_update_expression] = STATE(2022),
    [sym_string] = STATE(2022),
    [sym_template_string] = STATE(2022),
    [sym_regex] = STATE(2022),
    [sym_meta_property] = STATE(2022),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4839),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4841),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4841),
    [sym_false] = ACTIONS(4841),
    [sym_null] = ACTIONS(4841),
    [sym_undefined] = ACTIONS(4841),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [1971] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4843),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1972] = {
    [anon_sym_RPAREN] = ACTIONS(4843),
    [sym_comment] = ACTIONS(78),
  },
  [1973] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4845),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1974] = {
    [sym_export_statement] = STATE(1500),
    [sym__declaration] = STATE(1500),
    [sym_import_statement] = STATE(1500),
    [sym_expression_statement] = STATE(1500),
    [sym_variable_declaration] = STATE(1500),
    [sym_lexical_declaration] = STATE(1500),
    [sym_statement_block] = STATE(1500),
    [sym_if_statement] = STATE(1500),
    [sym_switch_statement] = STATE(1500),
    [sym_for_statement] = STATE(1500),
    [sym_for_in_statement] = STATE(1500),
    [sym_for_of_statement] = STATE(1500),
    [sym_while_statement] = STATE(1500),
    [sym_do_statement] = STATE(1500),
    [sym_try_statement] = STATE(1500),
    [sym_with_statement] = STATE(1500),
    [sym_break_statement] = STATE(1500),
    [sym_continue_statement] = STATE(1500),
    [sym_debugger_statement] = STATE(1500),
    [sym_return_statement] = STATE(1500),
    [sym_throw_statement] = STATE(1500),
    [sym_empty_statement] = STATE(1500),
    [sym_labeled_statement] = STATE(1500),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1975] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4847),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1976] = {
    [anon_sym_RPAREN] = ACTIONS(4847),
    [sym_comment] = ACTIONS(78),
  },
  [1977] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4849),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1978] = {
    [anon_sym_RPAREN] = ACTIONS(4849),
    [sym_comment] = ACTIONS(78),
  },
  [1979] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4851),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1980] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4853),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [1981] = {
    [anon_sym_RPAREN] = ACTIONS(4853),
    [sym_comment] = ACTIONS(78),
  },
  [1982] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4855),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1983] = {
    [anon_sym_of] = ACTIONS(4857),
    [sym_comment] = ACTIONS(78),
  },
  [1984] = {
    [anon_sym_of] = ACTIONS(4859),
    [sym_comment] = ACTIONS(78),
  },
  [1985] = {
    [anon_sym_of] = ACTIONS(4861),
    [sym_comment] = ACTIONS(78),
  },
  [1986] = {
    [sym_export_statement] = STATE(1809),
    [sym__declaration] = STATE(1809),
    [sym_import_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_variable_declaration] = STATE(1809),
    [sym_lexical_declaration] = STATE(1809),
    [sym_statement_block] = STATE(1809),
    [sym_if_statement] = STATE(1809),
    [sym_switch_statement] = STATE(1809),
    [sym_for_statement] = STATE(1809),
    [sym_for_in_statement] = STATE(1809),
    [sym_for_of_statement] = STATE(1809),
    [sym_while_statement] = STATE(1809),
    [sym_do_statement] = STATE(1809),
    [sym_try_statement] = STATE(1809),
    [sym_with_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_debugger_statement] = STATE(1809),
    [sym_return_statement] = STATE(1809),
    [sym_throw_statement] = STATE(1809),
    [sym_empty_statement] = STATE(1809),
    [sym_labeled_statement] = STATE(1809),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1987] = {
    [sym_export_statement] = STATE(1810),
    [sym__declaration] = STATE(1810),
    [sym_import_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_variable_declaration] = STATE(1810),
    [sym_lexical_declaration] = STATE(1810),
    [sym_statement_block] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_for_in_statement] = STATE(1810),
    [sym_for_of_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_with_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_debugger_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_throw_statement] = STATE(1810),
    [sym_empty_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1988] = {
    [sym_export_statement] = STATE(1811),
    [sym__declaration] = STATE(1811),
    [sym_import_statement] = STATE(1811),
    [sym_expression_statement] = STATE(1811),
    [sym_variable_declaration] = STATE(1811),
    [sym_lexical_declaration] = STATE(1811),
    [sym_statement_block] = STATE(1811),
    [sym_if_statement] = STATE(1811),
    [sym_switch_statement] = STATE(1811),
    [sym_for_statement] = STATE(1811),
    [sym_for_in_statement] = STATE(1811),
    [sym_for_of_statement] = STATE(1811),
    [sym_while_statement] = STATE(1811),
    [sym_do_statement] = STATE(1811),
    [sym_try_statement] = STATE(1811),
    [sym_with_statement] = STATE(1811),
    [sym_break_statement] = STATE(1811),
    [sym_continue_statement] = STATE(1811),
    [sym_debugger_statement] = STATE(1811),
    [sym_return_statement] = STATE(1811),
    [sym_throw_statement] = STATE(1811),
    [sym_empty_statement] = STATE(1811),
    [sym_labeled_statement] = STATE(1811),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1989] = {
    [sym_export_statement] = STATE(1812),
    [sym__declaration] = STATE(1812),
    [sym_import_statement] = STATE(1812),
    [sym_expression_statement] = STATE(1812),
    [sym_variable_declaration] = STATE(1812),
    [sym_lexical_declaration] = STATE(1812),
    [sym_statement_block] = STATE(1812),
    [sym_if_statement] = STATE(1812),
    [sym_switch_statement] = STATE(1812),
    [sym_for_statement] = STATE(1812),
    [sym_for_in_statement] = STATE(1812),
    [sym_for_of_statement] = STATE(1812),
    [sym_while_statement] = STATE(1812),
    [sym_do_statement] = STATE(1812),
    [sym_try_statement] = STATE(1812),
    [sym_with_statement] = STATE(1812),
    [sym_break_statement] = STATE(1812),
    [sym_continue_statement] = STATE(1812),
    [sym_debugger_statement] = STATE(1812),
    [sym_return_statement] = STATE(1812),
    [sym_throw_statement] = STATE(1812),
    [sym_empty_statement] = STATE(1812),
    [sym_labeled_statement] = STATE(1812),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1990] = {
    [sym_export_statement] = STATE(1813),
    [sym__declaration] = STATE(1813),
    [sym_import_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_variable_declaration] = STATE(1813),
    [sym_lexical_declaration] = STATE(1813),
    [sym_statement_block] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_for_in_statement] = STATE(1813),
    [sym_for_of_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_with_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_debugger_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_throw_statement] = STATE(1813),
    [sym_empty_statement] = STATE(1813),
    [sym_labeled_statement] = STATE(1813),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1991] = {
    [sym_export_statement] = STATE(1814),
    [sym__declaration] = STATE(1814),
    [sym_import_statement] = STATE(1814),
    [sym_expression_statement] = STATE(1814),
    [sym_variable_declaration] = STATE(1814),
    [sym_lexical_declaration] = STATE(1814),
    [sym_statement_block] = STATE(1814),
    [sym_if_statement] = STATE(1814),
    [sym_switch_statement] = STATE(1814),
    [sym_for_statement] = STATE(1814),
    [sym_for_in_statement] = STATE(1814),
    [sym_for_of_statement] = STATE(1814),
    [sym_while_statement] = STATE(1814),
    [sym_do_statement] = STATE(1814),
    [sym_try_statement] = STATE(1814),
    [sym_with_statement] = STATE(1814),
    [sym_break_statement] = STATE(1814),
    [sym_continue_statement] = STATE(1814),
    [sym_debugger_statement] = STATE(1814),
    [sym_return_statement] = STATE(1814),
    [sym_throw_statement] = STATE(1814),
    [sym_empty_statement] = STATE(1814),
    [sym_labeled_statement] = STATE(1814),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1992] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4863),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1993] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4865),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1994] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4867),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [1995] = {
    [anon_sym_LBRACE] = ACTIONS(4148),
    [anon_sym_GT] = ACTIONS(4148),
    [anon_sym_SLASH] = ACTIONS(4150),
    [sym_jsx_identifier] = ACTIONS(4148),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4150),
  },
  [1996] = {
    [sym_export_statement] = STATE(1916),
    [sym__declaration] = STATE(1916),
    [sym_import_statement] = STATE(1916),
    [sym_expression_statement] = STATE(1916),
    [sym_variable_declaration] = STATE(1916),
    [sym_lexical_declaration] = STATE(1916),
    [sym_statement_block] = STATE(1916),
    [sym_if_statement] = STATE(1916),
    [sym_switch_statement] = STATE(1916),
    [sym_for_statement] = STATE(1916),
    [sym_for_in_statement] = STATE(1916),
    [sym_for_of_statement] = STATE(1916),
    [sym_while_statement] = STATE(1916),
    [sym_do_statement] = STATE(1916),
    [sym_try_statement] = STATE(1916),
    [sym_with_statement] = STATE(1916),
    [sym_break_statement] = STATE(1916),
    [sym_continue_statement] = STATE(1916),
    [sym_debugger_statement] = STATE(1916),
    [sym_return_statement] = STATE(1916),
    [sym_throw_statement] = STATE(1916),
    [sym_empty_statement] = STATE(1916),
    [sym_labeled_statement] = STATE(1916),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1997] = {
    [sym_export_statement] = STATE(1917),
    [sym__declaration] = STATE(1917),
    [sym_import_statement] = STATE(1917),
    [sym_expression_statement] = STATE(1917),
    [sym_variable_declaration] = STATE(1917),
    [sym_lexical_declaration] = STATE(1917),
    [sym_statement_block] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_switch_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_for_in_statement] = STATE(1917),
    [sym_for_of_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_do_statement] = STATE(1917),
    [sym_try_statement] = STATE(1917),
    [sym_with_statement] = STATE(1917),
    [sym_break_statement] = STATE(1917),
    [sym_continue_statement] = STATE(1917),
    [sym_debugger_statement] = STATE(1917),
    [sym_return_statement] = STATE(1917),
    [sym_throw_statement] = STATE(1917),
    [sym_empty_statement] = STATE(1917),
    [sym_labeled_statement] = STATE(1917),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1998] = {
    [sym_export_statement] = STATE(1918),
    [sym__declaration] = STATE(1918),
    [sym_import_statement] = STATE(1918),
    [sym_expression_statement] = STATE(1918),
    [sym_variable_declaration] = STATE(1918),
    [sym_lexical_declaration] = STATE(1918),
    [sym_statement_block] = STATE(1918),
    [sym_if_statement] = STATE(1918),
    [sym_switch_statement] = STATE(1918),
    [sym_for_statement] = STATE(1918),
    [sym_for_in_statement] = STATE(1918),
    [sym_for_of_statement] = STATE(1918),
    [sym_while_statement] = STATE(1918),
    [sym_do_statement] = STATE(1918),
    [sym_try_statement] = STATE(1918),
    [sym_with_statement] = STATE(1918),
    [sym_break_statement] = STATE(1918),
    [sym_continue_statement] = STATE(1918),
    [sym_debugger_statement] = STATE(1918),
    [sym_return_statement] = STATE(1918),
    [sym_throw_statement] = STATE(1918),
    [sym_empty_statement] = STATE(1918),
    [sym_labeled_statement] = STATE(1918),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1529),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1531),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [1999] = {
    [sym_export_statement] = STATE(1161),
    [sym__declaration] = STATE(1161),
    [sym_import_statement] = STATE(1161),
    [sym_expression_statement] = STATE(1161),
    [sym_variable_declaration] = STATE(1161),
    [sym_lexical_declaration] = STATE(1161),
    [sym_statement_block] = STATE(1161),
    [sym_if_statement] = STATE(1161),
    [sym_switch_statement] = STATE(1161),
    [sym_for_statement] = STATE(1161),
    [sym_for_in_statement] = STATE(1161),
    [sym_for_of_statement] = STATE(1161),
    [sym_while_statement] = STATE(1161),
    [sym_do_statement] = STATE(1161),
    [sym_try_statement] = STATE(1161),
    [sym_with_statement] = STATE(1161),
    [sym_break_statement] = STATE(1161),
    [sym_continue_statement] = STATE(1161),
    [sym_debugger_statement] = STATE(1161),
    [sym_return_statement] = STATE(1161),
    [sym_throw_statement] = STATE(1161),
    [sym_empty_statement] = STATE(1161),
    [sym_labeled_statement] = STATE(1161),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2000] = {
    [sym__initializer] = STATE(363),
    [sym__automatic_semicolon] = ACTIONS(635),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(4869),
    [anon_sym_of] = ACTIONS(4871),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [2001] = {
    [sym__initializer] = STATE(367),
    [sym__automatic_semicolon] = ACTIONS(643),
    [anon_sym_COMMA] = ACTIONS(643),
    [anon_sym_in] = ACTIONS(4873),
    [anon_sym_of] = ACTIONS(4875),
    [anon_sym_SEMI] = ACTIONS(643),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [2002] = {
    [sym__initializer] = STATE(368),
    [sym__automatic_semicolon] = ACTIONS(645),
    [anon_sym_COMMA] = ACTIONS(645),
    [anon_sym_in] = ACTIONS(4877),
    [anon_sym_of] = ACTIONS(4879),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(637),
    [sym_comment] = ACTIONS(78),
  },
  [2003] = {
    [sym_parenthesized_expression] = STATE(2042),
    [sym__expression] = STATE(2042),
    [sym_yield_expression] = STATE(2042),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(2042),
    [sym_jsx_fragment] = STATE(2042),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(2042),
    [sym_anonymous_class] = STATE(2042),
    [sym_class] = STATE(2042),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(2042),
    [sym_generator_function] = STATE(2042),
    [sym_call_expression] = STATE(2042),
    [sym_new_expression] = STATE(2042),
    [sym_await_expression] = STATE(2042),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(2042),
    [sym_augmented_assignment_expression] = STATE(2042),
    [sym_ternary_expression] = STATE(2042),
    [sym_binary_expression] = STATE(2042),
    [sym_unary_expression] = STATE(2042),
    [sym_update_expression] = STATE(2042),
    [sym_sequence_expression] = STATE(2043),
    [sym_string] = STATE(2042),
    [sym_template_string] = STATE(2042),
    [sym_regex] = STATE(2042),
    [sym_meta_property] = STATE(2042),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4881),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4883),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4883),
    [sym_false] = ACTIONS(4883),
    [sym_null] = ACTIONS(4883),
    [sym_undefined] = ACTIONS(4883),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [2004] = {
    [sym_parenthesized_expression] = STATE(2044),
    [sym__expression] = STATE(2044),
    [sym_yield_expression] = STATE(2044),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2044),
    [sym_jsx_fragment] = STATE(2044),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2044),
    [sym_anonymous_class] = STATE(2044),
    [sym_class] = STATE(2044),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2044),
    [sym_generator_function] = STATE(2044),
    [sym_call_expression] = STATE(2044),
    [sym_new_expression] = STATE(2044),
    [sym_await_expression] = STATE(2044),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2044),
    [sym_augmented_assignment_expression] = STATE(2044),
    [sym_ternary_expression] = STATE(2044),
    [sym_binary_expression] = STATE(2044),
    [sym_unary_expression] = STATE(2044),
    [sym_update_expression] = STATE(2044),
    [sym_string] = STATE(2044),
    [sym_template_string] = STATE(2044),
    [sym_regex] = STATE(2044),
    [sym_meta_property] = STATE(2044),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4885),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4887),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4887),
    [sym_false] = ACTIONS(4887),
    [sym_null] = ACTIONS(4887),
    [sym_undefined] = ACTIONS(4887),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2005] = {
    [sym_parenthesized_expression] = STATE(2046),
    [sym__expression] = STATE(2046),
    [sym_yield_expression] = STATE(2046),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(2046),
    [sym_jsx_fragment] = STATE(2046),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2046),
    [sym_anonymous_class] = STATE(2046),
    [sym_class] = STATE(2046),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2046),
    [sym_generator_function] = STATE(2046),
    [sym_call_expression] = STATE(2046),
    [sym_new_expression] = STATE(2046),
    [sym_await_expression] = STATE(2046),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(2046),
    [sym_augmented_assignment_expression] = STATE(2046),
    [sym_ternary_expression] = STATE(2046),
    [sym_binary_expression] = STATE(2046),
    [sym_unary_expression] = STATE(2046),
    [sym_update_expression] = STATE(2046),
    [sym_sequence_expression] = STATE(2047),
    [sym_string] = STATE(2046),
    [sym_template_string] = STATE(2046),
    [sym_regex] = STATE(2046),
    [sym_meta_property] = STATE(2046),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_RPAREN] = ACTIONS(4889),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4891),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4893),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4893),
    [sym_false] = ACTIONS(4893),
    [sym_null] = ACTIONS(4893),
    [sym_undefined] = ACTIONS(4893),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [2006] = {
    [sym_parenthesized_expression] = STATE(2048),
    [sym__expression] = STATE(2048),
    [sym_yield_expression] = STATE(2048),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(2048),
    [sym_jsx_fragment] = STATE(2048),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(2048),
    [sym_anonymous_class] = STATE(2048),
    [sym_class] = STATE(2048),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(2048),
    [sym_generator_function] = STATE(2048),
    [sym_call_expression] = STATE(2048),
    [sym_new_expression] = STATE(2048),
    [sym_await_expression] = STATE(2048),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(2048),
    [sym_augmented_assignment_expression] = STATE(2048),
    [sym_ternary_expression] = STATE(2048),
    [sym_binary_expression] = STATE(2048),
    [sym_unary_expression] = STATE(2048),
    [sym_update_expression] = STATE(2048),
    [sym_sequence_expression] = STATE(2049),
    [sym_string] = STATE(2048),
    [sym_template_string] = STATE(2048),
    [sym_regex] = STATE(2048),
    [sym_meta_property] = STATE(2048),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4895),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4897),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4897),
    [sym_false] = ACTIONS(4897),
    [sym_null] = ACTIONS(4897),
    [sym_undefined] = ACTIONS(4897),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [2007] = {
    [sym_parenthesized_expression] = STATE(2050),
    [sym__expression] = STATE(2050),
    [sym_yield_expression] = STATE(2050),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2050),
    [sym_jsx_fragment] = STATE(2050),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2050),
    [sym_anonymous_class] = STATE(2050),
    [sym_class] = STATE(2050),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2050),
    [sym_generator_function] = STATE(2050),
    [sym_call_expression] = STATE(2050),
    [sym_new_expression] = STATE(2050),
    [sym_await_expression] = STATE(2050),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2050),
    [sym_augmented_assignment_expression] = STATE(2050),
    [sym_ternary_expression] = STATE(2050),
    [sym_binary_expression] = STATE(2050),
    [sym_unary_expression] = STATE(2050),
    [sym_update_expression] = STATE(2050),
    [sym_string] = STATE(2050),
    [sym_template_string] = STATE(2050),
    [sym_regex] = STATE(2050),
    [sym_meta_property] = STATE(2050),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4899),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4901),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4901),
    [sym_false] = ACTIONS(4901),
    [sym_null] = ACTIONS(4901),
    [sym_undefined] = ACTIONS(4901),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2008] = {
    [sym_parenthesized_expression] = STATE(2051),
    [sym__expression] = STATE(2051),
    [sym_yield_expression] = STATE(2051),
    [sym_object] = STATE(1196),
    [sym_array] = STATE(1197),
    [sym_jsx_element] = STATE(2051),
    [sym_jsx_fragment] = STATE(2051),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(2051),
    [sym_anonymous_class] = STATE(2051),
    [sym_class] = STATE(2051),
    [sym_function] = STATE(137),
    [sym_arrow_function] = STATE(2051),
    [sym_generator_function] = STATE(2051),
    [sym_call_expression] = STATE(2051),
    [sym_new_expression] = STATE(2051),
    [sym_await_expression] = STATE(2051),
    [sym_member_expression] = STATE(1198),
    [sym_subscript_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(2051),
    [sym_augmented_assignment_expression] = STATE(2051),
    [sym_ternary_expression] = STATE(2051),
    [sym_binary_expression] = STATE(2051),
    [sym_unary_expression] = STATE(2051),
    [sym_update_expression] = STATE(2051),
    [sym_sequence_expression] = STATE(2052),
    [sym_string] = STATE(2051),
    [sym_template_string] = STATE(2051),
    [sym_regex] = STATE(2051),
    [sym_meta_property] = STATE(2051),
    [sym_decorator] = STATE(138),
    [sym_formal_parameters] = STATE(1200),
    [aux_sym_export_statement_repeat1] = STATE(138),
    [anon_sym_LBRACE] = ACTIONS(206),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(2696),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(2700),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2710),
    [anon_sym_DASH_DASH] = ACTIONS(2710),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(4903),
    [sym_identifier] = ACTIONS(2714),
    [sym_this] = ACTIONS(4905),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(4905),
    [sym_false] = ACTIONS(4905),
    [sym_null] = ACTIONS(4905),
    [sym_undefined] = ACTIONS(4905),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
  },
  [2009] = {
    [sym_parenthesized_expression] = STATE(2053),
    [sym__expression] = STATE(2053),
    [sym_yield_expression] = STATE(2053),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2053),
    [sym_jsx_fragment] = STATE(2053),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2053),
    [sym_anonymous_class] = STATE(2053),
    [sym_class] = STATE(2053),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2053),
    [sym_generator_function] = STATE(2053),
    [sym_call_expression] = STATE(2053),
    [sym_new_expression] = STATE(2053),
    [sym_await_expression] = STATE(2053),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2053),
    [sym_augmented_assignment_expression] = STATE(2053),
    [sym_ternary_expression] = STATE(2053),
    [sym_binary_expression] = STATE(2053),
    [sym_unary_expression] = STATE(2053),
    [sym_update_expression] = STATE(2053),
    [sym_string] = STATE(2053),
    [sym_template_string] = STATE(2053),
    [sym_regex] = STATE(2053),
    [sym_meta_property] = STATE(2053),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4907),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4909),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4909),
    [sym_false] = ACTIONS(4909),
    [sym_null] = ACTIONS(4909),
    [sym_undefined] = ACTIONS(4909),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2010] = {
    [sym_object] = STATE(2055),
    [sym_array] = STATE(2056),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(166),
    [sym_comment] = ACTIONS(78),
    [sym_identifier] = ACTIONS(4911),
  },
  [2011] = {
    [anon_sym_of] = ACTIONS(4871),
    [sym_comment] = ACTIONS(78),
  },
  [2012] = {
    [anon_sym_of] = ACTIONS(4875),
    [sym_comment] = ACTIONS(78),
  },
  [2013] = {
    [anon_sym_of] = ACTIONS(4879),
    [sym_comment] = ACTIONS(78),
  },
  [2014] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4913),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2015] = {
    [anon_sym_RPAREN] = ACTIONS(4913),
    [sym_comment] = ACTIONS(78),
  },
  [2016] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4915),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2017] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4917),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2018] = {
    [anon_sym_RPAREN] = ACTIONS(4917),
    [sym_comment] = ACTIONS(78),
  },
  [2019] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4919),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2020] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4921),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2021] = {
    [anon_sym_RPAREN] = ACTIONS(4921),
    [sym_comment] = ACTIONS(78),
  },
  [2022] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4923),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2023] = {
    [sym_export_statement] = STATE(1672),
    [sym__declaration] = STATE(1672),
    [sym_import_statement] = STATE(1672),
    [sym_expression_statement] = STATE(1672),
    [sym_variable_declaration] = STATE(1672),
    [sym_lexical_declaration] = STATE(1672),
    [sym_statement_block] = STATE(1672),
    [sym_if_statement] = STATE(1672),
    [sym_switch_statement] = STATE(1672),
    [sym_for_statement] = STATE(1672),
    [sym_for_in_statement] = STATE(1672),
    [sym_for_of_statement] = STATE(1672),
    [sym_while_statement] = STATE(1672),
    [sym_do_statement] = STATE(1672),
    [sym_try_statement] = STATE(1672),
    [sym_with_statement] = STATE(1672),
    [sym_break_statement] = STATE(1672),
    [sym_continue_statement] = STATE(1672),
    [sym_debugger_statement] = STATE(1672),
    [sym_return_statement] = STATE(1672),
    [sym_throw_statement] = STATE(1672),
    [sym_empty_statement] = STATE(1672),
    [sym_labeled_statement] = STATE(1672),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2024] = {
    [sym_export_statement] = STATE(1683),
    [sym__declaration] = STATE(1683),
    [sym_import_statement] = STATE(1683),
    [sym_expression_statement] = STATE(1683),
    [sym_variable_declaration] = STATE(1683),
    [sym_lexical_declaration] = STATE(1683),
    [sym_statement_block] = STATE(1683),
    [sym_if_statement] = STATE(1683),
    [sym_switch_statement] = STATE(1683),
    [sym_for_statement] = STATE(1683),
    [sym_for_in_statement] = STATE(1683),
    [sym_for_of_statement] = STATE(1683),
    [sym_while_statement] = STATE(1683),
    [sym_do_statement] = STATE(1683),
    [sym_try_statement] = STATE(1683),
    [sym_with_statement] = STATE(1683),
    [sym_break_statement] = STATE(1683),
    [sym_continue_statement] = STATE(1683),
    [sym_debugger_statement] = STATE(1683),
    [sym_return_statement] = STATE(1683),
    [sym_throw_statement] = STATE(1683),
    [sym_empty_statement] = STATE(1683),
    [sym_labeled_statement] = STATE(1683),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2025] = {
    [sym_export_statement] = STATE(1688),
    [sym__declaration] = STATE(1688),
    [sym_import_statement] = STATE(1688),
    [sym_expression_statement] = STATE(1688),
    [sym_variable_declaration] = STATE(1688),
    [sym_lexical_declaration] = STATE(1688),
    [sym_statement_block] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_switch_statement] = STATE(1688),
    [sym_for_statement] = STATE(1688),
    [sym_for_in_statement] = STATE(1688),
    [sym_for_of_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_do_statement] = STATE(1688),
    [sym_try_statement] = STATE(1688),
    [sym_with_statement] = STATE(1688),
    [sym_break_statement] = STATE(1688),
    [sym_continue_statement] = STATE(1688),
    [sym_debugger_statement] = STATE(1688),
    [sym_return_statement] = STATE(1688),
    [sym_throw_statement] = STATE(1688),
    [sym_empty_statement] = STATE(1688),
    [sym_labeled_statement] = STATE(1688),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2026] = {
    [sym_export_statement] = STATE(1689),
    [sym__declaration] = STATE(1689),
    [sym_import_statement] = STATE(1689),
    [sym_expression_statement] = STATE(1689),
    [sym_variable_declaration] = STATE(1689),
    [sym_lexical_declaration] = STATE(1689),
    [sym_statement_block] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_switch_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_for_in_statement] = STATE(1689),
    [sym_for_of_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_do_statement] = STATE(1689),
    [sym_try_statement] = STATE(1689),
    [sym_with_statement] = STATE(1689),
    [sym_break_statement] = STATE(1689),
    [sym_continue_statement] = STATE(1689),
    [sym_debugger_statement] = STATE(1689),
    [sym_return_statement] = STATE(1689),
    [sym_throw_statement] = STATE(1689),
    [sym_empty_statement] = STATE(1689),
    [sym_labeled_statement] = STATE(1689),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2027] = {
    [sym_export_statement] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym_import_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_lexical_declaration] = STATE(1690),
    [sym_statement_block] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_for_in_statement] = STATE(1690),
    [sym_for_of_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_try_statement] = STATE(1690),
    [sym_with_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_debugger_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_throw_statement] = STATE(1690),
    [sym_empty_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2028] = {
    [sym_export_statement] = STATE(1691),
    [sym__declaration] = STATE(1691),
    [sym_import_statement] = STATE(1691),
    [sym_expression_statement] = STATE(1691),
    [sym_variable_declaration] = STATE(1691),
    [sym_lexical_declaration] = STATE(1691),
    [sym_statement_block] = STATE(1691),
    [sym_if_statement] = STATE(1691),
    [sym_switch_statement] = STATE(1691),
    [sym_for_statement] = STATE(1691),
    [sym_for_in_statement] = STATE(1691),
    [sym_for_of_statement] = STATE(1691),
    [sym_while_statement] = STATE(1691),
    [sym_do_statement] = STATE(1691),
    [sym_try_statement] = STATE(1691),
    [sym_with_statement] = STATE(1691),
    [sym_break_statement] = STATE(1691),
    [sym_continue_statement] = STATE(1691),
    [sym_debugger_statement] = STATE(1691),
    [sym_return_statement] = STATE(1691),
    [sym_throw_statement] = STATE(1691),
    [sym_empty_statement] = STATE(1691),
    [sym_labeled_statement] = STATE(1691),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2029] = {
    [sym_export_statement] = STATE(1692),
    [sym__declaration] = STATE(1692),
    [sym_import_statement] = STATE(1692),
    [sym_expression_statement] = STATE(1692),
    [sym_variable_declaration] = STATE(1692),
    [sym_lexical_declaration] = STATE(1692),
    [sym_statement_block] = STATE(1692),
    [sym_if_statement] = STATE(1692),
    [sym_switch_statement] = STATE(1692),
    [sym_for_statement] = STATE(1692),
    [sym_for_in_statement] = STATE(1692),
    [sym_for_of_statement] = STATE(1692),
    [sym_while_statement] = STATE(1692),
    [sym_do_statement] = STATE(1692),
    [sym_try_statement] = STATE(1692),
    [sym_with_statement] = STATE(1692),
    [sym_break_statement] = STATE(1692),
    [sym_continue_statement] = STATE(1692),
    [sym_debugger_statement] = STATE(1692),
    [sym_return_statement] = STATE(1692),
    [sym_throw_statement] = STATE(1692),
    [sym_empty_statement] = STATE(1692),
    [sym_labeled_statement] = STATE(1692),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2030] = {
    [sym_parenthesized_expression] = STATE(2063),
    [sym__expression] = STATE(2063),
    [sym_yield_expression] = STATE(2063),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2063),
    [sym_jsx_fragment] = STATE(2063),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2063),
    [sym_anonymous_class] = STATE(2063),
    [sym_class] = STATE(2063),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2063),
    [sym_generator_function] = STATE(2063),
    [sym_call_expression] = STATE(2063),
    [sym_new_expression] = STATE(2063),
    [sym_await_expression] = STATE(2063),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2063),
    [sym_augmented_assignment_expression] = STATE(2063),
    [sym_ternary_expression] = STATE(2063),
    [sym_binary_expression] = STATE(2063),
    [sym_unary_expression] = STATE(2063),
    [sym_update_expression] = STATE(2063),
    [sym_string] = STATE(2063),
    [sym_template_string] = STATE(2063),
    [sym_regex] = STATE(2063),
    [sym_meta_property] = STATE(2063),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4925),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4927),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4927),
    [sym_false] = ACTIONS(4927),
    [sym_null] = ACTIONS(4927),
    [sym_undefined] = ACTIONS(4927),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2031] = {
    [sym_parenthesized_expression] = STATE(2064),
    [sym__expression] = STATE(2064),
    [sym_yield_expression] = STATE(2064),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2064),
    [sym_jsx_fragment] = STATE(2064),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2064),
    [sym_anonymous_class] = STATE(2064),
    [sym_class] = STATE(2064),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2064),
    [sym_generator_function] = STATE(2064),
    [sym_call_expression] = STATE(2064),
    [sym_new_expression] = STATE(2064),
    [sym_await_expression] = STATE(2064),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2064),
    [sym_augmented_assignment_expression] = STATE(2064),
    [sym_ternary_expression] = STATE(2064),
    [sym_binary_expression] = STATE(2064),
    [sym_unary_expression] = STATE(2064),
    [sym_update_expression] = STATE(2064),
    [sym_string] = STATE(2064),
    [sym_template_string] = STATE(2064),
    [sym_regex] = STATE(2064),
    [sym_meta_property] = STATE(2064),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4929),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4931),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4931),
    [sym_false] = ACTIONS(4931),
    [sym_null] = ACTIONS(4931),
    [sym_undefined] = ACTIONS(4931),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2032] = {
    [sym_parenthesized_expression] = STATE(2065),
    [sym__expression] = STATE(2065),
    [sym_yield_expression] = STATE(2065),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2065),
    [sym_jsx_fragment] = STATE(2065),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2065),
    [sym_anonymous_class] = STATE(2065),
    [sym_class] = STATE(2065),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2065),
    [sym_generator_function] = STATE(2065),
    [sym_call_expression] = STATE(2065),
    [sym_new_expression] = STATE(2065),
    [sym_await_expression] = STATE(2065),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2065),
    [sym_augmented_assignment_expression] = STATE(2065),
    [sym_ternary_expression] = STATE(2065),
    [sym_binary_expression] = STATE(2065),
    [sym_unary_expression] = STATE(2065),
    [sym_update_expression] = STATE(2065),
    [sym_string] = STATE(2065),
    [sym_template_string] = STATE(2065),
    [sym_regex] = STATE(2065),
    [sym_meta_property] = STATE(2065),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4933),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4935),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4935),
    [sym_false] = ACTIONS(4935),
    [sym_null] = ACTIONS(4935),
    [sym_undefined] = ACTIONS(4935),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2033] = {
    [sym_export_statement] = STATE(1916),
    [sym__declaration] = STATE(1916),
    [sym_import_statement] = STATE(1916),
    [sym_expression_statement] = STATE(1916),
    [sym_variable_declaration] = STATE(1916),
    [sym_lexical_declaration] = STATE(1916),
    [sym_statement_block] = STATE(1916),
    [sym_if_statement] = STATE(1916),
    [sym_switch_statement] = STATE(1916),
    [sym_for_statement] = STATE(1916),
    [sym_for_in_statement] = STATE(1916),
    [sym_for_of_statement] = STATE(1916),
    [sym_while_statement] = STATE(1916),
    [sym_do_statement] = STATE(1916),
    [sym_try_statement] = STATE(1916),
    [sym_with_statement] = STATE(1916),
    [sym_break_statement] = STATE(1916),
    [sym_continue_statement] = STATE(1916),
    [sym_debugger_statement] = STATE(1916),
    [sym_return_statement] = STATE(1916),
    [sym_throw_statement] = STATE(1916),
    [sym_empty_statement] = STATE(1916),
    [sym_labeled_statement] = STATE(1916),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2034] = {
    [sym_export_statement] = STATE(1917),
    [sym__declaration] = STATE(1917),
    [sym_import_statement] = STATE(1917),
    [sym_expression_statement] = STATE(1917),
    [sym_variable_declaration] = STATE(1917),
    [sym_lexical_declaration] = STATE(1917),
    [sym_statement_block] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_switch_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_for_in_statement] = STATE(1917),
    [sym_for_of_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_do_statement] = STATE(1917),
    [sym_try_statement] = STATE(1917),
    [sym_with_statement] = STATE(1917),
    [sym_break_statement] = STATE(1917),
    [sym_continue_statement] = STATE(1917),
    [sym_debugger_statement] = STATE(1917),
    [sym_return_statement] = STATE(1917),
    [sym_throw_statement] = STATE(1917),
    [sym_empty_statement] = STATE(1917),
    [sym_labeled_statement] = STATE(1917),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2035] = {
    [sym_export_statement] = STATE(1918),
    [sym__declaration] = STATE(1918),
    [sym_import_statement] = STATE(1918),
    [sym_expression_statement] = STATE(1918),
    [sym_variable_declaration] = STATE(1918),
    [sym_lexical_declaration] = STATE(1918),
    [sym_statement_block] = STATE(1918),
    [sym_if_statement] = STATE(1918),
    [sym_switch_statement] = STATE(1918),
    [sym_for_statement] = STATE(1918),
    [sym_for_in_statement] = STATE(1918),
    [sym_for_of_statement] = STATE(1918),
    [sym_while_statement] = STATE(1918),
    [sym_do_statement] = STATE(1918),
    [sym_try_statement] = STATE(1918),
    [sym_with_statement] = STATE(1918),
    [sym_break_statement] = STATE(1918),
    [sym_continue_statement] = STATE(1918),
    [sym_debugger_statement] = STATE(1918),
    [sym_return_statement] = STATE(1918),
    [sym_throw_statement] = STATE(1918),
    [sym_empty_statement] = STATE(1918),
    [sym_labeled_statement] = STATE(1918),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(147),
    [sym_function] = STATE(148),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(147),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(149),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(149),
    [anon_sym_export] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(1892),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(1894),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(1896),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(1898),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(1900),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2036] = {
    [sym_parenthesized_expression] = STATE(2066),
    [sym__expression] = STATE(2066),
    [sym_yield_expression] = STATE(2066),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(2066),
    [sym_jsx_fragment] = STATE(2066),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2066),
    [sym_anonymous_class] = STATE(2066),
    [sym_class] = STATE(2066),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2066),
    [sym_generator_function] = STATE(2066),
    [sym_call_expression] = STATE(2066),
    [sym_new_expression] = STATE(2066),
    [sym_await_expression] = STATE(2066),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(2066),
    [sym_augmented_assignment_expression] = STATE(2066),
    [sym_ternary_expression] = STATE(2066),
    [sym_binary_expression] = STATE(2066),
    [sym_unary_expression] = STATE(2066),
    [sym_update_expression] = STATE(2066),
    [sym_sequence_expression] = STATE(2067),
    [sym_string] = STATE(2066),
    [sym_template_string] = STATE(2066),
    [sym_regex] = STATE(2066),
    [sym_meta_property] = STATE(2066),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4937),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4939),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4939),
    [sym_false] = ACTIONS(4939),
    [sym_null] = ACTIONS(4939),
    [sym_undefined] = ACTIONS(4939),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [2037] = {
    [sym_parenthesized_expression] = STATE(2068),
    [sym__expression] = STATE(2068),
    [sym_yield_expression] = STATE(2068),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2068),
    [sym_jsx_fragment] = STATE(2068),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2068),
    [sym_anonymous_class] = STATE(2068),
    [sym_class] = STATE(2068),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2068),
    [sym_generator_function] = STATE(2068),
    [sym_call_expression] = STATE(2068),
    [sym_new_expression] = STATE(2068),
    [sym_await_expression] = STATE(2068),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2068),
    [sym_augmented_assignment_expression] = STATE(2068),
    [sym_ternary_expression] = STATE(2068),
    [sym_binary_expression] = STATE(2068),
    [sym_unary_expression] = STATE(2068),
    [sym_update_expression] = STATE(2068),
    [sym_string] = STATE(2068),
    [sym_template_string] = STATE(2068),
    [sym_regex] = STATE(2068),
    [sym_meta_property] = STATE(2068),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4941),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4943),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4943),
    [sym_false] = ACTIONS(4943),
    [sym_null] = ACTIONS(4943),
    [sym_undefined] = ACTIONS(4943),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2038] = {
    [sym_parenthesized_expression] = STATE(2069),
    [sym__expression] = STATE(2069),
    [sym_yield_expression] = STATE(2069),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(2069),
    [sym_jsx_fragment] = STATE(2069),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2069),
    [sym_anonymous_class] = STATE(2069),
    [sym_class] = STATE(2069),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2069),
    [sym_generator_function] = STATE(2069),
    [sym_call_expression] = STATE(2069),
    [sym_new_expression] = STATE(2069),
    [sym_await_expression] = STATE(2069),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(2069),
    [sym_augmented_assignment_expression] = STATE(2069),
    [sym_ternary_expression] = STATE(2069),
    [sym_binary_expression] = STATE(2069),
    [sym_unary_expression] = STATE(2069),
    [sym_update_expression] = STATE(2069),
    [sym_sequence_expression] = STATE(2070),
    [sym_string] = STATE(2069),
    [sym_template_string] = STATE(2069),
    [sym_regex] = STATE(2069),
    [sym_meta_property] = STATE(2069),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4945),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4947),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4947),
    [sym_false] = ACTIONS(4947),
    [sym_null] = ACTIONS(4947),
    [sym_undefined] = ACTIONS(4947),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [2039] = {
    [sym_parenthesized_expression] = STATE(2071),
    [sym__expression] = STATE(2071),
    [sym_yield_expression] = STATE(2071),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2071),
    [sym_jsx_fragment] = STATE(2071),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2071),
    [sym_anonymous_class] = STATE(2071),
    [sym_class] = STATE(2071),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2071),
    [sym_generator_function] = STATE(2071),
    [sym_call_expression] = STATE(2071),
    [sym_new_expression] = STATE(2071),
    [sym_await_expression] = STATE(2071),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2071),
    [sym_augmented_assignment_expression] = STATE(2071),
    [sym_ternary_expression] = STATE(2071),
    [sym_binary_expression] = STATE(2071),
    [sym_unary_expression] = STATE(2071),
    [sym_update_expression] = STATE(2071),
    [sym_string] = STATE(2071),
    [sym_template_string] = STATE(2071),
    [sym_regex] = STATE(2071),
    [sym_meta_property] = STATE(2071),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4949),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4951),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4951),
    [sym_false] = ACTIONS(4951),
    [sym_null] = ACTIONS(4951),
    [sym_undefined] = ACTIONS(4951),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2040] = {
    [sym_parenthesized_expression] = STATE(2072),
    [sym__expression] = STATE(2072),
    [sym_yield_expression] = STATE(2072),
    [sym_object] = STATE(375),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(2072),
    [sym_jsx_fragment] = STATE(2072),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2072),
    [sym_anonymous_class] = STATE(2072),
    [sym_class] = STATE(2072),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2072),
    [sym_generator_function] = STATE(2072),
    [sym_call_expression] = STATE(2072),
    [sym_new_expression] = STATE(2072),
    [sym_await_expression] = STATE(2072),
    [sym_member_expression] = STATE(130),
    [sym_subscript_expression] = STATE(130),
    [sym_assignment_expression] = STATE(2072),
    [sym_augmented_assignment_expression] = STATE(2072),
    [sym_ternary_expression] = STATE(2072),
    [sym_binary_expression] = STATE(2072),
    [sym_unary_expression] = STATE(2072),
    [sym_update_expression] = STATE(2072),
    [sym_sequence_expression] = STATE(2073),
    [sym_string] = STATE(2072),
    [sym_template_string] = STATE(2072),
    [sym_regex] = STATE(2072),
    [sym_meta_property] = STATE(2072),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(132),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(162),
    [anon_sym_yield] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(649),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(178),
    [anon_sym_new] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_DASH] = ACTIONS(184),
    [anon_sym_BANG] = ACTIONS(186),
    [anon_sym_TILDE] = ACTIONS(186),
    [anon_sym_typeof] = ACTIONS(184),
    [anon_sym_void] = ACTIONS(184),
    [anon_sym_delete] = ACTIONS(184),
    [anon_sym_PLUS_PLUS] = ACTIONS(188),
    [anon_sym_DASH_DASH] = ACTIONS(188),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4953),
    [sym_identifier] = ACTIONS(653),
    [sym_this] = ACTIONS(4955),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4955),
    [sym_false] = ACTIONS(4955),
    [sym_null] = ACTIONS(4955),
    [sym_undefined] = ACTIONS(4955),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(657),
    [anon_sym_set] = ACTIONS(657),
  },
  [2041] = {
    [sym_parenthesized_expression] = STATE(2074),
    [sym__expression] = STATE(2074),
    [sym_yield_expression] = STATE(2074),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2074),
    [sym_jsx_fragment] = STATE(2074),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2074),
    [sym_anonymous_class] = STATE(2074),
    [sym_class] = STATE(2074),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2074),
    [sym_generator_function] = STATE(2074),
    [sym_call_expression] = STATE(2074),
    [sym_new_expression] = STATE(2074),
    [sym_await_expression] = STATE(2074),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2074),
    [sym_augmented_assignment_expression] = STATE(2074),
    [sym_ternary_expression] = STATE(2074),
    [sym_binary_expression] = STATE(2074),
    [sym_unary_expression] = STATE(2074),
    [sym_update_expression] = STATE(2074),
    [sym_string] = STATE(2074),
    [sym_template_string] = STATE(2074),
    [sym_regex] = STATE(2074),
    [sym_meta_property] = STATE(2074),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4957),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(4959),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(4959),
    [sym_false] = ACTIONS(4959),
    [sym_null] = ACTIONS(4959),
    [sym_undefined] = ACTIONS(4959),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2042] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [2043] = {
    [anon_sym_RPAREN] = ACTIONS(4961),
    [sym_comment] = ACTIONS(78),
  },
  [2044] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4963),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2045] = {
    [sym_export_statement] = STATE(1500),
    [sym__declaration] = STATE(1500),
    [sym_import_statement] = STATE(1500),
    [sym_expression_statement] = STATE(1500),
    [sym_variable_declaration] = STATE(1500),
    [sym_lexical_declaration] = STATE(1500),
    [sym_statement_block] = STATE(1500),
    [sym_if_statement] = STATE(1500),
    [sym_switch_statement] = STATE(1500),
    [sym_for_statement] = STATE(1500),
    [sym_for_in_statement] = STATE(1500),
    [sym_for_of_statement] = STATE(1500),
    [sym_while_statement] = STATE(1500),
    [sym_do_statement] = STATE(1500),
    [sym_try_statement] = STATE(1500),
    [sym_with_statement] = STATE(1500),
    [sym_break_statement] = STATE(1500),
    [sym_continue_statement] = STATE(1500),
    [sym_debugger_statement] = STATE(1500),
    [sym_return_statement] = STATE(1500),
    [sym_throw_statement] = STATE(1500),
    [sym_empty_statement] = STATE(1500),
    [sym_labeled_statement] = STATE(1500),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2046] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4965),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2047] = {
    [anon_sym_RPAREN] = ACTIONS(4965),
    [sym_comment] = ACTIONS(78),
  },
  [2048] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4967),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [2049] = {
    [anon_sym_RPAREN] = ACTIONS(4967),
    [sym_comment] = ACTIONS(78),
  },
  [2050] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4969),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2051] = {
    [sym_template_string] = STATE(238),
    [sym_arguments] = STATE(238),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_STAR] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RPAREN] = ACTIONS(4971),
    [anon_sym_in] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(3501),
    [anon_sym_DOT] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(3501),
    [anon_sym_GT_GT_GT] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_PERCENT] = ACTIONS(3497),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
  },
  [2052] = {
    [anon_sym_RPAREN] = ACTIONS(4971),
    [sym_comment] = ACTIONS(78),
  },
  [2053] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4973),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2054] = {
    [anon_sym_of] = ACTIONS(4975),
    [sym_comment] = ACTIONS(78),
  },
  [2055] = {
    [anon_sym_of] = ACTIONS(4977),
    [sym_comment] = ACTIONS(78),
  },
  [2056] = {
    [anon_sym_of] = ACTIONS(4979),
    [sym_comment] = ACTIONS(78),
  },
  [2057] = {
    [sym_export_statement] = STATE(1809),
    [sym__declaration] = STATE(1809),
    [sym_import_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_variable_declaration] = STATE(1809),
    [sym_lexical_declaration] = STATE(1809),
    [sym_statement_block] = STATE(1809),
    [sym_if_statement] = STATE(1809),
    [sym_switch_statement] = STATE(1809),
    [sym_for_statement] = STATE(1809),
    [sym_for_in_statement] = STATE(1809),
    [sym_for_of_statement] = STATE(1809),
    [sym_while_statement] = STATE(1809),
    [sym_do_statement] = STATE(1809),
    [sym_try_statement] = STATE(1809),
    [sym_with_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_debugger_statement] = STATE(1809),
    [sym_return_statement] = STATE(1809),
    [sym_throw_statement] = STATE(1809),
    [sym_empty_statement] = STATE(1809),
    [sym_labeled_statement] = STATE(1809),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2058] = {
    [sym_export_statement] = STATE(1810),
    [sym__declaration] = STATE(1810),
    [sym_import_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_variable_declaration] = STATE(1810),
    [sym_lexical_declaration] = STATE(1810),
    [sym_statement_block] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_for_in_statement] = STATE(1810),
    [sym_for_of_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_with_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_debugger_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_throw_statement] = STATE(1810),
    [sym_empty_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2059] = {
    [sym_export_statement] = STATE(1811),
    [sym__declaration] = STATE(1811),
    [sym_import_statement] = STATE(1811),
    [sym_expression_statement] = STATE(1811),
    [sym_variable_declaration] = STATE(1811),
    [sym_lexical_declaration] = STATE(1811),
    [sym_statement_block] = STATE(1811),
    [sym_if_statement] = STATE(1811),
    [sym_switch_statement] = STATE(1811),
    [sym_for_statement] = STATE(1811),
    [sym_for_in_statement] = STATE(1811),
    [sym_for_of_statement] = STATE(1811),
    [sym_while_statement] = STATE(1811),
    [sym_do_statement] = STATE(1811),
    [sym_try_statement] = STATE(1811),
    [sym_with_statement] = STATE(1811),
    [sym_break_statement] = STATE(1811),
    [sym_continue_statement] = STATE(1811),
    [sym_debugger_statement] = STATE(1811),
    [sym_return_statement] = STATE(1811),
    [sym_throw_statement] = STATE(1811),
    [sym_empty_statement] = STATE(1811),
    [sym_labeled_statement] = STATE(1811),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2060] = {
    [sym_export_statement] = STATE(1812),
    [sym__declaration] = STATE(1812),
    [sym_import_statement] = STATE(1812),
    [sym_expression_statement] = STATE(1812),
    [sym_variable_declaration] = STATE(1812),
    [sym_lexical_declaration] = STATE(1812),
    [sym_statement_block] = STATE(1812),
    [sym_if_statement] = STATE(1812),
    [sym_switch_statement] = STATE(1812),
    [sym_for_statement] = STATE(1812),
    [sym_for_in_statement] = STATE(1812),
    [sym_for_of_statement] = STATE(1812),
    [sym_while_statement] = STATE(1812),
    [sym_do_statement] = STATE(1812),
    [sym_try_statement] = STATE(1812),
    [sym_with_statement] = STATE(1812),
    [sym_break_statement] = STATE(1812),
    [sym_continue_statement] = STATE(1812),
    [sym_debugger_statement] = STATE(1812),
    [sym_return_statement] = STATE(1812),
    [sym_throw_statement] = STATE(1812),
    [sym_empty_statement] = STATE(1812),
    [sym_labeled_statement] = STATE(1812),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2061] = {
    [sym_export_statement] = STATE(1813),
    [sym__declaration] = STATE(1813),
    [sym_import_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_variable_declaration] = STATE(1813),
    [sym_lexical_declaration] = STATE(1813),
    [sym_statement_block] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_for_in_statement] = STATE(1813),
    [sym_for_of_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_with_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_debugger_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_throw_statement] = STATE(1813),
    [sym_empty_statement] = STATE(1813),
    [sym_labeled_statement] = STATE(1813),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2062] = {
    [sym_export_statement] = STATE(1814),
    [sym__declaration] = STATE(1814),
    [sym_import_statement] = STATE(1814),
    [sym_expression_statement] = STATE(1814),
    [sym_variable_declaration] = STATE(1814),
    [sym_lexical_declaration] = STATE(1814),
    [sym_statement_block] = STATE(1814),
    [sym_if_statement] = STATE(1814),
    [sym_switch_statement] = STATE(1814),
    [sym_for_statement] = STATE(1814),
    [sym_for_in_statement] = STATE(1814),
    [sym_for_of_statement] = STATE(1814),
    [sym_while_statement] = STATE(1814),
    [sym_do_statement] = STATE(1814),
    [sym_try_statement] = STATE(1814),
    [sym_with_statement] = STATE(1814),
    [sym_break_statement] = STATE(1814),
    [sym_continue_statement] = STATE(1814),
    [sym_debugger_statement] = STATE(1814),
    [sym_return_statement] = STATE(1814),
    [sym_throw_statement] = STATE(1814),
    [sym_empty_statement] = STATE(1814),
    [sym_labeled_statement] = STATE(1814),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2063] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4981),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2064] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4983),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2065] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4985),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2066] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4987),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2067] = {
    [anon_sym_RPAREN] = ACTIONS(4987),
    [sym_comment] = ACTIONS(78),
  },
  [2068] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4989),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2069] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4991),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2070] = {
    [anon_sym_RPAREN] = ACTIONS(4991),
    [sym_comment] = ACTIONS(78),
  },
  [2071] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4993),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2072] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4995),
    [anon_sym_in] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(787),
    [anon_sym_GT] = ACTIONS(787),
    [anon_sym_SLASH] = ACTIONS(803),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(803),
    [anon_sym_GT_GT_GT] = ACTIONS(797),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_LT_EQ] = ACTIONS(817),
    [anon_sym_EQ_EQ] = ACTIONS(787),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(817),
    [anon_sym_BANG_EQ] = ACTIONS(787),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(817),
    [anon_sym_GT_EQ] = ACTIONS(817),
    [anon_sym_instanceof] = ACTIONS(817),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2073] = {
    [anon_sym_RPAREN] = ACTIONS(4995),
    [sym_comment] = ACTIONS(78),
  },
  [2074] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(4997),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2075] = {
    [sym_export_statement] = STATE(1672),
    [sym__declaration] = STATE(1672),
    [sym_import_statement] = STATE(1672),
    [sym_expression_statement] = STATE(1672),
    [sym_variable_declaration] = STATE(1672),
    [sym_lexical_declaration] = STATE(1672),
    [sym_statement_block] = STATE(1672),
    [sym_if_statement] = STATE(1672),
    [sym_switch_statement] = STATE(1672),
    [sym_for_statement] = STATE(1672),
    [sym_for_in_statement] = STATE(1672),
    [sym_for_of_statement] = STATE(1672),
    [sym_while_statement] = STATE(1672),
    [sym_do_statement] = STATE(1672),
    [sym_try_statement] = STATE(1672),
    [sym_with_statement] = STATE(1672),
    [sym_break_statement] = STATE(1672),
    [sym_continue_statement] = STATE(1672),
    [sym_debugger_statement] = STATE(1672),
    [sym_return_statement] = STATE(1672),
    [sym_throw_statement] = STATE(1672),
    [sym_empty_statement] = STATE(1672),
    [sym_labeled_statement] = STATE(1672),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2076] = {
    [sym_export_statement] = STATE(1683),
    [sym__declaration] = STATE(1683),
    [sym_import_statement] = STATE(1683),
    [sym_expression_statement] = STATE(1683),
    [sym_variable_declaration] = STATE(1683),
    [sym_lexical_declaration] = STATE(1683),
    [sym_statement_block] = STATE(1683),
    [sym_if_statement] = STATE(1683),
    [sym_switch_statement] = STATE(1683),
    [sym_for_statement] = STATE(1683),
    [sym_for_in_statement] = STATE(1683),
    [sym_for_of_statement] = STATE(1683),
    [sym_while_statement] = STATE(1683),
    [sym_do_statement] = STATE(1683),
    [sym_try_statement] = STATE(1683),
    [sym_with_statement] = STATE(1683),
    [sym_break_statement] = STATE(1683),
    [sym_continue_statement] = STATE(1683),
    [sym_debugger_statement] = STATE(1683),
    [sym_return_statement] = STATE(1683),
    [sym_throw_statement] = STATE(1683),
    [sym_empty_statement] = STATE(1683),
    [sym_labeled_statement] = STATE(1683),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2077] = {
    [sym_export_statement] = STATE(1688),
    [sym__declaration] = STATE(1688),
    [sym_import_statement] = STATE(1688),
    [sym_expression_statement] = STATE(1688),
    [sym_variable_declaration] = STATE(1688),
    [sym_lexical_declaration] = STATE(1688),
    [sym_statement_block] = STATE(1688),
    [sym_if_statement] = STATE(1688),
    [sym_switch_statement] = STATE(1688),
    [sym_for_statement] = STATE(1688),
    [sym_for_in_statement] = STATE(1688),
    [sym_for_of_statement] = STATE(1688),
    [sym_while_statement] = STATE(1688),
    [sym_do_statement] = STATE(1688),
    [sym_try_statement] = STATE(1688),
    [sym_with_statement] = STATE(1688),
    [sym_break_statement] = STATE(1688),
    [sym_continue_statement] = STATE(1688),
    [sym_debugger_statement] = STATE(1688),
    [sym_return_statement] = STATE(1688),
    [sym_throw_statement] = STATE(1688),
    [sym_empty_statement] = STATE(1688),
    [sym_labeled_statement] = STATE(1688),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2078] = {
    [sym_export_statement] = STATE(1689),
    [sym__declaration] = STATE(1689),
    [sym_import_statement] = STATE(1689),
    [sym_expression_statement] = STATE(1689),
    [sym_variable_declaration] = STATE(1689),
    [sym_lexical_declaration] = STATE(1689),
    [sym_statement_block] = STATE(1689),
    [sym_if_statement] = STATE(1689),
    [sym_switch_statement] = STATE(1689),
    [sym_for_statement] = STATE(1689),
    [sym_for_in_statement] = STATE(1689),
    [sym_for_of_statement] = STATE(1689),
    [sym_while_statement] = STATE(1689),
    [sym_do_statement] = STATE(1689),
    [sym_try_statement] = STATE(1689),
    [sym_with_statement] = STATE(1689),
    [sym_break_statement] = STATE(1689),
    [sym_continue_statement] = STATE(1689),
    [sym_debugger_statement] = STATE(1689),
    [sym_return_statement] = STATE(1689),
    [sym_throw_statement] = STATE(1689),
    [sym_empty_statement] = STATE(1689),
    [sym_labeled_statement] = STATE(1689),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2079] = {
    [sym_export_statement] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym_import_statement] = STATE(1690),
    [sym_expression_statement] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_lexical_declaration] = STATE(1690),
    [sym_statement_block] = STATE(1690),
    [sym_if_statement] = STATE(1690),
    [sym_switch_statement] = STATE(1690),
    [sym_for_statement] = STATE(1690),
    [sym_for_in_statement] = STATE(1690),
    [sym_for_of_statement] = STATE(1690),
    [sym_while_statement] = STATE(1690),
    [sym_do_statement] = STATE(1690),
    [sym_try_statement] = STATE(1690),
    [sym_with_statement] = STATE(1690),
    [sym_break_statement] = STATE(1690),
    [sym_continue_statement] = STATE(1690),
    [sym_debugger_statement] = STATE(1690),
    [sym_return_statement] = STATE(1690),
    [sym_throw_statement] = STATE(1690),
    [sym_empty_statement] = STATE(1690),
    [sym_labeled_statement] = STATE(1690),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2080] = {
    [sym_export_statement] = STATE(1691),
    [sym__declaration] = STATE(1691),
    [sym_import_statement] = STATE(1691),
    [sym_expression_statement] = STATE(1691),
    [sym_variable_declaration] = STATE(1691),
    [sym_lexical_declaration] = STATE(1691),
    [sym_statement_block] = STATE(1691),
    [sym_if_statement] = STATE(1691),
    [sym_switch_statement] = STATE(1691),
    [sym_for_statement] = STATE(1691),
    [sym_for_in_statement] = STATE(1691),
    [sym_for_of_statement] = STATE(1691),
    [sym_while_statement] = STATE(1691),
    [sym_do_statement] = STATE(1691),
    [sym_try_statement] = STATE(1691),
    [sym_with_statement] = STATE(1691),
    [sym_break_statement] = STATE(1691),
    [sym_continue_statement] = STATE(1691),
    [sym_debugger_statement] = STATE(1691),
    [sym_return_statement] = STATE(1691),
    [sym_throw_statement] = STATE(1691),
    [sym_empty_statement] = STATE(1691),
    [sym_labeled_statement] = STATE(1691),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2081] = {
    [sym_export_statement] = STATE(1692),
    [sym__declaration] = STATE(1692),
    [sym_import_statement] = STATE(1692),
    [sym_expression_statement] = STATE(1692),
    [sym_variable_declaration] = STATE(1692),
    [sym_lexical_declaration] = STATE(1692),
    [sym_statement_block] = STATE(1692),
    [sym_if_statement] = STATE(1692),
    [sym_switch_statement] = STATE(1692),
    [sym_for_statement] = STATE(1692),
    [sym_for_in_statement] = STATE(1692),
    [sym_for_of_statement] = STATE(1692),
    [sym_while_statement] = STATE(1692),
    [sym_do_statement] = STATE(1692),
    [sym_try_statement] = STATE(1692),
    [sym_with_statement] = STATE(1692),
    [sym_break_statement] = STATE(1692),
    [sym_continue_statement] = STATE(1692),
    [sym_debugger_statement] = STATE(1692),
    [sym_return_statement] = STATE(1692),
    [sym_throw_statement] = STATE(1692),
    [sym_empty_statement] = STATE(1692),
    [sym_labeled_statement] = STATE(1692),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2082] = {
    [sym_parenthesized_expression] = STATE(2094),
    [sym__expression] = STATE(2094),
    [sym_yield_expression] = STATE(2094),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2094),
    [sym_jsx_fragment] = STATE(2094),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2094),
    [sym_anonymous_class] = STATE(2094),
    [sym_class] = STATE(2094),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2094),
    [sym_generator_function] = STATE(2094),
    [sym_call_expression] = STATE(2094),
    [sym_new_expression] = STATE(2094),
    [sym_await_expression] = STATE(2094),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2094),
    [sym_augmented_assignment_expression] = STATE(2094),
    [sym_ternary_expression] = STATE(2094),
    [sym_binary_expression] = STATE(2094),
    [sym_unary_expression] = STATE(2094),
    [sym_update_expression] = STATE(2094),
    [sym_string] = STATE(2094),
    [sym_template_string] = STATE(2094),
    [sym_regex] = STATE(2094),
    [sym_meta_property] = STATE(2094),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(4999),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(5001),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(5001),
    [sym_false] = ACTIONS(5001),
    [sym_null] = ACTIONS(5001),
    [sym_undefined] = ACTIONS(5001),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2083] = {
    [sym_parenthesized_expression] = STATE(2095),
    [sym__expression] = STATE(2095),
    [sym_yield_expression] = STATE(2095),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2095),
    [sym_jsx_fragment] = STATE(2095),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2095),
    [sym_anonymous_class] = STATE(2095),
    [sym_class] = STATE(2095),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2095),
    [sym_generator_function] = STATE(2095),
    [sym_call_expression] = STATE(2095),
    [sym_new_expression] = STATE(2095),
    [sym_await_expression] = STATE(2095),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2095),
    [sym_augmented_assignment_expression] = STATE(2095),
    [sym_ternary_expression] = STATE(2095),
    [sym_binary_expression] = STATE(2095),
    [sym_unary_expression] = STATE(2095),
    [sym_update_expression] = STATE(2095),
    [sym_string] = STATE(2095),
    [sym_template_string] = STATE(2095),
    [sym_regex] = STATE(2095),
    [sym_meta_property] = STATE(2095),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(5003),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(5005),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(5005),
    [sym_false] = ACTIONS(5005),
    [sym_null] = ACTIONS(5005),
    [sym_undefined] = ACTIONS(5005),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2084] = {
    [sym_parenthesized_expression] = STATE(2096),
    [sym__expression] = STATE(2096),
    [sym_yield_expression] = STATE(2096),
    [sym_object] = STATE(1211),
    [sym_array] = STATE(1212),
    [sym_jsx_element] = STATE(2096),
    [sym_jsx_fragment] = STATE(2096),
    [sym_jsx_opening_element] = STATE(128),
    [sym_jsx_self_closing_element] = STATE(2096),
    [sym_anonymous_class] = STATE(2096),
    [sym_class] = STATE(2096),
    [sym_function] = STATE(129),
    [sym_arrow_function] = STATE(2096),
    [sym_generator_function] = STATE(2096),
    [sym_call_expression] = STATE(2096),
    [sym_new_expression] = STATE(2096),
    [sym_await_expression] = STATE(2096),
    [sym_member_expression] = STATE(1213),
    [sym_subscript_expression] = STATE(1213),
    [sym_assignment_expression] = STATE(2096),
    [sym_augmented_assignment_expression] = STATE(2096),
    [sym_ternary_expression] = STATE(2096),
    [sym_binary_expression] = STATE(2096),
    [sym_unary_expression] = STATE(2096),
    [sym_update_expression] = STATE(2096),
    [sym_string] = STATE(2096),
    [sym_template_string] = STATE(2096),
    [sym_regex] = STATE(2096),
    [sym_meta_property] = STATE(2096),
    [sym_decorator] = STATE(133),
    [sym_formal_parameters] = STATE(1214),
    [aux_sym_export_statement_repeat1] = STATE(133),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(158),
    [anon_sym_await] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(166),
    [anon_sym_LT] = ACTIONS(168),
    [anon_sym_SLASH] = ACTIONS(170),
    [anon_sym_class] = ACTIONS(172),
    [anon_sym_async] = ACTIONS(2724),
    [anon_sym_function] = ACTIONS(176),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [anon_sym_SQUOTE] = ACTIONS(192),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym_number] = ACTIONS(5007),
    [sym_identifier] = ACTIONS(2738),
    [sym_this] = ACTIONS(5009),
    [sym_super] = ACTIONS(202),
    [sym_true] = ACTIONS(5009),
    [sym_false] = ACTIONS(5009),
    [sym_null] = ACTIONS(5009),
    [sym_undefined] = ACTIONS(5009),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(2742),
    [anon_sym_set] = ACTIONS(2742),
  },
  [2085] = {
    [sym_export_statement] = STATE(1916),
    [sym__declaration] = STATE(1916),
    [sym_import_statement] = STATE(1916),
    [sym_expression_statement] = STATE(1916),
    [sym_variable_declaration] = STATE(1916),
    [sym_lexical_declaration] = STATE(1916),
    [sym_statement_block] = STATE(1916),
    [sym_if_statement] = STATE(1916),
    [sym_switch_statement] = STATE(1916),
    [sym_for_statement] = STATE(1916),
    [sym_for_in_statement] = STATE(1916),
    [sym_for_of_statement] = STATE(1916),
    [sym_while_statement] = STATE(1916),
    [sym_do_statement] = STATE(1916),
    [sym_try_statement] = STATE(1916),
    [sym_with_statement] = STATE(1916),
    [sym_break_statement] = STATE(1916),
    [sym_continue_statement] = STATE(1916),
    [sym_debugger_statement] = STATE(1916),
    [sym_return_statement] = STATE(1916),
    [sym_throw_statement] = STATE(1916),
    [sym_empty_statement] = STATE(1916),
    [sym_labeled_statement] = STATE(1916),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2086] = {
    [sym_export_statement] = STATE(1917),
    [sym__declaration] = STATE(1917),
    [sym_import_statement] = STATE(1917),
    [sym_expression_statement] = STATE(1917),
    [sym_variable_declaration] = STATE(1917),
    [sym_lexical_declaration] = STATE(1917),
    [sym_statement_block] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_switch_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_for_in_statement] = STATE(1917),
    [sym_for_of_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_do_statement] = STATE(1917),
    [sym_try_statement] = STATE(1917),
    [sym_with_statement] = STATE(1917),
    [sym_break_statement] = STATE(1917),
    [sym_continue_statement] = STATE(1917),
    [sym_debugger_statement] = STATE(1917),
    [sym_return_statement] = STATE(1917),
    [sym_throw_statement] = STATE(1917),
    [sym_empty_statement] = STATE(1917),
    [sym_labeled_statement] = STATE(1917),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2087] = {
    [sym_export_statement] = STATE(1918),
    [sym__declaration] = STATE(1918),
    [sym_import_statement] = STATE(1918),
    [sym_expression_statement] = STATE(1918),
    [sym_variable_declaration] = STATE(1918),
    [sym_lexical_declaration] = STATE(1918),
    [sym_statement_block] = STATE(1918),
    [sym_if_statement] = STATE(1918),
    [sym_switch_statement] = STATE(1918),
    [sym_for_statement] = STATE(1918),
    [sym_for_in_statement] = STATE(1918),
    [sym_for_of_statement] = STATE(1918),
    [sym_while_statement] = STATE(1918),
    [sym_do_statement] = STATE(1918),
    [sym_try_statement] = STATE(1918),
    [sym_with_statement] = STATE(1918),
    [sym_break_statement] = STATE(1918),
    [sym_continue_statement] = STATE(1918),
    [sym_debugger_statement] = STATE(1918),
    [sym_return_statement] = STATE(1918),
    [sym_throw_statement] = STATE(1918),
    [sym_empty_statement] = STATE(1918),
    [sym_labeled_statement] = STATE(1918),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(3373),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(3375),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(3379),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(3381),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2088] = {
    [sym_export_statement] = STATE(1809),
    [sym__declaration] = STATE(1809),
    [sym_import_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_variable_declaration] = STATE(1809),
    [sym_lexical_declaration] = STATE(1809),
    [sym_statement_block] = STATE(1809),
    [sym_if_statement] = STATE(1809),
    [sym_switch_statement] = STATE(1809),
    [sym_for_statement] = STATE(1809),
    [sym_for_in_statement] = STATE(1809),
    [sym_for_of_statement] = STATE(1809),
    [sym_while_statement] = STATE(1809),
    [sym_do_statement] = STATE(1809),
    [sym_try_statement] = STATE(1809),
    [sym_with_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_debugger_statement] = STATE(1809),
    [sym_return_statement] = STATE(1809),
    [sym_throw_statement] = STATE(1809),
    [sym_empty_statement] = STATE(1809),
    [sym_labeled_statement] = STATE(1809),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2089] = {
    [sym_export_statement] = STATE(1810),
    [sym__declaration] = STATE(1810),
    [sym_import_statement] = STATE(1810),
    [sym_expression_statement] = STATE(1810),
    [sym_variable_declaration] = STATE(1810),
    [sym_lexical_declaration] = STATE(1810),
    [sym_statement_block] = STATE(1810),
    [sym_if_statement] = STATE(1810),
    [sym_switch_statement] = STATE(1810),
    [sym_for_statement] = STATE(1810),
    [sym_for_in_statement] = STATE(1810),
    [sym_for_of_statement] = STATE(1810),
    [sym_while_statement] = STATE(1810),
    [sym_do_statement] = STATE(1810),
    [sym_try_statement] = STATE(1810),
    [sym_with_statement] = STATE(1810),
    [sym_break_statement] = STATE(1810),
    [sym_continue_statement] = STATE(1810),
    [sym_debugger_statement] = STATE(1810),
    [sym_return_statement] = STATE(1810),
    [sym_throw_statement] = STATE(1810),
    [sym_empty_statement] = STATE(1810),
    [sym_labeled_statement] = STATE(1810),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2090] = {
    [sym_export_statement] = STATE(1811),
    [sym__declaration] = STATE(1811),
    [sym_import_statement] = STATE(1811),
    [sym_expression_statement] = STATE(1811),
    [sym_variable_declaration] = STATE(1811),
    [sym_lexical_declaration] = STATE(1811),
    [sym_statement_block] = STATE(1811),
    [sym_if_statement] = STATE(1811),
    [sym_switch_statement] = STATE(1811),
    [sym_for_statement] = STATE(1811),
    [sym_for_in_statement] = STATE(1811),
    [sym_for_of_statement] = STATE(1811),
    [sym_while_statement] = STATE(1811),
    [sym_do_statement] = STATE(1811),
    [sym_try_statement] = STATE(1811),
    [sym_with_statement] = STATE(1811),
    [sym_break_statement] = STATE(1811),
    [sym_continue_statement] = STATE(1811),
    [sym_debugger_statement] = STATE(1811),
    [sym_return_statement] = STATE(1811),
    [sym_throw_statement] = STATE(1811),
    [sym_empty_statement] = STATE(1811),
    [sym_labeled_statement] = STATE(1811),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2091] = {
    [sym_export_statement] = STATE(1812),
    [sym__declaration] = STATE(1812),
    [sym_import_statement] = STATE(1812),
    [sym_expression_statement] = STATE(1812),
    [sym_variable_declaration] = STATE(1812),
    [sym_lexical_declaration] = STATE(1812),
    [sym_statement_block] = STATE(1812),
    [sym_if_statement] = STATE(1812),
    [sym_switch_statement] = STATE(1812),
    [sym_for_statement] = STATE(1812),
    [sym_for_in_statement] = STATE(1812),
    [sym_for_of_statement] = STATE(1812),
    [sym_while_statement] = STATE(1812),
    [sym_do_statement] = STATE(1812),
    [sym_try_statement] = STATE(1812),
    [sym_with_statement] = STATE(1812),
    [sym_break_statement] = STATE(1812),
    [sym_continue_statement] = STATE(1812),
    [sym_debugger_statement] = STATE(1812),
    [sym_return_statement] = STATE(1812),
    [sym_throw_statement] = STATE(1812),
    [sym_empty_statement] = STATE(1812),
    [sym_labeled_statement] = STATE(1812),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2092] = {
    [sym_export_statement] = STATE(1813),
    [sym__declaration] = STATE(1813),
    [sym_import_statement] = STATE(1813),
    [sym_expression_statement] = STATE(1813),
    [sym_variable_declaration] = STATE(1813),
    [sym_lexical_declaration] = STATE(1813),
    [sym_statement_block] = STATE(1813),
    [sym_if_statement] = STATE(1813),
    [sym_switch_statement] = STATE(1813),
    [sym_for_statement] = STATE(1813),
    [sym_for_in_statement] = STATE(1813),
    [sym_for_of_statement] = STATE(1813),
    [sym_while_statement] = STATE(1813),
    [sym_do_statement] = STATE(1813),
    [sym_try_statement] = STATE(1813),
    [sym_with_statement] = STATE(1813),
    [sym_break_statement] = STATE(1813),
    [sym_continue_statement] = STATE(1813),
    [sym_debugger_statement] = STATE(1813),
    [sym_return_statement] = STATE(1813),
    [sym_throw_statement] = STATE(1813),
    [sym_empty_statement] = STATE(1813),
    [sym_labeled_statement] = STATE(1813),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2093] = {
    [sym_export_statement] = STATE(1814),
    [sym__declaration] = STATE(1814),
    [sym_import_statement] = STATE(1814),
    [sym_expression_statement] = STATE(1814),
    [sym_variable_declaration] = STATE(1814),
    [sym_lexical_declaration] = STATE(1814),
    [sym_statement_block] = STATE(1814),
    [sym_if_statement] = STATE(1814),
    [sym_switch_statement] = STATE(1814),
    [sym_for_statement] = STATE(1814),
    [sym_for_in_statement] = STATE(1814),
    [sym_for_of_statement] = STATE(1814),
    [sym_while_statement] = STATE(1814),
    [sym_do_statement] = STATE(1814),
    [sym_try_statement] = STATE(1814),
    [sym_with_statement] = STATE(1814),
    [sym_break_statement] = STATE(1814),
    [sym_continue_statement] = STATE(1814),
    [sym_debugger_statement] = STATE(1814),
    [sym_return_statement] = STATE(1814),
    [sym_throw_statement] = STATE(1814),
    [sym_empty_statement] = STATE(1814),
    [sym_labeled_statement] = STATE(1814),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2094] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(5011),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2095] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(5013),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2096] = {
    [sym_template_string] = STATE(460),
    [sym_arguments] = STATE(460),
    [anon_sym_STAR] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(793),
    [anon_sym_RPAREN] = ACTIONS(5015),
    [anon_sym_in] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(795),
    [anon_sym_LT] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3535),
    [anon_sym_DOT] = ACTIONS(789),
    [anon_sym_QMARK] = ACTIONS(3537),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3535),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3543),
    [anon_sym_CARET] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3545),
    [anon_sym_PLUS] = ACTIONS(3547),
    [anon_sym_DASH] = ACTIONS(3547),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_instanceof] = ACTIONS(3549),
    [anon_sym_PLUS_PLUS] = ACTIONS(819),
    [anon_sym_DASH_DASH] = ACTIONS(819),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(194),
  },
  [2097] = {
    [sym_export_statement] = STATE(1916),
    [sym__declaration] = STATE(1916),
    [sym_import_statement] = STATE(1916),
    [sym_expression_statement] = STATE(1916),
    [sym_variable_declaration] = STATE(1916),
    [sym_lexical_declaration] = STATE(1916),
    [sym_statement_block] = STATE(1916),
    [sym_if_statement] = STATE(1916),
    [sym_switch_statement] = STATE(1916),
    [sym_for_statement] = STATE(1916),
    [sym_for_in_statement] = STATE(1916),
    [sym_for_of_statement] = STATE(1916),
    [sym_while_statement] = STATE(1916),
    [sym_do_statement] = STATE(1916),
    [sym_try_statement] = STATE(1916),
    [sym_with_statement] = STATE(1916),
    [sym_break_statement] = STATE(1916),
    [sym_continue_statement] = STATE(1916),
    [sym_debugger_statement] = STATE(1916),
    [sym_return_statement] = STATE(1916),
    [sym_throw_statement] = STATE(1916),
    [sym_empty_statement] = STATE(1916),
    [sym_labeled_statement] = STATE(1916),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2098] = {
    [sym_export_statement] = STATE(1917),
    [sym__declaration] = STATE(1917),
    [sym_import_statement] = STATE(1917),
    [sym_expression_statement] = STATE(1917),
    [sym_variable_declaration] = STATE(1917),
    [sym_lexical_declaration] = STATE(1917),
    [sym_statement_block] = STATE(1917),
    [sym_if_statement] = STATE(1917),
    [sym_switch_statement] = STATE(1917),
    [sym_for_statement] = STATE(1917),
    [sym_for_in_statement] = STATE(1917),
    [sym_for_of_statement] = STATE(1917),
    [sym_while_statement] = STATE(1917),
    [sym_do_statement] = STATE(1917),
    [sym_try_statement] = STATE(1917),
    [sym_with_statement] = STATE(1917),
    [sym_break_statement] = STATE(1917),
    [sym_continue_statement] = STATE(1917),
    [sym_debugger_statement] = STATE(1917),
    [sym_return_statement] = STATE(1917),
    [sym_throw_statement] = STATE(1917),
    [sym_empty_statement] = STATE(1917),
    [sym_labeled_statement] = STATE(1917),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
  [2099] = {
    [sym_export_statement] = STATE(1918),
    [sym__declaration] = STATE(1918),
    [sym_import_statement] = STATE(1918),
    [sym_expression_statement] = STATE(1918),
    [sym_variable_declaration] = STATE(1918),
    [sym_lexical_declaration] = STATE(1918),
    [sym_statement_block] = STATE(1918),
    [sym_if_statement] = STATE(1918),
    [sym_switch_statement] = STATE(1918),
    [sym_for_statement] = STATE(1918),
    [sym_for_in_statement] = STATE(1918),
    [sym_for_of_statement] = STATE(1918),
    [sym_while_statement] = STATE(1918),
    [sym_do_statement] = STATE(1918),
    [sym_try_statement] = STATE(1918),
    [sym_with_statement] = STATE(1918),
    [sym_break_statement] = STATE(1918),
    [sym_continue_statement] = STATE(1918),
    [sym_debugger_statement] = STATE(1918),
    [sym_return_statement] = STATE(1918),
    [sym_throw_statement] = STATE(1918),
    [sym_empty_statement] = STATE(1918),
    [sym_labeled_statement] = STATE(1918),
    [sym_parenthesized_expression] = STATE(42),
    [sym__expression] = STATE(42),
    [sym_yield_expression] = STATE(42),
    [sym_object] = STATE(43),
    [sym_array] = STATE(44),
    [sym_jsx_element] = STATE(42),
    [sym_jsx_fragment] = STATE(42),
    [sym_jsx_opening_element] = STATE(45),
    [sym_jsx_self_closing_element] = STATE(42),
    [sym_anonymous_class] = STATE(42),
    [sym_class] = STATE(46),
    [sym_function] = STATE(47),
    [sym_arrow_function] = STATE(42),
    [sym_generator_function] = STATE(46),
    [sym_call_expression] = STATE(42),
    [sym_new_expression] = STATE(42),
    [sym_await_expression] = STATE(42),
    [sym_member_expression] = STATE(48),
    [sym_subscript_expression] = STATE(48),
    [sym_assignment_expression] = STATE(42),
    [sym_augmented_assignment_expression] = STATE(42),
    [sym_ternary_expression] = STATE(42),
    [sym_binary_expression] = STATE(42),
    [sym_unary_expression] = STATE(42),
    [sym_update_expression] = STATE(42),
    [sym_sequence_expression] = STATE(49),
    [sym_string] = STATE(42),
    [sym_template_string] = STATE(42),
    [sym_regex] = STATE(42),
    [sym_meta_property] = STATE(42),
    [sym_decorator] = STATE(52),
    [sym_formal_parameters] = STATE(50),
    [aux_sym_export_statement_repeat1] = STATE(52),
    [anon_sym_export] = ACTIONS(10),
    [anon_sym_LBRACE] = ACTIONS(12),
    [anon_sym_import] = ACTIONS(14),
    [anon_sym_var] = ACTIONS(16),
    [anon_sym_let] = ACTIONS(18),
    [anon_sym_const] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(4300),
    [anon_sym_switch] = ACTIONS(22),
    [anon_sym_for] = ACTIONS(4302),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_await] = ACTIONS(28),
    [anon_sym_while] = ACTIONS(4304),
    [anon_sym_do] = ACTIONS(32),
    [anon_sym_try] = ACTIONS(34),
    [anon_sym_with] = ACTIONS(4306),
    [anon_sym_break] = ACTIONS(38),
    [anon_sym_continue] = ACTIONS(40),
    [anon_sym_debugger] = ACTIONS(42),
    [anon_sym_return] = ACTIONS(44),
    [anon_sym_throw] = ACTIONS(46),
    [anon_sym_SEMI] = ACTIONS(48),
    [anon_sym_yield] = ACTIONS(50),
    [anon_sym_LBRACK] = ACTIONS(52),
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_SLASH] = ACTIONS(56),
    [anon_sym_class] = ACTIONS(58),
    [anon_sym_async] = ACTIONS(60),
    [anon_sym_function] = ACTIONS(62),
    [anon_sym_EQ_GT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS] = ACTIONS(68),
    [anon_sym_DASH] = ACTIONS(68),
    [anon_sym_BANG] = ACTIONS(70),
    [anon_sym_TILDE] = ACTIONS(70),
    [anon_sym_typeof] = ACTIONS(68),
    [anon_sym_void] = ACTIONS(68),
    [anon_sym_delete] = ACTIONS(68),
    [anon_sym_PLUS_PLUS] = ACTIONS(72),
    [anon_sym_DASH_DASH] = ACTIONS(72),
    [anon_sym_DQUOTE] = ACTIONS(74),
    [anon_sym_SQUOTE] = ACTIONS(76),
    [sym_comment] = ACTIONS(78),
    [anon_sym_BQUOTE] = ACTIONS(80),
    [sym_number] = ACTIONS(82),
    [sym_identifier] = ACTIONS(4308),
    [sym_this] = ACTIONS(86),
    [sym_super] = ACTIONS(88),
    [sym_true] = ACTIONS(86),
    [sym_false] = ACTIONS(86),
    [sym_null] = ACTIONS(86),
    [sym_undefined] = ACTIONS(86),
    [anon_sym_AT] = ACTIONS(90),
    [anon_sym_get] = ACTIONS(92),
    [anon_sym_set] = ACTIONS(92),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 0, .reusable = false},
  [2] = {.count = 1, .reusable = true}, RECOVER(),
  [4] = {.count = 1, .reusable = false}, RECOVER(),
  [6] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [8] = {.count = 1, .reusable = true}, SHIFT(2),
  [10] = {.count = 1, .reusable = false}, SHIFT(3),
  [12] = {.count = 1, .reusable = true}, SHIFT(4),
  [14] = {.count = 1, .reusable = false}, SHIFT(5),
  [16] = {.count = 1, .reusable = false}, SHIFT(6),
  [18] = {.count = 1, .reusable = false}, SHIFT(7),
  [20] = {.count = 1, .reusable = false}, SHIFT(8),
  [22] = {.count = 1, .reusable = false}, SHIFT(9),
  [24] = {.count = 1, .reusable = false}, SHIFT(10),
  [26] = {.count = 1, .reusable = true}, SHIFT(11),
  [28] = {.count = 1, .reusable = false}, SHIFT(12),
  [30] = {.count = 1, .reusable = false}, SHIFT(13),
  [32] = {.count = 1, .reusable = false}, SHIFT(14),
  [34] = {.count = 1, .reusable = false}, SHIFT(15),
  [36] = {.count = 1, .reusable = false}, SHIFT(16),
  [38] = {.count = 1, .reusable = false}, SHIFT(17),
  [40] = {.count = 1, .reusable = false}, SHIFT(18),
  [42] = {.count = 1, .reusable = false}, SHIFT(19),
  [44] = {.count = 1, .reusable = false}, SHIFT(20),
  [46] = {.count = 1, .reusable = false}, SHIFT(21),
  [48] = {.count = 1, .reusable = true}, SHIFT(22),
  [50] = {.count = 1, .reusable = false}, SHIFT(23),
  [52] = {.count = 1, .reusable = true}, SHIFT(24),
  [54] = {.count = 1, .reusable = true}, SHIFT(25),
  [56] = {.count = 1, .reusable = false}, SHIFT(26),
  [58] = {.count = 1, .reusable = false}, SHIFT(27),
  [60] = {.count = 1, .reusable = false}, SHIFT(28),
  [62] = {.count = 1, .reusable = false}, SHIFT(29),
  [64] = {.count = 1, .reusable = true}, SHIFT(30),
  [66] = {.count = 1, .reusable = false}, SHIFT(31),
  [68] = {.count = 1, .reusable = false}, SHIFT(32),
  [70] = {.count = 1, .reusable = true}, SHIFT(32),
  [72] = {.count = 1, .reusable = true}, SHIFT(33),
  [74] = {.count = 1, .reusable = true}, SHIFT(34),
  [76] = {.count = 1, .reusable = true}, SHIFT(35),
  [78] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [80] = {.count = 1, .reusable = true}, SHIFT(36),
  [82] = {.count = 1, .reusable = true}, SHIFT(42),
  [84] = {.count = 1, .reusable = false}, SHIFT(37),
  [86] = {.count = 1, .reusable = false}, SHIFT(42),
  [88] = {.count = 1, .reusable = false}, SHIFT(38),
  [90] = {.count = 1, .reusable = true}, SHIFT(39),
  [92] = {.count = 1, .reusable = false}, SHIFT(40),
  [94] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [96] = {.count = 1, .reusable = true}, SHIFT(54),
  [98] = {.count = 1, .reusable = true}, SHIFT(55),
  [100] = {.count = 1, .reusable = true}, SHIFT(56),
  [102] = {.count = 1, .reusable = true}, SHIFT(6),
  [104] = {.count = 1, .reusable = true}, SHIFT(7),
  [106] = {.count = 1, .reusable = true}, SHIFT(57),
  [108] = {.count = 1, .reusable = true}, SHIFT(58),
  [110] = {.count = 1, .reusable = true}, SHIFT(59),
  [112] = {.count = 1, .reusable = true}, SHIFT(64),
  [114] = {.count = 1, .reusable = true}, SHIFT(65),
  [116] = {.count = 1, .reusable = true}, SHIFT(66),
  [118] = {.count = 1, .reusable = false}, SHIFT(67),
  [120] = {.count = 1, .reusable = false}, SHIFT(68),
  [122] = {.count = 1, .reusable = false}, SHIFT(69),
  [124] = {.count = 1, .reusable = false}, SHIFT(70),
  [126] = {.count = 1, .reusable = true}, SHIFT(71),
  [128] = {.count = 1, .reusable = false}, SHIFT(72),
  [130] = {.count = 1, .reusable = true}, SHIFT(73),
  [132] = {.count = 1, .reusable = true}, SHIFT(74),
  [134] = {.count = 1, .reusable = false}, SHIFT(75),
  [136] = {.count = 1, .reusable = false}, SHIFT(76),
  [138] = {.count = 1, .reusable = true}, SHIFT(84),
  [140] = {.count = 1, .reusable = true}, SHIFT(85),
  [142] = {.count = 1, .reusable = true}, SHIFT(86),
  [144] = {.count = 1, .reusable = true}, SHIFT(90),
  [146] = {.count = 1, .reusable = true}, SHIFT(91),
  [148] = {.count = 1, .reusable = true}, SHIFT(92),
  [150] = {.count = 1, .reusable = true}, SHIFT(97),
  [152] = {.count = 1, .reusable = true}, SHIFT(100),
  [154] = {.count = 1, .reusable = true}, SHIFT(101),
  [156] = {.count = 1, .reusable = true}, SHIFT(102),
  [158] = {.count = 1, .reusable = true}, SHIFT(103),
  [160] = {.count = 1, .reusable = true}, SHIFT(104),
  [162] = {.count = 1, .reusable = false}, SHIFT(105),
  [164] = {.count = 1, .reusable = false}, SHIFT(106),
  [166] = {.count = 1, .reusable = true}, SHIFT(107),
  [168] = {.count = 1, .reusable = true}, SHIFT(108),
  [170] = {.count = 1, .reusable = false}, SHIFT(109),
  [172] = {.count = 1, .reusable = false}, SHIFT(110),
  [174] = {.count = 1, .reusable = false}, SHIFT(111),
  [176] = {.count = 1, .reusable = false}, SHIFT(112),
  [178] = {.count = 1, .reusable = true}, SHIFT(113),
  [180] = {.count = 1, .reusable = false}, SHIFT(114),
  [182] = {.count = 1, .reusable = true}, SHIFT(115),
  [184] = {.count = 1, .reusable = false}, SHIFT(116),
  [186] = {.count = 1, .reusable = true}, SHIFT(116),
  [188] = {.count = 1, .reusable = true}, SHIFT(117),
  [190] = {.count = 1, .reusable = true}, SHIFT(118),
  [192] = {.count = 1, .reusable = true}, SHIFT(119),
  [194] = {.count = 1, .reusable = true}, SHIFT(120),
  [196] = {.count = 1, .reusable = true}, SHIFT(124),
  [198] = {.count = 1, .reusable = false}, SHIFT(121),
  [200] = {.count = 1, .reusable = false}, SHIFT(124),
  [202] = {.count = 1, .reusable = false}, SHIFT(122),
  [204] = {.count = 1, .reusable = false}, SHIFT(123),
  [206] = {.count = 1, .reusable = true}, SHIFT(134),
  [208] = {.count = 1, .reusable = true}, SHIFT(136),
  [210] = {.count = 1, .reusable = false}, SHIFT(135),
  [212] = {.count = 1, .reusable = false}, SHIFT(136),
  [214] = {.count = 1, .reusable = false}, SHIFT(140),
  [216] = {.count = 1, .reusable = false}, SHIFT(141),
  [218] = {.count = 1, .reusable = false}, SHIFT(142),
  [220] = {.count = 1, .reusable = false}, SHIFT(143),
  [222] = {.count = 1, .reusable = false}, SHIFT(144),
  [224] = {.count = 1, .reusable = false}, SHIFT(145),
  [226] = {.count = 1, .reusable = true}, SHIFT(150),
  [228] = {.count = 1, .reusable = true}, SHIFT(153),
  [230] = {.count = 1, .reusable = true}, SHIFT(154),
  [232] = {.count = 1, .reusable = true}, SHIFT(155),
  [234] = {.count = 1, .reusable = true}, SHIFT(156),
  [236] = {.count = 1, .reusable = true}, SHIFT(157),
  [238] = {.count = 1, .reusable = true}, SHIFT(158),
  [240] = {.count = 1, .reusable = true}, SHIFT(159),
  [242] = {.count = 1, .reusable = false}, SHIFT(159),
  [244] = {.count = 1, .reusable = true}, SHIFT(161),
  [246] = {.count = 1, .reusable = false}, SHIFT(161),
  [248] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [250] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [252] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [254] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [256] = {.count = 1, .reusable = false}, SHIFT(25),
  [258] = {.count = 1, .reusable = true}, SHIFT(163),
  [260] = {.count = 1, .reusable = false}, SHIFT(163),
  [262] = {.count = 1, .reusable = true}, SHIFT(164),
  [264] = {.count = 1, .reusable = false}, SHIFT(165),
  [266] = {.count = 1, .reusable = false}, SHIFT(166),
  [268] = {.count = 1, .reusable = true}, SHIFT(167),
  [270] = {.count = 1, .reusable = false}, SHIFT(168),
  [272] = {.count = 1, .reusable = true}, SHIFT(169),
  [274] = {.count = 1, .reusable = false}, SHIFT(170),
  [276] = {.count = 1, .reusable = true}, SHIFT(171),
  [278] = {.count = 1, .reusable = false}, SHIFT(172),
  [280] = {.count = 1, .reusable = true}, SHIFT(172),
  [282] = {.count = 1, .reusable = true}, SHIFT(173),
  [284] = {.count = 1, .reusable = true}, SHIFT(176),
  [286] = {.count = 1, .reusable = false}, SHIFT(174),
  [288] = {.count = 1, .reusable = false}, SHIFT(176),
  [290] = {.count = 1, .reusable = false}, SHIFT(175),
  [292] = {.count = 1, .reusable = true}, SHIFT(183),
  [294] = {.count = 1, .reusable = true}, SHIFT(184),
  [296] = {.count = 1, .reusable = false}, SHIFT(185),
  [298] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [300] = {.count = 1, .reusable = true}, SHIFT(188),
  [302] = {.count = 1, .reusable = true}, SHIFT(189),
  [304] = {.count = 1, .reusable = false}, SHIFT(190),
  [306] = {.count = 1, .reusable = false}, SHIFT(191),
  [308] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [310] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [312] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(194),
  [315] = {.count = 1, .reusable = true}, SHIFT(195),
  [317] = {.count = 1, .reusable = false}, SHIFT(196),
  [319] = {.count = 1, .reusable = false}, SHIFT(197),
  [321] = {.count = 1, .reusable = true}, SHIFT(198),
  [323] = {.count = 1, .reusable = true}, SHIFT(199),
  [325] = {.count = 1, .reusable = false}, SHIFT(200),
  [327] = {.count = 1, .reusable = true}, SHIFT(202),
  [329] = {.count = 1, .reusable = true}, SHIFT(194),
  [331] = {.count = 1, .reusable = true}, SHIFT(203),
  [333] = {.count = 1, .reusable = true}, SHIFT(205),
  [335] = {.count = 1, .reusable = true}, SHIFT(207),
  [337] = {.count = 1, .reusable = false}, SHIFT(207),
  [339] = {.count = 1, .reusable = false}, SHIFT(208),
  [341] = {.count = 1, .reusable = false}, SHIFT(209),
  [343] = {.count = 1, .reusable = false}, SHIFT(210),
  [345] = {.count = 1, .reusable = false}, SHIFT(211),
  [347] = {.count = 1, .reusable = false}, SHIFT(212),
  [349] = {.count = 1, .reusable = true}, SHIFT(212),
  [351] = {.count = 1, .reusable = true}, SHIFT(213),
  [353] = {.count = 1, .reusable = true}, SHIFT(214),
  [355] = {.count = 1, .reusable = false}, SHIFT(215),
  [357] = {.count = 1, .reusable = false}, SHIFT(214),
  [359] = {.count = 1, .reusable = false}, SHIFT(216),
  [361] = {.count = 1, .reusable = false}, SHIFT(217),
  [363] = {.count = 1, .reusable = true}, SHIFT(223),
  [365] = {.count = 1, .reusable = false}, SHIFT(223),
  [367] = {.count = 1, .reusable = true}, SHIFT(224),
  [369] = {.count = 1, .reusable = false}, SHIFT(224),
  [371] = {.count = 1, .reusable = false}, SHIFT(225),
  [373] = {.count = 1, .reusable = true}, SHIFT(226),
  [375] = {.count = 1, .reusable = true}, SHIFT(227),
  [377] = {.count = 1, .reusable = true}, SHIFT(230),
  [379] = {.count = 1, .reusable = true}, SHIFT(228),
  [381] = {.count = 1, .reusable = true}, SHIFT(229),
  [383] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [385] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [387] = {.count = 1, .reusable = false}, SHIFT(231),
  [389] = {.count = 1, .reusable = true}, SHIFT(232),
  [391] = {.count = 1, .reusable = true}, SHIFT(233),
  [393] = {.count = 1, .reusable = true}, SHIFT(234),
  [395] = {.count = 1, .reusable = true}, SHIFT(236),
  [397] = {.count = 1, .reusable = true}, SHIFT(237),
  [399] = {.count = 1, .reusable = false}, SHIFT(239),
  [401] = {.count = 1, .reusable = false}, SHIFT(240),
  [403] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [405] = {.count = 1, .reusable = true}, SHIFT(242),
  [407] = {.count = 1, .reusable = true}, SHIFT(243),
  [409] = {.count = 1, .reusable = true}, SHIFT(244),
  [411] = {.count = 1, .reusable = false}, SHIFT(243),
  [413] = {.count = 1, .reusable = true}, SHIFT(245),
  [415] = {.count = 1, .reusable = true}, SHIFT(246),
  [417] = {.count = 1, .reusable = true}, SHIFT(247),
  [419] = {.count = 1, .reusable = false}, SHIFT(246),
  [421] = {.count = 1, .reusable = false}, SHIFT(247),
  [423] = {.count = 1, .reusable = false}, SHIFT(248),
  [425] = {.count = 1, .reusable = true}, SHIFT(231),
  [427] = {.count = 1, .reusable = true}, SHIFT(249),
  [429] = {.count = 1, .reusable = false}, SHIFT(252),
  [431] = {.count = 1, .reusable = false}, SHIFT(253),
  [433] = {.count = 1, .reusable = false}, SHIFT(256),
  [435] = {.count = 1, .reusable = true}, SHIFT(257),
  [437] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [439] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [441] = {.count = 1, .reusable = true}, SHIFT(259),
  [443] = {.count = 1, .reusable = true}, SHIFT(260),
  [445] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [447] = {.count = 1, .reusable = true}, SHIFT(262),
  [449] = {.count = 1, .reusable = false}, SHIFT(264),
  [451] = {.count = 1, .reusable = false}, SHIFT(265),
  [453] = {.count = 1, .reusable = false}, SHIFT(266),
  [455] = {.count = 1, .reusable = true}, SHIFT(267),
  [457] = {.count = 1, .reusable = false}, SHIFT(268),
  [459] = {.count = 1, .reusable = false}, SHIFT(269),
  [461] = {.count = 1, .reusable = true}, SHIFT(269),
  [463] = {.count = 1, .reusable = true}, SHIFT(270),
  [465] = {.count = 1, .reusable = true}, SHIFT(273),
  [467] = {.count = 1, .reusable = false}, SHIFT(271),
  [469] = {.count = 1, .reusable = false}, SHIFT(273),
  [471] = {.count = 1, .reusable = false}, SHIFT(272),
  [473] = {.count = 1, .reusable = true}, SHIFT(278),
  [475] = {.count = 1, .reusable = true}, SHIFT(279),
  [477] = {.count = 1, .reusable = true}, SHIFT(280),
  [479] = {.count = 1, .reusable = true}, SHIFT(282),
  [481] = {.count = 1, .reusable = true}, SHIFT(283),
  [483] = {.count = 1, .reusable = true}, SHIFT(284),
  [485] = {.count = 1, .reusable = true}, SHIFT(285),
  [487] = {.count = 1, .reusable = true}, SHIFT(287),
  [489] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2),
  [491] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2),
  [493] = {.count = 1, .reusable = true}, SHIFT(288),
  [495] = {.count = 1, .reusable = true}, SHIFT(290),
  [497] = {.count = 1, .reusable = false}, SHIFT(291),
  [499] = {.count = 1, .reusable = true}, SHIFT(292),
  [501] = {.count = 1, .reusable = true}, SHIFT(293),
  [503] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [505] = {.count = 1, .reusable = true}, SHIFT(294),
  [507] = {.count = 1, .reusable = false}, SHIFT(295),
  [509] = {.count = 1, .reusable = true}, SHIFT(80),
  [511] = {.count = 1, .reusable = false}, SHIFT(296),
  [513] = {.count = 1, .reusable = false}, SHIFT(297),
  [515] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [517] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [519] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [521] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [523] = {.count = 1, .reusable = true}, SHIFT(303),
  [525] = {.count = 1, .reusable = true}, SHIFT(304),
  [527] = {.count = 1, .reusable = true}, SHIFT(307),
  [529] = {.count = 1, .reusable = false}, SHIFT(307),
  [531] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(308),
  [534] = {.count = 1, .reusable = true}, SHIFT(309),
  [536] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2), SHIFT(194),
  [540] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [542] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(290),
  [545] = {.count = 1, .reusable = false}, SHIFT(195),
  [547] = {.count = 1, .reusable = false}, SHIFT(310),
  [549] = {.count = 1, .reusable = false}, SHIFT(311),
  [551] = {.count = 1, .reusable = false}, SHIFT(313),
  [553] = {.count = 1, .reusable = false}, SHIFT(314),
  [555] = {.count = 1, .reusable = false}, SHIFT(315),
  [557] = {.count = 1, .reusable = true}, SHIFT(316),
  [559] = {.count = 1, .reusable = false}, SHIFT(317),
  [561] = {.count = 1, .reusable = false}, SHIFT(318),
  [563] = {.count = 1, .reusable = true}, SHIFT(318),
  [565] = {.count = 1, .reusable = true}, SHIFT(319),
  [567] = {.count = 1, .reusable = true}, SHIFT(322),
  [569] = {.count = 1, .reusable = false}, SHIFT(320),
  [571] = {.count = 1, .reusable = false}, SHIFT(322),
  [573] = {.count = 1, .reusable = false}, SHIFT(321),
  [575] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [578] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [580] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [583] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .alias_sequence_id = 2), SHIFT(327),
  [586] = {.count = 1, .reusable = false}, SHIFT(328),
  [588] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), REDUCE(sym__property_name, 1, .alias_sequence_id = 2),
  [591] = {.count = 1, .reusable = true}, SHIFT(331),
  [593] = {.count = 1, .reusable = true}, SHIFT(334),
  [595] = {.count = 1, .reusable = true}, SHIFT(336),
  [597] = {.count = 1, .reusable = false}, SHIFT(337),
  [599] = {.count = 1, .reusable = false}, SHIFT(259),
  [601] = {.count = 1, .reusable = false}, SHIFT(260),
  [603] = {.count = 1, .reusable = false}, SHIFT(339),
  [605] = {.count = 1, .reusable = true}, SHIFT(342),
  [607] = {.count = 1, .reusable = false}, SHIFT(340),
  [609] = {.count = 1, .reusable = true}, SHIFT(345),
  [611] = {.count = 1, .reusable = true}, SHIFT(346),
  [613] = {.count = 1, .reusable = true}, SHIFT(347),
  [615] = {.count = 1, .reusable = true}, SHIFT(349),
  [617] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [619] = {.count = 1, .reusable = true}, SHIFT(351),
  [621] = {.count = 1, .reusable = true}, SHIFT(352),
  [623] = {.count = 1, .reusable = false}, SHIFT(353),
  [625] = {.count = 1, .reusable = false}, SHIFT(354),
  [627] = {.count = 1, .reusable = false}, SHIFT(355),
  [629] = {.count = 1, .reusable = true}, SHIFT(359),
  [631] = {.count = 1, .reusable = true}, SHIFT(360),
  [633] = {.count = 1, .reusable = false}, SHIFT(360),
  [635] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1),
  [637] = {.count = 1, .reusable = true}, SHIFT(196),
  [639] = {.count = 1, .reusable = true}, SHIFT(364),
  [641] = {.count = 1, .reusable = true}, SHIFT(365),
  [643] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .alias_sequence_id = 3),
  [645] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .alias_sequence_id = 4),
  [647] = {.count = 1, .reusable = true}, SHIFT(369),
  [649] = {.count = 1, .reusable = false}, SHIFT(371),
  [651] = {.count = 1, .reusable = true}, SHIFT(374),
  [653] = {.count = 1, .reusable = false}, SHIFT(372),
  [655] = {.count = 1, .reusable = false}, SHIFT(374),
  [657] = {.count = 1, .reusable = false}, SHIFT(373),
  [659] = {.count = 1, .reusable = false}, SHIFT(378),
  [661] = {.count = 1, .reusable = false}, SHIFT(379),
  [663] = {.count = 1, .reusable = false}, SHIFT(380),
  [665] = {.count = 1, .reusable = false}, SHIFT(381),
  [667] = {.count = 1, .reusable = false}, SHIFT(382),
  [669] = {.count = 1, .reusable = true}, SHIFT(384),
  [671] = {.count = 1, .reusable = false}, SHIFT(386),
  [673] = {.count = 1, .reusable = false}, SHIFT(387),
  [675] = {.count = 1, .reusable = false}, SHIFT(388),
  [677] = {.count = 1, .reusable = true}, SHIFT(392),
  [679] = {.count = 1, .reusable = true}, SHIFT(393),
  [681] = {.count = 1, .reusable = false}, SHIFT(394),
  [683] = {.count = 1, .reusable = false}, SHIFT(395),
  [685] = {.count = 1, .reusable = false}, SHIFT(396),
  [687] = {.count = 1, .reusable = true}, SHIFT(400),
  [689] = {.count = 1, .reusable = false}, SHIFT(400),
  [691] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [693] = {.count = 1, .reusable = true}, SHIFT(402),
  [695] = {.count = 1, .reusable = false}, SHIFT(402),
  [697] = {.count = 1, .reusable = false}, SHIFT(108),
  [699] = {.count = 1, .reusable = true}, SHIFT(403),
  [701] = {.count = 1, .reusable = false}, SHIFT(403),
  [703] = {.count = 1, .reusable = true}, SHIFT(404),
  [705] = {.count = 1, .reusable = true}, SHIFT(405),
  [707] = {.count = 1, .reusable = false}, SHIFT(405),
  [709] = {.count = 1, .reusable = true}, SHIFT(408),
  [711] = {.count = 1, .reusable = true}, SHIFT(409),
  [713] = {.count = 1, .reusable = false}, SHIFT(410),
  [715] = {.count = 1, .reusable = true}, SHIFT(413),
  [717] = {.count = 1, .reusable = true}, SHIFT(414),
  [719] = {.count = 1, .reusable = false}, SHIFT(415),
  [721] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(418),
  [724] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1), SHIFT(419),
  [727] = {.count = 1, .reusable = true}, SHIFT(420),
  [729] = {.count = 1, .reusable = false}, SHIFT(421),
  [731] = {.count = 1, .reusable = false}, SHIFT(422),
  [733] = {.count = 1, .reusable = true}, SHIFT(423),
  [735] = {.count = 1, .reusable = true}, SHIFT(424),
  [737] = {.count = 1, .reusable = false}, SHIFT(425),
  [739] = {.count = 1, .reusable = true}, SHIFT(428),
  [741] = {.count = 1, .reusable = true}, SHIFT(429),
  [743] = {.count = 1, .reusable = true}, SHIFT(431),
  [745] = {.count = 1, .reusable = true}, SHIFT(433),
  [747] = {.count = 1, .reusable = false}, SHIFT(433),
  [749] = {.count = 1, .reusable = false}, SHIFT(434),
  [751] = {.count = 1, .reusable = false}, SHIFT(435),
  [753] = {.count = 1, .reusable = true}, SHIFT(436),
  [755] = {.count = 1, .reusable = false}, SHIFT(437),
  [757] = {.count = 1, .reusable = false}, SHIFT(436),
  [759] = {.count = 1, .reusable = false}, SHIFT(438),
  [761] = {.count = 1, .reusable = true}, SHIFT(444),
  [763] = {.count = 1, .reusable = true}, SHIFT(445),
  [765] = {.count = 1, .reusable = false}, SHIFT(445),
  [767] = {.count = 1, .reusable = true}, SHIFT(446),
  [769] = {.count = 1, .reusable = false}, SHIFT(446),
  [771] = {.count = 1, .reusable = false}, SHIFT(447),
  [773] = {.count = 1, .reusable = true}, SHIFT(448),
  [775] = {.count = 1, .reusable = true}, SHIFT(449),
  [777] = {.count = 1, .reusable = true}, SHIFT(451),
  [779] = {.count = 1, .reusable = true}, SHIFT(450),
  [781] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(418),
  [784] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(452),
  [787] = {.count = 1, .reusable = false}, SHIFT(453),
  [789] = {.count = 1, .reusable = true}, SHIFT(454),
  [791] = {.count = 1, .reusable = true}, SHIFT(455),
  [793] = {.count = 1, .reusable = true}, SHIFT(458),
  [795] = {.count = 1, .reusable = true}, SHIFT(459),
  [797] = {.count = 1, .reusable = true}, SHIFT(461),
  [799] = {.count = 1, .reusable = true}, SHIFT(462),
  [801] = {.count = 1, .reusable = true}, SHIFT(463),
  [803] = {.count = 1, .reusable = false}, SHIFT(461),
  [805] = {.count = 1, .reusable = true}, SHIFT(464),
  [807] = {.count = 1, .reusable = true}, SHIFT(465),
  [809] = {.count = 1, .reusable = true}, SHIFT(466),
  [811] = {.count = 1, .reusable = false}, SHIFT(465),
  [813] = {.count = 1, .reusable = false}, SHIFT(466),
  [815] = {.count = 1, .reusable = false}, SHIFT(467),
  [817] = {.count = 1, .reusable = true}, SHIFT(453),
  [819] = {.count = 1, .reusable = true}, SHIFT(468),
  [821] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(469),
  [824] = {.count = 1, .reusable = true}, SHIFT(418),
  [826] = {.count = 1, .reusable = true}, SHIFT(452),
  [828] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(472),
  [831] = {.count = 1, .reusable = false}, SHIFT(475),
  [833] = {.count = 1, .reusable = false}, SHIFT(477),
  [835] = {.count = 1, .reusable = true}, SHIFT(479),
  [837] = {.count = 1, .reusable = true}, SHIFT(480),
  [839] = {.count = 1, .reusable = false}, SHIFT(481),
  [841] = {.count = 1, .reusable = false}, SHIFT(482),
  [843] = {.count = 1, .reusable = false}, SHIFT(483),
  [845] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [847] = {.count = 1, .reusable = true}, SHIFT(486),
  [849] = {.count = 1, .reusable = true}, SHIFT(487),
  [851] = {.count = 1, .reusable = true}, SHIFT(29),
  [853] = {.count = 1, .reusable = true}, SHIFT(490),
  [855] = {.count = 1, .reusable = true}, SHIFT(491),
  [857] = {.count = 1, .reusable = true}, SHIFT(494),
  [859] = {.count = 1, .reusable = true}, SHIFT(495),
  [861] = {.count = 1, .reusable = true}, SHIFT(496),
  [863] = {.count = 1, .reusable = true}, SHIFT(497),
  [865] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2),
  [867] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2),
  [869] = {.count = 1, .reusable = false}, SHIFT(498),
  [871] = {.count = 1, .reusable = false}, SHIFT(499),
  [873] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [875] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [877] = {.count = 1, .reusable = true}, SHIFT(503),
  [879] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [881] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [883] = {.count = 1, .reusable = true}, SHIFT(504),
  [885] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [887] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [889] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [891] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [893] = {.count = 1, .reusable = true}, SHIFT(505),
  [895] = {.count = 1, .reusable = true}, SHIFT(506),
  [897] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [899] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [901] = {.count = 1, .reusable = true}, SHIFT(507),
  [903] = {.count = 1, .reusable = false}, SHIFT(507),
  [905] = {.count = 1, .reusable = true}, SHIFT(509),
  [907] = {.count = 1, .reusable = false}, SHIFT(509),
  [909] = {.count = 1, .reusable = true}, SHIFT(510),
  [911] = {.count = 1, .reusable = false}, SHIFT(510),
  [913] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [915] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [917] = {.count = 1, .reusable = false}, SHIFT(511),
  [919] = {.count = 1, .reusable = true}, SHIFT(512),
  [921] = {.count = 1, .reusable = true}, SHIFT(513),
  [923] = {.count = 1, .reusable = false}, SHIFT(514),
  [925] = {.count = 1, .reusable = true}, SHIFT(515),
  [927] = {.count = 1, .reusable = false}, SHIFT(515),
  [929] = {.count = 1, .reusable = false}, SHIFT(516),
  [931] = {.count = 1, .reusable = false}, SHIFT(517),
  [933] = {.count = 1, .reusable = true}, SHIFT(518),
  [935] = {.count = 1, .reusable = false}, SHIFT(518),
  [937] = {.count = 1, .reusable = false}, SHIFT(519),
  [939] = {.count = 1, .reusable = true}, SHIFT(520),
  [941] = {.count = 1, .reusable = true}, SHIFT(521),
  [943] = {.count = 1, .reusable = true}, SHIFT(522),
  [945] = {.count = 1, .reusable = false}, SHIFT(521),
  [947] = {.count = 1, .reusable = true}, SHIFT(523),
  [949] = {.count = 1, .reusable = true}, SHIFT(524),
  [951] = {.count = 1, .reusable = true}, SHIFT(525),
  [953] = {.count = 1, .reusable = false}, SHIFT(524),
  [955] = {.count = 1, .reusable = false}, SHIFT(525),
  [957] = {.count = 1, .reusable = false}, SHIFT(526),
  [959] = {.count = 1, .reusable = true}, SHIFT(519),
  [961] = {.count = 1, .reusable = false}, SHIFT(531),
  [963] = {.count = 1, .reusable = false}, SHIFT(532),
  [965] = {.count = 1, .reusable = true}, SHIFT(533),
  [967] = {.count = 1, .reusable = true}, SHIFT(534),
  [969] = {.count = 1, .reusable = true}, SHIFT(535),
  [971] = {.count = 1, .reusable = false}, SHIFT(536),
  [973] = {.count = 1, .reusable = true}, SHIFT(537),
  [975] = {.count = 1, .reusable = false}, SHIFT(537),
  [977] = {.count = 1, .reusable = true}, SHIFT(540),
  [979] = {.count = 1, .reusable = false}, SHIFT(541),
  [981] = {.count = 1, .reusable = true}, SHIFT(542),
  [983] = {.count = 1, .reusable = true}, SHIFT(543),
  [985] = {.count = 1, .reusable = false}, SHIFT(544),
  [987] = {.count = 1, .reusable = true}, SHIFT(545),
  [989] = {.count = 1, .reusable = true}, SHIFT(546),
  [991] = {.count = 1, .reusable = true}, SHIFT(552),
  [993] = {.count = 1, .reusable = false}, SHIFT(547),
  [995] = {.count = 1, .reusable = false}, SHIFT(548),
  [997] = {.count = 1, .reusable = false}, SHIFT(549),
  [999] = {.count = 1, .reusable = false}, SHIFT(555),
  [1001] = {.count = 1, .reusable = false}, SHIFT(556),
  [1003] = {.count = 1, .reusable = false}, SHIFT(557),
  [1005] = {.count = 1, .reusable = true}, SHIFT(558),
  [1007] = {.count = 1, .reusable = false}, SHIFT(559),
  [1009] = {.count = 1, .reusable = false}, SHIFT(560),
  [1011] = {.count = 1, .reusable = true}, SHIFT(560),
  [1013] = {.count = 1, .reusable = true}, SHIFT(561),
  [1015] = {.count = 1, .reusable = true}, SHIFT(564),
  [1017] = {.count = 1, .reusable = false}, SHIFT(562),
  [1019] = {.count = 1, .reusable = false}, SHIFT(564),
  [1021] = {.count = 1, .reusable = false}, SHIFT(563),
  [1023] = {.count = 1, .reusable = true}, SHIFT(190),
  [1025] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 2),
  [1027] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 2),
  [1029] = {.count = 1, .reusable = true}, SHIFT(572),
  [1031] = {.count = 1, .reusable = false}, SHIFT(573),
  [1033] = {.count = 1, .reusable = false}, SHIFT(574),
  [1035] = {.count = 1, .reusable = true}, SHIFT(577),
  [1037] = {.count = 1, .reusable = true}, SHIFT(578),
  [1039] = {.count = 1, .reusable = false}, SHIFT(578),
  [1041] = {.count = 1, .reusable = true}, SHIFT(579),
  [1043] = {.count = 1, .reusable = true}, SHIFT(582),
  [1045] = {.count = 1, .reusable = false}, SHIFT(582),
  [1047] = {.count = 1, .reusable = true}, SHIFT(583),
  [1049] = {.count = 1, .reusable = false}, SHIFT(583),
  [1051] = {.count = 1, .reusable = true}, SHIFT(584),
  [1053] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 1),
  [1055] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 1),
  [1057] = {.count = 1, .reusable = true}, SHIFT(585),
  [1059] = {.count = 1, .reusable = true}, SHIFT(587),
  [1061] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 2),
  [1063] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 2),
  [1065] = {.count = 1, .reusable = false}, SHIFT(590),
  [1067] = {.count = 1, .reusable = true}, SHIFT(591),
  [1069] = {.count = 1, .reusable = false}, SHIFT(592),
  [1071] = {.count = 1, .reusable = true}, SHIFT(439),
  [1073] = {.count = 1, .reusable = false}, SHIFT(593),
  [1075] = {.count = 1, .reusable = false}, SHIFT(439),
  [1077] = {.count = 1, .reusable = false}, SHIFT(594),
  [1079] = {.count = 1, .reusable = true}, SHIFT(599),
  [1081] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .alias_sequence_id = 5),
  [1083] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .alias_sequence_id = 5),
  [1085] = {.count = 1, .reusable = false}, SHIFT(601),
  [1087] = {.count = 1, .reusable = true}, SHIFT(602),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2),
  [1093] = {.count = 1, .reusable = true}, SHIFT(606),
  [1095] = {.count = 1, .reusable = false}, SHIFT(605),
  [1097] = {.count = 1, .reusable = false}, SHIFT(606),
  [1099] = {.count = 1, .reusable = true}, SHIFT(607),
  [1101] = {.count = 1, .reusable = true}, SHIFT(608),
  [1103] = {.count = 1, .reusable = true}, SHIFT(609),
  [1105] = {.count = 1, .reusable = false}, SHIFT(608),
  [1107] = {.count = 1, .reusable = false}, SHIFT(609),
  [1109] = {.count = 1, .reusable = false}, SHIFT(610),
  [1111] = {.count = 1, .reusable = true}, SHIFT(605),
  [1113] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1115] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [1117] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2),
  [1119] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2),
  [1121] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1123] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1125] = {.count = 1, .reusable = false}, SHIFT(611),
  [1127] = {.count = 1, .reusable = true}, SHIFT(612),
  [1129] = {.count = 1, .reusable = true}, SHIFT(613),
  [1131] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [1133] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [1135] = {.count = 1, .reusable = true}, SHIFT(614),
  [1137] = {.count = 1, .reusable = false}, SHIFT(614),
  [1139] = {.count = 1, .reusable = true}, SHIFT(617),
  [1141] = {.count = 1, .reusable = true}, SHIFT(616),
  [1143] = {.count = 1, .reusable = true}, SHIFT(618),
  [1145] = {.count = 1, .reusable = false}, SHIFT(618),
  [1147] = {.count = 1, .reusable = true}, SHIFT(620),
  [1149] = {.count = 1, .reusable = true}, SHIFT(621),
  [1151] = {.count = 1, .reusable = false}, SHIFT(621),
  [1153] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2),
  [1155] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2),
  [1157] = {.count = 1, .reusable = true}, SHIFT(622),
  [1159] = {.count = 1, .reusable = true}, SHIFT(623),
  [1161] = {.count = 1, .reusable = true}, SHIFT(624),
  [1163] = {.count = 1, .reusable = true}, SHIFT(625),
  [1165] = {.count = 1, .reusable = false}, SHIFT(625),
  [1167] = {.count = 1, .reusable = true}, SHIFT(628),
  [1169] = {.count = 1, .reusable = false}, SHIFT(628),
  [1171] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [1173] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [1175] = {.count = 1, .reusable = false}, REDUCE(sym__identifier_reference, 1, .alias_sequence_id = 1),
  [1177] = {.count = 1, .reusable = true}, REDUCE(sym__identifier_reference, 1, .alias_sequence_id = 1),
  [1179] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [1181] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [1183] = {.count = 1, .reusable = false}, SHIFT(630),
  [1185] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1187] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1189] = {.count = 1, .reusable = true}, SHIFT(632),
  [1191] = {.count = 1, .reusable = false}, SHIFT(632),
  [1193] = {.count = 1, .reusable = true}, SHIFT(633),
  [1195] = {.count = 1, .reusable = false}, SHIFT(633),
  [1197] = {.count = 1, .reusable = false}, SHIFT(635),
  [1199] = {.count = 1, .reusable = false}, SHIFT(636),
  [1201] = {.count = 1, .reusable = false}, SHIFT(637),
  [1203] = {.count = 1, .reusable = true}, SHIFT(638),
  [1205] = {.count = 1, .reusable = false}, SHIFT(639),
  [1207] = {.count = 1, .reusable = false}, SHIFT(640),
  [1209] = {.count = 1, .reusable = true}, SHIFT(640),
  [1211] = {.count = 1, .reusable = true}, SHIFT(641),
  [1213] = {.count = 1, .reusable = true}, SHIFT(644),
  [1215] = {.count = 1, .reusable = false}, SHIFT(642),
  [1217] = {.count = 1, .reusable = false}, SHIFT(644),
  [1219] = {.count = 1, .reusable = false}, SHIFT(643),
  [1221] = {.count = 1, .reusable = true}, SHIFT(649),
  [1223] = {.count = 1, .reusable = false}, SHIFT(649),
  [1225] = {.count = 1, .reusable = true}, SHIFT(650),
  [1227] = {.count = 1, .reusable = false}, SHIFT(650),
  [1229] = {.count = 1, .reusable = true}, SHIFT(651),
  [1231] = {.count = 1, .reusable = false}, SHIFT(651),
  [1233] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3),
  [1235] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3),
  [1237] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4),
  [1239] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4),
  [1241] = {.count = 1, .reusable = true}, SHIFT(652),
  [1243] = {.count = 1, .reusable = true}, SHIFT(653),
  [1245] = {.count = 1, .reusable = true}, SHIFT(654),
  [1247] = {.count = 1, .reusable = false}, SHIFT(654),
  [1249] = {.count = 1, .reusable = false}, SHIFT(656),
  [1251] = {.count = 1, .reusable = true}, SHIFT(657),
  [1253] = {.count = 1, .reusable = false}, SHIFT(658),
  [1255] = {.count = 1, .reusable = false}, SHIFT(661),
  [1257] = {.count = 1, .reusable = false}, SHIFT(663),
  [1259] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 2),
  [1261] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 2),
  [1263] = {.count = 1, .reusable = false}, SHIFT(665),
  [1265] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 2),
  [1267] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 2),
  [1269] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [1271] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [1274] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [1277] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [1280] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [1283] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [1286] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [1289] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [1292] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [1295] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [1298] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [1301] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [1304] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1307] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1310] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [1313] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [1316] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1319] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1322] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1325] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1331] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [1334] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [1337] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(25),
  [1340] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(26),
  [1343] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(27),
  [1346] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(28),
  [1349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(29),
  [1352] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(30),
  [1355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(31),
  [1358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(32),
  [1361] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(32),
  [1364] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(33),
  [1367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(34),
  [1370] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(35),
  [1373] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(36),
  [1376] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(42),
  [1379] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(37),
  [1382] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(42),
  [1385] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(38),
  [1388] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(39),
  [1391] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(40),
  [1394] = {.count = 1, .reusable = true}, SHIFT(666),
  [1396] = {.count = 1, .reusable = false}, SHIFT(667),
  [1398] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [1400] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(39),
  [1403] = {.count = 1, .reusable = true}, SHIFT(670),
  [1405] = {.count = 1, .reusable = true}, SHIFT(671),
  [1407] = {.count = 1, .reusable = false}, SHIFT(671),
  [1409] = {.count = 1, .reusable = true}, SHIFT(672),
  [1411] = {.count = 1, .reusable = false}, SHIFT(672),
  [1413] = {.count = 1, .reusable = false}, SHIFT(673),
  [1415] = {.count = 1, .reusable = true}, SHIFT(674),
  [1417] = {.count = 1, .reusable = true}, SHIFT(675),
  [1419] = {.count = 1, .reusable = false}, SHIFT(676),
  [1421] = {.count = 1, .reusable = true}, SHIFT(677),
  [1423] = {.count = 1, .reusable = false}, SHIFT(677),
  [1425] = {.count = 1, .reusable = false}, SHIFT(678),
  [1427] = {.count = 1, .reusable = false}, SHIFT(679),
  [1429] = {.count = 1, .reusable = false}, SHIFT(680),
  [1431] = {.count = 1, .reusable = true}, SHIFT(681),
  [1433] = {.count = 1, .reusable = true}, SHIFT(682),
  [1435] = {.count = 1, .reusable = false}, SHIFT(682),
  [1437] = {.count = 1, .reusable = true}, SHIFT(683),
  [1439] = {.count = 1, .reusable = true}, SHIFT(684),
  [1441] = {.count = 1, .reusable = true}, SHIFT(685),
  [1443] = {.count = 1, .reusable = false}, SHIFT(684),
  [1445] = {.count = 1, .reusable = false}, SHIFT(685),
  [1447] = {.count = 1, .reusable = false}, SHIFT(686),
  [1449] = {.count = 1, .reusable = true}, SHIFT(680),
  [1451] = {.count = 1, .reusable = true}, SHIFT(687),
  [1453] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [1455] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1),
  [1457] = {.count = 1, .reusable = true}, SHIFT(688),
  [1459] = {.count = 1, .reusable = true}, SHIFT(689),
  [1461] = {.count = 1, .reusable = true}, SHIFT(690),
  [1463] = {.count = 1, .reusable = true}, SHIFT(692),
  [1465] = {.count = 1, .reusable = true}, SHIFT(695),
  [1467] = {.count = 1, .reusable = true}, SHIFT(697),
  [1469] = {.count = 1, .reusable = true}, SHIFT(699),
  [1471] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [1473] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [1475] = {.count = 1, .reusable = true}, SHIFT(701),
  [1477] = {.count = 1, .reusable = false}, SHIFT(702),
  [1479] = {.count = 1, .reusable = false}, SHIFT(703),
  [1481] = {.count = 1, .reusable = false}, SHIFT(704),
  [1483] = {.count = 1, .reusable = true}, SHIFT(705),
  [1485] = {.count = 1, .reusable = false}, SHIFT(706),
  [1487] = {.count = 1, .reusable = false}, SHIFT(707),
  [1489] = {.count = 1, .reusable = true}, SHIFT(707),
  [1491] = {.count = 1, .reusable = true}, SHIFT(708),
  [1493] = {.count = 1, .reusable = true}, SHIFT(711),
  [1495] = {.count = 1, .reusable = false}, SHIFT(709),
  [1497] = {.count = 1, .reusable = false}, SHIFT(711),
  [1499] = {.count = 1, .reusable = false}, SHIFT(710),
  [1501] = {.count = 1, .reusable = true}, SHIFT(717),
  [1503] = {.count = 1, .reusable = false}, SHIFT(718),
  [1505] = {.count = 1, .reusable = false}, SHIFT(719),
  [1507] = {.count = 1, .reusable = false}, SHIFT(720),
  [1509] = {.count = 1, .reusable = true}, SHIFT(724),
  [1511] = {.count = 1, .reusable = true}, SHIFT(725),
  [1513] = {.count = 1, .reusable = false}, SHIFT(725),
  [1515] = {.count = 1, .reusable = true}, SHIFT(308),
  [1517] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .alias_sequence_id = 6),
  [1519] = {.count = 1, .reusable = true}, SHIFT(728),
  [1521] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [1523] = {.count = 1, .reusable = false}, SHIFT(734),
  [1525] = {.count = 1, .reusable = false}, SHIFT(735),
  [1527] = {.count = 1, .reusable = false}, SHIFT(736),
  [1529] = {.count = 1, .reusable = false}, SHIFT(737),
  [1531] = {.count = 1, .reusable = false}, SHIFT(738),
  [1533] = {.count = 1, .reusable = false}, SHIFT(740),
  [1535] = {.count = 1, .reusable = false}, SHIFT(741),
  [1537] = {.count = 1, .reusable = false}, SHIFT(742),
  [1539] = {.count = 1, .reusable = true}, SHIFT(746),
  [1541] = {.count = 1, .reusable = true}, SHIFT(747),
  [1543] = {.count = 1, .reusable = true}, SHIFT(748),
  [1545] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .alias_sequence_id = 6),
  [1547] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .alias_sequence_id = 6),
  [1549] = {.count = 1, .reusable = true}, SHIFT(749),
  [1551] = {.count = 1, .reusable = true}, SHIFT(750),
  [1553] = {.count = 1, .reusable = false}, SHIFT(750),
  [1555] = {.count = 1, .reusable = true}, SHIFT(751),
  [1557] = {.count = 1, .reusable = false}, SHIFT(751),
  [1559] = {.count = 1, .reusable = false}, SHIFT(728),
  [1561] = {.count = 1, .reusable = true}, SHIFT(752),
  [1563] = {.count = 1, .reusable = true}, SHIFT(753),
  [1565] = {.count = 1, .reusable = false}, SHIFT(754),
  [1567] = {.count = 1, .reusable = true}, SHIFT(755),
  [1569] = {.count = 1, .reusable = false}, SHIFT(755),
  [1571] = {.count = 1, .reusable = false}, SHIFT(756),
  [1573] = {.count = 1, .reusable = false}, SHIFT(757),
  [1575] = {.count = 1, .reusable = false}, SHIFT(758),
  [1577] = {.count = 1, .reusable = true}, SHIFT(759),
  [1579] = {.count = 1, .reusable = true}, SHIFT(760),
  [1581] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [1583] = {.count = 1, .reusable = false}, SHIFT(760),
  [1585] = {.count = 1, .reusable = true}, SHIFT(761),
  [1587] = {.count = 1, .reusable = true}, SHIFT(762),
  [1589] = {.count = 1, .reusable = true}, SHIFT(763),
  [1591] = {.count = 1, .reusable = false}, SHIFT(762),
  [1593] = {.count = 1, .reusable = false}, SHIFT(763),
  [1595] = {.count = 1, .reusable = false}, SHIFT(764),
  [1597] = {.count = 1, .reusable = true}, SHIFT(758),
  [1599] = {.count = 1, .reusable = false}, SHIFT(765),
  [1601] = {.count = 1, .reusable = false}, SHIFT(766),
  [1603] = {.count = 1, .reusable = false}, SHIFT(767),
  [1605] = {.count = 1, .reusable = true}, SHIFT(768),
  [1607] = {.count = 1, .reusable = false}, SHIFT(769),
  [1609] = {.count = 1, .reusable = false}, SHIFT(770),
  [1611] = {.count = 1, .reusable = true}, SHIFT(770),
  [1613] = {.count = 1, .reusable = true}, SHIFT(771),
  [1615] = {.count = 1, .reusable = true}, SHIFT(774),
  [1617] = {.count = 1, .reusable = false}, SHIFT(772),
  [1619] = {.count = 1, .reusable = false}, SHIFT(774),
  [1621] = {.count = 1, .reusable = false}, SHIFT(773),
  [1623] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 7), REDUCE(sym_assignment_expression, 2),
  [1626] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 7),
  [1628] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 3), REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 3),
  [1631] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 3),
  [1633] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [1635] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [1637] = {.count = 1, .reusable = true}, SHIFT(779),
  [1639] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 4), REDUCE(sym_assignment_expression, 2, .alias_sequence_id = 4),
  [1642] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .alias_sequence_id = 4),
  [1644] = {.count = 1, .reusable = true}, SHIFT(780),
  [1646] = {.count = 1, .reusable = false}, SHIFT(780),
  [1648] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [1650] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [1652] = {.count = 1, .reusable = true}, SHIFT(327),
  [1654] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(67),
  [1657] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(68),
  [1660] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(69),
  [1663] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(70),
  [1666] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(337),
  [1669] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [1671] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(65),
  [1674] = {.count = 1, .reusable = true}, SHIFT(783),
  [1676] = {.count = 1, .reusable = true}, SHIFT(784),
  [1678] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [1680] = {.count = 1, .reusable = true}, SHIFT(785),
  [1682] = {.count = 1, .reusable = true}, SHIFT(786),
  [1684] = {.count = 1, .reusable = true}, SHIFT(789),
  [1686] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [1688] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [1690] = {.count = 1, .reusable = true}, SHIFT(790),
  [1692] = {.count = 1, .reusable = true}, SHIFT(792),
  [1694] = {.count = 1, .reusable = true}, SHIFT(795),
  [1696] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2),
  [1698] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [1700] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [1702] = {.count = 1, .reusable = true}, SHIFT(798),
  [1704] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .alias_sequence_id = 3),
  [1706] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .alias_sequence_id = 4),
  [1708] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [1710] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [1712] = {.count = 1, .reusable = true}, SHIFT(800),
  [1714] = {.count = 1, .reusable = true}, SHIFT(801),
  [1716] = {.count = 1, .reusable = true}, SHIFT(803),
  [1718] = {.count = 1, .reusable = true}, SHIFT(804),
  [1720] = {.count = 1, .reusable = true}, SHIFT(807),
  [1722] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3),
  [1724] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3),
  [1726] = {.count = 1, .reusable = false}, SHIFT(808),
  [1728] = {.count = 1, .reusable = true}, SHIFT(809),
  [1730] = {.count = 1, .reusable = true}, SHIFT(810),
  [1732] = {.count = 1, .reusable = true}, SHIFT(811),
  [1734] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3),
  [1736] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3),
  [1738] = {.count = 1, .reusable = true}, SHIFT(813),
  [1740] = {.count = 1, .reusable = false}, SHIFT(816),
  [1742] = {.count = 1, .reusable = true}, SHIFT(817),
  [1744] = {.count = 1, .reusable = false}, SHIFT(819),
  [1746] = {.count = 1, .reusable = true}, SHIFT(820),
  [1748] = {.count = 1, .reusable = false}, SHIFT(821),
  [1750] = {.count = 1, .reusable = true}, SHIFT(822),
  [1752] = {.count = 1, .reusable = false}, SHIFT(823),
  [1754] = {.count = 1, .reusable = false}, SHIFT(824),
  [1756] = {.count = 1, .reusable = true}, SHIFT(827),
  [1758] = {.count = 1, .reusable = true}, SHIFT(829),
  [1760] = {.count = 1, .reusable = true}, SHIFT(832),
  [1762] = {.count = 1, .reusable = true}, SHIFT(833),
  [1764] = {.count = 1, .reusable = false}, SHIFT(835),
  [1766] = {.count = 1, .reusable = false}, SHIFT(836),
  [1768] = {.count = 1, .reusable = false}, SHIFT(837),
  [1770] = {.count = 1, .reusable = false}, SHIFT(839),
  [1772] = {.count = 1, .reusable = true}, SHIFT(840),
  [1774] = {.count = 1, .reusable = false}, SHIFT(845),
  [1776] = {.count = 1, .reusable = false}, SHIFT(846),
  [1778] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3, .alias_sequence_id = 5),
  [1780] = {.count = 1, .reusable = true}, SHIFT(850),
  [1782] = {.count = 1, .reusable = true}, SHIFT(851),
  [1784] = {.count = 1, .reusable = false}, SHIFT(851),
  [1786] = {.count = 1, .reusable = true}, SHIFT(852),
  [1788] = {.count = 1, .reusable = true}, SHIFT(855),
  [1790] = {.count = 1, .reusable = false}, SHIFT(855),
  [1792] = {.count = 1, .reusable = true}, SHIFT(856),
  [1794] = {.count = 1, .reusable = false}, SHIFT(856),
  [1796] = {.count = 1, .reusable = true}, SHIFT(857),
  [1798] = {.count = 1, .reusable = true}, SHIFT(858),
  [1800] = {.count = 1, .reusable = true}, SHIFT(860),
  [1802] = {.count = 1, .reusable = true}, SHIFT(862),
  [1804] = {.count = 1, .reusable = false}, SHIFT(864),
  [1806] = {.count = 1, .reusable = false}, SHIFT(865),
  [1808] = {.count = 1, .reusable = false}, SHIFT(866),
  [1810] = {.count = 1, .reusable = true}, SHIFT(869),
  [1812] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [1814] = {.count = 1, .reusable = false}, SHIFT(873),
  [1816] = {.count = 1, .reusable = true}, SHIFT(874),
  [1818] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [1820] = {.count = 1, .reusable = true}, SHIFT(875),
  [1822] = {.count = 1, .reusable = false}, SHIFT(875),
  [1824] = {.count = 1, .reusable = true}, SHIFT(876),
  [1826] = {.count = 1, .reusable = true}, SHIFT(877),
  [1828] = {.count = 1, .reusable = false}, SHIFT(877),
  [1830] = {.count = 1, .reusable = true}, SHIFT(878),
  [1832] = {.count = 1, .reusable = true}, SHIFT(879),
  [1834] = {.count = 1, .reusable = true}, SHIFT(880),
  [1836] = {.count = 1, .reusable = false}, SHIFT(880),
  [1838] = {.count = 1, .reusable = true}, SHIFT(883),
  [1840] = {.count = 1, .reusable = false}, SHIFT(883),
  [1842] = {.count = 1, .reusable = true}, SHIFT(885),
  [1844] = {.count = 1, .reusable = false}, SHIFT(885),
  [1846] = {.count = 1, .reusable = true}, SHIFT(886),
  [1848] = {.count = 1, .reusable = false}, SHIFT(886),
  [1850] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [1852] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [1854] = {.count = 1, .reusable = true}, SHIFT(888),
  [1856] = {.count = 1, .reusable = false}, SHIFT(888),
  [1858] = {.count = 1, .reusable = true}, SHIFT(889),
  [1860] = {.count = 1, .reusable = false}, SHIFT(889),
  [1862] = {.count = 1, .reusable = true}, SHIFT(890),
  [1864] = {.count = 1, .reusable = false}, SHIFT(890),
  [1866] = {.count = 1, .reusable = true}, SHIFT(891),
  [1868] = {.count = 1, .reusable = false}, SHIFT(891),
  [1870] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3, .alias_sequence_id = 8),
  [1872] = {.count = 1, .reusable = true}, SHIFT(892),
  [1874] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3, .alias_sequence_id = 9),
  [1876] = {.count = 1, .reusable = true}, SHIFT(893),
  [1878] = {.count = 1, .reusable = false}, SHIFT(894),
  [1880] = {.count = 1, .reusable = false}, SHIFT(896),
  [1882] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1884] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1886] = {.count = 1, .reusable = true}, SHIFT(191),
  [1888] = {.count = 1, .reusable = true}, SHIFT(197),
  [1890] = {.count = 1, .reusable = true}, SHIFT(898),
  [1892] = {.count = 1, .reusable = false}, SHIFT(899),
  [1894] = {.count = 1, .reusable = false}, SHIFT(900),
  [1896] = {.count = 1, .reusable = false}, SHIFT(901),
  [1898] = {.count = 1, .reusable = false}, SHIFT(902),
  [1900] = {.count = 1, .reusable = false}, SHIFT(903),
  [1902] = {.count = 1, .reusable = false}, SHIFT(905),
  [1904] = {.count = 1, .reusable = false}, SHIFT(906),
  [1906] = {.count = 1, .reusable = false}, SHIFT(907),
  [1908] = {.count = 1, .reusable = true}, SHIFT(911),
  [1910] = {.count = 1, .reusable = true}, SHIFT(912),
  [1912] = {.count = 1, .reusable = true}, SHIFT(914),
  [1914] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3),
  [1916] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3),
  [1918] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3),
  [1920] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3),
  [1922] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .alias_sequence_id = 10),
  [1924] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .alias_sequence_id = 10),
  [1926] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .alias_sequence_id = 10),
  [1928] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .alias_sequence_id = 10),
  [1930] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [1932] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [1934] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [1936] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [1938] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [1940] = {.count = 1, .reusable = true}, SHIFT(918),
  [1942] = {.count = 1, .reusable = false}, SHIFT(918),
  [1944] = {.count = 1, .reusable = true}, SHIFT(919),
  [1946] = {.count = 1, .reusable = false}, SHIFT(919),
  [1948] = {.count = 1, .reusable = true}, SHIFT(920),
  [1950] = {.count = 1, .reusable = false}, SHIFT(920),
  [1952] = {.count = 1, .reusable = true}, SHIFT(921),
  [1954] = {.count = 1, .reusable = true}, SHIFT(922),
  [1956] = {.count = 1, .reusable = false}, SHIFT(922),
  [1958] = {.count = 1, .reusable = true}, SHIFT(923),
  [1960] = {.count = 1, .reusable = false}, SHIFT(923),
  [1962] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [1964] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [1966] = {.count = 1, .reusable = true}, SHIFT(924),
  [1968] = {.count = 1, .reusable = false}, SHIFT(924),
  [1970] = {.count = 1, .reusable = true}, SHIFT(925),
  [1972] = {.count = 1, .reusable = false}, SHIFT(925),
  [1974] = {.count = 1, .reusable = true}, SHIFT(926),
  [1976] = {.count = 1, .reusable = false}, SHIFT(926),
  [1978] = {.count = 1, .reusable = true}, SHIFT(927),
  [1980] = {.count = 1, .reusable = false}, SHIFT(927),
  [1982] = {.count = 1, .reusable = true}, SHIFT(928),
  [1984] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(164),
  [1987] = {.count = 1, .reusable = false}, SHIFT(929),
  [1989] = {.count = 1, .reusable = false}, SHIFT(930),
  [1991] = {.count = 1, .reusable = true}, SHIFT(931),
  [1993] = {.count = 1, .reusable = true}, SHIFT(932),
  [1995] = {.count = 1, .reusable = false}, SHIFT(932),
  [1997] = {.count = 1, .reusable = true}, SHIFT(934),
  [1999] = {.count = 1, .reusable = false}, SHIFT(934),
  [2001] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1),
  [2003] = {.count = 1, .reusable = true}, SHIFT(935),
  [2005] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1, .alias_sequence_id = 2),
  [2007] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1, .alias_sequence_id = 2),
  [2009] = {.count = 1, .reusable = true}, SHIFT(936),
  [2011] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 1),
  [2013] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 1),
  [2015] = {.count = 1, .reusable = true}, SHIFT(937),
  [2017] = {.count = 1, .reusable = true}, SHIFT(938),
  [2019] = {.count = 1, .reusable = false}, SHIFT(939),
  [2021] = {.count = 1, .reusable = true}, SHIFT(941),
  [2023] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3),
  [2025] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3),
  [2027] = {.count = 1, .reusable = false}, SHIFT(942),
  [2029] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [2031] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [2033] = {.count = 1, .reusable = true}, SHIFT(943),
  [2035] = {.count = 1, .reusable = false}, SHIFT(943),
  [2037] = {.count = 1, .reusable = false}, SHIFT(944),
  [2039] = {.count = 1, .reusable = true}, SHIFT(945),
  [2041] = {.count = 1, .reusable = true}, SHIFT(946),
  [2043] = {.count = 1, .reusable = true}, SHIFT(949),
  [2045] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2047] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2049] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1),
  [2051] = {.count = 1, .reusable = true}, SHIFT(673),
  [2053] = {.count = 1, .reusable = false}, SHIFT(951),
  [2055] = {.count = 1, .reusable = true}, SHIFT(953),
  [2057] = {.count = 1, .reusable = true}, SHIFT(955),
  [2059] = {.count = 1, .reusable = false}, SHIFT(955),
  [2061] = {.count = 1, .reusable = true}, SHIFT(956),
  [2063] = {.count = 1, .reusable = false}, SHIFT(956),
  [2065] = {.count = 1, .reusable = false}, SHIFT(957),
  [2067] = {.count = 1, .reusable = true}, SHIFT(958),
  [2069] = {.count = 1, .reusable = true}, SHIFT(959),
  [2071] = {.count = 1, .reusable = false}, SHIFT(960),
  [2073] = {.count = 1, .reusable = true}, SHIFT(961),
  [2075] = {.count = 1, .reusable = false}, SHIFT(961),
  [2077] = {.count = 1, .reusable = false}, SHIFT(962),
  [2079] = {.count = 1, .reusable = false}, SHIFT(963),
  [2081] = {.count = 1, .reusable = false}, SHIFT(964),
  [2083] = {.count = 1, .reusable = true}, SHIFT(965),
  [2085] = {.count = 1, .reusable = true}, SHIFT(966),
  [2087] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [2089] = {.count = 1, .reusable = false}, SHIFT(966),
  [2091] = {.count = 1, .reusable = true}, SHIFT(967),
  [2093] = {.count = 1, .reusable = true}, SHIFT(968),
  [2095] = {.count = 1, .reusable = true}, SHIFT(969),
  [2097] = {.count = 1, .reusable = false}, SHIFT(968),
  [2099] = {.count = 1, .reusable = false}, SHIFT(969),
  [2101] = {.count = 1, .reusable = false}, SHIFT(970),
  [2103] = {.count = 1, .reusable = true}, SHIFT(964),
  [2105] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3),
  [2107] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3),
  [2109] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 3),
  [2111] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 3),
  [2113] = {.count = 1, .reusable = true}, SHIFT(972),
  [2115] = {.count = 1, .reusable = false}, SHIFT(972),
  [2117] = {.count = 1, .reusable = true}, SHIFT(419),
  [2119] = {.count = 1, .reusable = true}, SHIFT(421),
  [2121] = {.count = 1, .reusable = true}, SHIFT(469),
  [2123] = {.count = 1, .reusable = true}, SHIFT(472),
  [2125] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 11),
  [2127] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 11),
  [2129] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2),
  [2131] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3),
  [2133] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3),
  [2135] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .alias_sequence_id = 1),
  [2137] = {.count = 1, .reusable = true}, SHIFT(976),
  [2139] = {.count = 1, .reusable = false}, SHIFT(976),
  [2141] = {.count = 1, .reusable = true}, SHIFT(979),
  [2143] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3),
  [2145] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3),
  [2147] = {.count = 1, .reusable = true}, SHIFT(980),
  [2149] = {.count = 1, .reusable = true}, SHIFT(981),
  [2151] = {.count = 1, .reusable = false}, SHIFT(982),
  [2153] = {.count = 1, .reusable = false}, SHIFT(983),
  [2155] = {.count = 1, .reusable = false}, SHIFT(984),
  [2157] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [2159] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [2161] = {.count = 1, .reusable = true}, SHIFT(985),
  [2163] = {.count = 1, .reusable = true}, SHIFT(986),
  [2165] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 5),
  [2167] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .alias_sequence_id = 5),
  [2169] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3),
  [2171] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3),
  [2173] = {.count = 1, .reusable = true}, SHIFT(987),
  [2175] = {.count = 1, .reusable = false}, SHIFT(987),
  [2177] = {.count = 1, .reusable = true}, SHIFT(988),
  [2179] = {.count = 1, .reusable = false}, SHIFT(988),
  [2181] = {.count = 1, .reusable = true}, SHIFT(989),
  [2183] = {.count = 1, .reusable = false}, SHIFT(989),
  [2185] = {.count = 1, .reusable = true}, SHIFT(990),
  [2187] = {.count = 1, .reusable = false}, SHIFT(990),
  [2189] = {.count = 1, .reusable = true}, SHIFT(991),
  [2191] = {.count = 1, .reusable = false}, SHIFT(991),
  [2193] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [2195] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [2197] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [2199] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(612),
  [2202] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [2204] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(613),
  [2207] = {.count = 1, .reusable = true}, SHIFT(992),
  [2209] = {.count = 1, .reusable = true}, SHIFT(993),
  [2211] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [2213] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [2215] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(617),
  [2218] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [2220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(229),
  [2223] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2225] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2227] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .alias_sequence_id = 12),
  [2229] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .alias_sequence_id = 12),
  [2231] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 13),
  [2233] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .alias_sequence_id = 13),
  [2235] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3),
  [2237] = {.count = 1, .reusable = true}, SHIFT(994),
  [2239] = {.count = 1, .reusable = false}, SHIFT(994),
  [2241] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [2243] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [2245] = {.count = 1, .reusable = true}, SHIFT(995),
  [2247] = {.count = 1, .reusable = false}, SHIFT(995),
  [2249] = {.count = 1, .reusable = true}, SHIFT(996),
  [2251] = {.count = 1, .reusable = true}, SHIFT(999),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1000),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1001),
  [2257] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2),
  [2259] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2),
  [2261] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3),
  [2263] = {.count = 1, .reusable = true}, SHIFT(1002),
  [2265] = {.count = 1, .reusable = false}, SHIFT(1002),
  [2267] = {.count = 1, .reusable = true}, SHIFT(1003),
  [2269] = {.count = 1, .reusable = false}, SHIFT(1003),
  [2271] = {.count = 1, .reusable = false}, SHIFT(1004),
  [2273] = {.count = 1, .reusable = true}, SHIFT(1005),
  [2275] = {.count = 1, .reusable = true}, SHIFT(1006),
  [2277] = {.count = 1, .reusable = false}, SHIFT(1007),
  [2279] = {.count = 1, .reusable = true}, SHIFT(1008),
  [2281] = {.count = 1, .reusable = false}, SHIFT(1008),
  [2283] = {.count = 1, .reusable = false}, SHIFT(1009),
  [2285] = {.count = 1, .reusable = false}, SHIFT(1010),
  [2287] = {.count = 1, .reusable = false}, SHIFT(1011),
  [2289] = {.count = 1, .reusable = true}, SHIFT(1012),
  [2291] = {.count = 1, .reusable = true}, SHIFT(1013),
  [2293] = {.count = 1, .reusable = true}, SHIFT(1014),
  [2295] = {.count = 1, .reusable = false}, SHIFT(1013),
  [2297] = {.count = 1, .reusable = true}, SHIFT(1015),
  [2299] = {.count = 1, .reusable = true}, SHIFT(1016),
  [2301] = {.count = 1, .reusable = true}, SHIFT(1017),
  [2303] = {.count = 1, .reusable = false}, SHIFT(1016),
  [2305] = {.count = 1, .reusable = false}, SHIFT(1017),
  [2307] = {.count = 1, .reusable = false}, SHIFT(1018),
  [2309] = {.count = 1, .reusable = true}, SHIFT(1011),
  [2311] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 2),
  [2313] = {.count = 1, .reusable = false}, SHIFT(1019),
  [2315] = {.count = 1, .reusable = false}, SHIFT(1020),
  [2317] = {.count = 1, .reusable = false}, SHIFT(1021),
  [2319] = {.count = 1, .reusable = true}, SHIFT(1022),
  [2321] = {.count = 1, .reusable = false}, SHIFT(1023),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1024),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1024),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1025),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1028),
  [2331] = {.count = 1, .reusable = false}, SHIFT(1026),
  [2333] = {.count = 1, .reusable = false}, SHIFT(1028),
  [2335] = {.count = 1, .reusable = false}, SHIFT(1027),
  [2337] = {.count = 1, .reusable = true}, SHIFT(1033),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1034),
  [2341] = {.count = 1, .reusable = false}, SHIFT(1035),
  [2343] = {.count = 1, .reusable = false}, SHIFT(1038),
  [2345] = {.count = 1, .reusable = false}, SHIFT(1040),
  [2347] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_element, 3),
  [2349] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_element, 3),
  [2351] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(252),
  [2354] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(1042),
  [2357] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(665),
  [2360] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2362] = {.count = 1, .reusable = false}, SHIFT(1043),
  [2364] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2),
  [2366] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4),
  [2368] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4),
  [2370] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2372] = {.count = 1, .reusable = false}, SHIFT(1046),
  [2374] = {.count = 1, .reusable = true}, SHIFT(1047),
  [2376] = {.count = 1, .reusable = false}, SHIFT(1047),
  [2378] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2380] = {.count = 1, .reusable = false}, SHIFT(1048),
  [2382] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2384] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2386] = {.count = 1, .reusable = false}, SHIFT(1050),
  [2388] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2390] = {.count = 1, .reusable = false}, SHIFT(1051),
  [2392] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2394] = {.count = 1, .reusable = false}, SHIFT(1052),
  [2396] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2398] = {.count = 1, .reusable = false}, SHIFT(1053),
  [2400] = {.count = 1, .reusable = true}, SHIFT(1054),
  [2402] = {.count = 1, .reusable = false}, SHIFT(1054),
  [2404] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2406] = {.count = 1, .reusable = false}, SHIFT(1055),
  [2408] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [2410] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2412] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2414] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .alias_sequence_id = 14),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2424] = {.count = 1, .reusable = false}, SHIFT(1071),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2428] = {.count = 1, .reusable = false}, SHIFT(1072),
  [2430] = {.count = 1, .reusable = false}, SHIFT(1073),
  [2432] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2434] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2436] = {.count = 1, .reusable = false}, SHIFT(1076),
  [2438] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2440] = {.count = 1, .reusable = false}, SHIFT(1077),
  [2442] = {.count = 1, .reusable = false}, SHIFT(1078),
  [2444] = {.count = 1, .reusable = false}, SHIFT(1079),
  [2446] = {.count = 1, .reusable = false}, SHIFT(1080),
  [2448] = {.count = 1, .reusable = true}, SHIFT(1081),
  [2450] = {.count = 1, .reusable = true}, SHIFT(1082),
  [2452] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2454] = {.count = 1, .reusable = false}, SHIFT(1082),
  [2456] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2458] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2460] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2462] = {.count = 1, .reusable = false}, SHIFT(1085),
  [2464] = {.count = 1, .reusable = false}, SHIFT(1086),
  [2466] = {.count = 1, .reusable = false}, SHIFT(1087),
  [2468] = {.count = 1, .reusable = true}, SHIFT(1080),
  [2470] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2472] = {.count = 1, .reusable = true}, SHIFT(1091),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1094),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2478] = {.count = 1, .reusable = true}, SHIFT(1097),
  [2480] = {.count = 1, .reusable = false}, SHIFT(1097),
  [2482] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 3),
  [2484] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2486] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2488] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2490] = {.count = 1, .reusable = false}, SHIFT(1104),
  [2492] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2494] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2496] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2498] = {.count = 1, .reusable = false}, SHIFT(1111),
  [2500] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2502] = {.count = 1, .reusable = false}, SHIFT(1113),
  [2504] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2506] = {.count = 1, .reusable = false}, SHIFT(1115),
  [2508] = {.count = 1, .reusable = false}, SHIFT(1116),
  [2510] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [2513] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [2515] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .alias_sequence_id = 6),
  [2517] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .alias_sequence_id = 6),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1120),
  [2521] = {.count = 1, .reusable = false}, SHIFT(1120),
  [2523] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2525] = {.count = 1, .reusable = false}, SHIFT(1121),
  [2527] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2529] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2531] = {.count = 1, .reusable = false}, SHIFT(1123),
  [2533] = {.count = 1, .reusable = true}, SHIFT(1124),
  [2535] = {.count = 1, .reusable = false}, SHIFT(1124),
  [2537] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2539] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2543] = {.count = 1, .reusable = false}, SHIFT(1126),
  [2545] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2547] = {.count = 1, .reusable = false}, SHIFT(1127),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2551] = {.count = 1, .reusable = false}, SHIFT(1128),
  [2553] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1129),
  [2557] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2559] = {.count = 1, .reusable = false}, SHIFT(1130),
  [2561] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2565] = {.count = 1, .reusable = false}, SHIFT(1133),
  [2567] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2569] = {.count = 1, .reusable = false}, SHIFT(1134),
  [2571] = {.count = 1, .reusable = false}, SHIFT(1135),
  [2573] = {.count = 1, .reusable = false}, SHIFT(1136),
  [2575] = {.count = 1, .reusable = false}, SHIFT(1137),
  [2577] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2581] = {.count = 1, .reusable = false}, SHIFT(1139),
  [2583] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2587] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2589] = {.count = 1, .reusable = false}, SHIFT(1141),
  [2591] = {.count = 1, .reusable = false}, SHIFT(1142),
  [2593] = {.count = 1, .reusable = false}, SHIFT(1143),
  [2595] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2597] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [2599] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [2601] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [2603] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3),
  [2605] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2609] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [2611] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [2613] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2615] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .alias_sequence_id = 15),
  [2617] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2619] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [2621] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2623] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2625] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2629] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2631] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [2633] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [2635] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [2637] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(365),
  [2640] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2642] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2644] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2646] = {.count = 1, .reusable = false}, SHIFT(1155),
  [2648] = {.count = 1, .reusable = false}, SHIFT(1156),
  [2650] = {.count = 1, .reusable = true}, SHIFT(1160),
  [2652] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2654] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [2656] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [2658] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2660] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2662] = {.count = 1, .reusable = false}, SHIFT(1165),
  [2664] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2666] = {.count = 1, .reusable = false}, SHIFT(1167),
  [2668] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2670] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2672] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2674] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2676] = {.count = 1, .reusable = false}, SHIFT(1170),
  [2678] = {.count = 1, .reusable = false}, SHIFT(1172),
  [2680] = {.count = 1, .reusable = false}, SHIFT(1171),
  [2682] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2686] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2688] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2690] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2692] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1185),
  [2696] = {.count = 1, .reusable = false}, SHIFT(1186),
  [2698] = {.count = 1, .reusable = false}, SHIFT(1187),
  [2700] = {.count = 1, .reusable = false}, SHIFT(1188),
  [2702] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2704] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2706] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2708] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2710] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2712] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2714] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2716] = {.count = 1, .reusable = false}, SHIFT(1195),
  [2718] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2720] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2722] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2724] = {.count = 1, .reusable = false}, SHIFT(1203),
  [2726] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2728] = {.count = 1, .reusable = false}, SHIFT(1205),
  [2730] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2734] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2736] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2738] = {.count = 1, .reusable = false}, SHIFT(1208),
  [2740] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2742] = {.count = 1, .reusable = false}, SHIFT(1209),
  [2744] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2746] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2748] = {.count = 1, .reusable = false}, SHIFT(1216),
  [2750] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2752] = {.count = 1, .reusable = false}, SHIFT(1218),
  [2754] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2756] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2758] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2760] = {.count = 1, .reusable = false}, SHIFT(1221),
  [2762] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2764] = {.count = 1, .reusable = false}, SHIFT(1223),
  [2766] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2768] = {.count = 1, .reusable = true}, SHIFT(1227),
  [2770] = {.count = 1, .reusable = true}, SHIFT(1228),
  [2772] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2774] = {.count = 1, .reusable = false}, SHIFT(1231),
  [2776] = {.count = 1, .reusable = false}, SHIFT(1232),
  [2778] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2780] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2782] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2784] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2786] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .alias_sequence_id = 5),
  [2788] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2790] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .alias_sequence_id = 8),
  [2792] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .alias_sequence_id = 9),
  [2794] = {.count = 1, .reusable = true}, SHIFT(1241),
  [2796] = {.count = 1, .reusable = false}, SHIFT(1241),
  [2798] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4, .alias_sequence_id = 5),
  [2800] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(418),
  [2803] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2805] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2807] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2809] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [2811] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2815] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2817] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4, .alias_sequence_id = 8),
  [2819] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4, .alias_sequence_id = 9),
  [2821] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2823] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2825] = {.count = 1, .reusable = true}, SHIFT(667),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2829] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2831] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2833] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2837] = {.count = 1, .reusable = false}, SHIFT(1267),
  [2839] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2841] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2845] = {.count = 1, .reusable = false}, SHIFT(1272),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2849] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2851] = {.count = 1, .reusable = false}, SHIFT(1275),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2855] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2857] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2),
  [2859] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2),
  [2861] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2),
  [2863] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2),
  [2865] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4),
  [2867] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4),
  [2869] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2871] = {.count = 1, .reusable = false}, SHIFT(1280),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2875] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [2877] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2881] = {.count = 1, .reusable = false}, SHIFT(1283),
  [2883] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 2),
  [2885] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2887] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_namespace_name, 3),
  [2889] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_namespace_name, 3),
  [2891] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 4),
  [2893] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 4),
  [2895] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2897] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2899] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2901] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1),
  [2903] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2905] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2), SHIFT_REPEAT(533),
  [2908] = {.count = 1, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2),
  [2910] = {.count = 1, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2),
  [2912] = {.count = 2, .reusable = true}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2), SHIFT_REPEAT(537),
  [2915] = {.count = 2, .reusable = false}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2), SHIFT_REPEAT(537),
  [2918] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [2920] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [2922] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4),
  [2924] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4),
  [2926] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2928] = {.count = 1, .reusable = false}, SHIFT(1293),
  [2930] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2932] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [2934] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [2936] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2),
  [2938] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [2940] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [2942] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(64),
  [2945] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(543),
  [2948] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(544),
  [2951] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(545),
  [2954] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(546),
  [2957] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(552),
  [2960] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(547),
  [2963] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(39),
  [2966] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(548),
  [2969] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(549),
  [2972] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2974] = {.count = 1, .reusable = false}, SHIFT(1297),
  [2976] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2978] = {.count = 1, .reusable = false}, SHIFT(1298),
  [2980] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2982] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2984] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2986] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2988] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2990] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2992] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2994] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2996] = {.count = 1, .reusable = false}, SHIFT(1303),
  [2998] = {.count = 1, .reusable = true}, SHIFT(1304),
  [3000] = {.count = 1, .reusable = false}, SHIFT(1304),
  [3002] = {.count = 1, .reusable = true}, SHIFT(1305),
  [3004] = {.count = 1, .reusable = false}, SHIFT(1305),
  [3006] = {.count = 1, .reusable = true}, SHIFT(1306),
  [3008] = {.count = 1, .reusable = false}, SHIFT(1306),
  [3010] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4),
  [3012] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4),
  [3014] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4),
  [3016] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4),
  [3018] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4),
  [3020] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4),
  [3022] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4),
  [3024] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4),
  [3026] = {.count = 1, .reusable = true}, SHIFT(1309),
  [3028] = {.count = 1, .reusable = false}, SHIFT(1310),
  [3030] = {.count = 1, .reusable = true}, SHIFT(1311),
  [3032] = {.count = 1, .reusable = true}, SHIFT(1312),
  [3034] = {.count = 1, .reusable = false}, SHIFT(1312),
  [3036] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [3038] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [3040] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [3042] = {.count = 1, .reusable = true}, SHIFT(1313),
  [3044] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(622),
  [3047] = {.count = 1, .reusable = true}, SHIFT(1314),
  [3049] = {.count = 1, .reusable = false}, SHIFT(1314),
  [3051] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [3053] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [3055] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .alias_sequence_id = 13),
  [3057] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .alias_sequence_id = 13),
  [3059] = {.count = 1, .reusable = true}, SHIFT(1315),
  [3061] = {.count = 1, .reusable = false}, SHIFT(1315),
  [3063] = {.count = 1, .reusable = true}, SHIFT(1316),
  [3065] = {.count = 1, .reusable = false}, SHIFT(1316),
  [3067] = {.count = 1, .reusable = true}, SHIFT(1317),
  [3069] = {.count = 1, .reusable = false}, SHIFT(1317),
  [3071] = {.count = 1, .reusable = true}, SHIFT(1318),
  [3073] = {.count = 1, .reusable = true}, SHIFT(1319),
  [3075] = {.count = 1, .reusable = false}, SHIFT(1319),
  [3077] = {.count = 1, .reusable = true}, SHIFT(1320),
  [3079] = {.count = 1, .reusable = false}, SHIFT(1320),
  [3081] = {.count = 1, .reusable = true}, SHIFT(1321),
  [3083] = {.count = 1, .reusable = false}, SHIFT(1321),
  [3085] = {.count = 1, .reusable = true}, SHIFT(1322),
  [3087] = {.count = 1, .reusable = false}, SHIFT(1322),
  [3089] = {.count = 1, .reusable = true}, SHIFT(1323),
  [3091] = {.count = 1, .reusable = false}, SHIFT(1323),
  [3093] = {.count = 1, .reusable = true}, SHIFT(1324),
  [3095] = {.count = 1, .reusable = false}, SHIFT(1324),
  [3097] = {.count = 1, .reusable = true}, SHIFT(1325),
  [3099] = {.count = 1, .reusable = false}, SHIFT(1325),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1326),
  [3103] = {.count = 1, .reusable = false}, SHIFT(1326),
  [3105] = {.count = 1, .reusable = true}, SHIFT(1327),
  [3107] = {.count = 1, .reusable = false}, SHIFT(1327),
  [3109] = {.count = 1, .reusable = false}, SHIFT(1328),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1329),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1330),
  [3115] = {.count = 1, .reusable = false}, SHIFT(1331),
  [3117] = {.count = 1, .reusable = true}, SHIFT(1332),
  [3119] = {.count = 1, .reusable = false}, SHIFT(1332),
  [3121] = {.count = 1, .reusable = false}, SHIFT(1333),
  [3123] = {.count = 1, .reusable = false}, SHIFT(1334),
  [3125] = {.count = 1, .reusable = false}, SHIFT(1335),
  [3127] = {.count = 1, .reusable = true}, SHIFT(1336),
  [3129] = {.count = 1, .reusable = true}, SHIFT(1337),
  [3131] = {.count = 1, .reusable = false}, SHIFT(1337),
  [3133] = {.count = 1, .reusable = true}, SHIFT(1338),
  [3135] = {.count = 1, .reusable = true}, SHIFT(1339),
  [3137] = {.count = 1, .reusable = true}, SHIFT(1340),
  [3139] = {.count = 1, .reusable = false}, SHIFT(1339),
  [3141] = {.count = 1, .reusable = false}, SHIFT(1340),
  [3143] = {.count = 1, .reusable = false}, SHIFT(1341),
  [3145] = {.count = 1, .reusable = true}, SHIFT(1335),
  [3147] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_expression, 3),
  [3149] = {.count = 1, .reusable = true}, SHIFT(1342),
  [3151] = {.count = 1, .reusable = true}, SHIFT(1343),
  [3153] = {.count = 1, .reusable = false}, SHIFT(1344),
  [3155] = {.count = 1, .reusable = true}, SHIFT(1345),
  [3157] = {.count = 1, .reusable = false}, SHIFT(1346),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1349),
  [3161] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 4),
  [3163] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 4),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1351),
  [3167] = {.count = 1, .reusable = false}, SHIFT(1351),
  [3169] = {.count = 1, .reusable = true}, SHIFT(1352),
  [3171] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3),
  [3173] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .alias_sequence_id = 14),
  [3175] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .alias_sequence_id = 14),
  [3177] = {.count = 1, .reusable = true}, SHIFT(1353),
  [3179] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(1354),
  [3182] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [3184] = {.count = 1, .reusable = true}, SHIFT(1355),
  [3186] = {.count = 1, .reusable = true}, SHIFT(1358),
  [3188] = {.count = 1, .reusable = true}, SHIFT(1360),
  [3190] = {.count = 1, .reusable = false}, SHIFT(1360),
  [3192] = {.count = 1, .reusable = true}, SHIFT(1361),
  [3194] = {.count = 1, .reusable = false}, SHIFT(1361),
  [3196] = {.count = 1, .reusable = true}, SHIFT(1362),
  [3198] = {.count = 1, .reusable = false}, SHIFT(1362),
  [3200] = {.count = 1, .reusable = true}, SHIFT(1363),
  [3202] = {.count = 1, .reusable = true}, SHIFT(1364),
  [3204] = {.count = 1, .reusable = false}, SHIFT(1364),
  [3206] = {.count = 1, .reusable = true}, SHIFT(1365),
  [3208] = {.count = 1, .reusable = false}, SHIFT(1365),
  [3210] = {.count = 1, .reusable = true}, SHIFT(1366),
  [3212] = {.count = 1, .reusable = false}, SHIFT(1366),
  [3214] = {.count = 1, .reusable = true}, SHIFT(1367),
  [3216] = {.count = 1, .reusable = false}, SHIFT(1367),
  [3218] = {.count = 1, .reusable = true}, SHIFT(1368),
  [3220] = {.count = 1, .reusable = false}, SHIFT(1368),
  [3222] = {.count = 1, .reusable = true}, SHIFT(1369),
  [3224] = {.count = 1, .reusable = false}, SHIFT(1369),
  [3226] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4),
  [3228] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4),
  [3230] = {.count = 1, .reusable = true}, SHIFT(1370),
  [3232] = {.count = 1, .reusable = true}, SHIFT(1371),
  [3234] = {.count = 1, .reusable = true}, SHIFT(1373),
  [3236] = {.count = 1, .reusable = false}, SHIFT(1375),
  [3238] = {.count = 1, .reusable = false}, SHIFT(1376),
  [3240] = {.count = 1, .reusable = false}, SHIFT(1377),
  [3242] = {.count = 1, .reusable = true}, SHIFT(1381),
  [3244] = {.count = 1, .reusable = true}, SHIFT(1382),
  [3246] = {.count = 1, .reusable = true}, SHIFT(1383),
  [3248] = {.count = 1, .reusable = true}, SHIFT(1384),
  [3250] = {.count = 1, .reusable = true}, SHIFT(1385),
  [3252] = {.count = 1, .reusable = true}, SHIFT(1386),
  [3254] = {.count = 1, .reusable = true}, SHIFT(1387),
  [3256] = {.count = 1, .reusable = true}, SHIFT(1388),
  [3258] = {.count = 1, .reusable = false}, SHIFT(1388),
  [3260] = {.count = 1, .reusable = true}, SHIFT(1390),
  [3262] = {.count = 1, .reusable = false}, SHIFT(1390),
  [3264] = {.count = 1, .reusable = true}, SHIFT(1391),
  [3266] = {.count = 1, .reusable = true}, SHIFT(1392),
  [3268] = {.count = 1, .reusable = false}, SHIFT(1392),
  [3270] = {.count = 1, .reusable = true}, SHIFT(1394),
  [3272] = {.count = 1, .reusable = false}, SHIFT(1394),
  [3274] = {.count = 1, .reusable = true}, SHIFT(1396),
  [3276] = {.count = 1, .reusable = false}, SHIFT(1396),
  [3278] = {.count = 1, .reusable = true}, SHIFT(1397),
  [3280] = {.count = 1, .reusable = false}, SHIFT(1397),
  [3282] = {.count = 1, .reusable = true}, SHIFT(1399),
  [3284] = {.count = 1, .reusable = false}, SHIFT(1399),
  [3286] = {.count = 1, .reusable = true}, SHIFT(1400),
  [3288] = {.count = 1, .reusable = true}, SHIFT(1404),
  [3290] = {.count = 1, .reusable = false}, SHIFT(1404),
  [3292] = {.count = 1, .reusable = true}, SHIFT(1405),
  [3294] = {.count = 1, .reusable = true}, SHIFT(1406),
  [3296] = {.count = 1, .reusable = false}, SHIFT(1406),
  [3298] = {.count = 1, .reusable = true}, SHIFT(1407),
  [3300] = {.count = 1, .reusable = false}, SHIFT(1407),
  [3302] = {.count = 1, .reusable = true}, SHIFT(1408),
  [3304] = {.count = 1, .reusable = true}, SHIFT(1409),
  [3306] = {.count = 1, .reusable = false}, SHIFT(1409),
  [3308] = {.count = 1, .reusable = true}, SHIFT(1410),
  [3310] = {.count = 1, .reusable = false}, SHIFT(1410),
  [3312] = {.count = 1, .reusable = true}, SHIFT(1411),
  [3314] = {.count = 1, .reusable = false}, SHIFT(1411),
  [3316] = {.count = 1, .reusable = true}, SHIFT(1412),
  [3318] = {.count = 1, .reusable = false}, SHIFT(1412),
  [3320] = {.count = 1, .reusable = true}, SHIFT(1413),
  [3322] = {.count = 1, .reusable = false}, SHIFT(1413),
  [3324] = {.count = 1, .reusable = true}, SHIFT(1414),
  [3326] = {.count = 1, .reusable = false}, SHIFT(1414),
  [3328] = {.count = 1, .reusable = true}, REDUCE(sym_object, 5),
  [3330] = {.count = 1, .reusable = false}, REDUCE(sym_object, 5),
  [3332] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .alias_sequence_id = 15),
  [3334] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .alias_sequence_id = 15),
  [3336] = {.count = 1, .reusable = true}, SHIFT(1415),
  [3338] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(1416),
  [3341] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1417),
  [3345] = {.count = 1, .reusable = false}, SHIFT(1418),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1419),
  [3349] = {.count = 1, .reusable = false}, SHIFT(1422),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1423),
  [3353] = {.count = 1, .reusable = false}, SHIFT(1425),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3357] = {.count = 1, .reusable = false}, SHIFT(1427),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1428),
  [3361] = {.count = 1, .reusable = false}, SHIFT(1429),
  [3363] = {.count = 1, .reusable = false}, SHIFT(1430),
  [3365] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3367] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3369] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [3371] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [3373] = {.count = 1, .reusable = false}, SHIFT(1433),
  [3375] = {.count = 1, .reusable = false}, SHIFT(1434),
  [3377] = {.count = 1, .reusable = false}, SHIFT(1435),
  [3379] = {.count = 1, .reusable = false}, SHIFT(1436),
  [3381] = {.count = 1, .reusable = false}, SHIFT(1437),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1439),
  [3385] = {.count = 1, .reusable = false}, SHIFT(1439),
  [3387] = {.count = 1, .reusable = true}, SHIFT(1440),
  [3389] = {.count = 1, .reusable = false}, SHIFT(1440),
  [3391] = {.count = 1, .reusable = false}, SHIFT(1441),
  [3393] = {.count = 1, .reusable = true}, SHIFT(1442),
  [3395] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3397] = {.count = 1, .reusable = false}, SHIFT(1444),
  [3399] = {.count = 1, .reusable = true}, SHIFT(1445),
  [3401] = {.count = 1, .reusable = false}, SHIFT(1445),
  [3403] = {.count = 1, .reusable = false}, SHIFT(1446),
  [3405] = {.count = 1, .reusable = false}, SHIFT(1447),
  [3407] = {.count = 1, .reusable = false}, SHIFT(1448),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3411] = {.count = 1, .reusable = true}, SHIFT(1450),
  [3413] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3417] = {.count = 1, .reusable = false}, SHIFT(1450),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1454),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3425] = {.count = 1, .reusable = false}, SHIFT(1454),
  [3427] = {.count = 1, .reusable = false}, SHIFT(1455),
  [3429] = {.count = 1, .reusable = false}, SHIFT(1456),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1448),
  [3433] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [3435] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [3437] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(809),
  [3440] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [3442] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(811),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3447] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3449] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3451] = {.count = 1, .reusable = false}, SHIFT(1459),
  [3453] = {.count = 1, .reusable = true}, SHIFT(1460),
  [3455] = {.count = 1, .reusable = false}, SHIFT(1460),
  [3457] = {.count = 1, .reusable = true}, SHIFT(1462),
  [3459] = {.count = 1, .reusable = false}, SHIFT(1462),
  [3461] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3463] = {.count = 1, .reusable = false}, SHIFT(1463),
  [3465] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3467] = {.count = 1, .reusable = false}, SHIFT(1465),
  [3469] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3471] = {.count = 1, .reusable = false}, SHIFT(1466),
  [3473] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3475] = {.count = 1, .reusable = false}, SHIFT(1467),
  [3477] = {.count = 1, .reusable = false}, SHIFT(1468),
  [3479] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3481] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3483] = {.count = 1, .reusable = false}, SHIFT(1471),
  [3485] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3487] = {.count = 1, .reusable = false}, SHIFT(1472),
  [3489] = {.count = 1, .reusable = false}, SHIFT(1473),
  [3491] = {.count = 1, .reusable = false}, SHIFT(1474),
  [3493] = {.count = 1, .reusable = false}, SHIFT(1475),
  [3495] = {.count = 1, .reusable = true}, SHIFT(1476),
  [3497] = {.count = 1, .reusable = true}, SHIFT(1477),
  [3499] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3501] = {.count = 1, .reusable = false}, SHIFT(1477),
  [3503] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3505] = {.count = 1, .reusable = false}, SHIFT(1483),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3509] = {.count = 1, .reusable = false}, SHIFT(1484),
  [3511] = {.count = 1, .reusable = false}, SHIFT(1485),
  [3513] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3515] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3517] = {.count = 1, .reusable = false}, SHIFT(1488),
  [3519] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3521] = {.count = 1, .reusable = false}, SHIFT(1489),
  [3523] = {.count = 1, .reusable = false}, SHIFT(1490),
  [3525] = {.count = 1, .reusable = false}, SHIFT(1491),
  [3527] = {.count = 1, .reusable = false}, SHIFT(1492),
  [3529] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3531] = {.count = 1, .reusable = true}, SHIFT(1494),
  [3533] = {.count = 1, .reusable = true}, SHIFT(1495),
  [3535] = {.count = 1, .reusable = false}, SHIFT(1494),
  [3537] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3539] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3541] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3543] = {.count = 1, .reusable = false}, SHIFT(1497),
  [3545] = {.count = 1, .reusable = false}, SHIFT(1498),
  [3547] = {.count = 1, .reusable = false}, SHIFT(1499),
  [3549] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3551] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3553] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3559] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3565] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1510),
  [3571] = {.count = 1, .reusable = false}, SHIFT(1511),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3575] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3577] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3579] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3583] = {.count = 1, .reusable = false}, SHIFT(1520),
  [3585] = {.count = 1, .reusable = false}, SHIFT(1521),
  [3587] = {.count = 1, .reusable = false}, SHIFT(1522),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1528),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3603] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3605] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3607] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3609] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3613] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3615] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3619] = {.count = 1, .reusable = false}, SHIFT(1539),
  [3621] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3623] = {.count = 1, .reusable = false}, SHIFT(1541),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3627] = {.count = 1, .reusable = false}, SHIFT(1542),
  [3629] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3631] = {.count = 1, .reusable = false}, SHIFT(1544),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1545),
  [3635] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5),
  [3637] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5),
  [3639] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3641] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3643] = {.count = 1, .reusable = false}, SHIFT(1549),
  [3645] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 5),
  [3647] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 5),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3651] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_expression, 3),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3655] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3657] = {.count = 1, .reusable = false}, SHIFT(1553),
  [3659] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3665] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3, .alias_sequence_id = 2),
  [3667] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3, .alias_sequence_id = 2),
  [3669] = {.count = 1, .reusable = false}, SHIFT(1559),
  [3671] = {.count = 1, .reusable = false}, SHIFT(1561),
  [3673] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_attribute, 3),
  [3675] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_attribute, 3),
  [3677] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_self_closing_element, 5),
  [3679] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_self_closing_element, 5),
  [3681] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 3),
  [3683] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 3),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1562),
  [3687] = {.count = 1, .reusable = true}, SHIFT(1563),
  [3689] = {.count = 1, .reusable = false}, SHIFT(1563),
  [3691] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3693] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5),
  [3695] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5),
  [3697] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5),
  [3699] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5),
  [3701] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3704] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [3706] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [3708] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3710] = {.count = 1, .reusable = false}, SHIFT(1565),
  [3712] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5),
  [3714] = {.count = 1, .reusable = true}, SHIFT(1566),
  [3716] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3718] = {.count = 1, .reusable = false}, SHIFT(1567),
  [3720] = {.count = 1, .reusable = true}, SHIFT(1568),
  [3722] = {.count = 1, .reusable = false}, SHIFT(1568),
  [3724] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3726] = {.count = 1, .reusable = false}, SHIFT(1569),
  [3728] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3730] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3732] = {.count = 1, .reusable = false}, SHIFT(1571),
  [3734] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3736] = {.count = 1, .reusable = false}, SHIFT(1572),
  [3738] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3740] = {.count = 1, .reusable = false}, SHIFT(1573),
  [3742] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3744] = {.count = 1, .reusable = false}, SHIFT(1574),
  [3746] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3748] = {.count = 1, .reusable = false}, SHIFT(1575),
  [3750] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3752] = {.count = 1, .reusable = false}, SHIFT(1576),
  [3754] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_closing_element, 4),
  [3756] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_closing_element, 4),
  [3758] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3760] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3762] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [3764] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [3766] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5),
  [3768] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5),
  [3770] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3772] = {.count = 1, .reusable = false}, SHIFT(1579),
  [3774] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .alias_sequence_id = 14),
  [3776] = {.count = 1, .reusable = true}, SHIFT(1580),
  [3778] = {.count = 1, .reusable = false}, SHIFT(1580),
  [3780] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3782] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3784] = {.count = 1, .reusable = false}, SHIFT(1583),
  [3786] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3788] = {.count = 1, .reusable = false}, SHIFT(1587),
  [3790] = {.count = 1, .reusable = true}, SHIFT(1588),
  [3792] = {.count = 1, .reusable = false}, SHIFT(1590),
  [3794] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3796] = {.count = 1, .reusable = false}, SHIFT(1592),
  [3798] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3800] = {.count = 1, .reusable = false}, SHIFT(1594),
  [3802] = {.count = 1, .reusable = false}, SHIFT(1595),
  [3804] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3806] = {.count = 1, .reusable = false}, SHIFT(1598),
  [3808] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3810] = {.count = 1, .reusable = false}, SHIFT(1600),
  [3812] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3814] = {.count = 1, .reusable = false}, SHIFT(1601),
  [3816] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3818] = {.count = 1, .reusable = false}, SHIFT(1603),
  [3820] = {.count = 1, .reusable = true}, SHIFT(1604),
  [3822] = {.count = 1, .reusable = false}, SHIFT(1604),
  [3824] = {.count = 1, .reusable = true}, SHIFT(1606),
  [3826] = {.count = 1, .reusable = false}, SHIFT(1606),
  [3828] = {.count = 1, .reusable = true}, SHIFT(1607),
  [3830] = {.count = 1, .reusable = true}, SHIFT(1608),
  [3832] = {.count = 1, .reusable = true}, SHIFT(1609),
  [3834] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3836] = {.count = 1, .reusable = true}, SHIFT(1611),
  [3838] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3840] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3842] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3844] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3846] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3848] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5),
  [3850] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5),
  [3852] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3854] = {.count = 1, .reusable = false}, SHIFT(1617),
  [3856] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3858] = {.count = 1, .reusable = false}, SHIFT(1618),
  [3860] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3862] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .alias_sequence_id = 15),
  [3864] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3866] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3868] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3870] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3872] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3874] = {.count = 1, .reusable = true}, SHIFT(1625),
  [3876] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3878] = {.count = 1, .reusable = false}, SHIFT(1626),
  [3880] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3882] = {.count = 1, .reusable = false}, SHIFT(1628),
  [3884] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3886] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3888] = {.count = 1, .reusable = false}, SHIFT(1630),
  [3890] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3892] = {.count = 1, .reusable = false}, SHIFT(1632),
  [3894] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3896] = {.count = 1, .reusable = false}, SHIFT(1634),
  [3898] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3900] = {.count = 1, .reusable = false}, SHIFT(1635),
  [3902] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3904] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3906] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3908] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3910] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3912] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3914] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [3916] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [3918] = {.count = 1, .reusable = true}, SHIFT(1648),
  [3920] = {.count = 1, .reusable = false}, SHIFT(1648),
  [3922] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3924] = {.count = 1, .reusable = false}, SHIFT(1649),
  [3926] = {.count = 1, .reusable = true}, SHIFT(1650),
  [3928] = {.count = 1, .reusable = false}, SHIFT(1650),
  [3930] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3932] = {.count = 1, .reusable = true}, SHIFT(1652),
  [3934] = {.count = 1, .reusable = false}, SHIFT(1652),
  [3936] = {.count = 1, .reusable = true}, SHIFT(1653),
  [3938] = {.count = 1, .reusable = false}, SHIFT(1653),
  [3940] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3942] = {.count = 1, .reusable = false}, SHIFT(1654),
  [3944] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3),
  [3946] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3),
  [3948] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3950] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3952] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3954] = {.count = 1, .reusable = false}, SHIFT(1657),
  [3956] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3958] = {.count = 1, .reusable = false}, SHIFT(1658),
  [3960] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3962] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3964] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3968] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3970] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3972] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3974] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3976] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3978] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3980] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3982] = {.count = 1, .reusable = false}, SHIFT(1480),
  [3984] = {.count = 1, .reusable = false}, SHIFT(1481),
  [3986] = {.count = 1, .reusable = false}, SHIFT(1482),
  [3988] = {.count = 1, .reusable = true}, SHIFT(1475),
  [3990] = {.count = 1, .reusable = true}, SHIFT(1666),
  [3992] = {.count = 1, .reusable = false}, SHIFT(1666),
  [3994] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3996] = {.count = 1, .reusable = false}, SHIFT(1667),
  [3998] = {.count = 1, .reusable = true}, SHIFT(1668),
  [4000] = {.count = 1, .reusable = false}, SHIFT(1668),
  [4002] = {.count = 1, .reusable = true}, SHIFT(1669),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1670),
  [4006] = {.count = 1, .reusable = false}, SHIFT(1670),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1671),
  [4010] = {.count = 1, .reusable = false}, SHIFT(1671),
  [4012] = {.count = 1, .reusable = true}, SHIFT(1673),
  [4014] = {.count = 1, .reusable = false}, SHIFT(1673),
  [4016] = {.count = 1, .reusable = true}, SHIFT(1674),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1674),
  [4020] = {.count = 1, .reusable = true}, SHIFT(1675),
  [4022] = {.count = 1, .reusable = false}, SHIFT(1675),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1676),
  [4026] = {.count = 1, .reusable = false}, SHIFT(1676),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1677),
  [4030] = {.count = 1, .reusable = false}, SHIFT(1677),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1678),
  [4034] = {.count = 1, .reusable = false}, SHIFT(1678),
  [4036] = {.count = 1, .reusable = true}, SHIFT(1679),
  [4038] = {.count = 1, .reusable = false}, SHIFT(1679),
  [4040] = {.count = 1, .reusable = true}, SHIFT(1680),
  [4042] = {.count = 1, .reusable = true}, SHIFT(1681),
  [4044] = {.count = 1, .reusable = false}, SHIFT(1681),
  [4046] = {.count = 1, .reusable = true}, SHIFT(1682),
  [4048] = {.count = 1, .reusable = false}, SHIFT(1682),
  [4050] = {.count = 1, .reusable = true}, SHIFT(1684),
  [4052] = {.count = 1, .reusable = false}, SHIFT(1684),
  [4054] = {.count = 1, .reusable = true}, SHIFT(1685),
  [4056] = {.count = 1, .reusable = false}, SHIFT(1685),
  [4058] = {.count = 1, .reusable = true}, SHIFT(1686),
  [4060] = {.count = 1, .reusable = false}, SHIFT(1686),
  [4062] = {.count = 1, .reusable = true}, SHIFT(1687),
  [4064] = {.count = 1, .reusable = false}, SHIFT(1687),
  [4066] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [4068] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [4070] = {.count = 1, .reusable = true}, SHIFT(1693),
  [4072] = {.count = 1, .reusable = false}, SHIFT(1693),
  [4074] = {.count = 1, .reusable = true}, SHIFT(1694),
  [4076] = {.count = 1, .reusable = false}, SHIFT(1694),
  [4078] = {.count = 1, .reusable = true}, SHIFT(1695),
  [4080] = {.count = 1, .reusable = false}, SHIFT(1695),
  [4082] = {.count = 1, .reusable = true}, SHIFT(1696),
  [4084] = {.count = 1, .reusable = true}, SHIFT(1697),
  [4086] = {.count = 1, .reusable = true}, SHIFT(1698),
  [4088] = {.count = 1, .reusable = false}, SHIFT(1701),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1702),
  [4092] = {.count = 1, .reusable = false}, SHIFT(1704),
  [4094] = {.count = 1, .reusable = true}, SHIFT(1705),
  [4096] = {.count = 1, .reusable = false}, SHIFT(1706),
  [4098] = {.count = 1, .reusable = true}, SHIFT(1707),
  [4100] = {.count = 1, .reusable = false}, SHIFT(1708),
  [4102] = {.count = 1, .reusable = false}, SHIFT(1709),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1712),
  [4106] = {.count = 1, .reusable = false}, SHIFT(1712),
  [4108] = {.count = 1, .reusable = true}, SHIFT(1714),
  [4110] = {.count = 1, .reusable = false}, SHIFT(1714),
  [4112] = {.count = 1, .reusable = true}, SHIFT(1715),
  [4114] = {.count = 1, .reusable = false}, SHIFT(1715),
  [4116] = {.count = 1, .reusable = true}, SHIFT(1717),
  [4118] = {.count = 1, .reusable = false}, SHIFT(1717),
  [4120] = {.count = 1, .reusable = true}, SHIFT(1718),
  [4122] = {.count = 1, .reusable = false}, SHIFT(1718),
  [4124] = {.count = 1, .reusable = true}, SHIFT(1720),
  [4126] = {.count = 1, .reusable = false}, SHIFT(1720),
  [4128] = {.count = 1, .reusable = true}, SHIFT(1721),
  [4130] = {.count = 1, .reusable = true}, SHIFT(1722),
  [4132] = {.count = 1, .reusable = true}, SHIFT(1723),
  [4134] = {.count = 1, .reusable = true}, SHIFT(1724),
  [4136] = {.count = 1, .reusable = true}, SHIFT(1725),
  [4138] = {.count = 1, .reusable = true}, SHIFT(1726),
  [4140] = {.count = 1, .reusable = true}, SHIFT(1727),
  [4142] = {.count = 1, .reusable = true}, SHIFT(1728),
  [4144] = {.count = 1, .reusable = true}, SHIFT(1729),
  [4146] = {.count = 1, .reusable = true}, SHIFT(1730),
  [4148] = {.count = 1, .reusable = true}, REDUCE(sym_jsx_fragment, 6),
  [4150] = {.count = 1, .reusable = false}, REDUCE(sym_jsx_fragment, 6),
  [4152] = {.count = 1, .reusable = false}, SHIFT(1732),
  [4154] = {.count = 1, .reusable = false}, SHIFT(1733),
  [4156] = {.count = 1, .reusable = false}, SHIFT(1734),
  [4158] = {.count = 1, .reusable = false}, SHIFT(1736),
  [4160] = {.count = 1, .reusable = false}, SHIFT(1737),
  [4162] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 4),
  [4164] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 4),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1739),
  [4168] = {.count = 1, .reusable = false}, SHIFT(1739),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1740),
  [4172] = {.count = 1, .reusable = false}, SHIFT(1740),
  [4174] = {.count = 1, .reusable = true}, SHIFT(1741),
  [4176] = {.count = 1, .reusable = false}, SHIFT(1741),
  [4178] = {.count = 1, .reusable = true}, SHIFT(1742),
  [4180] = {.count = 1, .reusable = true}, SHIFT(1743),
  [4182] = {.count = 1, .reusable = false}, SHIFT(1743),
  [4184] = {.count = 1, .reusable = true}, SHIFT(1744),
  [4186] = {.count = 1, .reusable = true}, SHIFT(1745),
  [4188] = {.count = 1, .reusable = true}, SHIFT(1746),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1747),
  [4192] = {.count = 1, .reusable = true}, SHIFT(1748),
  [4194] = {.count = 1, .reusable = true}, SHIFT(1749),
  [4196] = {.count = 1, .reusable = true}, SHIFT(1750),
  [4198] = {.count = 1, .reusable = false}, SHIFT(1750),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1752),
  [4202] = {.count = 1, .reusable = false}, SHIFT(1752),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1753),
  [4206] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4208] = {.count = 1, .reusable = false}, SHIFT(1754),
  [4210] = {.count = 1, .reusable = true}, SHIFT(1756),
  [4212] = {.count = 1, .reusable = false}, SHIFT(1756),
  [4214] = {.count = 1, .reusable = true}, SHIFT(1758),
  [4216] = {.count = 1, .reusable = false}, SHIFT(1758),
  [4218] = {.count = 1, .reusable = true}, SHIFT(1759),
  [4220] = {.count = 1, .reusable = false}, SHIFT(1759),
  [4222] = {.count = 1, .reusable = true}, SHIFT(1761),
  [4224] = {.count = 1, .reusable = false}, SHIFT(1761),
  [4226] = {.count = 1, .reusable = true}, SHIFT(1762),
  [4228] = {.count = 1, .reusable = true}, SHIFT(1765),
  [4230] = {.count = 1, .reusable = true}, SHIFT(1766),
  [4232] = {.count = 1, .reusable = true}, SHIFT(1767),
  [4234] = {.count = 1, .reusable = true}, SHIFT(1768),
  [4236] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4238] = {.count = 1, .reusable = true}, SHIFT(1770),
  [4240] = {.count = 1, .reusable = true}, SHIFT(1771),
  [4242] = {.count = 1, .reusable = false}, SHIFT(1771),
  [4244] = {.count = 1, .reusable = true}, SHIFT(1772),
  [4246] = {.count = 1, .reusable = false}, SHIFT(1772),
  [4248] = {.count = 1, .reusable = true}, SHIFT(1773),
  [4250] = {.count = 1, .reusable = false}, SHIFT(1773),
  [4252] = {.count = 1, .reusable = true}, SHIFT(1774),
  [4254] = {.count = 1, .reusable = false}, SHIFT(1774),
  [4256] = {.count = 1, .reusable = true}, SHIFT(1775),
  [4258] = {.count = 1, .reusable = false}, SHIFT(1775),
  [4260] = {.count = 1, .reusable = true}, SHIFT(1777),
  [4262] = {.count = 1, .reusable = false}, SHIFT(1777),
  [4264] = {.count = 1, .reusable = true}, SHIFT(1778),
  [4266] = {.count = 1, .reusable = false}, SHIFT(1778),
  [4268] = {.count = 1, .reusable = true}, SHIFT(1780),
  [4270] = {.count = 1, .reusable = false}, SHIFT(1780),
  [4272] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4274] = {.count = 1, .reusable = false}, SHIFT(1781),
  [4276] = {.count = 1, .reusable = true}, SHIFT(1783),
  [4278] = {.count = 1, .reusable = false}, SHIFT(1783),
  [4280] = {.count = 1, .reusable = true}, SHIFT(1784),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4284] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4286] = {.count = 1, .reusable = true}, SHIFT(1787),
  [4288] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4290] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4292] = {.count = 1, .reusable = true}, SHIFT(1790),
  [4294] = {.count = 1, .reusable = true}, SHIFT(1791),
  [4296] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4298] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4300] = {.count = 1, .reusable = false}, SHIFT(1794),
  [4302] = {.count = 1, .reusable = false}, SHIFT(1795),
  [4304] = {.count = 1, .reusable = false}, SHIFT(1796),
  [4306] = {.count = 1, .reusable = false}, SHIFT(1797),
  [4308] = {.count = 1, .reusable = false}, SHIFT(1798),
  [4310] = {.count = 1, .reusable = false}, SHIFT(1800),
  [4312] = {.count = 1, .reusable = false}, SHIFT(1801),
  [4314] = {.count = 1, .reusable = false}, SHIFT(1802),
  [4316] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4318] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [4320] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1433),
  [4323] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1434),
  [4326] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1435),
  [4329] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1436),
  [4332] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1437),
  [4335] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4337] = {.count = 1, .reusable = false}, SHIFT(1807),
  [4339] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4),
  [4341] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4),
  [4343] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4345] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4347] = {.count = 1, .reusable = false}, SHIFT(1815),
  [4349] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7),
  [4351] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7),
  [4353] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1817),
  [4357] = {.count = 1, .reusable = false}, SHIFT(1817),
  [4359] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7),
  [4361] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7),
  [4363] = {.count = 1, .reusable = true}, SHIFT(1818),
  [4365] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [4367] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [4369] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 16),
  [4371] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 16),
  [4373] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 16),
  [4375] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 16),
  [4377] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 17),
  [4379] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7, .alias_sequence_id = 17),
  [4381] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 17),
  [4383] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7, .alias_sequence_id = 17),
  [4385] = {.count = 1, .reusable = true}, SHIFT(1819),
  [4387] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4389] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4391] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4393] = {.count = 1, .reusable = true}, SHIFT(1823),
  [4395] = {.count = 1, .reusable = true}, SHIFT(1824),
  [4397] = {.count = 1, .reusable = true}, SHIFT(1825),
  [4399] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4401] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4403] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4405] = {.count = 1, .reusable = false}, SHIFT(1828),
  [4407] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4409] = {.count = 1, .reusable = false}, SHIFT(1830),
  [4411] = {.count = 1, .reusable = true}, SHIFT(1831),
  [4413] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4415] = {.count = 1, .reusable = false}, SHIFT(1832),
  [4417] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4419] = {.count = 1, .reusable = false}, SHIFT(1834),
  [4421] = {.count = 1, .reusable = true}, SHIFT(1836),
  [4423] = {.count = 1, .reusable = false}, SHIFT(1836),
  [4425] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4427] = {.count = 1, .reusable = false}, SHIFT(1837),
  [4429] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4431] = {.count = 1, .reusable = false}, SHIFT(1839),
  [4433] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4435] = {.count = 1, .reusable = true}, SHIFT(1843),
  [4437] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4439] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4441] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4443] = {.count = 1, .reusable = true}, SHIFT(1847),
  [4445] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4447] = {.count = 1, .reusable = true}, SHIFT(1849),
  [4449] = {.count = 1, .reusable = false}, SHIFT(1849),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1850),
  [4453] = {.count = 1, .reusable = false}, SHIFT(1850),
  [4455] = {.count = 1, .reusable = true}, SHIFT(1851),
  [4457] = {.count = 1, .reusable = false}, SHIFT(1851),
  [4459] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5),
  [4461] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5),
  [4463] = {.count = 1, .reusable = false}, SHIFT(1852),
  [4465] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4467] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4469] = {.count = 1, .reusable = false}, SHIFT(1855),
  [4471] = {.count = 1, .reusable = true}, SHIFT(1856),
  [4473] = {.count = 1, .reusable = false}, SHIFT(1857),
  [4475] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4477] = {.count = 1, .reusable = false}, SHIFT(1860),
  [4479] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4481] = {.count = 1, .reusable = false}, SHIFT(1861),
  [4483] = {.count = 1, .reusable = true}, SHIFT(1863),
  [4485] = {.count = 1, .reusable = false}, SHIFT(1863),
  [4487] = {.count = 1, .reusable = true}, SHIFT(1864),
  [4489] = {.count = 1, .reusable = false}, SHIFT(1864),
  [4491] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4493] = {.count = 1, .reusable = false}, SHIFT(1866),
  [4495] = {.count = 1, .reusable = true}, SHIFT(1867),
  [4497] = {.count = 1, .reusable = false}, SHIFT(1867),
  [4499] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4501] = {.count = 1, .reusable = false}, SHIFT(1869),
  [4503] = {.count = 1, .reusable = true}, SHIFT(1870),
  [4505] = {.count = 1, .reusable = true}, SHIFT(1871),
  [4507] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4509] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4511] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4513] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4515] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4517] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4519] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4521] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4523] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4525] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4527] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4529] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4531] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4533] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4535] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4537] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4539] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4541] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4543] = {.count = 1, .reusable = false}, SHIFT(1889),
  [4545] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4547] = {.count = 1, .reusable = false}, SHIFT(1890),
  [4549] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4551] = {.count = 1, .reusable = false}, SHIFT(1891),
  [4553] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4555] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4557] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4559] = {.count = 1, .reusable = false}, SHIFT(1898),
  [4561] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4563] = {.count = 1, .reusable = false}, SHIFT(1902),
  [4565] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4567] = {.count = 1, .reusable = false}, SHIFT(1905),
  [4569] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4571] = {.count = 1, .reusable = false}, SHIFT(1907),
  [4573] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4575] = {.count = 1, .reusable = false}, SHIFT(1909),
  [4577] = {.count = 1, .reusable = false}, SHIFT(1910),
  [4579] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4581] = {.count = 1, .reusable = false}, SHIFT(1913),
  [4583] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8),
  [4585] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8),
  [4587] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8),
  [4589] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8),
  [4591] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 18),
  [4593] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 18),
  [4595] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 18),
  [4597] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 18),
  [4599] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 19),
  [4601] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8, .alias_sequence_id = 19),
  [4603] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 19),
  [4605] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8, .alias_sequence_id = 19),
  [4607] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4609] = {.count = 1, .reusable = false}, SHIFT(1914),
  [4611] = {.count = 1, .reusable = true}, SHIFT(1915),
  [4613] = {.count = 1, .reusable = false}, SHIFT(1915),
  [4615] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4617] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4619] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4621] = {.count = 1, .reusable = false}, SHIFT(1921),
  [4623] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4625] = {.count = 1, .reusable = false}, SHIFT(1922),
  [4627] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4629] = {.count = 1, .reusable = false}, SHIFT(1924),
  [4631] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4633] = {.count = 1, .reusable = false}, SHIFT(1925),
  [4635] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4637] = {.count = 1, .reusable = false}, SHIFT(1927),
  [4639] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4641] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4643] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4645] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4647] = {.count = 1, .reusable = true}, SHIFT(1932),
  [4649] = {.count = 1, .reusable = true}, SHIFT(1933),
  [4651] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4653] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4655] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4657] = {.count = 1, .reusable = true}, SHIFT(1937),
  [4659] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4661] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4663] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4665] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4667] = {.count = 1, .reusable = false}, SHIFT(1942),
  [4669] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4671] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4673] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4675] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4677] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4679] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4681] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4683] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4685] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4687] = {.count = 1, .reusable = false}, SHIFT(1951),
  [4689] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4691] = {.count = 1, .reusable = false}, SHIFT(1952),
  [4693] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4695] = {.count = 1, .reusable = false}, SHIFT(1953),
  [4697] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4699] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4701] = {.count = 1, .reusable = true}, SHIFT(1956),
  [4703] = {.count = 1, .reusable = false}, SHIFT(1958),
  [4705] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4707] = {.count = 1, .reusable = false}, SHIFT(1960),
  [4709] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4711] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4713] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4715] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4717] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4719] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4721] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4723] = {.count = 1, .reusable = true}, SHIFT(1971),
  [4725] = {.count = 1, .reusable = false}, SHIFT(1971),
  [4727] = {.count = 1, .reusable = true}, SHIFT(1973),
  [4729] = {.count = 1, .reusable = false}, SHIFT(1973),
  [4731] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4733] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4735] = {.count = 1, .reusable = false}, SHIFT(1975),
  [4737] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4739] = {.count = 1, .reusable = false}, SHIFT(1977),
  [4741] = {.count = 1, .reusable = true}, SHIFT(1979),
  [4743] = {.count = 1, .reusable = false}, SHIFT(1979),
  [4745] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4747] = {.count = 1, .reusable = false}, SHIFT(1980),
  [4749] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4751] = {.count = 1, .reusable = false}, SHIFT(1982),
  [4753] = {.count = 1, .reusable = true}, SHIFT(1983),
  [4755] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9),
  [4757] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9),
  [4759] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 20),
  [4761] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 20),
  [4763] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 21),
  [4765] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9, .alias_sequence_id = 21),
  [4767] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4769] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4771] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4773] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4775] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4777] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4779] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4781] = {.count = 1, .reusable = false}, SHIFT(1992),
  [4783] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4785] = {.count = 1, .reusable = false}, SHIFT(1993),
  [4787] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4789] = {.count = 1, .reusable = false}, SHIFT(1994),
  [4791] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4793] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4795] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4797] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4799] = {.count = 1, .reusable = false}, SHIFT(1999),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4803] = {.count = 1, .reusable = false}, SHIFT(2003),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4807] = {.count = 1, .reusable = false}, SHIFT(2006),
  [4809] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4811] = {.count = 1, .reusable = false}, SHIFT(2008),
  [4813] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4815] = {.count = 1, .reusable = false}, SHIFT(2010),
  [4817] = {.count = 1, .reusable = false}, SHIFT(2011),
  [4819] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4821] = {.count = 1, .reusable = false}, SHIFT(2014),
  [4823] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4825] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4827] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4829] = {.count = 1, .reusable = false}, SHIFT(2017),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2019),
  [4833] = {.count = 1, .reusable = false}, SHIFT(2019),
  [4835] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4837] = {.count = 1, .reusable = false}, SHIFT(2020),
  [4839] = {.count = 1, .reusable = true}, SHIFT(2022),
  [4841] = {.count = 1, .reusable = false}, SHIFT(2022),
  [4843] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4845] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4847] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4849] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4851] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4853] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4859] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4861] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4863] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4865] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4867] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4869] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4871] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4873] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4875] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4877] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4879] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4883] = {.count = 1, .reusable = false}, SHIFT(2042),
  [4885] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4887] = {.count = 1, .reusable = false}, SHIFT(2044),
  [4889] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4891] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4893] = {.count = 1, .reusable = false}, SHIFT(2046),
  [4895] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4897] = {.count = 1, .reusable = false}, SHIFT(2048),
  [4899] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4901] = {.count = 1, .reusable = false}, SHIFT(2050),
  [4903] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4905] = {.count = 1, .reusable = false}, SHIFT(2051),
  [4907] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4909] = {.count = 1, .reusable = false}, SHIFT(2053),
  [4911] = {.count = 1, .reusable = true}, SHIFT(2054),
  [4913] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4915] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4917] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4919] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4921] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4923] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4925] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4927] = {.count = 1, .reusable = false}, SHIFT(2063),
  [4929] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4931] = {.count = 1, .reusable = false}, SHIFT(2064),
  [4933] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4935] = {.count = 1, .reusable = false}, SHIFT(2065),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4939] = {.count = 1, .reusable = false}, SHIFT(2066),
  [4941] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4943] = {.count = 1, .reusable = false}, SHIFT(2068),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4947] = {.count = 1, .reusable = false}, SHIFT(2069),
  [4949] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4951] = {.count = 1, .reusable = false}, SHIFT(2071),
  [4953] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4955] = {.count = 1, .reusable = false}, SHIFT(2072),
  [4957] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4959] = {.count = 1, .reusable = false}, SHIFT(2074),
  [4961] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4963] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4965] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4967] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4969] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4971] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4973] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4975] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4977] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4979] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4981] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4983] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4985] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4987] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4989] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4991] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4993] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4995] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4997] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4999] = {.count = 1, .reusable = true}, SHIFT(2094),
  [5001] = {.count = 1, .reusable = false}, SHIFT(2094),
  [5003] = {.count = 1, .reusable = true}, SHIFT(2095),
  [5005] = {.count = 1, .reusable = false}, SHIFT(2095),
  [5007] = {.count = 1, .reusable = true}, SHIFT(2096),
  [5009] = {.count = 1, .reusable = false}, SHIFT(2096),
  [5011] = {.count = 1, .reusable = true}, SHIFT(2097),
  [5013] = {.count = 1, .reusable = true}, SHIFT(2098),
  [5015] = {.count = 1, .reusable = true}, SHIFT(2099),
};

void *tree_sitter_javascript_external_scanner_create();
void tree_sitter_javascript_external_scanner_destroy(void *);
bool tree_sitter_javascript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_javascript_external_scanner_serialize(void *, char *);
void tree_sitter_javascript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_javascript() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_javascript_external_scanner_create,
      tree_sitter_javascript_external_scanner_destroy,
      tree_sitter_javascript_external_scanner_scan,
      tree_sitter_javascript_external_scanner_serialize,
      tree_sitter_javascript_external_scanner_deserialize,
    },
  };
  return &language;
}
